<?php

use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\Exception;

class CommonUtil extends CApplicationComponent {

    public function convertToHoursMins($Decimalvalue, $format = '%02d:%02d') {

        $Decimalvalue =(float) $Decimalvalue;  
        if (is_numeric($Decimalvalue)) {
            $time = round($Decimalvalue * 60);
            if ($time < 1) {
                $hours = 0;
                $minutes = 0;
                return sprintf($format, $hours, $minutes);
            }
            $hours = floor($time / 60);
            $minutes = ($time % 60);
            return sprintf($format, $hours, $minutes);
        } else {
            return $Decimalvalue;
        }
    }

    function convertTime($dec) {
        $dec =(float) $dec; 
        return gmdate('H:i:s', floor($dec * 3600));
    }

    function ConvertToDecimal($time) {
        $hms = explode(":", $time);
        return ($hms[0] + ($hms[1] / 60));
    }

    public function RenderHtmlView($template, $data) {
        extract($data);
        ob_start();
        include( $template );
        $content = ob_get_contents();
        ob_end_clean();
        return $content;
    }

    public function SendMail($view, $subject, $members, $params1 = [], $params2 = []) {


        foreach ($members as $member) {
            $mail = new PHPMailer(true);
            $mail->isSMTP();
            $mail->Host = 'smtp.office365.com';
            $mail->Port = 587;
            $mail->SMTPSecure = 'tls';
            $mail->SMTPAuth   = true;
            $mail->Username = 'lka-iforce@efl.global';
            $mail->Password = 'Hoj01247';
            $mail->SetFrom('lka-iforce@efl.global', 'IForce');
            $mail->addAddress($member['email'], $member['name']);

            $mail->IsHTML(true);

            $mail->Subject = $subject;
            $mail->Body = $this->RenderHtmlView(dirname(__FILE__) . '/../views/mail/' . $view . '.php', array('data1' => $params1, 'data2' => $params2, 'name' => $member['name']));

            $mail->send();
        }
    }

}
