<?php

class EligibleLeaveUtil extends CApplicationComponent {

    public function getEligibleLeavesByEmployee($empId){
        $employee = Employee::model()->findByAttributes(array('id' => $empId));
        $takenLeaves = $this->getEmployeeTakenLeavesCalanderYear($empId);
        // $casualAndMedicalLeaves = $this->getEmployeeCasualAndMedicalLeave($empId);
        $casualAndMedicalLeavesForCurrentYear = $this->getEmployeeCasualAndMedicalLeaveForCurrentYear($empId);

        if(empty($employee))
            return array("Annual"=>0,"Casual"=>0,"Medical"=>0,"ShortLeave"=>0);

        $joinDate = $employee->joindate;
        // $joinDate = '2019-06-03';
        $joinMonth = (int)date("m",strtotime($joinDate));
        $joinYear = (int)date("Y",strtotime($joinDate));

        $currentDate = date('Y-m-d');
        $currentMonth = (int)date('m');
        $currentYear = (int)date('Y');
        
        $months = (int)$this->getMonthGap($joinDate,$currentDate);
        // return $casualAndMedicalLeavesForCurrentYear;
       
        if($months <= 6  && $currentYear == $joinYear ){
            
            switch($months){
                case 1:
                    return array("Annual"=>0,"Casual"=>0.5-$casualAndMedicalLeavesForCurrentYear["casual"],"Medical"=>0.5-$casualAndMedicalLeavesForCurrentYear["medical"],"ShortLeave"=>0);
                    break;
                case 2:
                    return array("Annual"=>0,"Casual"=>1-$casualAndMedicalLeavesForCurrentYear["casual"],"Medical"=>1-$casualAndMedicalLeavesForCurrentYear["medical"],"ShortLeave"=>0);
                    break;
                case 3:
                    return array("Annual"=>0,"Casual"=>1.5-$casualAndMedicalLeavesForCurrentYear["casual"],"Medical"=>1.5-$casualAndMedicalLeavesForCurrentYear["medical"],"ShortLeave"=>0);
                    break;
                case 4:
                    return array("Annual"=>0,"Casual"=>2-$casualAndMedicalLeavesForCurrentYear["casual"],"Medical"=>2-$casualAndMedicalLeavesForCurrentYear["medical"],"ShortLeave"=>0);
                    break;
                case 5:
                    return array("Annual"=>0,"Casual"=>2.5-$casualAndMedicalLeavesForCurrentYear["casual"],"Medical"=>2.5-$casualAndMedicalLeavesForCurrentYear["medical"],"ShortLeave"=>0);
                    break;
                case 6:
                    return array("Annual"=>0,"Casual"=>3-$casualAndMedicalLeavesForCurrentYear["casual"],"Medical"=>3-$casualAndMedicalLeavesForCurrentYear["medical"],"ShortLeave"=>0);
                    break;
            }
            
        }else if($months <= 6  && ($currentYear-$joinYear)==1){

            if($joinMonth == 7){
                return array(
                    "Annual"=>$this->getAnnualLeavesCount($joinMonth)-$takenLeaves["Annual"],
                    "Casual"=>0.5-$casualAndMedicalLeavesForCurrentYear["casual"],
                    "Medical"=>0.5-$casualAndMedicalLeavesForCurrentYear["medical"],
                    "ShortLeave"=>0
                );
            }else if($joinMonth == 8){

                switch($months){
                    case 5:
                        return array(
                            "Annual"=>$this->getAnnualLeavesCount($joinMonth)-$takenLeaves["Annual"],
                            "Casual"=>0.5-$casualAndMedicalLeavesForCurrentYear["casual"],
                            "Medical"=>0.5-$casualAndMedicalLeavesForCurrentYear["medical"],
                            "ShortLeave"=>0
                        );
                        break;
                    case 6:
                        return array(
                            "Annual"=>$this->getAnnualLeavesCount($joinMonth)-$takenLeaves["Annual"],
                            "Casual"=>1-$casualAndMedicalLeavesForCurrentYear["casual"],
                            "Medical"=>1-$casualAndMedicalLeavesForCurrentYear["medical"],
                            "ShortLeave"=>0
                        );
                        break;
                }

            }else if($joinMonth == 9){

                switch($months){
                    case 4:
                        return array(
                            "Annual"=>$this->getAnnualLeavesCount($joinMonth)-$takenLeaves["Annual"],
                            "Casual"=>0.5-$casualAndMedicalLeavesForCurrentYear["casual"],
                            "Medical"=>0.5-$casualAndMedicalLeavesForCurrentYear["medical"],
                            "ShortLeave"=>0
                        );
                        break;
                    case 5:
                        return array(
                            "Annual"=>$this->getAnnualLeavesCount($joinMonth)-$takenLeaves["Annual"],
                            "Casual"=>1-$casualAndMedicalLeavesForCurrentYear["casual"],
                            "Medical"=>1-$casualAndMedicalLeavesForCurrentYear["medical"],
                            "ShortLeave"=>0
                        );
                        break;
                    case 6:
                        return array(
                            "Annual"=>$this->getAnnualLeavesCount($joinMonth)-$takenLeaves["Annual"],
                            "Casual"=>1.5-$casualAndMedicalLeavesForCurrentYear["casual"],
                            "Medical"=>1.5-$casualAndMedicalLeavesForCurrentYear["medical"],
                            "ShortLeave"=>0
                        );
                        break;
                }
                
            }else if($joinMonth == 10){

                switch($months){
                    case 3:
                        return array(
                            "Annual"=>$this->getAnnualLeavesCount($joinMonth)-$takenLeaves["Annual"],
                            "Casual"=>0.5-$casualAndMedicalLeavesForCurrentYear["casual"],
                            "Medical"=>0.5-$casualAndMedicalLeavesForCurrentYear["medical"],
                            "ShortLeave"=>0
                        );
                        break;
                    case 4:
                        return array(
                            "Annual"=>$this->getAnnualLeavesCount($joinMonth)-$takenLeaves["Annual"],
                            "Casual"=>1-$casualAndMedicalLeavesForCurrentYear["casual"],
                            "Medical"=>1-$casualAndMedicalLeavesForCurrentYear["medical"],
                            "ShortLeave"=>0
                        );
                        break;
                    case 5:
                        return array(
                            "Annual"=>$this->getAnnualLeavesCount($joinMonth)-$takenLeaves["Annual"],
                            "Casual"=>1.5-$casualAndMedicalLeavesForCurrentYear["casual"],
                            "Medical"=>1.5-$casualAndMedicalLeavesForCurrentYear["medical"],
                            "ShortLeave"=>0
                        );
                        break;
                    case 6:
                        return array(
                            "Annual"=>$this->getAnnualLeavesCount($joinMonth)-$takenLeaves["Annual"],
                            "Casual"=>2-$casualAndMedicalLeavesForCurrentYear["casual"],
                            "Medical"=>2-$casualAndMedicalLeavesForCurrentYear["medical"],
                            "ShortLeave"=>0
                        );
                        break;
                }
                
            }else if($joinMonth == 11){

                switch($months){
                    case 2:
                        return array(
                            "Annual"=>$this->getAnnualLeavesCount($joinMonth)-$takenLeaves["Annual"],
                            "Casual"=>0.5-$casualAndMedicalLeavesForCurrentYear["casual"],
                            "Medical"=>0.5-$casualAndMedicalLeavesForCurrentYear["medical"],
                            "ShortLeave"=>0
                        );
                        break;
                    case 3:
                        return array(
                            "Annual"=>$this->getAnnualLeavesCount($joinMonth)-$takenLeaves["Annual"],
                            "Casual"=>1-$casualAndMedicalLeavesForCurrentYear["casual"],
                            "Medical"=>1-$casualAndMedicalLeavesForCurrentYear["medical"],
                            "ShortLeave"=>0
                        );
                        break;
                    case 4:
                        return array(
                            "Annual"=>$this->getAnnualLeavesCount($joinMonth)-$takenLeaves["Annual"],
                            "Casual"=>1.5-$casualAndMedicalLeavesForCurrentYear["casual"],
                            "Medical"=>1.5-$casualAndMedicalLeavesForCurrentYear["medical"],
                            "ShortLeave"=>0
                        );
                        break;
                    case 5:
                        return array(
                            "Annual"=>$this->getAnnualLeavesCount($joinMonth)-$takenLeaves["Annual"],
                            "Casual"=>2-$casualAndMedicalLeavesForCurrentYear["casual"],
                            "Medical"=>2-$casualAndMedicalLeavesForCurrentYear["medical"],
                            "ShortLeave"=>0
                        );
                        break;
                    case 6:
                        return array(
                            "Annual"=>$this->getAnnualLeavesCount($joinMonth)-$takenLeaves["Annual"],
                            "Casual"=>2.5-$casualAndMedicalLeavesForCurrentYear["casual"],
                            "Medical"=>2.5-$casualAndMedicalLeavesForCurrentYear["medical"],
                            "ShortLeave"=>0
                        );
                        break;
                }
                
            }else if($joinMonth == 12){

                switch($months){
                    case 1:
                        return array(
                            "Annual"=>$this->getAnnualLeavesCount($joinMonth)-$takenLeaves["Annual"],
                            "Casual"=>0.5-$casualAndMedicalLeavesForCurrentYear["casual"],
                            "Medical"=>0.5-$casualAndMedicalLeavesForCurrentYear["medical"],
                            "ShortLeave"=>0
                        );
                        break;
                    case 2:
                        return array(
                            "Annual"=>$this->getAnnualLeavesCount($joinMonth)-$takenLeaves["Annual"],
                            "Casual"=>1-$casualAndMedicalLeavesForCurrentYear["casual"],
                            "Medical"=>1-$casualAndMedicalLeavesForCurrentYear["medical"],
                            "ShortLeave"=>0
                        );
                        break;
                    case 3:
                        return array(
                            "Annual"=>$this->getAnnualLeavesCount($joinMonth)-$takenLeaves["Annual"],
                            "Casual"=>1.5-$casualAndMedicalLeavesForCurrentYear["casual"],
                            "Medical"=>1.5-$casualAndMedicalLeavesForCurrentYear["medical"],
                            "ShortLeave"=>0
                        );
                        break;
                    case 4:
                        return array(
                            "Annual"=>$this->getAnnualLeavesCount($joinMonth)-$takenLeaves["Annual"],
                            "Casual"=>2-$casualAndMedicalLeavesForCurrentYear["casual"],
                            "Medical"=>2-$casualAndMedicalLeavesForCurrentYear["medical"],
                            "ShortLeave"=>0
                        );
                        break;
                    case 5:
                        return array(
                            "Annual"=>$this->getAnnualLeavesCount($joinMonth)-$takenLeaves["Annual"],
                            "Casual"=>2.5-$casualAndMedicalLeavesForCurrentYear["casual"],
                            "Medical"=>2.5-$casualAndMedicalLeavesForCurrentYear["medical"],
                            "ShortLeave"=>0
                        );
                        break;
                    case 6:
                        return array(
                            "Annual"=>$this->getAnnualLeavesCount($joinMonth)-$takenLeaves["Annual"],
                            "Casual"=>3-$casualAndMedicalLeavesForCurrentYear["casual"],
                            "Medical"=>3-$casualAndMedicalLeavesForCurrentYear["medical"],
                            "ShortLeave"=>0
                        );
                        break;
                }
                
            }

        }else if($months > 6 && $currentYear == $joinYear){

            return array(
                "Annual"=>0,
                "Casual"=>7-$casualAndMedicalLeavesForCurrentYear["casual"],
                "Medical"=>7-$casualAndMedicalLeavesForCurrentYear["medical"],
                "ShortLeave"=>2-$casualAndMedicalLeavesForCurrentYear["ShortLeave"]
            );

        }else if($months > 6 && ($currentYear-$joinYear)==1){

            return array(
                "Annual"=>$this->getAnnualLeavesCount($joinMonth)-$takenLeaves["Annual"],
                "Casual"=>7-$casualAndMedicalLeavesForCurrentYear["casual"],
                "Medical"=>7-$casualAndMedicalLeavesForCurrentYear["medical"],
                "ShortLeave"=>2-$casualAndMedicalLeavesForCurrentYear["ShortLeave"]
            );
        }
        else if(($currentYear-$joinYear) > 1){

            return array(
                "Annual"=>14-$takenLeaves["Annual"],
                "Casual"=>7-$casualAndMedicalLeavesForCurrentYear["casual"],
                "Medical"=>7-$casualAndMedicalLeavesForCurrentYear["medical"],
                "ShortLeave"=>2-$casualAndMedicalLeavesForCurrentYear["ShortLeave"]
            );

        }
        
        return array("Annual"=>0,"Casual"=>0,"Medical"=>0,"ShortLeave"=>0);
    }

    private function getMonthGap($start, $end){
        
        $date1 = new DateTime($start);
        $date2 = $date1->diff(new DateTime($end));
        return (($date2->y *12) + $date2->m) + 1;

    }

    private function getAnnualLeavesCount($month){
        
        if($month >= 1 && $month <= 3){
            return 14;
        }
        else if($month >= 4 && $month <= 6){
            return 10;
        }
        else if($month >= 7 && $month <= 9){
            return 7;
        }
        else if($month >= 10 && $month <= 12){
            return 4;
        }
    }

    private function getEmployeeTakenLeavesCalanderYear($empId){
        $leaves = Yii::app()->db->createCommand("SELECT ltp.Type,IF(t.Days is NULL, 0, t.Days ) AS Days,IF(t.Hours is NULL,0,t.Hours) as Hours FROM leavetype ltp LEFT JOIN (SELECT l.EmoloyeeId,lt.Type, SUM(l.No_of_Day) AS Days , SUM(l.No_of_Hour) AS Hours FROM `leave` l INNER JOIN leavetype lt ON l.LeaveType = lt.id 
            WHERE YEAR(l.StartDate) = YEAR(CURDATE()) AND l.EmoloyeeId=".$empId." AND  lt.Type != 'SHORT LEAVE' GROUP BY lt.Type
            UNION ALL
            SELECT l.EmoloyeeId,lt.Type, COUNT(lt.Type) AS Days , SUM(l.No_of_Hour) AS Hours FROM `leave` l INNER JOIN leavetype lt ON l.LeaveType = lt.id 
            WHERE MONTH(l.StartDate) = MONTH(CURDATE()) AND l.EmoloyeeId=".$empId." AND  lt.Type = 'SHORT LEAVE' GROUP BY lt.Type) t ON t.Type = ltp.Type")->queryAll();

        $annual = 0;
        $casual = 0;
        $medical = 0;
        $shortLeaves = 0;

        foreach($leaves as $l){
            switch ($l['Type']) {
                case 'ANNUAL LEAVE':
                    $annual = $l['Days'];
                    break;
                case 'CASUAL LEAVE':
                    $casual = $l['Days'];
                    break;
                case 'MEDICAL LEAVE':
                    $medical = $l['Days'];
                    break;
                case 'SHORT LEAVE':
                    $shortLeaves = $l['Days'];
                    break;
            }
        }


        return array("Annual"=>$annual,"Casual"=>$casual,"Medical"=>$medical,"ShortLeave"=>$shortLeaves);
    }

    private function getEmployeeCasualAndMedicalLeaveForCurrentYear($empId){
        $casualLeaveCount = Yii::app()->db->createCommand("SELECT (IFNULL(SUM(L.No_of_Day),0)+(SELECT IFNULL(COUNT(L1.id),0)*0.5 FROM `leave` L1 WHERE L1.LeaveType = 1 AND YEAR(L1.StartDate) = YEAR(CURDATE()) AND L1.EmoloyeeId = ".$empId." AND L1.day_type = 'Half Day')) as casualCount
            FROM `leave` L
            WHERE L.LeaveType = 1 AND YEAR(L.StartDate) = YEAR(CURDATE()) AND L.EmoloyeeId = ".$empId." AND L.day_type = 'Full Day'")->queryScalar();

        $medicalLeaveCount = Yii::app()->db->createCommand("SELECT (IFNULL(SUM(L.No_of_Day),0)+(SELECT IFNULL(COUNT(L1.id),0)*0.5 FROM `leave` L1 WHERE L1.LeaveType = 4 AND YEAR(L1.StartDate) = YEAR(CURDATE()) AND L1.EmoloyeeId = ".$empId." AND L1.day_type = 'Half Day')) as casualCount
            FROM `leave` L
            WHERE L.LeaveType = 4 AND YEAR(L.StartDate) = YEAR(CURDATE()) AND L.EmoloyeeId = ".$empId." AND L.day_type = 'Full Day'")->queryScalar();
        $shortLeaveCount = Yii::app()->db->createCommand("SELECT count(`id`) 
            FROM `leave` 
            WHERE `LeaveType` = 2 AND MONTH(`StartDate`) = MONTH(CURDATE()) AND YEAR(`StartDate`) = YEAR(CURDATE()) AND `EmoloyeeId` = ".$empId."")->queryScalar();

        return array('casual'=>$casualLeaveCount,'medical'=>$medicalLeaveCount,'ShortLeave'=>$shortLeaveCount);
    }
}
