<?php

class FlexiShiftMonthlyCalculationUtil extends CApplicationComponent {

    public function CreateTimeSheet($model, $flexiShift) {

        $employee = Employee::model()->findByAttributes(array('id' => $model->Employeeid));
        $employeesalary = Employeesalary::model()->findByAttributes(array('employeeid' => $model->Employeeid, 'site_id' => $model->Siteid, 'Status' => 1));
        if (empty($employeesalary)) {
            $employeesalary = new Employeesalary;
            $employeesalary->monthsalary = 0;
            $employeesalary->DalySalary = 0;
            $employeesalary->HourlyRate = 0;
            $employeesalary->OTRate = 0;
            $employeesalary->DoubleOTRate = 0;
            $employeesalary->BasicSalary = 0;
            $employeesalary->BRA1 = 0;
            $employeesalary->BRA2 = 0;
            $employeesalary->BRA3 = 0;
        }

        if (!empty($flexiShift)) {

            $Sheduldate = $flexiShift[0]['Schedul_Date'];
            $DayWithName = Yii::app()->PublicFunctionForTimesheetUtil->GetDayForTimsheet($Sheduldate, $employee->siteid);

            //------get intime------//
            $InTimelogs = Yii::app()->PublicFunctionForTimesheetUtil->GetInTimeLogForFlexiShift($Sheduldate, $model->Employeeid);

            if (!empty($InTimelogs)) {
                //------get out time-------//

                $OutTimelogs = Yii::app()->PublicFunctionForTimesheetUtil->GetOutTimeLogForFlexiShift($InTimelogs[0]['PunchTime'], $model->Employeeid);

                if ($DayWithName == "SUNDAY" or $DayWithName == "HOLIDAY") {
                    Yii::app()->FlexiShiftMonthlyCalculationUtil->TimeSheetForHolyday($flexiShift, $Sheduldate, $model, $employeesalary, $InTimelogs, $OutTimelogs, $DayWithName, $employee);
                } else {
                    Yii::app()->FlexiShiftMonthlyCalculationUtil->TimeSheetForWeekday($flexiShift, $Sheduldate, $model, $employeesalary, $InTimelogs, $OutTimelogs, $employee);
                }
            }
        }
    }

    public function TimeSheetForHolyday($flexiShift, $Sheduldate, $model, $employeesalary, $InTimelogs, $OutTimelogs, $DayWithName, $employee) {

        $InTimelogOfShift = empty($InTimelogs) ? $OutTimelogs : $InTimelogs;
        $OutTimelogOfShift = empty($OutTimelogs) ? $InTimelogs : $OutTimelogs;

        if (!empty($flexiShift)) {

            //-----get relewent shift---------//     
            $shiftid = $flexiShift[0]['shift_id'];
            $Current_Shift = Shift::model()->findByAttributes(array('id' => $shiftid));

            $ShiftHourlyRate = $Current_Shift->salaryRate;
            $NotRang = $Current_Shift->FirstOTTimeRang;
            $DotRang = $Current_Shift->SecondOTRange;
            $NOTGraceTime = $Current_Shift->NOTGraceTime;
            $DOTGraceTime = $Current_Shift->DOTGraceTime;
            $OTRoundupValue = $Current_Shift->OTRoundup;
            $ShiftTOTRate = $Current_Shift->ThirdOTRate;
            $TOTRang = $Current_Shift->ThirdOTTimeRang;
            $TOTGraceTime = $Current_Shift->TOTGraceTime;

            $InTimelog = $InTimelogOfShift[0]['PunchTime'];
            $OutTimelog = $OutTimelogOfShift[0]['PunchTime'];

            $STime = strtotime(str_replace('/', '-', $InTimelog));
            $ETime = strtotime(str_replace('/', '-', $OutTimelog));
            $AWorkedhour = abs($ETime - $STime) / 3600;
            $TotalWorkedHour = $AWorkedhour > 0 ? $AWorkedhour : 0;

            $ShiftHour = 0;
            $OTH = $TotalWorkedHour >= $NotRang ? $NotRang : $TotalWorkedHour;
            $NOTHour = $OTH > 0 ? $OTH : 0;

            $ShiftAndNOTHour = $NotRang;
            $DOTHValue = $TotalWorkedHour - $ShiftAndNOTHour;
            $DOTH = $DOTHValue >= $DotRang ? $DotRang : $DOTHValue;
            $DOTHour = $DOTH > 0 ? $DOTH : 0;

            $ShiftAndDOTHour = $NotRang + $DotRang;
            $TOTHValue = $TotalWorkedHour - $ShiftAndDOTHour;
            $TOTH = $TOTHValue >= $TOTRang ? $TOTRang : $TOTHValue;
            $TOTHour = $TOTH > 0 ? $TOTH : 0;

            $NOTHourwithGrace = $NOTHour <= $NOTGraceTime ? 0 : $NOTHour;
            $DOTHourwithGrace = $DOTHour <= $DOTGraceTime ? 0 : $DOTHour;
            $TOTHourwithGrace = $TOTHour <= $TOTGraceTime ? 0 : $TOTHour;

            if ($NOTHour > $NOTGraceTime) {
                $Value = $OTRoundupValue;
                $NOTRoundupValue = Yii::app()->PublicFunctionForTimesheetUtil->OTRoundUp($NOTHour, $Value);
                $NOTHourwithGrace = $NOTRoundupValue;
            }
            if ($DOTHour > $DOTGraceTime) {
                $Value = $OTRoundupValue;
                $DOTRoundupValue = Yii::app()->PublicFunctionForTimesheetUtil->OTRoundUp($DOTHour, $Value);
                $DOTHourwithGrace = $DOTRoundupValue;
            }

            if ($TOTHour > $TOTGraceTime) {
                $Value = $OTRoundupValue;
                $TOTRoundupValue = Yii::app()->PublicFunctionForTimesheetUtil->OTRoundUp($TOTHour, $Value);
                $TOTHourwithGrace = $TOTRoundupValue;
            }

            $Result = Yii::app()->PublicFunctionForTimesheetUtil->ShortLeaveCalculationForFlexiShift($model->Employeeid, $InTimelogOfShift[0]['PunchTime'], $OutTimelogOfShift[0]['PunchTime']);
            $WorkedHourInshift = $Result[0];
            //======= Out Late deduct ==========//
            $OutLateDeductTime = $Result[2];
            $OutLateDeductAmount = $ShiftHourlyRate * ($OutLateDeductTime * $employeesalary->HourlyRate);

            $Timesheet = new Timesheet;
            $ActualInTime = empty($InTimelogs) ? "0000-00-00 00:00:00" : $InTimelogs[0]['PunchTime'];
            $ActualOutTime = empty($OutTimelogs) ? "0000-00-00 00:00:00" : $OutTimelogs[0]['PunchTime'];

            $Daywage = $employeesalary->DalySalary * $ShiftHourlyRate;
            $Timesheetforemployee = Timesheet::model()->findByAttributes(array('EmployeeId'=>$model->Employeeid,'EmployeeShiftid' => $flexiShift[0]['EmpShift_Id']));
           
            if (empty($Timesheetforemployee)) {
                $Timesheet->Intime = $ActualInTime;
                $Timesheet->OuteTime = $ActualOutTime;
                $Timesheet->EmployeeId = $model->Employeeid;
                $Timesheet->date = $Sheduldate;

                $Timesheet->NOvertimeHours = $NOTHour <= $NotRang ? $NOTHourwithGrace : $NotRang;
                $Timesheet->NOvertimeSalary = $Timesheet->NOvertimeHours * $employeesalary->OTRate;
                $Timesheet->DOverTimeHour = $DOTHour <= $DotRang ? $DOTHourwithGrace : $DotRang;
                $Timesheet->Dovertimesalary = $Timesheet->DOverTimeHour * $employeesalary->DoubleOTRate;
                $Timesheet->TOverTimeHour = $TOTHour <= $TOTRang ? $TOTHourwithGrace : $TOTRang;
                $Timesheet->Tovertimesalary = $ShiftTOTRate * ($Timesheet->TOverTimeHour * $employeesalary->HourlyRate);

                $Timesheet->SallaryRate = $Daywage;
                $Timesheet->WorkedHour = $ShiftHour;
                $Timesheet->EmployeeShiftid = $flexiShift[0]['EmpShift_Id'];
                $Timesheet->DesignaId = $employee->designationid;
                $Timesheet->TotalOTHour = $Timesheet->NOvertimeHours + $Timesheet->DOverTimeHour + $Timesheet->TOverTimeHour;
                $Timesheet->PaymentMethod = "MONTHLY";
                $Timesheet->DayName = $DayWithName;
                $Timesheet->LatedeductTime = 0;
                $Timesheet->LatedeductAmount = 0;
                $Timesheet->SiteId = $employee->siteid;
                $Timesheet->OutLateDeductTime = $OutLateDeductTime;
                $Timesheet->OutLateDeductAmount = $OutLateDeductAmount;
                $Timesheet->WorkedDay = 0;
                $Timesheet->Category = $employee->categoryid;
                $Timesheet->account_id = $employee->Accountid;
                $Timesheet->department_id = $employee->departmentid;
                $Timesheet->MP_suplier_id = $employee->supplierid;
                $Timesheet->full_Basic_Salary = $employeesalary->DalySalary;
                $Timesheet->Sub_Basic_salary = $employeesalary->BasicSalary;
                $Timesheet->BRA1 = $employeesalary->BRA1;
                $Timesheet->BRA2 = $employeesalary->BRA2;
                $Timesheet->BRA3 = $employeesalary->BRA3;
                $Timesheet->Actual_WorkHourInShift = $TotalWorkedHour;
                $Timesheet->PreOTHour = 0;
                $Timesheet->PreOTAmount = 0;

                $Timesheet->save();
            } else {

                $NOTHours = $NOTHour >= $NotRang ? $NotRang : $NOTHourwithGrace;
                $NOTAmount = $NOTHours * $employeesalary->OTRate;

                $DOTHours = $DOTHour <= $DotRang ? $DOTHourwithGrace : $DotRang;
                $DOTSallary = $DOTHours * $employeesalary->DoubleOTRate;

                $TOTHours = $TOTHour <= $TOTRang ? $TOTHourwithGrace : $TOTRang;
                $TOTSallary = 3 * ($TOTHours * $employeesalary->HourlyRate);
                $TotalOTHour = $NOTHours + $DOTHours + $TOTHours;
                Timesheet::model()->updateAll(array('WorkedHour' => $ShiftHour, 'Actual_WorkHourInShift' => $TotalWorkedHour, 'WorkedDay' => 0, 'TotalOTHour' => $TotalOTHour, 'OutLateDeductTime' => $OutLateDeductTime, 'OutLateDeductAmount' => $OutLateDeductAmount, 'Intime' => $InTimelogOfShift[0]['PunchTime'], 'OuteTime' => $OutTimelogOfShift[0]['PunchTime'], 'NOvertimeHours' => $NOTHour, 'NOvertimeSalary' => $NOTAmount, 'DOverTimeHour' => $DOTHour, 'Dovertimesalary' => $DOTSallary, 'TOverTimeHour' => $TOTHour, 'Tovertimesalary' => $TOTSallary), 'id ="' . $Timesheetforemployee->id . '"');

                if (empty($OutTimelogs)) {
                    Timesheet::model()->updateAll(array('WorkedHour' => 0, 'Actual_WorkHourInShift' => 0, 'WorkedDay' => 0, 'TotalOTHour' => 0, 'LatedeductTime' => 0, 'LatedeductAmount' => 0, 'OutLateDeductTime' => $OutLateDeductTime, 'OutLateDeductAmount' => $OutLateDeductAmount, 'Intime' => $InTimelogOfShift[0]['PunchTime'], 'OuteTime' => "0000-00-00 00:00:00", 'NOvertimeHours' => 0, 'NOvertimeSalary' => 0, 'DOverTimeHour' => 0, 'Dovertimesalary' => 0, 'TOverTimeHour' => 0, 'Tovertimesalary' => 0, 'PreOTHour' => 0, 'PreOTAmount' => 0), 'id ="' . $Timesheetforemployee->id . '"');
                }
            }
        }
    }

    public function TimeSheetForWeekday($flexiShift, $Sheduldate, $model, $employeesalary, $InTimelogs, $OutTimelogs, $employee) {

        $InTimelogOfShift = empty($InTimelogs) ? $OutTimelogs : $InTimelogs;
        $OutTimelogOfShift = empty($OutTimelogs) ? $InTimelogs : $OutTimelogs;

        if (!empty($flexiShift)) {

            //-----get relewent shift---------//     
            $shiftid = $flexiShift[0]['shift_id'];
            $Current_Shift = Shift::model()->findByAttributes(array('id' => $shiftid));

            $Sheduldate = $flexiShift[0]['Schedul_Date'];
            $DayWithName = Yii::app()->PublicFunctionForTimesheetUtil->GetDayForTimsheet($Sheduldate, $employee->siteid);

            $ShiftHourlyRate = $Current_Shift->salaryRate;
            $NotRang = $Current_Shift->FirstOTTimeRang;
            $DotRang = $Current_Shift->SecondOTRange;
            $NOTGraceTime = $Current_Shift->NOTGraceTime;
            $DOTGraceTime = $Current_Shift->DOTGraceTime;
            $OTRoundupValue = $Current_Shift->OTRoundup;
            $ShiftTOTRate = $Current_Shift->ThirdOTRate;
            $TOTRang = $Current_Shift->ThirdOTTimeRang;
            $TOTGraceTime = $Current_Shift->TOTGraceTime;

            $InTimelog = $InTimelogOfShift[0]['PunchTime'];
            $OutTimelog = $OutTimelogOfShift[0]['PunchTime'];

            $STime = strtotime(str_replace('/', '-', $InTimelog));
            $ETime = strtotime(str_replace('/', '-', $OutTimelog));
            $AWorkedhour = abs($ETime - $STime) / 3600;
            $TotalWorkedHour = $AWorkedhour > 0 ? $AWorkedhour : 0;

            $updated = strtotime($Sheduldate);
            $day = date('l', $updated);
            
            if ($day == "Saturday") {

                $OTH = $TotalWorkedHour - 5;
                $NOTHour = $OTH > 0 ? $OTH : 0;
                $ShiftAndNOTHour = 5 + $NotRang;
                $DOTH = $TotalWorkedHour - $ShiftAndNOTHour;
                $DOTHour = $DOTH > 0 ? $DOTH : 0;
                $ShiftAndDOTHour = 5 + $NotRang + $DotRang;
                $TOTH = $TotalWorkedHour - $ShiftAndDOTHour;
                $TOTHour = $TOTH > 0 ? $TOTH : 0;

                $NOTHourwithGrace = $NOTHour <= $NOTGraceTime ? 0 : $NOTHour;
                $DOTHourwithGrace = $DOTHour <= $DOTGraceTime ? 0 : $DOTHour;
                $TOTHourwithGrace = $TOTHour <= $TOTGraceTime ? 0 : $TOTHour;
            } else {
                $OTH = $TotalWorkedHour - 9;
                $NOTHour = $OTH > 0 ? $OTH : 0;
                $ShiftAndNOTHour = 9 + $NotRang;
                $DOTH = $TotalWorkedHour - $ShiftAndNOTHour;
                $DOTHour = $DOTH > 0 ? $DOTH : 0;
                $ShiftAndDOTHour = 9 + $NotRang + $DotRang;
                $TOTH = $TotalWorkedHour - $ShiftAndDOTHour;
                $TOTHour = $TOTH > 0 ? $TOTH : 0;

                $NOTHourwithGrace = $NOTHour <= $NOTGraceTime ? 0 : $NOTHour;
                $DOTHourwithGrace = $DOTHour <= $DOTGraceTime ? 0 : $DOTHour;
                $TOTHourwithGrace = $TOTHour <= $TOTGraceTime ? 0 : $TOTHour;
            }


            if ($NOTHour > $NOTGraceTime) {
                $Value = $OTRoundupValue;
                $NOTRoundupValue = Yii::app()->PublicFunctionForTimesheetUtil->OTRoundUp($NOTHour, $Value);
                $NOTHourwithGrace = $NOTRoundupValue;
            }
            if ($DOTHour > $DOTGraceTime) {
                $Value = $OTRoundupValue;
                $DOTRoundupValue = Yii::app()->PublicFunctionForTimesheetUtil->OTRoundUp($DOTHour, $Value);
                $DOTHourwithGrace = $DOTRoundupValue;
            }

            if ($TOTHour > $TOTGraceTime) {
                $Value = $OTRoundupValue;
                $TOTRoundupValue = Yii::app()->PublicFunctionForTimesheetUtil->OTRoundUp($TOTHour, $Value);
                $TOTHourwithGrace = $TOTRoundupValue;
            }

            $Result = Yii::app()->PublicFunctionForTimesheetUtil->ShortLeaveCalculationForFlexiShift($model->Employeeid, $InTimelogOfShift[0]['PunchTime'], $OutTimelogOfShift[0]['PunchTime']);
            $WorkedHourInshift = $Result[0];
            //======= Out Late deduct ==========//
            $OutLateDeductTime = $Result[2];
            $OutLateDeductAmount = $ShiftHourlyRate * ($OutLateDeductTime * $employeesalary->HourlyRate);

            $Timesheet = new Timesheet;
            $ActualInTime = empty($InTimelogs) ? "0000-00-00 00:00:00" : $InTimelogs[0]['PunchTime'];
            $ActualOutTime = empty($OutTimelogs) ? "0000-00-00 00:00:00" : $OutTimelogs[0]['PunchTime'];

            $Daywage = $employeesalary->DalySalary * $ShiftHourlyRate;
            $Timesheetforemployee = Timesheet::model()->findByAttributes(array('EmployeeId' => $model->Employeeid, 'EmployeeShiftid' => $flexiShift[0]['EmpShift_Id']));

            if (empty($Timesheetforemployee)) {
                $Timesheet->Intime = $ActualInTime;
                $Timesheet->OuteTime = $ActualOutTime;
                $Timesheet->EmployeeId = $model->Employeeid;
                $Timesheet->date = $Sheduldate;

                $Timesheet->NOvertimeHours = $NOTHour <= $NotRang ? $NOTHourwithGrace : $NotRang;
                $Timesheet->NOvertimeSalary = $Timesheet->NOvertimeHours * $employeesalary->OTRate;
                $Timesheet->DOverTimeHour = $DOTHour <= $DotRang ? $DOTHourwithGrace : $DotRang;
                $Timesheet->Dovertimesalary = $Timesheet->DOverTimeHour * $employeesalary->DoubleOTRate;
                $Timesheet->TOverTimeHour = $TOTHour <= $TOTRang ? $TOTHourwithGrace : $TOTRang;
                $Timesheet->Tovertimesalary = $ShiftTOTRate * ($Timesheet->TOverTimeHour * $employeesalary->HourlyRate);

                $Timesheet->SallaryRate = $Daywage;
                $Timesheet->WorkedHour = $WorkedHourInshift;
                $Timesheet->EmployeeShiftid = $flexiShift[0]['EmpShift_Id'];
                $Timesheet->DesignaId = $employee->designationid;
                $Timesheet->TotalOTHour = $Timesheet->NOvertimeHours + $Timesheet->DOverTimeHour + $Timesheet->TOverTimeHour;
                $Timesheet->PaymentMethod = "MONTHLY";
                $Timesheet->DayName = $DayWithName;
                $Timesheet->LatedeductTime = 0;
                $Timesheet->LatedeductAmount = 0;
                $Timesheet->SiteId = $employee->siteid;
                $Timesheet->OutLateDeductTime = $OutLateDeductTime;
                $Timesheet->OutLateDeductAmount = $OutLateDeductAmount;
                $Timesheet->WorkedDay = 0;
                $Timesheet->Category = $employee->categoryid;
                $Timesheet->account_id = $employee->Accountid;
                $Timesheet->department_id = $employee->departmentid;
                $Timesheet->MP_suplier_id = $employee->supplierid;
                $Timesheet->full_Basic_Salary = $employeesalary->DalySalary;
                $Timesheet->Sub_Basic_salary = $employeesalary->BasicSalary;
                $Timesheet->BRA1 = $employeesalary->BRA1;
                $Timesheet->BRA2 = $employeesalary->BRA2;
                $Timesheet->BRA3 = $employeesalary->BRA3;
                $Timesheet->Actual_WorkHourInShift = $TotalWorkedHour;
                $Timesheet->PreOTHour = 0;
                $Timesheet->PreOTAmount = 0;

                $Timesheet->save();
            } else {

                $NOTHours = $NOTHour >= $NotRang ? $NotRang : $NOTHourwithGrace;
                $NOTAmount = $NOTHours * $employeesalary->OTRate;

                $DOTHours = $DOTHour <= $DotRang ? $DOTHourwithGrace : $DotRang;
                $DOTSallary = $DOTHours * $employeesalary->DoubleOTRate;

                $TOTHours = $TOTHour <= $TOTRang ? $TOTHourwithGrace : $TOTRang;
                $TOTSallary = 3 * ($TOTHours * $employeesalary->HourlyRate);
                $TotalOTHour = $NOTHours + $DOTHours + $TOTHours;
                Timesheet::model()->updateAll(array('WorkedHour' => $WorkedHourInshift, 'Actual_WorkHourInShift' => $TotalWorkedHour, 'WorkedDay' => 0, 'TotalOTHour' => $TotalOTHour, 'OutLateDeductTime' => $OutLateDeductTime, 'OutLateDeductAmount' => $OutLateDeductAmount, 'Intime' => $InTimelogOfShift[0]['PunchTime'], 'OuteTime' => $OutTimelogOfShift[0]['PunchTime'], 'NOvertimeHours' => $NOTHour, 'NOvertimeSalary' => $NOTAmount, 'DOverTimeHour' => $DOTHour, 'Dovertimesalary' => $DOTSallary, 'TOverTimeHour' => $TOTHour, 'Tovertimesalary' => $TOTSallary), 'id ="' . $Timesheetforemployee->id . '"');

                if (empty($OutTimelogs)) {
                    Timesheet::model()->updateAll(array('WorkedHour' => 0, 'Actual_WorkHourInShift' => 0, 'WorkedDay' => 0, 'TotalOTHour' => 0, 'LatedeductTime' => 0, 'LatedeductAmount' => 0, 'OutLateDeductTime' => $OutLateDeductTime, 'OutLateDeductAmount' => $OutLateDeductAmount, 'Intime' => $InTimelogOfShift[0]['PunchTime'], 'OuteTime' => "0000-00-00 00:00:00", 'NOvertimeHours' => 0, 'NOvertimeSalary' => 0, 'DOverTimeHour' => 0, 'Dovertimesalary' => 0, 'TOverTimeHour' => 0, 'Tovertimesalary' => 0, 'PreOTHour' => 0, 'PreOTAmount' => 0), 'id ="' . $Timesheetforemployee->id . '"');
                }
            }
        }
    }

    public function TimesheetCreateByshift($EmployeeShift, $InTimelogs, $OutTimelogs) {

        $InTimelog = !empty($InTimelogs) ? $InTimelogs[0]['PunchTime'] : $OutTimelogs[0]['PunchTime'];
        $OutTimelog = !empty($OutTimelogs) ? $OutTimelogs[0]['PunchTime'] : $InTimelogs[0]['PunchTime'];

        $shiftid = $EmployeeShift->ShiftId;
        $shift = Shift::model()->findByAttributes(array('id' => $shiftid));
        $ShiStartdate = strtotime($shift->StartTime);
        $SheduleDate = date('Y-m-d', $ShiStartdate);

        $employee = Employee::model()->findByAttributes(array('id' => $EmployeeShift->EmployeeId));
        $employeesalary = Employeesalary::model()->findByAttributes(array('employeeid' => $EmployeeShift->EmployeeId, 'site_id' => $employee->siteid, 'Status' => 1));
        if (empty($employeesalary)) {
            $employeesalary = new Employeesalary;
            $employeesalary->monthsalary = 0;
            $employeesalary->DalySalary = 0;
            $employeesalary->HourlyRate = 0;
            $employeesalary->OTRate = 0;
            $employeesalary->DoubleOTRate = 0;
            $employeesalary->BasicSalary = 0;
            $employeesalary->BRA1 = 0;
            $employeesalary->BRA2 = 0;
            $employeesalary->BRA3 = 0;
        }


        $DayWithName = Yii::app()->PublicFunctionForTimesheetUtil->GetDayForTimsheet($SheduleDate, $employee->siteid);

        $NotRang = $shift->FirstOTTimeRang;
        $DotRang = $shift->SecondOTRange;
        $NOTGraceTime = $shift->NOTGraceTime;
        $DOTGraceTime = $shift->DOTGraceTime;
        $OTRoundupValue = $shift->OTRoundup;
        $ShiftTOTRate = $shift->ThirdOTRate;
        $TOTRang = $shift->ThirdOTTimeRang;
        $TOTGraceTime = $shift->TOTGraceTime;

        $STime = strtotime(str_replace('/', '-', $InTimelog));
        $ETime = strtotime(str_replace('/', '-', $OutTimelog));
        $AWorkedhour = abs($ETime - $STime) / 3600;
        $TotalWorkedHour = $AWorkedhour > 0 ? $AWorkedhour : 0;

        $updated = strtotime($SheduleDate);
        $day = date('l', $updated);

        if ($DayWithName == "SUNDAY" or $DayWithName == "HOLIDAY") {

            $OTH = $TotalWorkedHour >= $NotRang ? $NotRang : $TotalWorkedHour;
            $NOTHour = $OTH > 0 ? $OTH : 0;

            $ShiftAndNOTHour = $NotRang;
            $DOTHValue = $TotalWorkedHour - $ShiftAndNOTHour;
            $DOTH = $DOTHValue >= $DotRang ? $DotRang : $DOTHValue;
            $DOTHour = $DOTH > 0 ? $DOTH : 0;

            $ShiftAndDOTHour = $NotRang + $DotRang;
            $TOTHValue = $TotalWorkedHour - $ShiftAndDOTHour;
            $TOTH = $TOTHValue >= $TOTRang ? $TOTRang : $TOTHValue;
            $TOTHour = $TOTH > 0 ? $TOTH : 0;
        } elseif ($day == "Saturday") {

            $OTH = $TotalWorkedHour - 5;
            $NOTHour = $OTH > 0 ? $OTH : 0;
            $ShiftAndNOTHour = 5 + $NotRang;
            $DOTH = $TotalWorkedHour - $ShiftAndNOTHour;
            $DOTHour = $DOTH > 0 ? $DOTH : 0;
            $ShiftAndDOTHour = 5 + $NotRang + $DotRang;
            $TOTH = $TotalWorkedHour - $ShiftAndDOTHour;
            $TOTHour = $TOTH > 0 ? $TOTH : 0;

            $NOTHourwithGrace = $NOTHour <= $NOTGraceTime ? 0 : $NOTHour;
            $DOTHourwithGrace = $DOTHour <= $DOTGraceTime ? 0 : $DOTHour;
            $TOTHourwithGrace = $TOTHour <= $TOTGraceTime ? 0 : $TOTHour;
        } else {
            $OTH = $TotalWorkedHour - 9;
            $NOTHour = $OTH > 0 ? $OTH : 0;
            $ShiftAndNOTHour = 9 + $NotRang;
            $DOTH = $TotalWorkedHour - $ShiftAndNOTHour;
            $DOTHour = $DOTH > 0 ? $DOTH : 0;
            $ShiftAndDOTHour = 9 + $NotRang + $DotRang;
            $TOTH = $TotalWorkedHour - $ShiftAndDOTHour;
            $TOTHour = $TOTH > 0 ? $TOTH : 0;
        }

        $NOTHourwithGrace = $NOTHour <= $NOTGraceTime ? 0 : $NOTHour;
        $DOTHourwithGrace = $DOTHour <= $DOTGraceTime ? 0 : $DOTHour;
        $TOTHourwithGrace = $TOTHour <= $TOTGraceTime ? 0 : $TOTHour;

        $HolidayR = $shift->salaryRate - 1;
        $HolidayRate = $HolidayR > 0 ? $HolidayR : 0;
        $ShiftHourlyRate = $DayWithName == "HOLIDAY" ? $HolidayRate : $shift->salaryRate;

        if ($NOTHour > $NOTGraceTime) {
            $Value = $OTRoundupValue;
            $NOTRoundupValue = Yii::app()->PublicFunctionForTimesheetUtil->OTRoundUp($NOTHour, $Value);
            $NOTHourwithGrace = $NOTRoundupValue;
        }
        if ($DOTHour > $DOTGraceTime) {
            $Value = $OTRoundupValue;
            $DOTRoundupValue = Yii::app()->PublicFunctionForTimesheetUtil->OTRoundUp($DOTHour, $Value);
            $DOTHourwithGrace = $DOTRoundupValue;
        }

        if ($TOTHour > $TOTGraceTime) {
            $Value = $OTRoundupValue;
            $TOTRoundupValue = Yii::app()->PublicFunctionForTimesheetUtil->OTRoundUp($TOTHour, $Value);
            $TOTHourwithGrace = $TOTRoundupValue;
        }

        $Result = Yii::app()->PublicFunctionForTimesheetUtil->ShortLeaveCalculationForFlexiShift($EmployeeShift->EmployeeId, $InTimelog, $OutTimelog);

        if ($DayWithName == "SUNDAY" or $DayWithName == "HOLIDAY") {
            $WorkedHourInshift = 0;
        } else {
            $WorkedHourInshift = $Result[0];
        }
        //======= Out Late deduct ==========//
        $OutLateDeductTime = $Result[2];
        $OutLateDeductAmount = $ShiftHourlyRate * ($OutLateDeductTime * $employeesalary->HourlyRate);

        $Timesheet = new Timesheet;

        $ActualInTime = empty($InTimelogs[0]) ? "0000-00-00 00:00:00" : $InTimelogs[0]['PunchTime'];
        $ActualOutTime = empty($OutTimelogs) ? "0000-00-00 00:00:00" : $OutTimelogs[0]['PunchTime'];

        $Daywage = $employeesalary->DalySalary * $ShiftHourlyRate;

        $Timesheet->Intime = $ActualInTime;
        $Timesheet->OuteTime = $ActualOutTime;
        $Timesheet->EmployeeId = $EmployeeShift->EmployeeId;
        $Timesheet->date = $SheduleDate;

        $Timesheet->NOvertimeHours = $NOTHour <= $NotRang ? $NOTHourwithGrace : $NotRang;
        $Timesheet->NOvertimeSalary = $Timesheet->NOvertimeHours * $employeesalary->OTRate;
        $Timesheet->DOverTimeHour = $DOTHour <= $DotRang ? $DOTHourwithGrace : $DotRang;
        $Timesheet->Dovertimesalary = $Timesheet->DOverTimeHour * $employeesalary->DoubleOTRate;
        $Timesheet->TOverTimeHour = $TOTHour <= $TOTRang ? $TOTHourwithGrace : $TOTRang;
        $Timesheet->Tovertimesalary = $ShiftTOTRate * ($Timesheet->TOverTimeHour * $employeesalary->HourlyRate);

        $Timesheet->SallaryRate = $Daywage;
        $Timesheet->WorkedHour = $WorkedHourInshift;
        $Timesheet->EmployeeShiftid = $EmployeeShift->id;
        $Timesheet->DesignaId = $employee->designationid;
        $Timesheet->TotalOTHour = $Timesheet->NOvertimeHours + $Timesheet->DOverTimeHour + $Timesheet->TOverTimeHour;
        $Timesheet->PaymentMethod = "MONTHLY";
        $Timesheet->DayName = $DayWithName;
        $Timesheet->LatedeductTime = 0;
        $Timesheet->LatedeductAmount = 0;
        $Timesheet->SiteId = $employee->siteid;
        $Timesheet->OutLateDeductTime = $OutLateDeductTime;
        $Timesheet->OutLateDeductAmount = $OutLateDeductAmount;
        $Timesheet->WorkedDay = 0;
        $Timesheet->Category = $employee->categoryid;
        $Timesheet->account_id = $employee->Accountid;
        $Timesheet->department_id = $employee->departmentid;
        $Timesheet->MP_suplier_id = $employee->supplierid;
        $Timesheet->full_Basic_Salary = $employeesalary->DalySalary;
        $Timesheet->Sub_Basic_salary = $employeesalary->BasicSalary;
        $Timesheet->BRA1 = $employeesalary->BRA1;
        $Timesheet->BRA2 = $employeesalary->BRA2;
        $Timesheet->BRA3 = $employeesalary->BRA3;
        $Timesheet->Actual_WorkHourInShift = $TotalWorkedHour;
        $Timesheet->PreOTHour = 0;
        $Timesheet->PreOTAmount = 0;
        $Timesheet->save();
    }

    public function TimesheetRecalculate($TimeSheetid) {

        $Current_Timesheet = Timesheet::model()->findByAttributes(array('id' => $TimeSheetid));
        if (!empty($Current_Timesheet)) {

            $OutTime = $Current_Timesheet->OuteTime;
            $InTime = $Current_Timesheet->Intime;
            $emshiftid = $Current_Timesheet->EmployeeShiftid;
            $EmployeeId = $Current_Timesheet->EmployeeId;
            $TimsheetId = $Current_Timesheet->id;
            $SiteId = $Current_Timesheet->SiteId;

            $employeesalary = Employeesalary::model()->findByAttributes(array('employeeid' => $EmployeeId, 'site_id' => $SiteId, 'Status' => 1));
            if (empty($employeesalary)) {
                $employeesalary = new Employeesalary;
                $employeesalary->monthsalary = 0;
                $employeesalary->DalySalary = 0;
                $employeesalary->HourlyRate = 0;
                $employeesalary->OTRate = 0;
                $employeesalary->DoubleOTRate = 0;
                $employeesalary->BasicSalary = 0;
                $employeesalary->BRA1 = 0;
                $employeesalary->BRA2 = 0;
                $employeesalary->BRA3 = 0;
            }
            $employeeshift = EmployeeShift::model()->findByAttributes(array('id' => $emshiftid));

            $shiftid = $employeeshift->ShiftId;

            $shift = Shift::model()->findByAttributes(array('id' => $shiftid));

            $ShiStartdate = strtotime($shift->StartTime);
            $Sheduldate = date('Y-m-d', $ShiStartdate);
            $DayWithName = Yii::app()->PublicFunctionForTimesheetUtil->GetDayForTimsheet($Sheduldate, $Current_Timesheet->SiteId);

            $NotRang = $shift->FirstOTTimeRang;
            $DotRang = $shift->SecondOTRange;
            $NOTGraceTime = $shift->NOTGraceTime;
            $DOTGraceTime = $shift->DOTGraceTime;
            $OTRoundupValue = $shift->OTRoundup;
            $TOTRang = $shift->ThirdOTTimeRang;
            $TOTGraceTime = $shift->TOTGraceTime;

            $HolidayR = $shift->salaryRate - 1;
            $HolidayRate = $HolidayR > 0 ? $HolidayR : 0;
            $ShiftHourlyRate = $DayWithName == "HOLIDAY" ? $HolidayRate : $shift->salaryRate;

            $DayWge = $employeesalary->DalySalary * $ShiftHourlyRate;

            if ($InTime == '0000-00-00 00:00:00' || $OutTime == '0000-00-00 00:00:00') {

                $OutLateTime = $InTime == '0000-00-00 00:00:00' ? 0 : 9;
                $OutLateDeduct = $InTime == '0000-00-00 00:00:00' ? 0 : $DayWge;

                Timesheet::model()->updateAll(array('WorkedHour' => 0, 'Actual_WorkHourInShift' => 0, 'TotalOTHour' => 0, 'SallaryRate' => $DayWge, 'full_Basic_Salary' => $employeesalary->DalySalary, 'Sub_Basic_salary' => $employeesalary->BasicSalary, 'BRA1' => $employeesalary->BRA1, 'BRA2' => $employeesalary->BRA2, 'BRA3' => $employeesalary->BRA3, 'NOvertimeHours' => 0, 'NOvertimeSalary' => 0, 'DOverTimeHour' => 0, 'Dovertimesalary' => 0, 'LatedeductTime' => 0, 'LatedeductAmount' => 0, 'OutLateDeductTime' => $OutLateTime, 'OutLateDeductAmount' => $OutLateDeduct, 'TOverTimeHour' => 0, 'Tovertimesalary' => 0, 'PreOTHour' => 0, 'PreOTAmount' => 0, 'DayName' => $DayWithName), 'id ="' . $TimsheetId . '"');
            } else {


                $STime = strtotime(str_replace('/', '-', $InTime));
                $ETime = strtotime(str_replace('/', '-', $OutTime));
                $AWorkedhour = abs($ETime - $STime) / 3600;
                $TotalWorkedHour = $AWorkedhour > 0 ? $AWorkedhour : 0;

                $updated = strtotime($Sheduldate);
                $day = date('l', $updated);

                if ($DayWithName == "SUNDAY" or $DayWithName == "HOLIDAY") {

                    $OTH = $TotalWorkedHour >= $NotRang ? $NotRang : $TotalWorkedHour;
                    $NOTHour = $OTH > 0 ? $OTH : 0;

                    $ShiftAndNOTHour = $NotRang;
                    $DOTHValue = $TotalWorkedHour - $ShiftAndNOTHour;
                    $DOTH = $DOTHValue >= $DotRang ? $DotRang : $DOTHValue;
                    $DOTHour = $DOTH > 0 ? $DOTH : 0;

                    $ShiftAndDOTHour = $NotRang + $DotRang;
                    $TOTHValue = $TotalWorkedHour - $ShiftAndDOTHour;
                    $TOTH = $TOTHValue >= $TOTRang ? $TOTRang : $TOTHValue;
                    $TOTHour = $TOTH > 0 ? $TOTH : 0;
                } elseif ($day == "Saturday") {

                    $OTH = $TotalWorkedHour - 5;
                    $NOTHour = $OTH > 0 ? $OTH : 0;
                    $ShiftAndNOTHour = 5 + $NotRang;
                    $DOTH = $TotalWorkedHour - $ShiftAndNOTHour;
                    $DOTHour = $DOTH > 0 ? $DOTH : 0;
                    $ShiftAndDOTHour = 5 + $NotRang + $DotRang;
                    $TOTH = $TotalWorkedHour - $ShiftAndDOTHour;
                    $TOTHour = $TOTH > 0 ? $TOTH : 0;

                    $NOTHourwithGrace = $NOTHour <= $NOTGraceTime ? 0 : $NOTHour;
                    $DOTHourwithGrace = $DOTHour <= $DOTGraceTime ? 0 : $DOTHour;
                    $TOTHourwithGrace = $TOTHour <= $TOTGraceTime ? 0 : $TOTHour;
                } else {
                    $OTH = $TotalWorkedHour - 9;
                    $NOTHour = $OTH > 0 ? $OTH : 0;
                    $ShiftAndNOTHour = 9 + $NotRang;
                    $DOTH = $TotalWorkedHour - $ShiftAndNOTHour;
                    $DOTHour = $DOTH > 0 ? $DOTH : 0;
                    $ShiftAndDOTHour = 9 + $NotRang + $DotRang;
                    $TOTH = $TotalWorkedHour - $ShiftAndDOTHour;
                    $TOTHour = $TOTH > 0 ? $TOTH : 0;
                }


                $NOTHourwithGrace = $NOTHour <= $NOTGraceTime ? 0 : $NOTHour;
                $DOTHourwithGrace = $DOTHour <= $DOTGraceTime ? 0 : $DOTHour;
                $TOTHourwithGrace = $TOTHour <= $TOTGraceTime ? 0 : $TOTHour;

                if ($NOTHour > $NOTGraceTime) {
                    $Value = $OTRoundupValue;
                    $NOTRoundupValue = Yii::app()->PublicFunctionForTimesheetUtil->OTRoundUp($NOTHour, $Value);
                    $NOTHourwithGrace = $NOTRoundupValue;
                }
                if ($DOTHour > $DOTGraceTime) {
                    $Value = $OTRoundupValue;
                    $DOTRoundupValue = Yii::app()->PublicFunctionForTimesheetUtil->OTRoundUp($DOTHour, $Value);
                    $DOTHourwithGrace = $DOTRoundupValue;
                }

                if ($TOTHour > $TOTGraceTime) {
                    $Value = $OTRoundupValue;
                    $TOTRoundupValue = Yii::app()->PublicFunctionForTimesheetUtil->OTRoundUp($TOTHour, $Value);
                    $TOTHourwithGrace = $TOTRoundupValue;
                }


                $Result = Yii::app()->PublicFunctionForTimesheetUtil->ShortLeaveCalculationForFlexiShift($EmployeeId, $InTime, $OutTime);

                if ($DayWithName == "SUNDAY" or $DayWithName == "HOLIDAY") {
                    $WorkedHourInshift = 0;
                } else {
                    $WorkedHourInshift = $Result[0];
                }

                //======= Out Late deduct ==========//
                $OutLateDeductTime = $Result[2];
                $OutLateDeductAmount = $ShiftHourlyRate * ($OutLateDeductTime * $employeesalary->HourlyRate);

                $employee = Employee::model()->findByAttributes(array('id' => $Current_Timesheet->EmployeeId));
                $paymentmethodType = $employee->Paymentmethod->type;
                $Category = $employee->categoryid;

                $NOTHours = $NOTHour >= $NotRang ? $NotRang : $NOTHourwithGrace;
                $NOTAmount = $NOTHours * $employeesalary->OTRate;

                $DOTHours = $DOTHour <= $DotRang ? $DOTHourwithGrace : $DotRang;
                $DOTSallary = $DOTHours * $employeesalary->DoubleOTRate;

                $TOTHours = $TOTHour <= $TOTRang ? $TOTHourwithGrace : $TOTRang;
                $TOTSallary = 3 * ($TOTHours * $employeesalary->HourlyRate);
                $TotalOTHour = $NOTHours + $DOTHours + $TOTHours;

                Timesheet::model()->updateAll(array('WorkedHour' => $WorkedHourInshift, 'Actual_WorkHourInShift' => $TotalWorkedHour, 'Category' => $Category, 'WorkedDay' => 1, 'Intime' => $InTime, 'OuteTime' => $OutTime, 'TotalOTHour' => $TotalOTHour, 'SallaryRate' => $DayWge, 'NOvertimeHours' => $NOTHours, 'NOvertimeSalary' => $NOTAmount, 'DOverTimeHour' => $DOTHours, 'Dovertimesalary' => $DOTSallary, 'LatedeductTime' => 0, 'LatedeductAmount' => 0, 'OutLateDeductTime' => $OutLateDeductTime, 'OutLateDeductAmount' => $OutLateDeductAmount, 'TOverTimeHour' => $TOTHour, 'Tovertimesalary' => $TOTSallary, 'PreOTHour' => 0, 'PreOTAmount' => 0, 'DayName' => $DayWithName), 'id ="' . $TimsheetId . '"');
            }
        }
    }

}
