<?php

class MonthlyPaymentCalculationEntitleUtilnew extends CApplicationComponent {

    public function CreateTimeSheet($model) {

        $employee = Employee::model()->findByAttributes(array('id' => $model->Employeeid));
        $employeesalary = Employeesalary::model()->findByAttributes(array('employeeid' => $model->Employeeid, 'site_id' => $model->Siteid, 'Status' => 1));
        if (empty($employeesalary)) {
            $employeesalary = new Employeesalary;
            $employeesalary->monthsalary = 0;
            $employeesalary->DalySalary = 0;
            $employeesalary->HourlyRate = 0;
            $employeesalary->OTRate = 0;
            $employeesalary->DoubleOTRate = 0;
            $employeesalary->BasicSalary = 0;
            $employeesalary->BRA1 = 0;
            $employeesalary->BRA2 = 0;
            $employeesalary->BRA3 = 0;
        }
        //------start of select punch time to shift -----//
        $SelectedShift = Yii::app()->PublicFunctionForTimesheetUtil->GetReleventShift($model);

        if (!empty($SelectedShift)) {
            //-----get relewent shift---------//     
            $shiftid = $SelectedShift[0]['shift_id'];
            $Current_Shift = Shift::model()->findByAttributes(array('id' => $shiftid));

            $ShiStartdate = strtotime($Current_Shift->StartTime);
            $Sheduldate = date('Y-m-d', $ShiStartdate);
            $DayWithName = Yii::app()->PublicFunctionForTimesheetUtil->GetDayForTimsheet($Sheduldate, $employee->siteid);

            //------get intime------//
            $InTimelogs = Yii::app()->PublicFunctionForTimesheetUtil->GetInTimeLog($Current_Shift, $model);

            //------get out time-------//
            $OutTimelogs = Yii::app()->PublicFunctionForTimesheetUtil->GetOutTimeLog($Current_Shift, $model);


            if ($DayWithName == "SUNDAY" or $DayWithName == "HOLIDAY") {
                Yii::app()->MonthlyPaymentCalculationEntitleUtilnew->TimeSheetForHolyday($SelectedShift, $Sheduldate, $model, $employeesalary, $InTimelogs, $OutTimelogs, $DayWithName, $employee);
            } else {
                Yii::app()->MonthlyPaymentCalculationEntitleUtilnew->TimeSheetForWeekday($SelectedShift, $Sheduldate, $model, $employeesalary, $InTimelogs, $OutTimelogs, $employee);
            }
        }
    }

    public function TimeSheetForHolyday($SelectedShift, $Sheduldate, $model, $employeesalary, $InTimelogs, $OutTimelogs, $DayWithName, $employee) {

        $InTimelogOfShift = empty($InTimelogs) ? $OutTimelogs : $InTimelogs;
        $OutTimelogOfShift = empty($OutTimelogs) ? $InTimelogs : $OutTimelogs;

        $shiftid = $SelectedShift[0]['shift_id'];
        $Current_Shift = Shift::model()->findByAttributes(array('id' => $shiftid));
        $ShiftStartTime = date('Y-m-d H:i:s', strtotime($Current_Shift->StartTime));
        $intime = date('Y-m-d H:i:s', strtotime($InTimelogOfShift[0]['PunchTime']));

        $StartTime = null;
        if ($ShiftStartTime < $intime) {
            $StartTime = Yii::app()->PublicFunctionForTimesheetUtil->ShiftLateDeduction($Current_Shift, $InTimelogOfShift[0]['PunchTime']);
        } else {
            $StartTime = $Current_Shift->StartTime;
        }

        $ts1 = strtotime(str_replace('/', '-', $Current_Shift->StartTime));
        $ts2 = strtotime(str_replace('/', '-', $OutTimelogOfShift[0]['PunchTime']));
        $timerange = ($ts2 - $ts1 ) / 3600;
        $diffhours = $timerange > 0 ? $timerange : 0;

        $ShiftStime = strtotime(str_replace('/', '-', $Current_Shift->StartTime));
        $ShiftEtime = strtotime(str_replace('/', '-', $Current_Shift->EndTime));
        $Shifthour = abs($ShiftStime - $ShiftEtime) / 3600;

        //new
//        $ShiftEndTime = date('Y-m-d H:i:s', strtotime($Current_Shift->EndTime));
//        $OutTime = date('Y-m-d H:i:s', strtotime($OutTimelogOfShift[0]['PunchTime']));
//        
//        $ActualStartTime = $ShiftStartTime < $intime ? $InTimelogOfShift[0]['PunchTime'] : $Current_Shift->StartTime;
//        $ActualEndTime = $OutTime < $ShiftEndTime ? $OutTimelogOfShift[0]['PunchTime'] : $Current_Shift->EndTime;

        $STime = strtotime(str_replace('/', '-', $InTimelogOfShift[0]['PunchTime']));
        $ETime = strtotime(str_replace('/', '-', $OutTimelogOfShift[0]['PunchTime']));
        $AWorkedhour = abs($ETime - $STime) / 3600;
        $ActualWorkedHourInShift = $AWorkedhour > 0 ? $timerange : 0;

        $HolidayR = $Current_Shift->salaryRate - 1;
        $HolidayRate = $HolidayR > 0 ? $HolidayR : 0;
        $ShiftHourlyRate = $DayWithName == "SUNDAY" ? $Current_Shift->salaryRate : $HolidayRate;
        $employeeshift = EmployeeShift::model()->findByAttributes(array('EmployeeId' => $model->Employeeid, 'ShiftId' => $shiftid));
        $Timesheetforemployee = Timesheet::model()->findByAttributes(array('EmployeeShiftid' => $employeeshift->id));


        $Timesheet = new Timesheet;
        $ActualInTime = empty($InTimelogs) ? "0000-00-00 00:00:00" : $InTimelogs[0]['PunchTime'];
        $ActualOutTime = empty($OutTimelogs) ? "0000-00-00 00:00:00" : $OutTimelogs[0]['PunchTime'];

        $Result = Yii::app()->PublicFunctionForTimesheetUtil->ShortLeaveCalculation($diffhours, $Shifthour, $model->Employeeid, $Current_Shift, $StartTime, $OutTimelogOfShift[0]['PunchTime']);
        $WorkedHour = $Result[0];

        //======= In Late deduct ==========//
        $LateDeductTime = $Result[1];
        $LateDeductAmount = $ShiftHourlyRate * ($LateDeductTime * $employeesalary->HourlyRate);


        //====== Get Short Leve Hour ========//
        $WorkedDays = 1;
        $shiftdate = strtotime($Current_Shift->EndTime);
        $Leavedate = date('Y-m-d', $shiftdate);
        $Short_Leave = Leave::model()->findByAttributes(array('EmoloyeeId' => $model->Employeeid, 'StartDate' => $Leavedate, 'PaidType' => "Pay", 'Status' => 1));
        if (!empty($Short_Leave)) {
            $WorkedHoursWithLeave1 = $Shifthour - $Short_Leave->No_Of_Hour;
            $WorkedHoursWithLeave2 = $WorkedHoursWithLeave1 < 0 ? 0 : $WorkedHoursWithLeave1;
            $WorkedDays = $WorkedHoursWithLeave2 / $Shifthour;
        }

        //======= Out Late deduct ==========//

        $OutLateDeductTime = $Result[2];
        $OutLateDeductAmount = $ShiftHourlyRate * ($OutLateDeductTime * $employeesalary->HourlyRate);

        $Daywage = $Shifthour == 0 ? 0 : $employeesalary->DalySalary * $ShiftHourlyRate;

        if ($Current_Shift->StartTime == $Current_Shift->EndTime) {
            $LateDeductTime = 0;
            $LateDeductAmount = 0;
            $OutLateDeductTime = 0;
            $OutLateDeductAmount = 0;
        }
        if (empty($Timesheetforemployee)) {

            $Timesheet->Intime = $ActualInTime;
            $Timesheet->OuteTime = $ActualOutTime;
            $Timesheet->EmployeeId = $model->Employeeid;
            $Timesheet->date = $Sheduldate;
            $Timesheet->SallaryRate = $Daywage;
            $Timesheet->WorkedHour = $WorkedHour;
            $Timesheet->NOvertimeHours = 0;
            $Timesheet->DOverTimeHour = 0;
            $Timesheet->Dovertimesalary = 0;
            $Timesheet->NOvertimeSalary = 0;
            $Timesheet->TotalOTHour = 0;
            $Timesheet->TOverTimeHour = 0;
            $Timesheet->Tovertimesalary = 0;

            $Timesheet->EmployeeShiftid = $employeeshift->id;
            //  $employeedesignation = EmployeeDesignation::model()->findByAttributes(array('EmployeeId' => $model->Employeeid));
            $Timesheet->DesignaId = $employee->designationid;
            $Timesheet->DayName = $DayWithName;
            $Timesheet->PaymentMethod = "MONTHLY";
            $Timesheet->LatedeductTime = $LateDeductTime;
            $Timesheet->LatedeductAmount = $LateDeductAmount;
            $Timesheet->SiteId = $employee->siteid;
            $Timesheet->OutLateDeductTime = $OutLateDeductTime;
            $Timesheet->OutLateDeductAmount = $OutLateDeductAmount;
            $Timesheet->WorkedDay = $WorkedDays;
            $Timesheet->Category = $employee->categoryid;
            $Timesheet->account_id = $employee->Accountid;
            $Timesheet->department_id = $employee->departmentid;
            $Timesheet->MP_suplier_id = $employee->supplierid;
            $Timesheet->full_Basic_Salary = 0;
            $Timesheet->Sub_Basic_salary = 0;
            $Timesheet->BRA1 = 0;
            $Timesheet->BRA2 = 0;
            $Timesheet->BRA3 = 0;
            $Timesheet->Actual_WorkHourInShift = $ActualWorkedHourInShift;

            if (empty($InTimelogs)) {
                $Timesheet->WorkedHour = 0;
                $Timesheet->LatedeductTime = 0;
                $Timesheet->LatedeductAmount = 0;
                $Timesheet->OutLateDeductTime = 0;
                $Timesheet->OutLateDeductAmount = 0;
                $Timesheet->Actual_WorkHourInShift = 0;
            }

            $Timesheet->ActualNOT = $Timesheet->NOvertimeHours;
            $Timesheet->ActualDOT = $Timesheet->DOverTimeHour;
            $Timesheet->ActualTOT = $Timesheet->TOverTimeHour;
            $Timesheet->save();
        } else {
            Timesheet::model()->updateAll(array('WorkedHour' => $WorkedHour, 'Actual_WorkHourInShift' => $ActualWorkedHourInShift, 'WorkedDay' => $WorkedDays, 'LatedeductTime' => $LateDeductTime, 'LatedeductAmount' => $LateDeductAmount, 'OutLateDeductTime' => $OutLateDeductTime, 'OutLateDeductAmount' => $OutLateDeductAmount, 'Intime' => $ActualInTime, 'OuteTime' => $ActualOutTime), 'id ="' . $Timesheetforemployee->id . '"');

            if (empty($InTimelogs)) {
                Timesheet::model()->updateAll(array('WorkedHour' => 0, 'Actual_WorkHourInShift' => 0, 'TotalOTHour' => 0, 'SallaryRate' => 0, 'LatedeductTime' => 0, 'LatedeductAmount' => 0, 'OutLateDeductTime' => 0, 'OutLateDeductAmount' => 0, 'Intime' => "0000-00-00 00:00:00", 'OuteTime' => $ActualOutTime, 'NOvertimeHours' => 0, 'NOvertimeSalary' => 0, 'DOverTimeHour' => 0, 'Dovertimesalary' => 0, 'TOverTimeHour' => 0, 'Tovertimesalary' => 0, 'ActualNOT' => 0, 'ActualDOT' => 0, 'ActualTOT' => 0), 'id ="' . $Timesheetforemployee->id . '"');
            }
        }
    }

    public function TimeSheetForWeekday($SelectedShift, $Sheduldate, $model, $employeesalary, $InTimelogs, $OutTimelogs, $employee) {

        $InTimelogOfShift = empty($InTimelogs) ? $OutTimelogs : $InTimelogs;
        $OutTimelogOfShift = empty($OutTimelogs) ? $InTimelogs : $OutTimelogs;

        $shiftid = $SelectedShift[0]['shift_id'];
        $Current_Shift = Shift::model()->findByAttributes(array('id' => $shiftid));
        $ShiftStartTime = date('Y-m-d H:i:s', strtotime($Current_Shift->StartTime));
        $intime = date('Y-m-d H:i:s', strtotime($InTimelogOfShift[0]['PunchTime']));

        $StartTime = null;

        if ($ShiftStartTime < $intime) {

            $StartTime = Yii::app()->PublicFunctionForTimesheetUtil->ShiftLateDeduction($Current_Shift, $InTimelogOfShift[0]['PunchTime']);
        } else {
            $StartTime = $Current_Shift->StartTime;
        }

        $ts1 = strtotime(str_replace('/', '-', $Current_Shift->StartTime));
        $ts2 = strtotime(str_replace('/', '-', $OutTimelogOfShift[0]['PunchTime']));
        $timerange = ($ts2 - $ts1 ) / 3600;
        $diffhours = $timerange > 0 ? $timerange : 0;

        $ShiftStime = strtotime(str_replace('/', '-', $Current_Shift->StartTime));
        $ShiftEtime = strtotime(str_replace('/', '-', $Current_Shift->EndTime));
        $Shifthour = abs($ShiftStime - $ShiftEtime) / 3600;

        //new
//        $ShiftEndTime = date('Y-m-d H:i:s', strtotime($Current_Shift->EndTime));
//        $OutTime = date('Y-m-d H:i:s', strtotime($OutTimelogOfShift[0]['PunchTime']));
//        
//        $ActualStartTime = $ShiftStartTime < $intime ? $InTimelogOfShift[0]['PunchTime'] : $Current_Shift->StartTime;
//        $ActualEndTime = $OutTime < $ShiftEndTime ? $OutTimelogOfShift[0]['PunchTime'] : $Current_Shift->EndTime;

        $STime = strtotime(str_replace('/', '-', $InTimelogOfShift[0]['PunchTime']));
        $ETime = strtotime(str_replace('/', '-', $OutTimelogOfShift[0]['PunchTime']));
        $AWorkedhour = abs($ETime - $STime) / 3600;
        $ActualWorkedHourInShift = $AWorkedhour > 0 ? $timerange : 0;

        $ShiftHourlyRate = $Current_Shift->salaryRate;
        $employeeshift = EmployeeShift::model()->findByAttributes(array('EmployeeId' => $model->Employeeid, 'ShiftId' => $shiftid));
        $Timesheetforemployee = Timesheet::model()->findByAttributes(array('EmployeeShiftid' => $employeeshift->id));


        $Timesheet = new Timesheet;
        $ActualInTime = empty($InTimelogs) ? "0000-00-00 00:00:00" : $InTimelogs[0]['PunchTime'];
        $ActualOutTime = empty($OutTimelogs) ? "0000-00-00 00:00:00" : $OutTimelogs[0]['PunchTime'];

        $Result = Yii::app()->PublicFunctionForTimesheetUtil->ShortLeaveCalculation($diffhours, $Shifthour, $model->Employeeid, $Current_Shift, $StartTime, $OutTimelogOfShift[0]['PunchTime']);
        $WorkedHour = $Result[0];

        //======= In Late deduct ==========//
        $LateDeductTime = $Result[1];
        $LateDeductAmount = $ShiftHourlyRate * ($LateDeductTime * $employeesalary->HourlyRate);

        //====== Get Short Leve Hour ========//
        $WorkedDays = 1;
        $shiftdate = strtotime($Current_Shift->EndTime);
        $Leavedate = date('Y-m-d', $shiftdate);
        $Short_Leave = Leave::model()->findByAttributes(array('EmoloyeeId' => $model->Employeeid, 'StartDate' => $Leavedate, 'PaidType' => "Pay", 'Status' => 1));
        if (!empty($Short_Leave)) {
            $WorkedHoursWithLeave1 = $Shifthour - $Short_Leave->No_Of_Hour;
            $WorkedHoursWithLeave2 = $WorkedHoursWithLeave1 < 0 ? 0 : $WorkedHoursWithLeave1;
            $WorkedDays = $WorkedHoursWithLeave2 / $Shifthour;
        }

        //======= Out Late deduct ==========//

        $OutLateDeductTime = $Result[2];
        $OutLateDeductAmount = $ShiftHourlyRate * ($OutLateDeductTime * $employeesalary->HourlyRate);

        $Daywage = $Shifthour == 0 ? 0 : $employeesalary->DalySalary * $ShiftHourlyRate;
        if ($Current_Shift->StartTime == $Current_Shift->EndTime) {
            $LateDeductTime = 0;
            $LateDeductAmount = 0;
            $OutLateDeductTime = 0;
            $OutLateDeductAmount = 0;
        }
        if (empty($Timesheetforemployee)) {

            $Timesheet->Intime = $ActualInTime;
            $Timesheet->OuteTime = $ActualOutTime;
            $Timesheet->EmployeeId = $model->Employeeid;
            $Timesheet->date = $Sheduldate;
            $Timesheet->SallaryRate = $Daywage;
            $Timesheet->NOvertimeHours = 0;
            $Timesheet->DOverTimeHour = 0;
            $Timesheet->Dovertimesalary = 0;
            $Timesheet->NOvertimeSalary = 0;
            $Timesheet->TotalOTHour = 0;
            $Timesheet->TOverTimeHour = 0;
            $Timesheet->Tovertimesalary = 0;

            $Timesheet->WorkedHour = $WorkedHour;
            $Timesheet->EmployeeShiftid = $employeeshift->id;
            //  $employeedesignation = EmployeeDesignation::model()->findByAttributes(array('EmployeeId' => $model->Employeeid));
            $Timesheet->DesignaId = $employee->designationid;
            $Timesheet->TotalOTHour = $Timesheet->NOvertimeHours + $Timesheet->DOverTimeHour;
            $Timesheet->DayName = "WEEKDAY";
            $Timesheet->PaymentMethod = "MONTHLY";
            $Timesheet->LatedeductTime = $LateDeductTime;
            $Timesheet->LatedeductAmount = $LateDeductAmount;
            $Timesheet->SiteId = $employee->siteid;
            $Timesheet->OutLateDeductTime = $OutLateDeductTime;
            $Timesheet->OutLateDeductAmount = $OutLateDeductAmount;
            $Timesheet->WorkedDay = $WorkedDays;
            $Timesheet->Category = $employee->categoryid;
            $Timesheet->account_id = $employee->Accountid;
            $Timesheet->department_id = $employee->departmentid;
            $Timesheet->MP_suplier_id = $employee->supplierid;
            $Timesheet->full_Basic_Salary = 0;
            $Timesheet->Sub_Basic_salary = 0;
            $Timesheet->BRA1 = 0;
            $Timesheet->BRA2 = 0;
            $Timesheet->BRA3 = 0;
            $Timesheet->Actual_WorkHourInShift = $ActualWorkedHourInShift;

            if (empty($InTimelogs)) {
                $Timesheet->WorkedHour = 0;
                $Timesheet->LatedeductTime = 0;
                $Timesheet->LatedeductAmount = 0;
                $Timesheet->OutLateDeductTime = 0;
                $Timesheet->OutLateDeductAmount = 0;
                $Timesheet->Actual_WorkHourInShift = 0;
            }
            $Timesheet->ActualNOT = $Timesheet->NOvertimeHours;
            $Timesheet->ActualDOT = $Timesheet->DOverTimeHour;
            $Timesheet->ActualTOT = $Timesheet->TOverTimeHour;
            $Timesheet->save();
        } else {

            Timesheet::model()->updateAll(array('WorkedHour' => $WorkedHour, 'Actual_WorkHourInShift' => $ActualWorkedHourInShift, 'WorkedDay' => $WorkedDays, 'LatedeductTime' => $LateDeductTime, 'LatedeductAmount' => $LateDeductAmount, 'OutLateDeductTime' => $OutLateDeductTime, 'OutLateDeductAmount' => $OutLateDeductAmount, 'Intime' => $ActualInTime, 'OuteTime' => $ActualOutTime), 'id ="' . $Timesheetforemployee->id . '"');

            if (empty($InTimelogs)) {
                Timesheet::model()->updateAll(array('WorkedHour' => 0, 'Actual_WorkHourInShift' => 0, 'TotalOTHour' => 0, 'LatedeductTime' => 0, 'LatedeductAmount' => 0, 'OutLateDeductTime' => 0, 'OutLateDeductAmount' => 0, 'Intime' => "0000-00-00 00:00:00", 'OuteTime' => $OutTimelogOfShift[0]['PunchTime'], 'NOvertimeHours' => 0, 'NOvertimeSalary' => 0, 'DOverTimeHour' => 0, 'Dovertimesalary' => 0, 'TOverTimeHour' => 0, 'Tovertimesalary' => 0, 'ActualNOT' => 0, 'ActualDOT' => 0, 'ActualTOT' => 0), 'id ="' . $Timesheetforemployee->id . '"');
            }
        }
    }

    public function TimesheetCreateByshift($EmployeeShift, $Timelogs) {

        $InTimelogOfShift = empty($Timelogs[0]) ? $Timelogs[1] : $Timelogs[0];
        $OutTimelogOfShift = empty($Timelogs[1]) ? $Timelogs[0] : $Timelogs[1];
        $Timesheet = new Timesheet;

        $shiftid = $EmployeeShift->ShiftId;
        $shift = Shift::model()->findByAttributes(array('id' => $shiftid));
        $ShiftStartTime = date('H:i:s', strtotime($shift->StartTime));
        $intime = date('H:i:s', strtotime($InTimelogOfShift[0]['PunchTime']));

        $ShiStartdate = strtotime($shift->StartTime);
        $SheduleDate = date('Y-m-d', $ShiStartdate);

        $employee = Employee::model()->findByAttributes(array('id' => $EmployeeShift->EmployeeId));
        $employeesalary = Employeesalary::model()->findByAttributes(array('employeeid' => $EmployeeShift->EmployeeId, 'site_id' => $employee->siteid, 'Status' => 1));
        if (empty($employeesalary)) {
            $employeesalary = new Employeesalary;
            $employeesalary->monthsalary = 0;
            $employeesalary->DalySalary = 0;
            $employeesalary->HourlyRate = 0;
            $employeesalary->OTRate = 0;
            $employeesalary->DoubleOTRate = 0;
            $employeesalary->BasicSalary = 0;
            $employeesalary->BRA1 = 0;
            $employeesalary->BRA2 = 0;
            $employeesalary->BRA3 = 0;
        }
        $DayWithName = Yii::app()->PublicFunctionForTimesheetUtil->GetDayForTimsheet($SheduleDate, $employee->siteid);

        $StartTime = null;
        if ($ShiftStartTime < $intime) {
            $StartTime = Yii::app()->PublicFunctionForTimesheetUtil->ShiftLateDeduction($shift, $InTimelogOfShift[0]['PunchTime']);
        } else {
            $StartTime = $shift->StartTime;
        }

        $ts1 = strtotime(str_replace('/', '-', $shift->StartTime));
        $ts2 = strtotime(str_replace('/', '-', $OutTimelogOfShift[0]['PunchTime']));
        $timerange = ($ts2 - $ts1 ) / 3600;
        $diffhours = $timerange > 0 ? $timerange : 0;

        $ShiftStime = strtotime(str_replace('/', '-', $shift->StartTime));
        $ShiftEtime = strtotime(str_replace('/', '-', $shift->EndTime));
        $Shifthour = abs($ShiftStime - $ShiftEtime) / 3600;

        //new
//        $ShiftEndTime = date('Y-m-d H:i:s', strtotime($shift->EndTime));
//        $OutTime = date('Y-m-d H:i:s', strtotime($OutTimelogOfShift[0]['PunchTime']));
//        
//        $ActualStartTime = $ShiftStartTime < $intime ? $InTimelogOfShift[0]['PunchTime'] : $shift->StartTime;
//        $ActualEndTime = $OutTime < $ShiftEndTime ? $OutTimelogOfShift[0]['PunchTime'] : $shift->EndTime;

        $STime = strtotime(str_replace('/', '-', $InTimelogOfShift[0]['PunchTime']));
        $ETime = strtotime(str_replace('/', '-', $OutTimelogOfShift[0]['PunchTime']));
        $AWorkedhour = abs($ETime - $STime) / 3600;
        $ActualWorkedHourInShift = $AWorkedhour > 0 ? $timerange : 0;

        $HolidayR = $shift->salaryRate - 1;
        $HolidayRate = $HolidayR > 0 ? $HolidayR : 0;
        $ShiftHourlyRate = $DayWithName == "HOLIDAY" ? $HolidayRate : $shift->salaryRate;

        $ActualInTime = empty($Timelogs[0]) ? "0000-00-00 00:00:00" : $Timelogs[0][0]['PunchTime'];
        $ActualOutTime = empty($Timelogs[1]) ? "0000-00-00 00:00:00" : $Timelogs[1][0]['PunchTime'];

        $Result = Yii::app()->PublicFunctionForTimesheetUtil->ShortLeaveCalculation($diffhours, $Shifthour, $EmployeeShift->EmployeeId, $shift, $StartTime, $OutTimelogOfShift[0]['PunchTime']);
        $workedhour = $Result[0];
        //======= In Late deduct ==========//
        $LateDeductTime = $Result[1];
        $LateDeductAmount = $ShiftHourlyRate * ($LateDeductTime * $employeesalary->HourlyRate);

        //====== Get Short Leve Hour ========//
        $WorkedDays = 1;
        $shiftdate = strtotime($shift->EndTime);
        $Leavedate = date('Y-m-d', $shiftdate);
        $Short_Leave = Leave::model()->findByAttributes(array('EmoloyeeId' => $EmployeeShift->EmployeeId, 'StartDate' => $Leavedate, 'PaidType' => "Pay", 'Status' => 1));
        if (!empty($Short_Leave)) {
            $WorkedHoursWithLeave1 = $Shifthour - $Short_Leave->No_Of_Hour;
            $WorkedHoursWithLeave2 = $WorkedHoursWithLeave1 < 0 ? 0 : $WorkedHoursWithLeave1;
            $WorkedDays = $WorkedHoursWithLeave2 / $Shifthour;
        }

        //======= Out Late deduct ==========//

        $OutLateDeductTime = $Result[2];
        $OutLateDeductAmount = $ShiftHourlyRate * ($OutLateDeductTime * $employeesalary->HourlyRate);

        $daysalarry = $Shifthour == 0 ? 0 : $employeesalary->DalySalary * $ShiftHourlyRate;
        // $DayWge = $DayWithName == "WEEKDAY" ? 0 : $daysalarry;

        if ($shift->StartTime == $shift->EndTime) {
            $LateDeductTime = 0;
            $LateDeductAmount = 0;
            $OutLateDeductTime = 0;
            $OutLateDeductAmount = 0;
        }

        $Timesheet->EmployeeId = $EmployeeShift->EmployeeId;
        $Timesheet->date = $SheduleDate;
        $Timesheet->Intime = $ActualInTime;
        $Timesheet->OuteTime = $ActualOutTime;
        $Timesheet->SallaryRate = $daysalarry;
        $Timesheet->NOvertimeHours = 0;
        $Timesheet->DOverTimeHour = 0;
        $Timesheet->Dovertimesalary = 0;
        $Timesheet->NOvertimeSalary = 0;
        $Timesheet->TotalOTHour = 0;
        $Timesheet->TOverTimeHour = 0;
        $Timesheet->Tovertimesalary = 0;

        $Timesheet->EmployeeShiftid = $EmployeeShift->id;
        $Timesheet->DesignaId = $employee->designationid;
        $Timesheet->WorkedHour = $workedhour;
        $Timesheet->PaymentMethod = "MONTHLY";
        $Timesheet->DayName = $DayWithName;
        $Timesheet->LatedeductTime = $LateDeductTime;
        $Timesheet->LatedeductAmount = $LateDeductAmount;
        $Timesheet->SiteId = $employee->siteid;
        $Timesheet->OutLateDeductTime = $OutLateDeductTime;
        $Timesheet->OutLateDeductAmount = $OutLateDeductAmount;
        $Timesheet->WorkedDay = $WorkedDays;
        $Timesheet->Category = $employee->categoryid;
        $Timesheet->account_id = $employee->Accountid;
        $Timesheet->department_id = $employee->departmentid;
        $Timesheet->MP_suplier_id = $employee->supplierid;
        $Timesheet->full_Basic_Salary = 0;
        $Timesheet->Sub_Basic_salary = 0;
        $Timesheet->BRA1 = 0;
        $Timesheet->BRA2 = 0;
        $Timesheet->BRA3 = 0;
        $Timesheet->Actual_WorkHourInShift = $ActualWorkedHourInShift;

        if (empty($Timelogs[0])) {
            $Timesheet->WorkedHour = 0;
            $Timesheet->LatedeductTime = 0;
            $Timesheet->LatedeductAmount = 0;
            $Timesheet->OutLateDeductTime = 0;
            $Timesheet->OutLateDeductAmount = 0;
            $Timesheet->Actual_WorkHourInShift = 0;
        }
        $Timesheet->ActualNOT = $Timesheet->NOvertimeHours;
        $Timesheet->ActualDOT = $Timesheet->DOverTimeHour;
        $Timesheet->ActualTOT = $Timesheet->TOverTimeHour;
        $Timesheet->save();
    }

    public function TimesheetRecalculate($TimeSheetid) {

        $Current_Timesheet = Timesheet::model()->findByAttributes(array('id' => $TimeSheetid));
        if (!empty($Current_Timesheet)) {

            $OutTime = $Current_Timesheet->OuteTime;
            $InTime = $Current_Timesheet->Intime;
            $emshiftid = $Current_Timesheet->EmployeeShiftid;
            $EmployeeId = $Current_Timesheet->EmployeeId;
            $TimsheetId = $Current_Timesheet->id;
            $SiteId = $Current_Timesheet->SiteId;
            // $DayWithName = $Current_Timesheet->DayName;

            $employeesalary = Employeesalary::model()->findByAttributes(array('employeeid' => $EmployeeId, 'site_id' => $SiteId, 'Status' => 1));
            if (empty($employeesalary)) {
                $employeesalary = new Employeesalary;
                $employeesalary->monthsalary = 0;
                $employeesalary->DalySalary = 0;
                $employeesalary->HourlyRate = 0;
                $employeesalary->OTRate = 0;
                $employeesalary->DoubleOTRate = 0;
                $employeesalary->BasicSalary = 0;
                $employeesalary->BRA1 = 0;
                $employeesalary->BRA2 = 0;
                $employeesalary->BRA3 = 0;
            }
            $employeeshift = EmployeeShift::model()->findByAttributes(array('id' => $emshiftid));

            $shiftid = $employeeshift->ShiftId;
            $shift = Shift::model()->findByAttributes(array('id' => $shiftid));

            $ShiftStartTime = date('H:i:s', strtotime($shift->StartTime));
            $intime = date('H:i:s', strtotime($InTime));
            $StartTime = null;

            $ShiStartdate = strtotime($shift->StartTime);
            $Sheduldate = date('Y-m-d', $ShiStartdate);
            $DayWithName = Yii::app()->PublicFunctionForTimesheetUtil->GetDayForTimsheet($Sheduldate, $Current_Timesheet->SiteId);

            if ($ShiftStartTime < $intime) {
                $StartTime = Yii::app()->PublicFunctionForTimesheetUtil->ShiftLateDeduction($shift, $InTime);
            } else {
                $StartTime = $shift->StartTime;
            }

            $ts1 = strtotime(str_replace('/', '-', $shift->StartTime));
            $ts2 = strtotime(str_replace('/', '-', $OutTime));
            $timerange = ($ts2 - $ts1 ) / 3600;
            $diffhours = $timerange > 0 ? $timerange : 0;

            $ShiftStime = strtotime(str_replace('/', '-', $shift->StartTime));
            $ShiftEtime = strtotime(str_replace('/', '-', $shift->EndTime));
            $Shifthour = abs($ShiftStime - $ShiftEtime) / 3600;

            //new
//            $ShiftEndTime = date('Y-m-d H:i:s', strtotime($shift->EndTime));
//            $OutTimeLog = date('Y-m-d H:i:s', strtotime($Current_Timesheet->OuteTime));
//               
//            $ActualStartTime = $ShiftStartTime < $intime ? $Current_Timesheet->Intime : $shift->StartTime;
//            $ActualEndTime = $OutTimeLog < $ShiftEndTime ? $Current_Timesheet->OuteTime : $shift->EndTime;

            $STime = strtotime(str_replace('/', '-', $Current_Timesheet->Intime));
            $ETime = strtotime(str_replace('/', '-', $Current_Timesheet->OuteTime));
            $AWorkedhour = abs($ETime - $STime) / 3600;
            $ActualWorkedHourInShift = $AWorkedhour > 0 ? $timerange : 0;

            $HolidayR = $shift->salaryRate - 1;
            $HolidayRate = $HolidayR > 0 ? $HolidayR : 0;
            $ShiftHourlyRate = $DayWithName == "HOLIDAY" ? $HolidayRate : $shift->salaryRate;

            $Result = Yii::app()->PublicFunctionForTimesheetUtil->ShortLeaveCalculation($diffhours, $Shifthour, $EmployeeId, $shift, $StartTime, $OutTime);
            $workedhour = $Result[0];

            //======= In Late deduct ==========//
            $LateDeductTime = $Result[1];
            $LateDeductAmount = $ShiftHourlyRate * ($LateDeductTime * $employeesalary->HourlyRate);

            //====== Get Short Leve Hour ========//
            $WorkedDays = 1;
            $shiftdate = strtotime($shift->EndTime);
            $Leavedate = date('Y-m-d', $shiftdate);
            $Short_Leave = Leave::model()->findByAttributes(array('EmoloyeeId' => $EmployeeId, 'StartDate' => $Leavedate, 'PaidType' => "Pay", 'Status' => 1));
            if (!empty($Short_Leave)) {
                $WorkedHoursWithLeave1 = $Shifthour - $Short_Leave->No_Of_Hour;
                $WorkedHoursWithLeave2 = $WorkedHoursWithLeave1 < 0 ? 0 : $WorkedHoursWithLeave1;
                $WorkedDays = $WorkedHoursWithLeave2 / $Shifthour;
            }

            //======= Out Late deduct ==========//
            $OutLateDeductTime = $Result[2];
            $OutLateDeductAmount = $ShiftHourlyRate * ($OutLateDeductTime * $employeesalary->HourlyRate);

            $DayWge = $Shifthour == 0 ? 0 : $employeesalary->DalySalary * $ShiftHourlyRate;
            //  $salary = $DayWithName == "WEEKDAY" ? 0 : $DayWge;

            if ($shift->StartTime == $shift->EndTime) {
                $LateDeductTime = 0;
                $LateDeductAmount = 0;
                $OutLateDeductTime = 0;
                $OutLateDeductAmount = 0;
            }
            $employee = Employee::model()->findByAttributes(array('id' => $Current_Timesheet->EmployeeId));
            $paymentmethodType = $employee->Paymentmethod->type;
            $Category = $employee->categoryid;

            Timesheet::model()->updateAll(array('WorkedHour' => $workedhour, 'Actual_WorkHourInShift' => $ActualWorkedHourInShift, 'Category' => $Category, 'WorkedDay' => $WorkedDays, 'Intime' => $InTime, 'OuteTime' => $OutTime, 'TotalOTHour' => 0, 'SallaryRate' => $DayWge, 'NOvertimeHours' => 0, 'NOvertimeSalary' => 0, 'DOverTimeHour' => 0, 'Dovertimesalary' => 0, 'LatedeductTime' => $LateDeductTime, 'LatedeductAmount' => $LateDeductAmount, 'OutLateDeductTime' => $OutLateDeductTime, 'OutLateDeductAmount' => $OutLateDeductAmount, 'TOverTimeHour' => 0, 'Tovertimesalary' => 0, 'ActualNOT' => 0, 'ActualDOT' => 0, 'ActualTOT' => 0, 'DayName' => $DayWithName), 'id ="' . $TimsheetId . '"');

            if ($shift->EndTime < $InTime) {
                Timesheet::model()->updateAll(array('WorkedHour' => 0, 'Actual_WorkHourInShift' => 0, 'TotalOTHour' => 0, 'NOvertimeHours' => 0, 'NOvertimeSalary' => 0, 'DOverTimeHour' => 0, 'Dovertimesalary' => 0, 'LatedeductTime' => 0, 'LatedeductAmount' => 0, 'OutLateDeductTime' => 0, 'OutLateDeductAmount' => 0, 'TOverTimeHour' => 0, 'Tovertimesalary' => 0, 'ActualNOT' => 0, 'ActualDOT' => 0, 'ActualTOT' => 0, 'DayName' => $DayWithName), 'id ="' . $TimsheetId . '"');
            }
            if ($InTime == '0000-00-00 00:00:00') {
                Timesheet::model()->updateAll(array('WorkedHour' => 0, 'Actual_WorkHourInShift' => 0, 'TotalOTHour' => 0, 'SallaryRate' => $DayWge, 'NOvertimeHours' => 0, 'NOvertimeSalary' => 0, 'DOverTimeHour' => 0, 'Dovertimesalary' => 0, 'LatedeductTime' => 0, 'LatedeductAmount' => 0, 'OutLateDeductTime' => 0, 'OutLateDeductAmount' => 0, 'TOverTimeHour' => 0, 'Tovertimesalary' => 0, 'ActualNOT' => 0, 'ActualDOT' => 0, 'ActualTOT' => 0, 'DayName' => $DayWithName), 'id ="' . $TimsheetId . '"');
            }
        }
    }

}
