<?php

class MonthlyPaymentCalculationUtilnew extends CApplicationComponent {

    public function CreateTimeSheet($model) {

        $employee = Employee::model()->findByAttributes(array('id' => $model->Employeeid));
        $employeesalary = Employeesalary::model()->findByAttributes(array('employeeid' => $model->Employeeid, 'site_id' => $model->Siteid, 'Status' => 1));

        if (empty($employeesalary)) {
            $employeesalary = new Employeesalary;
            $employeesalary->monthsalary = 0;
            $employeesalary->DalySalary = 0;
            $employeesalary->HourlyRate = 0;
            $employeesalary->OTRate = 0;
            $employeesalary->DoubleOTRate = 0;
            $employeesalary->BasicSalary = 0;
            $employeesalary->BRA1 = 0;
            $employeesalary->BRA2 = 0;
            $employeesalary->BRA3 = 0;
        }
        //------start of select punch time to shift -----//
        $SelectedShift = Yii::app()->PublicFunctionForTimesheetUtil->GetReleventShift($model);

        if (!empty($SelectedShift)) {
            //-----get relewent shift---------//     
            $shiftid = $SelectedShift[0]['shift_id'];
            $Current_Shift = Shift::model()->findByAttributes(array('id' => $shiftid));

            $ShiStartdate = strtotime($Current_Shift->StartTime);
            $Sheduldate = date('Y-m-d', $ShiStartdate);
            $DayWithName = Yii::app()->PublicFunctionForTimesheetUtil->GetDayForTimsheet($Sheduldate, $employee->siteid);

            //------get intime------//
            $InTimelogs = Yii::app()->PublicFunctionForTimesheetUtil->GetInTimeLog($Current_Shift, $model);

            //------get out time-------//
            $OutTimelogs = Yii::app()->PublicFunctionForTimesheetUtil->GetOutTimeLog($Current_Shift, $model);

            if ($DayWithName == "SUNDAY" or $DayWithName == "HOLIDAY") {
                Yii::app()->MonthlyPaymentCalculationUtilnew->TimeSheetForHolyday($SelectedShift, $Sheduldate, $model, $employeesalary, $InTimelogs, $OutTimelogs, $DayWithName, $employee);
            } else {
                Yii::app()->MonthlyPaymentCalculationUtilnew->TimeSheetForWeekday($SelectedShift, $Sheduldate, $model, $employeesalary, $InTimelogs, $OutTimelogs, $employee);
            }
        }
    }

    public function TimeSheetForHolyday($SelectedShift, $Sheduldate, $model, $employeesalary, $InTimelogs, $OutTimelogs, $DayWithName, $employee) {

        $InTimelogOfShift = empty($InTimelogs) ? $OutTimelogs : $InTimelogs;
        $OutTimelogOfShift = empty($OutTimelogs) ? $InTimelogs : $OutTimelogs;

        $shiftid = $SelectedShift[0]['shift_id'];
        $Current_Shift = Shift::model()->findByAttributes(array('id' => $shiftid));
        $ShiftStartTime = date('Y-m-d H:i:s', strtotime($Current_Shift->StartTime));
        $intime = date('Y-m-d H:i:s', strtotime($InTimelogOfShift[0]['PunchTime']));

        $StartTime = null;
        if ($ShiftStartTime < $intime) {
            $StartTime = Yii::app()->PublicFunctionForTimesheetUtil->ShiftLateDeduction($Current_Shift, $InTimelogOfShift[0]['PunchTime']);
        } else {
            $StartTime = $Current_Shift->StartTime;
        }

        $ts1 = strtotime(str_replace('/', '-', $Current_Shift->StartTime));
        $ts2 = strtotime(str_replace('/', '-', $OutTimelogOfShift[0]['PunchTime']));
        $timerange = ($ts2 - $ts1 ) / 3600;
        $diffhours = $timerange > 0 ? $timerange : 0;

        $ShiftStime = strtotime(str_replace('/', '-', $Current_Shift->StartTime));
        $ShiftEtime = strtotime(str_replace('/', '-', $Current_Shift->EndTime));
        $Shifthour = abs($ShiftStime - $ShiftEtime) / 3600;

        $STime = strtotime(str_replace('/', '-', $InTimelogOfShift[0]['PunchTime']));
        $ETime = strtotime(str_replace('/', '-', $OutTimelogOfShift[0]['PunchTime']));
        $AWorkedhour = abs($ETime - $STime) / 3600;
        $ActualWorkedHourInShift = $AWorkedhour > 0 ? $timerange : 0;

        $HolidayR = $Current_Shift->salaryRate - 1;
        $HolidayRate = $HolidayR > 0 ? $HolidayR : 0;
        $ShiftHourlyRate = $DayWithName == "SUNDAY" ? $Current_Shift->salaryRate : $HolidayRate;

        $ShiftNOTRate = $Current_Shift->FirstOTRate;
        $ShiftDOTRate = $Current_Shift->SecondOTRate;
        $NotRang = $Current_Shift->FirstOTTimeRang;
        $DotRang = $Current_Shift->SecondOTRange;
        $NOTGraceTime = $Current_Shift->NOTGraceTime;
        $DOTGraceTime = $Current_Shift->DOTGraceTime;
        $OTRoundupValue = $Current_Shift->OTRoundup;
        $ShiftTOTRate = $Current_Shift->ThirdOTRate;
        $TOTRang = $Current_Shift->ThirdOTTimeRang;
        $TOTGraceTime = $Current_Shift->TOTGraceTime;
        $PreOTStatus = $Current_Shift->PreOTStatus;

        $EmployeeSalaryHourlyRate = $employeesalary->HourlyRate;
        $EmployeeSalaryNOTRate = $employeesalary->OTRate;
        $EmployeeSalaryDOTRate = $employeesalary->DoubleOTRate;

        $OTHour = $diffhours - $Shifthour;
        $ShiftAndNOTHour = $Shifthour + $NotRang;
        $SecondOTHour = $diffhours - $ShiftAndNOTHour;
        $ShiftAndDOTHour = $Shifthour + $NotRang + $DotRang;
        $ThirdOTHour = $diffhours - $ShiftAndDOTHour;

        //new for Zeroshift
        $ts5 = strtotime(str_replace('/', '-', $Current_Shift->StartTime));
        $ts6 = strtotime(str_replace('/', '-', $InTimelogOfShift[0]['PunchTime']));
        $DeductTime = ($ts6 - $ts5 ) / 3600;
        $LateOur = $DeductTime > 0 ? $DeductTime : 0;

        //----new----//
        if ($Current_Shift->StartTime == $Current_Shift->EndTime) {

            $NotRang = $Current_Shift->FirstOTTimeRang > 1 ? $Current_Shift->FirstOTTimeRang - $LateOur : $Current_Shift->FirstOTTimeRang;

			if($Current_Shift->FirstOTTimeRang == 0){
             $DotRang = $Current_Shift->SecondOTRange > 1 ? $Current_Shift->SecondOTRange - $LateOur : $Current_Shift->SecondOTRange; 
             }

            $T1 = strtotime(str_replace('/', '-', $StartTime));
            $T2 = strtotime(str_replace('/', '-', $OutTimelogOfShift[0]['PunchTime']));
            $timerange = ($T2 - $T1 ) / 3600;
            $DifferStarAndOut = $timerange > 0 ? $timerange : 0;

            $OTHour = $DifferStarAndOut - $Shifthour;
            $ShiftAndNOTHour = $Shifthour + $NotRang;
            $SecondOTHour = $DifferStarAndOut - $ShiftAndNOTHour;
            $ShiftAndDOTHour = $Shifthour + $NotRang + $DotRang;
            $ThirdOTHour = $DifferStarAndOut - $ShiftAndDOTHour;
        }

        $ExtraOTHourStatus = $Current_Shift->ExtraHourStatus;
        $ExtraOTHour = $Current_Shift->ExtraHour;
        $ExtraOTHourRate = $Current_Shift->ExtraHourRate;

        if ($ExtraOTHourStatus == 1) {

            if (!empty($OutTimelogs) and $Current_Shift->EndTime <= $OutTimelogs[0]['PunchTime']) {

                if ($ExtraOTHourRate == "N-OT") {
                    $OTHour = $ExtraOTHour != null ? $ExtraOTHour : 0;
                } elseif ($ExtraOTHourRate == "D-OT") {
                    $SecondOTHour = $ExtraOTHour != null ? $ExtraOTHour : 0;
                }
            }
        }

        $NOTHourwithGrace = $OTHour <= $NOTGraceTime ? 0 : $OTHour;
        $DOTHourwithGrace = $SecondOTHour <= $DOTGraceTime ? 0 : $SecondOTHour;
        $TOTHourwithGrace = $ThirdOTHour <= $TOTGraceTime ? 0 : $ThirdOTHour;

        if ($OTHour > $NOTGraceTime) {
            $Value = $OTRoundupValue;
            $NOTRoundupValue = Yii::app()->PublicFunctionForTimesheetUtil->OTRoundUp($OTHour, $Value);
            $NOTHourwithGrace = $NOTRoundupValue;
        }
        if ($SecondOTHour > $DOTGraceTime) {
            $Value = $OTRoundupValue;
            $DOTRoundupValue = Yii::app()->PublicFunctionForTimesheetUtil->OTRoundUp($SecondOTHour, $Value);
            $DOTHourwithGrace = $DOTRoundupValue;
        }
        if ($ThirdOTHour > $TOTGraceTime) {
            $Value = $OTRoundupValue;
            $TOTRoundupValue = Yii::app()->PublicFunctionForTimesheetUtil->OTRoundUp($ThirdOTHour, $Value);
            $TOTHourwithGrace = $TOTRoundupValue;
        }

        $employeeshift = EmployeeShift::model()->findByAttributes(array('EmployeeId' => $model->Employeeid, 'ShiftId' => $shiftid));
        $Timesheet = new Timesheet;
        $ActualInTime = empty($InTimelogs) ? "0000-00-00 00:00:00" : $InTimelogs[0]['PunchTime'];
        $ActualOutTime = empty($OutTimelogs) ? "0000-00-00 00:00:00" : $OutTimelogs[0]['PunchTime'];

        $Result = Yii::app()->PublicFunctionForTimesheetUtil->ShortLeaveCalculation($diffhours, $Shifthour, $model->Employeeid, $Current_Shift, $StartTime, $OutTimelogOfShift[0]['PunchTime']);
        $WorkedHour = $Result[0];

        //======= In Late deduct ==========//
        //$LateDeductTime = Yii::app()->PublicFunctionForTimesheetUtil->GetEarlyDeductTime($Current_Shift, $StartTime, $model->Employeeid);
        $LateDeductTime = $Result[1];
        $LateDeductAmount = $ShiftHourlyRate * ($LateDeductTime * $employeesalary->HourlyRate);

        //====== Get Short Leve Hour ========//
        $WorkedDays = 1;
        $shiftdate = strtotime($Current_Shift->EndTime);
        $Leavedate = date('Y-m-d', $shiftdate);
        $Short_Leave = Leave::model()->findByAttributes(array('EmoloyeeId' => $model->Employeeid, 'StartDate' => $Leavedate, 'PaidType' => "Pay", 'Status' => 1));
        if (!empty($Short_Leave)) {
            $WorkedHoursWithLeave1 = $Shifthour - $Short_Leave->No_Of_Hour;
            $WorkedHoursWithLeave2 = $WorkedHoursWithLeave1 < 0 ? 0 : $WorkedHoursWithLeave1;
            if ($Shifthour > 0) {
                $WorkedDays = $WorkedHoursWithLeave2 / $Shifthour;
            }
        }
        $PreOTHour = 0;
        $PreOTAmount = 0;
        if ($PreOTStatus == 1) {
            $PreOTHour = Yii::app()->PublicFunctionForTimesheetUtil->GetPreOTTime($Current_Shift->StartTime, $intime);
            $PreOTAmount = $PreOTHour * $EmployeeSalaryNOTRate;
        }

        //======= Out Late deduct ==========//
        $OutLateDeductTime = $Result[2];
        $OutLateDeductAmount = $ShiftHourlyRate * ($OutLateDeductTime * $EmployeeSalaryHourlyRate);

        $Daywage = $Shifthour == 0 ? 0 : $employeesalary->DalySalary * $ShiftHourlyRate;

        if ($Current_Shift->StartTime == $Current_Shift->EndTime) {
            $LateDeductTime = 0;
            $LateDeductAmount = 0;
            $OutLateDeductTime = 0;
            $OutLateDeductAmount = 0;
        }
        $Timesheetforemployee = Timesheet::model()->findByAttributes(array('EmployeeShiftid' => $employeeshift->id));
        if (empty($Timesheetforemployee)) {

            $Timesheet->Intime = $ActualInTime;
            $Timesheet->OuteTime = $ActualOutTime;
            $Timesheet->EmployeeId = $model->Employeeid;
            $Timesheet->date = $Sheduldate;

            if ($Shifthour >= $diffhours) {

                $Timesheet->NOvertimeHours = 0;
                $Timesheet->DOverTimeHour = 0;
                $Timesheet->Dovertimesalary = 0;
                $Timesheet->NOvertimeSalary = 0;
                $Timesheet->WorkedHour = $WorkedHour;
                $Timesheet->TotalOTHour = 0;
                $Timesheet->TOverTimeHour = 0;
                $Timesheet->Tovertimesalary = 0;
            } else {

                $Timesheet->NOvertimeHours = $OTHour <= $NotRang ? $NOTHourwithGrace : $NotRang;
                $Timesheet->NOvertimeSalary = $Timesheet->NOvertimeHours * $EmployeeSalaryNOTRate;

                if ($diffhours > $ShiftAndNOTHour) {
                    $Timesheet->DOverTimeHour = $SecondOTHour <= $DotRang ? $DOTHourwithGrace : $DotRang;
                    $Timesheet->Dovertimesalary = $Timesheet->DOverTimeHour * $EmployeeSalaryDOTRate;

                    if ($diffhours > $ShiftAndDOTHour) {
                        $CustomizeOTHour = $ThirdOTHour <= $TOTRang ? $TOTHourwithGrace : $TOTRang;
                        $CustomizeOTAmount = $ShiftTOTRate * ( $CustomizeOTHour * $employeesalary->HourlyRate);
                        $Timesheet->TOverTimeHour = 0;
                        $Timesheet->Tovertimesalary = 0;

                        if ($ShiftTOTRate == 1.5) {
                            $Timesheet->NOvertimeHours = $Timesheet->NOvertimeHours + $CustomizeOTHour;
                            $Timesheet->NOvertimeSalary = $Timesheet->NOvertimeSalary + $CustomizeOTAmount;
                        } elseif ($ShiftTOTRate == 2) {
                            $Timesheet->DOverTimeHour = $Timesheet->DOverTimeHour + $CustomizeOTHour;
                            $Timesheet->Dovertimesalary = $Timesheet->Dovertimesalary + $CustomizeOTAmount;
                        } else {
                            $Timesheet->TOverTimeHour = $CustomizeOTHour;
                            $Timesheet->Tovertimesalary = $CustomizeOTAmount;
                        }
                    } else {
                        $Timesheet->TOverTimeHour = 0;
                        $Timesheet->Tovertimesalary = 0;
                    }
                } else {
                    $Timesheet->DOverTimeHour = 0;
                    $Timesheet->Dovertimesalary = 0;
                    $Timesheet->TOverTimeHour = 0;
                    $Timesheet->Tovertimesalary = 0;
                }
            }
            $Timesheet->SallaryRate = $Daywage;
            $Timesheet->WorkedHour = $WorkedHour;
            $Timesheet->EmployeeShiftid = $employeeshift->id;
            $Timesheet->DesignaId = $employee->designationid;
            $Timesheet->DayName = $DayWithName;
            $Timesheet->PaymentMethod = "MONTHLY";
            $Timesheet->LatedeductTime = $LateDeductTime;
            $Timesheet->LatedeductAmount = $LateDeductAmount;
            $Timesheet->SiteId = $employee->siteid;
            $Timesheet->OutLateDeductTime = $OutLateDeductTime;
            $Timesheet->OutLateDeductAmount = $OutLateDeductAmount;
            $Timesheet->WorkedDay = $WorkedDays;
            $Timesheet->Category = $employee->categoryid;
            $Timesheet->account_id = $employee->Accountid;
            $Timesheet->department_id = $employee->departmentid;
            $Timesheet->MP_suplier_id = $employee->supplierid;
            $Timesheet->full_Basic_Salary = 0;
            $Timesheet->Sub_Basic_salary = 0;
            $Timesheet->BRA1 = 0;
            $Timesheet->BRA2 = 0;
            $Timesheet->BRA3 = 0;
            $Timesheet->Actual_WorkHourInShift = $ActualWorkedHourInShift;
            $Timesheet->PreOTHour = empty($OutTimelogs) ? 0 : $PreOTHour;
            $Timesheet->PreOTAmount = empty($OutTimelogs) ? 0 : $PreOTAmount;
            $Timesheet->TotalOTHour = $Timesheet->NOvertimeHours + $Timesheet->DOverTimeHour + $Timesheet->PreOTHour;

            if (empty($InTimelogs)) {
                $Timesheet->WorkedHour = 0;
                $Timesheet->NOvertimeHours = 0;
                $Timesheet->DOverTimeHour = 0;
                $Timesheet->Dovertimesalary = 0;
                $Timesheet->NOvertimeSalary = 0;
                $Timesheet->TotalOTHour = 0;
                $Timesheet->TOverTimeHour = 0;
                $Timesheet->Tovertimesalary = 0;
                $Timesheet->LatedeductTime = 0;
                $Timesheet->LatedeductAmount = 0;
                $Timesheet->OutLateDeductTime = 0;
                $Timesheet->OutLateDeductAmount = 0;
                $Timesheet->Actual_WorkHourInShift = 0;
                $Timesheet->PreOTHour = 0;
                $Timesheet->PreOTAmount = 0;
            }
            $Timesheet->ActualNOT = $Timesheet->NOvertimeHours;
            $Timesheet->ActualDOT = $Timesheet->DOverTimeHour;
            $Timesheet->ActualTOT = $Timesheet->TOverTimeHour;
            $Timesheet->save();
        } else {

            if ($Shifthour >= $diffhours) {
                Timesheet::model()->updateAll(array('WorkedHour' => $WorkedHour, 'SallaryRate' => $Daywage, 'Actual_WorkHourInShift' => $ActualWorkedHourInShift, 'WorkedDay' => $WorkedDays, 'LatedeductTime' => $LateDeductTime, 'LatedeductAmount' => $LateDeductAmount, 'OutLateDeductTime' => $OutLateDeductTime, 'OutLateDeductAmount' => $OutLateDeductAmount, 'PreOTHour' => $PreOTHour, 'PreOTAmount' => $PreOTAmount, 'Intime' => $ActualInTime, 'OuteTime' => $ActualOutTime), 'id ="' . $Timesheetforemployee->id . '"');
            } else {

                $NOTHour = $OTHour >= $NotRang ? $NotRang : $NOTHourwithGrace;
                $NOTAmount = $NOTHour * $EmployeeSalaryNOTRate;
                $TotalOTHour = $NOTHour + $PreOTHour;

                if ($diffhours > $ShiftAndNOTHour) {
                    $DOTHour = $SecondOTHour <= $DotRang ? $DOTHourwithGrace : $DotRang;
                    $DOTSallary = $DOTHour * $EmployeeSalaryDOTRate;
                    $TotalOTHour = $NOTHour + $DOTHour + $PreOTHour;

                    if ($diffhours > $ShiftAndDOTHour) {
                        $CustomizeOTHour = $ThirdOTHour <= $TOTRang ? $TOTHourwithGrace : $TOTRang;
                        $CustomizeOTSallary = $ShiftTOTRate * ($CustomizeOTHour * $employeesalary->HourlyRate);
                        $TotalOTHour = $NOTHour + $DOTHour + $CustomizeOTHour + $PreOTHour;
                        $TOTHour = 0;
                        $TOTSallary = 0;

                        if ($ShiftTOTRate == 1.5) {
                            $NOTHour = $NOTHour + $CustomizeOTHour;
                            $NOTAmount = $NOTAmount + $CustomizeOTSallary;
                        } elseif ($ShiftTOTRate == 2) {
                            $DOTHour = $DOTHour + $CustomizeOTHour;
                            $DOTSallary = $DOTSallary + $CustomizeOTSallary;
                        } else {
                            $TOTHour = $CustomizeOTHour;
                            $TOTSallary = $CustomizeOTSallary;
                        }
                        Timesheet::model()->updateAll(array('WorkedHour' => $WorkedHour, 'SallaryRate' => $Daywage, 'Actual_WorkHourInShift' => $ActualWorkedHourInShift, 'WorkedDay' => $WorkedDays, 'TotalOTHour' => $TotalOTHour, 'LatedeductTime' => $LateDeductTime, 'LatedeductAmount' => $LateDeductAmount, 'OutLateDeductTime' => $OutLateDeductTime, 'OutLateDeductAmount' => $OutLateDeductAmount, 'PreOTHour' => $PreOTHour, 'PreOTAmount' => $PreOTAmount, 'Intime' => $ActualInTime, 'OuteTime' => $ActualOutTime, 'NOvertimeHours' => $NOTHour, 'NOvertimeSalary' => $NOTAmount, 'DOverTimeHour' => $DOTHour, 'Dovertimesalary' => $DOTSallary, 'TOverTimeHour' => $TOTHour, 'Tovertimesalary' => $TOTSallary,'ActualNOT' => $NOTHour,'ActualDOT' => $DOTHour,'ActualTOT' => $TOTHour), 'id ="' . $Timesheetforemployee->id . '"');
                    } else {
                        Timesheet::model()->updateAll(array('WorkedHour' => $WorkedHour, 'SallaryRate' => $Daywage, 'Actual_WorkHourInShift' => $ActualWorkedHourInShift, 'WorkedDay' => $WorkedDays, 'TotalOTHour' => $TotalOTHour, 'LatedeductTime' => $LateDeductTime, 'LatedeductAmount' => $LateDeductAmount, 'OutLateDeductTime' => $OutLateDeductTime, 'OutLateDeductAmount' => $OutLateDeductAmount, 'PreOTHour' => $PreOTHour, 'PreOTAmount' => $PreOTAmount, 'Intime' => $ActualInTime, 'OuteTime' => $ActualOutTime, 'NOvertimeHours' => $NOTHour, 'NOvertimeSalary' => $NOTAmount, 'DOverTimeHour' => $DOTHour, 'Dovertimesalary' => $DOTSallary, 'TOverTimeHour' => 0, 'Tovertimesalary' => 0,'ActualNOT' => $NOTHour,'ActualDOT' => $DOTHour,'ActualTOT' => 0), 'id ="' . $Timesheetforemployee->id . '"');
                    }
                } else {
                    Timesheet::model()->updateAll(array('WorkedHour' => $WorkedHour, 'SallaryRate' => $Daywage, 'Actual_WorkHourInShift' => $ActualWorkedHourInShift, 'WorkedDay' => $WorkedDays, 'TotalOTHour' => $TotalOTHour, 'LatedeductTime' => $LateDeductTime, 'LatedeductAmount' => $LateDeductAmount, 'OutLateDeductTime' => $OutLateDeductTime, 'OutLateDeductAmount' => $OutLateDeductAmount, 'PreOTHour' => $PreOTHour, 'PreOTAmount' => $PreOTAmount, 'Intime' => $ActualInTime, 'OuteTime' => $ActualOutTime, 'NOvertimeHours' => $NOTHour, 'NOvertimeSalary' => $NOTAmount, 'DOverTimeHour' => 0, 'Dovertimesalary' => 0, 'TOverTimeHour' => 0, 'Tovertimesalary' => 0,'ActualNOT' => $NOTHour,'ActualDOT' => 0,'ActualTOT' => 0), 'id ="' . $Timesheetforemployee->id . '"');
                }
            }
            if (empty($InTimelogs)) {
                Timesheet::model()->updateAll(array('WorkedHour' => 0, 'Actual_WorkHourInShift' => 0, 'TotalOTHour' => 0, 'LatedeductTime' => 0, 'LatedeductAmount' => 0, 'OutLateDeductTime' => 0, 'OutLateDeductAmount' => 0, 'Intime' => "0000-00-00 00:00:00", 'OuteTime' => $OutTimelogOfShift[0]['PunchTime'], 'NOvertimeHours' => 0, 'NOvertimeSalary' => 0, 'DOverTimeHour' => 0, 'Dovertimesalary' => 0, 'TOverTimeHour' => 0, 'Tovertimesalary' => 0,'ActualNOT' => 0,'ActualDOT' => 0,'ActualTOT' => 0), 'id ="' . $Timesheetforemployee->id . '"');
            }
            if (empty($OutTimelogs)) {
                Timesheet::model()->updateAll(array('WorkedHour' => 0, 'Actual_WorkHourInShift' => 0, 'TotalOTHour' => 0, 'LatedeductTime' => $LateDeductTime, 'LatedeductAmount' => $LateDeductAmount, 'OutLateDeductTime' => $OutLateDeductTime, 'OutLateDeductAmount' => $OutLateDeductAmount, 'Intime' => $ActualInTime, 'OuteTime' => "0000-00-00 00:00:00", 'NOvertimeHours' => 0, 'NOvertimeSalary' => 0, 'DOverTimeHour' => 0, 'Dovertimesalary' => 0, 'TOverTimeHour' => 0, 'Tovertimesalary' => 0,'ActualNOT' => 0,'ActualDOT' => 0,'ActualTOT' => 0), 'id ="' . $Timesheetforemployee->id . '"');
            }
        }
    }

    public function TimeSheetForWeekday($SelectedShift, $Sheduldate, $model, $employeesalary, $InTimelogs, $OutTimelogs, $employee) {

        $InTimelogOfShift = empty($InTimelogs) ? $OutTimelogs : $InTimelogs;
        $OutTimelogOfShift = empty($OutTimelogs) ? $InTimelogs : $OutTimelogs;

        $shiftid = $SelectedShift[0]['shift_id'];
        $Current_Shift = Shift::model()->findByAttributes(array('id' => $shiftid));
        $ShiftStartTime = date('Y-m-d H:i:s', strtotime($Current_Shift->StartTime));
        $intime = date('Y-m-d H:i:s', strtotime($InTimelogOfShift[0]['PunchTime']));

        $StartTime = null;

        if ($ShiftStartTime < $intime) {

            $StartTime = Yii::app()->PublicFunctionForTimesheetUtil->ShiftLateDeduction($Current_Shift, $InTimelogOfShift[0]['PunchTime']);
        } else {
            $StartTime = $Current_Shift->StartTime;
        }

        $ts1 = strtotime(str_replace('/', '-', $Current_Shift->StartTime));
        $ts2 = strtotime(str_replace('/', '-', $OutTimelogOfShift[0]['PunchTime']));
        $timerange = ($ts2 - $ts1 ) / 3600;
        $diffhours = $timerange > 0 ? $timerange : 0;

        $ShiftStime = strtotime(str_replace('/', '-', $Current_Shift->StartTime));
        $ShiftEtime = strtotime(str_replace('/', '-', $Current_Shift->EndTime));
        $Shifthour = abs($ShiftStime - $ShiftEtime) / 3600;

        $STime = strtotime(str_replace('/', '-', $InTimelogOfShift[0]['PunchTime']));
        $ETime = strtotime(str_replace('/', '-', $OutTimelogOfShift[0]['PunchTime']));
        $AWorkedhour = abs($ETime - $STime) / 3600;
        $ActualWorkedHourInShift = $AWorkedhour > 0 ? $timerange : 0;

        $ShiftHourlyRate = $Current_Shift->salaryRate;
        $ShiftNOTRate = $Current_Shift->FirstOTRate;
        $ShiftDOTRate = $Current_Shift->SecondOTRate;
        $NotRang = $Current_Shift->FirstOTTimeRang;
        $DotRang = $Current_Shift->SecondOTRange;
        $NOTGraceTime = $Current_Shift->NOTGraceTime;
        $DOTGraceTime = $Current_Shift->DOTGraceTime;
        $OTRoundupValue = $Current_Shift->OTRoundup;
        $ShiftTOTRate = $Current_Shift->ThirdOTRate;
        $TOTRang = $Current_Shift->ThirdOTTimeRang;
        $TOTGraceTime = $Current_Shift->TOTGraceTime;
        $PreOTStatus = $Current_Shift->PreOTStatus;

        $EmployeeSalaryHourlyRate = $employeesalary->HourlyRate;
        $EmployeeSalaryNOTRate = $employeesalary->OTRate;
        $EmployeeSalaryDOTRate = $employeesalary->DoubleOTRate;

        $OTHour = $diffhours - $Shifthour;
        $ShiftAndNOTHour = $Shifthour + $NotRang;
        $SecondOTHour = $diffhours - $ShiftAndNOTHour;
        $ShiftAndDOTHour = $Shifthour + $NotRang + $DotRang;
        $ThirdOTHour = $diffhours - $ShiftAndDOTHour;

        //new for Zeroshift
        $ts5 = strtotime(str_replace('/', '-', $Current_Shift->StartTime));
        $ts6 = strtotime(str_replace('/', '-', $InTimelogOfShift[0]['PunchTime']));
        $DeductTime = ($ts6 - $ts5 ) / 3600;
        $LateOur = $DeductTime > 0 ? $DeductTime : 0;

        //----new----//
        if ($Current_Shift->StartTime == $Current_Shift->EndTime) {

            $NotRang = $Current_Shift->FirstOTTimeRang > 1 ? $Current_Shift->FirstOTTimeRang - $LateOur : $Current_Shift->FirstOTTimeRang;

			if($Current_Shift->FirstOTTimeRang == 0){
             $DotRang = $Current_Shift->SecondOTRange > 1 ? $Current_Shift->SecondOTRange - $LateOur : $Current_Shift->SecondOTRange; 
             }

            $T1 = strtotime(str_replace('/', '-', $StartTime));
            $T2 = strtotime(str_replace('/', '-', $OutTimelogOfShift[0]['PunchTime']));
            $timerange = ($T2 - $T1 ) / 3600;
            $DifferStarAndOut = $timerange > 0 ? $timerange : 0;

            $OTHour = $DifferStarAndOut - $Shifthour;
            $ShiftAndNOTHour = $Shifthour + $NotRang;
            $SecondOTHour = $DifferStarAndOut - $ShiftAndNOTHour;
            $ShiftAndDOTHour = $Shifthour + $NotRang + $DotRang;
            $ThirdOTHour = $DifferStarAndOut - $ShiftAndDOTHour;
        }
        $ExtraOTHourStatus = $Current_Shift->ExtraHourStatus;
        $ExtraOTHour = $Current_Shift->ExtraHour;
        $ExtraOTHourRate = $Current_Shift->ExtraHourRate;

        if ($ExtraOTHourStatus == 1) {

            if (!empty($OutTimelogs) and $Current_Shift->EndTime <= $OutTimelogs[0]['PunchTime']) {

                if ($ExtraOTHourRate == "N-OT") {
                    $OTHour = $ExtraOTHour != null ? $ExtraOTHour : 0;
                } elseif ($ExtraOTHourRate == "D-OT") {
                    $SecondOTHour = $ExtraOTHour != null ? $ExtraOTHour : 0;
                }
            }
        }

        $NOTHourwithGrace = $OTHour <= $NOTGraceTime ? 0 : $OTHour;
        $DOTHourwithGrace = $SecondOTHour <= $DOTGraceTime ? 0 : $SecondOTHour;
        $TOTHourwithGrace = $ThirdOTHour <= $TOTGraceTime ? 0 : $ThirdOTHour;

        if ($OTHour > $NOTGraceTime) {
            $Value = $OTRoundupValue;
            $NOTRoundupValue = Yii::app()->PublicFunctionForTimesheetUtil->OTRoundUp($OTHour, $Value);
            $NOTHourwithGrace = $NOTRoundupValue;
        }
        if ($SecondOTHour > $DOTGraceTime) {
            $Value = $OTRoundupValue;
            $DOTRoundupValue = Yii::app()->PublicFunctionForTimesheetUtil->OTRoundUp($SecondOTHour, $Value);
            $DOTHourwithGrace = $DOTRoundupValue;
        }
        if ($ThirdOTHour > $TOTGraceTime) {
            $Value = $OTRoundupValue;
            $TOTRoundupValue = Yii::app()->PublicFunctionForTimesheetUtil->OTRoundUp($ThirdOTHour, $Value);
            $TOTHourwithGrace = $TOTRoundupValue;
        }

        $employeeshift = EmployeeShift::model()->findByAttributes(array('EmployeeId' => $model->Employeeid, 'ShiftId' => $shiftid));
        $Timesheet = new Timesheet;

        $ActualInTime = empty($InTimelogs) ? "0000-00-00 00:00:00" : $InTimelogs[0]['PunchTime'];
        $ActualOutTime = empty($OutTimelogs) ? "0000-00-00 00:00:00" : $OutTimelogs[0]['PunchTime'];

        $Result = Yii::app()->PublicFunctionForTimesheetUtil->ShortLeaveCalculation($diffhours, $Shifthour, $model->Employeeid, $Current_Shift, $StartTime, $OutTimelogOfShift[0]['PunchTime']);
        $WorkedHour = $Result[0];

        //======= In Late deduct ==========//
        //  $LateDeductTime = Yii::app()->PublicFunctionForTimesheetUtil->GetEarlyDeductTime($Current_Shift, $StartTime, $model->Employeeid);
        $LateDeductTime = $Result[1];
        $LateDeductAmount = $ShiftHourlyRate * ($LateDeductTime * $employeesalary->HourlyRate);

        $PreOTHour = 0;
        $PreOTAmount = 0;
        if ($PreOTStatus == 1) {
            $PreOTHour = Yii::app()->PublicFunctionForTimesheetUtil->GetPreOTTime($Current_Shift->StartTime, $intime);
            $PreOTAmount = $PreOTHour * $EmployeeSalaryNOTRate;
        }
        $OutLateDeductTime = $Result[2];
        $OutLateDeductAmount = $ShiftHourlyRate * ($OutLateDeductTime * $EmployeeSalaryHourlyRate);

        //====== Get Short Leve Hour ========//
        $WorkedDays = 1;
        $shiftdate = strtotime($Current_Shift->EndTime);
        $Leavedate = date('Y-m-d', $shiftdate);
        $Short_Leave = Leave::model()->findByAttributes(array('EmoloyeeId' => $model->Employeeid, 'StartDate' => $Leavedate, 'PaidType' => "Pay", 'Status' => 1));
        if (!empty($Short_Leave)) {
            $WorkedHoursWithLeave1 = $Shifthour - $Short_Leave->No_Of_Hour;
            $WorkedHoursWithLeave2 = $WorkedHoursWithLeave1 < 0 ? 0 : $WorkedHoursWithLeave1;
            if ($Shifthour > 0) {
                $WorkedDays = $WorkedHoursWithLeave2 / $Shifthour;
            }
        }

        $Daywage = $Shifthour == 0 ? 0 : $employeesalary->DalySalary * $ShiftHourlyRate;

        if ($Current_Shift->StartTime == $Current_Shift->EndTime) {
            $LateDeductTime = 0;
            $LateDeductAmount = 0;
            $OutLateDeductTime = 0;
            $OutLateDeductAmount = 0;
        }
        $Timesheetforemployee = Timesheet::model()->findByAttributes(array('EmployeeShiftid' => $employeeshift->id));
        if (empty($Timesheetforemployee)) {

            $Timesheet->Intime = $ActualInTime;
            $Timesheet->OuteTime = $ActualOutTime;
            $Timesheet->EmployeeId = $model->Employeeid;
            $Timesheet->date = $Sheduldate;

            if ($Shifthour >= $diffhours) {

                $Timesheet->NOvertimeHours = 0;
                $Timesheet->DOverTimeHour = 0;
                $Timesheet->Dovertimesalary = 0;
                $Timesheet->NOvertimeSalary = 0;
                $Timesheet->WorkedHour = $WorkedHour;
                $Timesheet->TotalOTHour = 0;
                $Timesheet->TOverTimeHour = 0;
                $Timesheet->Tovertimesalary = 0;
            } else {

                $Timesheet->WorkedHour = $WorkedHour;
                $Timesheet->NOvertimeHours = $OTHour <= $NotRang ? $NOTHourwithGrace : $NotRang;
                $Timesheet->NOvertimeSalary = $Timesheet->NOvertimeHours * $EmployeeSalaryNOTRate;

                if ($diffhours > $ShiftAndNOTHour) {
                    $Timesheet->DOverTimeHour = $SecondOTHour <= $DotRang ? $DOTHourwithGrace : $DotRang;
                    $Timesheet->Dovertimesalary = $Timesheet->DOverTimeHour * $EmployeeSalaryDOTRate;

                    if ($diffhours > $ShiftAndDOTHour) {

                        $CustomizeOTHour = $ThirdOTHour <= $TOTRang ? $TOTHourwithGrace : $TOTRang;
                        $CustomizeOTAmount = $ShiftTOTRate * ( $CustomizeOTHour * $employeesalary->HourlyRate);
                        $Timesheet->TOverTimeHour = 0;
                        $Timesheet->Tovertimesalary = 0;

                        if ($ShiftTOTRate == 1.5) {
                            $Timesheet->NOvertimeHours = $Timesheet->NOvertimeHours + $CustomizeOTHour;
                            $Timesheet->NOvertimeSalary = $Timesheet->NOvertimeSalary + $CustomizeOTAmount;
                        } elseif ($ShiftTOTRate == 2) {
                            $Timesheet->DOverTimeHour = $Timesheet->DOverTimeHour + $CustomizeOTHour;
                            $Timesheet->Dovertimesalary = $Timesheet->Dovertimesalary + $CustomizeOTAmount;
                        } else {
                            $Timesheet->TOverTimeHour = $CustomizeOTHour;
                            $Timesheet->Tovertimesalary = $CustomizeOTAmount;
                        }
                    } else {
                        $Timesheet->TOverTimeHour = 0;
                        $Timesheet->Tovertimesalary = 0;
                    }
                } else {
                    $Timesheet->DOverTimeHour = 0;
                    $Timesheet->Dovertimesalary = 0;
                    $Timesheet->TOverTimeHour = 0;
                    $Timesheet->Tovertimesalary = 0;
                }
            }
            $Timesheet->SallaryRate = $Daywage;
            $Timesheet->WorkedHour = $WorkedHour;
            $Timesheet->EmployeeShiftid = $employeeshift->id;
            //   $employeedesignation = EmployeeDesignation::model()->findByAttributes(array('EmployeeId' => $model->Employeeid));
            //  $payroll = CJSON::encode($employee->designationid);
            $Timesheet->DesignaId = $employee->designationid;
            $Timesheet->TotalOTHour = $Timesheet->NOvertimeHours + $Timesheet->DOverTimeHour;
            $Timesheet->DayName = "WEEKDAY";
            $Timesheet->PaymentMethod = "MONTHLY";
            $Timesheet->LatedeductTime = $LateDeductTime;
            $Timesheet->LatedeductAmount = $LateDeductAmount;
            $Timesheet->SiteId = $employee->siteid;
            $Timesheet->OutLateDeductTime = $OutLateDeductTime;
            $Timesheet->OutLateDeductAmount = $OutLateDeductAmount;
            $Timesheet->WorkedDay = $WorkedDays;
            $Timesheet->Category = $employee->categoryid;
            $Timesheet->account_id = $employee->Accountid;
            $Timesheet->department_id = $employee->departmentid;
            $Timesheet->MP_suplier_id = $employee->supplierid;
            $Timesheet->full_Basic_Salary = 0;
            $Timesheet->Sub_Basic_salary = 0;
            $Timesheet->BRA1 = 0;
            $Timesheet->BRA2 = 0;
            $Timesheet->BRA3 = 0;
            $Timesheet->Actual_WorkHourInShift = $ActualWorkedHourInShift;
            $Timesheet->PreOTHour = empty($OutTimelogs) ? 0 : $PreOTHour;
            $Timesheet->PreOTAmount = empty($OutTimelogs) ? 0 : $PreOTAmount;

            if (empty($InTimelogs)) {
                $Timesheet->WorkedHour = 0;
                $Timesheet->NOvertimeHours = 0;
                $Timesheet->DOverTimeHour = 0;
                $Timesheet->Dovertimesalary = 0;
                $Timesheet->NOvertimeSalary = 0;
                $Timesheet->TotalOTHour = 0;
                $Timesheet->TOverTimeHour = 0;
                $Timesheet->Tovertimesalary = 0;
                $Timesheet->LatedeductTime = 0;
                $Timesheet->LatedeductAmount = 0;
                $Timesheet->OutLateDeductTime = 0;
                $Timesheet->OutLateDeductAmount = 0;
                $Timesheet->Actual_WorkHourInShift = 0;
                $Timesheet->PreOTHour = 0;
                $Timesheet->PreOTAmount = 0;
            }
            $Timesheet->ActualNOT = $Timesheet->NOvertimeHours;
            $Timesheet->ActualDOT = $Timesheet->DOverTimeHour;
            $Timesheet->ActualTOT = $Timesheet->TOverTimeHour;
            $Timesheet->save();
        } else {

            if ($Shifthour >= $diffhours) {
                Timesheet::model()->updateAll(array('WorkedHour' => $WorkedHour, 'SallaryRate' => $Daywage, 'Actual_WorkHourInShift' => $ActualWorkedHourInShift, 'WorkedDay' => $WorkedDays, 'LatedeductTime' => $LateDeductTime, 'LatedeductAmount' => $LateDeductAmount, 'OutLateDeductTime' => $OutLateDeductTime, 'OutLateDeductAmount' => $OutLateDeductAmount, 'PreOTHour' => $PreOTHour, 'PreOTAmount' => $PreOTAmount, 'Intime' => $ActualInTime, 'OuteTime' => $ActualOutTime), 'id ="' . $Timesheetforemployee->id . '"');
            } else {

                $NOTHour = $OTHour >= $NotRang ? $NotRang : $NOTHourwithGrace;
                $NOTAmount = $NOTHour * $EmployeeSalaryNOTRate;
                $TotalOTHour = $NOTHour + $PreOTHour;

                if ($diffhours > $ShiftAndNOTHour) {
                    $DOTHour = $SecondOTHour <= $DotRang ? $DOTHourwithGrace : $DotRang;
                    $DOTSallary = $DOTHour * $EmployeeSalaryDOTRate;
                    $TotalOTHour = $NOTHour + $DOTHour + $PreOTHour;

                    if ($diffhours > $ShiftAndDOTHour) {

                        $CustomizeOTHour = $ThirdOTHour <= $TOTRang ? $TOTHourwithGrace : $TOTRang;
                        $CustomizeOTSallary = $ShiftTOTRate * ($CustomizeOTHour * $employeesalary->HourlyRate);
                        $TotalOTHour = $NOTHour + $DOTHour + $CustomizeOTHour + $PreOTHour;
                        $TOTHour = 0;
                        $TOTSallary = 0;

                        if ($ShiftTOTRate == 1.5) {
                            $NOTHour = $NOTHour + $CustomizeOTHour;
                            $NOTAmount = $NOTAmount + $CustomizeOTSallary;
                        } elseif ($ShiftTOTRate == 2) {
                            $DOTHour = $DOTHour + $CustomizeOTHour;
                            $DOTSallary = $DOTSallary + $CustomizeOTSallary;
                        } else {
                            $TOTHour = $CustomizeOTHour;
                            $TOTSallary = $CustomizeOTSallary;
                        }
//                         print_r($NOTHour);
//                        die;
                        Timesheet::model()->updateAll(array('WorkedHour' => $WorkedHour, 'SallaryRate' => $Daywage, 'Actual_WorkHourInShift' => $ActualWorkedHourInShift, 'WorkedDay' => $WorkedDays, 'TotalOTHour' => $TotalOTHour, 'LatedeductTime' => $LateDeductTime, 'LatedeductAmount' => $LateDeductAmount, 'OutLateDeductTime' => $OutLateDeductTime, 'OutLateDeductAmount' => $OutLateDeductAmount, 'PreOTHour' => $PreOTHour, 'PreOTAmount' => $PreOTAmount, 'Intime' => $ActualInTime, 'OuteTime' => $ActualOutTime, 'NOvertimeHours' => $NOTHour, 'NOvertimeSalary' => $NOTAmount, 'DOverTimeHour' => $DOTHour, 'Dovertimesalary' => $DOTSallary, 'TOverTimeHour' => $TOTHour, 'Tovertimesalary' => $TOTSallary,'ActualNOT' => $NOTHour,'ActualDOT' => $DOTHour,'ActualTOT' => $TOTHour), 'id ="' . $Timesheetforemployee->id . '"');
                    } else {
                        Timesheet::model()->updateAll(array('WorkedHour' => $WorkedHour, 'SallaryRate' => $Daywage, 'Actual_WorkHourInShift' => $ActualWorkedHourInShift, 'WorkedDay' => $WorkedDays, 'TotalOTHour' => $TotalOTHour, 'OuteTime' => $ActualOutTime, 'LatedeductTime' => $LateDeductTime, 'LatedeductAmount' => $LateDeductAmount, 'OutLateDeductTime' => $OutLateDeductTime, 'OutLateDeductAmount' => $OutLateDeductAmount, 'PreOTHour' => $PreOTHour, 'PreOTAmount' => $PreOTAmount, 'Intime' => $ActualInTime, 'NOvertimeHours' => $NOTHour, 'NOvertimeSalary' => $NOTAmount, 'DOverTimeHour' => $DOTHour, 'Dovertimesalary' => $DOTSallary, 'TOverTimeHour' => 0, 'Tovertimesalary' => 0,'ActualNOT' => $NOTHour,'ActualDOT' => $DOTHour,'ActualTOT' => 0), 'id ="' . $Timesheetforemployee->id . '"');
                    }
                } else {

                    Timesheet::model()->updateAll(array('WorkedHour' => $WorkedHour, 'SallaryRate' => $Daywage, 'Actual_WorkHourInShift' => $ActualWorkedHourInShift, 'WorkedDay' => $WorkedDays, 'TotalOTHour' => $TotalOTHour, 'LatedeductTime' => $LateDeductTime, 'LatedeductAmount' => $LateDeductAmount, 'OutLateDeductTime' => $OutLateDeductTime, 'OutLateDeductAmount' => $OutLateDeductAmount, 'PreOTHour' => $PreOTHour, 'PreOTAmount' => $PreOTAmount, 'Intime' => $ActualInTime, 'OuteTime' => $ActualOutTime, 'NOvertimeHours' => $NOTHour, 'NOvertimeSalary' => $NOTAmount, 'DOverTimeHour' => 0, 'Dovertimesalary' => 0, 'TOverTimeHour' => 0, 'Tovertimesalary' => 0,'ActualNOT' => $NOTHour,'ActualDOT' => 0,'ActualTOT' => 0), 'id ="' . $Timesheetforemployee->id . '"');
                }
            }
            if (empty($InTimelogs)) {
                Timesheet::model()->updateAll(array('WorkedHour' => 0, 'Actual_WorkHourInShift' => 0, 'TotalOTHour' => 0, 'SallaryRate' => 0, 'LatedeductTime' => 0, 'LatedeductAmount' => 0, 'OutLateDeductTime' => 0, 'OutLateDeductAmount' => 0, 'PreOTHour' => 0, 'PreOTAmount' => 0, 'Intime' => "0000-00-00 00:00:00", 'OuteTime' => $OutTimelogOfShift[0]['PunchTime'], 'NOvertimeHours' => 0, 'NOvertimeSalary' => 0, 'DOverTimeHour' => 0, 'Dovertimesalary' => 0, 'TOverTimeHour' => 0, 'Tovertimesalary' => 0,'ActualNOT' => 0,'ActualDOT' => 0,'ActualTOT' => 0), 'id ="' . $Timesheetforemployee->id . '"');
            }
            if (empty($OutTimelogs)) {
                Timesheet::model()->updateAll(array('WorkedHour' => 0, 'Actual_WorkHourInShift' => 0, 'TotalOTHour' => 0, 'LatedeductTime' => $LateDeductTime, 'LatedeductAmount' => $LateDeductAmount, 'OutLateDeductTime' => 8, 'OutLateDeductAmount' => $Daywage, 'PreOTHour' => 0, 'PreOTAmount' => 0, 'Intime' => $ActualInTime, 'OuteTime' => "0000-00-00 00:00:00", 'NOvertimeHours' => 0, 'NOvertimeSalary' => 0, 'DOverTimeHour' => 0, 'Dovertimesalary' => 0, 'TOverTimeHour' => 0, 'Tovertimesalary' => 0,'ActualNOT' => 0,'ActualDOT' => 0,'ActualTOT' => 0), 'id ="' . $Timesheetforemployee->id . '"');
            }
        }
    }

    public function TimesheetCreateByshift($EmployeeShift, $Timelogs) {

        $InTimelogOfShift = empty($Timelogs[0]) ? $Timelogs[1] : $Timelogs[0];
        $OutTimelogOfShift = empty($Timelogs[1]) ? $Timelogs[0] : $Timelogs[1];
        $Timesheet = new Timesheet;

        $shiftid = $EmployeeShift->ShiftId;
        $shift = Shift::model()->findByAttributes(array('id' => $shiftid));
        $ShiftStartTime = date('H:i:s', strtotime($shift->StartTime));
        $intime = date('H:i:s', strtotime($InTimelogOfShift[0]['PunchTime']));

        $ShiStartdate = strtotime($shift->StartTime);
        $SheduleDate = date('Y-m-d', $ShiStartdate);

        $employee = Employee::model()->findByAttributes(array('id' => $EmployeeShift->EmployeeId));
        $employeesalary = Employeesalary::model()->findByAttributes(array('employeeid' => $EmployeeShift->EmployeeId, 'site_id' => $employee->siteid, 'Status' => 1));
        if (empty($employeesalary)) {
            $employeesalary = new Employeesalary;
            $employeesalary->monthsalary = 0;
            $employeesalary->DalySalary = 0;
            $employeesalary->HourlyRate = 0;
            $employeesalary->OTRate = 0;
            $employeesalary->DoubleOTRate = 0;
            $employeesalary->BasicSalary = 0;
            $employeesalary->BRA1 = 0;
            $employeesalary->BRA2 = 0;
            $employeesalary->BRA3 = 0;
        }
        $DayWithName = Yii::app()->PublicFunctionForTimesheetUtil->GetDayForTimsheet($SheduleDate, $employee->siteid);

        $StartTime = null;

        if ($ShiftStartTime < $intime) {
            $StartTime = Yii::app()->PublicFunctionForTimesheetUtil->ShiftLateDeduction($shift, $InTimelogOfShift[0]['PunchTime']);
        } else {
            $StartTime = $shift->StartTime;
        }

        $ts1 = strtotime(str_replace('/', '-', $shift->StartTime));
        $ts2 = strtotime(str_replace('/', '-', $OutTimelogOfShift[0]['PunchTime']));
        $timerange = ($ts2 - $ts1 ) / 3600;
        $diffhours = $timerange > 0 ? $timerange : 0;

        $ShiftStime = strtotime(str_replace('/', '-', $shift->StartTime));
        $ShiftEtime = strtotime(str_replace('/', '-', $shift->EndTime));
        $Shifthour = abs($ShiftStime - $ShiftEtime) / 3600;

        $STime = strtotime(str_replace('/', '-', $InTimelogOfShift[0]['PunchTime']));
        $ETime = strtotime(str_replace('/', '-', $OutTimelogOfShift[0]['PunchTime']));
        $AWorkedhour = abs($ETime - $STime) / 3600;
        $ActualWorkedHourInShift = $AWorkedhour > 0 ? $timerange : 0;

        $HolidayR = $shift->salaryRate - 1;
        $HolidayRate = $HolidayR > 0 ? $HolidayR : 0;
        $ShiftHourlyRate = $DayWithName == "HOLIDAY" ? $HolidayRate : $shift->salaryRate;

        $ShiftNOTRate = $shift->FirstOTRate;
        $ShiftDOTRate = $shift->SecondOTRate;
        $NotRang = $shift->FirstOTTimeRang;
        $DotRang = $shift->SecondOTRange;
        $NOTGraceTime = $shift->NOTGraceTime;
        $DOTGraceTime = $shift->DOTGraceTime;
        $OTRoundupValue = $shift->OTRoundup;
        $ShiftTOTRate = $shift->ThirdOTRate;
        $TOTRang = $shift->ThirdOTTimeRang;
        $TOTGraceTime = $shift->TOTGraceTime;
        $PreOTStatus = $shift->PreOTStatus;

        $EmployeeSalaryHourlyRate = $employeesalary->HourlyRate;
        $EmployeeSalaryNOTRate = $employeesalary->OTRate;
        $EmployeeSalaryDOTRate = $employeesalary->DoubleOTRate;

        $Result = Yii::app()->PublicFunctionForTimesheetUtil->ShortLeaveCalculation($diffhours, $Shifthour, $EmployeeShift->EmployeeId, $shift, $StartTime, $OutTimelogOfShift[0]['PunchTime']);
        $workedhour = $Result[0];

        //======= In Late deduct ==========//
        //$LateDeductTime = Yii::app()->PublicFunctionForTimesheetUtil->GetEarlyDeductTime($shift, $StartTime, $EmployeeShift->EmployeeId);
        $LateDeductTime = $Result[1];
        $LateDeductAmount = $ShiftHourlyRate * ($LateDeductTime * $EmployeeSalaryHourlyRate);

        //======= Out Late deduct ==========//
        $OutLateDeductTime = $Result[2];
        $OutLateDeductAmount = $ShiftHourlyRate * ($OutLateDeductTime * $EmployeeSalaryHourlyRate);

        $OTHour = $diffhours - $Shifthour;
        $ShiftAndNOTHour = $Shifthour + $NotRang;
        $SecondOTHour = $diffhours - $ShiftAndNOTHour;
        $ShiftAndDOTHour = $Shifthour + $NotRang + $DotRang;
        $ThirdOTHour = $diffhours - $ShiftAndDOTHour;

        //new for Zeroshift
        $ts5 = strtotime(str_replace('/', '-', $shift->StartTime));
        $ts6 = strtotime(str_replace('/', '-', $InTimelogOfShift[0]['PunchTime']));
        $DeductTime = ($ts6 - $ts5 ) / 3600;
        $LateOur = $DeductTime > 0 ? $DeductTime : 0;

        //----new----//
        if ($shift->StartTime == $shift->EndTime) {

            $NotRang = $shift->FirstOTTimeRang > 1 ? $shift->FirstOTTimeRang - $LateOur : $shift->FirstOTTimeRang;

			if($shift->FirstOTTimeRang == 0){
            $DotRang = $shift->SecondOTRange > 1 ? $shift->SecondOTRange - $LateOur : $shift->SecondOTRange; 

            }

            $T1 = strtotime(str_replace('/', '-', $StartTime));
            $T2 = strtotime(str_replace('/', '-', $OutTimelogOfShift[0]['PunchTime']));
            $timerange = ($T2 - $T1 ) / 3600;
            $DifferStarAndOut = $timerange > 0 ? $timerange : 0;

            $OTHour = $DifferStarAndOut - $Shifthour;
            $ShiftAndNOTHour = $Shifthour + $NotRang;
            $SecondOTHour = $DifferStarAndOut - $ShiftAndNOTHour;
            $ShiftAndDOTHour = $Shifthour + $NotRang + $DotRang;
            $ThirdOTHour = $DifferStarAndOut - $ShiftAndDOTHour;

            $LateDeductTime = 0;
            $LateDeductAmount = 0;
            $OutLateDeductTime = 0;
            $OutLateDeductAmount = 0;
        }
        $ExtraOTHourStatus = $shift->ExtraHourStatus;
        $ExtraOTHour = $shift->ExtraHour;
        $ExtraOTHourRate = $shift->ExtraHourRate;

        if ($ExtraOTHourStatus == 1) {

            if (!empty($Timelogs[1]) and $shift->EndTime <= $Timelogs[1][0]['PunchTime']) {

                if ($ExtraOTHourRate == "N-OT") {
                    $OTHour = $ExtraOTHour != null ? $ExtraOTHour : 0;
                } elseif ($ExtraOTHourRate == "D-OT") {
                    $SecondOTHour = $ExtraOTHour != null ? $ExtraOTHour : 0;
                }
            }
        }

        $NOTHourwithGrace = $OTHour <= $NOTGraceTime ? 0 : $OTHour;
        $DOTHourwithGrace = $SecondOTHour <= $DOTGraceTime ? 0 : $SecondOTHour;
        $TOTHourwithGrace = $ThirdOTHour <= $TOTGraceTime ? 0 : $ThirdOTHour;


        if ($OTHour > $NOTGraceTime) {
            $Value = $OTRoundupValue;
            $NOTRoundupValue = Yii::app()->PublicFunctionForTimesheetUtil->OTRoundUp($OTHour, $Value);
            $NOTHourwithGrace = $NOTRoundupValue;
        }
        if ($SecondOTHour > $DOTGraceTime) {
            $Value = $OTRoundupValue;
            $DOTRoundupValue = Yii::app()->PublicFunctionForTimesheetUtil->OTRoundUp($SecondOTHour, $Value);
            $DOTHourwithGrace = $DOTRoundupValue;
        }
        if ($ThirdOTHour > $TOTGraceTime) {
            $Value = $OTRoundupValue;
            $TOTRoundupValue = Yii::app()->PublicFunctionForTimesheetUtil->OTRoundUp($ThirdOTHour, $Value);
            $TOTHourwithGrace = $TOTRoundupValue;
        }

        $ActualInTime = empty($Timelogs[0]) ? "0000-00-00 00:00:00" : $Timelogs[0][0]['PunchTime'];
        $ActualOutTime = empty($Timelogs[1]) ? "0000-00-00 00:00:00" : $Timelogs[1][0]['PunchTime'];

        //====== Get Short Leve Hour ========//
        $WorkedDays = 1;
        $shiftdate = strtotime($shift->EndTime);
        $Leavedate = date('Y-m-d', $shiftdate);
        $Short_Leave = Leave::model()->findByAttributes(array('EmoloyeeId' => $EmployeeShift->EmployeeId, 'StartDate' => $Leavedate, 'PaidType' => "Pay", 'Status' => 1));
        if (!empty($Short_Leave)) {
            $WorkedHoursWithLeave1 = $Shifthour - $Short_Leave->No_Of_Hour;
            $WorkedHoursWithLeave2 = $WorkedHoursWithLeave1 < 0 ? 0 : $WorkedHoursWithLeave1;
            if ($Shifthour > 0) {
                $WorkedDays = $WorkedHoursWithLeave2 / $Shifthour;
            }
        }
        //======= pre OT ==========//
        $PreOTHour = 0;
        $PreOTAmount = 0;
        if ($PreOTStatus == 1) {
            $PreOTHour = Yii::app()->PublicFunctionForTimesheetUtil->GetPreOTTime($shift->StartTime, $InTimelogOfShift[0]['PunchTime']);
            $PreOTAmount = $PreOTHour * $EmployeeSalaryNOTRate;
        }

        $daysalarry = $Shifthour == 0 ? 0 : $employeesalary->DalySalary * $ShiftHourlyRate;

        $Timesheet->EmployeeId = $EmployeeShift->EmployeeId;
        $Timesheet->date = $SheduleDate;
        $Timesheet->Intime = $ActualInTime;
        $Timesheet->OuteTime = $ActualOutTime;

        if ($Shifthour >= $diffhours) {
            $Timesheet->NOvertimeHours = 0;
            $Timesheet->DOverTimeHour = 0;
            $Timesheet->Dovertimesalary = 0;
            $Timesheet->NOvertimeSalary = 0;
            $Timesheet->TotalOTHour = 0;
            $Timesheet->TOverTimeHour = 0;
            $Timesheet->Tovertimesalary = 0;
        } else {
            $OTHour = $diffhours - $Shifthour;

            $Timesheet->NOvertimeHours = $OTHour <= $NotRang ? $NOTHourwithGrace : $NotRang;
            $Timesheet->NOvertimeSalary = $Timesheet->NOvertimeHours * $EmployeeSalaryNOTRate;

            if ($diffhours > $ShiftAndNOTHour) {
                $Timesheet->DOverTimeHour = $SecondOTHour <= $DotRang ? $DOTHourwithGrace : $DotRang;
                $Timesheet->Dovertimesalary = $Timesheet->DOverTimeHour * $EmployeeSalaryDOTRate;

                if ($diffhours > $ShiftAndDOTHour) {

                    $CustomizeOTHour = $ThirdOTHour <= $TOTRang ? $TOTHourwithGrace : $TOTRang;
                    $CustomizeOTAmount = $ShiftTOTRate * ( $CustomizeOTHour * $employeesalary->HourlyRate);
                    $Timesheet->TOverTimeHour = 0;
                    $Timesheet->Tovertimesalary = 0;

                    if ($ShiftTOTRate == 1.5) {
                        $Timesheet->NOvertimeHours = $Timesheet->NOvertimeHours + $CustomizeOTHour;
                        $Timesheet->NOvertimeSalary = $Timesheet->NOvertimeSalary + $CustomizeOTAmount;
                    } elseif ($ShiftTOTRate == 2) {
                        $Timesheet->DOverTimeHour = $Timesheet->DOverTimeHour + $CustomizeOTHour;
                        $Timesheet->Dovertimesalary = $Timesheet->Dovertimesalary + $CustomizeOTAmount;
                    } else {
                        $Timesheet->TOverTimeHour = $CustomizeOTHour;
                        $Timesheet->Tovertimesalary = $CustomizeOTAmount;
                    }
                } else {
                    $Timesheet->TOverTimeHour = 0;
                    $Timesheet->Tovertimesalary = 0;
                }
            } else {
                $Timesheet->DOverTimeHour = 0;
                $Timesheet->Dovertimesalary = 0;
                $Timesheet->TOverTimeHour = 0;
                $Timesheet->Tovertimesalary = 0;
            }
        }

        $Timesheet->SallaryRate = $daysalarry;
        $Timesheet->EmployeeShiftid = $EmployeeShift->id;
        // $employeedesignation = EmployeeDesignation::model()->findByAttributes(array('EmployeeId' => $EmployeeShift->EmployeeId));
        $Timesheet->DesignaId = $employee->designationid;
        $Timesheet->WorkedHour = $workedhour;
        $Timesheet->PaymentMethod = "MONTHLY";
        $Timesheet->DayName = $DayWithName;
        $Timesheet->LatedeductTime = $LateDeductTime;
        $Timesheet->LatedeductAmount = $LateDeductAmount;
        $Timesheet->SiteId = $employee->siteid;
        $Timesheet->OutLateDeductTime = $OutLateDeductTime;
        $Timesheet->OutLateDeductAmount = $OutLateDeductAmount;
        $Timesheet->WorkedDay = $WorkedDays;
        $Timesheet->Category = $employee->categoryid;
        $Timesheet->account_id = $employee->Accountid;
        $Timesheet->department_id = $employee->departmentid;
        $Timesheet->MP_suplier_id = $employee->supplierid;
        $Timesheet->full_Basic_Salary = 0;
        $Timesheet->Sub_Basic_salary = 0;
        $Timesheet->BRA1 = 0;
        $Timesheet->BRA2 = 0;
        $Timesheet->BRA3 = 0;
        $Timesheet->Actual_WorkHourInShift = $ActualWorkedHourInShift;
        $Timesheet->PreOTHour = empty($Timelogs[1]) ? 0 : $PreOTHour;
        $Timesheet->PreOTAmount = empty($Timelogs[1]) ? 0 : $PreOTAmount;
        $Timesheet->TotalOTHour = $Timesheet->NOvertimeHours + $Timesheet->DOverTimeHour + $Timesheet->TOverTimeHour + $Timesheet->PreOTHour;

        if (empty($Timelogs[0])) {
            $Timesheet->WorkedHour = 0;
            $Timesheet->NOvertimeHours = 0;
            $Timesheet->DOverTimeHour = 0;
            $Timesheet->Dovertimesalary = 0;
            $Timesheet->NOvertimeSalary = 0;
            $Timesheet->TotalOTHour = 0;
            $Timesheet->TOverTimeHour = 0;
            $Timesheet->Tovertimesalary = 0;
            $Timesheet->LatedeductTime = 0;
            $Timesheet->LatedeductAmount = 0;
            $Timesheet->OutLateDeductTime = 0;
            $Timesheet->OutLateDeductAmount = 0;
            $Timesheet->Actual_WorkHourInShift = 0;
            $Timesheet->PreOTHour = 0;
            $Timesheet->PreOTAmount = 0;
        }
        $Timesheet->ActualNOT = $Timesheet->NOvertimeHours;
        $Timesheet->ActualDOT = $Timesheet->DOverTimeHour;
        $Timesheet->ActualTOT = $Timesheet->TOverTimeHour;
        $Timesheet->save();
    }

    public function TimesheetRecalculate($TimeSheetid) {

        $Current_Timesheet = Timesheet::model()->findByAttributes(array('id' => $TimeSheetid));
        if (!empty($Current_Timesheet)) {

            $OutTime = $Current_Timesheet->OuteTime;
            $InTime = $Current_Timesheet->Intime;
            $emshiftid = $Current_Timesheet->EmployeeShiftid;
            $EmployeeId = $Current_Timesheet->EmployeeId;
            $TimsheetId = $Current_Timesheet->id;
            $SiteId = $Current_Timesheet->SiteId;

            $OldNOTHour = $Current_Timesheet->NOvertimeHours;
            $OldDOTHour = $Current_Timesheet->DOverTimeHour;
            $OldTOTHour = $Current_Timesheet->TOverTimeHour;

            // $DayWithName = $Current_Timesheet->DayName;

            $employeesalary = Employeesalary::model()->findByAttributes(array('employeeid' => $EmployeeId, 'site_id' => $SiteId, 'Status' => 1));
            if (empty($employeesalary)) {
                $employeesalary = new Employeesalary;
                $employeesalary->monthsalary = 0;
                $employeesalary->DalySalary = 0;
                $employeesalary->HourlyRate = 0;
                $employeesalary->OTRate = 0;
                $employeesalary->DoubleOTRate = 0;
                $employeesalary->BasicSalary = 0;
                $employeesalary->BRA1 = 0;
                $employeesalary->BRA2 = 0;
                $employeesalary->BRA3 = 0;
            }
            $employeeshift = EmployeeShift::model()->findByAttributes(array('id' => $emshiftid));

            $shiftid = $employeeshift->ShiftId;

            $shift = Shift::model()->findByAttributes(array('id' => $shiftid));

            $ShiftStartTime = date('H:i:s', strtotime($shift->StartTime));
            $intime = date('H:i:s', strtotime($InTime));

            $ShiStartdate = strtotime($shift->StartTime);
            $Sheduldate = date('Y-m-d', $ShiStartdate);
            $DayWithName = Yii::app()->PublicFunctionForTimesheetUtil->GetDayForTimsheet($Sheduldate, $Current_Timesheet->SiteId);

            $StartTime = null;

            if ($ShiftStartTime < $intime) {

                $StartTime = Yii::app()->PublicFunctionForTimesheetUtil->ShiftLateDeduction($shift, $InTime);
            } else {
                $StartTime = $shift->StartTime;
            }

            $ts1 = strtotime(str_replace('/', '-', $shift->StartTime));
            $ts2 = strtotime(str_replace('/', '-', $OutTime));
            $timerange = ($ts2 - $ts1 ) / 3600;
            $diffhours = $timerange > 0 ? $timerange : 0;

            $ShiftStime = strtotime(str_replace('/', '-', $shift->StartTime));
            $ShiftEtime = strtotime(str_replace('/', '-', $shift->EndTime));
            $Shifthour = abs($ShiftStime - $ShiftEtime) / 3600;

            $STime = strtotime(str_replace('/', '-', $Current_Timesheet->Intime));
            $ETime = strtotime(str_replace('/', '-', $Current_Timesheet->OuteTime));
            $AWorkedhour = abs($ETime - $STime) / 3600;
            $ActualWorkedHourInShift = $AWorkedhour > 0 ? $timerange : 0;

            $HolidayR = $shift->salaryRate - 1;
            $HolidayRate = $HolidayR > 0 ? $HolidayR : 0;
            $ShiftHourlyRate = $DayWithName == "HOLIDAY" ? $HolidayRate : $shift->salaryRate;

            $ShiftNOTRate = $shift->FirstOTRate;
            $ShiftDOTRate = $shift->SecondOTRate;
            $NotRang = $shift->FirstOTTimeRang;
            $DotRang = $shift->SecondOTRange;
            $NOTGraceTime = $shift->NOTGraceTime;
            $DOTGraceTime = $shift->DOTGraceTime;
            $OTRoundupValue = $shift->OTRoundup;
            $ShiftTOTRate = $shift->ThirdOTRate;
            $TOTRang = $shift->ThirdOTTimeRang;
            $TOTGraceTime = $shift->TOTGraceTime;
            $PreOTStatus = $shift->PreOTStatus;

            $EmployeeSalaryHourlyRate = $employeesalary->HourlyRate;
            $EmployeeSalaryNOTRate = $employeesalary->OTRate;
            $EmployeeSalaryDOTRate = $employeesalary->DoubleOTRate;

            $DayWge = $Shifthour == 0 ? 0 : $employeesalary->DalySalary * $ShiftHourlyRate;

            $Result = Yii::app()->PublicFunctionForTimesheetUtil->ShortLeaveCalculation($diffhours, $Shifthour, $EmployeeId, $shift, $StartTime, $OutTime);
            $workedhour = $Result[0];
            //======= In Late deduct ==========//
            //$LateDeductTime = Yii::app()->PublicFunctionForTimesheetUtil->GetEarlyDeductTime($shift, $StartTime, $EmployeeId);
            $LateDeductTime = $Result[1];
            $LateDeductAmount = $ShiftHourlyRate * ($LateDeductTime * $EmployeeSalaryHourlyRate);

            //======= Out Late deduct ==========//
            $OutLateDeductTime = $Result[2];
            $OutLateDeductAmount = $ShiftHourlyRate * ($OutLateDeductTime * $EmployeeSalaryHourlyRate);

            if ($InTime == '0000-00-00 00:00:00' || $OutTime == '0000-00-00 00:00:00') {

                $OutLateTime = $InTime == '0000-00-00 00:00:00' ? 0 : 8;
                $OutLateDeduct = $InTime == '0000-00-00 00:00:00' ? 0 : $DayWge;
                $InLateTime = $InTime == '0000-00-00 00:00:00' ? 0 : $LateDeductTime;
                $InLateDeduct = $InTime == '0000-00-00 00:00:00' ? 0 : $LateDeductAmount;

                Timesheet::model()->updateAll(array('WorkedHour' => 0, 'Actual_WorkHourInShift' => 0, 'TotalOTHour' => 0, 'SallaryRate' => $DayWge, 'full_Basic_Salary' => $employeesalary->DalySalary, 'Sub_Basic_salary' => $employeesalary->BasicSalary, 'BRA1' => $employeesalary->BRA1, 'BRA2' => $employeesalary->BRA2, 'BRA3' => $employeesalary->BRA3, 'NOvertimeHours' => 0, 'NOvertimeSalary' => 0, 'DOverTimeHour' => 0, 'Dovertimesalary' => 0, 'LatedeductTime' => $InLateTime, 'LatedeductAmount' => $InLateDeduct, 'OutLateDeductTime' => $OutLateTime, 'OutLateDeductAmount' => $OutLateDeduct, 'TOverTimeHour' => 0, 'Tovertimesalary' => 0, 'PreOTHour' => 0, 'PreOTAmount' => 0, 'DayName' => $DayWithName), 'id ="' . $TimsheetId . '"');
            } else {

                $OTHour = $diffhours - $Shifthour;
                $ShiftAndNOTHour = $Shifthour + $NotRang;
                $SecondOTHour = $diffhours - $ShiftAndNOTHour;
                $ShiftAndDOTHour = $Shifthour + $NotRang + $DotRang;
                $ThirdOTHour = $diffhours - $ShiftAndDOTHour;

                $ts5 = strtotime(str_replace('/', '-', $shift->StartTime));
                $ts6 = strtotime(str_replace('/', '-', $InTime));
                $DeductTime = ($ts6 - $ts5 ) / 3600;
                $LateOur = $DeductTime > 0 ? $DeductTime : 0;
                //----new----//
                if ($shift->StartTime == $shift->EndTime) {

                    $NotRang = $shift->FirstOTTimeRang > 1 ? $shift->FirstOTTimeRang - $LateOur : $shift->FirstOTTimeRang;

					if($shift->FirstOTTimeRang == 0){
                    $DotRang = $shift->SecondOTRange > 1 ? $shift->SecondOTRange - $LateOur : $shift->SecondOTRange; 

                    }

                    $T1 = strtotime(str_replace('/', '-', $StartTime));
                    $T2 = strtotime(str_replace('/', '-', $OutTime));
                    $timerange = ($T2 - $T1 ) / 3600;
                    $DifferStarAndOut = $timerange > 0 ? $timerange : 0;

                    $OTHour = $DifferStarAndOut - $Shifthour;
                    $ShiftAndNOTHour = $Shifthour + $NotRang;
                    $SecondOTHour = $DifferStarAndOut - $ShiftAndNOTHour;
                    $ShiftAndDOTHour = $Shifthour + $NotRang + $DotRang;
                    $ThirdOTHour = $DifferStarAndOut - $ShiftAndDOTHour;

                    $LateDeductTime = 0;
                    $LateDeductAmount = 0;
                    $OutLateDeductTime = 0;
                    $OutLateDeductAmount = 0;
                }
                $ExtraOTHourStatus = $shift->ExtraHourStatus;
                $ExtraOTHour = $shift->ExtraHour;
                $ExtraOTHourRate = $shift->ExtraHourRate;

                if ($ExtraOTHourStatus == 1) {

                    if ($OutTime != '0000-00-00 00:00:00' and $shift->EndTime <= $OutTime) {

                        if ($ExtraOTHourRate == "N-OT") {
                            $OTHour = $ExtraOTHour != null ? $ExtraOTHour : 0;
                        } elseif ($ExtraOTHourRate == "D-OT") {
                            $SecondOTHour = $ExtraOTHour != null ? $ExtraOTHour : 0;
                        }
                    }
                }
                $NOTHourwithGrace = $OTHour <= $NOTGraceTime ? 0 : $OTHour;
                $DOTHourwithGrace = $SecondOTHour <= $DOTGraceTime ? 0 : $SecondOTHour;
                $TOTHourwithGrace = $ThirdOTHour <= $TOTGraceTime ? 0 : $ThirdOTHour;

                if ($OTHour > $NOTGraceTime) {
                    $Value = $OTRoundupValue;
                    $NOTRoundupValue = Yii::app()->PublicFunctionForTimesheetUtil->OTRoundUp($OTHour, $Value);
                    $NOTHourwithGrace = $NOTRoundupValue;
                }
                if ($SecondOTHour > $DOTGraceTime) {
                    $Value = $OTRoundupValue;
                    $DOTRoundupValue = Yii::app()->PublicFunctionForTimesheetUtil->OTRoundUp($SecondOTHour, $Value);
                    $DOTHourwithGrace = $DOTRoundupValue;
                }
                if ($ThirdOTHour > $TOTGraceTime) {
                    $Value = $OTRoundupValue;
                    $TOTRoundupValue = Yii::app()->PublicFunctionForTimesheetUtil->OTRoundUp($ThirdOTHour, $Value);
                    $TOTHourwithGrace = $TOTRoundupValue;
                }

                $PreOTHour = 0;
                $PreOTAmount = 0;
                if ($PreOTStatus == 1) {
                    $PreOTHour = Yii::app()->PublicFunctionForTimesheetUtil->GetPreOTTime($shift->StartTime, $InTime);
                    $PreOTAmount = $PreOTHour * $EmployeeSalaryNOTRate;
                }

                //====== Get Short Leve Hour ========//
                $WorkedDays = 1;
                $shiftdate = strtotime($shift->EndTime);
                $Leavedate = date('Y-m-d', $shiftdate);
                $Short_Leave = Leave::model()->findByAttributes(array('EmoloyeeId' => $EmployeeId, 'StartDate' => $Leavedate, 'PaidType' => "Pay", 'Status' => 1));
                if (!empty($Short_Leave)) {
                    $WorkedHoursWithLeave1 = $Shifthour - $Short_Leave->No_Of_Hour;
                    $WorkedHoursWithLeave2 = $WorkedHoursWithLeave1 < 0 ? 0 : $WorkedHoursWithLeave1;
                    if ($Shifthour > 0) {
                        $WorkedDays = $WorkedHoursWithLeave2 / $Shifthour;
                    }
                }

                $employee = Employee::model()->findByAttributes(array('id' => $Current_Timesheet->EmployeeId));
                $paymentmethodType = $employee->Paymentmethod->type;
                $Category = $employee->categoryid;

                if ($Shifthour >= $diffhours) {

                    Timesheet::model()->updateAll(array('WorkedHour' => $workedhour,'Sub_Basic_salary' => $employeesalary->BasicSalary,'BRA1' => $employeesalary->BRA1,'BRA2' => $employeesalary->BRA2,'BRA3' => $employeesalary->BRA3, 'Actual_WorkHourInShift' => $ActualWorkedHourInShift, 'Category' => $Category, 'WorkedDay' => $WorkedDays, 'Intime' => $InTime, 'OuteTime' => $OutTime, 'TotalOTHour' => 0, 'SallaryRate' => $DayWge, 'NOvertimeHours' => 0, 'NOvertimeSalary' => 0, 'DOverTimeHour' => 0, 'Dovertimesalary' => 0, 'LatedeductTime' => $LateDeductTime, 'LatedeductAmount' => $LateDeductAmount, 'OutLateDeductTime' => $OutLateDeductTime, 'OutLateDeductAmount' => $OutLateDeductAmount, 'TOverTimeHour' => 0, 'Tovertimesalary' => 0, 'PreOTHour' => $PreOTHour, 'PreOTAmount' => $PreOTAmount, 'DayName' => $DayWithName), 'id ="' . $TimsheetId . '"');
                } else {

                    $NOTH = $OTHour >= $NotRang ? $NotRang : $NOTHourwithGrace;
                    $Re1 = $NOTH > 0 ? $NOTH : 0;
                    $Re2 = round($Re1 * 60);
                    $NOTHour = $Re2 / 60;

                    $NOTAmount = $NOTHour * $EmployeeSalaryNOTRate;
                    $TotalOTHour = $NOTHour + $PreOTHour;

                    if ($diffhours > $ShiftAndNOTHour) {
                        $DOTH = $SecondOTHour <= $DotRang ? $DOTHourwithGrace : $DotRang;
                        $DOTHour = $DOTH > 0 ? $DOTH : 0;
                        $DOTSallary = $DOTHour * $EmployeeSalaryDOTRate;
                        $TotalOTHour = $NOTHour + $DOTHour + $PreOTHour;

                        if ($diffhours > $ShiftAndDOTHour) {

                            $CustomizeOTHour = $ThirdOTHour <= $TOTRang ? $TOTHourwithGrace : $TOTRang;
                            $CustomizeOTSallary = $ShiftTOTRate * ($CustomizeOTHour * $employeesalary->HourlyRate);
                            $TotalOTHour = $NOTHour + $DOTHour + $CustomizeOTHour + $PreOTHour;
                            $TOTHour = 0;
                            $TOTSallary = 0;

                            if ($ShiftTOTRate == 1.5) {
                                $NOTHour = $NOTHour + $CustomizeOTHour;
                                $NOTAmount = $NOTAmount + $CustomizeOTSallary;
                            } elseif ($ShiftTOTRate == 2) {
                                $DOTHour = $DOTHour + $CustomizeOTHour;
                                $DOTSallary = $DOTSallary + $CustomizeOTSallary;
                            } else {
                                $TOTHour = $CustomizeOTHour;
                                $TOTSallary = $CustomizeOTSallary;
                            }
                            $NewNOTHour = $Current_Timesheet->OTApproveStatus == 1 ? $OldNOTHour : $NOTHour;
                            $NewDOTHour = $Current_Timesheet->OTApproveStatus == 1 ? $OldDOTHour : $DOTHour;
                            $NewTOTHour = $Current_Timesheet->OTApproveStatus == 1 ? $OldTOTHour : $TOTHour;

                            Timesheet::model()->updateAll(array('WorkedHour' => $workedhour, 'Sub_Basic_salary' => $employeesalary->BasicSalary, 'BRA1' => $employeesalary->BRA1, 'BRA2' => $employeesalary->BRA2, 'BRA3' => $employeesalary->BRA3, 'Actual_WorkHourInShift' => $ActualWorkedHourInShift, 'Category' => $Category, 'WorkedDay' => $WorkedDays, 'Intime' => $InTime, 'OuteTime' => $OutTime, 'TotalOTHour' => $TotalOTHour, 'SallaryRate' => $DayWge, 'NOvertimeHours' => $NewNOTHour, 'NOvertimeSalary' => $NOTAmount, 'DOverTimeHour' => $NewDOTHour, 'Dovertimesalary' => $DOTSallary, 'LatedeductTime' => $LateDeductTime, 'LatedeductAmount' => $LateDeductAmount, 'OutLateDeductTime' => $OutLateDeductTime, 'OutLateDeductAmount' => $OutLateDeductAmount, 'TOverTimeHour' => $NewTOTHour, 'Tovertimesalary' => $TOTSallary,'ActualNOT' => $NOTHour,'ActualDOT' => $DOTHour,'ActualTOT' => $TOTHour, 'PreOTHour' => $PreOTHour, 'PreOTAmount' => $PreOTAmount, 'DayName' => $DayWithName), 'id ="' . $TimsheetId . '"');
                        } else {
                            $NewNOTHour = $Current_Timesheet->OTApproveStatus == 1 ? $OldNOTHour : $NOTHour;
                            $NewDOTHour = $Current_Timesheet->OTApproveStatus == 1 ? $OldDOTHour : $DOTHour;
                            Timesheet::model()->updateAll(array('WorkedHour' => $workedhour, 'Actual_WorkHourInShift' => $ActualWorkedHourInShift, 'Category' => $Category, 'WorkedDay' => $WorkedDays, 'Intime' => $InTime, 'OuteTime' => $OutTime, 'TotalOTHour' => $TotalOTHour, 'SallaryRate' => $DayWge, 'NOvertimeHours' => $NewNOTHour, 'NOvertimeSalary' => $NOTAmount, 'DOverTimeHour' => $NewDOTHour, 'Dovertimesalary' => $DOTSallary, 'LatedeductTime' => $LateDeductTime, 'LatedeductAmount' => $LateDeductAmount, 'OutLateDeductTime' => $OutLateDeductTime, 'OutLateDeductAmount' => $OutLateDeductAmount, 'TOverTimeHour' => 0, 'Tovertimesalary' => 0,'ActualNOT' => $NOTHour,'ActualDOT' => $DOTHour,'ActualTOT' => 0, 'PreOTHour' => $PreOTHour, 'PreOTAmount' => $PreOTAmount, 'DayName' => $DayWithName), 'id ="' . $TimsheetId . '"');
                        }
                    } else {
                        $NewNOTHour = $Current_Timesheet->OTApproveStatus == 1 ? $OldNOTHour : $NOTHour;
                        Timesheet::model()->updateAll(array('WorkedHour' => $workedhour, 'Actual_WorkHourInShift' => $ActualWorkedHourInShift, 'Category' => $Category, 'WorkedDay' => $WorkedDays, 'Intime' => $InTime, 'OuteTime' => $OutTime, 'TotalOTHour' => $TotalOTHour, 'SallaryRate' => $DayWge, 'NOvertimeHours' => $NewNOTHour, 'NOvertimeSalary' => $NOTAmount, 'DOverTimeHour' => 0, 'Dovertimesalary' => 0, 'LatedeductTime' => $LateDeductTime, 'LatedeductAmount' => $LateDeductAmount, 'OutLateDeductTime' => $OutLateDeductTime, 'OutLateDeductAmount' => $OutLateDeductAmount, 'TOverTimeHour' => 0, 'Tovertimesalary' => 0,'ActualNOT' => $NOTHour,'ActualDOT' => 0,'ActualTOT' => 0, 'PreOTHour' => $PreOTHour, 'PreOTAmount' => $PreOTAmount, 'DayName' => $DayWithName), 'id ="' . $TimsheetId . '"');
                    }

                    if ($shift->EndTime < $InTime && $shift->StartTime != $shift->EndTime) {

                        Timesheet::model()->updateAll(array('WorkedHour' => 0, 'Actual_WorkHourInShift' => 0, 'TotalOTHour' => 0, 'NOvertimeHours' => 0, 'NOvertimeSalary' => 0, 'DOverTimeHour' => 0, 'Dovertimesalary' => 0, 'LatedeductTime' => 0, 'LatedeductAmount' => 0, 'OutLateDeductTime' => 0, 'OutLateDeductAmount' => 0, 'TOverTimeHour' => 0, 'Tovertimesalary' => 0, 'PreOTHour' => 0, 'PreOTAmount' => 0,'ActualNOT' => 0,'ActualDOT' => 0,'ActualTOT' => 0, 'DayName' => $DayWithName), 'id ="' . $TimsheetId . '"');
                    }
                }
            }
        }
    }

}
