<?php

class MonthlyPayrollCalculationUtil extends CApplicationComponent {

    public function CalculateBasicforMonthlyPayment($StartDate, $EndDate, $employeeid, $SiteId, $JoiningDate, $ResignDate, $JoiningDateNew) {

        $Employee = Employee::model()->findByAttributes(array('id' => $employeeid));
        $employeesalary = Employeesalary::model()->findByAttributes(array('employeeid' => $employeeid, 'site_id' => $SiteId, 'Status' => 1));

        $NumberOfWorked_Saturday = 0;
        $NumberOfWorked_Sunday = 0;
        if (empty($employeesalary)) {
            $employeesalary = new Employeesalary;
            $employeesalary->monthsalary = 0;
            $employeesalary->DalySalary = 0;
            $employeesalary->HourlyRate = 0;
            $employeesalary->OTRate = 0;
            $employeesalary->DoubleOTRate = 0;
            $employeesalary->BasicSalary = 0;
            $employeesalary->BRA1 = 0;
            $employeesalary->BRA2 = 0;
            $employeesalary->BRA3 = 0;
        }

        $Allsaturday = Yii::app()->MonthlyPayrollCalculationUtil->GetSpecificDayBetweenDates($JoiningDate, $ResignDate, 6);
        $NumOfSaturdaywithoutholiday = array();
        if (!empty($Allsaturday)) {
            foreach ($Allsaturday as $saturday) {

                $Sat_Holiday = Yii::app()->db->createCommand("SELECT holydays.Date
                               FROM holydays
                               WHERE holydays.Date ='" . $saturday . "' AND ( holydays.type ='GENERAL' OR holydays.siteId = '" . $SiteId . "')")->queryAll();

                if ($saturday < $JoiningDate || $saturday > $ResignDate) {
                    $Sat_Holiday = NULL;
                }
                if (empty($Sat_Holiday)) {

                    $NumOfSaturdaywithoutholiday[] = $saturday;
                }
            }
        }

        foreach ($NumOfSaturdaywithoutholiday as $saturdaywithout_holiday) {

            $d = strtotime($saturdaywithout_holiday);
            $start_week = strtotime("last sunday", $d);
            $end_week = strtotime("next saturday", $d);
            $Start_week = date("Y-m-d", $start_week);
            // $End_week = date("Y-m-d",$end_week);
            $End_week = $saturdaywithout_holiday;

            $Priviousdayof_joinedDate = date('Y-m-d', strtotime($JoiningDate . ' -1 day'));

            $Start_week_with_joigndate = $JoiningDateNew <= $Start_week ? $Start_week : $Priviousdayof_joinedDate;
            $End_week_with_Resign = $ResignDate >= $End_week ? $End_week : $ResignDate;

            $Holidays = Yii::app()->db->createCommand("SELECT COUNT( DISTINCT holydays.Date) AS HolidayCount
                FROM holydays
                WHERE holydays.Date >'" . $Start_week_with_joigndate . "' AND holydays.Date <='" . $End_week_with_Resign . "' AND ( holydays.type ='GENERAL' OR holydays.siteId = '" . $SiteId . "')")->queryAll();
            $AllHolidayCount = !empty($Holidays) ? $Holidays[0]['HolidayCount'] : 0;
            $AllHolidayHours = $AllHolidayCount * 8;

            $Timesheetcount = Yii::app()->db->createCommand("SELECT 
                COUNT(DISTINCT timesheet.date) AS NoOftimesheet,
                SUM(timesheet.WorkedHour) AS Hours
                FROM timesheet
                WHERE timesheet.date >'" . $Start_week . "'  AND timesheet.date <'" . $End_week . "'AND timesheet.EmployeeId= '" . $employeeid . "' AND timesheet.PaymentMethod ='MONTHLY' AND timesheet.DayName='WEEKDAY' AND (timesheet.date,timesheet.EmployeeId) NOT IN (SELECT leavedays.leaveDays,leavedays.EmpId
                FROM leavedays
                INNER JOIN `leave` ON leavedays.leaveId = (leave.id)
                WHERE leavedays.leaveDays >='" . $StartDate . "' AND leavedays.leaveDays <='" . $EndDate . "' AND (leave.Status) = 1 AND leavedays.leaveType ='Pay' AND leavedays.leave_type_status = 0)")->queryAll();

            $Dhour = !empty($Timesheetcount) ? $Timesheetcount[0]['Hours'] - $Timesheetcount[0]['NoOftimesheet'] : 0;
            $AllTimesheetcount = $Dhour > 0 ? $Dhour : 0;

            $Leave_count = Yii::app()->db->createCommand("SELECT COUNT(leavedays.id) AS leave_count
                FROM leavedays
                INNER JOIN `leave` L ON leavedays.leaveId = L.id
                WHERE leavedays.leaveDays >'" . $Start_week . "' AND leavedays.leaveDays <'" . $End_week . "' AND L.Status = 1 AND leavedays.EmpId ='" . $employeeid . "' AND leavedays.leaveType ='Pay' AND leavedays.leave_type_status = 0 AND leavedays.leaveDays NOT IN (SELECT DISTINCT holydays.Date 
                FROM holydays
                WHERE holydays.Date >'" . $StartDate . "' AND holydays.Date < '" . $EndDate . "' AND( holydays.type ='GENERAL' OR holydays.siteId =" . $SiteId . ")) ")->queryAll();

            $AllLeave_count = !empty($Leave_count) ? $Leave_count[0]['leave_count'] : 0;
            $AllLeave_Hours = $AllLeave_count * 8;

            $HalfDayLeave_count = Yii::app()->db->createCommand("SELECT COUNT(leavedays.id) AS leave_count
                FROM leavedays
                INNER JOIN `leave` L ON leavedays.leaveId = L.id
                WHERE leavedays.leaveDays >'" . $Start_week . "' AND leavedays.leaveDays <'" . $End_week . "' AND L.Status = 1 AND leavedays.EmpId ='" . $employeeid . "' AND leavedays.leaveType ='Pay' AND leavedays.leave_type_status = 1 AND leavedays.leaveDays NOT IN (SELECT DISTINCT holydays.Date 
                FROM holydays
                WHERE holydays.Date >'" . $StartDate . "' AND holydays.Date < '" . $EndDate . "' AND( holydays.type ='GENERAL' OR holydays.siteId =" . $SiteId . ")) ")->queryAll();

            $AllHalfdayLeave_count = !empty($HalfDayLeave_count) ? $HalfDayLeave_count[0]['leave_count'] : 0;
            $HalfdayAllLeave_Hours = $AllHalfdayLeave_count * 5;

            $saterday_hourcount = 0;
            $Saturday_Timesheet = Timesheet::model()->findByAttributes(array('date' => $End_week, 'EmployeeId' => $employeeid, 'SiteId' => $SiteId));
            if (!empty($Saturday_Timesheet)) {
                $saterday_hourcount = $Saturday_Timesheet->WorkedHour;
            }
            $Saturday_Leave = Yii::app()->db->createCommand("SELECT *
                FROM leavedays
                INNER JOIN `leave` L ON leavedays.leaveId = L.id
                WHERE leavedays.leaveDays ='" . $End_week . "' AND L.Status = 1 AND leavedays.EmpId ='" . $employeeid . "' AND leavedays.leaveType ='Pay'")->queryAll();

            if (!empty($Saturday_Leave)) {
                $saterday_hourcount = 5;
            }

            $WorkedHourinWeekfor_sat = $AllHolidayHours + $AllTimesheetcount + $AllLeave_Hours + $saterday_hourcount + $HalfdayAllLeave_Hours;

            $Timesheet_saterday = Timesheet::model()->findByAttributes(array('EmployeeId' => $employeeid, 'date' => $End_week, 'SiteId' => $SiteId));

            if (!empty($Timesheet_saterday) || !empty($Saturday_Leave)) {

                if ($JoiningDateNew >= $Start_week) {

                    $NumberOfWorked_Saturday += 1;
                } else {
                    if ($WorkedHourinWeekfor_sat >= 28) {

                        $NumberOfWorked_Saturday += 1;
                    } else {

                        $NumberOfWorked_Saturday += 0.5;
                    }
                }
            } else {
                if ($JoiningDateNew >= $Start_week) {

                    $NumberOfWorked_Saturday += 0.5;
                } else {
                    if ($WorkedHourinWeekfor_sat >= 28) {

                        $NumberOfWorked_Saturday += 0.5;
                    } else {

                        $NumberOfWorked_Saturday += 0;
                    }
                }
            }
        }

        $AllSunday = Yii::app()->MonthlyPayrollCalculationUtil->GetSpecificDayBetweenDates($JoiningDate, $ResignDate, 0);

        $NumOfSundaywithoutholiday = array();
        if (!empty($AllSunday)) {
            foreach ($AllSunday as $sunday) {

                $Sun_Holiday = Yii::app()->db->createCommand("SELECT holydays.Date
                               FROM holydays
                               WHERE holydays.Date ='" . $sunday . "' AND ( holydays.type ='GENERAL' OR holydays.siteId = '" . $SiteId . "')")->queryAll();

                if ($sunday < $JoiningDate || $sunday > $ResignDate) {
                    $Sat_Holiday = NULL;
                }

                if (empty($Sun_Holiday)) {

                    $NumOfSundaywithoutholiday[] = $sunday;
                }
            }
        }
        foreach ($NumOfSundaywithoutholiday as $sundaywithout_holiday) {

            $Priviousdayof_saturday = date('Y-m-d', strtotime($sundaywithout_holiday . ' -1 day'));
            $d = strtotime($Priviousdayof_saturday);
            $start_week = strtotime("last sunday", $d);
            $end_week = strtotime("next saturday", $d);
            $Start_week = date("Y-m-d", $start_week);
            // $End_week = date("Y-m-d",$end_week);
            $End_week = $Priviousdayof_saturday;

            $Priviousdayof_joinedDate = date('Y-m-d', strtotime($JoiningDate . ' -1 day'));

            $Start_week_with_joigndate = $JoiningDateNew <= $Start_week ? $Start_week : $Priviousdayof_joinedDate;
            $End_week_with_Resign = $ResignDate >= $End_week ? $End_week : $ResignDate;

            $Holidays = Yii::app()->db->createCommand("SELECT COUNT( DISTINCT holydays.Date) AS HolidayCount
                FROM holydays

                WHERE holydays.Date >'" . $Start_week_with_joigndate . "' AND holydays.Date < '" . $End_week_with_Resign . "' AND ( holydays.type ='GENERAL' OR holydays.siteId = '" . $SiteId . "')")->queryAll();

            $AllHolidayCount = !empty($Holidays) ? $Holidays[0]['HolidayCount'] : 0;
            $AllHolidayHours = $AllHolidayCount * 8;

            $sql2 = "SELECT 
            COUNT(DISTINCT timesheet.date) AS NoOftimesheet,
            SUM(timesheet.WorkedHour) AS Hours
            FROM timesheet
            WHERE timesheet.date >'" . $Start_week . "'  AND timesheet.date <'" . $End_week . "' AND timesheet.EmployeeId= " . $employeeid . " AND timesheet.PaymentMethod ='MONTHLY' AND timesheet.DayName='WEEKDAY' AND (timesheet.date,timesheet.EmployeeId) NOT IN (SELECT leavedays.leaveDays,leavedays.EmpId
            FROM leavedays
            INNER JOIN `leave` ON leavedays.leaveId = (leave.id)
            WHERE leavedays.leaveDays >='" . $StartDate . "' AND leavedays.leaveDays <='" . $EndDate . "' AND (leave.Status) =1 AND leavedays.leaveType ='Pay' AND leavedays.leave_type_status = 0)";
            $Timesheetcount = Yii::app()->db->createCommand($sql2)->queryAll();

            $DShour = !empty($Timesheetcount) ? $Timesheetcount[0]['Hours'] - $Timesheetcount[0]['NoOftimesheet'] : 0;
            $AllTimesheetcount = $DShour > 0 ? $DShour : 0;

            $Leave_count = Yii::app()->db->createCommand("SELECT COUNT(leavedays.id) AS leave_count
                FROM leavedays
                INNER JOIN `leave` L ON leavedays.leaveId = L.id
                WHERE leavedays.leaveDays >'" . $Start_week . "' AND leavedays.leaveDays <'" . $End_week . "' AND L.Status = 1 AND leavedays.EmpId ='" . $employeeid . "' AND leavedays.leaveType ='Pay' AND leavedays.leave_type_status = 0 AND leavedays.leaveDays NOT IN (SELECT DISTINCT holydays.Date 
                FROM holydays
                WHERE holydays.Date >'" . $StartDate . "' AND holydays.Date < '" . $EndDate . "' AND( holydays.type ='GENERAL' OR holydays.siteId =" . $SiteId . "))")->queryAll();

            $AllLeave_count = !empty($Leave_count) ? $Leave_count[0]['leave_count'] : 0;
            $AllLeave_Hours = $AllLeave_count * 8;

            $HalfDayLeave_count = Yii::app()->db->createCommand("SELECT COUNT(leavedays.id) AS leave_count
                FROM leavedays
                INNER JOIN `leave` L ON leavedays.leaveId = L.id
                WHERE leavedays.leaveDays >'" . $Start_week . "' AND leavedays.leaveDays <'" . $End_week . "' AND L.Status = 1 AND leavedays.EmpId ='" . $employeeid . "' AND leavedays.leaveType ='Pay' AND leavedays.leave_type_status = 1 AND leavedays.leaveDays NOT IN (SELECT DISTINCT holydays.Date 
                FROM holydays
                WHERE holydays.Date >'" . $StartDate . "' AND holydays.Date < '" . $EndDate . "' AND( holydays.type ='GENERAL' OR holydays.siteId =" . $SiteId . ")) ")->queryAll();

            $AllHalfdayLeave_count = !empty($HalfDayLeave_count) ? $HalfDayLeave_count[0]['leave_count'] : 0;
            $HalfdayAllLeave_Hours = $AllHalfdayLeave_count * 5;

            $saterday_hourcount = 0;

            $Saturday_Holiday = Yii::app()->db->createCommand("SELECT DISTINCT holydays.Date 
                FROM holydays
                WHERE holydays.Date ='" . $End_week . "' AND( holydays.type ='GENERAL' OR holydays.siteId =" . $SiteId . ")")->queryAll();

            $Saturday_Leave = Yii::app()->db->createCommand("SELECT *
                FROM leavedays
                INNER JOIN `leave` L ON leavedays.leaveId = L.id
                WHERE leavedays.leaveDays ='" . $End_week . "' AND L.Status = 1 AND leavedays.EmpId ='" . $employeeid . "' AND leavedays.leaveType ='Pay'")->queryAll();

            $Saturday_Timesheet = Timesheet::model()->findByAttributes(array('date' => $End_week, 'EmployeeId' => $employeeid, 'SiteId' => $SiteId));
            if (!empty($Saturday_Timesheet)) {
                $saterday_hourcount = $Saturday_Timesheet->WorkedHour;
            }
            if (!empty($Saturday_Holiday) || !empty($Saturday_Leave)) {
                $saterday_hourcount = 5;
            }

            $WorkedHourinWeek = $AllHolidayHours + $AllTimesheetcount + $AllLeave_Hours + $saterday_hourcount + $HalfdayAllLeave_Hours;

            if ($JoiningDateNew >= $Start_week) {

                $NumberOfWorked_Saturday += 1;
            } else {
                if ($WorkedHourinWeek >= 28) {
                    $NumberOfWorked_Sunday += 1;
                } else {
                    $NumberOfWorked_Sunday += 0;
                }
            }
        }

        $HolidayCount = Yii::app()->db->createCommand("SELECT COUNT( DISTINCT holydays.Date) AS HolidayCount
                FROM holydays
                WHERE holydays.Date >='" . $JoiningDate . "' AND holydays.Date <='" . $ResignDate . "' AND ( holydays.type ='GENERAL' OR holydays.siteId = '" . $SiteId . "')")->queryAll();
        $NumberOfAllHoliday = !empty($HolidayCount) ? $HolidayCount[0]['HolidayCount'] : 0;

        $WeekDays = Yii::app()->db->createCommand("SELECT 
            COUNT(timesheet.id) AS NumberOftimesheet,
            timesheet.DayName
            FROM timesheet
            WHERE timesheet.date >='" . $JoiningDate . "'  AND timesheet.date <='" . $ResignDate . "' AND timesheet.SiteId ='" . $SiteId . "' AND timesheet.EmployeeId ='" . $employeeid . "' AND timesheet.PaymentMethod ='MONTHLY' AND DAYNAME(timesheet.Date) NOT IN ('Saturday', 'Sunday') AND timesheet.DayName ='WEEKDAY'AND timesheet.Intime != '0000-00-00 00:00:00' AND timesheet.OuteTime != '0000-00-00 00:00:00'  AND timesheet.date NOT IN (SELECT leavedays.leaveDays
            FROM leavedays
            INNER JOIN `leave` ON leavedays.leaveId = (leave.id)
            WHERE leavedays.leaveDays >='" . $StartDate . "' AND leavedays.leaveDays <='" . $EndDate . "'AND leavedays.EmpId ='" . $employeeid . "' AND (leave.site) = '" . $SiteId . "' AND (leave.Status) = 1  AND leavedays.leaveType ='Pay' AND leavedays.leave_type_status = 0)")->queryAll();
        $NumberOfWeekDays = $WeekDays[0]['NumberOftimesheet'];

        $Weekday_Leaves = Yii::app()->db->createCommand("SELECT 
             COUNT(leavedays.id) AS NumberOfDays
             FROM leavedays
             INNER JOIN `leave` L ON leavedays.leaveId = L.id
             WHERE leavedays.leaveDays >='" . $JoiningDate . "' AND leavedays.leaveDays <='" . $ResignDate . "' AND L.site = '" . $SiteId . "' AND DAYNAME(leavedays.leaveDays) NOT IN ('Saturday', 'Sunday') AND leavedays.leaveDays NOT IN (SELECT holydays.Date FROM holydays WHERE holydays.Date >='" . $StartDate . "' AND holydays.Date <='" . $EndDate . "' AND ( holydays.type ='GENERAL' OR holydays.siteId = '" . $SiteId . "')) AND L.Status = 1 AND leavedays.EmpId ='" . $employeeid . "' AND L.PaidType ='Pay' AND leavedays.leave_type_status = 0")->queryAll();
        $NumberOfLeaveFullday = !empty($Weekday_Leaves) ? $Weekday_Leaves[0]['NumberOfDays'] : 0;

        $Weekday_HalfDayLeaveCount = Yii::app()->db->createCommand("SELECT DISTINCT L.StartDate, COUNT(L.id) AS NumberOfHarfDay
            FROM `leave` L
            WHERE L.EmoloyeeId ='" . $employeeid . "'  AND  L.StartDate >= '" . $JoiningDate . "' AND L.StartDate <= '" . $ResignDate . "' AND L.site = '" . $SiteId . "' AND L.Status = 1 AND L.PaidType ='Pay' AND L.day_type ='Half Day' AND DAYNAME(L.StartDate) NOT IN ('Saturday','Sunday') AND L.StartDate NOT IN (SELECT timesheet.date
            FROM timesheet
            WHERE timesheet.date >='" . $StartDate . "'  AND timesheet.date <='" . $EndDate . "' AND timesheet.SiteId ='" . $SiteId . "' AND timesheet.EmployeeId =" . $employeeid . " AND timesheet.PaymentMethod ='MONTHLY' AND DAYNAME(timesheet.Date) NOT IN ('Saturday','Sunday') AND timesheet.DayName ='WEEKDAY'AND timesheet.Intime != '0000-00-00 00:00:00' AND timesheet.OuteTime != '0000-00-00 00:00:00')")->queryAll();
        $NumberOfLeaveHlfDay = !empty($Weekday_HalfDayLeaveCount) ? $Weekday_HalfDayLeaveCount[0]['NumberOfHarfDay'] : 0;

        $NumberOfLeave = $NumberOfLeaveFullday + ($NumberOfLeaveHlfDay * 0.5);
        $date1 = date_create($StartDate);
        $date2 = date_create($EndDate);
        $diff = date_diff($date1, $date2);
        $numberofdayinmonth = $diff->format("%R%a");
        $NumberofDayinMonth = $numberofdayinmonth + 1;

        $Notworkedays = $NumberofDayinMonth - ($NumberOfAllHoliday + $NumberOfWeekDays + $NumberOfWorked_Saturday + $NumberOfWorked_Sunday + $NumberOfLeave);
        $NopayDays = $Notworkedays > 0 ? $Notworkedays : 0;

        switch ($NumberofDayinMonth) {
            case 28:

                if ($ResignDate < $EndDate) {
                    $NumberOfNoPayDays = $NopayDays > 0 ? $NopayDays + 2 : $NopayDays;
                } else {
                    $NumberOfNoPayDays = $NopayDays;
                }

                break;
            case 29:
                if ($ResignDate < $EndDate) {
                    $NumberOfNoPayDays = $NopayDays > 0 ? $NopayDays + 1 : $NopayDays;
                } else {
                    $NumberOfNoPayDays = $NopayDays;
                }

                break;
            case 31:
                $NumberOfNoPayDays = $NopayDays > 0 ? $NopayDays - 1 : $NopayDays;
                break;
            default:
                $NumberOfNoPayDays = $NopayDays;
        }

        $Res = $NumberOfNoPayDays > 0 ? $NumberOfNoPayDays : 0;

        $NoPayAmount = $employeesalary->DalySalary * $Res;
        $BasicSalary = $employeesalary->monthsalary - $NoPayAmount;

        //echo json_encode($AllSunday);
        //die;

        $WorkeddaysInMonth = $NumberofDayinMonth - $NopayDays;

        $Result = array($BasicSalary, $WorkeddaysInMonth, $Res, $NumberOfWeekDays);
        return $Result;
    }

    public function CalculateBasicforMonthlyPaymentRosterBase($StartDate, $EndDate, $employeeid, $SiteId, $JoiningDate, $ResignDate) {

        $employeesalary = Employeesalary::model()->findByAttributes(array('employeeid' => $employeeid, 'site_id' => $SiteId, 'Status' => 1));

        if (empty($employeesalary)) {
            $employeesalary = new Employeesalary;
            $employeesalary->monthsalary = 0;
            $employeesalary->DalySalary = 0;
            $employeesalary->HourlyRate = 0;
            $employeesalary->OTRate = 0;
            $employeesalary->DoubleOTRate = 0;
            $employeesalary->BasicSalary = 0;
            $employeesalary->BRA1 = 0;
            $employeesalary->BRA2 = 0;
            $employeesalary->BRA3 = 0;
        }

        $HolidayCount = Yii::app()->db->createCommand("SELECT COUNT( DISTINCT holydays.Date) AS HolidayCount
                FROM holydays
                WHERE holydays.Date >='" . $JoiningDate . "' AND holydays.Date <='" . $ResignDate . "' AND ( holydays.type ='GENERAL' OR holydays.siteId = '" . $SiteId . "')")->queryAll();
        $AllHoliday = !empty($HolidayCount) ? $HolidayCount[0]['HolidayCount'] : 0;

        $WorkedkDays = Yii::app()->db->createCommand("SELECT 
            COUNT(DISTINCT timesheet.date) AS NumberOftimesheet,
            timesheet.DayName
            FROM timesheet
            WHERE timesheet.date >='" . $StartDate . "'  AND timesheet.date <='" . $EndDate . "' AND timesheet.EmployeeId ='" . $employeeid . "' AND timesheet.PaymentMethod ='MONTHLY'AND timesheet.DayName NOT IN ('HOLIDAY') AND timesheet.Intime != '0000-00-00 00:00:00' AND timesheet.OuteTime != '0000-00-00 00:00:00' AND timesheet.date NOT IN (SELECT leavedays.leaveDays
            FROM leavedays
            INNER JOIN `leave` ON leavedays.leaveId = (leave.id)
            WHERE leavedays.leaveDays >='" . $StartDate . "' AND leavedays.leaveDays <='" . $EndDate . "'AND leavedays.EmpId ='" . $employeeid . "' AND (leave.site) = '" . $SiteId . "' AND (leave.Status) = 1  AND leavedays.leaveType ='Pay' AND leavedays.leave_type_status = 0)")->queryAll();
        $NumberOfWorkDaysWithoutHoliday = $WorkedkDays[0]['NumberOftimesheet'] > 0 ? $WorkedkDays[0]['NumberOftimesheet'] : 0;

        $Leaves = Yii::app()->db->createCommand("SELECT 
             COUNT(DISTINCT leavedays.leaveDays) AS NumberOfDays
             FROM leavedays
             INNER JOIN `leave` L ON leavedays.leaveId = L.id
             WHERE leavedays.leaveDays >='" . $StartDate . "' AND leavedays.leaveDays <='" . $EndDate . "' AND L.site = '" . $SiteId . "' AND L.Status = 1 AND leavedays.EmpId ='" . $employeeid . "' AND leavedays.leaveDays NOT IN (SELECT holydays.Date FROM holydays WHERE holydays.Date >='" . $StartDate . "' AND holydays.Date <='" . $EndDate . "' AND ( holydays.type ='GENERAL' OR holydays.siteId = '" . $SiteId . "')) AND L.PaidType ='Pay' AND leavedays.leave_type_status = 0")->queryAll();
        $NumberOfLeave = !empty($Leaves) ? $Leaves[0]['NumberOfDays'] : 0;

        $date1 = date_create($StartDate);
        $date2 = date_create($EndDate);
        $diff = date_diff($date1, $date2);
        $numberofdayinmonth = $diff->format("%R%a");
        $NumberofDayinMonth = $numberofdayinmonth + 1;

        $NotWorkedDay = $NumberofDayinMonth - ($AllHoliday + $NumberOfWorkDaysWithoutHoliday + $NumberOfLeave);
        $NopayDays = $NotWorkedDay > 0 ? $NotWorkedDay : 0;

        switch ($NumberofDayinMonth) {
            case 28:
                $NumberOfNoPayDays = $NopayDays > 0 ? $NopayDays + 2 : $NopayDays;
                break;
            case 29:
                $NumberOfNoPayDays = $NopayDays > 0 ? $NopayDays + 1 : $NopayDays;
                break;
            case 31:
                $NumberOfNoPayDays = $NopayDays > 0 ? $NopayDays - 1 : $NopayDays;
                break;
            default:
                $NumberOfNoPayDays = $NopayDays;
        }
        $NoPayAmount = $employeesalary->DalySalary * $NumberOfNoPayDays;
        $BasicSalary = $employeesalary->monthsalary - $NoPayAmount;

        $WorkeddaysInMonth = $NumberofDayinMonth - $NopayDays;
        //echo json_encode($AllSunday);
        //die;

        $Result = array($BasicSalary, $WorkeddaysInMonth, $NumberOfNoPayDays, $NumberOfWorkDaysWithoutHoliday);
        return $Result;
    }

    public function PoyadayPayment($StartDate, $EndDate, $Nic, $SiteId) {

        $Employee = Employee::model()->findByAttributes(array('nic' => $Nic));

        $Criteria1 = new CDbCriteria();
        $Criteria1->condition = 'date(Date)>= :StartDate AND date(Date) <= :EndDate AND Is_Poyaday = :Poyaday ';
        $Criteria1->params = array(':StartDate' => $StartDate, ':EndDate' => $EndDate, ':Poyaday' => "POYADAY");
        $Criteria1->select = "*";
        $poyaday = Holydays::model()->findAll($Criteria1);

        $BasicPayment = 0;
        $NormalOT = 0;
        $DoubleOT = 0;
        $ToubleOT = 0;
        $OutLatededuct = 0;
        $LatedeductAmount = 0;
        $OutLatedeductTime = 0;
        $LatedeductTime = 0;
        $NumberofTimsheet = 0;

        if (!empty($poyaday)) {

            foreach ($poyaday as $p) {
                $sql = " SELECT 
            COUNT(timesheet.id) AS NoOftimesheet,        
            SUM(timesheet.SallaryRate) AS BasicSalary,
            SUM(timesheet.NOvertimeSalary) AS NOTAmout,
            SUM(timesheet.Dovertimesalary) AS DOTAmount,
            SUM(timesheet.Tovertimesalary) AS TOTAmount,
            SUM(timesheet.LatedeductAmount) AS Latedeductamount,
            SUM(timesheet.OutLateDeductAmount) AS Outlatededuct,
            SUM(timesheet.LatedeductTime) AS LatedeductHours,
            SUM(timesheet.OutLateDeductTime) AS OutlatedeductHours,
            timesheet.date,
            timesheet.EmployeeId
            FROM timesheet
            WHERE timesheet.EmployeeId ='" . $Employee->id . "'  AND timesheet.date ='" . $p->Date . "' AND timesheet.SiteId ='" . $SiteId . "' AND timesheet.Intime != '0000-00-00 00:00:00' AND timesheet.OuteTime != '0000-00-00 00:00:00'
            GROUP BY timesheet.EmployeeId ";

                $Timsheet = Yii::app()->db->createCommand($sql)->queryAll();

                if (!empty($Timsheet)) {

                    $BasicPayment += $Timsheet[0]['BasicSalary'];
                    $NormalOT += $Timsheet[0]['NOTAmout'];
                    $DoubleOT += $Timsheet[0]['DOTAmount'];
                    $ToubleOT += $Timsheet[0]['TOTAmount'];
                    $OutLatededuct += $Timsheet[0]['Outlatededuct'];
                    $LatedeductAmount += $Timsheet[0]['Latedeductamount'];
                    $OutLatedeductTime += $Timsheet[0]['OutlatedeductHours'];
                    $LatedeductTime += $Timsheet[0]['LatedeductHours'];
                    $NumberofTimsheet += $Timsheet[0]['NoOftimesheet'];
                }
            }
        }
        $AllpoyadayPayment = $BasicPayment + $NormalOT + $DoubleOT + $ToubleOT;
        $poyadaypayment = array($AllpoyadayPayment, $BasicPayment, $NormalOT, $DoubleOT, $ToubleOT, $OutLatededuct, $LatedeductAmount, $OutLatedeductTime, $LatedeductTime, $NumberofTimsheet);
//       $payroll = CJSON::encode($AllpoyadayPayment);
//        echo $payroll;
//         die;
        return $poyadaypayment;
    }

    public function MercantilePayment($StartDate, $EndDate, $Nic, $SiteId) {

        $Employee = Employee::model()->findByAttributes(array('nic' => $Nic));

        $Criteria1 = new CDbCriteria();
        $Criteria1->condition = 'date(Date)>= :StartDate AND date(Date) <= :EndDate AND Is_Mercantile = :Mercantile AND Is_Poyaday != :Poyaday';
        $Criteria1->params = array(':StartDate' => $StartDate, ':EndDate' => $EndDate, ':Mercantile' => "MERCANTILE", ':Poyaday' => "POYADAY");
        $Criteria1->select = "*";
        $Mercantile = Holydays::model()->findAll($Criteria1);

        $BasicPayment = 0;
        $NormalOT = 0;
        $DoubleOT = 0;
        $ToubleOT = 0;
        $OutLatededuct = 0;
        $LatedeductAmount = 0;
        $OutLatedeductTime = 0;
        $LatedeductTime = 0;
        $NumberofTimsheet = 0;

        if (!empty($Mercantile)) {

            foreach ($Mercantile as $p) {
                $sql = " SELECT 
            COUNT(timesheet.id) AS NoOftimesheet,        
            SUM(timesheet.SallaryRate) AS BasicSalary,
            SUM(timesheet.NOvertimeSalary) AS NOTAmout,
            SUM(timesheet.Dovertimesalary) AS DOTAmount,
            SUM(timesheet.Tovertimesalary) AS TOTAmount,
            SUM(timesheet.OutLateDeductAmount) AS Outlatededuct,
            SUM(timesheet.LatedeductAmount) AS Latedeductamount,
            SUM(timesheet.LatedeductTime) AS LatedeductHours,
            SUM(timesheet.OutLateDeductTime) AS OutlatedeductHours,
            timesheet.date,
            timesheet.EmployeeId
            FROM timesheet
            WHERE timesheet.EmployeeId ='" . $Employee->id . "'  AND timesheet.date ='" . $p->Date . "' AND timesheet.SiteId ='" . $SiteId . "' AND timesheet.Intime != '0000-00-00 00:00:00' AND timesheet.OuteTime != '0000-00-00 00:00:00'
            GROUP BY timesheet.EmployeeId ";

                $Timsheet = Yii::app()->db->createCommand($sql)->queryAll();

                if (!empty($Timsheet)) {

                    $BasicPayment += $Timsheet[0]['BasicSalary'];
                    $NormalOT += $Timsheet[0]['NOTAmout'];
                    $DoubleOT += $Timsheet[0]['DOTAmount'];
                    $ToubleOT += $Timsheet[0]['TOTAmount'];
                    $OutLatededuct += $Timsheet[0]['Outlatededuct'];
                    $LatedeductAmount += $Timsheet[0]['Latedeductamount'];
                    $OutLatedeductTime += $Timsheet[0]['OutlatedeductHours'];
                    $LatedeductTime += $Timsheet[0]['LatedeductHours'];
                    $NumberofTimsheet += $Timsheet[0]['NoOftimesheet'];
                }
            }
        }
        $AllMercantilePayment = $BasicPayment + $NormalOT + $DoubleOT + $ToubleOT;
        $mercantilepayment = array($AllMercantilePayment, $BasicPayment, $NormalOT, $DoubleOT, $ToubleOT, $OutLatededuct, $LatedeductAmount, $OutLatedeductTime, $LatedeductTime, $NumberofTimsheet);
        return $mercantilepayment;
    }

    public function SundayPayment($StartDate, $EndDate, $Nic, $SiteId) {

        $AllSunday = Yii::app()->MonthlyPayrollCalculationUtil->GetSpecificDayBetweenDates($StartDate, $EndDate, 0);
        $Employee = Employee::model()->findByAttributes(array('nic' => $Nic));

        $BasicPayment = 0;
        $NormalOT = 0;
        $DoubleOT = 0;
        $ToubleOT = 0;
        $OutLatededuct = 0;
        $LatedeductAmount = 0;
        $OutLatedeductTime = 0;
        $LatedeductTime = 0;
        $NumberofTimsheet = 0;

        $NumOfSundaywithoutholiday = array();
        if (!empty($AllSunday)) {
            foreach ($AllSunday as $sunday) {
                $holiday = Holydays::model()->findByAttributes(array('Date' => $sunday));

                if (empty($holiday)) {

                    $NumOfSundaywithoutholiday[] = $sunday;
                }
            }
        }

        if (!empty($NumOfSundaywithoutholiday)) {

            foreach ($NumOfSundaywithoutholiday as $p) {

                $sql = " SELECT 
            COUNT(timesheet.id) AS NoOftimesheet,        
            SUM(timesheet.SallaryRate) AS BasicSalary,
            SUM(timesheet.NOvertimeSalary) AS NOTAmout,
            SUM(timesheet.Dovertimesalary) AS DOTAmount,
            SUM(timesheet.Tovertimesalary) AS TOTAmount,
            SUM(timesheet.OutLateDeductAmount) AS Outlatededuct,
            SUM(timesheet.LatedeductAmount) AS Latedeductamount,
            SUM(timesheet.LatedeductTime) AS LatedeductHours,
            SUM(timesheet.OutLateDeductTime) AS OutlatedeductHours,
            timesheet.date,
            timesheet.EmployeeId
            FROM timesheet
            WHERE timesheet.EmployeeId ='" . $Employee->id . "'  AND timesheet.date ='" . $p . "' AND timesheet.SiteId ='" . $SiteId . "' AND timesheet.Intime != '0000-00-00 00:00:00' AND timesheet.OuteTime != '0000-00-00 00:00:00'
            GROUP BY timesheet.EmployeeId ";

                $Timsheet = Yii::app()->db->createCommand($sql)->queryAll();

                if (!empty($Timsheet)) {

                    $BasicPayment += $Timsheet[0]['BasicSalary'];
                    $NormalOT += $Timsheet[0]['NOTAmout'];
                    $DoubleOT += $Timsheet[0]['DOTAmount'];
                    $ToubleOT += $Timsheet[0]['TOTAmount'];
                    $OutLatededuct += $Timsheet[0]['Outlatededuct'];
                    $LatedeductAmount += $Timsheet[0]['Latedeductamount'];
                    $OutLatedeductTime += $Timsheet[0]['OutlatedeductHours'];
                    $LatedeductTime += $Timsheet[0]['LatedeductHours'];
                    $NumberofTimsheet += $Timsheet[0]['NoOftimesheet'];
                }
            }
        }

        $AllSundayPayment = $BasicPayment + $NormalOT + $DoubleOT + $ToubleOT;
        $Sundaypayment = array($AllSundayPayment, $BasicPayment, $NormalOT, $DoubleOT, $ToubleOT, $OutLatededuct, $LatedeductAmount, $OutLatedeductTime, $LatedeductTime, $NumberofTimsheet);

        return $Sundaypayment;
    }

    public function SaturdayPayment($StartDate, $EndDate, $Nic, $SiteId) {

        $AllSaturday = Yii::app()->MonthlyPayrollCalculationUtil->GetSpecificDayBetweenDates($StartDate, $EndDate, 6);
        $Employee = Employee::model()->findByAttributes(array('nic' => $Nic));

        $BasicPayment = 0;
        $NormalOT = 0;
        $DoubleOT = 0;
        $ToubleOT = 0;
        $OutLatededuct = 0;
        $LatedeductAmount = 0;
        $OutLatedeductTime = 0;
        $LatedeductTime = 0;
        $NumberofTimsheet = 0;

        $NumOfSaturdaywithoutholiday = array();
        if (!empty($AllSaturday)) {
            foreach ($AllSaturday as $saturday) {
                $holiday = Holydays::model()->findByAttributes(array('Date' => $saturday));

                if (empty($holiday)) {

                    $NumOfSaturdaywithoutholiday[] = $saturday;
                }
            }
        }

        if (!empty($NumOfSaturdaywithoutholiday)) {

            foreach ($NumOfSaturdaywithoutholiday as $p) {

                $sql = " SELECT 
            COUNT(timesheet.id) AS NoOftimesheet,
            SUM(timesheet.SallaryRate) AS BasicSalary,
            SUM(timesheet.NOvertimeSalary) AS NOTAmout,
            SUM(timesheet.Dovertimesalary) AS DOTAmount,
            SUM(timesheet.Tovertimesalary) AS TOTAmount,
            SUM(timesheet.OutLateDeductAmount) AS Outlatededuct,
            SUM(timesheet.LatedeductAmount) AS Latedeductamount,
            SUM(timesheet.LatedeductTime) AS LatedeductHours,
            SUM(timesheet.OutLateDeductTime) AS OutlatedeductHours,
            timesheet.date,
            timesheet.EmployeeId
            FROM timesheet
            WHERE timesheet.EmployeeId ='" . $Employee->id . "'  AND timesheet.date ='" . $p . "' AND timesheet.SiteId ='" . $SiteId . "' AND timesheet.Intime != '0000-00-00 00:00:00' AND timesheet.OuteTime != '0000-00-00 00:00:00'
            GROUP BY timesheet.EmployeeId ";

                $Timsheet = Yii::app()->db->createCommand($sql)->queryAll();

                if (!empty($Timsheet)) {

                    $BasicPayment += $Timsheet[0]['BasicSalary'];
                    $NormalOT += $Timsheet[0]['NOTAmout'];
                    $DoubleOT += $Timsheet[0]['DOTAmount'];
                    $ToubleOT += $Timsheet[0]['TOTAmount'];
                    $OutLatededuct += $Timsheet[0]['Outlatededuct'];
                    $LatedeductAmount += $Timsheet[0]['Latedeductamount'];
                    $OutLatedeductTime += $Timsheet[0]['OutlatedeductHours'];
                    $LatedeductTime += $Timsheet[0]['LatedeductHours'];
                    $NumberofTimsheet += $Timsheet[0]['NoOftimesheet'];
                }
            }
        }

        $AllSundayPayment = $BasicPayment + $NormalOT + $DoubleOT + $ToubleOT;
        $Sundaypayment = array($AllSundayPayment, $BasicPayment, $NormalOT, $DoubleOT, $ToubleOT, $OutLatededuct, $LatedeductAmount, $OutLatedeductTime, $LatedeductTime, $NumberofTimsheet);

        return $Sundaypayment;
    }

    public function SiteHolidaydayPayment($StartDate, $EndDate, $Nic, $SiteId) {

        $sql = "
            SELECT *
            FROM holydays
            WHERE    
            holydays.Date >= '" . $StartDate . "' AND holydays.Date <= '" . $EndDate . "' AND  holydays.siteid ='" . $SiteId . "'";
        $SiteHolidays = Yii::app()->db->createCommand($sql)->queryAll();

        $Employee = Employee::model()->findByAttributes(array('nic' => $Nic));

        $BasicPayment = 0;
        $NormalOT = 0;
        $DoubleOT = 0;
        $ToubleOT = 0;
        $OutLatededuct = 0;
        $LatedeductAmount = 0;
        $OutLatedeductTime = 0;
        $LatedeductTime = 0;
        $NumberofTimsheet = 0;

        $NumOfSiteHolidaywithoutholiday = array();
        if (!empty($SiteHolidays)) {
            foreach ($SiteHolidays as $siteholiday) {
                $holiday = Holydays::model()->findByAttributes(array('Date' => $siteholiday['Date'], 'type' => 'GENERAL'));
                if (empty($holiday)) {
                    $NumOfSiteHolidaywithoutholiday[] = $siteholiday['Date'];
                }
            }
        }

        if (!empty($NumOfSiteHolidaywithoutholiday)) {

            foreach ($NumOfSiteHolidaywithoutholiday as $p) {

                $sql = " SELECT 
            COUNT(timesheet.id) AS NoOftimesheet,        
            SUM(timesheet.SallaryRate) AS BasicSalary,
            SUM(timesheet.NOvertimeSalary) AS NOTAmout,
            SUM(timesheet.Dovertimesalary) AS DOTAmount,
            SUM(timesheet.Tovertimesalary) AS TOTAmount,
            SUM(timesheet.OutLateDeductAmount) AS Outlatededuct,
            SUM(timesheet.LatedeductAmount) AS Latedeductamount,
            SUM(timesheet.LatedeductTime) AS LatedeductHours,
            SUM(timesheet.OutLateDeductTime) AS OutlatedeductHours,
            timesheet.date,
            timesheet.EmployeeId
            FROM timesheet
            WHERE timesheet.EmployeeId ='" . $Employee->id . "'  AND timesheet.date ='" . $p . "' AND timesheet.SiteId ='" . $SiteId . "' AND timesheet.Intime != '0000-00-00 00:00:00' AND timesheet.OuteTime != '0000-00-00 00:00:00'
            GROUP BY timesheet.EmployeeId ";

                $Timsheet = Yii::app()->db->createCommand($sql)->queryAll();

                if (!empty($Timsheet)) {

                    $BasicPayment += $Timsheet[0]['BasicSalary'];
                    $NormalOT += $Timsheet[0]['NOTAmout'];
                    $DoubleOT += $Timsheet[0]['DOTAmount'];
                    $ToubleOT += $Timsheet[0]['TOTAmount'];
                    $OutLatededuct += $Timsheet[0]['Outlatededuct'];
                    $LatedeductAmount += $Timsheet[0]['Latedeductamount'];
                    $OutLatedeductTime += $Timsheet[0]['OutlatedeductHours'];
                    $LatedeductTime += $Timsheet[0]['LatedeductHours'];
                    $NumberofTimsheet += $Timsheet[0]['NoOftimesheet'];
                }
            }
        }
        $AllSiteHolidaydayPayment = $BasicPayment + $NormalOT + $DoubleOT + $ToubleOT;
        $Siteholidaypayment = array($AllSiteHolidaydayPayment, $BasicPayment, $NormalOT, $DoubleOT, $ToubleOT, $OutLatededuct, $LatedeductAmount, $OutLatedeductTime, $LatedeductTime, $NumberofTimsheet);

        return $Siteholidaypayment;
    }

    public function EPFCalculations($BasicSalary, $PoyadayPayment, $MercantilePayment, $SundayPayment) {

        $BasicSalaryForEPF = $BasicSalary - ($PoyadayPayment[1] + $MercantilePayment[1] + $SundayPayment[1]);
        $EPF = $BasicSalaryForEPF * (8 / 100);
        return $EPF;
    }

    public function EPFByCompany($BasicSalary, $PoyadayPayment, $MercantilePayment, $SundayPayment) {

        $BasicSalaryForEPF = $BasicSalary - ($PoyadayPayment[1] + $MercantilePayment[1] + $SundayPayment[1]);
        $EPFByCompany = $BasicSalaryForEPF * (12 / 100);
        return $EPFByCompany;
    }

    public function ETFByCompany($BasicSalary, $PoyadayPayment, $MercantilePayment, $SundayPayment) {

        $BasicSalaryForETF = $BasicSalary - ($PoyadayPayment[1] + $MercantilePayment[1] + $SundayPayment[1]);
        $ETFByCompany = $BasicSalaryForETF * (3 / 100);
        return $ETFByCompany;
    }

    public function GetMonthlyPayrollSheet($payrollid) {
        $PayrollSheet = PayrollItems::model()->findAllByAttributes(array('Payroll_id' => $payrollid));
        return $PayrollSheet;
    }

    function GetSpecificDayBetweenDates($startDate, $endDate, $weekdayNumber) {
        $StartDate = strtotime($startDate);
        $EndDate = strtotime($endDate);

        $dateArr = array();

        do {
            if (date("w", $StartDate) != $weekdayNumber) {
                $StartDate += (24 * 3600); // add 1 day
            }
        } while (date("w", $StartDate) != $weekdayNumber);

        while ($StartDate <= $EndDate) {
            $dateArr[] = date('Y-m-d', $StartDate);
            $StartDate += (7 * 24 * 3600); // add 7 days
        }

        return($dateArr);
    }

    public function EPFCalculationsInMonthly($employeeid, $PoyadayPayment, $MercantilePayment, $SundayPayment) {

        $employeesalary = Employeesalary::model()->findByAttributes(array('employeeid' => $employeeid, 'Status' => 1));
        $BasicSalaryForEPF = $employeesalary->monthsalary;

        $EPF = $BasicSalaryForEPF * (8 / 100);
        return $EPF;
    }

    public function EPFByCompanyInMonthly($employeeid, $PoyadayPayment, $MercantilePayment, $SundayPayment) {

        $employeesalary = Employeesalary::model()->findByAttributes(array('employeeid' => $employeeid, 'Status' => 1));
        $BasicSalaryForEPF = $employeesalary->monthsalary;

        $EPFByCompany = $BasicSalaryForEPF * (12 / 100);
        return $EPFByCompany;
    }

    public function ETFByCompanyInMonthly($employeeid, $PoyadayPayment, $MercantilePayment, $SundayPayment) {

        $employeesalary = Employeesalary::model()->findByAttributes(array('employeeid' => $employeeid, 'Status' => 1));
        $BasicSalaryForEPF = $employeesalary->monthsalary;

        $ETFByCompany = $BasicSalaryForEPF * (3 / 100);
        return $ETFByCompany;
    }

    public function DailyPayrollReCalculation($Payrollid, $StartDate, $EndDate) {

        $paymentmethod = "DAILY";

        if (Yii::app()->user->data()->superuser == 1) {

            PayrollItems::model()->deleteAllByAttributes(array('Payroll_id' => $Payrollid));

            $sql = " SELECT 
            COUNT(timesheet.id) AS NoOftimesheet,
            SUM(timesheet.SallaryRate) AS BasicSalary,
            SUM(timesheet.NOvertimeSalary) AS NOTAmout,
            SUM(timesheet.Dovertimesalary) AS DOTAmount,
            SUM(timesheet.Tovertimesalary) AS TOTAmount,
            SUM(timesheet.NOvertimeHours) AS NOTHour,
            SUM(timesheet.DOverTimeHour) AS DOTHour,
            SUM(timesheet.TOverTimeHour) AS TOTHour,
            SUM(timesheet.LatedeductTime) AS LatedeductTime,
            SUM(timesheet.LatedeductAmount) AS LatedeductAmount,
            SUM(timesheet.OutLateDeductTime) AS EarlyOutLatedeductTime,
            SUM(timesheet.OutLateDeductAmount) AS EarlyOutLatedeductAmount,
            employee.designationid AS Designationid,
            designation.type,
            employee.id AS Empid,
            employee.Namewithini,
            employee.nic,
            employee.Accountid,
            employee.departmentid,
            employee.supplierid,
            paymentmethod.type AS paymentmethod ,
            sites.name AS SiteName,
            supplier.name AS SupplierName,
            accounts.name As AccountName

            FROM timesheet
            INNER JOIN employee ON timesheet.EmployeeId = employee.id
            INNER JOIN designation ON employee.designationid = designation.id
            INNER JOIN paymentmethod ON employee.paymentmethodid =paymentmethod.id
            INNER JOIN sites ON employee.siteid = sites.id
            INNER JOIN supplier ON employee.supplierid = supplier.id
            INNER JOIN accounts ON employee.Accountid = accounts.id
            
            WHERE timesheet.date >='" . $StartDate . "'  AND timesheet.date <='" . $EndDate . "' AND timesheet.PaymentMethod = '" . $paymentmethod . "' AND timesheet.Intime != '0000-00-00 00:00:00' AND timesheet.OuteTime != '0000-00-00 00:00:00'
            GROUP BY employee.nic 
            ORDER BY employee.Accountid ASC ";

            $rowdata = Yii::app()->db->createCommand($sql)->queryAll();

            if (!empty($rowdata)) {

                foreach ($rowdata as $Rowdata) {
                    $PayrollItems = new PayrollItems;
                    $employeeid = $Rowdata['Empid'];

                    $sql1 = " SELECT 
                                 COUNT(timesheet.id) AS NumOfWorkday,
                                 employee.id AS Empid,
                                 employee.nic
                                 FROM timesheet
                                 INNER JOIN employee ON timesheet.EmployeeId = employee.id
                                 WHERE timesheet.date >='" . $StartDate . "'  AND timesheet.date <='" . $EndDate . "' AND timesheet.PaymentMethod ='DAILY' AND timesheet.EmployeeId='" . $employeeid . "' AND timesheet.DayName='WEEKDAY' AND timesheet.Intime != '0000-00-00 00:00:00' AND timesheet.OuteTime != '0000-00-00 00:00:00'
                                 GROUP BY employee.nic";
                    $Data = Yii::app()->db->createCommand($sql1)->queryAll();

                    $PayrollItems->Payroll_id = $Payrollid;
                    $PayrollItems->EmployeeName = $Rowdata['Namewithini'];
                    $PayrollItems->NIC = $Rowdata['nic'];
                    $PayrollItems->JobTitle = $Rowdata['type'];
                    $PayrollItems->Designationid = $Rowdata['Designationid'];
                    $PayrollItems->RateType = $Rowdata['paymentmethod'];
                    $PayrollItems->MPSuplier = $Rowdata['SupplierName'];
                    $PayrollItems->Site = $Rowdata['SiteName'];
                    $PayrollItems->Account = $Rowdata['AccountName'];
                    $PayrollItems->WorkDay = empty($Data) ? 0 : $Data[0]['NumOfWorkday'];
                    $PayrollItems->Accountid = $Rowdata['Accountid'];
                    $PayrollItems->MPSupplierid = $Rowdata['supplierid'];
                    $PayrollItems->Departmentid = $Rowdata['departmentid'];

                    $PoyadayPayment = Yii::app()->MonthlyPayrollCalculationUtil->PoyadayPayment($StartDate, $EndDate, $Rowdata['nic']);
                    $poyadayoutdeduct = $PoyadayPayment[5];
                    $poyadayearlydeduct = $PoyadayPayment[6];
                    $AllDeductInPoyaDay = $PoyadayPayment[5] + $PoyadayPayment[6];
                    $PoyaDayAmount = $PoyadayPayment[1] - $AllDeductInPoyaDay;
                    $PayrollItems->PoyadayPayment = $PoyaDayAmount > 0 ? $PoyaDayAmount : 0;

                    $MercantilePayment = Yii::app()->MonthlyPayrollCalculationUtil->MercantilePayment($StartDate, $EndDate, $Rowdata['nic']);
                    $marcantiloutdeduct = $MercantilePayment[5];
                    $marcantilearlydeduct = $MercantilePayment[6];
                    $AllDeductInmarcday = $MercantilePayment[5] + $MercantilePayment[6];
                    $MercantileDayAmount = $MercantilePayment[1] - $AllDeductInmarcday;
                    $PayrollItems->MercantilePayment = $MercantileDayAmount > 0 ? $MercantileDayAmount : 0;

                    $SundayPayment = Yii::app()->MonthlyPayrollCalculationUtil->SundayPayment($StartDate, $EndDate, $Rowdata['nic']);
                    $sundayoutdeduct = $SundayPayment[5];
                    $sundayearlydeduct = $SundayPayment[6];
                    $AllDeductInSunday = $SundayPayment[5] + $SundayPayment[6];
                    $SundayAmount = $SundayPayment[1] - $AllDeductInSunday;
                    $PayrollItems->SundayPayment = $SundayAmount > 0 ? $SundayAmount : 0;

                    //$SiteHolidayPayment = Yii::app()->MonthlyPayrollCalculationUtil->SiteHolidaydayPayment($StartDate, $EndDate, $Rowdata['nic'],$SiteId);
                    $siteholidayoutdeduct = 0;
                    $siteholidayearlydeduct = 0;
                    $AllDeductInSiteholiday = 0;
                    $SiteHolidayAmount = 0;
                    $PayrollItems->SiteHolidayAmount = $SiteHolidayAmount;

                    $AllHolidayElyded = $poyadayearlydeduct + $marcantilearlydeduct + $sundayearlydeduct + $siteholidayearlydeduct;
                    $AllHolidayoutyded = $poyadayoutdeduct + $marcantiloutdeduct + $sundayoutdeduct + $siteholidayoutdeduct;

                    $PayrollItems->DayOfSundayP = 0;
                    //already late deduct in Timesheet allso again deduct in payroll therefor add deduct to basic
                    $PayrollItems->BasicWage = $Rowdata['BasicSalary'] - ($PoyadayPayment[1] + $MercantilePayment[1] + $SundayPayment[1] + $SiteHolidayAmount);

                    $PayrollItems->LateDeductTime = $Rowdata['LatedeductTime'];
                    $WeekdaysdayElydeduct = $Rowdata['LatedeductAmount'] - $AllHolidayElyded;
                    $PayrollItems->LateDeductAmount = $WeekdaysdayElydeduct;

                    $Weekdaysdayoutdeduct = $Rowdata['EarlyOutLatedeductAmount'] - $AllHolidayoutyded;
                    $PayrollItems->EarlyOutDeductAmount = $Weekdaysdayoutdeduct;

                    $Amount = $PayrollItems->BasicWage - ($WeekdaysdayElydeduct + $Weekdaysdayoutdeduct);
                    $AmountforEpf = $Amount > 0 ? $Amount : 0;
                    $PayrollItems->TotalForEPF = $AmountforEpf;

                    $PayrollItems->NOT = $Rowdata['NOTAmout'];
                    $PayrollItems->DOT = $Rowdata['DOTAmount'];
                    $PayrollItems->TOT = $Rowdata['TOTAmount'];
                    $PayrollItems->NOTHour = $Rowdata['NOTHour'];
                    $PayrollItems->DOTHour = $Rowdata['DOTHour'];
                    $PayrollItems->TOTHour = $Rowdata['TOTHour'];
                    $PayrollItems->Bonus = 0;
                    $PayrollItems->Allowance = 0;
                    $PayrollItems->Insentive = 0;
                    $PayrollItems->PAllowance = 0;
                    $PayrollItems->VAllowance = 0;
                    $PayrollItems->Arrears = 0;

                    //$EPF = Yii::app()->MonthlyPayrollCalculationUtil->EPFCalculations($Rowdata['BasicSalary'], $PoyadayPayment, $MercantilePayment, $SundayPayment);
                    // $PayrollItems->EPF = $EPF;

                    $TotalGross = $AmountforEpf + $Rowdata['NOTAmout'] + $Rowdata['DOTAmount'] + $Rowdata['TOTAmount'] + $PayrollItems->PoyadayPayment + $PayrollItems->MercantilePayment + $PayrollItems->SundayPayment + $PayrollItems->SiteHolidayAmount;
                    $PayrollItems->TotalGross = $TotalGross;

                    $PayrollItems->Deduction = 0;
                    $PayrollItems->Deduction2 = 0;
                    $PayrollItems->Deduction3 = 0;

                    $PayrollItems->TotalNet = $TotalGross;

                    $EPFByCompany = (12 / 100) * $AmountforEpf;
                    //Yii::app()->MonthlyPayrollCalculationUtil->EPFByCompany($Rowdata['BasicSalary'], $PoyadayPayment, $MercantilePayment, $SundayPayment);
                    $PayrollItems->EPFByCompany = $EPFByCompany;

                    $ETFByCompany = (3 / 100) * $AmountforEpf;
                    //Yii::app()->MonthlyPayrollCalculationUtil->ETFByCompany($Rowdata['BasicSalary'], $PoyadayPayment, $MercantilePayment, $SundayPayment);
                    $PayrollItems->ETFByCompany = $ETFByCompany;

                    $Contractfee = Employeecontractfee::model()->findByAttributes(array('employeeid' => $employeeid, 'status' => 1));
                    $contractfeevalue = $Contractfee != null ? $Contractfee->contractfee : 0;
                    $PayrollItems->ContractorFee = ($contractfeevalue / 100) * $AmountforEpf;

                    $ConF = $PayrollItems->ContractorFee;
                    $CostOfCompany = $PayrollItems->TotalNet + $EPFByCompany + $ETFByCompany + $ConF;
                    $PayrollItems->CostOfCompany = $CostOfCompany;

                    $PayrollItems->TotalAddition = 0;
                    $PayrollItems->TotalDeduction = 0;

                    $PayrollItems->save();

                    // $payroll = CJSON::encode($contractfeevalue);
                    //  echo $payroll;
                    //  die;
                }
                $GetPayrollShSheet = Yii::app()->MonthlyPayrollCalculationUtil->GetMonthlyPayrollSheet($Payrollid);
                $payroll = CJSON::encode($GetPayrollShSheet);
                echo $payroll;
            }
        } else {
            $SiteId = Yii::app()->user->data()->SiteId;

            PayrollItems::model()->deleteAllByAttributes(array('Payroll_id' => $Payrollid));

            $sql = " SELECT 
            COUNT(timesheet.id) AS NoOftimesheet,
            SUM(timesheet.SallaryRate) AS BasicSalary,
            SUM(timesheet.NOvertimeSalary) AS NOTAmout,
            SUM(timesheet.Dovertimesalary) AS DOTAmount,
            SUM(timesheet.Tovertimesalary) AS TOTAmount,
            SUM(timesheet.NOvertimeHours) AS NOTHour,
            SUM(timesheet.DOverTimeHour) AS DOTHour,
            SUM(timesheet.TOverTimeHour) AS TOTHour,
            SUM(timesheet.LatedeductTime) AS LatedeductTime,
            SUM(timesheet.LatedeductAmount) AS LatedeductAmount,
            SUM(timesheet.OutLateDeductTime) AS EarlyOutLatedeductTime,
            SUM(timesheet.OutLateDeductAmount) AS EarlyOutLatedeductAmount,
            employee.designationid AS Designationid,
            designation.type,
            employee.id AS Empid,
            employee.Namewithini,
            employee.nic,
            employee.Accountid,
            employee.departmentid,
            employee.supplierid,
            paymentmethod.type AS paymentmethod,
            sites.name AS SiteName,
            supplier.name AS SupplierName,
            accounts.name As AccountName

            FROM timesheet
            INNER JOIN employee ON timesheet.EmployeeId = employee.id
            INNER JOIN designation ON employee.designationid = designation.id
            INNER JOIN paymentmethod ON employee.paymentmethodid =paymentmethod.id
            INNER JOIN sites ON employee.siteid = sites.id
            INNER JOIN supplier ON employee.supplierid = supplier.id
            INNER JOIN accounts ON employee.Accountid = accounts.id

             WHERE timesheet.date >='" . $StartDate . "'  AND timesheet.date <='" . $EndDate . "' AND timesheet.SiteId ='" . $SiteId . "' AND timesheet.PaymentMethod = '" . $paymentmethod . "' AND timesheet.Intime != '0000-00-00 00:00:00' AND timesheet.OuteTime != '0000-00-00 00:00:00'
            GROUP BY employee.nic 
            ORDER BY employee.Accountid ASC ";

            $rowdata = Yii::app()->db->createCommand($sql)->queryAll();

            if (!empty($rowdata)) {

                foreach ($rowdata as $Rowdata) {
                    $PayrollItems = new PayrollItems;
                    $employeeid = $Rowdata['Empid'];
                    $sql1 = " SELECT 
                              COUNT(timesheet.id) AS NumOfWorkday,
                              employee.id AS Empid,
                              employee.nic
        
                              FROM timesheet
                              INNER JOIN employee ON timesheet.EmployeeId = employee.id
                              WHERE timesheet.date >='" . $StartDate . "'  AND timesheet.date <='" . $EndDate . "' AND timesheet.PaymentMethod ='DAILY' AND timesheet.EmployeeId='" . $employeeid . "' AND timesheet.DayName='WEEKDAY' AND timesheet.Intime != '0000-00-00 00:00:00' AND timesheet.OuteTime != '0000-00-00 00:00:00'
                              GROUP BY employee.nic";
                    $Data = Yii::app()->db->createCommand($sql1)->queryAll();

                    $PayrollItems->Payroll_id = $Payrollid;
                    $PayrollItems->EmployeeName = $Rowdata['Namewithini'];
                    $PayrollItems->NIC = $Rowdata['nic'];
                    $PayrollItems->JobTitle = $Rowdata['type'];
                    $PayrollItems->Designationid = $Rowdata['Designationid'];
                    $PayrollItems->RateType = $Rowdata['paymentmethod'];
                    $PayrollItems->MPSuplier = $Rowdata['SupplierName'];
                    $PayrollItems->Site = $Rowdata['SiteName'];
                    $PayrollItems->Account = $Rowdata['AccountName'];
                    $PayrollItems->WorkDay = empty($Data) ? 0 : $Data[0]['NumOfWorkday'];
                    $PayrollItems->Accountid = $Rowdata['Accountid'];
                    $PayrollItems->MPSupplierid = $Rowdata['supplierid'];
                    $PayrollItems->Departmentid = $Rowdata['departmentid'];

                    $PoyadayPayment = Yii::app()->MonthlyPayrollCalculationUtil->PoyadayPayment($StartDate, $EndDate, $Rowdata['nic']);
                    $poyadayoutdeduct = $PoyadayPayment[5];
                    $poyadayearlydeduct = $PoyadayPayment[6];
                    $AllDeductInPoyaDay = $PoyadayPayment[5] + $PoyadayPayment[6];
                    $PoyaDayAmount = $PoyadayPayment[1] - $AllDeductInPoyaDay;
                    $PayrollItems->PoyadayPayment = $PoyaDayAmount > 0 ? $PoyaDayAmount : 0;

                    $MercantilePayment = Yii::app()->MonthlyPayrollCalculationUtil->MercantilePayment($StartDate, $EndDate, $Rowdata['nic']);
                    $marcantiloutdeduct = $MercantilePayment[5];
                    $marcantilearlydeduct = $MercantilePayment[6];
                    $AllDeductInmarcday = $MercantilePayment[5] + $MercantilePayment[6];
                    $MercantileDayAmount = $MercantilePayment[1] - $AllDeductInmarcday;
                    $PayrollItems->MercantilePayment = $MercantileDayAmount > 0 ? $MercantileDayAmount : 0;

                    $SundayPayment = Yii::app()->MonthlyPayrollCalculationUtil->SundayPayment($StartDate, $EndDate, $Rowdata['nic']);
                    $sundayoutdeduct = $SundayPayment[5];
                    $sundayearlydeduct = $SundayPayment[6];
                    $AllDeductInSunday = $SundayPayment[5] + $SundayPayment[6];
                    $SundayAmount = $SundayPayment[1] - $AllDeductInSunday;
                    $PayrollItems->SundayPayment = $SundayAmount > 0 ? $SundayAmount : 0;

                    $SiteHolidayPayment = Yii::app()->MonthlyPayrollCalculationUtil->SiteHolidaydayPayment($StartDate, $EndDate, $Rowdata['nic'], $SiteId);
                    $siteholidayoutdeduct = $SiteHolidayPayment[5];
                    $siteholidayearlydeduct = $SiteHolidayPayment[6];
                    $AllDeductInSiteholiday = $SiteHolidayPayment[5] + $SiteHolidayPayment[6];
                    $SiteHolidayAmount = $SiteHolidayPayment[1] - $AllDeductInSiteholiday;
                    $PayrollItems->SiteHolidayAmount = $SiteHolidayAmount > 0 ? $SiteHolidayAmount : 0;

                    $AllHolidayElyded = $poyadayearlydeduct + $marcantilearlydeduct + $sundayearlydeduct + $siteholidayearlydeduct;
                    $AllHolidayoutyded = $poyadayoutdeduct + $marcantiloutdeduct + $sundayoutdeduct + $siteholidayoutdeduct;

                    $PayrollItems->DayOfSundayP = 0;
                    //already late deduct in Timesheet allso again deduct in payroll therefor add deduct to basic
                    $PayrollItems->BasicWage = $Rowdata['BasicSalary'] - ($PoyadayPayment[1] + $MercantilePayment[1] + $SundayPayment[1] + $SiteHolidayAmount);

                    $PayrollItems->LateDeductTime = $Rowdata['LatedeductTime'];
                    $WeekdaysdayElydeduct = $Rowdata['LatedeductAmount'] - $AllHolidayElyded;
                    $PayrollItems->LateDeductAmount = $WeekdaysdayElydeduct;

                    $Weekdaysdayoutdeduct = $Rowdata['EarlyOutLatedeductAmount'] - $AllHolidayoutyded;
                    $PayrollItems->EarlyOutDeductAmount = $Weekdaysdayoutdeduct;

                    $Amount = $PayrollItems->BasicWage - ($WeekdaysdayElydeduct + $Weekdaysdayoutdeduct);
                    $AmountforEpf = $Amount > 0 ? $Amount : 0;
                    $PayrollItems->TotalForEPF = $AmountforEpf;

                    $PayrollItems->NOT = $Rowdata['NOTAmout'];
                    $PayrollItems->DOT = $Rowdata['DOTAmount'];
                    $PayrollItems->TOT = $Rowdata['TOTAmount'];
                    $PayrollItems->NOTHour = $Rowdata['NOTHour'];
                    $PayrollItems->DOTHour = $Rowdata['DOTHour'];
                    $PayrollItems->TOTHour = $Rowdata['TOTHour'];
                    $PayrollItems->Bonus = 0;
                    $PayrollItems->Allowance = 0;
                    $PayrollItems->Insentive = 0;
                    $PayrollItems->PAllowance = 0;
                    $PayrollItems->VAllowance = 0;
                    $PayrollItems->Arrears = 0;

                    //$EPF = Yii::app()->MonthlyPayrollCalculationUtil->EPFCalculations($Rowdata['BasicSalary'], $PoyadayPayment, $MercantilePayment, $SundayPayment);
                    // $PayrollItems->EPF = $EPF;

                    $TotalGross = $AmountforEpf + $Rowdata['NOTAmout'] + $Rowdata['DOTAmount'] + $Rowdata['TOTAmount'] + $PayrollItems->PoyadayPayment + $PayrollItems->MercantilePayment + $PayrollItems->SundayPayment + $PayrollItems->SiteHolidayAmount;
                    $PayrollItems->TotalGross = $TotalGross;

                    $PayrollItems->Deduction = 0;
                    $PayrollItems->Deduction2 = 0;
                    $PayrollItems->Deduction3 = 0;

                    $PayrollItems->TotalNet = $TotalGross;

                    $EPFByCompany = (12 / 100) * $AmountforEpf;
                    //Yii::app()->MonthlyPayrollCalculationUtil->EPFByCompany($Rowdata['BasicSalary'], $PoyadayPayment, $MercantilePayment, $SundayPayment);
                    $PayrollItems->EPFByCompany = $EPFByCompany;

                    $ETFByCompany = (3 / 100) * $AmountforEpf;
                    //Yii::app()->MonthlyPayrollCalculationUtil->ETFByCompany($Rowdata['BasicSalary'], $PoyadayPayment, $MercantilePayment, $SundayPayment);
                    $PayrollItems->ETFByCompany = $ETFByCompany;

                    $Contractfee = Employeecontractfee::model()->findByAttributes(array('employeeid' => $employeeid, 'status' => 1));
                    $contractfeevalue = $Contractfee != null ? $Contractfee->contractfee : 0;
                    $PayrollItems->ContractorFee = ($contractfeevalue / 100) * $AmountforEpf;

                    $ConF = $PayrollItems->ContractorFee;
                    $CostOfCompany = $PayrollItems->TotalNet + $EPFByCompany + $ETFByCompany + $ConF;
                    $PayrollItems->CostOfCompany = $CostOfCompany;

                    $PayrollItems->TotalAddition = 0;
                    $PayrollItems->TotalDeduction = 0;

                    $PayrollItems->save();
                    // $payroll = CJSON::encode($contractfeevalue);
                    //  echo $payroll;
                    //  die;
                }
                $GetPayrollShSheet = Yii::app()->MonthlyPayrollCalculationUtil->GetMonthlyPayrollSheet($Payrollid);
                $payroll = CJSON::encode($GetPayrollShSheet);
                echo $payroll;
            }
        }
    }

    public function MonthlyPayrollReCalculation($Payrollid, $StartDate, $EndDate) {

        $paymentmethod = "MONTHLY";

        if (Yii::app()->user->data()->superuser == 1) {

            PayrollItems::model()->deleteAllByAttributes(array('Payroll_id' => $Payrollid));

            $sql = " SELECT 
            COUNT(timesheet.id) AS NoOftimesheet,
            SUM(timesheet.SallaryRate) AS BasicSalary,
            SUM(timesheet.NOvertimeSalary) AS NOTAmout,
            SUM(timesheet.Dovertimesalary) AS DOTAmount,
            SUM(timesheet.Tovertimesalary) AS TOTAmount,
            SUM(timesheet.NOvertimeHours) AS NOTHour,
            SUM(timesheet.DOverTimeHour) AS DOTHour,
            SUM(timesheet.TOverTimeHour) AS TOTHour,
            SUM(timesheet.LatedeductTime) AS LatedeductTime,
            SUM(timesheet.LatedeductAmount) AS LatedeductAmount,
            SUM(timesheet.OutLateDeductTime) AS EarlyOutLatedeductTime,
            SUM(timesheet.OutLateDeductAmount) AS EarlyOutLatedeductAmount,
            employee.designationid AS Designationid,
            designation.type,
            employee.id AS Empid,
            employee.Namewithini,
            employee.nic,
            employee.Accountid,
            employee.departmentid,
            employee.supplierid,
            paymentmethod.type AS paymentmethod ,
            sites.name AS SiteName,
            supplier.name AS SupplierName,
            accounts.name As AccountName

            FROM timesheet
            INNER JOIN employee ON timesheet.EmployeeId = employee.id
            INNER JOIN designation ON employee.designationid = designation.id
            INNER JOIN paymentmethod ON employee.paymentmethodid =paymentmethod.id
            INNER JOIN sites ON employee.siteid = sites.id
            INNER JOIN supplier ON employee.supplierid = supplier.id
            INNER JOIN accounts ON employee.Accountid = accounts.id

            WHERE timesheet.date >='" . $StartDate . "'  AND timesheet.date <='" . $EndDate . "' AND timesheet.PaymentMethod = '" . $paymentmethod . "' AND timesheet.Intime != '0000-00-00 00:00:00' AND timesheet.OuteTime != '0000-00-00 00:00:00'
            GROUP BY employee.nic
            ORDER BY employee.Accountid ASC ";

            $rowdata = Yii::app()->db->createCommand($sql)->queryAll();

            if (!empty($rowdata)) {

                foreach ($rowdata as $Rowdata) {
                    $PayrollItems = new PayrollItems;
                    $employeeid = $Rowdata['Empid'];

                    $sql1 = " SELECT 
                              COUNT(timesheet.id) AS NumOfWorkday,
                              employee.id AS Empid,
                              employee.nic
        
                              FROM timesheet
                              INNER JOIN employee ON timesheet.EmployeeId = employee.id
                              WHERE timesheet.date >='" . $StartDate . "'  AND timesheet.date <='" . $EndDate . "' AND timesheet.PaymentMethod ='MONTHLY' AND timesheet.EmployeeId='" . $employeeid . "' AND timesheet.DayName='WEEKDAY' AND timesheet.Intime != '0000-00-00 00:00:00' AND timesheet.OuteTime != '0000-00-00 00:00:00'
                              GROUP BY employee.nic";
                    $Data = Yii::app()->db->createCommand($sql1)->queryAll();

                    $PayrollItems->Payroll_id = $Payrollid;
                    $PayrollItems->EmployeeName = $Rowdata['Namewithini'];
                    $PayrollItems->NIC = $Rowdata['nic'];
                    $PayrollItems->JobTitle = $Rowdata['type'];
                    $PayrollItems->Designationid = $Rowdata['Designationid'];
                    $PayrollItems->RateType = $Rowdata['paymentmethod'];
                    $PayrollItems->MPSuplier = $Rowdata['SupplierName'];
                    $PayrollItems->Site = $Rowdata['SiteName'];
                    $PayrollItems->Account = $Rowdata['AccountName'];
                    $PayrollItems->WorkDay = empty($Data) ? 0 : $Data[0]['NumOfWorkday'];
                    $PayrollItems->Accountid = $Rowdata['Accountid'];
                    $PayrollItems->MPSupplierid = $Rowdata['supplierid'];
                    $PayrollItems->Departmentid = $Rowdata['departmentid'];

                    $PoyadayPayment = Yii::app()->MonthlyPayrollCalculationUtil->PoyadayPayment($StartDate, $EndDate, $Rowdata['nic']);
                    $poyadayoutdeduct = $PoyadayPayment[5];
                    $poyadayearlydeduct = $PoyadayPayment[6];
                    $AllDeductInPoyaDay = $PoyadayPayment[5] + $PoyadayPayment[6];
                    $PoyaDayAmount = $PoyadayPayment[1] - $AllDeductInPoyaDay;
                    $PayrollItems->PoyadayPayment = $PoyaDayAmount > 0 ? $PoyaDayAmount : 0;

                    $MercantilePayment = Yii::app()->MonthlyPayrollCalculationUtil->MercantilePayment($StartDate, $EndDate, $Rowdata['nic']);
                    $marcantiloutdeduct = $MercantilePayment[5];
                    $marcantilearlydeduct = $MercantilePayment[6];
                    $AllDeductInmarcday = $MercantilePayment[5] + $MercantilePayment[6];
                    $MercantileDayAmount = $MercantilePayment[1] - $AllDeductInmarcday;
                    $PayrollItems->MercantilePayment = $MercantileDayAmount > 0 ? $MercantileDayAmount : 0;

                    $SundayPayment = Yii::app()->MonthlyPayrollCalculationUtil->SundayPayment($StartDate, $EndDate, $Rowdata['nic']);
                    $sundayoutdeduct = $SundayPayment[5];
                    $sundayearlydeduct = $SundayPayment[6];
                    $AllDeductInSunday = $SundayPayment[5] + $SundayPayment[6];
                    $SundayAmount = $SundayPayment[1] - $AllDeductInSunday;
                    $PayrollItems->SundayPayment = $SundayAmount > 0 ? $SundayAmount : 0;

                    // $SiteHolidayPayment = Yii::app()->MonthlyPayrollCalculationUtil->SiteHolidaydayPayment($StartDate, $EndDate, $Rowdata['nic'],$SiteId);
                    $siteholidayoutdeduct = 0;
                    $siteholidayearlydeduct = 0;
                    $AllDeductInSiteholiday = 0;
                    $SiteHolidayAmount = 0;
                    $PayrollItems->SiteHolidayAmount = $SiteHolidayAmount;

                    $AllHolidayElyded = $poyadayearlydeduct + $marcantilearlydeduct + $sundayearlydeduct + $siteholidayearlydeduct;
                    $AllHolidayoutyded = $poyadayoutdeduct + $marcantiloutdeduct + $sundayoutdeduct + $siteholidayoutdeduct;

                    $WeekdaysdayElydeduct = $Rowdata['LatedeductAmount'] - $AllHolidayElyded;
                    $PayrollItems->LateDeductTime = $Rowdata['LatedeductTime'];
                    //not mach with late deduct amount with time
                    $PayrollItems->LateDeductAmount = $WeekdaysdayElydeduct;

                    $Weekdaysdayoutdeduct = $Rowdata['EarlyOutLatedeductAmount'] - $AllHolidayoutyded;
                    $PayrollItems->EarlyOutDeductAmount = $Weekdaysdayoutdeduct;

                    $PayrollItems->DayOfSundayP = 0;

                    $Basicwage = Yii::app()->MonthlyPayrollCalculationUtil->CalculateBasicforMonthlyPayment($StartDate, $EndDate, $employeeid);
                    $PayrollItems->BasicWage = $Basicwage >= 0 ? $Basicwage : 0;

                    $Amount = $PayrollItems->BasicWage - ($WeekdaysdayElydeduct + $Weekdaysdayoutdeduct);
                    $AmountforEpf = $Amount > 0 ? $Amount : 0;
                    $PayrollItems->TotalForEPF = $AmountforEpf;

                    $PayrollItems->NOT = $Rowdata['NOTAmout'];
                    $PayrollItems->DOT = $Rowdata['DOTAmount'];
                    $PayrollItems->TOT = $Rowdata['TOTAmount'];
                    $PayrollItems->NOTHour = $Rowdata['NOTHour'];
                    $PayrollItems->DOTHour = $Rowdata['DOTHour'];
                    $PayrollItems->TOTHour = $Rowdata['TOTHour'];
                    $PayrollItems->Bonus = 0;
                    $PayrollItems->Allowance = 0;
                    $PayrollItems->Insentive = 0;
                    $PayrollItems->PAllowance = 0;
                    $PayrollItems->VAllowance = 0;
                    $PayrollItems->Arrears = 0;

                    //$EPF = Yii::app()->MonthlyPayrollCalculationUtil->EPFCalculationsInMonthly($employeeid, $PoyadayPayment, $MercantilePayment, $SundayPayment);
                    //$PayrollItems->EPF = $EPF;

                    $TotalGross = $AmountforEpf + $PayrollItems->PoyadayPayment + $PayrollItems->MercantilePayment + $PayrollItems->SundayPayment + $PayrollItems->SiteHolidayAmount + $Rowdata['NOTAmout'] + $Rowdata['DOTAmount'] + $Rowdata['TOTAmount'];
                    $PayrollItems->TotalGross = $TotalGross;

                    $PayrollItems->Deduction = 0;
                    $PayrollItems->Deduction2 = 0;
                    $PayrollItems->Deduction3 = 0;
                    $PayrollItems->TotalNet = $TotalGross;

                    $EPFByCompany = (12 / 100) * $AmountforEpf;
                    //Yii::app()->MonthlyPayrollCalculationUtil->EPFByCompany($Rowdata['BasicSalary'], $PoyadayPayment, $MercantilePayment, $SundayPayment);
                    $PayrollItems->EPFByCompany = $EPFByCompany;

                    $ETFByCompany = (3 / 100) * $AmountforEpf;
                    //Yii::app()->MonthlyPayrollCalculationUtil->ETFByCompany($Rowdata['BasicSalary'], $PoyadayPayment, $MercantilePayment, $SundayPayment);
                    $PayrollItems->ETFByCompany = $ETFByCompany;

                    $Contractfee = Employeecontractfee::model()->findByAttributes(array('employeeid' => $employeeid, 'status' => 1));
                    $contractfeevalue = $Contractfee != null ? $Contractfee->contractfee : 0;
                    $PayrollItems->ContractorFee = ($contractfeevalue / 100) * $AmountforEpf;

                    $ConF = $PayrollItems->ContractorFee;
                    $CostOfCompany = $PayrollItems->TotalNet + $EPFByCompany + $ETFByCompany + $ConF;
                    $PayrollItems->CostOfCompany = $CostOfCompany;

                    $PayrollItems->TotalAddition = 0;
                    $PayrollItems->TotalDeduction = 0;

                    $PayrollItems->save();
                    // $payroll = CJSON::encode($contractfeevalue);
                    //  echo $payroll;
                    //  die;
                }
                $GetPayrollShSheet = Yii::app()->MonthlyPayrollCalculationUtil->GetMonthlyPayrollSheet($Payrollid);
                $payroll = CJSON::encode($GetPayrollShSheet);
                echo $payroll;
            }
        } else {
            //------Month Payroll for Site Wise------//    
            $SiteId = Yii::app()->user->data()->SiteId;

            PayrollItems::model()->deleteAllByAttributes(array('Payroll_id' => $Payrollid));

            $sql = " SELECT 
            COUNT(timesheet.id) AS NoOftimesheet,
            SUM(timesheet.SallaryRate) AS BasicSalary,
            SUM(timesheet.NOvertimeSalary) AS NOTAmout,
            SUM(timesheet.Dovertimesalary) AS DOTAmount,
            SUM(timesheet.Tovertimesalary) AS TOTAmount,
            SUM(timesheet.NOvertimeHours) AS NOTHour,
            SUM(timesheet.DOverTimeHour) AS DOTHour,
            SUM(timesheet.TOverTimeHour) AS TOTHour,
            SUM(timesheet.LatedeductTime) AS LatedeductTime,
            SUM(timesheet.LatedeductAmount) AS LatedeductAmount,
            SUM(timesheet.OutLateDeductTime) AS EarlyOutLatedeductTime,
            SUM(timesheet.OutLateDeductAmount) AS EarlyOutLatedeductAmount,
            employee.designationid AS Designationid,
            designation.type,
            employee.id AS Empid,
            employee.Namewithini,
            employee.nic,
            employee.Accountid,
            employee.departmentid,
            employee.supplierid,
            paymentmethod.type AS paymentmethod ,
            sites.name AS SiteName,
            supplier.name AS SupplierName,
            accounts.name As AccountName

            FROM timesheet
            INNER JOIN employee ON timesheet.EmployeeId = employee.id
            INNER JOIN designation ON employee.designationid = designation.id
            INNER JOIN paymentmethod ON employee.paymentmethodid =paymentmethod.id
            INNER JOIN sites ON employee.siteid = sites.id
            INNER JOIN supplier ON employee.supplierid = supplier.id
            INNER JOIN accounts ON employee.Accountid = accounts.id

            WHERE timesheet.date >='" . $StartDate . "'  AND timesheet.date <='" . $EndDate . "' AND timesheet.SiteId ='" . $SiteId . "' AND timesheet.PaymentMethod ='MONTHLY' AND timesheet.Intime != '0000-00-00 00:00:00' AND timesheet.OuteTime != '0000-00-00 00:00:00'
            GROUP BY employee.nic
            ORDER BY employee.Accountid ASC ";

            $rowdata = Yii::app()->db->createCommand($sql)->queryAll();

            if (!empty($rowdata)) {

                foreach ($rowdata as $Rowdata) {
                    $PayrollItems = new PayrollItems;
                    $employeeid = $Rowdata['Empid'];
                    $sql1 = " SELECT 
                              COUNT(timesheet.id) AS NumOfWorkday,
                              employee.id AS Empid,
                              employee.nic
        
                              FROM timesheet
                              INNER JOIN employee ON timesheet.EmployeeId = employee.id
                              WHERE timesheet.date >='" . $StartDate . "'  AND timesheet.date <='" . $EndDate . "' AND timesheet.PaymentMethod ='MONTHLY' AND timesheet.EmployeeId='" . $employeeid . "' AND timesheet.DayName='WEEKDAY' AND timesheet.Intime != '0000-00-00 00:00:00' AND timesheet.OuteTime != '0000-00-00 00:00:00'
                              GROUP BY employee.nic";
                    $Data = Yii::app()->db->createCommand($sql1)->queryAll();

                    $PayrollItems->Payroll_id = $Payrollid;
                    $PayrollItems->EmployeeName = $Rowdata['Namewithini'];
                    $PayrollItems->NIC = $Rowdata['nic'];
                    $PayrollItems->JobTitle = $Rowdata['type'];
                    $PayrollItems->Designationid = $Rowdata['Designationid'];
                    $PayrollItems->RateType = $Rowdata['paymentmethod'];
                    $PayrollItems->MPSuplier = $Rowdata['SupplierName'];
                    $PayrollItems->Site = $Rowdata['SiteName'];
                    $PayrollItems->Account = $Rowdata['AccountName'];
                    $PayrollItems->WorkDay = empty($Data) ? 0 : $Data[0]['NumOfWorkday'];
                    $PayrollItems->Accountid = $Rowdata['Accountid'];
                    $PayrollItems->MPSupplierid = $Rowdata['supplierid'];
                    $PayrollItems->Departmentid = $Rowdata['departmentid'];

                    $PoyadayPayment = Yii::app()->MonthlyPayrollCalculationUtil->PoyadayPayment($StartDate, $EndDate, $Rowdata['nic']);
                    $poyadayoutdeduct = $PoyadayPayment[5];
                    $poyadayearlydeduct = $PoyadayPayment[6];
                    $AllDeductInPoyaDay = $PoyadayPayment[5] + $PoyadayPayment[6];
                    $PoyaDayAmount = $PoyadayPayment[1] - $AllDeductInPoyaDay;
                    $PayrollItems->PoyadayPayment = $PoyaDayAmount > 0 ? $PoyaDayAmount : 0;

                    $MercantilePayment = Yii::app()->MonthlyPayrollCalculationUtil->MercantilePayment($StartDate, $EndDate, $Rowdata['nic']);
                    $marcantiloutdeduct = $MercantilePayment[5];
                    $marcantilearlydeduct = $MercantilePayment[6];
                    $AllDeductInmarcday = $MercantilePayment[5] + $MercantilePayment[6];
                    $MercantileDayAmount = $MercantilePayment[1] - $AllDeductInmarcday;
                    $PayrollItems->MercantilePayment = $MercantileDayAmount > 0 ? $MercantileDayAmount : 0;

                    $SundayPayment = Yii::app()->MonthlyPayrollCalculationUtil->SundayPayment($StartDate, $EndDate, $Rowdata['nic']);
                    $sundayoutdeduct = $SundayPayment[5];
                    $sundayearlydeduct = $SundayPayment[6];
                    $AllDeductInSunday = $SundayPayment[5] + $SundayPayment[6];
                    $SundayAmount = $SundayPayment[1] - $AllDeductInSunday;
                    $PayrollItems->SundayPayment = $SundayAmount > 0 ? $SundayAmount : 0;

                    $SiteHolidayPayment = Yii::app()->MonthlyPayrollCalculationUtil->SiteHolidaydayPayment($StartDate, $EndDate, $Rowdata['nic'], $SiteId);
                    $siteholidayoutdeduct = $SiteHolidayPayment[5];
                    $siteholidayearlydeduct = $SiteHolidayPayment[6];
                    $AllDeductInSiteholiday = $SiteHolidayPayment[5] + $SiteHolidayPayment[6];
                    $SiteHolidayAmount = $SiteHolidayPayment[1] - $AllDeductInSiteholiday;
                    $PayrollItems->SiteHolidayAmount = $SiteHolidayAmount > 0 ? $SiteHolidayAmount : 0;

                    $AllHolidayElyded = $poyadayearlydeduct + $marcantilearlydeduct + $sundayearlydeduct + $siteholidayearlydeduct;
                    $AllHolidayoutyded = $poyadayoutdeduct + $marcantiloutdeduct + $sundayoutdeduct + $siteholidayoutdeduct;

                    $WeekdaysdayElydeduct = $Rowdata['LatedeductAmount'] - $AllHolidayElyded;
                    $PayrollItems->LateDeductTime = $Rowdata['LatedeductTime'];
                    //not mach with late deduct amount with time
                    $PayrollItems->LateDeductAmount = $WeekdaysdayElydeduct;

                    $Weekdaysdayoutdeduct = $Rowdata['EarlyOutLatedeductAmount'] - $AllHolidayoutyded;
                    $PayrollItems->EarlyOutDeductAmount = $Weekdaysdayoutdeduct;

                    $PayrollItems->DayOfSundayP = 0;

                    $Basicwage = Yii::app()->MonthlyPayrollCalculationUtil->CalculateBasicforMonthlyPayment($StartDate, $EndDate, $employeeid, $SiteId);
                    $PayrollItems->BasicWage = $Basicwage >= 0 ? $Basicwage : 0;

                    $Amount = $PayrollItems->BasicWage - ($WeekdaysdayElydeduct + $Weekdaysdayoutdeduct);
                    $AmountforEpf = $Amount > 0 ? $Amount : 0;
                    $PayrollItems->TotalForEPF = $AmountforEpf;

                    $PayrollItems->NOT = $Rowdata['NOTAmout'];
                    $PayrollItems->DOT = $Rowdata['DOTAmount'];
                    $PayrollItems->TOT = $Rowdata['TOTAmount'];
                    $PayrollItems->NOTHour = $Rowdata['NOTHour'];
                    $PayrollItems->DOTHour = $Rowdata['DOTHour'];
                    $PayrollItems->TOTHour = $Rowdata['TOTHour'];
                    $PayrollItems->Bonus = 0;
                    $PayrollItems->Allowance = 0;
                    $PayrollItems->Insentive = 0;
                    $PayrollItems->PAllowance = 0;
                    $PayrollItems->VAllowance = 0;
                    $PayrollItems->Arrears = 0;

                    //$EPF = Yii::app()->MonthlyPayrollCalculationUtil->EPFCalculationsInMonthly($employeeid, $PoyadayPayment, $MercantilePayment, $SundayPayment);
                    //$PayrollItems->EPF = $EPF;

                    $TotalGross = $AmountforEpf + $PayrollItems->PoyadayPayment + $PayrollItems->MercantilePayment + $PayrollItems->SundayPayment + $PayrollItems->SiteHolidayAmount + $Rowdata['NOTAmout'] + $Rowdata['DOTAmount'] + $Rowdata['TOTAmount'];
                    $PayrollItems->TotalGross = $TotalGross;

                    $PayrollItems->Deduction = 0;
                    $PayrollItems->Deduction2 = 0;
                    $PayrollItems->Deduction3 = 0;

                    $PayrollItems->TotalNet = $TotalGross;

                    $EPFByCompany = (12 / 100) * $AmountforEpf;
                    //Yii::app()->MonthlyPayrollCalculationUtil->EPFByCompany($Rowdata['BasicSalary'], $PoyadayPayment, $MercantilePayment, $SundayPayment);
                    $PayrollItems->EPFByCompany = $EPFByCompany;

                    $ETFByCompany = (3 / 100) * $AmountforEpf;
                    //Yii::app()->MonthlyPayrollCalculationUtil->ETFByCompany($Rowdata['BasicSalary'], $PoyadayPayment, $MercantilePayment, $SundayPayment);
                    $PayrollItems->ETFByCompany = $ETFByCompany;

                    $Contractfee = Employeecontractfee::model()->findByAttributes(array('employeeid' => $employeeid, 'status' => 1));
                    $contractfeevalue = $Contractfee != null ? $Contractfee->contractfee : 0;
                    $PayrollItems->ContractorFee = ($contractfeevalue / 100) * $AmountforEpf;

                    $ConF = $PayrollItems->ContractorFee;
                    $CostOfCompany = $PayrollItems->TotalNet + $EPFByCompany + $ETFByCompany + $ConF;
                    $PayrollItems->CostOfCompany = $CostOfCompany;
                    $PayrollItems->TotalAddition = 0;
                    $PayrollItems->TotalDeduction = 0;

                    $PayrollItems->save();
                }
                $GetPayrollShSheet = Yii::app()->MonthlyPayrollCalculationUtil->GetMonthlyPayrollSheet($Payrollid);
                $payroll = CJSON::encode($GetPayrollShSheet);
                echo $payroll;
            }
        }
    }

    public function MonthlyPaymentForMaternityLeave($MaternityLeaveEmployees, $PayRoll_id, $StartDate, $EndDate, $SiteId) {

        foreach ($MaternityLeaveEmployees as $employee) {
            $PayrollItems = new PayrollItems;
            $employeeid = $employee['EmoloyeeId'];
            $Employee = Employee::model()->findByAttributes(array('id' => $employeeid));

            $JoiningDate = $StartDate;
            $JoiningDateNew = $StartDate;
            $EmployeeJoindate = EmployeeJoinDetails::model()->findByAttributes(array('employee_id' => $employeeid, 'site_id' => $SiteId, 'status' => 1));
            if (!empty($EmployeeJoindate)) {
                $JoiningDate = $EmployeeJoindate->join_date >= $StartDate ? $EmployeeJoindate->join_date : $StartDate;
                $JoiningDateNew = $EmployeeJoindate->join_date;
            }
            $ResignDate = $EndDate;
            $EmployeeResignDate = EmployeeResignDetails::model()->findByAttributes(array('employee_id' => $employeeid, 'site_id' => $SiteId, 'status' => 1));
            if (!empty($EmployeeResignDate)) {
                $ResignDate = $EmployeeResignDate->resign_date <= $EndDate ? $EmployeeResignDate->resign_date : $EndDate;
            }

            $employeesalary = Employeesalary::model()->findByAttributes(array('employeeid' => $employeeid, 'site_id' => $SiteId, 'Status' => 1));
            if (empty($employeesalary)) {
                $employeesalary = new Employeesalary;
                $employeesalary->monthsalary = 0;
                $employeesalary->DalySalary = 0;
                $employeesalary->HourlyRate = 0;
                $employeesalary->OTRate = 0;
                $employeesalary->DoubleOTRate = 0;
                $employeesalary->BasicSalary = 0;
                $employeesalary->BRA1 = 0;
                $employeesalary->BRA2 = 0;
                $employeesalary->BRA3 = 0;
            }
            $PayrollItems->Payroll_id = $PayRoll_id;
            $PayrollItems->EmployeeName = $Employee->Namewithini;
            $PayrollItems->NIC = $Employee->nic;
            $PayrollItems->JobTitle = $Employee->Designation->type;
            $PayrollItems->Designationid = $Employee->designationid;
            $PayrollItems->RateType = $Employee->paymentmethod->type;
            $PayrollItems->MPSuplier = $Employee->supplier->name;
            $PayrollItems->Site = $Employee->site->name;
            $PayrollItems->Account = $Employee->account->name;
            $PayrollItems->Accountid = $Employee->Accountid;
            $PayrollItems->MPSupplierid = $Employee->supplierid;
            $PayrollItems->Departmentid = $Employee->departmentid;
            $PayrollItems->DepartmentName = $Employee->department->name;
            $PayrollItems->PoyadayPayment = 0;
            $PayrollItems->MercantilePayment = 0;
            $PayrollItems->SiteHolidayAmount = 0;

            if ($Employee->Shift_mode == "ROSTER-BASE") {

                $PayrollItems->SundayPayment = 0;
                $PayrollItems->LateDeductTime = 0;
                $PayrollItems->LateDeductAmount = 0;
                $PayrollItems->EarlyOutDeductAmount = 0;

                $Basic = Yii::app()->MonthlyPayrollCalculationUtil->CalculateBasicforMonthlyPaymentRosterBase($StartDate, $EndDate, $employeeid, $SiteId, $JoiningDate, $ResignDate, $JoiningDateNew);
                $WorkedDays = $Basic[1] > 0 ? $Basic[1] : 0;
                $BasicWage = $Basic[0] >= 0 ? $Basic[0] : 0;

                $PayrollItems->NoPayDays = $noPayDays;  
                $PayrollItems->BasicWage = $BasicWage;
                $PayrollItems->WorkDay = $WorkedDays;
                $Amount = $PayrollItems->BasicWage;
                $AmountforEpf = $Amount > 0 ? $Amount : 0;
                $PayrollItems->TotalForEPF = $AmountforEpf;
            } else {


                $PayrollItems->SundayPayment = 0;
                $PayrollItems->LateDeductTime = 0;
                $PayrollItems->LateDeductAmount = 0;
                $PayrollItems->EarlyOutDeductAmount = 0;

                $Basic = Yii::app()->MonthlyPayrollCalculationUtil->CalculateBasicforMonthlyPayment($StartDate, $EndDate, $employeeid, $SiteId, $JoiningDate, $ResignDate, $JoiningDateNew);
                $WorkedDays = $Basic[1] > 0 ? $Basic[1] : 0;
                $BasicWage = $Basic[0] >= 0 ? $Basic[0] : 0;
                $noPayDays = $Basic[2] >= 0 ? $Basic[2] : 0;
                $PayrollItems->NoPayDays = $noPayDays;
                $PayrollItems->BasicWage = $BasicWage;
                $PayrollItems->WorkDay = $WorkedDays;
                $Amount = $PayrollItems->BasicWage;
                $AmountforEpf = $Amount > 0 ? $Amount : 0;
                $PayrollItems->TotalForEPF = $AmountforEpf;
                
            }

            $PayrollItems->DayOfSundayP = 0;
            $PayrollItems->full_Basic_Salary = $employeesalary->monthsalary;
            $PayrollItems->Sub_Basic_salary = $employeesalary->BasicSalary;
            $PayrollItems->BRA1 = $employeesalary->BRA1;
            $PayrollItems->BRA2 = $employeesalary->BRA2;
            $PayrollItems->BRA3 = $employeesalary->BRA3;

            $PayrollItems->TotalForEPFPoyaday = 0;
            $PayrollItems->NOT = 0;
            $PayrollItems->DOT = 0;
            $PayrollItems->TOT = 0;
            $PayrollItems->NOTHour = 0;
            $PayrollItems->DOTHour = 0;
            $PayrollItems->TOTHour = 0;
            $PayrollItems->Bonus = 0;
            $PayrollItems->Allowance = 0;
            $PayrollItems->Perday_incentive = 0;
            $PayrollItems->Lunch_incentive = 0;
            $PayrollItems->NightShift_incentive = 0;
            $PayrollItems->Insentive = 0;
            $PayrollItems->PAllowance = 0;
            $PayrollItems->VAllowance = 0;
            $PayrollItems->Arrears = 0;

            $TotalGross = $AmountforEpf + $PayrollItems->PoyadayPayment + $PayrollItems->MercantilePayment + $PayrollItems->SundayPayment + $PayrollItems->SiteHolidayAmount + $PayrollItems->NOT + $PayrollItems->DOT + $PayrollItems->TOT + $PayrollItems->Insentive;
            $PayrollItems->TotalGross = $TotalGross;

            $PayrollItems->Deduction = 0;
            $PayrollItems->Deduction2 = 0;
            $PayrollItems->Deduction3 = 0;
            $PayrollItems->TotalNet = $TotalGross;

            $EPFByCompany = (12 / 100) * ($AmountforEpf + $PayrollItems->TotalForEPFPoyaday);
            //Yii::app()->MonthlyPayrollCalculationUtil->EPFByCompany($Rowdata['BasicSalary'], $PoyadayPayment, $MercantilePayment, $SundayPayment);
            $PayrollItems->EPFByCompany = $EPFByCompany;

            $ETFByCompany = (3 / 100) * ($AmountforEpf + $PayrollItems->TotalForEPFPoyaday);
            //Yii::app()->MonthlyPayrollCalculationUtil->ETFByCompany($Rowdata['BasicSalary'], $PoyadayPayment, $MercantilePayment, $SundayPayment);
            $PayrollItems->ETFByCompany = $ETFByCompany;

            $Contractfee = Employeecontractfee::model()->findByAttributes(array('employeeid' => $employeeid, 'site_id' => $SiteId, 'status' => 1));
            $contractfeevalue = $Contractfee != null ? $Contractfee->contractfee : 0;
            $PayrollItems->ContractorFee = ($contractfeevalue / 100) * $BasicWage;
            $PayrollItems->contractorfee_rate = $contractfeevalue; 
            $ConF = $PayrollItems->ContractorFee;
            
            $CostOfCompany = $PayrollItems->TotalNet + $EPFByCompany + $ETFByCompany + $ConF;
            $PayrollItems->CostOfCompany = $CostOfCompany;
            $PayrollItems->TotalAddition = 0;
            $PayrollItems->TotalDeduction = 0;

            $PayrollItems->save();
        }
    }

}
