<?php

// uncomment the following to define a path alias
// Yii::setPathOfAlias('local','path/to/local-folder');
Yii::setPathOfAlias('bootstrap', dirname(__FILE__) . '/../extensions/bootstrap');
Yii::setPathOfAlias('chartjs', dirname(__FILE__) . '/../extensions/yii-chartjs');
Yii::setPathOfAlias('curl', dirname(__FILE__) . '/../extensions/curl');
Yii::setPathOfAlias('pdfext', dirname(__FILE__) . '/../extensions/yii-pdf');
Yii::setPathOfAlias('excel', dirname(__FILE__) . '/../extensions/yiiexcel');
Yii::setPathOfAlias('backjob', dirname(__FILE__) . '/../extensions/backjob');
require_once( dirname(__FILE__) . '/../../vendor/autoload.php');

// Yii::setPathOfAlias('spreadsheet', dirname(__FILE__) . '/../extensions/php-excel-reader-master');

Yii::import('excel.YiiExcel', true);
// Yii::import('spreadsheet.excel_reader2', true);
//Yii::import('backjob.EBackJob', true);
Yii::registerAutoloader(array('YiiExcel', 'autoload'), true);

// This is the main Web application configuration. Any writable
// CWebApplication properties can be configured here.
return array(
    'id'=>'thilina',
    'basePath' => dirname(__FILE__) . DIRECTORY_SEPARATOR . '..',
    'name' => '',
    'aliases' => array(
        'bootstrap' => realpath(__DIR__ . '/../extensions/bootstrap'), // change this if necessary
    ),
    // preloading 'log' component
    'preload' => array('log', 'chartjs','background'),
    // autoloading model and component classes
    'import' => array(
        'application.models.*',
        'application.components.*',
        'application.modules.user.models.*',
        'application.modules.user.components.*',
        'application.vendors.phpexcel.PHPExcel',
        'application.behaviors.DBRecordTracker',
        //================mail==================
        'ext.yii-mail.YiiMailMessage',
    
    ),
    'modules' => array(
        'user' => array(
            'debug' => true,
        ),
        'usergroup' => array(
            'usergroupTable' => 'usergroup',
            'usergroupMessageTable' => 'user_group_message',
        ),
        'membership' => array(
            'membershipTable' => 'membership',
            'paymentTable' => 'payment',
        ),
        'friendship' => array(
            'friendshipTable' => 'friendship',
        ),
        'profile' => array(
            'privacySettingTable' => 'privacysetting',
            'profileFieldTable' => 'profile_field',
            'profileTable' => 'profile',
            'profileCommentTable' => 'profile_comment',
            'profileVisitTable' => 'profile_visit',
        ),
        'role' => array(
            'roleTable' => 'role',
            'userRoleTable' => 'user_role',
            'actionTable' => 'action',
            'permissionTable' => 'permission',
        ),
        'message' => array(
            'messageTable' => 'message',
        ),
        'gii' => array(
            'class' => 'system.gii.GiiModule',
            'password' => 'SECRET',
            // If removed, Gii defaults to localhost only. Edit carefully to taste.
            //'ipFilters' => array('127.0.0.1', '10.1.28.1', '10.1.24.252'),
            'generatorPaths' => array(
                'bootstrap.gii',
            ),
        ),
    ),
   
    // application components
    'components' => array(
        
        'background' => array(
            'class' => 'backjob.EBackJob',
            'checkAndCreateTable' => true,  // creates table if it doesn't exist
            'key' => 'sjs&sk&F89fksL*987sdKf',   
            'useDb' => true,    
            'useCache' => true, // Use the cache
            'db' => 'db',    // Database component name to use
            'ch' => 'cache', // Cache component name to use
            'tableName' => 'e_background_job', // Name of DB table used
            'cachePrefix' => 'EBackJobPrefix-',  // Prefix used in the cache
            'errorTimeout' => 60,    
            'userAgent' => 'Mozilla/5.0 Firefox/3.6.12', // Useragent used for the background request
            'backlogDays' => 30, // Number of days successfully completed request-entries are retained in the database
            'allBacklogDays' => 60,

              ),
        // 'mail' => array(
        //     'class' => 'ext.yii-mail.YiiMail',
        //     'transportType'=>'smtp',
        //     'transportOptions'=>array(
        //             'host'=>'smtp.gmail.com',
        //             'username'=>'achinilv@gmail.com',
        //             'password'=>'Thilina12345#',
        //             'port'=>'587',						
        //     ),
        //     'viewPath' => 'application.views.mail',				
        // ),
        'mail' => array(
            'class' => 'ext.yii-mail.YiiMail',
            'transportType'=>'smtp',
            'transportOptions'=>array(
                'host'=>'smtp.office365.com',
                'username'=>'lka-iforce@expofreight.com',
                'password'=>'LPLmp@#119',
                'port'=>'587',
           //     'encryption'=>'STARTTLS',

                'encryption'=>'',

                ),
            'viewPath' => 'application.views.mail',
            'logging' => true,
            'dryRun' => false
        ),
        'yexcel' => array('class' => 'ext.yexcel.Yexcel'),
        'metadata'=>array('class'=>'Metadata'),
        'cache' => array('class' => 'system.caching.CDummyCache'),
        'paymentUtil'=>array('class'=>'PaymentUtil'),
        'commonUtil'=>array('class'=>'CommonUtil'),
        'HolidayRateUtil'=>array('class'=>'HolidayRateUtil'),
        'PayrollCalculationUtil'=>array('class'=>'PayrollCalculationUtil'),
        'PayrollCalculationEntitleUtil'=>array('class'=>'PayrollCalculationEntitleUtil'),
        'MonthlyPayrollCalculationUtil'=>array('class'=>'MonthlyPayrollCalculationUtil'),
        'MonthlyPaymentCalculationUtil'=>array('class'=>'MonthlyPaymentCalculationUtil'),
        'PayrollCalculationUtilnew'=>array('class'=>'PayrollCalculationUtilnew'), 
        'ShiftCreatApiUtil'=>array('class'=>'ShiftCreatApiUtil'),
        'MonthlyOTEntitle'=>array('class'=>'MonthlyOTEntitle'),
        'AddMissingEmplyeeToShiftUtil'=>array('class'=>'AddMissingEmplyeeToShiftUtil'),
        'CreateNewEmployeeToShift'=>array('class'=>'CreateNewEmployeeToShift'),
               
        'PublicFunctionForTimesheetUtil'=>array('class'=>'PublicFunctionForTimesheetUtil'),
        'PayrollCalculationEntitleUtilnew'=>array('class'=>'PayrollCalculationEntitleUtilnew'),
        'MonthlyPaymentCalculationUtilnew'=>array('class'=>'MonthlyPaymentCalculationUtilnew'),
        'MonthlyPaymentCalculationEntitleUtilnew'=>array('class'=>'MonthlyPaymentCalculationEntitleUtilnew'),
        'CreateTimsheetToDayRate'=>array('class'=>'CreateTimsheetToDayRate'),
        'EligibleLeaveUtil'=>array('class'=>'EligibleLeaveUtil'),
        'RemoveEmployeeFromShiftUtil'=>array('class'=>'RemoveEmployeeFromShiftUtil'),
        'PiecesPaymentCalculationUtil'=>array('class'=>'PiecesPaymentCalculationUtil'),
        'FlexiShiftMonthlyCalculationUtil'=>array('class'=>'FlexiShiftMonthlyCalculationUtil'),
        'FlexiShiftDailyCalculationUtil'=>array('class'=>'FlexiShiftDailyCalculationUtil'),
        
    
        'bootstrap' => array(
            'class' => 'bootstrap.components.Bootstrap',
            'responsiveCss' => true,
        ),
        'user' => array(
            'class' => 'application.modules.user.components.YumWebUser',
            'allowAutoLogin' => true,
            'loginUrl' => array('//user/user/login'),
        ),
       
        // 'session' => array(
        //     'savePath' =>'E:\session',
        //     'cookieMode' => 'allow',
        //     'cookieParams' => array(
        //         'path' => '/',
        //         'domain' => 'localhost',
        //         'httpOnly' => true,
        //     ),
        // ),
        'urlManager' => array(
            'urlFormat' => 'path',
            'rules' => array(

                array('TreemapApi/GetAllCompany', 'pattern' => 'treemapapi/getallcompany', 'verb' => 'GET'),
                array('TreemapApi/GetAllSector', 'pattern' => 'treemapapi/getallsector', 'verb' => 'GET'),
                array('RosterApi/GetAllRoster', 'pattern' => 'RosterApi/getallroster', 'verb' => 'GET'),
                array('HolydayApi/GetAllHolydas', 'pattern' => 'HolydayApi/getallholydas', 'verb' => 'GET'),
                array('FingerPrintApi/GetAllEmployee', 'pattern' => 'FingerPrintApi/GetAllEmployee', 'verb' => 'GET'),
                array('loginapi/login', 'pattern' => 'loginapi/login', 'verb' => 'POST'),
                array('userApi/securityusers', 'pattern' => 'userapi/securityusers', 'verb' => 'GET'),
                array('userApi/getallusers', 'pattern' => 'userapi/getallusers', 'verb' => 'GET'),
                array('scheduleApi/getschedulebyvehicle', 'pattern' => 'scheduleapi/getschedulebyvehicle', 'verb' => 'POST'),
                array('scheduleApi/getaccountbyid', 'pattern' => 'scheduleapi/getaccountbyid', 'verb' => 'POST'),
                array('scheduleApi/getuserbyid', 'pattern' => 'scheduleapi/getuserbyid', 'verb' => 'POST'),
                array('scheduleApi/getvisitorsbyschedule', 'pattern' => 'scheduleapi/getvisitorsbyschedule', 'verb' => 'POST'),
                array('scheduleApi/assigncard', 'pattern' => 'scheduleapi/assigncard', 'verb' => 'POST'),
                array('scheduleApi/getvehiclesbyschedule', 'pattern' => 'scheduleapi/getvehiclesbyschedule', 'verb' => 'POST'),
                array('scheduleApi/schedulereturncards', 'pattern' => 'scheduleapi/schedulereturncards', 'verb' => 'POST'),
                array('scheduleApi/schedulereturncardstest', 'pattern' => 'scheduleapi/schedulereturncardstest', 'verb' => 'POST'),
                array('scheduleApi/getexsistingcontactsbynic', 'pattern' => 'scheduleapi/getexsistingcontactsbynic', 'verb' => 'POST'),
                array('scheduleApi/getaccounts', 'pattern' => 'scheduleapi/getaccounts', 'verb' => 'POST'),
                array('scheduleApi/createvisitor', 'pattern' => 'scheduleapi/createvisitor', 'verb' => 'POST'),
                array('scheduleApi/createschedule', 'pattern' => 'scheduleapi/createschedule', 'verb' => 'POST'),
                array('scheduleApi/createschedulevisitor', 'pattern' => 'scheduleapi/createschedulevisitor', 'verb' => 'POST'),
                array('scheduleApi/createschedulevehicle', 'pattern' => 'scheduleapi/createschedulevehicle', 'verb' => 'POST'),
                array('scheduleApi/getvehiclebyplate', 'pattern' => 'scheduleapi/getvehiclebyplate', 'verb' => 'POST'),
                array('scheduleApi/createvehiclebyplate', 'pattern' => 'scheduleapi/createvehiclebyplate', 'verb' => 'POST'),
                array('scheduleApi/completeschedule', 'pattern' => 'scheduleapi/completeschedule', 'verb' => 'POST'),
                array('scheduleApi/opengate', 'pattern' => 'scheduleapi/opengate', 'verb' => 'POST'),
                array('scheduleApi/getuserbyepc', 'pattern' => 'scheduleapi/getuserbyepc', 'verb' => 'POST'),
                array('scheduleApi/getseatbyfloor', 'pattern' => 'scheduleapi/getseatbyfloor', 'verb' => 'POST'),
                array('scheduleApi/deallocateseat', 'pattern' => 'scheduleapi/deallocateseat', 'verb' => 'POST'),
                array('scheduleApi/allocateseat', 'pattern' => 'scheduleapi/allocateseat', 'verb' => 'POST'),
                array('scheduleApi/getseatusers', 'pattern' => 'scheduleapi/getseatusers', 'verb' => 'POST'),
                array('scheduleApi/getschedulebynic', 'pattern' => 'scheduleapi/getschedulebynic', 'verb' => 'POST'),
                array('scheduleApi/updateattendance', 'pattern' => 'scheduleapi/updateattendance', 'verb' => 'POST'),
                array('scheduleApi/getuserbyactivecard', 'pattern' => 'scheduleapi/getuserbyactivecard', 'verb' => 'POST'),
                array('scheduleApi/updateattendancetest', 'pattern' => 'scheduleapi/updateattendancetest', 'verb' => 'POST'),
                array('scheduleApi/getuserbyactivecardtest', 'pattern' => 'scheduleapi/getuserbyactivecardtest', 'verb' => 'POST'),
                array('scheduleApi/getwifitoken', 'pattern' => 'scheduleapi/getwifitoken', 'verb' => 'POST'),
                array('scheduleApi/updatewifitokens', 'pattern' => 'scheduleapi/updatewifitokens', 'verb' => 'POST'),
                array('scheduleApi/writeguestbook', 'pattern' => 'scheduleapi/writeguestbook', 'verb' => 'POST'),
                array('scheduleApi/writeguestbooktest', 'pattern' => 'scheduleapi/writeguestbooktest', 'verb' => 'POST'),
                array('scheduleApi/getguestbookrecord', 'pattern' => 'scheduleapi/getguestbookrecord', 'verb' => 'POST'),
                array('scheduleApi/getguestbookrecords', 'pattern' => 'scheduleapi/getguestbookrecords', 'verb' => 'POST'),
                array('scheduleApi/approveguestbookrecord', 'pattern' => 'scheduleapi/approveguestbookrecord', 'verb' => 'POST'),
                array('scheduleApi/getcardstats', 'pattern' => 'scheduleapi/getcardstats', 'verb' => 'POST'),
                array('scheduleApi/getcardtypebyepc', 'pattern' => 'scheduleapi/getcardtypebyepc', 'verb' => 'POST'),
                array('contractworkerApi/getexsistingworkerbynic', 'pattern' => 'contractworkerapi/getexsistingworkerbynic', 'verb' => 'POST'),
                array('contractworkerApi/createworker', 'pattern' => 'contractworkerapi/createworker', 'verb' => 'POST'),
                array('contractworkerApi/markattendance', 'pattern' => 'contractworkerapi/aarkattendance', 'verb' => 'POST'),
                array('mail/sendmail', 'pattern' => 'mail/sendmail', 'verb' => 'POST'),
                array('mail/sendmailkiosk', 'pattern' => 'mail/sendmailkiosk', 'verb' => 'POST'),
                array('mail/sendmailvipvisit', 'pattern' => 'mail/sendmailvipvisit', 'verb' => 'POST'),
                array('mail/sendmailtest', 'pattern' => 'mail/sendmailtest', 'verb' => 'POST'),
                array('attendanceApi/updateattendance', 'pattern' => 'attendanceApi/updateattendance', 'verb' => 'POST'),
                array('attendanceApi/updatezone', 'pattern' => 'attendanceApi/updatezone', 'verb' => 'POST'),
                array('attendanceApi/getuserslastdetectedtimes', 'pattern' => 'attendanceApi/getuserslastdetectedtimes', 'verb' => 'POST'),
                array('attendanceApi/updateattendancelog', 'pattern' => 'attendanceApi/updateattendancelog', 'verb' => 'POST'),
                array('userbyzoneApi/getcountbyzone', 'pattern' => 'userbyzoneapi/getcountbyzone', 'verb' => 'POST'),
                array('userbyzoneApi/getusersbyzone', 'pattern' => 'userbyzoneapi/getusersbyzone', 'verb' => 'POST'),
                array('attendanceApi/getfailedattendancerecords', 'pattern' => 'attendanceApi/getfailedattendancerecords', 'verb' => 'POST'),
                array('attendanceApi/updatefailedattendance', 'pattern' => 'attendanceApi/updatefailedattendance', 'verb' => 'POST'),
                '<controller:\w+>/<id:\d+>' => '<controller>/view',
                '<controller:\w+>/<action:\w+>/<id:\d+>' => '<controller>/<action>',
                '<controller:\w+>/<action:\w+>' => '<controller>/<action>',

            ),
        ),


        'db' => array(

           'connectionString' => 'mysql:host=localhost;dbname=iforce_live',
           'emulatePrepare' => true,

            'username' => 'eimuser',
            'password' => 'rfid@eimsky2014',
            'charset' => 'utf8',
        ),
        'errorHandler' => array(
            // use 'site/error' action to display errors
            'errorAction' => 'site/error',
        ),
        'curl' => array(
            'class' => 'curl.Curl',
            'options' => array(),
        ),
        'chartjs' => array('class' => 'chartjs.components.ChartJs'),

        //        'log' => array(
//            'class' => 'CLogRouter',
//            'routes' => array(
//                array(
//                    'class' => 'CFileLogRoute',
//                    'levels' => 'error',
//                ),
//                // uncomment the following to show log messages on web pages
//                array(
//                    'class' => 'CWebLogRoute',
//                ),
//            ),
//        ),


        'ePdf' => array(
            'class' => 'pdfext.EYiiPdf',
            'params' => array(
                'mpdf' => array(
                    'librarySourcePath' => 'application.vendors.mpdf.*',
                    'constants' => array(
                        '_MPDF_TEMP_PATH' => Yii::getPathOfAlias('application.runtime'),
                    ),
                    'class' => 'mpdf', // the literal class filename to be loaded from the vendors folder
                /* 'defaultParams'     => array( // More info: http://mpdf1.com/manual/index.php?tid=184
                  'mode'              => '', //  This parameter specifies the mode of the new document.
                  'format'            => 'A4', // format A4, A5, ...
                  'default_font_size' => 0, // Sets the default document font size in points (pt)
                  'default_font'      => '', // Sets the default font-family for the new document.
                  'mgl'               => 15, // margin_left. Sets the page margins for the new document.
                  'mgr'               => 15, // margin_right
                  'mgt'               => 16, // margin_top
                  'mgb'               => 16, // margin_bottom
                  'mgh'               => 9, // margin_header
                  'mgf'               => 9, // margin_footer
                  'orientation'       => 'P', // landscape or portrait orientation
                  ) */
                ),
                'HTML2PDF' => array(
                    'librarySourcePath' => 'application.vendors.html2pdf.*',
                    'classFile' => 'html2pdf.class.php', // For adding to Yii::$classMap
                /* 'defaultParams'     => array( // More info: http://wiki.spipu.net/doku.php?id=html2pdf:en:v4:accueil
                  'orientation' => 'P', // landscape or portrait orientation
                  'format'      => 'A4', // format A4, A5, ...
                  'language'    => 'en', // language: fr, en, it ...
                  'unicode'     => true, // TRUE means clustering the input text IS unicode (default = true)
                  'encoding'    => 'UTF-8', // charset encoding; Default is UTF-8
                  'marges'      => array(5, 5, 5, 8), // margins by default, in order (left, top, right, bottom)
                  ) */
                )
            ),
        ),
        
    ),
    // application-level parameters that can be accessed
    // using Yii::app()->params['paramName']
    'params' => array(
        'ldap' => array(
            'servers' => array(
                '10.1.150.2',
            ),
            'defaultDomain' => 'expo',
            'ldaphost' => 'expo.ad',
            'ldapuser' => 'cmsAdmin',
            'ldappassword' => 'vid@1359',
            'ldapdn' => 'DC=expo,DC=ad',
            'search' => array(
                'DC=expo,DC=ad',
            ),
        ),
        // this is used in contact page
        'adminEmail' => 'lka-iforce@expofreight.com',
        'mailServer' => '10.2.20.30',
    ),
);
