<?php

class DashboardApiController extends Controller
{

private $siteId;

public function __construct(){
        $this->siteId = Yii::app()->user->data()->SiteId;
}

public function actionPresenceAbsenceChart(){
    $yesterday = date('Y-m-d');
    //$list = [];
    $list = Yii::app()->db->createCommand("SELECT  S.name,IFNULL(chart.ttl,0) TTL,IFNULL(chart.pre,0) PRE,IFNULL(chart.abs,0) ABS
    FROM sites S
    LEFT JOIN (SELECT A.siteid, A.ttl,B.pre,(A.ttl - B.pre) abs
                FROM (SELECT E.siteid, COUNT(ET.employeeid) ttl
                        FROM employee_team ET
                        INNER JOIN employee E ON E.id = ET.employeeid
                        WHERE ET.Status = 1 AND ET.teamid IN (SELECT TS.teamid
                                                                FROM team_shift TS
                                                                WHERE TS.shiftid IN (SELECT SF.id
                                                                                FROM shift SF
                                                                                INNER JOIN schedule SCH ON SF.schedulid = SCH.id
                                                                                WHERE SCH.Date = '$yesterday'))
                                                                 GROUP BY E.siteid) A
    INNER JOIN (SELECT E.siteid,COUNT(DISTINCT(TL.Employeeid)) pre
            FROM timelog TL
            INNER JOIN employee E ON E.id = TL.Employeeid
            WHERE DATE(TL.PunchTime) = '$yesterday'  AND TL.Type = 'IN' AND TL.Employeeid IN (SELECT ET.employeeid
            FROM employee_team ET
                        WHERE ET.Status = 1 AND ET.teamid IN (SELECT TS.teamid
                        FROM team_shift TS
                        WHERE TS.shiftid IN (SELECT SF.id
                        FROM shift SF
                        INNER JOIN schedule SCH ON SF.schedulid = SCH.id
                        WHERE SCH.Date = '$yesterday')))
    
            GROUP BY E.siteid) B ON A.siteid = B.siteid) chart ON chart.siteid = S.id")->queryAll();
    $this->_sendResponse(200,CJSON::encode(array('list' => $list,'date' => $yesterday)));

}

public function actionPayrollChart(){
        $current_month=date('m');
	$current_year=date('Y');
	$lastmonth=$current_month-1;
        $lastYearMonth = $current_year.'-'.$lastmonth;
        $newDate = date("Y-m", strtotime($lastYearMonth));
        $newDate1 = date("M-Y", strtotime($lastYearMonth));
        
        $list = Yii::app()->db->createCommand("SELECT S.name,IFNULL(ROUND(((ccc.bcs * 100)/(ccc.bcs + ccc.ot + ccc.allwnc)) ,2),0) basic,IFNULL(ROUND(((ccc.ot * 100)/(ccc.bcs + ccc.ot + ccc.allwnc)) ,2),0) ot,IFNULL(ROUND(((ccc.allwnc * 100)/(ccc.bcs + ccc.ot + ccc.allwnc)) ,2),0) allownce
        FROM sites S
        LEFT JOIN (SELECT P.SiteId,SUM(bbb.basic) bcs,SUM(bbb.OT) ot,SUM(bbb.allowance) allwnc
                FROM payroll P 
                INNER JOIN (SELECT PI.Payroll_id,sum(PI.BasicWage) basic,SUM(PI.NOT),SUM(PI.DOT),SUM(PI.TOT),(SUM(PI.NOT) + SUM(PI.DOT) + SUM(PI.TOT)) OT,SUM(PI.Allowance) allowance
                        FROM payroll_items PI
                        WHERE PI.Payroll_id IN (SELECT P.id
                                FROM payroll P 
                                WHERE P.EndDate LIKE '%{$newDate}%')
        
                        GROUP by PI.Payroll_id) bbb ON bbb.Payroll_id = P.id
        
                GROUP BY P.SiteId) ccc ON ccc.siteId = S.id
        WHERE S.id NOT IN (6,14,15)")->queryAll();
    $this->_sendResponse(200,CJSON::encode(array('list' => $list,'date' => $newDate1)));

}

public function actionCreateTable(){
        $startDate = date('Y-m-d', strtotime('first day of last month'));
        $endDate =  date('Y-m-d', strtotime('last day of last month'));
        $dateRange = date('M-Y', strtotime('first day of last month'));
                Yii::app()->db->createCommand("call getAllAttendance('$startDate','$endDate')")->queryAll();
        //$list = Yii::app()->db->createCommand("call getAllAttendance('2018-03-10','2018-03-15')")->queryAll();
        //$this->_sendResponse(200,CJSON::encode(array('list' => $list,'date' => $dateRange)));
    
    }

public function actionAreaChart(){ 
        $startDate = date('Y-m-d', strtotime('first day of last month'));
        $endDate =  date('Y-m-d', strtotime('last day of last month'));
        $dateRange = date('M-Y', strtotime('first day of last month'));
        $list = Yii::app()->db->createCommand("SELECT DISTINCT(T.date) date,T.total,T.present,T.absent FROM tblResults T")->queryAll();
        $this->_sendResponse(200,CJSON::encode(array('list' => $list,'date' => $dateRange)));
    
}

        public function actionPieChart(){
                $yesterday = date('Y-m-d');
                
                $list = Yii::app()->db->createCommand("SELECT S.name,COUNT(E.id) count
                FROM employee E
                INNER JOIN sites S on S.id = E.siteid
                WHERE E.statusId = 1 AND E.id IN (SELECT A.Employeeid
                        from (SELECT DISTINCT T.Employeeid 
                                FROM timelog T
                                WHERE DATE(T.PunchTime) = '$yesterday' AND T.Type = 'IN') A
                        WHERE A.Employeeid NOT IN (SELECT ET.employeeid FROM employee_team ET WHERE ET.Status = 1 AND ET.teamid IN (SELECT TS.teamid 
                                                                                                                                        FROM team_shift TS 
                                                                                                                                        WHERE TS.shiftid IN (SELECT SF.id 
                                                                                                                                                                FROM shift SF 
                                                                                                                                                                INNER JOIN schedule SCH ON SF.schedulid = SCH.id 
                                                                                                                                                                WHERE SCH.Date = '$yesterday'))))
                GROUP BY E.siteid")->queryAll();
                
                $this->_sendResponse(200,CJSON::encode(array('list' => $list,'date' => $yesterday)));

        }

        public function actionGetSiteId(){
                $body = @file_get_contents('php://input');
                $obj = json_decode($body);
                
                $siteId = Sites::model()->findByAttributes(array('name'=>$obj->site));

                $this->_sendResponse(200,$siteId['id']);
        }

        public function actionGetAccountViceAttendance(){
                $sitid = Yii::app()->user->data()->SiteId;
               $list = [];
                $list = Yii::app()->db->createCommand("SELECT A.name, COUNT(DISTINCT T.Employeeid) AS count 
                FROM timelog T
                INNER JOIN employee E ON E.id = T.Employeeid 
                INNER JOIN accounts A ON A.id = E.Accountid
                WHERE DATE(T.PunchTime) = CURDATE() AND E.siteid = $sitid AND E.statusId = 1 AND T.Type = 'IN'
                GROUP BY A.name")->queryAll();

                $date = date('Y-m-d');

                $this->_sendResponse(200,CJSON::encode(array('list' => $list)));

        }


        public function actionGetAccountVicePresentAbsent(){
                $sitid = Yii::app()->user->data()->SiteId;
                $list = [];
               /* $list = Yii::app()->db->createCommand("SELECT allo.name,IFNULL(allo.allocated,0) allocated,IFNULL(pre.present,0) present,IFNULL((allo.allocated - pre.present),0) absent
                FROM (SELECT A.name, COUNT(E.id) allocated
                FROM employee_shift ES 
                INNER JOIN employee E ON E.id = ES.EmployeeId
                INNER JOIN accounts A ON A.id = E.Accountid
                WHERE E.statusId = 1 AND ES.ShiftId IN (SELECT SF.id 
                                     FROM schedule SCH
                                     INNER JOIN shift SF ON SF.schedulid = SCH.id
                                     WHERE SCH.Date = CURDATE() AND SF.SiteId = $sitid)
                GROUP BY A.name) allo 
                LEFT JOIN (SELECT A.name, count(DISTINCT(T.Employeeid)) present
                FROM timelog T
                INNER JOIN employee E ON E.id = T.Employeeid
                INNER JOIN accounts A ON A.id = E.Accountid
                WHERE DATE(T.PunchTime) = CURDATE() AND T.Type = 'IN' AND T.Employeeid IN (SELECT E.id
                        FROM employee_shift ES 
                        INNER JOIN employee E ON E.id = ES.EmployeeId
                        INNER JOIN accounts A ON A.id = E.Accountid
                        WHERE E.statusId = 1 AND ES.ShiftId IN (SELECT SF.id 
                                             FROM schedule SCH
                                             INNER JOIN shift SF ON SF.schedulid = SCH.id
                                             WHERE SCH.Date = CURDATE() AND SF.SiteId = $sitid))
                GROUP BY A.name) pre ON allo.name = pre.name")->queryAll();*/

                $date = date('Y-m-d');

                $this->_sendResponse(200,CJSON::encode(array('list' => $list)));

        }

        public function actionGetUserDetails(){
                if (Yii::app()->user->isAdmin()) {
                        $this->_sendResponse(200,CJSON::encode(array('role' => 1))); // 1 = admin
                }else{
                        $this->_sendResponse(200,CJSON::encode(array('role' => 2))); //2 = site operator
                }
        }

        public function actionGetAdminTotalEmployees(){
                $count = Yii::app()->db->createCommand("SELECT COUNT(id) FROM `employee` WHERE statusId = 1")->queryScalar();
                $this->_sendResponse(200,CJSON::encode(array('Count' => $count)));
        }

        public function actionGetAdminPresentEmployees(){
                $count = Yii::app()->db->createCommand("SELECT COUNT(DISTINCT T.Employeeid) AS count 
                        FROM timelog T
                        INNER JOIN employee E ON E.id = T.Employeeid 
                        WHERE DATE(T.PunchTime) = CURDATE() AND E.statusId = 1 AND T.type = 'IN'")->queryScalar();
                $this->_sendResponse(200,CJSON::encode(array('Count' => $count)));
        }

        public function actionGetAdminSuppliers(){
                $count = Yii::app()->db->createCommand("SELECT COUNT(DISTINCT name) name FROM `supplier` WHERE 1")->queryScalar();
                $this->_sendResponse(200,CJSON::encode(array('Count' => $count)));
        }

        public function actionGetAdminSites(){
                $count = Yii::app()->db->createCommand("SELECT COUNT(DISTINCT name) name FROM `sites` WHERE 1")->queryScalar();
                $this->_sendResponse(200,CJSON::encode(array('Count' => $count)));
        }

        public function actionGetSiteAllocatedEmployees(){
                $count =  Yii::app()->db->createCommand("SELECT count(E.id)
                        FROM employee_shift ES 
                        INNER JOIN employee E ON E.id = ES.EmployeeId
                        INNER JOIN accounts A ON A.id = E.Accountid
                        WHERE E.statusId = 1 AND E.siteid = $this->siteId AND ES.ShiftId IN (SELECT SF.id 
                                FROM schedule SCH
                                INNER JOIN shift SF ON SF.schedulid = SCH.id
                                WHERE SCH.Date = CURDATE() AND SF.SiteId = $this->siteId)")->queryScalar();
                $this->_sendResponse(200,CJSON::encode(array('Count' => $count)));
        }

        public function actionGetSitePresentEmployees(){
                $count = Yii::app()->db->createCommand("SELECT COUNT(DISTINCT T.Employeeid) AS count 
                        FROM timelog T
                        INNER JOIN employee E ON E.id = T.Employeeid 
                        WHERE DATE(T.PunchTime) = CURDATE() AND E.siteid = $this->siteId AND E.statusId = 1 AND T.Type = 'IN'")->queryScalar();
                $this->_sendResponse(200,CJSON::encode(array('Count' => $count)));
        }

        public function actionGetSiteNonAllocatedEmployees(){
                $count = Yii::app()->db->createCommand("SELECT count(DISTINCT(E.id)) nonEmp
                        FROM timelog T
                        INNER JOIN employee E ON E.id = T.Employeeid
                        WHERE E.statusId = 1 AND E.siteid = $this->siteId AND date(T.PunchTime) = CURDATE() AND E.siteid = $this->siteId AND T.Type = 'IN' AND T.Employeeid NOT IN (SELECT E.id
                                FROM employee_shift ES 
                                INNER JOIN employee E ON E.id = ES.EmployeeId
                                INNER JOIN accounts A ON A.id = E.Accountid
                                WHERE E.statusId = 1 AND  ES.ShiftId IN (SELECT SF.id 
                                        FROM schedule SCH
                                        INNER JOIN shift SF ON SF.schedulid = SCH.id
                                        WHERE SCH.Date = CURDATE() AND SF.SiteId = $this->siteId))")->queryScalar();
                $this->_sendResponse(200,CJSON::encode(array('Count' => $count)));
        }

        public function actionGetSiteAbsentEmployees(){
                $count = Yii::app()->db->createCommand("SELECT count(DISTINCT(ALLOCATED.id)) absentEmp
                        FROM (SELECT E.id
                                FROM employee_shift ES 
                                INNER JOIN employee E ON E.id = ES.EmployeeId
                                INNER JOIN accounts A ON A.id = E.Accountid
                                WHERE E.statusId = 1 AND E.siteid = $this->siteId AND ES.ShiftId IN (SELECT SF.id 
                                        FROM schedule SCH
                                        INNER JOIN shift SF ON SF.schedulid = SCH.id
                                        WHERE SCH.Date = CURDATE() AND SF.SiteId = $this->siteId)) ALLOCATED
                                        
                        WHERE ALLOCATED.id NOT IN (SELECT DISTINCT(T.Employeeid)
                                        FROM timelog T
                                        INNER JOIN employee E ON E.id = T.Employeeid 
                                        WHERE date(T.PunchTime) = CURDATE() AND E.siteid = $this->siteId AND T.Type = 'IN' )")->queryScalar();
                $this->_sendResponse(200,CJSON::encode(array('Count' => $count)));
        }

        public function actionGetAdminInvalidAttendance(){
                $previous_date = date('Y-m-d', strtotime(' -1 day'));
               /* $invalidAttendances = Yii::app()->db->createCommand("SELECT E.profileImage propic,D.type as designation,A.AccountOracleCode as accountId,T.date,E.nic,E.Namewithini name,A.name as account,S.name as supplier,IFNULL(T.Intime,'-----') AS Intime,IFNULL(T.OuteTime,'-----') as OuteTime
                        FROM timesheet as T
                        INNER JOIN employee E on T.Employeeid = E.id
                        INNER JOIN designation D ON D.id = E.designationid
                        INNER JOIN supplier S ON S.id = E.supplierid
                        INNER JOIN accounts A ON A.id = E.Accountid
                        WHERE T.date= '".$previous_date."' AND (T.Intime is NULL OR T.OuteTime is NULL ) ")->queryAll();*/
                $list = [];
                /*foreach($invalidAttendances as $invalidAttendance){
                       //PROFILE IMAGE ROTATE
                       error_reporting(E_ERROR);
                       try{
                               $exif = exif_read_data(Yii::app()->getBaseUrl(true).$invalidAttendance['propic']);
                       }catch(exception $ex){
                       }
                       $orientation = isset($exif['Orientation']) ? $exif['Orientation'] : null;

                       $isRotate = $orientation == 6 ? true : false;
                       //======END 
                       array_push($list,array('nic'=>$invalidAttendance['nic'],'name'=>$invalidAttendance['name'],'isRotate'=>$isRotate,'image'=>$invalidAttendance['propic'],'designation'=>$invalidAttendance['designation']));
                }*/
                
                $this->_sendResponse(200,CJSON::encode(array('$list' => $list)));
        }

        public function actionGetAdminTenuesList(){
                $tenures = Yii::app()->db->createCommand("SELECT E.* 
                        FROM employee E  
                        WHERE E.statusId = 1 
                        ORDER BY E.joindate ASC")->queryAll();
                $list = [];
               /* foreach ($tenures as $tenure ) {

                        $joindate = new DateTime($tenure['joindate']); 
                        $today = new Datetime(date('Y-m-d'));
                        $diff = $today->diff($joindate);
                        if($tenure['joindate'] == '0000-00-00') $age = 'JOIN DATE NOT SET';
                        else $age = $diff->y.' Yrs , '.$diff->m.' Mths , '.$diff->d.' Dys';
                        //PROFILE IMAGE ROTATE
                        error_reporting(E_ERROR);
                        try{
                                $exif = exif_read_data(Yii::app()->getBaseUrl(true).$tenure['profileImage']);
                        }catch(exception $ex){
                        }
                        $orientation = isset($exif['Orientation']) ? $exif['Orientation'] : null;

                        $isRotate = $orientation == 6 ? true : false;
                        //======END
                        array_push($list,array('nic'=>$tenure['nic'],'name'=>$tenure['Namewithini'],'duration'=>$age,'isRotate'=>$isRotate,'image'=>$tenure['profileImage']));
                }*/
                $this->_sendResponse(200,CJSON::encode(array('$list' => $list)));
        }

        public function actionGetSiteInvalidAttendance(){
                $previous_date = date('Y-m-d', strtotime(' -1 day'));
                $invalidAttendances = Yii::app()->db->createCommand("SELECT E.profileImage propic,D.type as designation,A.AccountOracleCode as accountId,T.date,E.nic,E.Namewithini name,A.name as account,S.name as supplier,IFNULL(T.Intime,'-----') AS Intime,IFNULL(T.OuteTime,'-----') as OuteTime
                        FROM timesheet as T
                        INNER JOIN employee E on T.Employeeid = E.id
                        INNER JOIN designation D ON D.id = E.designationid
                        INNER JOIN supplier S ON S.id = E.supplierid
                        INNER JOIN accounts A ON A.id = E.Accountid
                        WHERE T.date= '".$previous_date."' AND (T.Intime is NULL OR T.OuteTime is NULL ) AND E.siteid = '".$this->siteId."'")->queryAll();
                 $list = [];
                 foreach($invalidAttendances as $invalidAttendance){
                        //PROFILE IMAGE ROTATE
                        error_reporting(E_ERROR);
                        try{
                                $exif = exif_read_data(Yii::app()->getBaseUrl(true).$invalidAttendance['propic']);
                        }catch(exception $ex){
                        }
                        $orientation = isset($exif['Orientation']) ? $exif['Orientation'] : null;
 
                        $isRotate = $orientation == 6 ? true : false;
                        //======END 
                        array_push($list,array('nic'=>$invalidAttendance['nic'],'name'=>$invalidAttendance['name'],'isRotate'=>$isRotate,'image'=>$invalidAttendance['propic'],'designation'=>$invalidAttendance['designation']));
                 }
                 
                 $this->_sendResponse(200,CJSON::encode(array('$list' => $list)));
        }

        public function actionGetSiteTenuesList(){
                $tenures = Yii::app()->db->createCommand("SELECT E.* 
                FROM employee E  
                WHERE E.statusId = 1 AND E.siteid = $this->siteId
                ORDER BY E.joindate ASC")->queryAll();
                $list = [];
                foreach ($tenures as $tenure ) {

                        $joindate = new DateTime($tenure['joindate']); 
                        $today = new Datetime(date('Y-m-d'));
                        $diff = $today->diff($joindate);
                        if($tenure['joindate'] == '0000-00-00') $age = 'JOIN DATE NOT SET';
                        else $age = $diff->y.' Yrs , '.$diff->m.' Mths , '.$diff->d.' Dys';
                         //PROFILE IMAGE ROTATE
                         error_reporting(E_ERROR);
                         try{
                                 $exif = exif_read_data(Yii::app()->getBaseUrl(true).$tenure['profileImage']);
                         }catch(exception $ex){
                         }
                         $orientation = isset($exif['Orientation']) ? $exif['Orientation'] : null;
 
                         $isRotate = $orientation == 6 ? true : false;
                         //======END
                        array_push($list,array('nic'=>$tenure['nic'],'name'=>$tenure['Namewithini'],'duration'=>$age,'isRotate'=>$isRotate,'image'=>$tenure['profileImage']));
                }
                $this->_sendResponse(200,CJSON::encode(array('$list' => $list)));
        }

        public function actionGetAdminSiteWiseAttendance(){
        $list = [];
               $list = Yii::app()->db->createCommand("SELECT S.name, cast((present.pres * 100)/ allocated.allo as SIGNED) pres, cast(((allocated.allo - present.pres)*100)/allocated.allo as SIGNED) abs
                        FROM (SELECT S.id, COUNT(DISTINCT(E.id)) allo
                                FROM employee_shift ES
                                INNER JOIN employee E ON E.id = ES.EmployeeId
                                INNER JOIN sites S ON S.id = E.siteid
                                WHERE ES.ShiftId IN (SELECT SF.id
                                        FROM schedule SCH
                                        INNER JOIN shift SF ON SF.schedulid = SCH.id
                                        WHERE SCH.Date = curdate())
                                GROUP BY S.id) allocated
                        INNER JOIN sites S ON S.id = allocated.id
                        INNER JOIN (SELECT COUNT(DISTINCT(T.Employeeid)) pres,S.id
                                FROM timelog T 
                                INNER JOIN employee E ON E.id = T.Employeeid
                                INNER JOIN sites S ON S.id = E.siteid
                                WHERE DATE(T.PunchTime) = CURDATE() AND T.Type = 'IN' AND T.Employeeid IN (SELECT ES.EmployeeId
                                                                                                                FROM employee_shift ES 
                                                                                                                WHERE ES.ShiftId IN (SELECT SF.id
                                                                                                                        FROM schedule SCH
                                                                                                                        INNER JOIN shift SF ON SF.schedulid = SCH.id
                                                                                                                        WHERE SCH.Date = curdate()))
                                GROUP BY S.id) present ON present.id = allocated.id")->queryAll();
                $this->_sendResponse(200,CJSON::encode(array('$list' => $list)));
        }

        public function actionGetSiteAccountWiseAttendance(){
                $list = Yii::app()->db->createCommand("SELECT SF.name,cast((present.pres * 100)/allocated.allo as SIGNED) pre,cast(((allocated.allo -present.pres) * 100)/allocated.allo as SIGNED) abs
                        FROM(SELECT S.id,COUNT(ES.EmployeeId) allo
                                FROM employee_shift ES 
                                INNER JOIN shift S ON S.id = ES.ShiftId
                                INNER JOIN employee E ON E.id = ES.EmployeeId
                                WHERE E.statusId = 1 AND E.siteid = $this->siteId AND ES.ShiftId IN (SELECT SF.id
                                                FROM schedule SCH
                                                INNER JOIN shift SF ON SF.schedulid = SCH.id
                                                WHERE SCH.Date = CURDATE() AND SF.SiteId = $this->siteId)
                                GROUP BY ES.ShiftId) allocated
                        INNER JOIN shift SF ON SF.id =  allocated.id       
                        INNER JOIN (SELECT X.ShiftId,COUNT(DISTINCT(T.Employeeid)) pres
                                FROM timelog T 
                                INNER JOIN (SELECT ES.EmployeeId,ES.ShiftId
                                                FROM employee_shift ES 
                                                INNER JOIN shift S ON S.id = ES.ShiftId
                                                INNER JOIN employee E ON E.id = ES.EmployeeId
                                                WHERE E.statusId = 1 AND E.siteid = $this->siteId AND ES.ShiftId IN (SELECT SF.id
                                                                FROM schedule SCH
                                                                INNER JOIN shift SF ON SF.schedulid = SCH.id
                                                                WHERE SCH.Date = CURDATE() AND SF.SiteId = $this->siteId)) X ON X.EmployeeId = T.Employeeid
                        
                                WHERE date(T.PunchTime) = CURDATE() AND T.Type = 'IN' AND T.Employeeid IN (SELECT ES.EmployeeId
                                                FROM employee_shift ES 
                                                INNER JOIN shift S ON S.id = ES.ShiftId
                                                INNER JOIN employee E ON E.id = ES.EmployeeId
                                                WHERE E.statusId = 1 AND E.siteid = $this->siteId AND ES.ShiftId IN (SELECT SF.id
                                                                FROM schedule SCH
                                                                INNER JOIN shift SF ON SF.schedulid = SCH.id
                                                                WHERE SCH.Date = CURDATE() AND SF.SiteId = $this->siteId))
                        GROUP BY X.ShiftId) present ON present.ShiftId = allocated.id")->queryAll();
                $this->_sendResponse(200,CJSON::encode(array('$list' => $list)));
        }

        public function actionDownloadTenur(){
               // $this->_sendResponse(200,CJSON::encode(array("ccnn")));
            }



        public function actionDownloadTenure(){

              //  $this->_sendResponse(200,CJSON::encode(array("ccnn")));


                if(Yii::app()->user->isAdmin()){
                        $criteria   =   new CDbCriteria;                
                        $criteria->condition= 'statusId=1';
                        $criteria->order= 'joindate ASC';
                
                }else{
                        $criteria   =   new CDbCriteria;                
                        $criteria->condition= 'statusId=1 and siteid=:site';
                        $criteria->params= array(':site'=>  $this->siteId);                       
                        $criteria->order= 'joindate ASC'; 

                }

                $tenures = Employee::model()->findAll($criteria);

                $objPHPExcel = new PHPExcel();
       
                $objPHPExcel->setActiveSheetIndex(0)
                ->setCellValue('A1', 'Tenure List')
                ->setCellValue('E1', 'Generated On')
                ->setCellValue('F1', date("Y-m-d - h:i:sa"))
                ->setCellValue('A2', 'Employee Id')
                ->setCellValue('B2', 'Name')
                ->setCellValue('C2', 'NIC')
                ->setCellValue('D2', 'Designation')
                ->setCellValue('E2', 'Site')
                ->setCellValue('F2', 'Client Code')
                ->setCellValue('G2', 'Client Name')
                ->setCellValue('H2', 'Duration');
                $col = 3;


                foreach ($tenures as $tenure ) {
                        $row = 0;

                        $joindate = new DateTime($tenure['joindate']); 
                        $today = new Datetime(date('Y-m-d'));
                        $diff = $today->diff($joindate);
                        if($tenure['joindate'] == '0000-00-00') $age = 'JOIN DATE NOT SET';
                        else $age = $diff->y.' Yrs , '.$diff->m.' Mths , '.$diff->d.' Dys';

                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$col,$tenure['id']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$tenure['Namewithini']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$tenure['nic']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$tenure->Designation->type);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$tenure->site->name);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$tenure->account->AccountOracleCode);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$tenure->account->name);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$age);
                        $col++;
                        
                        
                }
                $styleArray = array(
                'font'  => array(
                        'bold'  => true,
                        'color' => array('rgb' => '#f79727'),
                        'size'  => 10
                ));
                $objPHPExcel->getActiveSheet()->getStyle('A1:I2')->applyFromArray($styleArray);

                //$objPHPExcel->getActiveSheet()->setTitle('sffd');

                $objPHPExcel->setActiveSheetIndex(0);

                ob_end_clean();
                ob_start();

                header('Content-Type: application/vnd.ms-excel');
                header('Content-Disposition: attachment;filename=TenuteReport.xls');
                header('Cache-Control: max-age=0');
                $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
                $objWriter->save('php://output');
        }


        
        public function actionDownloadInvalidAttendance(){
                $previous_date = date('Y-m-d', strtotime(' -1 day'));
                if(Yii::app()->user->isAdmin()){
                        
                         $invalidAttendances = Yii::app()->db->createCommand("SELECT E.id,E.profileImage propic,D.type as designation,A.AccountOracleCode as accountId,T.date,E.nic,E.Namewithini name,A.name as account,S.name as supplier,IFNULL(T.Intime,'-----') AS Intime,IFNULL(T.OuteTime,'-----') as OuteTime
                                FROM timesheet as T
                                INNER JOIN employee E on T.Employeeid = E.id
                                INNER JOIN designation D ON D.id = E.designationid
                                INNER JOIN supplier S ON S.id = E.supplierid
                                INNER JOIN accounts A ON A.id = E.Accountid
                                WHERE T.date= '".$previous_date."' AND (T.Intime is NULL OR T.OuteTime is NULL ) ")->queryAll();
                
               // $this->_sendResponse(200,CJSON::encode(array(invalidAttendances)));
               // $this->_sendResponse(200,CJSON::encode(array("ccnn")));
               print_r($invalidAttendances);die;

                }
                else{
                        $invalidAttendances = Yii::app()->db->createCommand("SELECT E.id,E.profileImage propic,D.type as designation,A.AccountOracleCode as accountId,T.date,E.nic,E.Namewithini name,A.name as account,S.name as supplier,IFNULL(T.Intime,'-----') AS Intime,IFNULL(T.OuteTime,'-----') as OuteTime
                                FROM timesheet as T
                                INNER JOIN employee E on T.Employeeid = E.id
                                INNER JOIN designation D ON D.id = E.designationid
                                INNER JOIN supplier S ON S.id = E.supplierid
                                INNER JOIN accounts A ON A.id = E.Accountid
                                WHERE T.date= '".$previous_date."' AND (T.Intime is NULL OR T.OuteTime is NULL ) AND E.siteid = '".$this->siteId."'")->queryAll();

                }
                
                $objPHPExcel = new PHPExcel();
       
                $objPHPExcel->setActiveSheetIndex(0)
                ->setCellValue('A1', 'Invalid Attendance '.$previous_date)
                ->setCellValue('E1', 'Generated On')
                ->setCellValue('F1', date("Y-m-d - h:i:sa"))
                ->setCellValue('A2', 'Employee Id')
                ->setCellValue('B2', 'Name')
                ->setCellValue('C2', 'NIC')
                ->setCellValue('D2', 'Designation')
                ->setCellValue('E2', 'Site')
                ->setCellValue('F2', 'Client Code')
                ->setCellValue('G2', 'Client Name');
                $col = 3;


                foreach ($invalidAttendances as $attendace ) {
                        $row = 0;

                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$col,$attendace['id']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$attendace['name']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$attendace['nic']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$attendace['designation']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$attendace['supplier']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$attendace['accountId']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$attendace['account']);
                        $col++;
                        
                        
                }
                $styleArray = array(
                'font'  => array(
                        'bold'  => true,
                        'color' => array('rgb' => '#f79727'),
                        'size'  => 10
                ));
                $objPHPExcel->getActiveSheet()->getStyle('A1:I2')->applyFromArray($styleArray);

                //$objPHPExcel->getActiveSheet()->setTitle('sffd');

                $objPHPExcel->setActiveSheetIndex(0);

                ob_end_clean();
                ob_start();

                header('Content-Type: application/vnd.ms-excel');
                header('Content-Disposition: attachment;filename=InvalidAttendanceReport.xls');
                header('Cache-Control: max-age=0');
                $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
                $objWriter->save('php://output');
        }

////////////////////////////////////////////////////////////////////////////////////////////////////////
        public function actionDownloadTotalNumOfEmp(){

             $m = date('m');
                $current_y = date('Y');
                $previous_y = date('Y',strtotime('-1 year'));
                $date = [];  

               
                if($m >= 4){
                        for($i=4;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i));
                        }
                }else{
                        $date = array($previous_y.'-04',$previous_y.'-05',$previous_y.'-06',$previous_y.'-07',$previous_y.'-08',$previous_y.'-09',$previous_y.'-10',$previous_y.'-11',$previous_y.'-12');
                        for($i=1;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i));
                        }
                }

          $invalidAttendances = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S")->queryAll();
               
          $objPHPExcel = new PHPExcel();

                $objPHPExcel->setActiveSheetIndex(0)
                ->setCellValue('A1', 'Number of Employee ')
                ->setCellValue('E1', 'Generated On')
                ->setCellValue('F1', date("Y-m-d - h:i:sa"))
                ->setCellValue('A4', 'Date')
                ->setCellValue('B4', 'ID')
                ->setCellValue('C4', 'name')
                ->setCellValue('D4', 'Count');

                $col = 6;

         $result = [];
                foreach($date as $aa){
                        $subArray = [];
                        $subArray['date'] = $aa;


         foreach ($invalidAttendances as $attendace ) {

                 $row = 0;

                 $date1 = Yii::app()->db->createCommand("SELECT AE.date 
                        FROM active_employee_count AE
                        WHERE AE.site_id = '".$attendace['id']."' AND AE.date LIKE '%{$aa}%'")->queryScalar(); 

                 $empCount = Yii::app()->db->createCommand("SELECT AE.count_of_begin
                                FROM active_employee_count AE
                                WHERE AE.site_id = '".$attendace['id']."' AND AE.date LIKE '%{$aa}%'")->queryScalar(); 


                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$col, $date1);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$attendace['id']);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$attendace['name']);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col, $empCount);
              //  $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$attendace['count_of_end']);
             
                $col++;

                 }

                }
                $styleArray = array(
                'font'  => array(
                        'bold'  => true,
                        'color' => array('rgb' => '#f79727'),
                        'size'  => 10
                ));

                $objPHPExcel->getActiveSheet()->getStyle('A1:I2')->applyFromArray($styleArray);

                //$objPHPExcel->getActiveSheet()->setTitle('sffd');

                $objPHPExcel->setActiveSheetIndex(0);

                ob_end_clean();
                ob_start();

                header('Content-Type: application/vnd.ms-excel');
                header('Content-Disposition: attachment;filename=InvalidAttendanceReport.xls');
                header('Cache-Control: max-age=0');
                $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
                $objWriter->save('php://output');
                //  $this->_sendResponse(200,CJSON::encode(array("ccnn")));

        }
// line
        public function actionDownloadOvertimeSalaryTrend_NEW(){

                 $m = date('m');
                $current_y = date('Y');
                $previous_y = date('Y',strtotime('-1 year'));
                $date = [];

                if($m >= 4){       
                        for($i=4;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i));
                        }
                }
               
                else{
                        $date = array($previous_y.'-04',$previous_y.'-05',$previous_y.'-06',$previous_y.'-07',$previous_y.'-08',$previous_y.'-09',$previous_y.'-10',$previous_y.'-11',$previous_y.'-12');
                        for($i=1;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i));
                        }
                }

                if(Yii::app()->user->isAdmin()){
                        $invalidAttendances = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S")->queryAll();
                }else{
                        $sitid = Yii::app()->user->data()->SiteId;
                        $invalidAttendances = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S WHERE S.id = $sitid ")->queryAll();
                }



            //  $invalidAttendances = Yii::app()->db->createCommand("SELECT S.id , S.name  FROM sites S")->queryAll();
                       
                    $objPHPExcel = new PHPExcel();
        
                $objPHPExcel->setActiveSheetIndex(0)
                //->setCellValue('A1', 'Number of Employee ')
               ->setCellValue('E1', 'Generated On')
               ->setCellValue('F1', date("Y-m-d - h:i:sa"))
               ->setCellValue('A4', 'date')
                ->setCellValue('B4', 'Id')
                ->setCellValue('C4', 'name')
                ->setCellValue('D4', 'Value');
               
                 $col = 6;
                 foreach($date as $aa){
                        $subArray = [];
                        $subArray['date'] = $aa;
                     
                     foreach ($invalidAttendances as $attendace ) {
                         $row = 0;

                        $date1 = Yii::app()->db->createCommand("SELECT AE.date 
                        FROM active_employee_count AE
                        WHERE AE.site_id = '".$attendace['id']."' AND AE.date LIKE '%{$aa}%'")->queryScalar(); 


                        $empCount = Yii::app()->db->createCommand("SELECT (sum(PI.NOT+PI.DOT+PI.TOT+PI.PreOTAmount))  as overtimeSalary
                        FROM payroll P 
                        INNER JOIN payroll_items PI ON PI.Payroll_id = P.id
                         WHERE P.Status = 2 AND P.SiteId = '".$attendace['id']."'  AND P.StartDate LIKE '%{$aa}%' ")->queryScalar();  

                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$col,$date1);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$attendace['id']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$attendace['name']);
                      //  $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$empCount);
                        

                        if($empCount > 0){
                                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$empCount);
                        }else{
                                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,0);
                        }


                        $col++;

                         }
        
     
                          }
        
                 $styleArray = array(
                'font'  => array(
                        'bold'  => true,
                        'color' => array('rgb' => '#f79727'),
                        'size'  => 10
                ));
        
               
                $objPHPExcel->getActiveSheet()->getStyle('A1:I2')->applyFromArray($styleArray);
        
                //$objPHPExcel->getActiveSheet()->setTitle('sffd');
        
                $objPHPExcel->setActiveSheetIndex(0);
        
                ob_end_clean();
                ob_start();
        
                header('Content-Type: application/vnd.ms-excel');
                header('Content-Disposition: attachment;filename=InvalidAttendanceReport.xls');
                header('Cache-Control: max-age=0');
                $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
                $objWriter->save('php://output');
              //  $this->_sendResponse(200,CJSON::encode(array("ccnn")));
        
        }
// line
        public function actionBasicSalaryTrend(){
                
                $m = date('m');
                $current_y = date('Y');
                $previous_y = date('Y',strtotime('-1 year'));
                $date = [];

                if($m >= 4){
                        for($i=4;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i).'-01');
                        }
                }else{
                        $date = array($previous_y.'-04-01',$previous_y.'-05-01',$previous_y.'-06-01',$previous_y.'-07-01',$previous_y.'-08-01',$previous_y.'-09-01',$previous_y.'-10-01',$previous_y.'-11-01',$previous_y.'-12-01');
                        for($i=1;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i).'-01');
                        }
                }
                
                if(Yii::app()->user->isAdmin()){
                        $sites = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S")->queryAll();
                }else{
                        $sitid = Yii::app()->user->data()->SiteId;
                        $sites = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S WHERE S.id = $sitid ")->queryAll();
                }

                $result = [];
                /*foreach($date as $aa){
                        $subArray = [];
                        $subArray['date'] = $aa;
                        foreach($sites as $site){
                                $basicSalary = Yii::app()->db->createCommand("SELECT IFNULL(sum(PI.BasicWage),0)
                                        FROM payroll P 
                                        INNER JOIN payroll_items PI ON PI.Payroll_id = P.id
                                        WHERE P.Status = 2 AND P.SiteId = '".$site['id']."' AND P.StartDate = '".$aa."' ")->queryScalar();  

                                $subArray[$site['name']] = round($basicSalary,2);
                        }
                        array_push($result,$subArray);
                }*/
                // print_r($result);die;
                 $this->_sendResponse(200,CJSON::encode(array('$list' => $result)));
         }
// line
        public function actionDownloadBasicSalaryTrend(){

                $m = date('m');
                $current_y = date('Y');
                $previous_y = date('Y',strtotime('-1 year'));
                $date = [];

               if($m >= 4){       
                        for($i=4;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i));
                        }
                 }else{
                        $date = array($previous_y.'-04',$previous_y.'-05',$previous_y.'-06',$previous_y.'-07',$previous_y.'-08',$previous_y.'-09',$previous_y.'-10',$previous_y.'-11',$previous_y.'-12');
                        for($i=1;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i));
                        }
                }
                 if(Yii::app()->user->isAdmin()){
                         $invalidAttendances = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S")->queryAll();
                }
                else{
                       // $this->_sendResponse(200,CJSON::encode(array("ccnn")));
                        $sitid = Yii::app()->user->data()->SiteId;
                        $invalidAttendances = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S WHERE S.id = $sitid ")->queryAll();
                }
                 // $invalidAttendances = Yii::app()->db->createCommand("SELECT S.id , S.name  FROM sites S")->queryAll();
                      
       
                  $objPHPExcel = new PHPExcel();
        
                $objPHPExcel->setActiveSheetIndex(0)
                ->setCellValue('A1', 'Basic Salary Trend')
               ->setCellValue('E1', 'Generated On')
               ->setCellValue('F1', date("Y-m-d - h:i:sa"))
               ->setCellValue('A4', 'Date')
                ->setCellValue('B4', 'Site_Id')
                ->setCellValue('C4', 'Site_Name')
                ->setCellValue('D4', 'Value');
               
                $col = 6;
                 $result = [];
                foreach($date as $aa){
                        $subArray = [];
                        $subArray['date'] = $aa;
                     
                     foreach ($invalidAttendances as $attendace ) {
        
                          $row = 0;

                        $date1 = Yii::app()->db->createCommand("SELECT AE.date 
                        FROM active_employee_count AE
                        WHERE AE.site_id = '".$attendace['id']."' AND AE.date LIKE '%{$aa}%'")->queryScalar(); 

                        //  $empCount quary is  correct 

                          $empCount = Yii::app()->db->createCommand("SELECT (sum(PI.BasicWage))  as overtimeSalary
                        FROM payroll P 
                        INNER JOIN payroll_items PI ON PI.Payroll_id = P.id
                         WHERE P.Status = 2 AND P.SiteId = '".$attendace['id']."'  AND P.StartDate LIKE '%{$aa}%' ")->queryScalar();  
                                                                          
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$col,$date1);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$attendace['id']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$attendace['name']);
                       // $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$empCount);
                        
                        if($empCount > 0){
                                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$empCount);
                        }else{
                                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,0);
                        }

                        $col++;
                         // print_r($attendace);die;
                      // $subArray[$attendace['name']] = round($empCount,3); 
                      
                }
        
                // array_push($result,$subArray);

         }
        
                  // $this->_sendResponse(200,CJSON::encode(array('$list' => $result)));

                $styleArray = array(
                'font'  => array(
                        'bold'  => true,
                        'color' => array('rgb' => '#f79727'),
                        'size'  => 10
                ));
        
               
                $objPHPExcel->getActiveSheet()->getStyle('A1:I2')->applyFromArray($styleArray);
        
                //$objPHPExcel->getActiveSheet()->setTitle('sffd');
        
                $objPHPExcel->setActiveSheetIndex(0);
        
                ob_end_clean();
                ob_start();
        
                header('Content-Type: application/vnd.ms-excel');
                header('Content-Disposition: attachment;filename=BasicSalaryTrendReport.xls');
                header('Cache-Control: max-age=0');
                $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
                $objWriter->save('php://output');
              //  $this->_sendResponse(200,CJSON::encode(array("ccnn")));
        
        }
// line
        public function actionTotalSalaryTrend(){
                
                $m = date('m');
                $current_y = date('Y');
                $previous_y = date('Y',strtotime('-1 year'));
                $date = [];

                if($m >= 4){
                        for($i=4;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i).'-01');
                        }
                }else{
                        $date = array($previous_y.'-04-01',$previous_y.'-05-01',$previous_y.'-06-01',$previous_y.'-07-01',$previous_y.'-08-01',$previous_y.'-09-01',$previous_y.'-10-01',$previous_y.'-11-01',$previous_y.'-12-01');
                        for($i=1;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i).'-01');
                        }
                }
                
                if(Yii::app()->user->isAdmin()){
                        $sites = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S")->queryAll();
                }else{
                        $sitid = Yii::app()->user->data()->SiteId;
                        $sites = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S WHERE S.id = $sitid ")->queryAll();
                }

                $result = [];
                /*foreach($date as $aa){
                        $subArray = [];
                        $subArray['date'] = $aa;
                        foreach($sites as $site){
                                $totalSalary = Yii::app()->db->createCommand("SELECT IFNULL(sum(PI.TotalNet),0)
                                        FROM payroll P 
                                        INNER JOIN payroll_items PI ON PI.Payroll_id = P.id
                                        WHERE P.Status = 2 AND P.SiteId = '".$site['id']."' AND P.StartDate = '".$aa."' ")->queryScalar();  

                                $subArray[$site['name']] = round($totalSalary,2);
                        }
                        array_push($result,$subArray);
                }*/
                // print_r($result);die;
                $this->_sendResponse(200,CJSON::encode(array('$list' => $result)));

                
        }
//line
        public function actionDownloadTotalSalaryTrend(){

                $m = date('m');
                $current_y = date('Y');
                $previous_y = date('Y',strtotime('-1 year'));
                $date = [];

               if($m >= 4){       
                        for($i=4;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i));
                        }
                         } else{
                        $date = array($previous_y.'-04',$previous_y.'-05',$previous_y.'-06',$previous_y.'-07',$previous_y.'-08',$previous_y.'-09',$previous_y.'-10',$previous_y.'-11',$previous_y.'-12');
                        for($i=1;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i));
                        }
                }

                       
                if(Yii::app()->user->isAdmin()){
                        $invalidAttendances = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S")->queryAll();
                }else{
                        $sitid = Yii::app()->user->data()->SiteId;
                        $invalidAttendances = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S WHERE S.id = $sitid ")->queryAll();
                }



               //  $invalidAttendances = Yii::app()->db->createCommand("SELECT S.id , S.name  FROM sites S")->queryAll();
                 $objPHPExcel = new PHPExcel();
        
                $objPHPExcel->setActiveSheetIndex(0)
               ->setCellValue('A1', 'Total Salary Trend')
               ->setCellValue('E1', 'Generated On')
               ->setCellValue('F1', date("Y-m-d - h:i:sa"))
               ->setCellValue('A4', 'Date')
                ->setCellValue('B4', 'Id')
                ->setCellValue('C4', 'Name')
                ->setCellValue('D4', 'Value');
               
                $col = 6;
                 $result = [];
                foreach($date as $aa){
                        $subArray = [];
                        $subArray['date'] = $aa;
                     
                     foreach ($invalidAttendances as $attendace ) {
        
                          $row = 0;

                        $date1 = Yii::app()->db->createCommand("SELECT AE.date 
                        FROM active_employee_count AE
                        WHERE AE.site_id = '".$attendace['id']."' AND AE.date LIKE '%{$aa}%'")->queryScalar(); 

                        //  $empCount quary is  correct 

                          $empCount = Yii::app()->db->createCommand("SELECT (sum(PI.TotalNet))  as overtimeSalary
                        FROM payroll P 
                        INNER JOIN payroll_items PI ON PI.Payroll_id = P.id
                         WHERE P.Status = 2 AND P.SiteId = '".$attendace['id']."'  AND P.StartDate LIKE '%{$aa}%' ")->queryScalar();  
                                                                          
                         $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$col,$date1);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$attendace['id']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$attendace['name']);
                     //   $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$empCount);
                        
                        if($empCount > 0){
                                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$empCount);
                        }else{
                                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,0);
                        }
                         $col++;
                     // print_r($attendace);die;
                     //  $subArray[$attendace['name']] = round($empCount,3); 
                      }
                         // array_push($result,$subArray);

                        }
                  //   $this->_sendResponse(200,CJSON::encode(array('$list' => $result)));

                $styleArray = array(
                'font'  => array(
                        'bold'  => true,
                        'color' => array('rgb' => '#f79727'),
                        'size'  => 10
                ));
        
               
                $objPHPExcel->getActiveSheet()->getStyle('A1:I2')->applyFromArray($styleArray);
        
                //$objPHPExcel->getActiveSheet()->setTitle('sffd');
        
                $objPHPExcel->setActiveSheetIndex(0);
        
                ob_end_clean();
                ob_start();
        
                header('Content-Type: application/vnd.ms-excel');
                header('Content-Disposition: attachment;filename=InvalidAttendanceReport.xls');
                header('Cache-Control: max-age=0');
                $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
                $objWriter->save('php://output');
              //  $this->_sendResponse(200,CJSON::encode(array("ccnn")));
        
        }
// line
        public function actionAverageCostPerEmployee(){
                
                $m = date('m');
                $current_y = date('Y');
                $previous_y = date('Y',strtotime('-1 year'));
                $date = [];

                if($m >= 4){
                        for($i=4;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i).'-01');
                        }
                }else{
                        $date = array($previous_y.'-04-01',$previous_y.'-05-01',$previous_y.'-06-01',$previous_y.'-07-01',$previous_y.'-08-01',$previous_y.'-09-01',$previous_y.'-10-01',$previous_y.'-11-01',$previous_y.'-12-01');
                        for($i=1;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i).'-01');
                        }
                }
                
                if(Yii::app()->user->isAdmin()){
                        $sites = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S")->queryAll();
                }else{
                        $sitid = Yii::app()->user->data()->SiteId;
                        $sites = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S WHERE S.id = $sitid ")->queryAll();
                }

                $result = [];
               /* foreach($date as $aa){
                        $subArray = [];
                        $subArray['date'] = $aa;
                        foreach($sites as $site){

                                $averageCoust = Yii::app()->db->createCommand("SELECT IFNULL(IFNULL(sum(PI.CostOfCompany),0)/count(PI.id),0)
                                        FROM payroll P 
                                        INNER JOIN payroll_items PI ON PI.Payroll_id = P.id
                                        WHERE P.Status = 2 AND P.SiteId = '".$site['id']."' AND P.StartDate = '".$aa."' ")->queryScalar();  

                                $subArray[$site['name']] = round($averageCoust,2);
                        }
                        array_push($result,$subArray);
                }*/
                // print_r($result);die;
                $this->_sendResponse(200,CJSON::encode(array('$list' => $result)));
                 }
        // link
  
       public function actionDownloadAverageCostPerEmployee(){

        $m = date('m');
        $current_y = date('Y');
        $previous_y = date('Y',strtotime('-1 year'));
        $date = [];

        if($m >= 4){
                for($i=4;$i<=$m;$i++){
                        array_push($date,$current_y.'-'.sprintf('%02d', $i).'-01');
                }
        }else{
                $date = array($previous_y.'-04-01',$previous_y.'-05-01',$previous_y.'-06-01',$previous_y.'-07-01',$previous_y.'-08-01',$previous_y.'-09-01',$previous_y.'-10-01',$previous_y.'-11-01',$previous_y.'-12-01');
                for($i=1;$i<=$m;$i++){
                        array_push($date,$current_y.'-'.sprintf('%02d', $i).'-01');
                }
        }
         $invalidAttendances = Yii::app()->db->createCommand("SELECT S.id , S.name  FROM sites S")->queryAll();
              

          $objPHPExcel = new PHPExcel();

        $objPHPExcel->setActiveSheetIndex(0)
                  ->setCellValue('A2', 'Average Cost Per Employee')
                ->setCellValue('E1', 'Generated On')
                ->setCellValue('F1', date("Y-m-d - h:i:sa"))
                ->setCellValue('A4', 'Date')
                 ->setCellValue('B4', 'Id')
                ->setCellValue('C4', 'name')
                ->setCellValue('D4', 'Value');
       
        $col = 6;
         $result = [];
        foreach($date as $aa){
                $subArray = [];
                $subArray['date'] = $aa;
             
             foreach ($invalidAttendances as $attendace ) {

                  $row = 0;

                $date1 = Yii::app()->db->createCommand("SELECT AE.date 
                FROM active_employee_count AE
                WHERE AE.site_id = '".$attendace['id']."' AND AE.date LIKE '%{$aa}%'")->queryScalar(); 

                //  $empCount quary is  correct 

                  $empCount = Yii::app()->db->createCommand("SELECT (sum(PI.CostOfCompany)/count(PI.id))  as overtimeSalary
                FROM payroll P 
                INNER JOIN payroll_items PI ON PI.Payroll_id = P.id
                 WHERE P.Status = 2 AND P.SiteId = '".$attendace['id']."'  AND P.StartDate LIKE '%{$aa}%' ")->queryScalar();  
                                                                  


                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$col,$date1);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$attendace['id']);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$attendace['name']);
              //  $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$empCount);
                

                if($empCount > 0){
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$empCount);
                }else{
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,0);
                }
                 $col++;
                 // print_r($attendace);die;
                //$subArray[$attendace['name']] = round($empCount,3); 
                
                }
                 //  array_push($result,$subArray);

                }
                //  $this->_sendResponse(200,CJSON::encode(array('$list' => $result)));

                $styleArray = array(
                'font'  => array(
                        'bold'  => true,
                        'color' => array('rgb' => '#f79727'),
                        'size'  => 10
                ));
                 $objPHPExcel->getActiveSheet()->getStyle('A1:I2')->applyFromArray($styleArray);

                //$objPHPExcel->getActiveSheet()->setTitle('sffd');

                $objPHPExcel->setActiveSheetIndex(0);

                ob_end_clean();
                ob_start();

                header('Content-Type: application/vnd.ms-excel');
                header('Content-Disposition: attachment;filename=AverageCostPerEmployeeReport.xls');
                header('Cache-Control: max-age=0');
                $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
                $objWriter->save('php://output');
        //  $this->_sendResponse(200,CJSON::encode(array("ccnn")));

                }

                public function actionDownloadAverageCostPerEmployeesss(){

                        $m = date('m');
                        $current_y = date('Y');
                        $previous_y = date('Y',strtotime('-1 year'));
                        $date = [];
                
                        if($m >= 4){
                                for($i=4;$i<=$m;$i++){
                                        array_push($date,$current_y.'-'.sprintf('%02d', $i).'-01');
                                }
                        }else{
                                $date = array($previous_y.'-04-01',$previous_y.'-05-01',$previous_y.'-06-01',$previous_y.'-07-01',$previous_y.'-08-01',$previous_y.'-09-01',$previous_y.'-10-01',$previous_y.'-11-01',$previous_y.'-12-01');
                                for($i=1;$i<=$m;$i++){
                                        array_push($date,$current_y.'-'.sprintf('%02d', $i).'-01');
                                }
                        }
                         $invalidAttendances = Yii::app()->db->createCommand("SELECT S.id , S.name  FROM sites S")->queryAll();
                              
                
                          $objPHPExcel = new PHPExcel();
                
                        $objPHPExcel->setActiveSheetIndex(0)
                                  ->setCellValue('A2', 'Average Cost Per Employee')
                                ->setCellValue('E1', 'Generated On')
                                ->setCellValue('F1', date("Y-m-d - h:i:sa"))
                                ->setCellValue('A4', 'Date')
                                 ->setCellValue('B4', 'Id')
                                ->setCellValue('C4', 'name')
                                ->setCellValue('D4', 'Value');
                       
                        $col = 6;
                         $result = [];
                        foreach($date as $aa){
                                $subArray = [];
                                $subArray['date'] = $aa;
                             
                             foreach ($invalidAttendances as $attendace ) {
                
                                  $row = 0;
                
                                $date1 = Yii::app()->db->createCommand("SELECT AE.date 
                                FROM active_employee_count AE
                                WHERE AE.site_id = '".$attendace['id']."' AND AE.date LIKE '%{$aa}%'")->queryScalar(); 
                
                                //  $empCount quary is  correct 
                
                                  $empCount = Yii::app()->db->createCommand("SELECT (sum(PI.CostOfCompany)/count(PI.id))  as overtimeSalary
                                FROM payroll P 
                                INNER JOIN payroll_items PI ON PI.Payroll_id = P.id
                                 WHERE P.Status = 2 AND P.SiteId = '".$attendace['id']."'  AND P.StartDate LIKE '%{$aa}%' ")->queryScalar();  
                                                                                  
                
                
                                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$col,$date1);
                                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$attendace['id']);
                                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$attendace['name']);
                              //  $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$empCount);
                                
                
                                if($empCount > 0){
                                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$empCount);
                                }else{
                                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,0);
                                }
                                 $col++;
                                 // print_r($attendace);die;
                                //$subArray[$attendace['name']] = round($empCount,3); 
                                
                                }
                                 //  array_push($result,$subArray);
                
                                }
                                //  $this->_sendResponse(200,CJSON::encode(array('$list' => $result)));
                
                                $styleArray = array(
                                'font'  => array(
                                        'bold'  => true,
                                        'color' => array('rgb' => '#f79727'),
                                        'size'  => 10
                                ));
                                 $objPHPExcel->getActiveSheet()->getStyle('A1:I2')->applyFromArray($styleArray);
                
                                //$objPHPExcel->getActiveSheet()->setTitle('sffd');
                
                                $objPHPExcel->setActiveSheetIndex(0);
                
                                ob_end_clean();
                                ob_start();
                
                                header('Content-Type: application/vnd.ms-excel');
                                header('Content-Disposition: attachment;filename=AverageCostPerEmployeeReport.xls');
                                header('Cache-Control: max-age=0');
                                $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
                                $objWriter->save('php://output');
                        //  $this->_sendResponse(200,CJSON::encode(array("ccnn")));
                
                                }


// stack
        public function actionSupplierWiseCost(){
                
                $date = date('Y-m-d', strtotime('first day of last month'));

                if(Yii::app()->user->isAdmin()){
                        $sites = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S")->queryAll();
                }else{
                        $sitid = Yii::app()->user->data()->SiteId;
                        $sites = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S WHERE S.id = $sitid ")->queryAll();
                }

                $mps = Yii::app()->db->createCommand("SELECT S.id,S.name FROM supplier S")->queryAll();

                $result = [];
                /*foreach($sites as $site){
                        $subArray = [];
                        $subArray['site'] = $site['name'];


                        $siteTotalCost = Yii::app()->db->createCommand("SELECT IFNULL(sum(PI.CostOfCompany),0)
                                FROM payroll P 
                                INNER JOIN payroll_items PI ON PI.Payroll_id = P.id
                                WHERE P.Status = 2 AND P.SiteId = '".$site['id']."' AND P.StartDate = '".$date."'")->queryScalar();  

                        foreach($mps as $mp){

                                $averageCoust = Yii::app()->db->createCommand("SELECT IFNULL(sum(PI.CostOfCompany),0)
                                        FROM payroll P 
                                        INNER JOIN payroll_items PI ON PI.Payroll_id = P.id
                                        WHERE P.Status = 2 AND P.SiteId = '".$site['id']."' AND P.StartDate = '".$date."' AND PI.MPSupplierid = '".$mp['id']."' ")->queryScalar();  

                                if($averageCoust > 0){
                                        $subArray[$mp['name']] = round(($averageCoust/$siteTotalCost)*100,2);
                                }else{
                                        $subArray[$mp['name']] = $averageCoust;
                                }
                        }
                        array_push($result,$subArray);
                }*/
                // print_r($result);die;
                $this->_sendResponse(200,CJSON::encode(array('$list' => $result)));

                
        }

        public function actionDownloadSupplierWiseCost(){

                $date = date('Y-m-d', strtotime('first day of last month'));

                 $invalidAttendances = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S")->queryAll();

                 $mps = Yii::app()->db->createCommand("SELECT S.id,S.name FROM supplier S")->queryAll();


              $objPHPExcel = new PHPExcel();
      
              $objPHPExcel->setActiveSheetIndex(0)
              ->setCellValue('A2', 'Supplier WiseCost')
             ->setCellValue('E1', 'Generated On')
             ->setCellValue('F1', date("Y-m-d - h:i:sa"))
              ->setCellValue('A4', 'Id')
              ->setCellValue('B4', 'Name')
              ->setCellValue('C4', 'averageCoust')
              ->setCellValue('D4', 'siteTotalCost')
              ->setCellValue('E4', 'SupplierWiseCost');
              

              $col = 6;
      
                    $result = [];
         foreach($invalidAttendances as $attendace){
                              $subArray = [];
                              $subArray['site'] = $attendace['name'];
            
                              $siteTotalCost = Yii::app()->db->createCommand("SELECT IFNULL(sum(PI.CostOfCompany),0)
                              FROM payroll P 
                              INNER JOIN payroll_items PI ON PI.Payroll_id = P.id
                              WHERE P.Status = 2 AND P.SiteId = '".$attendace['id']."' AND P.StartDate = '".$date."'")->queryScalar();  



                foreach($mps as $mp){

                      $row = 0;

                
                $averageCoust = Yii::app()->db->createCommand("SELECT IFNULL(sum(PI.CostOfCompany),0)
                FROM payroll P 
                INNER JOIN payroll_items PI ON PI.Payroll_id = P.id
                WHERE P.Status = 2 AND P.SiteId = '".$attendace['id']."' AND P.StartDate = '".$date."' AND PI.MPSupplierid = '".$mp['id']."' ")->queryScalar();  

                      $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$col,$attendace['id']);
                      $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$attendace['name']);
                      $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col, $siteTotalCost );
                     $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,  $averageCoust );
                   
                      if($averageCoust > 0){
                        $x =    round(($averageCoust/$siteTotalCost)*100);
                      $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,   $x );
                      }
                      else{
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col, $averageCoust);
                            }


                      $col++;
      
              // print_r($attendace);die;
              // $subArray[$attendace['name']] = round($empCount,3); 
                // $subArray[$attendace['name']] =  $empCount;
              
              }

             // array_push($result,$subArray);

                $styleArray = array(
              'font'  => array(
                      'bold'  => true,
                      'color' => array('rgb' => '#f79727'),
                      'size'  => 10
              ));
      
                $objPHPExcel->getActiveSheet()->getStyle('A1:I2')->applyFromArray($styleArray);
      
              //$objPHPExcel->getActiveSheet()->setTitle('sffd');
      
              $objPHPExcel->setActiveSheetIndex(0);
      
              ob_end_clean();
              ob_start();
      
              header('Content-Type: application/vnd.ms-excel');
              header('Content-Disposition: attachment;filename=SupplierWiseCostReport.xls');
              header('Cache-Control: max-age=0');
              $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
              $objWriter->save('php://output');
            //  $this->_sendResponse(200,CJSON::encode(array("ccnn")));
      
      }
}




//stack
         public function actionDepartmentWiseCost(){
                
                $date = date('Y-m-d', strtotime('first day of last month'));
                
                if(Yii::app()->user->isAdmin()){
                        $sites = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S")->queryAll();
                }else{
                        $sitid = Yii::app()->user->data()->SiteId;
                        $sites = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S WHERE S.id = $sitid ")->queryAll();
                }
                

                $result = [];
               /* foreach($sites as $site){
                        $subArray = [];
                        $subArray['site'] = $site['name'];
                        $dps = Yii::app()->db->createCommand("SELECT D.id,D.name FROM department D WHERE D.siteid = '".$site['id']."'")->queryAll();


                        $siteTotalCost = Yii::app()->db->createCommand("SELECT IFNULL(sum(PI.CostOfCompany),0)
                                FROM payroll P 
                                INNER JOIN payroll_items PI ON PI.Payroll_id = P.id
                                WHERE P.Status = 2 AND P.SiteId = '".$site['id']."' AND P.StartDate = '".$date."'")->queryScalar();  

                        foreach($dps as $dp){
                                $averageCoust = Yii::app()->db->createCommand("SELECT IFNULL(sum(PI.CostOfCompany),0)
                                        FROM payroll P 
                                        INNER JOIN payroll_items PI ON PI.Payroll_id = P.id
                                        WHERE P.Status = 2 AND P.SiteId = '".$site['id']."' AND P.StartDate = '".$date."' AND PI.Departmentid = '".$dp['id']."' ")->queryScalar();  

                                if($averageCoust > 0){
                                        $subArray[$dp['name']] = round(($averageCoust/$siteTotalCost)*100,2);
                                }else{
                                        $subArray[$dp['name']] = $averageCoust;
                                }
                        }
                        array_push($result,$subArray);
                }*/
                // print_r($result);die;
                $this->_sendResponse(200,CJSON::encode(array('$list' => $result)));

                
         }

         public function actionDownloadDepartmentWiseCost(){

                $date = date('Y-m-d', strtotime('first day of last month'));

                if(Yii::app()->user->isAdmin()){
                        $invalidAttendances = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S")->queryAll();
                }else{
                        $sitid = Yii::app()->user->data()->SiteId;
                        $invalidAttendances = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S WHERE S.id = $sitid ")->queryAll();
                }
                
              $objPHPExcel = new PHPExcel();
      
              $objPHPExcel->setActiveSheetIndex(0)
              ->setCellValue('A2', 'Department WiseCost')
             ->setCellValue('E1', 'Generated On')
             ->setCellValue('F1', date("Y-m-d - h:i:sa"))
             ->setCellValue('A4', 'Site_Id')
              ->setCellValue('B4', 'Site_Name')
              ->setCellValue('C4', 'Dep_Id')
              ->setCellValue('D4', 'Dep_Name')
            //  ->setCellValue('D4', 'siteTotalCost')
              ->setCellValue('E4', 'SupplierWiseCost');
              

              $col = 6;
      
                    $result = [];
                foreach($invalidAttendances as $attendace){
                              $subArray = [];
                              $subArray['site'] = $attendace['name'];
                              $dps = Yii::app()->db->createCommand("SELECT D.id,D.name FROM department D WHERE D.siteid = '".$attendace['id']."'")->queryAll();


                              $siteTotalCost = Yii::app()->db->createCommand("SELECT IFNULL(sum(PI.CostOfCompany),0)
                              FROM payroll P 
                              INNER JOIN payroll_items PI ON PI.Payroll_id = P.id
                              WHERE P.Status = 2 AND P.SiteId = '".$attendace['id']."' AND P.StartDate = '".$date."'")->queryScalar();  


                foreach($dps as $dp){

                      $row = 0;

                      $averageCoust = Yii::app()->db->createCommand("SELECT IFNULL(sum(PI.CostOfCompany),0)
                      FROM payroll P 
                      INNER JOIN payroll_items PI ON PI.Payroll_id = P.id
                      WHERE P.Status = 2 AND P.SiteId = '".$attendace['id']."' AND P.StartDate = '".$date."' AND PI.Departmentid = '".$dp['id']."' ")->queryScalar();  

                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$col,$attendace['id']);
                         $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$attendace['name']);
                      $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$dp['id']);
                      $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$dp['name']);
                  
                      if($averageCoust > 0){
                        $x =    round(($averageCoust/$siteTotalCost)*100);
                      $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,   $x );
                      }
                      else{
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col, $averageCoust);
                            }


                      $col++;
      
              // print_r($attendace);die;
              // $subArray[$attendace['name']] = round($empCount,3); 
                // $subArray[$attendace['name']] =  $empCount;
              
              }

             // array_push($result,$subArray);

                $styleArray = array(
              'font'  => array(
                      'bold'  => true,
                      'color' => array('rgb' => '#f79727'),
                      'size'  => 10
              ));
      
                $objPHPExcel->getActiveSheet()->getStyle('A1:I2')->applyFromArray($styleArray);
      
              //$objPHPExcel->getActiveSheet()->setTitle('sffd');
      
              $objPHPExcel->setActiveSheetIndex(0);
      
              ob_end_clean();
              ob_start();
      
              header('Content-Type: application/vnd.ms-excel');
              header('Content-Disposition: attachment;filename=Department WiseCostReport.xls');
              header('Cache-Control: max-age=0');
              $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
              $objWriter->save('php://output');
            //  $this->_sendResponse(200,CJSON::encode(array("ccnn")));
      
      }
}

//line
         public function actionAdhocTrend(){
                
                $m = date('m');
                $current_y = date('Y');
                $previous_y = date('Y',strtotime('-1 year'));
                $date = [];

                if($m >= 4){
                        for($i=4;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i));
                        }
                }else{
                        $date = array($previous_y.'-04',$previous_y.'-05',$previous_y.'-06',$previous_y.'-07',$previous_y.'-08',$previous_y.'-09',$previous_y.'-10',$previous_y.'-11',$previous_y.'-12');
                        for($i=1;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i));
                        }
                }

                if(Yii::app()->user->isAdmin()){
                        $sites = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S")->queryAll();
                }else{
                        $sitid = Yii::app()->user->data()->SiteId;
                        $sites = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S WHERE S.id = $sitid ")->queryAll();
                }

                $result = [];
                foreach($date as $aa){
                        $subArray = [];
                        $subArray['date'] = $aa;
                        foreach($sites as $site){
                                $totalSalary = Yii::app()->db->createCommand("SELECT IFNULL(SUM(T.cost_to_company),0)
                                FROM adhoc_cadre_employees E 
                                INNER JOIN adhoc_cadre_timelog T ON T.adhoc_employee_id = E.id
                                WHERE E.site_id = '".$site['id']."' AND T.in_time LIKE '%{$aa}%'")->queryScalar();  

                                $subArray[$site['name']] = round($totalSalary,2);
                        }
                        array_push($result,$subArray);
                }
                // print_r($result);die;
                $this->_sendResponse(200,CJSON::encode(array('$list' => $result)));
         }
// line
         public function actionDownloadAdhocTrend(){

                $m = date('m');
                $current_y = date('Y');
                $previous_y = date('Y',strtotime('-1 year'));
                $date = [];

                if($m >= 4){
                        for($i=4;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i));
                        }
                }else{
                        $date = array($previous_y.'-04',$previous_y.'-05',$previous_y.'-06',$previous_y.'-07',$previous_y.'-08',$previous_y.'-09',$previous_y.'-10',$previous_y.'-11',$previous_y.'-12');
                        for($i=1;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i));
                        }
                }


                 $invalidAttendances = Yii::app()->db->createCommand("SELECT S.id , S.name  FROM sites S")->queryAll();
                      
       
                  $objPHPExcel = new PHPExcel();
        
                $objPHPExcel->setActiveSheetIndex(0)
                ->setCellValue('A2', 'Adhoc Trend')
               ->setCellValue('E1', 'Generated On')
               ->setCellValue('F1', date("Y-m-d - h:i:sa"))
               ->setCellValue('A4', 'Date')
                ->setCellValue('B4', 'Id')
                ->setCellValue('C4', 'Name')
                ->setCellValue('D4', 'Value');
               
                $col = 6;
                 $result = [];
                foreach($date as $aa){
                        $subArray = [];
                        $subArray['date'] = $aa;
                     
                     foreach ($invalidAttendances as $attendace )
                      {             $row = 0;

                                        $date1 = Yii::app()->db->createCommand("SELECT AE.date 
                                        FROM active_employee_count AE
                                        WHERE AE.site_id = '".$attendace['id']."' AND AE.date LIKE '%{$aa}%'")->queryScalar(); 

                                        //  $empCount quary is  correct 

                                        $empCount = Yii::app()->db->createCommand("SELECT SUM(T.cost_to_company)
                                        FROM adhoc_cadre_employees E 
                                        INNER JOIN adhoc_cadre_timelog T ON T.adhoc_employee_id = E.id
                                        WHERE E.site_id = '".$attendace['id']."' AND T.in_time LIKE '%{$aa}%' ")->queryScalar();  
                                                                                        

                                        //  AND P.StartDate LIKE '%{$aa}%'

                                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$col,$date1);
                                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$attendace['id']);
                                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$attendace['name']);
                                //  $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$empCount);
                        
                                if($empCount > 0){
                                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$empCount);
                                }else{
                                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,0);
                                }
                                $col++;
                                
                                        // print_r($attendace);die;
                                        //$subArray[$attendace['name']] = round($empCount,3); 
                                }
                    //array_push($result,$subArray);

                   }
                   // $this->_sendResponse(200,CJSON::encode(array('$list' => $result)));

                        $styleArray = array(
                        'font'  => array(
                                'bold'  => true,
                                'color' => array('rgb' => '#f79727'),
                                'size'  => 10
                        ));
        
               
                $objPHPExcel->getActiveSheet()->getStyle('A1:I2')->applyFromArray($styleArray);
        
                //$objPHPExcel->getActiveSheet()->setTitle('sffd');
        
                $objPHPExcel->setActiveSheetIndex(0);
        
                ob_end_clean();
                ob_start();
        
                header('Content-Type: application/vnd.ms-excel');
                header('Content-Disposition: attachment;filename=AdhocTrendReport.xls');
                header('Cache-Control: max-age=0');
                $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
                $objWriter->save('php://output');
              //  $this->_sendResponse(200,CJSON::encode(array("ccnn")));
          }
//line

        public function actionPayrollAndAdhocTrend(){
                
                $m = date('m');
                $current_y = date('Y');
                $previous_y = date('Y',strtotime('-1 year'));
                $date = [];

                if($m >= 4){
                        for($i=4;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i));
                        }
                }else{
                        $date = array($previous_y.'-04',$previous_y.'-05',$previous_y.'-06',$previous_y.'-07',$previous_y.'-08',$previous_y.'-09',$previous_y.'-10',$previous_y.'-11',$previous_y.'-12');
                        for($i=1;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i));
                        }
                }

                if(Yii::app()->user->isAdmin()){
                        $sites = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S")->queryAll();
                }else{
                        $sitid = Yii::app()->user->data()->SiteId;
                        $sites = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S WHERE S.id = $sitid ")->queryAll();
                }

                $result = [];
                foreach($date as $aa){
                        $subArray = [];
                        $subArray['date'] = $aa;
                        foreach($sites as $site){
                                $adhoc = Yii::app()->db->createCommand("SELECT IFNULL(SUM(T.cost_to_company),0)
                                        FROM adhoc_cadre_employees E 
                                        INNER JOIN adhoc_cadre_timelog T ON T.adhoc_employee_id = E.id
                                        WHERE E.site_id = '".$site['id']."' AND T.in_time LIKE '%{$aa}%'")->queryScalar();  

                                $payroll = Yii::app()->db->createCommand("SELECT IFNULL(sum(PI.BasicWage),0)
                                        FROM payroll P 
                                        INNER JOIN payroll_items PI ON PI.Payroll_id = P.id
                                        WHERE P.Status = 2 AND P.SiteId = '".$site['id']."' AND P.StartDate LIKE '%{$aa}%' ")->queryScalar();

                                                                                

                                $subArray[$site['name']] = round($adhoc + $payroll,2);

                        }
                        array_push($result,$subArray);
                }
                // print_r($result);die;
                $this->_sendResponse(200,CJSON::encode(array('$list' => $result)));
      
        }
 //line       
         public function actionDownloadPayrollAndAdhocTrend(){

                $m = date('m');
                $current_y = date('Y');
                $previous_y = date('Y',strtotime('-1 year'));
                $date = [];
                if($m >= 4){
                        for($i=4;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i));
                        }
                }else{
                        $date = array($previous_y.'-04',$previous_y.'-05',$previous_y.'-06',$previous_y.'-07',$previous_y.'-08',$previous_y.'-09',$previous_y.'-10',$previous_y.'-11',$previous_y.'-12');
                        for($i=1;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i));
                        }
                }


                       
                if(Yii::app()->user->isAdmin()){
                        $invalidAttendances = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S")->queryAll();
                }else{
                        $sitid = Yii::app()->user->data()->SiteId;
                        $invalidAttendances = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S WHERE S.id = $sitid ")->queryAll();
                }


               //  $invalidAttendances = Yii::app()->db->createCommand("SELECT S.id , S.name  FROM sites S")->queryAll();
                      
       
                  $objPHPExcel = new PHPExcel();
        
                $objPHPExcel->setActiveSheetIndex(0)
               ->setCellValue('A1', 'Payroll And Adhoc Trend')
               ->setCellValue('E1', 'Generated On')
               ->setCellValue('F1', date("Y-m-d - h:i:sa"))
               ->setCellValue('A4', 'Date')
                ->setCellValue('B4', 'Id')
                ->setCellValue('C4', 'Name')
                ->setCellValue('D4', 'Value');
               
                $col = 6;
                 $result = [];
                foreach($date as $aa){
                        $subArray = [];
                        $subArray['date'] = $aa;
                     
                     foreach ($invalidAttendances as $attendace ) {
        
                          $row = 0;

                        $date1 = Yii::app()->db->createCommand("SELECT AE.date 
                        FROM active_employee_count AE
                        WHERE AE.site_id = '".$attendace['id']."' AND AE.date LIKE '%{$aa}%'")->queryScalar(); 

                        //  $empCount quary is  correct 

                        $adhoc = Yii::app()->db->createCommand("SELECT IFNULL(SUM(T.cost_to_company),0)
                        FROM adhoc_cadre_employees E 
                        INNER JOIN adhoc_cadre_timelog T ON T.adhoc_employee_id = E.id
                        WHERE E.site_id = '".$attendace['id']."' AND T.in_time LIKE '%{$aa}%'")->queryScalar();  

                         $payroll = Yii::app()->db->createCommand("SELECT IFNULL(sum(PI.BasicWage),0)
                        FROM payroll P 
                        INNER JOIN payroll_items PI ON PI.Payroll_id = P.id
                        WHERE P.Status = 2 AND P.SiteId = '".$attendace['id']."' AND P.StartDate LIKE '%{$aa}%' ")->queryScalar();
                                      
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$col,$date1);
                       $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$attendace['id']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$attendace['name']);
                       // $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$payroll);
                        
                        
                        if($payroll > 0){
                                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$payroll);
                        }else{
                                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,0);
                        }
        



                         $col++;
           
                     // print_r($attendace);die;
                    // $subArray[$attendace['name']] = round($adhoc + $payroll,2);
                      
                }
        
                    //array_push($result,$subArray);

                }
        
                  // $this->_sendResponse(200,CJSON::encode(array('$list' => $result)));

                $styleArray = array(
                'font'  => array(
                        'bold'  => true,
                        'color' => array('rgb' => '#f79727'),
                        'size'  => 10
                ));
        
               
                $objPHPExcel->getActiveSheet()->getStyle('A1:I2')->applyFromArray($styleArray);
        
                //$objPHPExcel->getActiveSheet()->setTitle('sffd');
        
                $objPHPExcel->setActiveSheetIndex(0);
        
                ob_end_clean();
                ob_start();
        
                header('Content-Type: application/vnd.ms-excel');
                header('Content-Disposition: attachment;filename=PayrollAndAdhocTrendReport.xls');
                header('Cache-Control: max-age=0');
                $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
                $objWriter->save('php://output');
              //  $this->_sendResponse(200,CJSON::encode(array("ccnn")));
        
        }
//line
        public function actionTotalNumOfEmp(){
                
                $m = date('m');
                $current_y = date('Y');
                $previous_y = date('Y',strtotime('-1 year'));
                $date = [];

                if($m >= 4){
                        for($i=4;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i));
                        }
                }else{
                        $date = array($previous_y.'-04',$previous_y.'-05',$previous_y.'-06',$previous_y.'-07',$previous_y.'-08',$previous_y.'-09',$previous_y.'-10',$previous_y.'-11',$previous_y.'-12');
                        for($i=1;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i));
                        }
                }

                if(Yii::app()->user->isAdmin()){
                        $sites = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S")->queryAll();
                }else{
                        $sitid = Yii::app()->user->data()->SiteId;
                        $sites = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S WHERE S.id = $sitid ")->queryAll();
                }

                

                $result = [];
                foreach($date as $aa){
                        $subArray = [];
                        $subArray['date'] = $aa;
                        foreach($sites as $site){

                                $empCount = Yii::app()->db->createCommand("SELECT IFNULL(AE.count_of_begin,0) 
                                FROM active_employee_count AE
                                WHERE AE.site_id = '".$site['id']."' AND AE.date LIKE '%{$aa}%'")->queryScalar(); 

                                      //  print_r($empCount);die;


                                if($empCount == ''){
                                        $empCount = 0;
                                }

                                $subArray[$site['name']] = $empCount;
                        }
                        array_push($result,$subArray);
                }
                // print_r($result);die;
                $this->_sendResponse(200,CJSON::encode(array('$list' => $result)));

                
        }
//line
        public function actionEmpTurnover(){
                
                $m = date('m');
                $current_y = date('Y');
                $previous_y = date('Y',strtotime('-1 year'));
                $date = [];

                if($m >= 4){
                        for($i=4;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i));
                        }
                }else{
                        $date = array($previous_y.'-04',$previous_y.'-05',$previous_y.'-06',$previous_y.'-07',$previous_y.'-08',$previous_y.'-09',$previous_y.'-10',$previous_y.'-11',$previous_y.'-12');
                        for($i=1;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i));
                        }
                }

                if(Yii::app()->user->isAdmin()){
                        $sites = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S")->queryAll();
                }else{
                        $sitid = Yii::app()->user->data()->SiteId;
                        $sites = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S WHERE S.id = $sitid ")->queryAll();
                }

                

                $result = [];
                /*foreach($date as $aa){
                        $subArray = [];
                        $subArray['date'] = $aa;
                        foreach($sites as $site){

                                $empCount = Yii::app()->db->createCommand("SELECT IFNULL(AE.count_of_begin,0) 
                                FROM active_employee_count AE
                                WHERE AE.site_id = '".$site['id']."' AND AE.date LIKE '%{$aa}%'")->queryScalar(); 

                                $resignEmpCount = Yii::app()->db->createCommand("SELECT RE.count 
                                FROM resign_employee_count RE 
                                WHERE RE.site_id = '".$site['id']."' AND RE.date LIKE '%{$aa}%'")->queryScalar(); 

                                $AvgEmpCount = Yii::app()->db->createCommand("SELECT ((AE.count_of_begin + AE.count_of_end)/2) as empcount
                                        FROM active_employee_count AE
                                        WHERE AE.site_id = '".$site['id']."' AND AE.date LIKE '%{$aa}%'")->queryScalar(); 

                                if($resignEmpCount == ''){
                                        $resignEmpCount = 0;
                                }
                                if($AvgEmpCount == '' || $AvgEmpCount == 0){
                                        $AvgEmpCount = 1;
                                }

                                $subArray[$site['name']] = round(($resignEmpCount/$AvgEmpCount)*100,2);
                        }
                        array_push($result,$subArray);
                }*/
                
                $this->_sendResponse(200,CJSON::encode(array('$list' => $result)));

                
        }
//line
        public function actionDownloadEmpTurnover(){

                  $m = date('m');
                $current_y = date('Y');
                $previous_y = date('Y',strtotime('-1 year'));
                $date = [];

                if($m >= 4){
                        for($i=4;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i));
                        }
                }else{
                        $date = array($previous_y.'-04',$previous_y.'-05',$previous_y.'-06',$previous_y.'-07',$previous_y.'-08',$previous_y.'-09',$previous_y.'-10',$previous_y.'-11',$previous_y.'-12');
                        for($i=1;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i));
                        }
                }

                       
                if(Yii::app()->user->isAdmin()){
                        $invalidAttendances = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S")->queryAll();
                }else{
                        $sitid = Yii::app()->user->data()->SiteId;
                        $invalidAttendances = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S WHERE S.id = $sitid ")->queryAll();
                }
 
                $objPHPExcel = new PHPExcel();
        
                $objPHPExcel->setActiveSheetIndex(0)
                ->setCellValue('A2', 'Employee Turnover')
               ->setCellValue('E1', 'Generated On')
               ->setCellValue('F1', date("Y-m-d - h:i:sa"))
                ->setCellValue('A4', 'Date')
                ->setCellValue('B4', 'Id')
                ->setCellValue('C4', 'Name')
                ->setCellValue('D4', 'ResignEmpCount')
                ->setCellValue('E4', 'AvgEmpCount')
                ->setCellValue('F4', 'Turnover');

                $col = 6;
        
                  $result = [];
                foreach($date as $aa){
                        $subArray = [];
                        $subArray['date'] = $aa;
                
                foreach ($invalidAttendances as $attendace ) {

                        $row = 0;

                        $date1 = Yii::app()->db->createCommand("SELECT AE.date 
                        FROM active_employee_count AE
                        WHERE AE.site_id = '".$attendace['id']."' AND AE.date LIKE '%{$aa}%'")->queryScalar(); 



                        $resignEmpCount = Yii::app()->db->createCommand("SELECT RE.count 
                                FROM resign_employee_count RE 
                                WHERE RE.site_id = '".$attendace['id']."' AND RE.date LIKE '%{$aa}%'")->queryScalar(); 

                        $AvgEmpCount = Yii::app()->db->createCommand("SELECT ((AE.count_of_begin + AE.count_of_end)/2) 
                                        FROM active_employee_count AE
                                        WHERE AE.site_id = '".$attendace['id']."' AND AE.date LIKE '%{$aa}%'")->queryScalar(); 

                                if($resignEmpCount == ''){
                                        $resignEmpCount = 0;
                                }
                                if($AvgEmpCount == '' || $AvgEmpCount == 0){
                                        $AvgEmpCount = 1;
                                }

                                $x =    round(($resignEmpCount/$AvgEmpCount)*100);

                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$col,$date1);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$attendace['id']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$attendace['name']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col, $resignEmpCount );
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col, $AvgEmpCount );
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,     $x);
        
                        $col++;
        
                // print_r($attendace);die;
                // $subArray[$attendace['name']] = round($empCount,3); 
                  // $subArray[$attendace['name']] =  $empCount;
                
                }

               // array_push($result,$subArray);

                  $styleArray = array(
                'font'  => array(
                        'bold'  => true,
                        'color' => array('rgb' => '#f79727'),
                        'size'  => 10
                ));
        
                  $objPHPExcel->getActiveSheet()->getStyle('A1:I2')->applyFromArray($styleArray);
        
                //$objPHPExcel->getActiveSheet()->setTitle('sffd');
        
                $objPHPExcel->setActiveSheetIndex(0);
        
                ob_end_clean();
                ob_start();
        
                header('Content-Type: application/vnd.ms-excel');
                header('Content-Disposition: attachment;filename=EmpTurnoverReport.xls');
                header('Cache-Control: max-age=0');
                $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
                $objWriter->save('php://output');
              //  $this->_sendResponse(200,CJSON::encode(array("ccnn")));
        
        }
}
//line
        public function actionMonthlySummery(){
                $previous_month = date('Y-m',strtotime('first day of last month'));
                $sitid = Yii::app()->user->data()->SiteId;
                
                $empCount = Yii::app()->db->createCommand("SELECT count(*) 
                        FROM payroll P 
                        INNER JOIN payroll_items PI ON PI.Payroll_id = P.id
                        WHERE P.StartDate LIKE '%{$previous_month}%' AND P.SiteId = $sitid AND P.PayrollMethod != 'PIECE-RATE'")->queryScalar();  

                $ttlOTHours = Yii::app()->db->createCommand("SELECT SUM(PI.NOTHour + PI.DOTHour + PI.TOTHour)
                        FROM payroll P 
                        INNER JOIN payroll_items PI ON PI.Payroll_id = P.id
                        WHERE P.StartDate LIKE '%{$previous_month}%' AND P.SiteId = $sitid AND P.PayrollMethod != 'PIECE-RATE'")->queryScalar();

                $ttlOTCost = Yii::app()->db->createCommand("SELECT SUM(PI.NOT + PI.DOT + PI.TOTHour)
                        FROM payroll P 
                        INNER JOIN payroll_items PI ON PI.Payroll_id = P.id
                        WHERE P.StartDate LIKE '%{$previous_month}%' AND P.SiteId = $sitid AND P.PayrollMethod != 'PIECE-RATE'")->queryScalar();

                $ttl_day_wage = Yii::app()->db->createCommand("SELECT SUM(PI.TotalNet)
                        FROM payroll P 
                        INNER JOIN payroll_items PI ON PI.Payroll_id = P.id
                        WHERE P.StartDate LIKE '%{$previous_month}%' AND P.SiteId = $sitid AND P.PayrollMethod != 'PIECE-RATE'")->queryScalar();

                $ttl_mp_cost = Yii::app()->db->createCommand("SELECT SUM(PI.ContractorFee)
                        FROM payroll P 
                        INNER JOIN payroll_items PI ON PI.Payroll_id = P.id
                        WHERE P.StartDate LIKE '%{$previous_month}%' AND P.SiteId = $sitid AND P.PayrollMethod != 'PIECE-RATE'")->queryScalar();

                $ttlWorkedHours = Yii::app()->db->createCommand("SELECT SUM(T.WorkedHour) 
                        FROM timesheet T
                        WHERE T.SiteId = 3 AND T.date LIKE '%{$previous_month}%' AND T.PaymentMethod != 'PIECE-RATE'")->queryScalar();

                $ttl_NOT_hr = Yii::app()->db->createCommand("SELECT SUM(PI.NOTHour)
                        FROM payroll P 
                        INNER JOIN payroll_items PI ON PI.Payroll_id = P.id
                        WHERE P.StartDate LIKE '%{$previous_month}%' AND P.SiteId = $sitid AND P.PayrollMethod != 'PIECE-RATE'")->queryScalar();

                $ttl_DOT_hr = Yii::app()->db->createCommand("SELECT SUM(PI.DOTHour)
                        FROM payroll P 
                        INNER JOIN payroll_items PI ON PI.Payroll_id = P.id
                        WHERE P.StartDate LIKE '%{$previous_month}%' AND P.SiteId = $sitid AND P.PayrollMethod != 'PIECE-RATE'")->queryScalar();

                $empCount = $empCount == '' ? 0 : $empCount;
                $ttlOTHours = $ttlOTHours == '' ? 0 : $ttlOTHours;
                $ttlOTCost = $ttlOTCost == '' ? 0 : $ttlOTCost;
                $ttl_day_wage = $ttl_day_wage == '' ? 0 : $ttl_day_wage;
                $ttl_mp_cost = $ttl_mp_cost == '' ? 0 : $ttl_mp_cost;
                $ttlWorkedHours = $ttlWorkedHours == '' ? 0 : $ttlWorkedHours;
                $ttl_NOT_hr = $ttl_NOT_hr == '' ? 0 : $ttl_NOT_hr;
                $ttl_DOT_hr = $ttl_DOT_hr == '' ? 0 : $ttl_DOT_hr;

                $total_hrs = $ttlOTHours + $ttlWorkedHours;
                $tmp_emp_count = $empCount;

                $total_hrs = $total_hrs == 0 ? 1 : $total_hrs;
                $tmp_emp_count = $tmp_emp_count == 0 ? 1 : $tmp_emp_count;


                $NOT_avg = ($ttl_NOT_hr/$total_hrs)*100;

                $DOT_avg = ($ttl_DOT_hr/$total_hrs)*100;

                $worked_hr_per_head = $ttlWorkedHours/$tmp_emp_count;

                $ot_hr_per_head = $ttlOTHours/$tmp_emp_count;


                $this->_sendResponse(200,CJSON::encode(array('$list' => ['total_ot_hrs'=>round($ttlOTHours,2),'total_worked_hrs'=>round($ttlWorkedHours,2),
                'Not_avg'=>round($NOT_avg,2).'%','Dot_avg'=>round($DOT_avg,2).'%','Tot_avg'=>round($NOT_avg+$DOT_avg,2).'%','man_hr_hd'=>round($worked_hr_per_head,2),'ot_hr_hd'=>round($ot_hr_per_head,2),
                'ttl_ot_cost'=>round($ttlOTCost,2),'ttl_day_wage'=>round($ttl_day_wage,2),'ttl_mp_cost'=>round($ttl_mp_cost,2)])));
        }
//line

        public function actionAbsenteeismRate(){
                
                $m = date('m');
                $current_y = date('Y');
                $previous_y = date('Y',strtotime('-1 year'));
                $date = [];

                if($m >= 4){
                        for($i=4;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i));
                        }
                }else{
                        $date = array($previous_y.'-04',$previous_y.'-05',$previous_y.'-06',$previous_y.'-07',$previous_y.'-08',$previous_y.'-09',$previous_y.'-10',$previous_y.'-11',$previous_y.'-12');
                        for($i=1;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i));
                        }
                }

                if(Yii::app()->user->isAdmin()){
                        $sites = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S")->queryAll();
                }else{
                        $sitid = Yii::app()->user->data()->SiteId;
                        $sites = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S WHERE S.id = $sitid ")->queryAll();
                }

                   $result = [];
                foreach($date as $aa){
                        $subArray = [];
                        $subArray['date'] = $aa;
                        foreach($sites as $site){

                                $rate = Yii::app()->db->createCommand("SELECT S.absenteeism_rate 
                                FROM sitewise_absentdays_and_worlkingdays S
                                WHERE S.site = '".$site['id']."' AND S.date LIKE '%$aa%'")->queryScalar(); 

                                if($rate == ''){
                                        $rate = '0';
                                }

                                $subArray[$site['name']] = $rate;
                        }
                        array_push($result,$subArray);
                }
                // print_r($result);die;
                $this->_sendResponse(200,CJSON::encode(array('$list' => $result)));
  }
   // line
        public function actionDownloadAbsenteeismRate(){

                $m = date('m');
                $current_y = date('Y');
                $previous_y = date('Y',strtotime('-1 year'));
                $date = [];

                if($m >= 4){       
                        for($i=4;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i));
                        }
                  }
        
                else{
                        $date = array($previous_y.'-04',$previous_y.'-05',$previous_y.'-06',$previous_y.'-07',$previous_y.'-08',$previous_y.'-09',$previous_y.'-10',$previous_y.'-11',$previous_y.'-12');
                        for($i=1;$i<=$m;$i++){
                                array_push($date,$current_y.'-'.sprintf('%02d', $i));
                        }
                }

                  if(Yii::app()->user->isAdmin()){
                        $invalidAttendances = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S")->queryAll();
                }else{
                        $sitid = Yii::app()->user->data()->SiteId;
                        $invalidAttendances = Yii::app()->db->createCommand("SELECT S.id,S.name FROM sites S WHERE S.id = $sitid ")->queryAll();
                }
 



              //  $invalidAttendances = Yii::app()->db->createCommand("SELECT S.id , S.name  FROM sites S")->queryAll();
                

                $objPHPExcel = new PHPExcel();

                $objPHPExcel->setActiveSheetIndex(0)
                 ->setCellValue('A2', 'Absenteeism Rate')
                ->setCellValue('E1', 'Generated On')
                ->setCellValue('F1', date("Y-m-d - h:i:sa"))
                ->setCellValue('A4', 'Date')
                 ->setCellValue('B4', 'Id')
                ->setCellValue('C4', 'SiteName')
                ->setCellValue('D4', 'Value');
        
                $col = 6;
                $result = [];
                foreach($date as $aa){
                        $subArray = [];
                        $subArray['date'] = $aa;
                
                foreach ($invalidAttendances as $attendace ) {

                        $row = 0;

                        $date1 = Yii::app()->db->createCommand("SELECT AE.date 
                        FROM active_employee_count AE
                        WHERE AE.site_id = '".$attendace['id']."' AND AE.date LIKE '%{$aa}%'")->queryScalar(); 

                        //  $empCount quary is  correct 

                        $empCount = Yii::app()->db->createCommand("SELECT S.absenteeism_rate 
                        FROM sitewise_absentdays_and_worlkingdays S
                        WHERE S.site = '".$attendace['id']."' AND S.date LIKE '%$aa%' ")->queryScalar();  
                                                                        


                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$col,$date1);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$attendace['id']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$attendace['name']);
                       // $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$empCount);
                        
                        if($empCount > 0){
                                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$empCount);
                        }else{
                                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,0);
                        }



                        $col++;
        
                // print_r($attendace);die;
                // $subArray[$attendace['name']] = round($empCount,3); 
                  // $subArray[$attendace['name']] =  $empCount;
                
                }

               // array_push($result,$subArray);

                                        }

              //  $this->_sendResponse(200,CJSON::encode(array('$list' => $result)));

                $styleArray = array(
                'font'  => array(
                        'bold'  => true,
                        'color' => array('rgb' => '#f79727'),
                        'size'  => 10
                ));

        
                $objPHPExcel->getActiveSheet()->getStyle('A1:I2')->applyFromArray($styleArray);

                //$objPHPExcel->getActiveSheet()->setTitle('sffd');

                $objPHPExcel->setActiveSheetIndex(0);

                ob_end_clean();
                ob_start();

                header('Content-Type: application/vnd.ms-excel');
                header('Content-Disposition: attachment;filename=AbsenteeismRateReport.xls');
                header('Cache-Control: max-age=0');
                $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
                $objWriter->save('php://output');
        //  $this->_sendResponse(200,CJSON::encode(array("ccnn")));

}

       
        




}