<?php

use Kreait\Firebase\Factory;
use Kreait\Firebase\ServiceAccount;

class EmployeeController extends Controller {

    /**
     * @var string the default layout for the views. Defaults to '//layouts/column2', meaning
     * using two-column layout. See 'protected/views/layouts/column2.php'.
     */
    public $layout = '//layouts/column1';

    /**
     * @return array action filters
     */
    public function filters() {
        return array(
            'accessControl', // perform access control for CRUD operations
        );
    }

    /**
     * Specifies the access control rules.
     * This method is used by the 'accessControl' filter.
     * @return array access control rules
     */
    public function accessRules() {
        return array(
//========================================================================================================================================
            array('allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('index','GetAssetsIssues','CreateEmployeeAsset','UpdateAssetsIssueTable', 'ImportCSV', 'view', 'ModelAddContact', 'Employeesalary', 'PersonalReport', 'PersonalReportPDF',
                    'PersonalReportExcel', 'NewEmployeesListExcel', 'NewEmployeesListPDF', 'NewEmployeesList', 'Salaryoverrit', 'GetEmployeeSlary',
                    'ChangeSalary', 'ChangeProfilePicture', 'AddIssueTshirt', 'AddIssueShoePair', 'GetTshirtIssues', 'GetShoeIssues',
                    'UpdateTshirtIssueTable', 'UpdateShoeIssueTable', 'AddStatusDetail', 'ActiveEmployee', 'auditLogEmployee', 'createAuditLogPDF', 'createAuditLogExcel', 'GetIncentives',
                    'DeactivateIncentive', 'activateIncentive', 'SendMail', 'ChangeDesignation', 'Employeecard', 'SyncEmployee', 'GetContractFee',
                    'OtOverwrite', 'GetServiceBreakDown', 'ActiveEmployeeConuntBeginOfMonth', 'ActiveEmployeeConuntEndOfMonth', 'ResignEmployeeConuntEndOfMonth',
                    'SitewiseAbsentAndAvailableDays', 'Synctest'
                ),
                'users' => array('*'),
            ),
//=======================================================================================================================================
            array('allow', // allow admin user to perform 'admin' and 'delete' actions
            'actions' => array('admin', 'delete'),
            'users' => array('admin'),

            ),
//=======================================================================================================================================
            array('allow', // allow only the owner to perform 'view'  actions
                'actions' => array('create', 'ViewAnother'),
                'expression' => 'Yii::app()->user->can("Employee_Create")',
            ),
            array('allow', // allow only the owner to perform 'index'  actions
                'actions' => array('index'),
                'expression' => 'Yii::app()->user->can("Employee_Index")',
            ),
            array('allow', // allow only the owner to perform 'admin'  actions
                'actions' => array('admin'),
                'expression' => 'Yii::app()->user->can("Employee_Admin")',
            ),
            array('allow', // allow only the owner to perform 'view'  actions
                'actions' => array('Update'),
                'expression' => 'Yii::app()->user->can("Employee_Update")',
            ),
            array('allow', // allow only the owner to perform 'ModelAddContact'  actions
                'actions' => array('ModelAddContact'),
                'expression' => 'Yii::app()->user->can("Employee_ModelAddContact")',
            ),
            array('allow', // allow only the owner to perform 'Employeesalary'  actions
                'actions' => array('Employeesalary'),
                'expression' => 'Yii::app()->user->can("Employee_Employeesalary")',
            ),
            array('allow', // allow only the owner to perform 'view'  actions
                'actions' => array('Salaryoverwrite'),
                'expression' => 'Yii::app()->user->can("Employee_Salaryoverwrite")',
            ),
            array('allow', // allow only the owner to perform 'GetEmployeeSlary'  actions
                'actions' => array('GetEmployeeSlary'),
                'expression' => 'Yii::app()->user->can("Employee_GetEmployeeSlary")',
            ),
            array('allow', // allow only the owner to perform 'ChangeProfilePicture'  actions
                'actions' => array('ChangeProfilePicture'),
                'expression' => 'Yii::app()->user->can("Employee_ChangeProfilePicture")',
            ),
            array('allow', // allow only the owner to perform 'AddIssueTshirt'  actions
                'actions' => array('AddIssueTshirt'),
                'expression' => 'Yii::app()->user->can("Employee_AddIssueTshirt")',
            ),
            array('allow', // allow only the owner to perform 'AddIssueShoePair'  actions
                'actions' => array('AddIssueShoePair'),
                'expression' => 'Yii::app()->user->can("Employee_AddIssueShoePair")',
            ),
            array('allow', // allow only the owner to perform 'GetTshirtIssues'  actions
                'actions' => array('GetTshirtIssues'),
                'expression' => 'Yii::app()->user->can("Employee_GetTshirtIssues")',
            ),
            array('allow', // allow only the owner to perform 'GetShoeIssues'  actions
                'actions' => array('GetShoeIssues'),
                'expression' => 'Yii::app()->user->can("Employee_GetShoeIssues")',
            ),
            array('allow', // allow only the owner to perform 'UpdateTshirtIssueTable'  actions
                'actions' => array('UpdateTshirtIssueTable'),
                'expression' => 'Yii::app()->user->can("Employee_UpdateTshirtIssueTable")',
            ),
            array('allow', // allow only the owner to perform 'UpdateShoeIssueTable'  actions
                'actions' => array('UpdateShoeIssueTable'),
                'expression' => 'Yii::app()->user->can("Employee_UpdateShoeIssueTable")',
            ),
            array('allow', // allow only the owner to perform 'AddStatusDetail'  actions
                'actions' => array('AddStatusDetail'),
                'expression' => 'Yii::app()->user->can("Employee_AddStatusDetail")',
            ),
            array('allow', // allow only the owner to perform 'ActiveEmployee'  actions
                'actions' => array('ActiveEmployee'),
                'expression' => 'Yii::app()->user->can("Employee_ActiveEmployee")',
            ),
            array('allow', // allow only the owner to perform 'Employee_Document_Upload'  actions
                'actions' => array('docupload'),
                'expression' => 'Yii::app()->user->can("Employee_Docupload")',
            ),
            array('allow', // allow only the owner to perform 'Employee_Document_Update'  actions
                'actions' => array('docupdate'),
                'expression' => 'Yii::app()->user->can("Employee_Docupdate")',
            ),
            array('allow', // allow only the owner to perform 'Employee_Document_Delete'  actions
                'actions' => array('employeedocdelete'),
                'expression' => 'Yii::app()->user->can("Employee_Employeedocdelete")',
            ),
            array('allow', // allow only the owner to perform 'Employee_Document_view'  actions
            'actions' => array('employeepdfview'),
            'expression' => 'Yii::app()->user->can("Employee_Employeepdfview")',
        ),

		array('allow', // allow only the owner to perform 'Employee_Document_view'  actions
            'actions' => array('TransferEmployees'),
            'expression' => 'Yii::app()->user->can("Employee_TransferEmployees")',
        ),

            
            array('deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function beforeAction($action) {

        if (Yii::app()->user->isGuest && Yii::app()->controller->action->id != "login") {
            Yii::app()->user->loginRequired();
        }
        return true;
    }

    /**
     * Displays a particular model.
     * @param integer $id the ID of the model to be displayed
     */
    public function actionDocupload() {

        ////// document uploade Strat


        if (Yii::app()->request->getParam('submit')) {

            $contact = new Contact;
            $employeesalary = new Employeesalary;
            //   $employeedocumenttype = new EmployeeDocumentType; 
            $employeedocumenttype = EmployeeDocumentType::model()->findAll();

            //  $model = Employee::model()->findByPk($id);
            //  $designation = Designation::model()->findByPk($model->designationid);
            //  $models = Contact::model()->findAllByAttributes(array('employeeid' => $id));
            //  $Contractfee = Employeecontractfee::model()->findByAttributes(array('employeeid' => $id,'status'=>1));
            // $emplosalary = Employeesalary::model()->findByAttributes(array('employeeid' => $id));
            // $emplosalary = Employeesalary::model()->findByAttributes(array('employeeid' => $id));
            //  $employee = Employee::model()->findByPk($id);
            //  $PaymentMethod = $employee->paymentmethod['type'];
            $currentDir = getcwd();
            if (Yii::app()->request->getParam('doctype') == '1') {

                $uploadDirectory = "/document/employee/coci1/";
                $fi_name = "coci1";
            }
            if (Yii::app()->request->getParam('doctype') == '2') {

                $uploadDirectory = "/document/employee/al2/";
                $fi_name = "al2";
            }
            if (Yii::app()->request->getParam('doctype') == '3') {

                $uploadDirectory = "/document/employee/cv3/";
                $fi_name = "cv3";
            }
            if (Yii::app()->request->getParam('doctype') == '4') {

                $uploadDirectory = "/document/employee/nic4/";
                $fi_name = "nic4";
            }
            if (Yii::app()->request->getParam('doctype') == '5') {

                $uploadDirectory = "/document/employee/tpscp5/";
                $fi_name = "tpscp5";
            }
            if (Yii::app()->request->getParam('doctype') == '6') {

                $uploadDirectory = "/document/employee/bc6/";
                $fi_name = "bc6";
            }
            if (Yii::app()->request->getParam('doctype') == '7') {

                $uploadDirectory = "/document/employee/ec7/";
                $fi_name = "ec7";
            }
            if (Yii::app()->request->getParam('doctype') == '8') {

                $uploadDirectory = "/document/employee/we8/";
                $fi_name = "we8";
            }

            if (Yii::app()->request->getParam('doctype') == '9') {

                $uploadDirectory = "/document/employee/pc9/";
                $fi_name = "pc9";
            }
            if (Yii::app()->request->getParam('doctype') == '10') {

                $uploadDirectory = "/document/employee/gsc10/";
                $fi_name = "gsc10";
            }
            if (Yii::app()->request->getParam('doctype') == '11') {

                $uploadDirectory = "/document/employee/bcrad11/";
                $fi_name = "bcrad11";
            }
            if (Yii::app()->request->getParam('doctype') == '12') {

                $uploadDirectory = "/document/employee/licence12/";
                $fi_name = "licence12";
            }

            $errors = []; // Store all foreseen and unforseen errors here
            $fileExtensions = ['pdf']; // Get all the file extensions


            $fileName = $_FILES['inputfile']['name'];
            $fileSize = $_FILES['inputfile']['size'];
            $fileTmpName = $_FILES['inputfile']['tmp_name'];
            $fileType = $_FILES['inputfile']['type'];

            $savefilename = (yii::app()->request->getParam('emploid') . $fi_name . date('YmdHis') . '.pdf' );

            // print_r($savefilename);
            // die;

            $tmp = explode('.', $savefilename);
            $fileExtension = end($tmp);

            $uploadPath = $currentDir . $uploadDirectory . basename($savefilename);
            if (isset($_POST['submit'])) {

                if (!in_array($fileExtension, $fileExtensions)) {
                    $errors[] = "This file extension is not allowed. Please upload a JPEG or PNG file";
                }

                if ($fileSize > 4000000) {
                    $errors[] = "This file is more than 4MB. Sorry, it has to be less than or equal to 4MB";
                }

                if (empty($errors)) {
                    $didUpload = move_uploaded_file($fileTmpName, $uploadPath);

                    if ($didUpload) {
                        $employeedocumentsmodel = new EmployeeDocuments();
                        $employeedocumentsmodel->emp_id = Yii::app()->request->getParam('emploid');
                        $employeedocumentsmodel->document_id = Yii::app()->request->getParam('doctype');
                        $employeedocumentsmodel->document_path = $uploadDirectory . basename($savefilename);

                        if (Yii::app()->request->getParam('doctype') == '4') {
                            $model = $this->loadModel(Yii::app()->request->getParam('emploid'));

                            $model->nic_photo = $uploadDirectory . basename($savefilename);
                            $model->save();
                        }
                        if (Yii::app()->request->getParam('Expedia_date')) {
                            $employeedocumentsmodel->inactive_date = Yii::app()->request->getParam('Expedia_date');
                        } else {
                            $employeedocumentsmodel->inactive_date = "0";
                        }

                        $employeedocumentsmodel->status = "1";
                        $employeedocumentsmodel->assign_date = date('Y-m-d h:i:s');
                        if ($employeedocumentsmodel->save()) {

                            $suppliername = Supplier::model()->findByPk(Yii::app()->request->getParam('emploid'));
                            $this->redirect(array('view', 'id' => Yii::app()->request->getParam('emploid')));
                        } else {
                            print_r("sssdfkl");
                            die;
                        }
                    } else {
                        echo "An error occurred somewhere. Try again or contact the admin";
                    }
                } else {
                    foreach ($errors as $error) {
                        echo $error . "These are the errors" . "\n";
                    }
                }
            }
        }
        ////// document uploade end
    }

    public function actionDocupdate() {

        ////// document uploaded file update start

        if (Yii::app()->request->getParam('update')) {

            $sup_id = Yii::app()->request->getParam('employeeidupdate');
            $doc_id = Yii::app()->request->getParam('docutypeupdate');


            $currentDir = getcwd();
            if (Yii::app()->request->getParam('docutypeupdate') == '1') {

                $uploadDirectory = "/document/employee/coci1/";
                $fi_name = "coci1";
            }
            if (Yii::app()->request->getParam('docutypeupdate') == '2') {

                $uploadDirectory = "/document/employee/al2/";
                $fi_name = "al2";
            }
            if (Yii::app()->request->getParam('docutypeupdate') == '3') {

                $uploadDirectory = "/document/employee/cv3/";
                $fi_name = "cv3";
            }
            if (Yii::app()->request->getParam('docutypeupdate') == '4') {

                $uploadDirectory = "/document/employee/nic4/";
                $fi_name = "nic4";
            }
            if (Yii::app()->request->getParam('docutypeupdate') == '5') {

                $uploadDirectory = "/document/employee/tpscp5/";
                $fi_name = "tpscp5";
            }
            if (Yii::app()->request->getParam('docutypeupdate') == '6') {

                $uploadDirectory = "/document/employee/bc6/";
                $fi_name = "bc6";
            }
            if (Yii::app()->request->getParam('docutypeupdate') == '7') {

                $uploadDirectory = "/document/employee/ec7/";
                $fi_name = "ec7";
            }
            if (Yii::app()->request->getParam('docutypeupdate') == '8') {

                $uploadDirectory = "/document/employee/we8/";
                $fi_name = "we8";
            }

            if (Yii::app()->request->getParam('docutypeupdate') == '9') {

                $uploadDirectory = "/document/employee/pc9/";
                $fi_name = "pc9";
            }
            if (Yii::app()->request->getParam('docutypeupdate') == '10') {

                $uploadDirectory = "/document/employee/gsc10/";
                $fi_name = "gsc10";
            }
            if (Yii::app()->request->getParam('docutypeupdate') == '11') {

                $uploadDirectory = "/document/employee/bcrad11/";
                $fi_name = "bcrad11";
                   
            } if (Yii::app()->request->getParam('docutypeupdate') == '12') {

                $uploadDirectory = "/document/employee/licence12/";
                $fi_name = "licence12";
            }
           
            $errors = []; // Store all foreseen and unforseen errors here

            $fileExtensions = ['pdf']; // Get all the file extensions


            $fileName = $_FILES['inputfileupdate']['name'];
            $fileSize = $_FILES['inputfileupdate']['size'];
            $fileTmpName = $_FILES['inputfileupdate']['tmp_name'];
            $fileType = $_FILES['inputfileupdate']['type'];

            $savefilename = (yii::app()->request->getParam('employeeidupdate') . $fi_name . date('YmdHis') . '.pdf' );

            $tmp = explode('.', $savefilename);
            $fileExtension = end($tmp);




            $uploadPath = $currentDir . $uploadDirectory . basename($savefilename);


            if (isset($_POST['update'])) {

                if (!in_array($fileExtension, $fileExtensions)) {
                    $errors[] = "This file extension is not allowed. Please upload a JPEG or PNG file";
                }

                if ($fileSize > 4000000) {
                    $errors[] = "This file is more than 4MB. Sorry, it has to be less than or equal to 4MB";
                }

                if (empty($errors)) {
                    $didUpload = move_uploaded_file($fileTmpName, $uploadPath);

                    if ($didUpload) {
                        $employeedocumentsmodel = EmployeeDocuments::model()->find("emp_id= '$sup_id' AND document_id='$doc_id' AND status=1");

                        $employeedocumentsmodel->document_path = $uploadDirectory . basename($savefilename);
                        if (Yii::app()->request->getParam('Expedia_date2')) {
                            $employeedocumentsmodel->inactive_date = Yii::app()->request->getParam('Expedia_date2');
                        } else {

                            $employeedocumentsmodel->inactive_date = "0";
                        }

                        if ($employeedocumentsmodel->save()) {

                            $suppliername = Supplier::model()->findByPk(Yii::app()->request->getParam('suplierid'));
                            $this->redirect(array('view', 'id' => $sup_id));
                        } else {
                            
                        }
                    } else {
                        $supplierdocumentsmodel = EmployeeDocuments::model()->find("emp_id= '$sup_id' AND document_id='$doc_id' AND status=1");
                        if (Yii::app()->request->getParam('Expedia_date2')) {
                            $supplierdocumentsmodel->inactive_date = Yii::app()->request->getParam('Expedia_date2');
                        } else {
                            $supplierdocumentsmodel->inactive_date = "0";
                        }

                        if ($supplierdocumentsmodel->save()) {

                            $suppliername = Supplier::model()->findByPk(Yii::app()->request->getParam('suplierid'));
                            $this->redirect(array('view', 'id' => $sup_id));
                        } else {

                            // print_r("ss");
                            // die;
                        }
                    }
                } else {
                    foreach ($errors as $error) {
                        echo $error . "These are the errors" . "\n";
                    }
                }
            } else {
                
            }
        }




        ////// document uploaded file update End
    }

    public function actionView($id) {

        error_reporting(E_ERROR);
        $contact = new Contact;
        $employeeAssets = new EmployeeAssets;
        $employeesalary = new Employeesalary;
        $designationChangeDetails = DesignationChange::model()->findByAttributes(array('emp_id' => $id, 'status' => 1));
        // print(CJSON::encode($designationChangeDetails));die;
        $employeedocumenttype = EmployeeDocumentType::model()->findAll();
        $model = Employee::model()->findByPk($id);
        try {
            $exif = exif_read_data(Yii::app()->getBaseUrl(true) . $model->profileImage);
        } catch (exception $ex) {
            
        }
        $orientation = isset($exif['Orientation']) ? $exif['Orientation'] : null;

        $designation = Designation::model()->findByPk($model->designationid);
        $models = Contact::model()->findAllByAttributes(array('employeeid' => $id));
        $employee = Employee::model()->findByPk($id);
        $Contractfee = Employeecontractfee::model()->findByAttributes(array('employeeid' => $id, 'site_id' => $employee->siteid, 'status' => 1));
        $SiteJoinedDate = EmployeeJoinDetails::model()->findByAttributes(array('employee_id' => $id, 'site_id' => $employee->siteid, 'status' => 1));
        $PaymentMethod = $employee->paymentmethod['type'];
        //set incentive dropdown
        $incentives = Incentive::model()->findAllByAttributes(array('status' => 1,));
        $ResignDateHistory = EmployeeStatusHistory::model()->findByAttributes(array('emp_id' => $id, 'status_id' => 2, 'status' => 1));
        $data = array();

        foreach ($incentives as $incentive)
            $data[$incentive->id] = $incentive->name;
        $this->render('view', array(
            'model' => $this->loadModel($id), 'employeeAssets' => $employeeAssets, 'contact' => $contact, 'employeesalary' => $employeesalary, 'models' => $models, 'designation' => $designation, 'PaymentMethod' => $PaymentMethod, 'Contractfee' => $Contractfee, 'employeedocumenttype' => $employeedocumenttype,
            'orientation' => $orientation, 'data' => $data, 'designationChangeDetails' => $designationChangeDetails, 'SiteJoinedDate' => $SiteJoinedDate, 'ResignDateHistory' => $ResignDateHistory,
        ));
    }

    public function actionEmployeepdfview() {


        $emp_id = Yii::app()->request->getParam('param1');


        $docu_type_id = Yii::app()->request->getParam('param2');


        $doc_detil = EmployeeDocuments::model()->find("emp_id= '$emp_id' AND document_id='$docu_type_id ' AND status=1");

        $this->render('employeepdfview', array(
            'supp_id' => $emp_id,
            'doc_detil' => $doc_detil,
        ));
    }

    /**
     * Creates a new model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     */
    public function actionCreate() {
        $model = new Employee;
        $EmplyeeContractFee = new Employeecontractfee;
        $Userid = Yii::app()->user->data()->id;

        if (Yii::app()->user->isAdmin()) {
            $Sites = Sites::model()->findAll();
        } else {
            $siteId = Yii::app()->user->data()->SiteId;
            $Sites = Sites::model()->findAllByAttributes(array('id' => $siteId));
        }

        if (isset($_POST['Employee'])) {
            $model->attributes = $_POST['Employee'];
            $model->payroll_status = 1;

            $tmp_name = $_FILES["file"]["tmp_name"];
            $tmp_name_nic = $_FILES["nic_phot"]["tmp_name"];

            if ($tmp_name_nic != "") {
                $uploadDirectory = "/document/employee/nic4/";
                $fi_name = "nic4";
                $currentDir = getcwd();
                $errors = []; // Store all foreseen and unforseen errors here
                $fileExtensions = ['pdf']; // Get all the file extensions


                $fileName = $_FILES['nic_phot']['name'];
                $fileSize = $_FILES['nic_phot']['size'];
                $fileTmpName = $_FILES['nic_phot']['tmp_name'];
                $fileType = $_FILES['nic_phot']['type'];

                $savefilename = ($fi_name . date('YmdHis') . '.pdf' );

                // print_r($savefilename);
                // die;

                $tmp = explode('.', $savefilename);
                $fileExtension = end($tmp);

                $uploadPath = $currentDir . $uploadDirectory . basename($savefilename);

                if ($tmp_name_nic != "") {

                    if (!in_array($fileExtension, $fileExtensions)) {
                        $errors[] = "This file extension is not allowed. Please upload a JPEG or PNG file";
                    }

                    if ($fileSize > 4000000) {
                        $errors[] = "This file is more than 4MB. Sorry, it has to be less than or equal to 4MB";
                    }

                    if (empty($errors)) {
                        $didUpload = move_uploaded_file($fileTmpName, $uploadPath);

                        if ($didUpload) {


                            $model->nic_photo = $uploadDirectory . basename($savefilename);
                        } else {
                            echo "An error occurred somewhere. Try again or contact the admin";
                        }
                    } else {
                        foreach ($errors as $error) {
                            echo $error . "These are the errors" . "\n";
                        }
                    }
                }
            }

            if (!ctype_upper($model->FirstName))
                $model->FirstName = strtoupper($model->FirstName);
            if (!ctype_upper($model->LastName))
                $model->LastName = strtoupper($model->LastName);
            if (!ctype_upper($model->SurName))
                $model->SurName = strtoupper($model->SurName);
            if (!ctype_upper($model->Namewithini))
                $model->Namewithini = strtoupper($model->Namewithini);
            if (!ctype_upper($model->FullName))
                $model->FullName = strtoupper($model->FullName);
            // ===========================================================================     
            if($model->Appointment ==null){
            $model->Appointment ='0000-00-00';
            }
            if($model->Confirmationdate ==null){
            $model->Confirmationdate ='0000-00-00';
            }


            if ($model->save()) {
                if ($tmp_name != "") {
                    $uploads_dir = Yii::getPathOfAlias("webroot") . '/themeassets/employee-images';
                    $filename = $model->id . ".jpeg";
                    $newpath = "$uploads_dir/$filename";
                    $newpath2 = '/themeassets/employee-images/' . $filename;
                    move_uploaded_file($tmp_name, $newpath);
                    Employee::model()->updateAll(array('profileImage' => $newpath2), "id=" . $model->id);
                }
                if (isset($_POST['EmplyeeContractFee'])) {
                    $Contractfeemodel = $_POST['EmplyeeContractFee'];
                    $EmplyeeContractFee->employeeid = $model->id;
                    $EmplyeeContractFee->contractfee = $Contractfeemodel['contractfee'];
					$EmplyeeContractFee->site_id = $model->siteid;
                    $EmplyeeContractFee->status = 1;
                    $EmplyeeContractFee->save();
                }

                $employeedesigna = new EmployeeDesignation;
                $employeedesigna->Status = 1;
                $employeedesigna->EmployeeId = $model->id;
                $employeedesigna->DesignationId = $model->designationid;
                $date = date('Y-m-d H:i:s');
                $employeedesigna->DateTime = $date;
                if ($employeedesigna->save()) {

					//write data in employee_join_details table
                    EmployeeJoinDetails::model()->updateAll(array('status' => 0), "employee_id=".$model->id." AND site_id=".$model->siteid." AND Status = 1");
                    $employeeJoin = new EmployeeJoinDetails;
                    $employeeJoin->employee_id = $model->id;
                    $employeeJoin->site_id = $model->siteid;
                    $employeeJoin->join_date = $model->joindate;
                    $employeeJoin->created_on = date('Y-m-d H:i:s');
                    $employeeJoin->created_by = Yii::app()->user->id;
                    $employeeJoin->status = 1;
                    $employeeJoin->save();

                    //write data in employee_designation_details table
                    EmployeeDesignationDetails::model()->updateAll(array('status' => 0), "employee_id=" . $model->id . " AND site_id=" . $model->siteid . " AND Status = 1");
                    $employeeDesignation = new EmployeeDesignationDetails;
                    $employeeDesignation->employee_id = $model->id;
                    $employeeDesignation->site_id = $model->siteid;
                    $employeeDesignation->designation_id = $model->designationid;
                    $employeeDesignation->created_on = date('Y-m-d H:i:s');
                    $employeeDesignation->changed_by = Yii::app()->user->id;
                    $employeeDesignation->status = 1;
                    $employeeDesignation->save();

                    $designationSalary = DesignationSalary::model()->findByAttributes(array("DesignationId" => $model->designationid, "Siteid" => $model->siteid, "Status" => 1));

                    // $monthlyWage = $designationSalary != null ? $designationSalary->MonthlySalary : 0;
                    if ($model->paymentmethod['type'] == "DAILY") {

                        $Wage = $designationSalary != null ? $designationSalary->DailySalary : 0;
                        $monthlyWage = 26 * $Wage;
                        $basicsalary = $designationSalary != null ? $designationSalary->DailyBasicSalary : 0;
                        $BRA1 = $designationSalary != null ? $designationSalary->DailyBRA1 : 0;
                        $BRA2 = $designationSalary != null ? $designationSalary->DailyBRA2 : 0;
                        $BRA3 = $designationSalary != null ? $designationSalary->DailyBRA3 : 0;
                    } else {
                        $Wage = $designationSalary != null ? $designationSalary->MonthlySalary : 0;
                        $monthlyWage = $Wage;
                        $basicsalary = $designationSalary != null ? $designationSalary->MonthlyBasicSalary : 0;
                        $BRA1 = $designationSalary != null ? $designationSalary->MonthlyBRA1 : 0;
                        $BRA2 = $designationSalary != null ? $designationSalary->MonthlyBRA2 : 0;
                        $BRA3 = $designationSalary != null ? $designationSalary->MonthlyBRA3 : 0;
                    }

                    $dailyWage = Yii::app()->paymentUtil->getDayWage($Wage, $model->paymentmethod['type'], $model->labourcategory->name);
                    $hourlyRate = Yii::app()->paymentUtil->getHourlyRate($Wage, $model->paymentmethod['type'], $model->labourcategory->name);
                    $doubleOTRate = Yii::app()->paymentUtil->getDoubleOTRate($Wage, $model->paymentmethod['type'], $model->labourcategory->name);
                    $normalOTRate = Yii::app()->paymentUtil->getOvetimeRateNormalDay($Wage, $model->paymentmethod['type'], $model->labourcategory->name);
                    $empSalary = new Employeesalary;
                    $empSalary->employeeid = $model->id;
                    $empSalary->monthsalary = $monthlyWage;
                    $empSalary->DalySalary = $dailyWage;
                    $empSalary->HourlyRate = $hourlyRate;
                    $empSalary->DoubleOTRate = $doubleOTRate;
                    $empSalary->OTRate = $normalOTRate;
                    $empSalary->CreatedBy = Yii::app()->user->id;
                    $empSalary->CreatedOn = $date;
                    $empSalary->BasicSalary = $basicsalary;
                    $empSalary->BRA1 = $BRA1;
                    $empSalary->BRA2 = $BRA2;
                    $empSalary->BRA3 = $BRA3;
                    $empSalary->Status = 1;
					$empSalary->site_id = $model->siteid;
                    $empSalary->save();

                    $designationIncentives = DesignationIncentive::model()->findAllByAttributes(array("designation_id" => $model->designationid, "site_id" => $model->siteid, "status" => 1));
                    EmployeeIncentive::model()->updateAll(array('status' => 0), 'employee_id ="' . $model->id . '"');
                    if ($designationIncentives) {

                        foreach ($designationIncentives as $designationIncentive) {

                            $newEmployeeIncentive = new EmployeeIncentive;

                            $newEmployeeIncentive->employee_id = $model->id;
                            $newEmployeeIncentive->incentive_id = $designationIncentive['incentive_id'];

                            if ($model->paymentmethod['type'] == "DAILY")
                                $newEmployeeIncentive->incentive_amount = $designationIncentive['incentive_amount_daily'];
                            else
                                $newEmployeeIncentive->incentive_amount = $designationIncentive['incentive_amount_monthly'];

                            $newEmployeeIncentive->createdBy = Yii::app()->user->id;
                            $newEmployeeIncentive->createdOn = date('Y-m-d H:i:s');
                            $newEmployeeIncentive->status = 1;
							$newEmployeeIncentive->site_id = $model->siteid;
                            $newEmployeeIncentive->save();
                        }
                    }
                }

                if ($tmp_name_nic != "") {

                    $employeedocumentsmodel = new EmployeeDocuments();
                    $employeedocumentsmodel->emp_id = $model->id;
                    $employeedocumentsmodel->document_id = '4';
                    $employeedocumentsmodel->document_path = $uploadDirectory . basename($savefilename);

                    $employeedocumentsmodel->inactive_date = "0";

                    $employeedocumentsmodel->status = "1";
                    $employeedocumentsmodel->assign_date = date('Y-m-d h:i:s');
                    $employeedocumentsmodel->save();
                } else {
                    echo "An error occurred somewhere. Try again or contact the admin";
                }



                $this->redirect(array('view', 'id' => $model->id));
            }
        }
        $this->render('create', array(
            'model' => $model, 'EmplyeeContractFee' => $EmplyeeContractFee, 'Sites' => $Sites, 'Userid' => $Userid,
        ));
    }

    /**
     * Updates a particular model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id the ID of the model to be updated
     */
    public function actionUpdate($id) {
        $model = $this->loadModel($id);
        $EmplyeeContractFee = new Employeecontractfee;
        $Userid = Yii::app()->user->data()->id;


        if (Yii::app()->user->isAdmin()) {
            $Sites = Sites::model()->findAll();
        } else {
            $siteId = Yii::app()->user->data()->SiteId;
            $Sites = Sites::model()->findAllByAttributes(array('id' => $siteId));
        }

        if (isset($_POST['Employee'])) {
            $model->attributes = $_POST['Employee'];
            $oldModel = $this->loadModel($id);


            $hasInvalidAttendance = Yii::app()->db->createCommand("SELECT T.*
                FROM timesheet as T
                WHERE MONTH(T.date) = MONTH(CURDATE()) AND YEAR(T.date) = YEAR(CURDATE()) AND (T.Intime is NULL OR T.OuteTime is NULL ) AND T.EmployeeId = " . $id . "")->queryAll();

            if ($hasInvalidAttendance && ($oldModel->siteid != $model->siteid)) {

                Yii::app()->user->setFlash('warning', "Oops!. This employee has invalid timesheets");
                $this->render('update', array(
                    'model' => $oldModel, 'EmplyeeContractFee' => $EmplyeeContractFee, 'Sites' => $Sites, 'Userid' => $Userid));
            } else {

                // ==================================Put an Image===========================

                $tmp_name = $_FILES["file"]["tmp_name"];
                if ($tmp_name != "") {
                    $uploads_dir = Yii::getPathOfAlias("webroot") . '/themeassets/employee-images';
                    $filename = $model->id . ".jpeg";
                    $newpath = "$uploads_dir/$filename";
                    $newpath2 = '/themeassets/employee-images/' . $filename;
                    move_uploaded_file($tmp_name, $newpath);
                    $model->profileImage = $newpath2;
                }
                $tmp_name_nic = $_FILES["nic_phot"]["tmp_name"];


                if ($tmp_name_nic != "") {
                    $uploadDirectory = "/document/employee/nic4/";
                    $fi_name = "nic4";
                    $currentDir = getcwd();
                    $errors = []; // Store all foreseen and unforseen errors here


                    $fileExtensions = ['pdf']; // Get all the file extensions


                    $fileName = $_FILES['nic_phot']['name'];
                    $fileSize = $_FILES['nic_phot']['size'];
                    $fileTmpName = $_FILES['nic_phot']['tmp_name'];
                    $fileType = $_FILES['nic_phot']['type'];

                    $savefilename = ($fi_name . date('YmdHis') . '.pdf' );

                    // print_r($savefilename);
                    // die;

                    $tmp = explode('.', $savefilename);
                    $fileExtension = end($tmp);




                    $uploadPath = $currentDir . $uploadDirectory . basename($savefilename);

                    if ($tmp_name_nic != "") {

                        if (!in_array($fileExtension, $fileExtensions)) {
                            $errors[] = "This file extension is not allowed. Please upload a JPEG or PNG file";
                        }

                        if ($fileSize > 4000000) {
                            $errors[] = "This file is more than 4MB. Sorry, it has to be less than or equal to 4MB";
                        }

                        if (empty($errors)) {
                            $didUpload = move_uploaded_file($fileTmpName, $uploadPath);

                            if ($didUpload) {


                                $model->nic_photo = $uploadDirectory . basename($savefilename);
                            } else {
                                echo "An error occurred somewhere. Try again or contact the admin";
                            }
                        } else {
                            foreach ($errors as $error) {
                                echo $error . "These are the errors" . "\n";
                            }
                        }
                    }
                }

                if (!ctype_upper($model->FirstName))
                    $model->FirstName = strtoupper($model->FirstName);
                if (!ctype_upper($model->LastName))
                    $model->LastName = strtoupper($model->LastName);
                if (!ctype_upper($model->SurName))
                    $model->SurName = strtoupper($model->SurName);
                if (!ctype_upper($model->Namewithini))
                    $model->Namewithini = strtoupper($model->Namewithini);
                if (!ctype_upper($model->FullName))
                    $model->FullName = strtoupper($model->FullName);

                // =========================================================================== 
                $employee = Employee::model()->findByAttributes(array("id" => $id));

                $OldDesignation = $employee->designationid;
                $OldPaymentmethod = $employee->paymentmethodid;
                $OldLabourCategory = $employee->LabourCategory;
                if($model->Appointment ==null){
                $model->Appointment ='0000-00-00';
                }
                if($model->Confirmationdate ==null){
                $model->Confirmationdate ='0000-00-00';
                }

                // print_r(CJSON::encode($model));die;
                if ($model->save()) {
                    // print_r(CJSON::encode($model));die;
                    if (isset($_POST['EmplyeeContractFee'])) {
                        $Contractfeemodel = $_POST['EmplyeeContractFee'];
                        Employeecontractfee::model()->updateAll(array('status' => 0), "employeeid=" . $model->id . " AND site_id=" . $model->siteid . " AND status = 1");
                        $EmplyeeContractFee = new Employeecontractfee;
                        $EmplyeeContractFee->employeeid = $model->id;
                        $EmplyeeContractFee->contractfee = $Contractfeemodel['contractfee'];
                        $EmplyeeContractFee->site_id = $model->siteid;
                        $EmplyeeContractFee->status = 1;
                        $EmplyeeContractFee->save();
                    }
                    $employeedesigna = new EmployeeDesignation;
                    $employeedesigna::model()->updateAll(array('Status' => 0), 'EmployeeId ="' . $id . '"');
                    $employeedesigna->Status = 1;
                    $employeedesigna->EmployeeId = $model->id;
                    $employeedesigna->DesignationId = $model->designationid;
                    $date = date('Y-m-d H:i:s');
                    $employeedesigna->DateTime = $date;

                    if ($employeedesigna->save()) {

                        if ($OldPaymentmethod != $model->paymentmethodid or $OldDesignation != $model->designationid or $OldLabourCategory != $model->LabourCategory) {

                            $designationSalary = DesignationSalary::model()->findByAttributes(array("DesignationId" => $model->designationid, "Siteid" => $model->siteid, "Status" => 1));

                            if ($model->paymentmethod['type'] == "DAILY") {
                                $Wage = $designationSalary != null ? $designationSalary->DailySalary : 0;
                                $monthlyWage = 26 * $Wage;
                                $basicsalary = $designationSalary != null ? $designationSalary->DailyBasicSalary : 0;
                                $BRA1 = $designationSalary != null ? $designationSalary->DailyBRA1 : 0;
                                $BRA2 = $designationSalary != null ? $designationSalary->DailyBRA2 : 0;
                                $BRA3 = $designationSalary != null ? $designationSalary->DailyBRA3 : 0;
                            } else {
                                $Wage = $designationSalary != null ? $designationSalary->MonthlySalary : 0;
                                $monthlyWage = $Wage;
                                $basicsalary = $designationSalary != null ? $designationSalary->MonthlyBasicSalary : 0;
                                $BRA1 = $designationSalary != null ? $designationSalary->MonthlyBRA1 : 0;
                                $BRA2 = $designationSalary != null ? $designationSalary->MonthlyBRA2 : 0;
                                $BRA3 = $designationSalary != null ? $designationSalary->MonthlyBRA3 : 0;
                            }

                            $dailyWage = Yii::app()->paymentUtil->getDayWage($Wage, $model->paymentmethod['type'], $model->labourcategory->name);
                            $hourlyRate = Yii::app()->paymentUtil->getHourlyRate($Wage, $model->paymentmethod['type'], $model->labourcategory->name);
                            $doubleOTRate = Yii::app()->paymentUtil->getDoubleOTRate($Wage, $model->paymentmethod['type'], $model->labourcategory->name);
                            $normalOTRate = Yii::app()->paymentUtil->getOvetimeRateNormalDay($Wage, $model->paymentmethod['type'], $model->labourcategory->name);

                            Employeesalary::model()->updateAll(array('monthsalary' => $monthlyWage, 'DalySalary' => $dailyWage, 'HourlyRate' => $hourlyRate, 'DoubleOTRate' => $doubleOTRate, 'OTRate' => $normalOTRate, 'BasicSalary' => $basicsalary, 'BRA1' => $BRA1, 'BRA2' => $BRA2, 'BRA3' => $BRA3), 'employeeid ="' . $model->id . '" AND Status ="' . 1 . '"');
                        }
                    }

                    if ($tmp_name_nic != "") {



                        $employeedocuments = EmployeeDocuments::model()->find("emp_id= '$id' AND document_id='4' AND status=1");
                        //    $employeedocuments = EmployeeDocuments::model()->find("emp_id" => $id And "document_id"=>'4' And "status" =>'1');


                        if ($employeedocuments) {

                            $employeedocuments->document_path = $model->nic_photo;
                            $employeedocuments->save();
                        } else {
                            $employeedocumentsmodel = new EmployeeDocuments();
                            $employeedocumentsmodel->emp_id = $id;
                            $employeedocumentsmodel->document_id = '4';
                            $employeedocumentsmodel->document_path = $model->nic_photo;

                            $employeedocumentsmodel->inactive_date = "0";

                            $employeedocumentsmodel->status = "1";
                            $employeedocumentsmodel->assign_date = date('Y-m-d h:i:s');
                            $employeedocumentsmodel->save();
                        }
                    }
                    $this->redirect(array('view', 'id' => $model->id));
                }
                $this->render('update', array(
                    'model' => $model, 'EmplyeeContractFee' => $EmplyeeContractFee, 'Sites' => $Sites, 'Userid' => $Userid
                ));
            }
        } else {
            $this->render('update', array(
                'model' => $model, 'EmplyeeContractFee' => $EmplyeeContractFee, 'Sites' => $Sites, 'Userid' => $Userid
            ));
        }
    }

    /**
     * Deletes a particular model.
     * If deletion is successful, the browser will be redirected to the 'admin' page.
     * @param integer $id the ID of the model to be deleted
     */
    public function actionDelete($id) {
        if (Yii::app()->request->isPostRequest) {
// we only allow deletion via POST request
            $this->loadModel($id)->delete();

// if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
            if (!isset($_GET['ajax']))
                $this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('admin'));
        } else
            throw new CHttpException(400, 'Invalid request. Please do not repeat this request again.');
    }

    /**
     * Lists all models.
     */
    public function actionIndex() {
        $dataProvider = new CActiveDataProvider('Employee');
        $this->render('index', array(
            'dataProvider' => $dataProvider,
        ));
    }

    /**
     * Manages all models.
     */
    public function actionAdmin() {
        $model = new Employee('search');
        $model->unsetAttributes();  // clear any default values
        if (isset($_GET['Employee']))
            $model->attributes = $_GET['Employee'];

        $this->render('admin', array(
            'model' => $model,
        ));
    }

    /**
     * Returns the data model based on the primary key given in the GET variable.
     * If the data model is not found, an HTTP exception will be raised.
     * @param integer the ID of the model to be loaded
     */
    public function loadModel($id) {
        $model = Employee::model()->findByPk($id);
        if ($model === null)
            throw new CHttpException(404, 'The requested page does not exist.');
        return $model;
    }

    /**
     * Performs the AJAX validation.
     * @param CModel the model to be validated
     */
    protected function performAjaxValidation($model) {
        if (isset($_POST['ajax']) && $_POST['ajax'] === 'employee-form') {
            echo CActiveForm::validate($model);
            Yii::app()->end();
        }
    }

    // employee Document Delete
    public function actionEmployeedocdelete() {

        $empl_id = Yii::app()->request->getParam('suppid');


        $docu_type_id = Yii::app()->request->getParam('docid');

        $deletedocmodel = EmployeeDocuments::model()->find("emp_id= '$empl_id' AND document_id='$docu_type_id' AND status=1");

        if ($deletedocmodel) {

            $deletedocmodel->status = "2";
            if ($deletedocmodel->save()) {


                $this->redirect(array('view', 'id' => $empl_id));
            } else {
                print_r("error");
            }
        }
    }

    // employee Document Delete



    public function actionModelAddContact() {
        $contact = new Contact;
        $contact->number = $_POST['number'];
        $contact->type = $_POST['type'];
        $contact->employeeid = $_POST['employeeid'];
        $contact->address = $_POST['address'];
        $contact->save();
    }

    //=========================================================================

    public function actionAddStatusDetail() { //employee deactivation
        $model = new EmployeeStatusHistory;
        $date = $_POST['selecteddate']; //resign date
        $description = $_POST['description'];
        $employeeid = $_POST['employeeid'];
        $emp = Employee::model()->findByPk($employeeid);

        $hasInvalidAttendance = Yii::app()->db->createCommand("SELECT T.*
            FROM timesheet as T
            WHERE MONTH(T.date) = MONTH(CURDATE()) AND YEAR(T.date) = YEAR(CURDATE()) AND (T.Intime is NULL OR T.OuteTime is NULL ) AND T.PaymentMethod != 'PIECE-RATE' AND T.EmployeeId = " . $employeeid . "")->queryAll();

        if ($hasInvalidAttendance) {
            echo false;
        } else {
            Employee::model()->updateAll(array('statusId' => 2, 'TeamStatus' => 0, 'resigndate' => $date), 'id ="' . $employeeid . '"');
            EmployeeTeam::model()->updateAll(array('Status' => 0), 'employeeid="' . $employeeid . '"AND Status ="' . 1 . '"');
            EmployeeStatusHistory::model()->updateAll(array('status' => 0), 'emp_id="' . $employeeid . '"AND status = 1');

            //============================= push ============================
            $key = 'deletedEmp';
            $value = $emp->siteid . '_' . $emp->id;

            $serviceAccount = ServiceAccount::fromJsonFile('secret/efl-wfm-console-e35c327b704d.json');

            $firebase = (new Factory)
                    ->withServiceAccount($serviceAccount)
                    ->create();

            $database = $firebase->getDatabase();
            $database->getReference()->getChild($key)->set($value);
            //=========================================================

            $model->emp_id = $employeeid;
            $model->affective_date = $date;
            $model->description = $description;
            $model->status_id = 2;
            $model->responsible_person = Yii::app()->user->id;
            $model->status = 1;
            $model->site_id = $emp->siteid;
            $model->save();

            //write data in employee_resign_details table
            EmployeeResignDetails::model()->updateAll(array('status' => 0), "employee_id=" . $employeeid . " AND site_id=" . $emp->siteid . " AND Status = 1");
            $employeeResign = new EmployeeResignDetails;
            $employeeResign->employee_id = $employeeid;
            $employeeResign->site_id = $emp->siteid;
            $employeeResign->resign_date = $date;
            $employeeResign->created_on = date('Y-m-d H:i:s');
            $employeeResign->created_by = Yii::app()->user->id;
            $employeeResign->status = 1;
            $employeeResign->save();

            echo true;
        }
    }

    //===========================================================
    public function actionActiveEmployee($id) {

        $model = $this->loadModel($id);
        $EmplyeeContractFee = new Employeecontractfee;
        $Userid = Yii::app()->user->data()->id;

        $model->statusId = 1;
        if (Yii::app()->user->isAdmin()) {
            $Sites = Sites::model()->findAll();
        } else {
            $siteId = Yii::app()->user->data()->SiteId;
            $Sites = Sites::model()->findAllByAttributes(array('id' => $siteId));
        }

        if (isset($_POST['Employee'])) {
            $model->attributes = $_POST['Employee'];
            $tmp_name = $_FILES["file"]["tmp_name"];
            if ($tmp_name != "") {
                $uploads_dir = Yii::getPathOfAlias("webroot") . '/themeassets/employee-images';
                $filename = $model->id . ".jpeg";
                $newpath = "$uploads_dir/$filename";
                $newpath2 = '/themeassets/employee-images/' . $filename;
                move_uploaded_file($tmp_name, $newpath);
                $model->profileImage = $newpath2;
            }
            $tmp_name_nic = $_FILES["nic_phot"]["tmp_name"];


            if ($tmp_name_nic != "") {
                $uploadDirectory = "/document/employee/nic4/";
                $fi_name = "nic4";
                $currentDir = getcwd();
                $errors = []; // Store all foreseen and unforseen errors here


                $fileExtensions = ['pdf']; // Get all the file extensions


                $fileName = $_FILES['nic_phot']['name'];
                $fileSize = $_FILES['nic_phot']['size'];
                $fileTmpName = $_FILES['nic_phot']['tmp_name'];
                $fileType = $_FILES['nic_phot']['type'];

                $savefilename = ($fi_name . date('YmdHis') . '.pdf' );

                // print_r($savefilename);
                // die;

                $tmp = explode('.', $savefilename);
                $fileExtension = end($tmp);




                $uploadPath = $currentDir . $uploadDirectory . basename($savefilename);

                if ($tmp_name_nic != "") {

                    if (!in_array($fileExtension, $fileExtensions)) {
                        $errors[] = "This file extension is not allowed. Please upload a JPEG or PNG file";
                    }

                    if ($fileSize > 4000000) {
                        $errors[] = "This file is more than 4MB. Sorry, it has to be less than or equal to 4MB";
                    }

                    if (empty($errors)) {
                        $didUpload = move_uploaded_file($fileTmpName, $uploadPath);

                        if ($didUpload) {


                            $model->nic_photo = $uploadDirectory . basename($savefilename);
                        } else {
                            echo "An error occurred somewhere. Try again or contact the admin";
                        }
                    } else {
                        foreach ($errors as $error) {
                            echo $error . "These are the errors" . "\n";
                        }
                    }
                }
            }

            if (!ctype_upper($model->FirstName))
                $model->FirstName = strtoupper($model->FirstName);
            if (!ctype_upper($model->LastName))
                $model->LastName = strtoupper($model->LastName);
            if (!ctype_upper($model->SurName))
                $model->SurName = strtoupper($model->SurName);
            if (!ctype_upper($model->Namewithini))
                $model->Namewithini = strtoupper($model->Namewithini);
            if (!ctype_upper($model->FullName))
                $model->FullName = strtoupper($model->FullName);

            // =========================================================================== 
            $employee = Employee::model()->findByAttributes(array("id" => $id));

            $OldDesignation = $employee->designationid;
            $OldPaymentmethod = $employee->paymentmethodid;
            $model->resigndate = null;
            if($model->Appointment ==null){
            $model->Appointment ='0000-00-00';
            }
            if($model->Confirmationdate ==null){
            $model->Confirmationdate ='0000-00-00';
            }

            if ($model->save()) {

                //tracking changes
                $EmployeeStatusHistory = new EmployeeStatusHistory;
                $EmployeeStatusHistory->emp_id = $id;
                $EmployeeStatusHistory->status_id = 1;
                $EmployeeStatusHistory->description = "Active Employee";
                $EmployeeStatusHistory->responsible_person = Yii::app()->user->id;
                $EmployeeStatusHistory->affective_date = date("Y-m-d H:i:m");
                $EmployeeStatusHistory->status = 1;
                $EmployeeStatusHistory->site_id = $employee->siteid;
                $EmployeeStatusHistory->save();

                //inactive all the resign dates in curret site.
                EmployeeResignDetails::model()->updateAll(array('status' => 0), "employee_id=" . $model->id . " AND site_id=" . $model->siteid . " AND Status = 1");

                //write data in employee_join_details table
                EmployeeJoinDetails::model()->updateAll(array('status' => 0), "employee_id=" . $model->id . " AND site_id=" . $model->siteid . " AND Status = 1");
                $employeeJoin = new EmployeeJoinDetails;
                $employeeJoin->employee_id = $model->id;
                $employeeJoin->site_id = $model->siteid;
                $employeeJoin->join_date = $model->joindate;
                $employeeJoin->created_on = date('Y-m-d H:i:s');
                $employeeJoin->created_by = Yii::app()->user->id;
                $employeeJoin->status = 1;
                $employeeJoin->save();

                //write data in employee_designation_details table
                EmployeeDesignationDetails::model()->updateAll(array('status' => 0), "employee_id=" . $model->id . " AND site_id=" . $model->siteid . " AND Status = 1");
                $employeeDesignation = new EmployeeDesignationDetails;
                $employeeDesignation->employee_id = $model->id;
                $employeeDesignation->site_id = $model->siteid;
                $employeeDesignation->designation_id = $model->designationid;
                $employeeDesignation->created_on = date('Y-m-d H:i:s');
                $employeeDesignation->changed_by = Yii::app()->user->id;
                $employeeDesignation->status = 1;
                $employeeDesignation->save();

                if (isset($_POST['EmplyeeContractFee'])) {
                    $Contractfeemodel = $_POST['EmplyeeContractFee'];
                    Employeecontractfee::model()->updateAll(array('status' => 0), "employeeid=" . $model->id . " AND site_id=" . $model->siteid . " AND status = 1");
                    $EmplyeeContractFee = new Employeecontractfee;
                    $EmplyeeContractFee->employeeid = $model->id;
                    $EmplyeeContractFee->contractfee = $Contractfeemodel['contractfee'];
                    $EmplyeeContractFee->site_id = $model->siteid;
                    $EmplyeeContractFee->status = 1;
                    $EmplyeeContractFee->save();
                }

                EmployeeDesignation::model()->updateAll(array('Status' => 0), 'EmployeeId ="' . $id . '"');
                $employeedesigna = new EmployeeDesignation;
                $employeedesigna->Status = 1;
                $employeedesigna->EmployeeId = $model->id;
                $employeedesigna->DesignationId = $model->designationid;
                $employeedesigna->DateTime = date('Y-m-d H:i:s');

                if ($employeedesigna->save()) {

                    $designationSalary = DesignationSalary::model()->findByAttributes(array("DesignationId" => $model->designationid, "Siteid" => $model->siteid, "Status" => 1));

                    if ($model->paymentmethod['type'] == "DAILY") {
                        $Wage = $designationSalary != null ? $designationSalary->DailySalary : 0;
                        $monthlyWage = 26 * $Wage;
                    } else {
                        $Wage = $designationSalary != null ? $designationSalary->MonthlySalary : 0;
                        $monthlyWage = $Wage;
                    }

                    $dailyWage = Yii::app()->paymentUtil->getDayWage($Wage, $model->paymentmethod['type'], $model->labourcategory->name);
                    $hourlyRate = Yii::app()->paymentUtil->getHourlyRate($Wage, $model->paymentmethod['type'], $model->labourcategory->name);
                    $doubleOTRate = Yii::app()->paymentUtil->getDoubleOTRate($Wage, $model->paymentmethod['type'], $model->labourcategory->name);
                    $normalOTRate = Yii::app()->paymentUtil->getOvetimeRateNormalDay($Wage, $model->paymentmethod['type'], $model->labourcategory->name);

                    $hasActiveEmployeeSalary = Employeesalary::model()->findByAttributes(['employeeid' => $model->id, 'site_id' => $model->siteid, 'Status' => 1]);
                    if (empty($hasActiveEmployeeSalary)) {
                        $newEmployeeSalary = new Employeesalary;

                        $newEmployeeSalary->employeeid = $model->id;
                        $newEmployeeSalary->monthsalary = $monthlyWage;
                        $newEmployeeSalary->DalySalary = $dailyWage;
                        $newEmployeeSalary->HourlyRate = $hourlyRate;
                        $newEmployeeSalary->DoubleOTRate = $doubleOTRate;
                        $newEmployeeSalary->OTRate = $normalOTRate;
                        $newEmployeeSalary->CreatedBy = Yii::app()->user->id;
                        $newEmployeeSalary->CreatedOn = date('Y-m-d H:i:s');
                        $newEmployeeSalary->Status = 1;
                        $newEmployeeSalary->site_id = $model->siteid;

                        if ($model->paymentmethod['type'] == "DAILY") {
                            $newEmployeeSalary->BasicSalary = $designationSalary != null ? $designationSalary->DailyBasicSalary : 0;
                            $newEmployeeSalary->BRA1 = $designationSalary != null ? $designationSalary->DailyBRA1 : 0;
                            $newEmployeeSalary->BRA2 = $designationSalary != null ? $designationSalary->DailyBRA2 : 0;
                            $newEmployeeSalary->BRA3 = $designationSalary != null ? $designationSalary->DailyBRA3 : 0;
                        } else {
                            $newEmployeeSalary->BasicSalary = $designationSalary != null ? $designationSalary->MonthlyBasicSalary : 0;
                            $newEmployeeSalary->BRA1 = $designationSalary != null ? $designationSalary->MonthlyBRA1 : 0;
                            $newEmployeeSalary->BRA2 = $designationSalary != null ? $designationSalary->MonthlyBRA2 : 0;
                            $newEmployeeSalary->BRA3 = $designationSalary != null ? $designationSalary->MonthlyBRA3 : 0;
                        }

                        $newEmployeeSalary->save();
                        // print_r($newEmployeeSalary->getErrors());die;
                    } else {
                        $hasActiveEmployeeSalary->monthsalary = $monthlyWage;
                        $hasActiveEmployeeSalary->DalySalary = $dailyWage;
                        $hasActiveEmployeeSalary->HourlyRate = $hourlyRate;
                        $hasActiveEmployeeSalary->DoubleOTRate = $doubleOTRate;
                        $hasActiveEmployeeSalary->OTRate = $normalOTRate;
                        $hasActiveEmployeeSalary->save();
                    }
                    // Employeesalary::model()->updateAll(array('monthsalary' =>$monthlyWage,'DalySalary' =>$dailyWage,'HourlyRate' =>$hourlyRate,'DoubleOTRate' =>$doubleOTRate,'OTRate' =>$normalOTRate), 'employeeid ="' . $model->id . '" AND Status ="' . 1 . '"');
                }

                if ($tmp_name_nic != "") {

                    $employeedocuments = EmployeeDocuments::model()->find("emp_id= '$id' AND document_id='4' AND status=1");

                    if ($employeedocuments) {

                        $employeedocuments->document_path = $model->nic_photo;
                        $employeedocuments->save();
                    } else {
                        $employeedocumentsmodel = new EmployeeDocuments();
                        $employeedocumentsmodel->emp_id = $id;
                        $employeedocumentsmodel->document_id = '4';
                        $employeedocumentsmodel->document_path = $model->nic_photo;

                        $employeedocumentsmodel->inactive_date = "0";

                        $employeedocumentsmodel->status = "1";
                        $employeedocumentsmodel->assign_date = date('Y-m-d h:i:s');
                        $employeedocumentsmodel->save();
                    }
                }
                $this->redirect(array('view', 'id' => $model->id));
            }
            $this->render('_activateEmployee', array(
                'model' => $model, 'EmplyeeContractFee' => $EmplyeeContractFee, 'Sites' => $Sites, 'Userid' => $Userid
            ));
        } else {
            $this->render('_activateEmployee', array(
                'model' => $model, 'EmplyeeContractFee' => $EmplyeeContractFee, 'Sites' => $Sites, 'Userid' => $Userid
            ));
        }
    }

    //===========================================================

    public function actionEmployeesalary() {


        $employeesalary = new Employeesalary;
        $empid = $_POST['employeeid'];

        $emplosalary = Employeesalary::model()->findByAttributes(array('employeeid' => $empid, 'Status' => 1));

        if (empty($emplosalary)) {
            $employeesalary->employeeid = $_POST['employeeid'];
            $employeesalary->monthsalary = $_POST['monthlysalary'];
            $employeesalary->DalySalary = 0;

            $monthsalary = $employeesalary->monthsalary;
            $hourlyrate = $monthsalary / 200;
            $employeesalary->HourlyRate = $hourlyrate;

            $NOT = $hourlyrate * 1.5;
            $employeesalary->OTRate = $NOT;

            $DOT = $hourlyrate * 2;
            $employeesalary->DoubleOTRate = $DOT;

            $employeesalary->CreatedBy = yii::app()->user->id;
            $employeesalary->CreatedOn = date("Y-m-d H:i");
            $employeesalary->Status = 1;
            $employeesalary->ActiveStatus = 0;

            $employeesalary->save();
        } else {

            $monthsalary = $_POST['monthlysalary'];
            $hourlyrate = $monthsalary / 200;
            $NOT = $hourlyrate * 1.5;
            $DOT = $hourlyrate * 2;

            Employeesalary::model()->updateAll(array('monthsalary' => $monthsalary, 'CreatedOn' => date("Y-m-d H:i"), 'CreatedBy' => yii::app()->user->id, 'HourlyRate' => $hourlyrate, 'OTRate' => $NOT, 'DoubleOTRate' => $DOT), "employeeid=" . $empid . " AND Status =" . 1 . "");
        }
    }

    public function actionGetEmployeeSlary() {
        $employeeid = $_POST['Employeeid'];
        // $empSalaries = Employeesalary::model()->findAllByAttributes(array("employeeid"=>$employeeid));
        $Criteria1 = new CDbCriteria();
        if (Yii::app()->user->isAdmin()) {
            $Criteria1->condition = 'employeeid= :employeeid';
            $Criteria1->params = array(':employeeid' => $employeeid,);
        } else {
            $Criteria1->condition = 'employeeid= :employeeid AND site_id= :site_id';
            $Criteria1->params = array(':employeeid' => $employeeid, ':site_id' => Yii::app()->user->data()->SiteId);
        }

        $Criteria1->limit = 10;
        $Criteria1->order = "Status DESC";
        $Criteria1->select = "*";
        $empSalaries = Employeesalary::model()->findAll($Criteria1);

        foreach ($empSalaries as $empSalary) {
            echo '<tr>';
            echo '<td>' . ($empSalary->salaryChanged == '1' ? '<span class="label label-success">Changed</span>' : '<span class="label label-info">Default</span>') . '</td>';
            switch ($empSalary->Status) {
                case 1:
                    echo '<td><span class="label label-success">ACTIVE</span></td>';
                    break;
                case 0:
                    echo '<td><span class="label label-danger">INACTIVE</span></td>';
                    break;
                case 2:
                    echo '<td><span class="label label-info">PENDING</span></td>';
                    break;
                case 3:
                    echo '<td><span class="label label-warning">REJECTED</span></td>';
                    break;
            }
            $site = Sites::model()->findByPk($empSalary->site_id);

            echo '<td>' . $site['name'] . '</td>';
            echo '<td>' . $empSalary->DalySalary . '</td>';
            echo '<td>' . $empSalary->monthsalary . '</td>';
            echo '<td>' . $empSalary->HourlyRate . '</td>';
            echo '<td>' . $empSalary->OTRate . '</td>';
            echo '<td>' . $empSalary->DoubleOTRate . '</td>';
            echo '<td>' . $empSalary->CreatedOn . '</td>';
            echo '<td>' . $empSalary->BasicSalary . '</td>';
            echo '<td>' . $empSalary->BRA1 . '</td>';
            echo '<td>' . $empSalary->BRA2 . '</td>';
            echo '<td>' . $empSalary->BRA3 . '</td>';

            // echo '<td>'.($empSalary->Status == '1' ? '<span class="label label-success">Active</span>' :'<span class="label label-danger">InActive</span>').'</td>';
            echo '</tr>';
        }
    }

    public function actionChangeSalary() {

        $employeeid = $_POST['Employeeid'];
        $basic_salary = $_POST['basic_salary'];
        $bra1 = $_POST['bra1'];
        $bra2 = $_POST['bra2'];
        $bra3 = $_POST['bra3'];

        $pendingChanges = Employeesalary::model()->findByAttributes(['Status' => 2, 'employeeid' => $employeeid]);
        if (empty($pendingChanges)) {
            $employee = Employee::model()->findByPk($employeeid);
            //$Wage = $employee->paymentmethod['type'] == "DAILY" ? $DailyWage : $monthlyWage; 

            $Wage = $basic_salary + $bra1 + $bra2 + $bra3;
            $dailyWage = Yii::app()->paymentUtil->getDayWage($Wage, $employee->paymentmethod['type'], $employee->labourcategory->name);
            $hourlyRate = Yii::app()->paymentUtil->getHourlyRate($Wage, $employee->paymentmethod['type'], $employee->labourcategory->name);
            $doubleOTRate = Yii::app()->paymentUtil->getDoubleOTRate($Wage, $employee->paymentmethod['type'], $employee->labourcategory->name);
            $normalOTRate = Yii::app()->paymentUtil->getOvetimeRateNormalDay($Wage, $employee->paymentmethod['type'], $employee->labourcategory->name);
            // Employeesalary::model()->updateAll(array('Status' => 0), 'Status = 1 AND employeeid = '.$employeeid.'');

            $empSalary = new Employeesalary;
            $empSalary->employeeid = $employeeid;
            $empSalary->monthsalary = $employee->paymentmethod['type'] == "MONTHLY" ? $Wage : $Wage * 26;
            $empSalary->DalySalary = $dailyWage;
            $empSalary->HourlyRate = $hourlyRate;
            $empSalary->DoubleOTRate = $doubleOTRate;
            $empSalary->OTRate = $normalOTRate;
            $empSalary->CreatedBy = Yii::app()->user->id;
            $empSalary->CreatedOn = date("Y-m-d H:i");
            $empSalary->site_id = $employee->siteid;
            $empSalary->Status = 2; //status 2 is for pendding 
            $empSalary->salaryChanged = 1;
            //============ new change ===============
            $empSalary->BasicSalary = $basic_salary;
            $empSalary->BRA1 = $bra1;
            $empSalary->BRA2 = $bra2;
            $empSalary->BRA3 = $bra3;

            //===============end====================
            if ($empSalary->save()) {

                $employeeSalary = Employeesalary::model()->findByAttributes(["Status" => 1, "site_id" => $employee->siteid, "employeeid" => $employeeid]);
                $empSalaryApproval = new EmployeeSalaryChangeApproval;

                $empSalaryApproval->emp_id = $employeeid;
                $empSalaryApproval->payment_method = $employee->paymentmethodid;
                $empSalaryApproval->changed_by = Yii::app()->user->id;
                $empSalaryApproval->changed_on = date('Y-m-d H:i:s');
                if (!empty($employeeSalary)) {
                    $empSalaryApproval->old_emp_salary_id = $employeeSalary->id;
                }
                $empSalaryApproval->new_emp_salary_id = $empSalary->id;
                $empSalaryApproval->status = 1;
                if ($empSalaryApproval->save()) {
                    $members = Yii::app()->db->createCommand("SELECT EGM.* 
                    FROM email_groups EG
                    INNER JOIN email_group_members EGM ON EGM.email_group_id = EG.id
                    WHERE EG.group_name = 'EMPLOYEE DESIGNATION OR SALARY CHANGE' AND EGM.email_group_id = EG.id AND EGM.status = 1 AND EGM.site_id ='" . $employee->siteid . "'")->queryAll();
                   // if (!empty($members))
                        //Yii::app()->commonUtil->SendMail('salaryChange', 'Salary Change', $members, $employeeSalary, $empSalary);
                }
            }
            echo true;
        }else {
            echo false;
        }
    }

    public function actionOtOverwrite() {
        $employeeid = $_POST['Employeeid'];
        $normalOt = $_POST['normalOt'];
        $doubleOt = $_POST['doubleOt'];
        $emp = Employee::model()->findByPk($employeeid);

        $employeeSalary = Employeesalary::model()->findByAttributes(["Status" => 1, "employeeid" => $employeeid, "site_id" => $emp->siteid]);

        if (!empty($employeeSalary)) {

            $model = new EmployeeOtOverwriteTrack;
            $model->emp_id = $employeeSalary->employeeid;
            $model->employee_salary_id = $employeeSalary->id;
            $model->old_normal_ot_rate = $employeeSalary->OTRate;
            $model->new_normal_ot_rate = $normalOt;
            $model->old_double_ot_rate = $employeeSalary->DoubleOTRate;
            $model->new_double_ot_rate = $doubleOt;
            $model->overwrite_on = date('Y-m-d H:i:s');
            $model->overwrite_by = Yii::app()->user->id;

            if ($model->save()) {
                $employeeSalary->OTRate = $normalOt;
                $employeeSalary->DoubleOTRate = $doubleOt;

                if ($employeeSalary->save()) {
                    echo true;
                } else {
                    echo false;
                }
            } else {
                echo false;
            }
        } else {
            echo false;
        }
    }

    public function actionSalaryoverwrite() {
        $employeesalary = new Employeesalary;
        $status = $_POST['Checkevent'];
        $employeeid = $_POST['Employeeid'];

        $designation = EmployeeDesignation::model()->findByAttributes(array('EmployeeId' => $employeeid));
        $desigid = $designation->DesignationId;
        $siteid = Yii::app()->user->data()->SiteId;
        $designatinsalary = DesignationSalary::model()->findByAttributes(array('DesignationId' => $desigid, 'Status' => 1, 'Siteid' => $siteid));

        $hourlyrate = $designatinsalary->MonthlySalary / 200;
        $NOT = $hourlyrate * 1.5;
        $DOT = $hourlyrate * 2;
        $MonthlySalary = $designatinsalary->MonthlySalary;
        $Dalysalary = $designatinsalary->DailySalary;


        Employeesalary::model()->updateAll(array('ActiveStatus' => 0), 'employeeid="' . $employeeid . '"');

        if ($status == 0) {

            $emplosalary = Employeesalary::model()->findByAttributes(array('employeeid' => $employeeid, 'Status' => 2));

            if (empty($emplosalary)) {

                $employeesalary->employeeid = $employeeid;
                $employeesalary->monthsalary = $MonthlySalary;
                $employeesalary->DalySalary = $Dalysalary;
                $employeesalary->HourlyRate = $hourlyrate;
                $employeesalary->OTRate = $NOT;
                $employeesalary->DoubleOTRate = $DOT;
                $employeesalary->CreatedBy = yii::app()->user->id;
                $employeesalary->CreatedOn = date("Y-m-d H:i");
                $employeesalary->Status = 2;
                $employeesalary->ActiveStatus = 1;
                $employeesalary->save();

                $employeesal = CJSON::encode($employeesalary);
                echo $employeesal;
            } else {
                Employeesalary::model()->updateAll(array('ActiveStatus' => 1), "employeeid=" . $employeeid . " AND Status =" . 2 . "");

                $employeesal2 = CJSON::encode($emplosalary);
                echo $employeesal2;
            }
        } else {
            Employeesalary::model()->updateAll(array('ActiveStatus' => 1), "employeeid=" . $employeeid . " AND Status =" . 1 . "");

            $emplosalary22 = Employeesalary::model()->findByAttributes(array('employeeid' => $employeeid, 'Status' => 1));

            $employeesal3 = CJSON::encode($emplosalary22);
            echo $employeesal3;
        }
    }

    public function actionGetTshirtIssues() {
        //Search for t-shirt issues for the relevant employee  

        $employeeid = $_POST['Employeeid'];
        $tshirtIssues = EmployeeTshirt::model()->findAllBySql("select * from employee_tshirt where empID = $employeeid");
        $employee = Employee::model()->findByPk($employeeid);

        $tshirt = Tshirt::model()->findByPk($employee->tshirtsize);

        foreach ($tshirtIssues as $issue) {
            echo '<tr>';
            echo '<td>' . $tshirt->type . '</td>';
            echo '<td>' . $issue->issuedDate . '</td>';

            if ($issue->Status == 'Returned') {
                echo '<td>' . $issue->returnedDate . '</td>';
                echo '<td>' . $issue->Status . '</td>';
                echo '<td> 
                <input type="checkbox" checked="checked" name="myTextEditBox1" value=' . $issue->issueID . ' onchange="changeContentTshirtIssues(' . $issue->issueID . ',this.checked)"
                style="margin-left:auto; margin-right:auto;">
                </td>';
            } else {
                echo '<td>' . '0000-00-00' . '</td>';
                echo '<td>' . $issue->Status . '</td>';
                echo '<td> 
                 <input type="checkbox" name="myTextEditBox1" value=' . $issue->issueID . ' onchange="changeContentTshirtIssues(' . $issue->issueID . ',this.checked)"
                 style="margin-left:auto; margin-right:auto;">
                </td>';
            }

            echo '</tr>';
        }
    }
    
    public function actionGetAssetsIssues() {
        //Search for t-shirt issues for the relevant employee  

        $employeeid = $_POST['Employeeid'];
        $tshirtIssues = EmployeeAssets::model()->findAllBySql("select*
                        from employee_assets ea
                        where empID = $employeeid
                        ORDER BY ea.asset_id, ea.issuedDate ASC");
        
        foreach ($tshirtIssues as $issue) {
            
            echo '<tr>';
            echo '<td>' . $issue->asset->name . '</td>';
            echo '<td>' . $issue->assetType->type . '</td>';
            echo '<td>' . $issue->issuedDate . '</td>';

            if ($issue->Status == 'Returned') {
                echo '<td>' . $issue->returnedDate . '</td>';
                echo '<td>' . $issue->Status . '</td>';
                echo '<td> 
                <input type="checkbox" checked="checked" name="myTextEditBox1" value=' . $issue->id . ' onchange="changeContentAssetsIssues(' . $issue->id . ',this.checked)"
                style="margin-left:auto; margin-right:auto;">
                </td>';
            } else {
                echo '<td>' . '0000-00-00' . '</td>';
                echo '<td>' . $issue->Status . '</td>';
                echo '<td> 
                 <input type="checkbox" name="myTextEditBox1" value=' . $issue->id . ' onchange="changeContentAssetsIssues(' . $issue->id . ',this.checked)"
                 style="margin-left:auto; margin-right:auto;">
                </td>';
            }

            echo '</tr>';
        }
    }

    public function actionUpdateAssetsIssueTable() {

        //update t shirt issues

        $issueID = $_POST['shoeIssueID'];
        $status = $_POST['shoeIssueStatus'];
        if ($status == 'true') {
            EmployeeAssets::model()->updateAll(array('returnedDate' => date('Y-m-d'), 'Status' => 'Returned'), "id=" . $issueID . "");
        } else {
            EmployeeAssets::model()->updateAll(array('returnedDate' => null, 'Status' => 'Not Returned'), "id=" . $issueID . "");
        }
    }
    
        public function actionCreateEmployeeAsset() {

        $EmployeeAssets = new EmployeeAssets;
        $EmployeeAssets->empId = $_POST['empId'];
        $EmployeeAssets->issuedDate = $_POST['issueDate'];
        $EmployeeAssets->asset_id = $_POST['assetId'];
        $EmployeeAssets->assetType_id = $_POST['assetTypeId'];
        $EmployeeAssets->save();
    }
    
    public function actionGetShoeIssues() {
        //Search for shoe issues for the relevant employee  

        $employeeid = $_POST['Employeeid'];
        $shoeIssues = EmployeeShoe::model()->findAllBySql("select * from employee_shoe where empID = $employeeid");
        $employee = Employee::model()->findByPk($employeeid);

        $shoe = Shoes::model()->findByPk($employee->shoesize);

        foreach ($shoeIssues as $Shoeissue) {
            echo '<tr>';
            echo '<td>' . $shoe->type . '</td>';
            echo '<td>' . $Shoeissue->issuedDate . '</td>';

            if ($Shoeissue->Status == 'Returned') {
                echo '<td>' . $Shoeissue->returnedDate . '</td>';
                echo '<td>' . $Shoeissue->Status . '</td>';
                echo '<td> 
                        <input  type="checkbox" checked="checked" name="myTextEditBox" value=' . $Shoeissue->issueID . ' onchange="changeContentShoeIssues(' . $Shoeissue->issueID . ',this.checked)"
                        style="margin-left:auto; margin-right:auto;">
                    </td>';
            } else {
                echo '<td>' . '0000-00-00' . '</td>';
                echo '<td>' . $Shoeissue->Status . '</td>';
                echo '<td> 
                        <input type="checkbox"    name="myTextEditBox" value=' . $Shoeissue->issueID . '  onchange="changeContentShoeIssues(' . $Shoeissue->issueID . ',this.checked)"
                        style="margin-left:auto; margin-right:auto;">
                    </td>';
            }


            echo '</tr>';
        }
    }

    public function actionAddIssueTshirt() {

        // Issuing a t shirt

        $employeeid = CJSON::decode($_POST['Employeeid']);
        $tshirtIssue = new EmployeeTshirt;
        $tshirtIssue->empID = $employeeid;
        $tshirtIssue->issuedDate = $_POST['IssuedDate'];
        $tshirtIssue->save();
    }

    public function actionAddIssueShoePair() {

        // Issuing a pair of shoes

        $employeeid = CJSON::decode($_POST['Employeeid']);
        $shoeIssue = new EmployeeShoe;
        $shoeIssue->empID = $employeeid;
        $shoeIssue->issuedDate = $_POST['ShoesIssuedDate'];
        $shoeIssue->save();
    }

    public function actionUpdateShoeIssueTable() {

        //update t shirt issues

        $issueID = $_POST['shoeIssueID'];
        $status = $_POST['shoeIssueStatus'];
        if ($status == 'true') {
            EmployeeShoe::model()->updateAll(array('returnedDate' => date('Y-m-d'), 'Status' => 'Returned'), "issueID=" . $issueID . "");
        } else {
            EmployeeShoe::model()->updateAll(array('returnedDate' => null, 'Status' => 'Not Returned'), "issueID=" . $issueID . "");
        }
    }

    public function actionUpdateTshirtIssueTable() {

        //update shoe issues

        $issueID = $_POST['tshirtIssueID'];
        $status = $_POST['tshirtIssueStatus'];

        if ($status == 'true') {
            EmployeeTshirt::model()->updateAll(array('returnedDate' => date('Y-m-d'), 'Status' => 'Returned'), "issueID=" . $issueID . "");
        } else {
            EmployeeTshirt::model()->updateAll(array('returnedDate' => null, 'Status' => 'Not Returned'), "issueID=" . $issueID . "");
        }
    }

    public function actionChangeProfilePicture() {

        $uploads_dir = Yii::getPathOfAlias("webroot") . '/themeassets/employee-images';
        $tmp_name = $_FILES["file"]["tmp_name"];
        $name = basename($_FILES["file"]["name"]);

        $employee = $_POST["employee"];
        $imageNewname =$employee ."-". date("Y-m-d-Hi");
        $type = $_FILES["file"]["type"];
        $filename = $imageNewname . ".jpeg";
        $newpath = "$uploads_dir/$filename";
        $newpath2 = '/themeassets/employee-images/' . $filename;
        Employee::model()->updateAll(array('profileImage' => $newpath2), "id=" . $employee);
        move_uploaded_file($tmp_name, $newpath);
    }

    //===================================================================================
    public function actionImportCSV() {

        if (($handle = fopen('lpdc2.csv', 'r')) !== false) {

            while (($row = fgetcsv($handle, 1000, ",")) !== false) {
                $model = new Employee();

                $model->title = $row[0];
                $model->LabourCategory = $row[25];
                $model->EntitleOT = 0; //===================
                $model->TeamStatus = 0; //===================
                $model->Accountid = (int) $row[26];
                $model->gender = $row[1];
                $model->FirstName = strtoupper($row[3]);
                $model->tshirtsize = (int) $row[18];
                $model->SurName = strtoupper($row[5]);
                $model->FullName = strtoupper($row[7]);
                $model->nic = $row[8];
                $model->date_of_birth = $row[9];
                $model->address = $row[10];
                $model->designationid = (int) $row[11];
                $model->joindate = $row[12];
                $model->paymentmethodid = (int) $row[13];
                $model->siteid = (int) $row[14];
                $model->departmentid = (int) $row[15];
                $model->categoryid = (int) $row[16];
                $model->supplierid = (int) $row[17];
                $model->shoesize = (int) $row[19];
                $model->CivilStatus = $row[2];
                $model->Namewithini = strtoupper($row[6]);
                $model->LastName = strtoupper($row[4]);
                $model->EPFNo = $row[20];



                if ($model->validate()) {
                    $model->save();




                    // ===========================================================================      
                    $employeedesigna = new EmployeeDesignation;
                    $employeedesigna->Status = 1;
                    $employeedesigna->EmployeeId = $model->id;
                    $employeedesigna->DesignationId = $model->designationid;
                    $date = date('Y-m-d H:i:s');
                    $employeedesigna->DateTime = $date;
                    if ($employeedesigna->save()) {
                        $designationSalary = DesignationSalary::model()->findByAttributes(
                                array(
                                    "DesignationId" => $model->designationid,
                                    "Status" => 1
                                )
                        );
                        $monthlyWage = $designationSalary != null ? $designationSalary->MonthlySalary : 0;

                        $dailyWage = Yii::app()->paymentUtil->getDayWage($monthlyWage, $model->paymentmethod, "WagesBoard");
                        $hourlyRate = Yii::app()->paymentUtil->getHourlyRate($monthlyWage, $model->paymentmethod, "WagesBoard");
                        $doubleOTRate = Yii::app()->paymentUtil->getDoubleOTRate($monthlyWage, $model->paymentmethod, "WagesBoard");
                        $normalOTRate = Yii::app()->paymentUtil->getOvetimeRateNormalDay($monthlyWage, $model->paymentmethod, "WagesBoard");
                        $empSalary = new Employeesalary;
                        $empSalary->employeeid = $model->id;
                        $empSalary->monthsalary = $monthlyWage;
                        $empSalary->DalySalary = $dailyWage;
                        $empSalary->HourlyRate = $hourlyRate;
                        $empSalary->DoubleOTRate = $doubleOTRate;
                        $empSalary->OTRate = $normalOTRate;
                        $empSalary->CreatedBy = Yii::app()->user->id;
                        $empSalary->CreatedOn = $date;
                        $empSalary->Status = 1;
                        $empSalary->save();
                    }
                } else {
                    //... code If an error in the preservation.
                    $model2 = new EmployeeBulckUploadFails;
                    $model2->NameWithInitial = $row[7];
                    $model2->FullName = $row[5];
                    $model2->NIC = $row[8];
                    $model2->save();
                    //$model2->Description = $lastName;
                    //print_r('fail');
                    //die;
                }
            }
            fclose($handle);
            print_r("upload finished");
        }
    }

    public function actionGetAllEmployees() {
        $employees = Employee::model()->findAll();
        $this->_sendResponse(200, CJSON::encode($employees));
    }

    public function actionViewAnother() {
        $id = $_POST['employee'];
        $this->redirect(array('view', 'id' => $id));
    }

    public function actionGetIncentives() {
        //Search for shoe issues for the relevant employee  

        $employeeid = $_POST['Employeeid'];
        if (Yii::app()->user->isAdmin()) {
            $inscntives = Yii::app()->db->createCommand("SELECT EI.*,I.name
            FROM employee_incentive EI
            INNER JOIN incentive I ON I.id = EI.incentive_id
            WHERE EI.employee_id = $employeeid
            ORDER BY EI.status DESC")->queryAll();
        } else {
            $inscntives = Yii::app()->db->createCommand("SELECT EI.*,I.name
            FROM employee_incentive EI
            INNER JOIN incentive I ON I.id = EI.incentive_id
            WHERE EI.employee_id = $employeeid AND EI.site_id = " . Yii::app()->user->data()->SiteId . "
            ORDER BY EI.status DESC")->queryAll();
        }

        //  print_r($inscntives);
        foreach ($inscntives as $inscntive) {

            $Site = Sites::model()->findByPk($inscntive['site_id']);
            $status = $inscntive['status'] == 1 ? '<td><div style="background: #3cc051;color: white;padding: 3px; font-size: 11px;    max-width: 58px;
            text-align: center;" >ACTIVE</div></td>' : '<td><div style="background: #ed4e2a;color: white;padding: 3px;font-size: 11px;    max-width: 58px;text-align: center;" >INACTIVE</div></td>';
            echo '<tr>';
            echo '<td>' . $inscntive['name'] . '</td>';
            echo '<td>' . $inscntive['incentive_amount'] . '</td>';
            echo '<td>' . $inscntive['createdOn'] . '</td>';
            echo '<td>' . $Site['name'] . '</td>';
            echo $status;
             if($inscntive['status'] == 1){
                 echo '<td style="text-align: center;"><a onClick="deactiveIncentive('.$employeeid.','.$inscntive['incentive_id'].')"><i style="color:#ed4e2a;font-size:20px;" class="fa fa-times-circle"></i></a></td>';
             }else{
                 echo '<td style="text-align: center;"><a onClick="activeIncentive('.$inscntive['id'].','.$employeeid.','.$inscntive['incentive_id'].')"><i style="color:#3cc051;font-size:20px;" class="fa fa-check-circle"></i></i></a></td>';
             }
            echo '<tr>';
        }
    }


    public function actionGetServiceBreakDown() {
        $employeeid = $_POST['Employeeid'];
        $results = Yii::app()->db->createCommand("SELECT *  FROM `employee_join_details` WHERE `employee_id` = $employeeid ORDER BY `id` ASC")->queryAll();

        //  print_r($inscntives);
        foreach ($results as $result) {

            $Site = Sites::model()->findByPk($result['site_id']);
            echo '<tr>';
            echo '<td>' . $Site['name'] . '</td>';
            echo '<td>' . $result['join_date'] . '</td>';
            echo '<td>' . $result['created_on'] . '</td>';
            echo '<tr>';
        }
    }

    public function actionDeactivateIncentive() {
        $empId = $_POST['Employeeid'];
        $incntvId = $_POST['Incentiveid'];

        EmployeeIncentive::model()->updateAll(array('status' => 0), "employee_id=" . $empId . " AND status = 1 AND incentive_id=" . $incntvId . "");

        print_r(true);
    }
    public function actionactivateIncentive(){
        $empIncentiveId = $_POST['empIncentiveId'];
        $empId = $_POST['empId'];
        $incentiveId = $_POST['incentiveId'];
        $site_id = Yii::app()->user->data()->SiteId;
        
        $isIncentiveAvailable = EmployeeIncentive::model()->findByAttributes(array('employee_id' => $empId, 'site_id' => $site_id, 'incentive_id' => $incentiveId, 'status' => 1));
        if (empty($isIncentiveAvailable)) {
            EmployeeIncentive::model()->updateAll(array('status' => 1), "id=" . $empIncentiveId . "");
            print(true);
        }else{
            print_r(false);
        }

        
    }

    public function actionChangeDesignation() {
        // $emp_id = 1;
        // $designation_id = 19;

        $emp_id = $_POST['emp_id'];
        $designation_id = $_POST['designation_id'];

        $oldEmployee = Employee::model()->findByPk($emp_id);
        Employee::model()->updateByPk($emp_id, ['designationid' => $designation_id]);
        $employee = Employee::model()->findByPk($emp_id);

        $employeedesigna = new EmployeeDesignation;
        $employeedesigna::model()->updateAll(array('Status' => 0), 'EmployeeId ="' . $employee->id . '"');
        $employeedesigna->Status = 1;
        $employeedesigna->EmployeeId = $employee->id;
        $employeedesigna->DesignationId = $employee->designationid;
        $employeedesigna->DateTime = date('Y-m-d H:i:s');

        if ($employeedesigna->save()) {

            //write data in employee_designation_details table
            EmployeeDesignationDetails::model()->updateAll(array('status' => 0), "employee_id=" . $employee->id . " AND site_id=" . $employee->siteid . " AND Status = 1");
            $employeeDesignation = new EmployeeDesignationDetails;
            $employeeDesignation->employee_id = $employee->id;
            $employeeDesignation->site_id = $employee->siteid;
            $employeeDesignation->designation_id = $employee->designationid;
            $employeeDesignation->created_on = date('Y-m-d H:i:s');
            $employeeDesignation->changed_by = Yii::app()->user->id;
            $employeeDesignation->status = 1;
            $employeeDesignation->save();

            $designationSalary = DesignationSalary::model()->findByAttributes(array("DesignationId" => $employee->designationid, "Siteid" => $employee->siteid, "Status" => 1));

            if ($employee->paymentmethod['type'] == "DAILY") {
                $Wage = $designationSalary != null ? $designationSalary->DailySalary : 0;
                $monthlyWage = 26 * $Wage;

                $basic = $designationSalary != null ? $designationSalary->DailyBasicSalary : 0;
                $bra1 = $designationSalary != null ? $designationSalary->DailyBRA1 : 0;
                $bra2 = $designationSalary != null ? $designationSalary->DailyBRA2 : 0;
                $bra3 = $designationSalary != null ? $designationSalary->DailyBRA3 : 0;
            } else {
                $Wage = $designationSalary != null ? $designationSalary->MonthlySalary : 0;
                $monthlyWage = $Wage;

                $basic = $designationSalary != null ? $designationSalary->MonthlyBasicSalary : 0;
                $bra1 = $designationSalary != null ? $designationSalary->MonthlyBRA1 : 0;
                $bra2 = $designationSalary != null ? $designationSalary->MonthlyBRA2 : 0;
                $bra3 = $designationSalary != null ? $designationSalary->MonthlyBRA3 : 0;
            }

            $dailyWage = Yii::app()->paymentUtil->getDayWage($Wage, $employee->paymentmethod['type'], $employee->labourcategory->name);
            $hourlyRate = Yii::app()->paymentUtil->getHourlyRate($Wage, $employee->paymentmethod['type'], $employee->labourcategory->name);
            $doubleOTRate = Yii::app()->paymentUtil->getDoubleOTRate($Wage, $employee->paymentmethod['type'], $employee->labourcategory->name);
            $normalOTRate = Yii::app()->paymentUtil->getOvetimeRateNormalDay($Wage, $employee->paymentmethod['type'], $employee->labourcategory->name);

            Employeesalary::model()->updateAll(array('monthsalary' => $monthlyWage, 'DalySalary' => $dailyWage, 'HourlyRate' => $hourlyRate, 'DoubleOTRate' => $doubleOTRate, 'OTRate' => $normalOTRate, 'BasicSalary' => $basic, 'BRA1' => $bra1, 'BRA2' => $bra2, 'BRA3' => $bra3), 'employeeid ="' . $employee->id . '" AND site_id ="' . $employee->siteid . '" AND Status ="' . 1 . '"');

            $designationIncentives = DesignationIncentive::model()->findAllByAttributes(array("designation_id" => $employee->designationid, "site_id" => $employee->siteid, "status" => 1));
            EmployeeIncentive::model()->updateAll(array('status' => 0), 'employee_id ="' . $employee->id . '" AND site_id ="' . $employee->siteid . '"');
            if ($designationIncentives) {

                foreach ($designationIncentives as $designationIncentive) {

                    $newEmployeeIncentive = new EmployeeIncentive;

                    $newEmployeeIncentive->employee_id = $employee->id;
                    $newEmployeeIncentive->incentive_id = $designationIncentive['incentive_id'];

                    if ($employee->paymentmethod['type'] == "DAILY")
                        $newEmployeeIncentive->incentive_amount = $designationIncentive['incentive_amount_daily'];
                    else
                        $newEmployeeIncentive->incentive_amount = $designationIncentive['incentive_amount_monthly'];

                    $newEmployeeIncentive->createdBy = Yii::app()->user->id;
                    $newEmployeeIncentive->createdOn = date('Y-m-d H:i:s');
                    $newEmployeeIncentive->site_id = $employee->siteid;
                    $newEmployeeIncentive->status = 1;
                    $newEmployeeIncentive->save();
                }
            }

            $members = Yii::app()->db->createCommand("SELECT EGM.* 
                    FROM email_groups EG
                    INNER JOIN email_group_members EGM ON EGM.email_group_id = EG.id
                    WHERE EG.group_name = 'EMPLOYEE DESIGNATION OR SALARY CHANGE' AND EGM.email_group_id = EG.id AND EGM.status = 1 AND EGM.site_id ='" . $employee->siteid . "'")->queryAll();
            if (!empty($members))
               // Yii::app()->commonUtil->SendMail('designationChange', 'DESIGNATION CHANGE', $members, array('designation_id' => $designation_id, 'changed_by' => Yii::app()->user->id), $oldEmployee);
            echo true;
        }
    }

    public function actionEmployeecard() {

        $model = CJSON::decode($_POST['model']);
        $filepath = Yii::app()->getBaseUrl(true) . $model['profileImage'];





        $this->render('employeecard', array('model' => $model, 'filepath' => $filepath));
    }

    public function actionSyncEmployee() {

        $siteId = Yii::app()->user->data()->SiteId;
        $siteName = Sites::model()->findByPk($siteId);
        $key = 'Value';
        $value = $siteName->name . '_' . date('Y-m-d H:i:s');

        $serviceAccount = ServiceAccount::fromJsonFile('secret/efl-wfm-console-e35c327b704d.json');

        $firebase = (new Factory)
                ->withServiceAccount($serviceAccount)
                ->create();

        $database = $firebase->getDatabase();
        $database->getReference()->getChild($key)->set($value);

        $this->_sendResponse(200, CJSON::encode(true));
    }

    public function actionGetContractFee() {
        $id = $_POST['empId'];
        $siteId = $_POST['siteId'];
        $contractfee = Employeecontractfee::model()->findByAttributes(array('employeeid' => $id, 'site_id' => $siteId, 'status' => 1))->contractfee;
        
        $this->_sendResponse(200, $contractfee);
    }

    public function actionTransferEmployees() {
        $model = new TransferEmployees;
        $employees = Employee::model()->findAllByAttributes(array('statusId' => 1));
        $Sites = Sites::model()->findAll();

        if (isset($_POST['TransferEmployees'])) {

            $model->attributes = $_POST['TransferEmployees'];

            if ($model->validate() && isset($_POST['employees'])) {

                $empIds = $_POST['employees'];
                foreach ($empIds as $empId) {
                    $oldEmplyeeDetails = $this->loadModel($empId); //get employee's details befor transfer

                    $employee = $this->loadModel($empId); //update employee's details
                    $employee->siteid = $model->site;
                    $employee->Accountid = $model->account;
                    $employee->departmentid = $model->department;
                    $employee->designationid = $model->designation;
                    $employee->Shift_mode = 'NON-ROSTER-BASE';
                    $employee->paymentmethodid = $model->PaymentMethod;
                    $employee->LabourCategory = $model->LabourCategorys;
                    $employee->TeamStatus = 0;

                    if ($employee->save()) {    //create employee salary
                        //inactive all resign dates in employee current site
                        EmployeeResignDetails::model()->updateAll(array('status' => 0), "employee_id=" . $empId . " AND site_id=" . $employee->siteid . " AND Status = 1");

                        //write data in employee_resign_details table
                        EmployeeResignDetails::model()->updateAll(array('status' => 0), "employee_id=" . $empId . " AND site_id=" . $oldEmplyeeDetails->siteid . " AND Status = 1");
                        $employeeResign = new EmployeeResignDetails;
                        $employeeResign->employee_id = $empId;
                        $employeeResign->site_id = $oldEmplyeeDetails->siteid;
                        $employeeResign->resign_date = $model->resignDate;
                        $employeeResign->created_on = date('Y-m-d H:i:s');
                        $employeeResign->created_by = Yii::app()->user->id;
                        $employeeResign->status = 1;
                        $employeeResign->save();

                        //write data in employee_join_details table
                        EmployeeJoinDetails::model()->updateAll(array('status' => 0), "employee_id=" . $empId . " AND site_id=" . $employee->siteid . " AND Status = 1");
                        $employeeJoin = new EmployeeJoinDetails;
                        $employeeJoin->employee_id = $empId;
                        $employeeJoin->site_id = $employee->siteid;
                        $employeeJoin->join_date = $model->joinDate;
                        $employeeJoin->created_on = date('Y-m-d H:i:s');
                        $employeeJoin->created_by = Yii::app()->user->id;
                        $employeeJoin->status = 1;
                        $employeeJoin->save();

                        //write data in employee_designation_details table
                        EmployeeDesignationDetails::model()->updateAll(array('status' => 0), "employee_id=" . $empId . " AND site_id=" . $employee->siteid . " AND Status = 1");
                        $employeeDesignation = new EmployeeDesignationDetails;
                        $employeeDesignation->employee_id = $empId;
                        $employeeDesignation->site_id = $employee->siteid;
                        $employeeDesignation->designation_id = $employee->designationid;
                        $employeeDesignation->created_on = date('Y-m-d H:i:s');
                        $employeeDesignation->changed_by = Yii::app()->user->id;
                        $employeeDesignation->status = 1;
                        $employeeDesignation->save();

                        Employeecontractfee::model()->updateAll(array('status' => 0), "employeeid=" . $empId . " AND site_id=" . $employee->siteid . " AND status = 1");
                        $EmplyeeContractFee = new Employeecontractfee;
                        $EmplyeeContractFee->employeeid = $empId;
                        $EmplyeeContractFee->contractfee = $model->EmployeeContactfee;
                        $EmplyeeContractFee->site_id = $employee->siteid;
                        $EmplyeeContractFee->status = 1;
                        $EmplyeeContractFee->save();

                        Employeesalary::model()->updateAll(array('Status' => 0), "employeeid=" . $employee->id . " AND site_id=" . $employee->siteid . " AND Status = 1");
                        $empPaymentMethod = Paymentmethod::model()->findByPk($employee->paymentmethodid);
                        $designationSalary = DesignationSalary::model()->findByAttributes(['DesignationId' => $employee->designationid, 'Siteid' => $employee->siteid, 'Status' => 1]);

                        if ($empPaymentMethod->type == "DAILY") {
                            $Wage = $designationSalary != null ? $designationSalary->DailySalary : 0;
                            $monthlyWage = 26 * $Wage;
                        } else {
                            $Wage = $designationSalary != null ? $designationSalary->MonthlySalary : 0;
                            $monthlyWage = $Wage;
                        }

                        $dailyWage = Yii::app()->paymentUtil->getDayWage($Wage, $empPaymentMethod->type, $employee->labourcategory->name);
                        $hourlyRate = Yii::app()->paymentUtil->getHourlyRate($Wage, $empPaymentMethod->type, $employee->labourcategory->name);
                        $doubleOTRate = Yii::app()->paymentUtil->getDoubleOTRate($Wage, $empPaymentMethod->type, $employee->labourcategory->name);
                        $normalOTRate = Yii::app()->paymentUtil->getOvetimeRateNormalDay($Wage, $empPaymentMethod->type, $employee->labourcategory->name);

                        $empSalary = new Employeesalary;
                        $empSalary->employeeid = $employee->id;
                        $empSalary->monthsalary = $monthlyWage;
                        $empSalary->DalySalary = $dailyWage;
                        $empSalary->HourlyRate = $hourlyRate;
                        $empSalary->DoubleOTRate = $doubleOTRate;
                        $empSalary->OTRate = $normalOTRate;
                        $empSalary->CreatedBy = Yii::app()->user->id;
                        $empSalary->CreatedOn = date("Y-m-d H:i");
                        $empSalary->Status = 1;
                        $empSalary->site_id = $employee->siteid;
                        $empSalary->salaryChanged = 1;

                        if ($empPaymentMethod->type == "DAILY") {
                            $empSalary->BasicSalary = $designationSalary != null ? $designationSalary->DailyBasicSalary : 0;
                            $empSalary->BRA1 = $designationSalary != null ? $designationSalary->DailyBRA1 : 0;
                            $empSalary->BRA2 = $designationSalary != null ? $designationSalary->DailyBRA2 : 0;
                            $empSalary->BRA3 = $designationSalary != null ? $designationSalary->DailyBRA3 : 0;
                        } else {

                            $empSalary->BasicSalary = $designationSalary != null ? $designationSalary->MonthlyBasicSalary : 0;
                            $empSalary->BRA1 = $designationSalary != null ? $designationSalary->MonthlyBRA1 : 0;
                            $empSalary->BRA2 = $designationSalary != null ? $designationSalary->MonthlyBRA2 : 0;
                            $empSalary->BRA3 = $designationSalary != null ? $designationSalary->MonthlyBRA3 : 0;
                        }

                        if ($empSalary->save()) { // create employee incentive
                            $designationIncentives = DesignationIncentive::model()->findAllByAttributes(array("designation_id" => $employee->designationid, "site_id" => $employee->siteid, "status" => 1));
                            EmployeeIncentive::model()->updateAll(array('status' => 0), 'employee_id ="' . $employee->id . '" AND site_id ="' . $employee->siteid . '" AND status = 1');
                            if ($designationIncentives) {

                                foreach ($designationIncentives as $designationIncentive) {

                                    $newEmployeeIncentive = new EmployeeIncentive;

                                    $newEmployeeIncentive->employee_id = $employee->id;
                                    $newEmployeeIncentive->incentive_id = $designationIncentive['incentive_id'];

                                    if ($employee->paymentmethod['type'] == "DAILY")
                                        $newEmployeeIncentive->incentive_amount = $designationIncentive['incentive_amount_daily'];
                                    else
                                        $newEmployeeIncentive->incentive_amount = $designationIncentive['incentive_amount_monthly'];

                                    $newEmployeeIncentive->createdBy = Yii::app()->user->id;
                                    $newEmployeeIncentive->createdOn = date('Y-m-d H:i:s');
                                    $newEmployeeIncentive->status = 1;
                                    $newEmployeeIncentive->site_id = $employee->siteid;
                                    $newEmployeeIncentive->save();
                                } //end of designation incentive wise foreach
                            }// check designation has incentive
                        }// end of employee salary save

                        Yii::app()->RemoveEmployeeFromShiftUtil->removeAllShiftsAndTimesheets($model->resignDate, $empId);
                    }// end of employee save
                }// end of employee wise foreach

                $this->render('transferEmployees', array('model' => new TransferEmployees, 'employees' => $employees, 'Sites' => $Sites));
            }else {
                $this->render('transferEmployees', array('model' => $model, 'employees' => $employees, 'Sites' => $Sites));
            }
        } else {
            $this->render('transferEmployees', array('model' => $model, 'employees' => $employees, 'Sites' => $Sites));
        }
    }

    public function actionActiveEmployeeConuntBeginOfMonth() {
        $sites = Sites::model()->findAll();
        $date = date('Y-m');
        foreach ($sites as $site) {
            $count = Yii::app()->db->createCommand("SELECT COUNT(E.id) as count FROM employee E WHERE E.statusId = 1 AND E.siteid = '" . $site['id'] . "'")->queryScalar();
            $model = new ActiveEmployeeCount;
            $model->date = $date;
            $model->site_id = $site['id'];
            $model->count_of_begin = $count;
            $model->count_of_end = 0;
            $model->created_on = date('Y-m-d H:i:s');
            $model->save();
        }
    }

    public function actionActiveEmployeeConuntEndOfMonth() {
        $sites = Sites::model()->findAll();
        $date = date('Y-m');
        foreach ($sites as $site) {
            $count = Yii::app()->db->createCommand("SELECT COUNT(E.id) as count FROM employee E WHERE E.statusId = 1 AND E.siteid = '" . $site['id'] . "'")->queryScalar();
            ActiveEmployeeCount::model()->updateAll(array('count_of_end' => $count), "date='" . $date . "' AND site_id=" . $site['id'] . "");
        }
    }

    public function actionResignEmployeeConuntEndOfMonth() {
        $sites = Sites::model()->findAll();
        $date = date('Y-m');
        foreach ($sites as $site) {
            $count = Yii::app()->db->createCommand("SELECT COUNT(E.id) as count FROM employee E WHERE E.statusId = 2 AND E.siteid = '" . $site['id'] . "' AND E.resigndate LIKE '%{$date}%'")->queryScalar();
            $model = new ResignEmployeeCount;
            $model->date = $date;
            $model->site_id = $site['id'];
            $model->count = $count;
            $model->created_on = date('Y-m-d H:i:s');
            $model->save();
        }
    }

    public function actionSitewiseAbsentAndAvailableDays() {

        $sites = Sites::model()->findAll();
        $start_date = date('Y-m-d', strtotime('first day of last month'));
        $end_date = date('Y-m-d', strtotime('last day of last month'));
        $year_month = date('Y-m', strtotime('first day of last month'));
        $year = date('Y', strtotime('first day of last month'));
        $month = date('m', strtotime('first day of last month'));


        //=============calculate working days in month-=============================
        $count = 0;
        $ignore = array(0); // 0 for sundays
        $counter = mktime(0, 0, 0, $month, 1, $year);
        while (date("n", $counter) == $month) {
            if (in_array(date("w", $counter), $ignore) == false) {
                $count++;
            }
            $counter = strtotime("+1 day", $counter);
        }

        //===========================================================================
        $holiday_count = Yii::app()->db->createCommand("SELECT count(*)
            FROM holydays H
            WHERE H.Date LIKE '%{$year_month}%' AND H.type = 'GENERAL'")->queryScalar();

        $available_working_days_in_month = $count - $holiday_count;

        foreach ($sites as $site) {
            $absent_days = Yii::app()->db->createCommand("SELECT count(*) FROM
                (SELECT employee_shift.EmployeeId as EmployeeId,shift.name as Shift,shift.StartTime as StartTime,'No Pay' as PaidType,employee.siteid as Site,employee.Accountid as Account
                FROM  employee_shift
                LEFT JOIN timesheet ON employee_shift.id = timesheet.EmployeeShiftid
                LEFT JOIN employee ON employee_shift.EmployeeId = employee.id
                INNER JOIN shift ON shift.id = employee_shift.shiftid
                WHERE employee.statusId = 1 AND Intime IS NULL AND OuteTime IS NULL AND
                DATE( shift.StartTime ) >= '$start_date' AND DATE( shift.StartTime ) <='$end_date' AND employee_shift.EmployeeId NOT IN (SELECT EmoloyeeId
                FROM  `leave` AS L
                WHERE L.StartDate >='$start_date'
                AND DATE_ADD( L.StartDate, INTERVAL L.No_of_Day DAY) <= '$end_date')


                UNION


                SELECT employee_shift.EmployeeId as EmployeeId,shift.name as Shift,shift.StartTime as StartTime,'No Pay' as PaidType,employee.siteid as Site,employee.Accountid as Account
                FROM  employee_shift
                LEFT JOIN timesheet ON employee_shift.id = timesheet.EmployeeShiftid
                LEFT JOIN employee ON employee_shift.EmployeeId = employee.id
                INNER JOIN shift ON shift.id = employee_shift.shiftid
                WHERE employee.statusId = 1 AND Intime IS NULL AND OuteTime IS NULL AND
                DATE( shift.StartTime ) >= '$start_date' AND DATE( shift.StartTime ) <= '$end_date' AND employee_shift.EmployeeId IN (SELECT EmoloyeeId
                FROM  `leave` AS L
                WHERE L.StartDate >='$start_date'
                AND DATE_ADD( L.StartDate, INTERVAL L.No_of_Day DAY) <=  '$end_date' AND PaidType = 'NO Pay')
                ) as newTable
                WHERE newTable.Site = '" . $site['id'] . "'
                ORDER BY newTable.Account,newTable.EmployeeId")->queryScalar();

            $employee_count = Yii::app()->db->createCommand("SELECT count(DISTINCT(T.Employeeid))
                FROM timelog T 
                WHERE T.PunchTime LIKE '%{$year_month}%' AND T.Siteid = '" . $site['id'] . "'")->queryScalar();

            if ($employee_count == '' || $employee_count == 0)
                $employee_count = 1;

            $total_available_days = $available_working_days_in_month * $employee_count;

            $absenteeism_rate = ($absent_days / $total_available_days) * 100;

            $model = new SitewiseAbsentdaysAndWorlkingdays;
            $model->date = $year_month;
            $model->site = $site['id'];
            $model->absent_days = $absent_days;
            $model->available_working_days = $total_available_days;
            $model->absenteeism_rate = round($absenteeism_rate, 2);
            $model->save();
        }
    }

}
