<?php

class ImportExcelController extends Controller {

    public function accessRules() {
        return array(
            array('allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('ImportVAS','ImportTimelogs', 'ImportAdhocCadre', 'ImportLeave', 'ImportAdhocTimelog'),
                'users' => array('*'),
            ),
            array('allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array(),
                'users' => array('@'),
            ),
            array('allow', // allow admin user to perform 'admin' and 'delete' actions
                'actions' => array(),
                'users' => array('admin'),
            ),
            array('deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function actionImportVAS() {
        $model = new ImportForm;
        //  require_once Yii::app()->basePath.'/../upload/excel_reader2.php';

        if (isset($_POST['ImportForm'])) {

            $a = $model->validate();
            if ($a) {
                //upload file
                $model->attributes = $_POST['ImportForm'];
                $file = CUploadedFile::getInstance($model, 'file_excel');
                $fileName = date("Y-m-d - h:i:sa");

                $file->saveAs(Yii::app()->basePath . '/../uploadVAS/' . $fileName . '.xls');

                //Read excel to array
                $path = Yii::app()->basepath . '/../uploadVAS/' . $fileName . '.xls';
                $sheet_array = Yii::app()->yexcel->readActiveSheet($path);

                if (!empty($sheet_array)) {
                    $vasTrack = new VasSourceFileTrack;
                    $vasTrack->file_name = $fileName . '.xls';
                    $vasTrack->file_location = $path;
                    $vasTrack->created_by = Yii::app()->user->id;
                    $vasTrack->save();

                    for ($i = 1; $i <= count($sheet_array); $i++) {
                        if ($sheet_array[$i]['A'] != '') {
                            $dailyVAS = new DailyVas;
                            $dailyVAS->nic = $sheet_array[$i]['A'];
                            $dailyVAS->sku = $sheet_array[$i]['B'];
                            $dailyVAS->dec = $sheet_array[$i]['C'];
                            $dailyVAS->client_rate = $sheet_array[$i]['D'];
                            $dailyVAS->employee_rate = $sheet_array[$i]['E'];
                            $dailyVAS->no_of_pieces = $sheet_array[$i]['F'];
                            $dailyVAS->source_id = $vasTrack->id;
                            $dailyVAS->save();
                        }
                    }
                }
                Yii::app()->user->setFlash('success', 'Upload Successful');
                unlink($path);
                $this->render('//import/import', array('model' => new ImportForm, 'heading' => 'Import Daily VAS Pieces', 'imgPath' => ''));
            }
        } else {
            $this->render('//import/import', array('model' => $model, 'heading' => 'Import Daily VAS Pieces', 'imgPath' => ''));
        }
    }

    public function actionImportAdhocCadre() {
        $model = new ImportForm;
        //  require_once Yii::app()->basePath.'/../upload/excel_reader2.php';

        if (isset($_POST['ImportForm'])) {

            $a = $model->validate();
            if ($a) {
                //upload file
                $model->attributes = $_POST['ImportForm'];
                $file = CUploadedFile::getInstance($model, 'file_excel');
                $fileName = date("Y-m-d - h:i:sa");

                $file->saveAs(Yii::app()->basePath . '/../uploadVAS/' . $fileName . '.xls');

                //Read excel to array
                $path = Yii::app()->basepath . '/../uploadVAS/' . $fileName . '.xls';
                $sheet_array = Yii::app()->yexcel->readActiveSheet($path);

                if (!empty($sheet_array)) {
                    $adhocTrack = new AdhocSourceFileTrack;
                    $adhocTrack->file_name = $fileName . '.xls';
                    $adhocTrack->file_location = $path;
                    $adhocTrack->created_by = Yii::app()->user->id;
                    $adhocTrack->save();

                    for ($i = 1; $i <= count($sheet_array); $i++) {
                        if ($sheet_array[$i]['A'] != '') {
                            $model = new AdhocCadreData;
                            $model->date = $sheet_array[$i]['A'];
                            $model->manpowe_supplier = $sheet_array[$i]['B'];
                            $model->department = $sheet_array[$i]['C'];
                            $model->customer_name = $sheet_array[$i]['D'];
                            $model->special_designation = $sheet_array[$i]['E'];
                            $model->number_of_heads = $sheet_array[$i]['F'];
                            $model->daily_rate = $sheet_array[$i]['G'];
                            $model->total_basic = $sheet_array[$i]['H'];
                            $model->normal_ot_rate = $sheet_array[$i]['I'];
                            $model->total_normal_ot_hours = $sheet_array[$i]['J'];
                            $model->total_normal_ot = $sheet_array[$i]['K'];
                            $model->double_ot_rate = $sheet_array[$i]['L'];
                            $model->total_double_ot_hours = $sheet_array[$i]['M'];
                            $model->total_double_ot = $sheet_array[$i]['N'];
                            $model->total_salary = $sheet_array[$i]['O'];

                            $model->save();
                        }
                    }
                }
                $this->render('//import/import', array('model' => new ImportForm, 'heading' => 'Import Adhoc Cadre Employees Details', 'imgPath' => ''));
            }
        } else {
            $this->render('//import/import', array('model' => $model, 'heading' => 'Import Adhoc Cadre Employees Details', 'imgPath' => ''));
        }
    }

    public function actionImportLeave() {
        $model = new ImportForm;
        //  require_once Yii::app()->basePath.'/../upload/excel_reader2.php';

        if (isset($_POST['ImportForm'])) {

            $a = $model->validate();
            if ($a) {
                //upload file
                $model->attributes = $_POST['ImportForm'];
                $file = CUploadedFile::getInstance($model, 'file_excel');
                $fileName = 'leave';

                $file->saveAs(Yii::app()->basePath . '/../uploadVAS/' . $fileName . '.xls');

                //Read excel to array
                $path = Yii::app()->basepath . '/../uploadVAS/' . $fileName . '.xls';
                $sheet_array = Yii::app()->yexcel->readActiveSheet($path);

                if (!empty($sheet_array)) {
                    for ($i = 2; $i <= count($sheet_array); $i++) {
                        if ($sheet_array[$i]['A'] != '') {
                            // print_r($sheet_array[$i]['A']);die;


                            $model = new Leave;
                            $employee = Employee::model()->findByAttributes(array('nic' => $sheet_array[$i]['A']));
                            $model->EmoloyeeId = $employee->id;
                            $model->StartDate = $sheet_array[$i]['B'];
                            $model->No_of_Day = 1;
                            $model->No_Of_Hour = 0;
                            $model->LeaveType = 9;
                            $model->PaidType = 'Pay';
                            $model->Reason = 'Bulk Upload';
                            $model->CreatedBy = 11;
                            $model->CreatedTime = date('Y-m-d H:i:s');
                            $model->Approvedtime = date('Y-m-d H:i:s');
                            $model->ApprovedBy = 11;
                            $model->Status = 1;
                            $model->site = $employee->siteid;

                            if ($model->save()) {
                                $dayCount = $model->day_type == "Half Day" ? 1 : (int) ($model->No_of_Day);
                                $leveTypeStatus = $model->day_type == "Half Day" ? 1 : 0;

                                $lDate = date($model->StartDate);
                                $day = date('D', strtotime($lDate));

                                for ($j = 0; $j < $dayCount; $j++) {
                                    if (!($day == 'Sun')) {

                                        $leaveday = new Leavedays;
                                        $leaveday->leaveDays = $lDate;
                                        $leaveday->EmpId = $model->EmoloyeeId;
                                        $leaveday->Hours = $model->No_Of_Hour;
                                        $leaveday->CreatedOn = $model->CreatedTime;
                                        $leaveday->CreatedBy = $model->CreatedBy;
                                        $leaveday->leaveId = $model->id;
                                        $leaveday->leaveType = $model->PaidType;
                                        $leaveday->leave_type_status = $leveTypeStatus;
                                        $leaveday->save();
                                    } else {
                                        $dayCount++;
                                    }
                                    $lDate = date('Y-m-d', strtotime($lDate . ' + 1 days'));
                                    $day = date('D', strtotime($lDate));
                                }
                            }
                        }
                    }
                }
                Yii::app()->user->setFlash('success', 'Upload Successful');
                unlink($path);
                $this->render('//import/import', array('model' => new ImportForm, 'heading' => 'Import Leave Details', 'imgPath' => ''));
            }
        } else {
            $this->render('//import/import', array('model' => $model, 'heading' => 'Import Leave Details', 'imgPath' => ''));
        }
    }

    public function actionImportAdhocTimelog() {
        $model = new ImportForm;
        //  require_once Yii::app()->basePath.'/../upload/excel_reader2.php';

        if (isset($_POST['ImportForm'])) {

            $a = $model->validate();
            if ($a) {
                //upload file
                $model->attributes = $_POST['ImportForm'];
                $file = CUploadedFile::getInstance($model, 'file_excel');
                $fileName = 'timelog';

                $file->saveAs(Yii::app()->basePath . '/../uploadVAS/' . $fileName . '.xls');

                //Read excel to array
                $path = Yii::app()->basepath . '/../uploadVAS/' . $fileName . '.xls';
                $sheet_array = Yii::app()->yexcel->readActiveSheet($path);

                if (!empty($sheet_array)) {
                    for ($i = 2; $i <= count($sheet_array); $i++) {
                        if ($sheet_array[$i]['A'] != '') {
                            $nic = strtoupper(preg_replace('/\s/', '', $sheet_array[$i]['B']));
                            $isEmployeeExist = AdhocCadreEmployees::model()->findByAttributes(array('nic' => $nic, 'site_id' => Yii::app()->user->data()->SiteId));

                            if (empty($isEmployeeExist)) {
                                $adhocEmployeeModel = new AdhocCadreEmployees;
                                $adhocEmployeeModel->full_name = strtoupper($sheet_array[$i]['A']);
                                $adhocEmployeeModel->nic = $nic;
                                $adhocEmployeeModel->current_address = strtoupper($sheet_array[$i]['C']);
                                $adhocEmployeeModel->permanent_address = strtoupper($sheet_array[$i]['D']);

                                $adhocEmployeeModel->site_id = Yii::app()->user->data()->SiteId;

                                if ($adhocEmployeeModel->save()) {
                                    $adhocTimelogModel = new AdhocCadreTimelog;
                                    $adhocTimelogModel->adhoc_employee_id = $adhocEmployeeModel->id;
                                    $adhocTimelogModel->department = strtoupper($sheet_array[$i]['E']);
                                    $adhocTimelogModel->supplier = strtoupper($sheet_array[$i]['F']);
                                    $adhocTimelogModel->in_time = date("Y-m-d H:i:s", strtotime($sheet_array[$i]['G']));
                                    $adhocTimelogModel->out_time = date("Y-m-d H:i:s", strtotime($sheet_array[$i]['H']));
                                    $adhocTimelogModel->in_late_hrs = $sheet_array[$i]['I'];
                                    $adhocTimelogModel->in_late_deduction = $sheet_array[$i]['J'];
                                    $adhocTimelogModel->out_late_hrs = $sheet_array[$i]['K'];
                                    $adhocTimelogModel->out_late_deduction = $sheet_array[$i]['L'];
                                    $adhocTimelogModel->N_OT_hrs = $sheet_array[$i]['M'];
                                    $adhocTimelogModel->N_OT_cost = $sheet_array[$i]['N'];
                                    $adhocTimelogModel->D_OT_hrs = $sheet_array[$i]['O'];
                                    $adhocTimelogModel->D_OT_cost = $sheet_array[$i]['P'];
                                    $adhocTimelogModel->basic_day_wage = $sheet_array[$i]['Q'];
                                    $adhocTimelogModel->BRA1 = $sheet_array[$i]['R'];
                                    $adhocTimelogModel->BRA2 = $sheet_array[$i]['S'];
                                    $adhocTimelogModel->BRA3 = $sheet_array[$i]['T'];
                                    $adhocTimelogModel->transport = $sheet_array[$i]['U'];
                                    $adhocTimelogModel->per_day_incentive = $sheet_array[$i]['V'];
                                    $adhocTimelogModel->night_shift_incentive = $sheet_array[$i]['W'];
                                    $adhocTimelogModel->meal = $sheet_array[$i]['X'];
                                    $adhocTimelogModel->cont_Fee = $sheet_array[$i]['Y'];
                                    $adhocTimelogModel->EPF = $sheet_array[$i]['Z'];
                                    $adhocTimelogModel->ETF = $sheet_array[$i]['AA'];
                                    $adhocTimelogModel->cost_to_company = $sheet_array[$i]['AB'];
                                    $adhocTimelogModel->created_on = date('Y-m-d H:i:s');
                                    $adhocTimelogModel->created_by = Yii::app()->user->id;
                                    $adhocTimelogModel->Site_id = Yii::app()->user->data()->SiteId;
                                    $adhocTimelogModel->save();
                                }
                            } else {
                                $adhocTimelogModel = new AdhocCadreTimelog;
                                $adhocTimelogModel->adhoc_employee_id = $isEmployeeExist->id;
                                $adhocTimelogModel->department = strtoupper($sheet_array[$i]['E']);
                                $adhocTimelogModel->supplier = strtoupper($sheet_array[$i]['F']);
                                $adhocTimelogModel->in_time = date("Y-m-d H:i:s", strtotime($sheet_array[$i]['G']));
                                $adhocTimelogModel->out_time = date("Y-m-d H:i:s", strtotime($sheet_array[$i]['H']));
                                $adhocTimelogModel->in_late_hrs = $sheet_array[$i]['I'];
                                $adhocTimelogModel->in_late_deduction = $sheet_array[$i]['J'];
                                $adhocTimelogModel->out_late_hrs = $sheet_array[$i]['K'];
                                $adhocTimelogModel->out_late_deduction = $sheet_array[$i]['L'];
                                $adhocTimelogModel->N_OT_hrs = $sheet_array[$i]['M'];
                                $adhocTimelogModel->N_OT_cost = $sheet_array[$i]['N'];
                                $adhocTimelogModel->D_OT_hrs = $sheet_array[$i]['O'];
                                $adhocTimelogModel->D_OT_cost = $sheet_array[$i]['P'];
                                $adhocTimelogModel->basic_day_wage = $sheet_array[$i]['Q'];
                                $adhocTimelogModel->BRA1 = $sheet_array[$i]['R'];
                                $adhocTimelogModel->BRA2 = $sheet_array[$i]['S'];
                                $adhocTimelogModel->BRA3 = $sheet_array[$i]['T'];
                                $adhocTimelogModel->transport = $sheet_array[$i]['U'];
                                $adhocTimelogModel->per_day_incentive = $sheet_array[$i]['V'];
                                $adhocTimelogModel->night_shift_incentive = $sheet_array[$i]['W'];
                                $adhocTimelogModel->meal = $sheet_array[$i]['X'];
                                $adhocTimelogModel->cont_Fee = $sheet_array[$i]['Y'];
                                $adhocTimelogModel->EPF = $sheet_array[$i]['Z'];
                                $adhocTimelogModel->ETF = $sheet_array[$i]['AA'];
                                $adhocTimelogModel->cost_to_company = $sheet_array[$i]['AB'];
                                $adhocTimelogModel->created_on = date('Y-m-d H:i:s');
                                $adhocTimelogModel->created_by = Yii::app()->user->id;
                                $adhocTimelogModel->Site_id = Yii::app()->user->data()->SiteId;
                                $adhocTimelogModel->save();
                            }
                        }
                    }
                }
                Yii::app()->user->setFlash('success', 'Upload Successful');
                unlink($path);
                $this->render('//import/import', array('model' => new ImportForm, 'heading' => 'Import Adhoc Cadre Time Log', 'imgPath' => ''));
            }
        } else {
            $this->render('//import/import', array('model' => $model, 'heading' => 'Import Adhoc Cadre Time Log', 'imgPath' => ''));
        }
    }

    public function actionImportTimelogs() {
        $models = new ImportForm;

        if (isset($_POST['ImportForm'])) {

            $a = $models->validate();
            if ($a) {
                //upload file
                $models->attributes = $_POST['ImportForm'];
                $file = CUploadedFile::getInstance($models, 'file_excel');
                $fileName = 'timelog';
                
                $file->saveAs(Yii::app()->basePath . '/../uploadVAS/' . $fileName . '.xls');

                //Read excel to array
                $path = Yii::app()->basepath . '/../uploadVAS/' . $fileName . '.xls';
                $sheet_array = Yii::app()->yexcel->readActiveSheet($path);

                if (!empty($sheet_array)) {
                    for ($i = 2; $i <= count($sheet_array); $i++) {
                        if ($sheet_array[$i]['A'] != '') {
                            $nic = strtoupper(preg_replace('/\s/', '', $sheet_array[$i]['A']));

                            $Employee = Employee::model()->findByAttributes(array('nic' => $nic));

                        
                            if (!empty($Employee)) {
                                $model = new Timelog;

                                $model->Employeeid = $Employee->id;
                                $model->PunchTime = date("Y-m-d H:i:s", strtotime($sheet_array[$i]['B']));
                                $model->Type = $sheet_array[$i]['C'];
                                $model->manual = "YES";
                                $model->Siteid = $Employee->siteid;
                                $model->Accountid = $Employee->Accountid;
                                $model->departmentid = $Employee->departmentid;
                                $model->ValidStatus = 1;
//                                $model->validate();
//                                print_r($model->errors);
//                                die;
                                
                                if ($model->save()) {
                                                                       
                                    //======create employee incentive eligibility================
                                    if ($model->Type == 'IN') {
                                        $employeeIncentives = EmployeeIncentive::model()->findAllByAttributes(array('employee_id' => $model->Employeeid, 'status' => 1));
                                        foreach ($employeeIncentives as $employeeIncentive) {
                                            switch ($employeeIncentive['incentive_id']) {
                                                case 1:
                                                    if (new DateTime(date("H:i:s", strtotime($model->PunchTime))) < new DateTime('08:15:00')) {

                                                        $employeeIncentiveEligibility = EmployeeIncentiveEligibility::model()->findByAttributes(array('emp_id' => $model->Employeeid, 'incentive_id' => $employeeIncentive['incentive_id'], 'date' => date("Y-m-d", strtotime($model->PunchTime)), 'status' => 1));
                                                        if (empty($employeeIncentiveEligibility)) {
                                                            $eligibility = new EmployeeIncentiveEligibility;

                                                            $eligibility->emp_id = $model->Employeeid;
                                                            $eligibility->incentive_id = $employeeIncentive['incentive_id'];
                                                            $eligibility->incentive_amount = $employeeIncentive['incentive_amount'];
                                                            $eligibility->timelog_id = $model->id;
                                                            $eligibility->date = date("Y-m-d", strtotime($model->PunchTime));
                                                            $eligibility->status = 1;
                                                            $eligibility->save();
                                                        }
                                                    }

                                                    break;
                                                case 2:
                                                    $employeeIncentiveEligibility = EmployeeIncentiveEligibility::model()->findByAttributes(array('emp_id' => $model->Employeeid, 'incentive_id' => $employeeIncentive['incentive_id'], 'date' => date("Y-m-d", strtotime($model->PunchTime)), 'status' => 1));
                                                    if (empty($employeeIncentiveEligibility)) {
                                                        $eligibility = new EmployeeIncentiveEligibility;

                                                        $eligibility->emp_id = $model->Employeeid;
                                                        $eligibility->incentive_id = $employeeIncentive['incentive_id'];
                                                        $eligibility->incentive_amount = $employeeIncentive['incentive_amount'];
                                                        $eligibility->timelog_id = $model->id;
                                                        $eligibility->date = date("Y-m-d", strtotime($model->PunchTime));
                                                        $eligibility->status = 1;
                                                        $eligibility->save();
                                                    }

                                                    break;
                                                case 3:
                                                    if (new DateTime(date("H:i:s", strtotime($model->PunchTime))) > new DateTime('17:00:00')) {

                                                        $employeeIncentiveEligibility = EmployeeIncentiveEligibility::model()->findByAttributes(array('emp_id' => $model->Employeeid, 'incentive_id' => $employeeIncentive['incentive_id'], 'date' => date("Y-m-d", strtotime($model->PunchTime)), 'status' => 1));
                                                        if (empty($employeeIncentiveEligibility)) {
                                                            $eligibility = new EmployeeIncentiveEligibility;

                                                            $eligibility->emp_id = $model->Employeeid;
                                                            $eligibility->incentive_id = $employeeIncentive['incentive_id'];
                                                            $eligibility->incentive_amount = $employeeIncentive['incentive_amount'];
                                                            $eligibility->timelog_id = $model->id;
                                                            $eligibility->date = date("Y-m-d", strtotime($model->PunchTime));
                                                            $eligibility->status = 1;
                                                            $eligibility->save();
                                                        }
                                                    }

                                                    break;
                                            }
                                        }
                                    }
                                    //end
                                    //=========new change===========//
                                    $emplyeeid = $model->Employeeid;
                                    $employee = Employee::model()->findByAttributes(array('id' => $emplyeeid));

                                    if ($employee->statusId == 1) {

                                        $flexiShift = Yii::app()->PublicFunctionForTimesheetUtil->GetFlexiShift($model);

                                        if (!empty($flexiShift)) {
                                            if ($employee->Paymentmethod->type == "DAILY") {

                                                Yii::app()->FlexiShiftDailyCalculationUtil->TimesheetCalculation($model, $flexiShift);
                                            } elseif (($employee->Paymentmethod->type == "MONTHLY")) {

                                                Yii::app()->FlexiShiftMonthlyCalculationUtil->CreateTimeSheet($model, $flexiShift);
                                            }
                                        } else {
                                            if ($employee->Paymentmethod->type == "DAILY") {

                                                if ($employee->EntitleOT == 1) {
                                                    Yii::app()->PayrollCalculationEntitleUtilnew->TimesheetCalculation($model);
                                                } else {

                                                    Yii::app()->PayrollCalculationUtilnew->TimesheetCalculation($model);
                                                }
                                            } elseif (($employee->Paymentmethod->type == "MONTHLY")) {

                                                if ($employee->EntitleOT == 1) {
                                                    Yii::app()->MonthlyPaymentCalculationEntitleUtilnew->CreateTimeSheet($model);
                                                } else {

                                                    Yii::app()->MonthlyPaymentCalculationUtilnew->CreateTimeSheet($model);
                                                }
                                            }
                                        }
                                    }
                                }
                               
                            }
                        }
                    }
                }
                Yii::app()->user->setFlash('success', 'Upload Successful');
                unlink($path);
                $this->render('//import/import', array('model' => new ImportForm, 'heading' => 'Import Manual Time Log', 'imgPath' => ''));
            }
        } else {
            $this->render('//import/import', array('model' => $models, 'heading' => 'Import Manual Time Log', 'imgPath' => ''));
        }
    }

}
