<?php

class NonpayrollEmployeeController extends Controller {

    /**
     * @var string the default layout for the views. Defaults to '//layouts/column2', meaning
     * using two-column layout. See 'protected/views/layouts/column2.php'.
     */
    public $layout = '//layouts/column1';

    /**
     * @return array action filters
     */
    public function filters() {
        return array(
            'accessControl', // perform access control for CRUD operations
        );
    }

    /**
     * Specifies the access control rules.
     * This method is used by the 'accessControl' filter.
     * @return array access control rules
     */
    public function accessRules() {
        return array(
            array('allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('index','ActiveEmployee', 'AddStatusDetail', 'view', 'admin', 'GetTshirtIssues', 'GetShoeIssues', 'ChangeProfilePicture', 'Docupdate', 'Docupload', 'Employeepdfview', 'Employeedocdelete', 'ChangeDesignation', 'ViewAnother'),
                'users' => array('*'),
            ),
            array('allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array('create', 'update'),
                'users' => array('@'),
            ),
            array('allow', // allow admin user to perform 'admin' and 'delete' actions
                'actions' => array('admin', 'delete'),
                'users' => array('admin'),
            ),
            array('deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function actionView($id) {
        error_reporting(E_ERROR);
        $contact = new Contact;
        $employeesalary = new Employeesalary;
        $designationChangeDetails = DesignationChange::model()->findByAttributes(array('emp_id' => $id, 'status' => 1));
        $employeedocumenttype = EmployeeDocumentType::model()->findAll();
        $employee = NonpayrollEmployee::model()->findByPk($id);
        $designation = Designation::model()->findByPk($employee->designationid);
        $models = Contact::model()->findAllByAttributes(array('employeeid' => $id));
        $Contractfee = Employeecontractfee::model()->findByAttributes(array('employeeid' => $id, 'site_id' => $employee->siteid, 'status' => 1));
        $SiteJoinedDate = EmployeeJoinDetails::model()->findByAttributes(array('employee_id' => $id, 'site_id' => $employee->siteid, 'status' => 1));
        $PaymentMethod = $employee->paymentmethod['type'];
        $ResignDateHistory = EmployeeStatusHistory::model()->findByAttributes(array('emp_id' => $id, 'status_id' => 2, 'status' => 1));

        $this->render('view', array(
            'model' => $this->loadModel($id), 'contact' => $contact, 'employeesalary' => $employeesalary, 'models' => $models, 'designation' => $designation, 'PaymentMethod' => $PaymentMethod, 'Contractfee' => $Contractfee, 'employeedocumenttype' => $employeedocumenttype,
            'designationChangeDetails' => $designationChangeDetails, 'SiteJoinedDate' => $SiteJoinedDate, 'ResignDateHistory' => $ResignDateHistory,
        ));
    }

    public function actionViewAnother() {
        $id = $_POST['employee'];
        $this->redirect(array('view', 'id' => $id));
    }

    public function actionCreate() {
        $model = new NonpayrollEmployee;
        $EmplyeeContractFee = new Employeecontractfee;
        $Userid = Yii::app()->user->data()->id;

        if (Yii::app()->user->isAdmin()) {
            $Sites = Sites::model()->findAll();
        } else {
            $siteId = Yii::app()->user->data()->SiteId;
            $Sites = Sites::model()->findAllByAttributes(array('id' => $siteId));
        }

        if (isset($_POST['NonpayrollEmployee'])) {

            $model->attributes = $_POST['NonpayrollEmployee'];
            $model->payroll_status = 0;

            $tmp_name = $_FILES["file"]["tmp_name"];
            $tmp_name_nic = $_FILES["nic_phot"]["tmp_name"];

            if ($tmp_name_nic != "") {
                $uploadDirectory = "/document/employee/nic4/";
                $fi_name = "nic4";
                $currentDir = getcwd();
                $errors = array(); // Store all foreseen and unforseen errors here
                $fileExtensions = ['pdf']; // Get all the file extensions


                $fileName = $_FILES['nic_phot']['name'];
                $fileSize = $_FILES['nic_phot']['size'];
                $fileTmpName = $_FILES['nic_phot']['tmp_name'];
                $fileType = $_FILES['nic_phot']['type'];

                $savefilename = ($fi_name . date('YmdHis') . '.pdf' );

                $tmp = explode('.', $savefilename);
                $fileExtension = end($tmp);

                $uploadPath = $currentDir . $uploadDirectory . basename($savefilename);

                if ($tmp_name_nic != "") {

                    if (!in_array($fileExtension, $fileExtensions)) {
                        $errors[] = "This file extension is not allowed. Please upload a JPEG or PNG file";
                    }

                    if ($fileSize > 4000000) {
                        $errors[] = "This file is more than 4MB. Sorry, it has to be less than or equal to 4MB";
                    }

                    if (empty($errors)) {
                        $didUpload = move_uploaded_file($fileTmpName, $uploadPath);

                        if ($didUpload) {


                            $model->nic_photo = $uploadDirectory . basename($savefilename);
                        } else {
                            echo "An error occurred somewhere. Try again or contact the admin";
                        }
                    } else {
                        foreach ($errors as $error) {
                            echo $error . "These are the errors" . "\n";
                        }
                    }
                }
            }

            if (!ctype_upper($model->FirstName))
                $model->FirstName = strtoupper($model->FirstName);
            if (!ctype_upper($model->LastName))
                $model->LastName = strtoupper($model->LastName);
            if (!ctype_upper($model->SurName))
                $model->SurName = strtoupper($model->SurName);
            if (!ctype_upper($model->Namewithini))
                $model->Namewithini = strtoupper($model->Namewithini);
            if (!ctype_upper($model->FullName))
                $model->FullName = strtoupper($model->FullName);
            // ===========================================================================     
            if($model->Appointment ==null){
            $model->Appointment ='0000-00-00';
            }
            if($model->Confirmationdate ==null){
            $model->Confirmationdate ='0000-00-00';
            }
            
            if ($model->save()) {
                if ($tmp_name != "") {
                    $uploads_dir = Yii::getPathOfAlias("webroot") . '/themeassets/employee-images';
                    $filename = $model->id . ".jpeg";
                    $newpath = "$uploads_dir/$filename";
                    $newpath2 = '/themeassets/employee-images/' . $filename;
                    move_uploaded_file($tmp_name, $newpath);
                    NonpayrollEmployee::model()->updateAll(array('profileImage' => $newpath2), "id=" . $model->id);
                }
                if (isset($_POST['EmplyeeContractFee'])) {
                    $Contractfeemodel = $_POST['EmplyeeContractFee'];
                    $EmplyeeContractFee->employeeid = $model->id;
                    $EmplyeeContractFee->contractfee = $Contractfeemodel['contractfee'];
                    $EmplyeeContractFee->site_id = $model->siteid;
                    $EmplyeeContractFee->status = 1;
                    $EmplyeeContractFee->save();
                }

                $employeedesigna = new EmployeeDesignation;
                $employeedesigna->Status = 1;
                $employeedesigna->EmployeeId = $model->id;
                $employeedesigna->DesignationId = $model->designationid;
                $date = date('Y-m-d H:i:s');
                $employeedesigna->DateTime = $date;

                if ($employeedesigna->save()) {

                    //write data in employee_join_details table
                    EmployeeJoinDetails::model()->updateAll(array('status' => 0), "employee_id=" . $model->id . " AND site_id=" . $model->siteid . " AND Status = 1");
                    $employeeJoin = new EmployeeJoinDetails;
                    $employeeJoin->employee_id = $model->id;
                    $employeeJoin->site_id = $model->siteid;
                    $employeeJoin->join_date = $model->joindate;
                    $employeeJoin->created_on = date('Y-m-d H:i:s');
                    $employeeJoin->created_by = Yii::app()->user->id;
                    $employeeJoin->status = 1;
                    $employeeJoin->save();

                    //write data in employee_designation_details table
                    EmployeeDesignationDetails::model()->updateAll(array('status' => 0), "employee_id=" . $model->id . " AND site_id=" . $model->siteid . " AND Status = 1");
                    $employeeDesignation = new EmployeeDesignationDetails;
                    $employeeDesignation->employee_id = $model->id;
                    $employeeDesignation->site_id = $model->siteid;
                    $employeeDesignation->designation_id = $model->designationid;
                    $employeeDesignation->created_on = date('Y-m-d H:i:s');
                    $employeeDesignation->changed_by = Yii::app()->user->id;
                    $employeeDesignation->status = 1;
                    $employeeDesignation->save();
                }

                if ($tmp_name_nic != "") {

                    $employeedocumentsmodel = new EmployeeDocuments();
                    $employeedocumentsmodel->emp_id = $model->id;
                    $employeedocumentsmodel->document_id = '4';
                    $employeedocumentsmodel->document_path = $uploadDirectory . basename($savefilename);

                    $employeedocumentsmodel->inactive_date = "0";

                    $employeedocumentsmodel->status = "1";
                    $employeedocumentsmodel->assign_date = date('Y-m-d h:i:s');
                    $employeedocumentsmodel->save();
                } else {
                    echo "An error occurred somewhere. Try again or contact the admin";
                }



                $this->redirect(array('view', 'id' => $model->id));
            }
        }
        $this->render('create', array(
            'model' => $model, 'EmplyeeContractFee' => $EmplyeeContractFee, 'Sites' => $Sites, 'Userid' => $Userid,
        ));
    }

    public function actionDocupload() {

        if (Yii::app()->request->getParam('submit')) {

            $contact = new Contact;
            $employeesalary = new Employeesalary;
            $employeedocumenttype = EmployeeDocumentType::model()->findAll();

            $currentDir = getcwd();
            if (Yii::app()->request->getParam('doctype') == '1') {

                $uploadDirectory = "/document/employee/coci1/";
                $fi_name = "coci1";
            }
            if (Yii::app()->request->getParam('doctype') == '2') {

                $uploadDirectory = "/document/employee/al2/";
                $fi_name = "al2";
            }
            if (Yii::app()->request->getParam('doctype') == '3') {

                $uploadDirectory = "/document/employee/cv3/";
                $fi_name = "cv3";
            }
            if (Yii::app()->request->getParam('doctype') == '4') {

                $uploadDirectory = "/document/employee/nic4/";
                $fi_name = "nic4";
            }
            if (Yii::app()->request->getParam('doctype') == '5') {

                $uploadDirectory = "/document/employee/tpscp5/";
                $fi_name = "tpscp5";
            }
            if (Yii::app()->request->getParam('doctype') == '6') {

                $uploadDirectory = "/document/employee/bc6/";
                $fi_name = "bc6";
            }
            if (Yii::app()->request->getParam('doctype') == '7') {

                $uploadDirectory = "/document/employee/ec7/";
                $fi_name = "ec7";
            }
            if (Yii::app()->request->getParam('doctype') == '8') {

                $uploadDirectory = "/document/employee/we8/";
                $fi_name = "we8";
            }

            if (Yii::app()->request->getParam('doctype') == '9') {

                $uploadDirectory = "/document/employee/pc9/";
                $fi_name = "pc9";
            }
            if (Yii::app()->request->getParam('doctype') == '10') {

                $uploadDirectory = "/document/employee/gsc10/";
                $fi_name = "gsc10";
            }
            if (Yii::app()->request->getParam('doctype') == '11') {

                $uploadDirectory = "/document/employee/rec11/";
                $fi_name = "rec11";
            }

            $errors = []; // Store all foreseen and unforseen errors here
            $fileExtensions = ['pdf']; // Get all the file extensions


            $fileName = $_FILES['inputfile']['name'];
            $fileSize = $_FILES['inputfile']['size'];
            $fileTmpName = $_FILES['inputfile']['tmp_name'];
            $fileType = $_FILES['inputfile']['type'];

            $savefilename = (yii::app()->request->getParam('emploid') . $fi_name . date('YmdHis') . '.pdf' );

            $tmp = explode('.', $savefilename);
            $fileExtension = end($tmp);

            $uploadPath = $currentDir . $uploadDirectory . basename($savefilename);

            if (isset($_POST['submit'])) {

                if (!in_array($fileExtension, $fileExtensions)) {
                    $errors[] = "This file extension is not allowed. Please upload a JPEG or PNG file";
                }

                if ($fileSize > 4000000) {
                    $errors[] = "This file is more than 4MB. Sorry, it has to be less than or equal to 4MB";
                }

                if (empty($errors)) {
                    $didUpload = move_uploaded_file($fileTmpName, $uploadPath);

                    if ($didUpload) {
                        $employeedocumentsmodel = new EmployeeDocuments();
                        $employeedocumentsmodel->emp_id = Yii::app()->request->getParam('emploid');
                        $employeedocumentsmodel->document_id = Yii::app()->request->getParam('doctype');
                        $employeedocumentsmodel->document_path = $uploadDirectory . basename($savefilename);

                        if (Yii::app()->request->getParam('doctype') == '4') {
                            $model = $this->loadModel(Yii::app()->request->getParam('emploid'));

                            $model->nic_photo = $uploadDirectory . basename($savefilename);
                            $model->save();
                        }
                        if (Yii::app()->request->getParam('Expedia_date')) {
                            $employeedocumentsmodel->inactive_date = Yii::app()->request->getParam('Expedia_date');
                        } else {
                            $employeedocumentsmodel->inactive_date = "0";
                        }

                        $employeedocumentsmodel->status = "1";
                        $employeedocumentsmodel->assign_date = date('Y-m-d h:i:s');
                        if ($employeedocumentsmodel->save()) {

                            $suppliername = Supplier::model()->findByPk(Yii::app()->request->getParam('emploid'));
                            $this->redirect(array('view', 'id' => Yii::app()->request->getParam('emploid')));
                        } else {
                            print_r("sssdfkl");
                            die;
                        }
                    } else {
                        echo "An error occurred somewhere. Try again or contact the admin";
                    }
                } else {
                    foreach ($errors as $error) {
                        echo $error . "These are the errors" . "\n";
                    }
                }
            }
        }
    }

    public function actionDocupdate() {


        if (Yii::app()->request->getParam('update')) {

            $sup_id = Yii::app()->request->getParam('employeeidupdate');
            $doc_id = Yii::app()->request->getParam('docutypeupdate');

            $contact = new Contact;
            $employeesalary = new Employeesalary;
            $employeedocumenttype = EmployeeDocumentType::model()->findAll();

            $currentDir = getcwd();
            if (Yii::app()->request->getParam('docutypeupdate') == '1') {

                $uploadDirectory = "/document/employee/coci1/";
                $fi_name = "coci1";
            }
            if (Yii::app()->request->getParam('docutypeupdate') == '2') {

                $uploadDirectory = "/document/employee/al2/";
                $fi_name = "al2";
            }
            if (Yii::app()->request->getParam('docutypeupdate') == '3') {

                $uploadDirectory = "/document/employee/cv3/";
                $fi_name = "cv3";
            }
            if (Yii::app()->request->getParam('docutypeupdate') == '4') {

                $uploadDirectory = "/document/employee/nic4/";
                $fi_name = "nic4";
            }
            if (Yii::app()->request->getParam('docutypeupdate') == '5') {

                $uploadDirectory = "/document/employee/tpscp5/";
                $fi_name = "tpscp5";
            }
            if (Yii::app()->request->getParam('docutypeupdate') == '6') {

                $uploadDirectory = "/document/employee/bc6/";
                $fi_name = "bc6";
            }
            if (Yii::app()->request->getParam('docutypeupdate') == '7') {

                $uploadDirectory = "/document/employee/ec7/";
                $fi_name = "ec7";
            }
            if (Yii::app()->request->getParam('docutypeupdate') == '8') {

                $uploadDirectory = "/document/employee/we8/";
                $fi_name = "we8";
            }

            if (Yii::app()->request->getParam('docutypeupdate') == '9') {

                $uploadDirectory = "/document/employee/pc9/";
                $fi_name = "pc9";
            }
            if (Yii::app()->request->getParam('docutypeupdate') == '10') {

                $uploadDirectory = "/document/employee/gsc10/";
                $fi_name = "gsc10";
            }

            $errors = []; // Store all foreseen and unforseen errors here

            $fileExtensions = ['pdf']; // Get all the file extensions


            $fileName = $_FILES['inputfileupdate']['name'];
            $fileSize = $_FILES['inputfileupdate']['size'];
            $fileTmpName = $_FILES['inputfileupdate']['tmp_name'];
            $fileType = $_FILES['inputfileupdate']['type'];

            $savefilename = (yii::app()->request->getParam('employeeidupdate') . $fi_name . date('YmdHis') . '.pdf' );

            $tmp = explode('.', $savefilename);
            $fileExtension = end($tmp);

            $uploadPath = $currentDir . $uploadDirectory . basename($savefilename);

            if (isset($_POST['update'])) {

                if (!in_array($fileExtension, $fileExtensions)) {
                    $errors[] = "This file extension is not allowed. Please upload a JPEG or PNG file";
                }

                if ($fileSize > 4000000) {
                    $errors[] = "This file is more than 4MB. Sorry, it has to be less than or equal to 4MB";
                }

                if (empty($errors)) {
                    $didUpload = move_uploaded_file($fileTmpName, $uploadPath);

                    if ($didUpload) {
                        $employeedocumentsmodel = EmployeeDocuments::model()->find("emp_id= '$sup_id' AND document_id='$doc_id' AND status=1");

                        $employeedocumentsmodel->document_path = $uploadDirectory . basename($savefilename);
                        if (Yii::app()->request->getParam('Expedia_date2')) {
                            $employeedocumentsmodel->inactive_date = Yii::app()->request->getParam('Expedia_date2');
                        } else {

                            $employeedocumentsmodel->inactive_date = "0";
                        }

                        if ($employeedocumentsmodel->save()) {

                            $suppliername = Supplier::model()->findByPk(Yii::app()->request->getParam('suplierid'));
                            $this->redirect(array('view', 'id' => $sup_id));
                        } else {
                            
                        }
                    } else {
                        $supplierdocumentsmodel = EmployeeDocuments::model()->find("emp_id= '$sup_id' AND document_id='$doc_id' AND status=1");
                        if (Yii::app()->request->getParam('Expedia_date2')) {
                            $supplierdocumentsmodel->inactive_date = Yii::app()->request->getParam('Expedia_date2');
                        } else {
                            $supplierdocumentsmodel->inactive_date = "0";
                        }

                        if ($supplierdocumentsmodel->save()) {

                            $suppliername = Supplier::model()->findByPk(Yii::app()->request->getParam('suplierid'));
                            $this->redirect(array('view', 'id' => $sup_id));
                        } else {
                            
                        }
                    }
                } else {
                    foreach ($errors as $error) {
                        echo $error . "These are the errors" . "\n";
                    }
                }
            } else {
                
            }
        }
    }

    public function actionEmployeepdfview() {


        $emp_id = Yii::app()->request->getParam('param1');

        $docu_type_id = Yii::app()->request->getParam('param2');

        $doc_detil = EmployeeDocuments::model()->find("emp_id= '$emp_id' AND document_id='$docu_type_id ' AND status=1");

        $this->render('employeepdfview', array(
            'supp_id' => $emp_id,
            'doc_detil' => $doc_detil,
        ));
    }

    public function actionEmployeedocdelete() {

        $empl_id = Yii::app()->request->getParam('suppid');

        $docu_type_id = Yii::app()->request->getParam('docid');

        $deletedocmodel = EmployeeDocuments::model()->find("emp_id= '$empl_id' AND document_id='$docu_type_id' AND status=1");

        if ($deletedocmodel) {

            $deletedocmodel->status = "2";
            if ($deletedocmodel->save()) {


                $this->redirect(array('view', 'id' => $empl_id));
            } else {
                print_r("error");
            }
        }
    }

    public function actionGetTshirtIssues() {
        //Search for t-shirt issues for the relevant employee  

        $employeeid = $_POST['Employeeid'];
        $tshirtIssues = EmployeeTshirt::model()->findAllBySql("select * from employee_tshirt where empID = $employeeid ORDER BY `employee_tshirt`.`issueID`  DESC");

        foreach ($tshirtIssues as $issue) {
            echo '<tr>';
            echo '<td>' . $issue->issuedDate . '</td>';

            if ($issue->Status == 'Returned') {
                echo '<td>' . $issue->returnedDate . '</td>';
                echo '<td>' . $issue->Status . '</td>';
                echo '<td> 
                <input type="checkbox" checked="checked" name="myTextEditBox1" value=' . $issue->issueID . ' onchange="changeContentTshirtIssues(' . $issue->issueID . ',this.checked)"
                style="margin-left:auto; margin-right:auto;">
                </td>';
            } else {
                echo '<td>' . '0000-00-00' . '</td>';
                echo '<td>' . $issue->Status . '</td>';
                echo '<td> 
                 <input type="checkbox" name="myTextEditBox1" value=' . $issue->issueID . ' onchange="changeContentTshirtIssues(' . $issue->issueID . ',this.checked)"
                 style="margin-left:auto; margin-right:auto;">
                </td>';
            }

            echo '</tr>';
        }
    }

    public function actionGetShoeIssues() {
        //Search for shoe issues for the relevant employee  

        $employeeid = $_POST['Employeeid'];
        $shoeIssues = EmployeeShoe::model()->findAllBySql("select * from employee_shoe where empID = $employeeid ORDER BY `employee_shoe`.`issueID`  DESC");

        foreach ($shoeIssues as $Shoeissue) {
            echo '<tr>';
            echo '<td>' . $Shoeissue->issuedDate . '</td>';

            if ($Shoeissue->Status == 'Returned') {
                echo '<td>' . $Shoeissue->returnedDate . '</td>';
                echo '<td>' . $Shoeissue->Status . '</td>';
                echo '<td> 
                        <input  type="checkbox" checked="checked" name="myTextEditBox" value=' . $Shoeissue->issueID . ' onchange="changeContentShoeIssues(' . $Shoeissue->issueID . ',this.checked)"
                        style="margin-left:auto; margin-right:auto;">
                    </td>';
            } else {
                echo '<td>' . '0000-00-00' . '</td>';
                echo '<td>' . $Shoeissue->Status . '</td>';
                echo '<td> 
                        <input type="checkbox"    name="myTextEditBox" value=' . $Shoeissue->issueID . '  onchange="changeContentShoeIssues(' . $Shoeissue->issueID . ',this.checked)"
                        style="margin-left:auto; margin-right:auto;">
                    </td>';
            }


            echo '</tr>';
        }
    }

    public function actionUpdate($id) {
        $model = $this->loadModel($id);
        $Userid = Yii::app()->user->data()->id;
        
         if (Yii::app()->user->isAdmin()) {
            $Sites = Sites::model()->findAll();
        } else {
            $siteId = Yii::app()->user->data()->SiteId;
            $Sites = Sites::model()->findAllByAttributes(array('id' => $siteId));
        }

        $EmplyeeContractFee = new Employeecontractfee;
        $Userid = Yii::app()->user->data()->id;

        if (Yii::app()->user->isAdmin()) {
            $Sites = Sites::model()->findAll();
        } else {
            $siteId = Yii::app()->user->data()->SiteId;
            $Sites = Sites::model()->findAllByAttributes(array('id' => $siteId));
        }

        if (isset($_POST['NonpayrollEmployee'])) {
            $model->attributes = $_POST['NonpayrollEmployee'];
            $oldModel = $this->loadModel($id);

            // ==================================Put an Image===========================

            $tmp_name = $_FILES["file"]["tmp_name"];
            if ($tmp_name != "") {
                $uploads_dir = Yii::getPathOfAlias("webroot") . '/themeassets/employee-images';
                $filename = $model->id . ".jpeg";
                $newpath = "$uploads_dir/$filename";
                $newpath2 = '/themeassets/employee-images/' . $filename;
                move_uploaded_file($tmp_name, $newpath);
                $model->profileImage = $newpath2;
            }
            $tmp_name_nic = $_FILES["nic_phot"]["tmp_name"];

            if ($tmp_name_nic != "") {
                $uploadDirectory = "/document/employee/nic4/";
                $fi_name = "nic4";
                $currentDir = getcwd();
                $errors = []; // Store all foreseen and unforseen errors here


                $fileExtensions = ['pdf']; // Get all the file extensions


                $fileName = $_FILES['nic_phot']['name'];
                $fileSize = $_FILES['nic_phot']['size'];
                $fileTmpName = $_FILES['nic_phot']['tmp_name'];
                $fileType = $_FILES['nic_phot']['type'];

                $savefilename = ($fi_name . date('YmdHis') . '.pdf' );

                $tmp = explode('.', $savefilename);
                $fileExtension = end($tmp);

                $uploadPath = $currentDir . $uploadDirectory . basename($savefilename);

                if ($tmp_name_nic != "") {

                    if (!in_array($fileExtension, $fileExtensions)) {
                        $errors[] = "This file extension is not allowed. Please upload a JPEG or PNG file";
                    }

                    if ($fileSize > 4000000) {
                        $errors[] = "This file is more than 4MB. Sorry, it has to be less than or equal to 4MB";
                    }

                    if (empty($errors)) {
                        $didUpload = move_uploaded_file($fileTmpName, $uploadPath);

                        if ($didUpload) {


                            $model->nic_photo = $uploadDirectory . basename($savefilename);
                        } else {
                            echo "An error occurred somewhere. Try again or contact the admin";
                        }
                    } else {
                        foreach ($errors as $error) {
                            echo $error . "These are the errors" . "\n";
                        }
                    }
                }
            }

            if (!ctype_upper($model->FirstName))
                $model->FirstName = strtoupper($model->FirstName);
            if (!ctype_upper($model->LastName))
                $model->LastName = strtoupper($model->LastName);
            if (!ctype_upper($model->SurName))
                $model->SurName = strtoupper($model->SurName);
            if (!ctype_upper($model->Namewithini))
                $model->Namewithini = strtoupper($model->Namewithini);
            if (!ctype_upper($model->FullName))
                $model->FullName = strtoupper($model->FullName);

            if($model->Appointment ==null){
            $model->Appointment ='0000-00-00';
            }
            if($model->Confirmationdate ==null){
            $model->Confirmationdate ='0000-00-00';
            }
            // =========================================================================== 

            if ($model->save()) {

                $employeedesigna = new EmployeeDesignation;
                $employeedesigna::model()->updateAll(array('Status' => 0), 'EmployeeId ="' . $id . '"');
                $employeedesigna->Status = 1;
                $employeedesigna->EmployeeId = $model->id;
                $employeedesigna->DesignationId = $model->designationid;
                $date = date('Y-m-d H:i:s');
                $employeedesigna->DateTime = $date;

                $employeedesigna->save();

                if ($tmp_name_nic != "") {



                    $employeedocuments = EmployeeDocuments::model()->find("emp_id= '$id' AND document_id='4' AND status=1");

                    if ($employeedocuments) {

                        $employeedocuments->document_path = $model->nic_photo;
                        $employeedocuments->save();
                    } else {
                        $employeedocumentsmodel = new EmployeeDocuments();
                        $employeedocumentsmodel->emp_id = $id;
                        $employeedocumentsmodel->document_id = '4';
                        $employeedocumentsmodel->document_path = $model->nic_photo;

                        $employeedocumentsmodel->inactive_date = "0";

                        $employeedocumentsmodel->status = "1";
                        $employeedocumentsmodel->assign_date = date('Y-m-d h:i:s');
                        $employeedocumentsmodel->save();
                    }
                }
                $this->redirect(array('view', 'id' => $model->id));
            }
            $this->render('update', array(
                'model' => $model, 'EmplyeeContractFee' => $EmplyeeContractFee, 'Sites' => $Sites, 'Userid' => $Userid
            ));
        } else {
            $this->render('update', array(
                'model' => $model, 'EmplyeeContractFee' => $EmplyeeContractFee, 'Sites' => $Sites, 'Userid' => $Userid
            ));
        }
    }


    public function actionChangeProfilePicture() {

        $uploads_dir = Yii::getPathOfAlias("webroot") . '/themeassets/employee-images';
        $tmp_name = $_FILES["file"]["tmp_name"];
        $name = basename($_FILES["file"]["name"]);

        $employee = $_POST["employee"];
        $type = $_FILES["file"]["type"];
        $filename = $employee . ".jpeg";
        $newpath = "$uploads_dir/$filename";
        $newpath2 = '/themeassets/employee-images/' . $filename;
        NonpayrollEmployee::model()->updateAll(array('profileImage' => $newpath2), "id=" . $employee);
        move_uploaded_file($tmp_name, $newpath);
    }

    public function actionDelete($id) {
        if (Yii::app()->request->isPostRequest) {
// we only allow deletion via POST request
            $this->loadModel($id)->delete();

// if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
            if (!isset($_GET['ajax']))
                $this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('admin'));
        } else
            throw new CHttpException(400, 'Invalid request. Please do not repeat this request again.');
    }

    public function actionIndex() {
        $dataProvider = new CActiveDataProvider('NonpayrollEmployee');
        $this->render('index', array(
            'dataProvider' => $dataProvider,
        ));
    }

    public function actionAdmin() {
        $model = new NonpayrollEmployee('search');
        $model->unsetAttributes();  // clear any default values
        if (isset($_GET['NonpayrollEmployee']))
            $model->attributes = $_GET['NonpayrollEmployee'];

        $this->render('admin', array(
            'model' => $model,
        ));
    }

    public function loadModel($id) {
        $model = NonpayrollEmployee::model()->findByPk($id);
        if ($model === null)
            throw new CHttpException(404, 'The requested page does not exist.');
        return $model;
    }

    protected function performAjaxValidation($model) {
        if (isset($_POST['ajax']) && $_POST['ajax'] === 'nonpayroll-employee-form') {
            echo CActiveForm::validate($model);
            Yii::app()->end();
        }
    }

    public function actionChangeDesignation() {

        $emp_id = $_POST['emp_id'];
        $designation_id = $_POST['designation_id'];

        NonpayrollEmployee::model()->updateAll(array('designationid' => $designation_id), 'id ="' . $emp_id . '"');
        $employee = NonpayrollEmployee::model()->findByPk($emp_id);

        $employeedesigna = new EmployeeDesignation;
        $employeedesigna::model()->updateAll(array('Status' => 0), 'EmployeeId ="' . $employee->id . '"');
        $employeedesigna->Status = 1;
        $employeedesigna->EmployeeId = $employee->id;
        $employeedesigna->DesignationId = $employee->designationid;
        $employeedesigna->DateTime = date('Y-m-d H:i:s');

        if ($employeedesigna->save()) {

            //write data in employee_designation_details table
            EmployeeDesignationDetails::model()->updateAll(array('status' => 0), "employee_id=" . $employee->id . " AND site_id=" . $employee->siteid . " AND Status = 1");
            $employeeDesignation = new EmployeeDesignationDetails;
            $employeeDesignation->employee_id = $employee->id;
            $employeeDesignation->site_id = $employee->siteid;
            $employeeDesignation->designation_id = $employee->designationid;
            $employeeDesignation->created_on = date('Y-m-d H:i:s');
            $employeeDesignation->changed_by = Yii::app()->user->id;
            $employeeDesignation->status = 1;
            $employeeDesignation->save();
        }
    }

    public function actionAddStatusDetail() { //employee deactivation
        $model = new EmployeeStatusHistory;
        $date = $_POST['selecteddate']; //resign date
        $description = $_POST['description'];
        $employeeid = $_POST['employeeid'];
        $emp = NonpayrollEmployee::model()->findByPk($employeeid);

        $hasInvalidAttendance = Yii::app()->db->createCommand("SELECT T.*
            FROM timesheet as T
            WHERE MONTH(T.date) = MONTH(CURDATE()) AND YEAR(T.date) = YEAR(CURDATE()) AND (T.Intime is NULL OR T.OuteTime is NULL ) AND T.PaymentMethod != 'PIECE-RATE' AND T.EmployeeId = " . $employeeid . "")->queryAll();

        if ($hasInvalidAttendance) {
            echo false;
        } else {
            NonpayrollEmployee::model()->updateAll(array('statusId' => 2, 'TeamStatus' => 0, 'resigndate' => $date), 'id ="' . $employeeid . '"');
            EmployeeStatusHistory::model()->updateAll(array('status' => 0), 'emp_id="' . $employeeid . '"AND status = 1');

            $model->emp_id = $employeeid;
            $model->affective_date = $date;
            $model->description = $description;
            $model->status_id = 2;
            $model->responsible_person = Yii::app()->user->id;
            $model->status = 1;
            $model->site_id = $emp->siteid;
            $model->save();

            //write data in employee_resign_details table
            EmployeeResignDetails::model()->updateAll(array('status' => 0), "employee_id=" . $employeeid . " AND site_id=" . $emp->siteid . " AND Status = 1");
            $employeeResign = new EmployeeResignDetails;
            $employeeResign->employee_id = $employeeid;
            $employeeResign->site_id = $emp->siteid;
            $employeeResign->resign_date = $date;
            $employeeResign->created_on = date('Y-m-d H:i:s');
            $employeeResign->created_by = Yii::app()->user->id;
            $employeeResign->status = 1;
            $employeeResign->save();

            echo true;
        }
    }

    //===========================================================
    public function actionActiveEmployee($id) {

        $model = $this->loadModel($id);
        $EmplyeeContractFee = new Employeecontractfee;
        $Userid = Yii::app()->user->data()->id;

        $model->statusId = 1;
        if (Yii::app()->user->isAdmin()) {
            $Sites = Sites::model()->findAll();
        } else {
            $siteId = Yii::app()->user->data()->SiteId;
            $Sites = Sites::model()->findAllByAttributes(array('id' => $siteId));
        }

        if (isset($_POST['NonpayrollEmployee'])) {
            
            
            $model->attributes = $_POST['NonpayrollEmployee'];
            $tmp_name = $_FILES["file"]["tmp_name"];
            if ($tmp_name != "") {
                $uploads_dir = Yii::getPathOfAlias("webroot") . '/themeassets/employee-images';
                $filename = $model->id . ".jpeg";
                $newpath = "$uploads_dir/$filename";
                $newpath2 = '/themeassets/employee-images/' . $filename;
                move_uploaded_file($tmp_name, $newpath);
                $model->profileImage = $newpath2;
            }
            $tmp_name_nic = $_FILES["nic_phot"]["tmp_name"];

            if ($tmp_name_nic != "") {
                $uploadDirectory = "/document/employee/nic4/";
                $fi_name = "nic4";
                $currentDir = getcwd();
                $errors = []; // Store all foreseen and unforseen errors here


                $fileExtensions = ['pdf']; // Get all the file extensions


                $fileName = $_FILES['nic_phot']['name'];
                $fileSize = $_FILES['nic_phot']['size'];
                $fileTmpName = $_FILES['nic_phot']['tmp_name'];
                $fileType = $_FILES['nic_phot']['type'];

                $savefilename = ($fi_name . date('YmdHis') . '.pdf' );

                // print_r($savefilename);
                // die;

                $tmp = explode('.', $savefilename);
                $fileExtension = end($tmp);

                $uploadPath = $currentDir . $uploadDirectory . basename($savefilename);

                if ($tmp_name_nic != "") {

                    if (!in_array($fileExtension, $fileExtensions)) {
                        $errors[] = "This file extension is not allowed. Please upload a JPEG or PNG file";
                    }

                    if ($fileSize > 4000000) {
                        $errors[] = "This file is more than 4MB. Sorry, it has to be less than or equal to 4MB";
                    }

                    if (empty($errors)) {
                        $didUpload = move_uploaded_file($fileTmpName, $uploadPath);

                        if ($didUpload) {


                            $model->nic_photo = $uploadDirectory . basename($savefilename);
                        } else {
                            echo "An error occurred somewhere. Try again or contact the admin";
                        }
                    } else {
                        foreach ($errors as $error) {
                            echo $error . "These are the errors" . "\n";
                        }
                    }
                }
            }

            if (!ctype_upper($model->FirstName))
                $model->FirstName = strtoupper($model->FirstName);
            if (!ctype_upper($model->LastName))
                $model->LastName = strtoupper($model->LastName);
            if (!ctype_upper($model->SurName))
                $model->SurName = strtoupper($model->SurName);
            if (!ctype_upper($model->Namewithini))
                $model->Namewithini = strtoupper($model->Namewithini);
            if (!ctype_upper($model->FullName))
                $model->FullName = strtoupper($model->FullName);

            // =========================================================================== 
            $employee = NonpayrollEmployee::model()->findByAttributes(array("id" => $id));

            $OldDesignation = $employee->designationid;
            $OldPaymentmethod = $employee->paymentmethodid;
            $model->resigndate = null;

            if ($model->save()) {

                //tracking changes
                $EmployeeStatusHistory = new EmployeeStatusHistory;
                $EmployeeStatusHistory->emp_id = $id;
                $EmployeeStatusHistory->status_id = 1;
                $EmployeeStatusHistory->description = "Active Employee";
                $EmployeeStatusHistory->responsible_person = Yii::app()->user->id;
                $EmployeeStatusHistory->affective_date = date("Y-m-d H:i:m");
                $EmployeeStatusHistory->status = 1;
                $EmployeeStatusHistory->site_id = $employee->siteid;
                $EmployeeStatusHistory->save();

                //inactive all the resign dates in curret site.
                EmployeeResignDetails::model()->updateAll(array('status' => 0), "employee_id=" . $model->id . " AND site_id=" . $model->siteid . " AND Status = 1");

                //write data in employee_join_details table
                EmployeeJoinDetails::model()->updateAll(array('status' => 0), "employee_id=" . $model->id . " AND site_id=" . $model->siteid . " AND Status = 1");
                $employeeJoin = new EmployeeJoinDetails;
                $employeeJoin->employee_id = $model->id;
                $employeeJoin->site_id = $model->siteid;
                $employeeJoin->join_date = $model->joindate;
                $employeeJoin->created_on = date('Y-m-d H:i:s');
                $employeeJoin->created_by = Yii::app()->user->id;
                $employeeJoin->status = 1;
                $employeeJoin->save();

                //write data in employee_designation_details table
                EmployeeDesignationDetails::model()->updateAll(array('status' => 0), "employee_id=" . $model->id . " AND site_id=" . $model->siteid . " AND Status = 1");
                $employeeDesignation = new EmployeeDesignationDetails;
                $employeeDesignation->employee_id = $model->id;
                $employeeDesignation->site_id = $model->siteid;
                $employeeDesignation->designation_id = $model->designationid;
                $employeeDesignation->created_on = date('Y-m-d H:i:s');
                $employeeDesignation->changed_by = Yii::app()->user->id;
                $employeeDesignation->status = 1;
                $employeeDesignation->save();

                EmployeeDesignation::model()->updateAll(array('Status' => 0), 'EmployeeId ="' . $id . '"');
                $employeedesigna = new EmployeeDesignation;
                $employeedesigna->Status = 1;
                $employeedesigna->EmployeeId = $model->id;
                $employeedesigna->DesignationId = $model->designationid;
                $employeedesigna->DateTime = date('Y-m-d H:i:s');
                $employeedesigna->save();

                if ($tmp_name_nic != "") {

                    $employeedocuments = EmployeeDocuments::model()->find("emp_id= '$id' AND document_id='4' AND status=1");

                    if ($employeedocuments) {

                        $employeedocuments->document_path = $model->nic_photo;
                        $employeedocuments->save();
                    } else {
                        $employeedocumentsmodel = new EmployeeDocuments();
                        $employeedocumentsmodel->emp_id = $id;
                        $employeedocumentsmodel->document_id = '4';
                        $employeedocumentsmodel->document_path = $model->nic_photo;

                        $employeedocumentsmodel->inactive_date = "0";

                        $employeedocumentsmodel->status = "1";
                        $employeedocumentsmodel->assign_date = date('Y-m-d h:i:s');
                        $employeedocumentsmodel->save();
                    }
                }
                $this->redirect(array('view', 'id' => $model->id));
            }
            $this->render('_activateEmployee', array(
                'model' => $model, 'EmplyeeContractFee' => $EmplyeeContractFee, 'Sites' => $Sites, 'Userid' => $Userid
            ));
        } else {
            $this->render('_activateEmployee', array(
                'model' => $model, 'EmplyeeContractFee' => $EmplyeeContractFee, 'Sites' => $Sites, 'Userid' => $Userid
            ));
        }
    }

}
