<?php

class PomaterialController extends Controller {

    /**
     * @var string the default layout for the views. Defaults to '//layouts/column2', meaning
     * using two-column layout. See 'protected/views/layouts/column2.php'.
     */
    public $layout = '//layouts/column1';

    /**
     * @return array action filters
     */
    public function filters() {
        return array(
            'accessControl', // perform access control for CRUD operations
        );
    }

    /**
     * Specifies the access control rules.
     * This method is used by the 'accessControl' filter.
     * @return array access control rules
     */
    public function accessRules() {
        return array(
            array('allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('index', 'admin', 'view', 'CreateData', 'GetSectorsByCompany', 'GetClustorsBySector', 'GetSitesByClustors', 'GetAccountsBySites', 'GetPOByAccounts', 'AddPOMeterialCode', 'AddSalesOrderCode', 'CreateSAPExcel'),
                'users' => array('*'),
            ),
            array('allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array('create', 'update'),
                'users' => array('@'),
            ),
            array('allow', // allow admin user to perform 'admin' and 'delete' actions
                'actions' => array('admin', 'delete'),
                'users' => array('admin'),
            ),
            array('deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    /**
     * Displays a particular model.
     * @param integer $id the ID of the model to be displayed
     */
    public function actionView($id) {
        $this->render('view', array(
            'model' => $this->loadModel($id),
        ));
    }

    /**
     * Creates a new model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     */
    public function actionCreate() {
        $model = new Pomaterial;

// Uncomment the following line if AJAX validation is needed
// $this->performAjaxValidation($model);

        if (isset($_POST['Pomaterial'])) {
            $model->attributes = $_POST['Pomaterial'];
            if ($model->save()) {
                //$this->redirect(array('view', 'id' => $model->id));
                //$data = Accounts::model()->findAllByAttributes(array('siteid'=>$SiteId));
            }
        }

        $this->render('create', array(
            'model' => $model,
        ));
    }

    public function actionCreateData() {
        $model = new Pomaterial;

        if (isset($_POST['Pomaterial'])) {
            $model->attributes = $_POST['Pomaterial'];
            $account_id = $model->Accountid;
            $Payment_method = $model->PaymentMethod;
            $sql = "SELECT designation.id
                FROM designation
                WHERE designation.id NOT IN (SELECT pomaterial.Designationid
                FROM pomaterial
                INNER JOIN designation ON pomaterial.Designationid = designation.id
                WHERE pomaterial.Accountid =" . $account_id . " AND  pomaterial.PaymentMethod='" . $Payment_method . "') ";
            $rowd1 = Yii::app()->db->createCommand($sql)->queryAll();
//           $result = CJSON::encode($rowd1);
//                echo $result;
            if (!empty($rowd1)) {
                foreach ($rowd1 as $designationid) {
                    $model2 = new Pomaterial;
                    $model2->attributes = $_POST['Pomaterial'];
                    $model2->Designationid = $designationid['id'];
                    $model2->save();
                }
                $sql = " SELECT
                                pomaterial.id,
                                company.name as CompanyName,
                                sector.name as SectorName,
                                cluster.name AS ClustorName,
                                sites.name AS SiteName,
                                accounts.name AS AccountName,
                                designation.type AS DesignationType,
                                pomaterial.POmeterialCode,
                                pomaterial.PaymentMethod,
                                pomaterial.SaleOrderMCode

                                FROM pomaterial

                                INNER JOIN company ON pomaterial.Companyid = company.id
                                INNER JOIN sector ON pomaterial.Sectorid = sector.id
                                INNER JOIN cluster ON pomaterial.Clustorid = cluster.id
                                INNER JOIN sites ON pomaterial.Sitesid = sites.id
                                INNER JOIN accounts ON pomaterial.Accountid = accounts.id
                                INNER JOIN designation ON pomaterial.Designationid =designation.id

                                WHERE pomaterial.Accountid ='" . $account_id . "' AND  pomaterial.PaymentMethod='" . $Payment_method . "'";

                $rowdata = Yii::app()->db->createCommand($sql)->queryAll();
                $result = CJSON::encode($rowdata);
                echo $result;
            } else {
                $rowdata = array();
                $result = CJSON::encode($rowdata);
                echo $result;
            }
        }
    }

    /**
     * Updates a particular model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id the ID of the model to be updated
     */
    public function actionUpdate($id) {
        $model = $this->loadModel($id);

// Uncomment the following line if AJAX validation is needed
// $this->performAjaxValidation($model);

        if (isset($_POST['Pomaterial'])) {
            $model->attributes = $_POST['Pomaterial'];
            if ($model->save())
                $this->redirect(array('view', 'id' => $model->id));
        }

        $this->render('update', array(
            'model' => $model,
        ));
    }

    /**
     * Deletes a particular model.
     * If deletion is successful, the browser will be redirected to the 'admin' page.
     * @param integer $id the ID of the model to be deleted
     */
    public function actionDelete($id) {
        if (Yii::app()->request->isPostRequest) {
// we only allow deletion via POST request
            $this->loadModel($id)->delete();

// if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
            if (!isset($_GET['ajax']))
                $this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('admin'));
        } else
            throw new CHttpException(400, 'Invalid request. Please do not repeat this request again.');
    }

    /**
     * Lists all models.
     */
    public function actionIndex() {

        if (Yii::app()->user->data()->superuser == 1) {
         //  $Payroll_list = Payroll::model()->findAll();
            $Payroll_list = Payroll::model()->findAllByAttributes(array('PayrollMethod' => 'DAILY'));
        } else {
            $SiteId = Yii::app()->user->data()->SiteId;
            $Payroll_list = Payroll::model()->findAllByAttributes(array('SiteId' => $SiteId,'PayrollMethod' => 'DAILY'));
        }
        $POreports = new PoReport;

        if (isset($_POST['POreports'])) {
            $POreports->attributes = $_POST['POreports'];
            $Payroll = Payroll::model()->findByAttributes(array('id' => $POreports->Payroll));
            $PaymentMethods = array("Basic", "Incentive", "OT", "DOT");
            $All_List = array();
            foreach ($PaymentMethods as $paymentmethod) {

                if ($paymentmethod == 'Basic') {
                    $sql = " SELECT
                    payroll_items.Accountid,
                    payroll_items.Account,
                    accounts.SAPCoustomCode AS SAPAcountCode, 
                    employee.supplierid,
                    supplier.SuplierCode,
                    payroll_items.JobTitle AS Designation,
                    payroll_items.Designationid,
                    COUNT(payroll_items.id) AS NumberOfEmployee,
                    SUM(payroll_items.WorkDay) AS Quantity,
                    designation_salary.DailySalary As TotalNet,
                    pomaterial.POmeterialCode,
                    pomaterial.SaleOrderMCode,
                    sites.name,
                    pomaterial.PaymentMethod,
                    sites.PlantName
                    
                   
                    from payroll_items
                    INNER JOIN employee ON payroll_items.NIC = employee.nic
                    INNER JOIN supplier ON employee.supplierid = supplier.id
                    INNER JOIN accounts ON payroll_items.Accountid = accounts.id
                    INNER JOIN payroll ON payroll_items.Payroll_id =payroll.id
                    INNER JOIN sites ON payroll.SiteId =sites.id
                    LEFT OUTER JOIN pomaterial ON payroll_items.Designationid = pomaterial.Designationid  AND payroll_items.Accountid = pomaterial.Accountid AND '" . $paymentmethod . "'  = pomaterial.PaymentMethod
                    INNER JOIN designation_salary ON payroll_items.Designationid =designation_salary.DesignationId AND  designation_salary.Status =1                    

                    WHERE payroll_items.Payroll_id='" . $POreports->Payroll . "'
                    GROUP by payroll_items.Accountid, employee.supplierid,payroll_items.Designationid";

                    $PO_List = Yii::app()->db->createCommand($sql)->queryAll();
                } elseif ($paymentmethod == 'Incentive') {
                    $sql = " SELECT
                    payroll_items.Accountid,
                    payroll_items.Account,
                    accounts.SAPCoustomCode AS SAPAcountCode, 
                    employee.supplierid,
                    supplier.SuplierCode,
                    payroll_items.JobTitle AS Designation,
                    payroll_items.Designationid,
                    COUNT(payroll_items.id) AS NumberOfEmployee,
              --    SUM(payroll_items.WorkDay) AS WorkedDays,
                    1 AS Quantity,
                    SUM(payroll_items.Insentive) AS TotalNet,
                    pomaterial.POmeterialCode,
                    pomaterial.SaleOrderMCode,
                    sites.name,
                    pomaterial.PaymentMethod,
                    sites.PlantName
                   
                    from payroll_items
                    INNER JOIN employee ON payroll_items.NIC = employee.nic
                    INNER JOIN supplier ON employee.supplierid = supplier.id
                    INNER JOIN accounts ON payroll_items.Accountid = accounts.id
                    INNER JOIN payroll ON payroll_items.Payroll_id =payroll.id
                    INNER JOIN sites ON payroll.SiteId =sites.id
                    LEFT OUTER JOIN pomaterial ON payroll_items.Designationid = pomaterial.Designationid  AND payroll_items.Accountid = pomaterial.Accountid AND '" . $paymentmethod . "'  = pomaterial.PaymentMethod
                    INNER JOIN designation_salary ON payroll_items.Designationid =designation_salary.DesignationId AND  designation_salary.Status =1                    


                    WHERE payroll_items.Payroll_id='" . $POreports->Payroll . "'
                    GROUP by payroll_items.Accountid, employee.supplierid,payroll_items.Designationid";

                    $PO_List = Yii::app()->db->createCommand($sql)->queryAll();
                } elseif ($paymentmethod == 'OT') {
                    $sql = " SELECT
                    payroll_items.Accountid,
                    payroll_items.Account,
                    accounts.SAPCoustomCode AS SAPAcountCode, 
                    employee.supplierid,
                    supplier.SuplierCode,
                    payroll_items.JobTitle AS Designation,
                    payroll_items.Designationid,
                    COUNT(payroll_items.id) AS NumberOfEmployee,
                --  SUM(payroll_items.WorkDay) AS WorkedDays,
                    SUM(payroll_items.NOTHour) AS Quantity,
                    SUM(payroll_items.TotalNet) AS TotalNet,
                    designation_salary.DailySalary As TotalNet,
                    pomaterial.POmeterialCode,
                    pomaterial.SaleOrderMCode,
                    sites.name,
                    payroll.SiteId,
                    pomaterial.PaymentMethod,
                    sites.PlantName
                   
                    from payroll_items
                    INNER JOIN employee ON payroll_items.NIC = employee.nic
                    INNER JOIN supplier ON employee.supplierid = supplier.id
                    INNER JOIN accounts ON payroll_items.Accountid = accounts.id
                    INNER JOIN payroll ON payroll_items.Payroll_id =payroll.id
                    INNER JOIN sites ON payroll.SiteId =sites.id
                    LEFT OUTER JOIN pomaterial ON payroll_items.Designationid = pomaterial.Designationid  AND payroll_items.Accountid = pomaterial.Accountid AND '" . $paymentmethod . "'  = pomaterial.PaymentMethod
                    INNER JOIN designation_salary ON payroll_items.Designationid =designation_salary.DesignationId AND  designation_salary.Status =1                    


                    WHERE payroll_items.Payroll_id='" . $POreports->Payroll . "'
                    GROUP by payroll_items.Accountid, employee.supplierid,payroll_items.Designationid";

                    $PO_List1 = Yii::app()->db->createCommand($sql)->queryAll();
                    $PO_List = array();

                    if (!empty($PO_List1)) {
                        foreach ($PO_List1 as $list) {

                            $designationSalary = DesignationSalary::model()->findByAttributes(array("DesignationId" => $list['Designationid'], "Siteid" => $list['SiteId'], "Status" => 1));
                            $DailyWage = $designationSalary != null ? $designationSalary->DailySalary : 0;
                            $NOTRate = ($DailyWage / 8) * 1.5;

                            $list['TotalNet'] = $NOTRate;
                            $PO_List[] = $list;
                        }
                    }
                } elseif ($paymentmethod == 'DOT') {
                    $sql = " SELECT
                    payroll_items.Accountid,
                    payroll_items.Account,
                    accounts.SAPCoustomCode AS SAPAcountCode, 
                    employee.supplierid,
                    supplier.SuplierCode,
                    payroll_items.JobTitle AS Designation,
                    payroll_items.Designationid,
                    COUNT(payroll_items.id) AS NumberOfEmployee,
               --   SUM(payroll_items.WorkDay) AS WorkedDays,
                    SUM(payroll_items.DOTHour) AS Quantity,
                    SUM(payroll_items.TotalNet) AS TotalNet,
                    pomaterial.POmeterialCode,
                    pomaterial.SaleOrderMCode,
                    sites.name,
                    payroll.SiteId,
                    pomaterial.PaymentMethod,
                    sites.PlantName
                   
                    from payroll_items
                    INNER JOIN employee ON payroll_items.NIC = employee.nic
                    INNER JOIN supplier ON employee.supplierid = supplier.id
                    INNER JOIN accounts ON payroll_items.Accountid = accounts.id
                    INNER JOIN payroll ON payroll_items.Payroll_id =payroll.id
                    INNER JOIN sites ON payroll.SiteId =sites.id
                    LEFT OUTER JOIN pomaterial ON payroll_items.Designationid = pomaterial.Designationid  AND payroll_items.Accountid = pomaterial.Accountid AND '" . $paymentmethod . "'  = pomaterial.PaymentMethod
                    INNER JOIN designation_salary ON payroll_items.Designationid =designation_salary.DesignationId AND  designation_salary.Status =1                    


                    WHERE payroll_items.Payroll_id='" . $POreports->Payroll . "'
                    GROUP by payroll_items.Accountid, employee.supplierid,payroll_items.Designationid";

                    $PO_List2 = Yii::app()->db->createCommand($sql)->queryAll();
                    $PO_List = array();

                    if (!empty($PO_List2)) {
                        foreach ($PO_List2 as $list) {

                            $designationSalary = DesignationSalary::model()->findByAttributes(array("DesignationId" => $list['Designationid'], "Siteid" => $list['SiteId'], "Status" => 1));
                            $DailyWage = $designationSalary != null ? $designationSalary->DailySalary : 0;
                            $DOTRate = ($DailyWage / 8) * 2;

                            $list['TotalNet'] = $DOTRate;
                            $PO_List[] = $list;
                        }
                    }
                }


                if (!empty($PO_List)) {
                    foreach ($PO_List as $list) {

                        $All_List[] = $list;
                    }
                }
            }

            foreach ($All_List as $key => $row) {
                $Accountid[$key] = $row['Accountid'];
                $Supplierid[$key] = $row['supplierid'];
                $Designationid[$key] = $row['Designationid'];
            }

            array_multisort($Accountid, $Supplierid, $Designationid, SORT_ASC, $All_List);

//           print_r($All_List);
//           die;

            $this->render('POReport', array('All_List' => $All_List, 'Payroll' => $Payroll));
        } else {
            $this->render('index', array('Payroll_list' => $Payroll_list, 'POreports' => $POreports));
        }
    }

    /**
     * Manages all models.
     */
    public function actionAdmin() {
        $model = new Pomaterial('search');
        $model->unsetAttributes();  // clear any default values
        if (isset($_GET['Pomaterial']))
            $model->attributes = $_GET['Pomaterial'];

        $this->render('admin', array(
            'model' => $model,
        ));
    }

    /**
     * Returns the data model based on the primary key given in the GET variable.
     * If the data model is not found, an HTTP exception will be raised.
     * @param integer the ID of the model to be loaded
     */
    public function loadModel($id) {
        $model = Pomaterial::model()->findByPk($id);
        if ($model === null)
            throw new CHttpException(404, 'The requested page does not exist.');
        return $model;
    }

    /**
     * Performs the AJAX validation.
     * @param CModel the model to be validated
     */
    protected function performAjaxValidation($model) {
        if (isset($_POST['ajax']) && $_POST['ajax'] === 'pomaterial-form') {
            echo CActiveForm::validate($model);
            Yii::app()->end();
        }
    }

    public function actionGetSectorsByCompany() {

        $Comapany_id = ($_POST['Company_id']);
        if (!empty($Comapany_id)) {
            $Sectors = Sector::model()->findAllByAttributes(array('companyid' => $Comapany_id));
            $list = CHtml::listData($Sectors, 'id', 'name');
            echo "<option value=''> </option>";
            foreach ($list as $value => $key) {
                echo CHtml::tag('option', array('value' => $value), CHtml::encode($key), true);
            }
        }
    }

    public function actionGetClustorsBySector() {

        $sector_id = ($_POST['Sector_id']);
        if (!empty($sector_id)) {
            $Clustors = Cluster::model()->findAllByAttributes(array('sectorid' => $sector_id));
            $list = CHtml::listData($Clustors, 'id', 'name');
            echo "<option value=''> </option>";
            foreach ($list as $value => $key) {
                echo CHtml::tag('option', array('value' => $value), CHtml::encode($key), true);
            }
        }
    }

    public function actionGetSitesByClustors() {

        $clustor_id = ($_POST['Clustorid_id']);
        if (!empty($clustor_id)) {
            $Sites = Sites::model()->findAllByAttributes(array('clusterid' => $clustor_id));
            $list = CHtml::listData($Sites, 'id', 'name');
            echo "<option value=''> </option>";
            foreach ($list as $value => $key) {
                echo CHtml::tag('option', array('value' => $value), CHtml::encode($key), true);
            }
        }
    }

    public function actionGetAccountsBySites() {

        $site_id = ($_POST['Site_id']);
        if (!empty($site_id)) {
            $Accounts = Accounts::model()->findAllByAttributes(array('siteid' => $site_id));
            $list = CHtml::listData($Accounts, 'id', 'name');
            echo "<option value=''> </option>";
            foreach ($list as $value => $key) {
                echo CHtml::tag('option', array('value' => $value), CHtml::encode($key), true);
            }
        }
    }

    public function actionGetPOByAccounts() {

        $account_id = ($_POST['Account_id']);
        $paymentmethod_id = ($_POST['PaymentMethod_id']);

        if (!empty($account_id and $paymentmethod_id)) {

            $sql = " SELECT
                pomaterial.id,
                company.name as CompanyName,
                sector.name as SectorName,
                cluster.name AS ClustorName,
                sites.name AS SiteName,
                accounts.name AS AccountName,
                designation.type AS DesignationType,
                pomaterial.POmeterialCode,
                pomaterial.PaymentMethod,
                pomaterial.SaleOrderMCode

                FROM pomaterial

                INNER JOIN company ON pomaterial.Companyid = company.id
                INNER JOIN sector ON pomaterial.Sectorid = sector.id
                INNER JOIN cluster ON pomaterial.Clustorid = cluster.id
                INNER JOIN sites ON pomaterial.Sitesid = sites.id
                INNER JOIN accounts ON pomaterial.Accountid = accounts.id
                INNER JOIN designation ON pomaterial.Designationid =designation.id

                WHERE pomaterial.Accountid ='" . $account_id . "'AND  pomaterial.PaymentMethod='" . $paymentmethod_id . "'  ";

            $rowdata = Yii::app()->db->createCommand($sql)->queryAll();

            $result = CJSON::encode($rowdata);
            echo $result;
        }
    }

    public function actionAddPOMeterialCode() {

        $id = ($_POST['id']);
        $POValue = ($_POST['POValue']);

        if (!empty($POValue)) {

            Pomaterial::model()->updateAll(array('POmeterialCode' => $POValue), 'id ="' . $id . '"');
        }
        $msg = CJSON::encode("Updated Successfully");
        echo $msg;
    }

    public function actionAddSalesOrderCode() {

        $id = ($_POST['id']);
        $SOMValue = ($_POST['SOMValue']);

        if (!empty($SOMValue)) {

            Pomaterial::model()->updateAll(array('SaleOrderMCode' => $SOMValue), 'id ="' . $id . '"');
        }
        $msg = CJSON::encode("Updated Successfully");
        echo $msg;
    }

    public function actionCreateSAPExcel() {


        $objPHPExcel = new PHPExcel();
        $PO_List = CJSON::decode($_POST['POList']);

        // Set document properties
        $objPHPExcel->getProperties()->setCreator("K'iin Balam")
                ->setLastModifiedBy("K'iin Balam")
                ->setTitle("YiiExcel Test Document")
                ->setSubject("YiiExcel Test Document")
                ->setDescription("Test document for YiiExcel, generated using PHP classes.")
                ->setKeywords("office PHPExcel php YiiExcel UPNFM")
                ->setCategory("Test result file");

        // Add some data
        $objPHPExcel->setActiveSheetIndex(0)
//                ->setCellValue('A1', 'SAP Report')
//                ->setCellValue('E1', 'Generated On')
//                ->setCellValue('F1', date("Y-m-d - h:i:sa"))
//                ->setCellValue('A2', 'Site :')
//                ->setCellValue('C2', $PO_List[0]['name'])
                ->setCellValue('A1', 'Group ID')
                ->setCellValue('B1', 'Vendor')
                ->setCellValue('C1', 'Name 1')
                ->setCellValue('D1', 'AccAssCat')
                ->setCellValue('E1', 'PO Material')
                ->setCellValue('F1', 'Sort Text')
                ->setCellValue('G1', 'Quantity')
                ->setCellValue('H1', 'Net Price')
                ->setCellValue('I1', 'Currency')
                ->setCellValue('J1', 'Plant')
                ->setCellValue('K1', 'Storage Location')
                ->setCellValue('L1', 'GL Account')
                ->setCellValue('M1', 'Cost Center')
                ->setCellValue('N1', 'Tax code')
                ->setCellValue('O1', 'NBT %')
                ->setCellValue('P1', 'Doc Date')
                ->setCellValue('Q1', 'Customer')
                ->setCellValue('R1', 'Name 1')
                ->setCellValue('S1', 'Division')
                ->setCellValue('T1', 'Sale Product')
                ->setCellValue('U1', 'Material Description')
                ->setCellValue('V1', 'Sales Doc Type')
                ->setCellValue('W1', 'Sales Org')
                ->setCellValue('X1', 'Order')
                ->setCellValue('Y1', 'Text');

        $styleArray = array(
            'font' => array(
                'bold' => true,
                'color' => array('rgb' => '#3498db'),
                'size' => 10
        ));
        $objPHPExcel->getActiveSheet()->getStyle('A1:Y1')->applyFromArray($styleArray);


        $row = 2;
        foreach ($PO_List as $POList) {

            $col = 1;

            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, $row, '1');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col, $row, $POList['SuplierCode']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col, $row, '');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col, $row, 'K');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col, $row, $POList['POmeterialCode']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col, $row, '');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col, $row, $POList['Quantity']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col, $row, $POList['TotalNet']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col, $row, 'LKR');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col, $row, $POList['PlantName']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col, $row, '');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col, $row, '');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col, $row, '');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col, $row, 'B1');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col, $row, '2');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col, $row, date("d.m.Y"));
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col, $row, $POList['SAPAcountCode']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col, $row, '');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col, $row, 'L1');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col, $row, $POList['SaleOrderMCode']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col, $row, '');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col, $row, 'ZOL1');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col, $row, 'LGWL');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col, $row, '');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col, $row, 'TEST');
            $row++;
        }




        $objPHPExcel->getActiveSheet()->setTitle('YiiExcel');
        $filename = "SAP";
        header('Content-Type: application/vnd.ms-excel');
        header('Content-Disposition: attachment;filename="' . $filename . '.xls"');
        header('Cache-Control: max-age=0');

        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');

        $objWriter->save('php://output');
        unset($this->objWriter);
        unset($this->objWorksheet);
        unset($this->objReader);
        unset($this->objPHPExcel);
        exit();
    }

}
