<?php

class TeamController extends Controller {

    /**
     * @var string the default layout for the views. Defaults to '//layouts/column2', meaning
     * using two-column layout. See 'protected/views/layouts/column2.php'.
     */
    public $layout = '//layouts/column1';

    /**
     * @return array action filters
     */
    public function filters() {
        return array(
            'accessControl', // perform access control for CRUD operations
        );
    }

    /**
     * Specifies the access control rules.
     * This method is used by the 'accessControl' filter.
     * @return array access control rules
     */
    public function accessRules() {
        return array(
            array('allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('index','view','RemoveEmployee','emp'),
                'users' => array('*'),
            ),
            array('allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array('create','admin', 'update'),
                'users' => array('@'),
            ),
            array('allow', // allow admin user to perform 'admin' and 'delete' actions
                'actions' => array('admin', 'delete'),
                'users' => array('admin'),
            ),
            array('deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    /**
     * Displays a particular model.
     * @param integer $id the ID of the model to be displayed
     */
    public function actionView($id) {
                $sql = "
            SELECT 
            employee.id,
            employee.Namewithini,
            employee.nic,
            employee_team.Status,
            employee_team.teamid,
            designation.type
            
            FROM employee_team
            INNER JOIN employee ON employee_team.employeeid = employee.id
            INNER JOIN designation ON employee.designationid = designation.id
            WHERE employee_team.teamid ='" . $id . "'  AND employee_team.Status ='" . 1 . "'";

                 
      $EmployeeList = Yii::app()->db->createCommand($sql)->queryAll();
//      print_r($EmployeeList);
//      die;
        $this->render('view', array(
            'model' => $this->loadModel($id),'EmployeeList'=>$EmployeeList,
        ));
    }

    /**
     * Creates a new model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     */
    public function actionCreate() {
        $model = new Team;
        //$models = new Employee;
        //$models = Employee::model()->findAll();
        if (Yii::app()->user->data()->superuser == 1) {
            $models = Employee::model()->findAllByAttributes(array('TeamStatus' => 0, 'statusId' => 1));
        } else {
            $SiteId = Yii::app()->user->data()->SiteId;
            $models = Employee::model()->findAllByAttributes(array('TeamStatus' => 0, 'statusId' => 1, 'siteid' => $SiteId));
        }


        if (isset($_POST['Team'])) {
            $model->attributes = $_POST['Team'];
            if ($model->save()) {

                if (isset($_POST['employees'])) {

                    if ($model->SalaryOverrideStatus == 1) {

                        foreach ($_POST['employees'] as $selectedOption) {

                            $employee = Employee::model()->findByPk($selectedOption);

                            if ($employee->paymentmethod['type'] == "DAILY") {

                                $Wage = $model->SectionDaySalary;
                                $dailyWage = Yii::app()->paymentUtil->getDayWage($Wage, "DAILY", "WagesBoard");
                                $hourlyRate = Yii::app()->paymentUtil->getHourlyRate($Wage, "DAILY", "WagesBoard");
                                $doubleOTRate = Yii::app()->paymentUtil->getDoubleOTRate($Wage, "DAILY", "WagesBoard");
                                $normalOTRate = Yii::app()->paymentUtil->getOvetimeRateNormalDay($Wage, "DAILY", "WagesBoard");
                                Employeesalary::model()->updateAll(array('Status' => 0), 'Status = 1 AND employeeid = ' . $selectedOption . '');

                                $empSalary = new Employeesalary;
                                $empSalary->employeeid = $selectedOption;
                                $empSalary->monthsalary = $Wage * 26;
                                $empSalary->DalySalary = $dailyWage;
                                $empSalary->HourlyRate = $hourlyRate;
                                $empSalary->DoubleOTRate = $doubleOTRate;
                                $empSalary->OTRate = $normalOTRate;
                                $empSalary->CreatedBy = Yii::app()->user->id;
                                $empSalary->CreatedOn = date("Y-m-d H:i");
                                $empSalary->Status = 1;
                                $empSalary->salaryChanged = 1;

                                $empSalary->save();
                            }

                            $employeeteam = new EmployeeTeam;
                            $employeeteam->teamid = $model->id;
                            $employeeteam->employeeid = $selectedOption;
                            $employeeteam->Status = 1;
                            $date = date('Y-m-d H:i:s');
                            $employeeteam->assigndate = $date;
                            $employeeteam->save();
                            Employee::model()->updateAll(array('TeamStatus' => 1), 'id="' . $selectedOption . '"');
                        }
                    } else {

                        foreach ($_POST['employees'] as $selectedOption) {

                            $employeeteam = new EmployeeTeam;
                            $employeeteam->teamid = $model->id;
                            $employeeteam->employeeid = $selectedOption;
                            $employeeteam->Status = 1;
                            $date = date('Y-m-d H:i:s');
                            $employeeteam->assigndate = $date;
                            $employeeteam->save();
                            Employee::model()->updateAll(array('TeamStatus' => 1), 'id="' . $selectedOption . '"');
                        }
                    }
                }
            }
            $this->redirect(array('view', 'id' => $model->id));
        }

        $this->render('create', array(
            'model' => $model, 'models' => $models,
        ));
    }
    
    /**
     * Updates a particular model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id the ID of the model to be updated
     */
    public function actionUpdate($id) {
        $model = $this->loadModel($id);

        $sql = "
            SELECT 
            
            employee.id,
            employee.FirstName,
            employee.LastName,
            employee.Namewithini,
            employee.nic,
            employee.TeamStatus

            FROM employee_team
            INNER JOIN employee ON employee_team.employeeid = employee.id
            WHERE employee_team.teamid ='" . $id . "'  AND employee_team.Status ='" . 1 . "'";


        $SEmployee = Yii::app()->db->createCommand($sql)->queryAll();
        if (Yii::app()->user->data()->superuser == 1) {
            $models = Employee::model()->findAllByAttributes(array('TeamStatus' => 0, 'statusId' => 1));
        } else {
            $SiteId = Yii::app()->user->data()->SiteId;
            $models = Employee::model()->findAllByAttributes(array('TeamStatus' => 0, 'statusId' => 1, 'siteid' => $SiteId));
        }

// Uncomment the following line if AJAX validation is needed
// $this->performAjaxValidation($model);

        if (isset($_POST['Team'])) {
            $model->attributes = $_POST['Team'];
            if ($model->save()) {
                $EmployeeOnTeam = EmployeeTeam::model()->findAllByAttributes(array('teamid' => $id, 'Status' => 1));

                foreach ($EmployeeOnTeam as $selectemployee) {

                    Employee::model()->updateAll(array('TeamStatus' => 0), 'id ="' . $selectemployee->employeeid . '"');
                }

                EmployeeTeam::model()->updateAll(array('Status' => 0), 'teamid="' . $id . '"');

                if (isset($_POST['employees'])) {

                    if ($model->SalaryOverrideStatus == 1) {

                        foreach ($_POST['employees'] as $selectedOption) {

                            $employee = Employee::model()->findByPk($selectedOption);

                            if ($employee->paymentmethod['type'] == "DAILY") {

                                $Wage = $model->SectionDaySalary;
                                $dailyWage = Yii::app()->paymentUtil->getDayWage($Wage, "DAILY", "WagesBoard");
                                $hourlyRate = Yii::app()->paymentUtil->getHourlyRate($Wage, "DAILY", "WagesBoard");
                                $doubleOTRate = Yii::app()->paymentUtil->getDoubleOTRate($Wage, "DAILY", "WagesBoard");
                                $normalOTRate = Yii::app()->paymentUtil->getOvetimeRateNormalDay($Wage, "DAILY", "WagesBoard");
                                Employeesalary::model()->updateAll(array('Status' => 0), 'Status = 1 AND employeeid = ' . $selectedOption . '');

                                $empSalary = new Employeesalary;
                                $empSalary->employeeid = $selectedOption;
                                $empSalary->monthsalary = $Wage * 26;
                                $empSalary->DalySalary = $dailyWage;
                                $empSalary->HourlyRate = $hourlyRate;
                                $empSalary->DoubleOTRate = $doubleOTRate;
                                $empSalary->OTRate = $normalOTRate;
                                $empSalary->CreatedBy = Yii::app()->user->id;
                                $empSalary->CreatedOn = date("Y-m-d H:i");
                                $empSalary->Status = 1;
                                $empSalary->salaryChanged = 1;

                                $empSalary->save();
                            }

                            $employeeteam = new EmployeeTeam;
                            $employeeteam->teamid = $model->id;
                            $employeeteam->employeeid = $selectedOption;
                            $employeeteam->Status = 1;
                            $date = date('Y-m-d H:i:s');
                            $employeeteam->assigndate = $date;
                            $employeeteam->save();
                            Employee::model()->updateAll(array('TeamStatus' => 1), 'id="' . $selectedOption . '"');
                        }
                    } else {

                        foreach ($_POST['employees'] as $selectedOption) {

                            $employeeteam = new EmployeeTeam;
                            $employeeteam->teamid = $model->id;
                            $employeeteam->employeeid = $selectedOption;
                            $employeeteam->Status = 1;
                            $date = date('Y-m-d H:i:s');
                            $employeeteam->assigndate = $date;
                            $employeeteam->save();
                            Employee::model()->updateAll(array('TeamStatus' => 1), 'id="' . $selectedOption . '"');
                        }
                    }
                }
            }
            $this->redirect(array('view', 'id' => $model->id));
        }

        $this->render('update', array(
            'model' => $model, 'models' => $models, 'SEmployee' => $SEmployee,
        ));
    }

    /**
     * Deletes a particular model.
     * If deletion is successful, the browser will be redirected to the 'admin' page.
     * @param integer $id the ID of the model to be deleted
     */
    public function actionDelete($id) {
        if (Yii::app()->request->isPostRequest) {
// we only allow deletion via POST request
            $this->loadModel($id)->delete();

// if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
            if (!isset($_GET['ajax']))
                $this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('admin'));
        } else
            throw new CHttpException(400, 'Invalid request. Please do not repeat this request again.');
    }

    /**
     * Lists all models.
     */
    public function actionIndex() {
       
        if (Yii::app()->user->data()->superuser == 1) {
            $sql = "SELECT 
                    employee.id as employeeid,
                    employee.Namewithini,
                    employee.nic,
                    team.id AS teamid,
                    team.name AS TeamName,
                    employee_team.id,
                    employee_team.assigndate,
                    employee_team.Status

                    FROM
                    employee_team
                    INNER JOIN employee ON employee_team.employeeid = employee.id
                    INNER JOIN team ON employee_team.teamid = team.id
                     WHERE employee_team.Status ='1'";
            $SEmployeeTeam = Yii::app()->db->createCommand($sql)->queryAll();
        } else {
            $SiteId = Yii::app()->user->data()->SiteId;
            $sql = "
                    SELECT 
                    employee.id as employeeid,
                    employee.Namewithini,
                    employee.nic,
                    team.id AS teamid,
                    team.name AS TeamName,
                    employee_team.id,
                    employee_team.assigndate,
                    employee_team.Status

                    FROM
                    employee_team

                    INNER JOIN employee ON employee_team.employeeid = employee.id
                    INNER JOIN team ON employee_team.teamid = team.id
                     WHERE employee_team.Status ='1' AND employee.siteid ='" . $SiteId . "'";
            $SEmployeeTeam = Yii::app()->db->createCommand($sql)->queryAll();
        }


        $this->render('index', array(
            'SEmployeeTeam' => $SEmployeeTeam,
        ));
    }
    

    public function actionAdmin() {
        $model = new Team('search');
        $model->unsetAttributes();  // clear any default values
        if (isset($_GET['Team']))
            $model->attributes = $_GET['Team'];

        $this->render('admin', array(
            'model' => $model,
        ));
    }

    /**
     * Returns the data model based on the primary key given in the GET variable.
     * If the data model is not found, an HTTP exception will be raised.
     * @param integer the ID of the model to be loaded
     */
    public function loadModel($id) {
        $model = Team::model()->findByPk($id);
        if ($model === null)
            throw new CHttpException(404, 'The requested page does not exist.');
        return $model;
    }

    /**
     * Performs the AJAX validation.
     * @param CModel the model to be validated
     */
    protected function performAjaxValidation($model) {
        if (isset($_POST['ajax']) && $_POST['ajax'] === 'team-form') {
            echo CActiveForm::validate($model);
            Yii::app()->end();
        }
    }
     public function actionRemoveEmployee() {
        
        $Employeeteamid = ($_POST['id']);

        if (!empty($Employeeteamid)) {
            $Employeeteam = EmployeeTeam::model()->findByAttributes(array('id' => $Employeeteamid));
           
            EmployeeTeam::model()->updateAll(array('Status' => 0), "id=" . $Employeeteamid . "");
            Employee::model()->updateAll(array('TeamStatus' => 0), 'id="' . $Employeeteam->employeeid . '"');
                  
            echo 'Removed Successfully';
        }
        
    }

}
