import React from "react";
import Warning from "../message"
import { Icon, Row } from "antd";
import Avatar from './avatar';
import { ExportButton } from '../Buttons';

let base_url = "http://localhost/WFM_EFL/";

if (process.env.NODE_ENV === "production") {
  base_url = window.location.origin.toString() + "/WFM_EFL/";
}

export default class AvatarGrid extends React.Component{
    render(){
        return (
            <div class="wfm-dashboard-tile-container">
                <div>{this.props.title ? this.props.title.toUpperCase() : '-' }</div>

                {this.props.href && <ExportButton href={this.props.href}>Export</ExportButton>}

                <div class="wfm-dashboard-tile-payload">
                    <span class="wfm-dashboard-icon-container">
                        <i data-feather={this.props.icon}></i>
                    </span>
                    <div className="wfm-dashboard-card-payload">
                        {
                          this.props.data
                          ? this.props.data.error
                            ? <Warning message={this.props.data.error.message} icon="warning" color="#ff2828"/>
                            : <Row gutter={5} className="avatar-grid-container">
                                {this.props.data.map((item, i) => <Avatar data={item} i={i} baseUrl={base_url}/>)}
                                {this.props.data.length < 1 && <Warning message="Nothing to show here." icon="warning" color="#ff2828"/>}
                              </Row>
                          : <div className="center"><Icon type="loading" className="wfm-loading-icon"/></div>
                        }
                    </div>
                </div>
                {/* <div class="wfm-dashboard-tile-footer">
                    <a href="!">
                        <i data-feather="external-link"></i>
                    </a>
                </div> */}
            </div>
        )
    }
}