import React from "react";
import { Icon } from "antd";
import Warning from "../message"
import "./style.css"

export default class Card extends React.Component{
    render(){
        return (
            <div class="wfm-dashboard-tile-container">
                <div>{this.props.title ? this.props.title.toUpperCase() : '-' }</div>
                <div class="wfm-dashboard-tile-payload">
                    <span class="wfm-dashboard-icon-container">
                        <i data-feather={this.props.icon}></i>
                    </span>
                    <div className="wfm-dashboard-card-payload">
                        {
                          this.props.data
                          ? this.props.data.error
                            ? <Warning message={this.props.data.error.message} icon="warning" color="#ff2828"/>
                            : <h1 className="wfm-dashboard-card-payload-value">{this.props.data}</h1>
                          : <div className="center"><Icon type="loading" className="wfm-loading-icon"/></div>
                        }
                    </div>
                </div>
                <div class="wfm-dashboard-tile-footer">
                    <a href={this.props.href} title="View More">
                        <i data-feather="external-link"></i>
                    </a>
                </div>
            </div>
        )
    }
} 