
import React from "react";
import { withContext } from "../context"
import "react-grid-layout/css/styles.css"

import { Col, Row } from "antd";

class ResponsiveLocalStorageLayout extends React.PureComponent {
  render() {
    const { Tree } = this.props;
    return (
      <Row style={{padding : 10}} gutter={10}>
        {
          Tree.map((e, i) => {
            const { Element, id } = e;
            return <Col key={id} {...e.layout} style={{ marginBottom: 10}}><Element {...e}/></Col>
          })
        }
      </Row>
    );
  }
}
export default withContext.bind(this, ResponsiveLocalStorageLayout);

