

var app = angular.module('ItouchApp', ['chart.js', 'nvd3']);
app.controller('dashboardCtrl', ['$http', '$scope', '$location', '$window', function ($http, $scope, $location, $window) {
    $scope.colorsBar = [{
        backgroundColor: '#4a69bd',
        borderColor: '#4a69bd',
        hoverBackgroundColor: '#4a69bd',
        hoverBorderColor: '#4a69bd'
    },
    {
        backgroundColor: '#eb2f06',
        borderColor: '#eb2f06',
        hoverBackgroundColor: '#eb2f06',
        hoverBorderColor: '#eb2f06'
    }];
    $scope.datasetOverrideBar = [
        {
            fill: true,
            backgroundColor: [
                "#4a69bd",
                "#4a69bd",

            ]
        },
        {
            fill: true,
            backgroundColor: [
                "#eb2f06",
                "#eb2f06",

            ]
        }];
    $scope.labelsBar = [];
    $scope.seriesBar = ['Present', 'Absent'];
    $scope.preBar = [];
    $scope.absBar = [];
    $scope.dataBar = [];
    $scope.optionsBar = {
        scales: {
            xAxes: [{
                gridLines: {
                    display: false
                },
                barPercentage: 1,
                categoryPercentage: 1,
                scaleLabel: {
                    display: true,
                    labelString: 'Sites'
                }



            }],
            yAxes: [{
                gridLines: {
                    display: true
                },
                scaleLabel: {
                    display: true,
                    labelString: 'Head Count'
                }

            }]
        }
    };


    $scope.dateBar;

    $http.get("http://localhost/itouch/index.php/DashboardApi/PresenceAbsenceChart")
        .then(function (response) {
            var list = response.data.list;
            $scope.dateBar = response.data.date + ' (Today)';
            for (var i = 0; i < list.length; i++) {
                $scope.labelsBar.push(list[i].name.substring(0, 2));
                $scope.preBar.push(list[i].PRE);
                $scope.absBar.push(list[i].ABS);
            }


            $scope.dataBar = [$scope.preBar, $scope.absBar];

        }, function errorCallback(response) {

            console.log(response);

        });

    $scope.export = function () {

        $window.location.href = '/itouch/index.php/report/BarChartDownload';

    };

}]);


app.controller('stackChart', ['$http', '$scope', '$location','$window', function ($http, $scope, $location,$window) {

    $scope.labelsStack = [];
    $scope.typeStack = "StackedBar";
    $scope.seriesStack = ['Basic', 'OT', 'Allownce'];
    $scope.optionsStack = {
        scales: {
            xAxes: [{
                stacked: true,
                ticks: {
                    beginAtZero: true
                },
                gridLines: {
                    display: false
                },
                scaleLabel: {
                    display: true,
                    labelString: 'Sites'
                },

            }],
            yAxes: [{
                stacked: true,
                gridLines: {
                    display: true
                },
                scaleLabel: {
                    display: true,
                    labelString: 'Cost(%)'
                },
                ticks: {
                    callback: function (tick) {
                        return tick.toString() + '%';
                    }
                }
            }]
        }
    };
    $scope.bscStack = [];
    $scope.otStack = [];
    $scope.allwncStack = [];
    $scope.dateStack;

    $http.get("http://localhost/itouch/index.php/DashboardApi/PayrollChart")
        .then(function (response) {
            var list = response.data.list;
            $scope.dateStack = response.data.date;
            for (var i = 0; i < list.length; i++) {
                $scope.labelsStack.push(list[i].name.substring(0, 2));
                $scope.bscStack.push(list[i].basic);
                $scope.otStack.push(list[i].ot);
                $scope.allwncStack.push(list[i].allownce);
            }





        }, function errorCallback(response) {

            console.log(response);

        });

    $scope.export = function () {

        $window.location.href = '/itouch/index.php/report/StackChartDownload';

    };
    
    $scope.dataStack = [
        $scope.bscStack,
        $scope.otStack,
        $scope.allwncStack
    ];
    $scope.colorsStack = [{
        backgroundColor: '#28b779',
        borderColor: '#28b779',
        hoverBackgroundColor: '#28b779',
        hoverBorderColor: '#28b779'
    },
    {
        backgroundColor: '#ffb848',
        borderColor: '#ffb848',
        hoverBackgroundColor: '#ffb848',
        hoverBorderColor: '#ffb848'
    },
    {
        backgroundColor: '#852b99',
        borderColor: '#852b99',
        hoverBackgroundColor: '#852b99',
        hoverBorderColor: '#852b99'
    }];

    $scope.datasetOverrideStack = [
        {
            label: "My First dataset",
            //backgroundColor: "#2ed573",
            data: $scope.bscStack,
            stack: 1
        }, {
            label: "My Second dataset",
            //backgroundColor: "#ff6b81",
            data: $scope.otStack,
            stack: 2
        }, {
            label: "My Third dataset",
            //backgroundColor: "#eccc68",
            data: $scope.allwncStack,
            stack: 2
        }
    ];

}]);

app.controller("LineCtrl", function ($http, $scope, $window) {
    $scope.labelsLine = [];
    $scope.colorsLine = ['#7d5fff', '#fffa65', '#dfe6e9'];
    $scope.seriesLine = ['Present', 'Absent', 'Total Allocated'];
    $scope.dataLine = [];
    $scope.preLine = [];
    $scope.absLine = [];
    $scope.ttlLine = [];
    $scope.dateLine;
    var month;

    $http.get("http://localhost/itouch/index.php/DashboardApi/AreaChart")
        .then(function (response) {
            var list = response.data.list;
            $scope.exprt = list;
            $scope.dateLine = response.data.date;
            for (var i = 0; i < list.length; i++) {
                $scope.labelsLine.push(list[i].date.slice(-2));
                $scope.preLine.push(list[i].present);
                $scope.absLine.push(list[i].absent);
                $scope.ttlLine.push(list[i].total);
            }


            $scope.dataLine = [$scope.preLine, $scope.absLine, $scope.ttlLine];

        }, function errorCallback(response) {

            console.log(response);

        });

    $scope.export = function () {

        $window.location.href = '/itouch/index.php/report/LineChartDownload';

    };


    $scope.onClick = function (points, evt) {
        console.log(points, evt);
    };
    $scope.datasetOverrideLine = [{ yAxisID: 'y-axis-1' }];

    $scope.optionsLine = {
        scales: {
            xAxes: [{
                stacked: true,
                ticks: {
                    beginAtZero: true
                },
                gridLines: {
                    display: false
                },
                scaleLabel: {
                    display: true,
                    labelString: 'Dates Of Month'
                }
            }],
            yAxes: [
                {
                    id: 'y-axis-1',
                    type: 'linear',
                    display: true,
                    position: 'left',
                    scaleLabel: {
                        display: true,
                        labelString: 'Head Count'
                    }
                }]
        }
    };
});


app.controller("PieCtrl", function ($http, $scope, $location, $window) {


    $scope.labelsPie = [];
    $scope.dataPie = [];
    $scope.datePie;
    $scope.showHeader = false;
    $scope.msg = 'No Data Found';


    $http.get("http://localhost/itouch/index.php/DashboardApi/PieChart")
        .then(function (response) {
            var list = response.data.list;
            if (list.length == 0) {
                $scope.showHeader = true;
            }
            $scope.datePie = response.data.date + ' (Today)';
            for (var i = 0; i < list.length; i++) {
                $scope.labelsPie.push(list[i].name);
                $scope.dataPie.push(list[i].count);

            }




        }, function errorCallback(response) {

            console.log(response);

        });

    $scope.export = function () {

        $window.location.href = '/itouch/index.php/report/PieChartDownload';

    };

    $scope.onClick = function (points, evt) {
        var index = points[0]._index;
        var siteName = $scope.labelsPie[index];
        var items = {
            site: siteName
        };
        //console.log(siteName);

        $http.post('http://localhost/itouch/index.php/DashboardApi/GetSiteId', items).success(function (res) {

            $window.location.href = '/itouch/index.php/report/NonAllocatedEmployees/' + res;

        });
        // var a = JSON.parse(points[0]);
        // console.log(a.ChartElement );
        //$window.location.href = '/itouch/index.php/report/NonAllocatedEmployees/' + siteName;
    };



});

app.controller("BaseCtrl",
    function ($scope, $http, $window) {
        $scope.labelsB = [];
        $scope.dataB = [];
        $scope.typeB = 'polarArea';
        $scope.date;
        $scope.showHeader = false;
        $scope.msg = 'No Data Found';

        $http.get("http://localhost/itouch/index.php/DashboardApi/GetAccountViceAttendance")
            .then(function (response) {
                var list = response.data.list;
                if (list.length == 0) {
                    $scope.showHeader = true;
                }
                $scope.date = response.data.date
                for (var i = 0; i < list.length; i++) {
                    $scope.labelsB.push(list[i].name);
                    $scope.dataB.push(list[i].count);
                }
            }, function errorCallback(response) {

                console.log(response);

            });

        
        
    $scope.export = function () {

        $window.location.href = '/itouch/index.php/report/SitePieChartDownload';

    };

        $scope.toggle = function () {

            $scope.typeB = $scope.typeB === 'polarArea' ?
                'pie' : 'polarArea';
        };
    });

app.controller('siteBarChart', ['$http', '$scope', '$location','$window', function ($http, $scope, $location,$window) {
    $scope.colorsSiteBar = [{
        backgroundColor: '#28b779',
        borderColor: '#28b779',
        hoverBackgroundColor: '#28b779',
        hoverBorderColor: '#28b779'
    },
    {
        backgroundColor: '#852b99',
        borderColor: '#852b99',
        hoverBackgroundColor: '#852b99',
        hoverBorderColor: '#852b99'
    }, {
        backgroundColor: '#eb2f06',
        borderColor: '#eb2f06',
        hoverBackgroundColor: '#eb2f06',
        hoverBorderColor: '#eb2f06'
    }];
    $scope.datasetOverrideSiteBar = [
        {
            fill: true,
            backgroundColor: [
                "#4a69bd",
                "#4a69bd",

            ]
        },
        {
            fill: true,
            backgroundColor: [
                "#eb2f06",
                "#eb2f06",

            ]
        }];
    $scope.labelsSiteBar = [];
    $scope.seriesSiteBar = ['Total Allocated', 'Present', 'Absent'];
    $scope.allocatedSiteBar = [];
    $scope.preSiteBar = [];
    $scope.absSiteBar = [];
    $scope.dataSiteBar = [];
    $scope.optionsSiteBar = {
        scales: {
            xAxes: [{
                gridLines: {
                    display: false
                },
                BarPercentage: 1,
                categoryPercentage: 1,
                scaleLabel: {
                    display: true,
                    labelString: 'Accounts'
                }



            }],
            yAxes: [{
                gridLines: {
                    display: true
                },
                scaleLabel: {
                    display: true,
                    labelString: 'Head Count'
                }

            }]
        }
    };


    $scope.dateSiteBar;
    $scope.date;
    $scope.showHeader = false;
    $scope.msg = 'There Is No Allocated Employees';

    $http.get("http://localhost/itouch/index.php/DashboardApi/GetAccountVicePresentAbsent")
        .then(function (response) {
            var list = response.data.list;
            if (list.length == 0) {
                $scope.showHeader = true;
            }
            $scope.date = response.data.date
            for (var i = 0; i < list.length; i++) {
                $scope.labelsSiteBar.push(list[i].name.substring(0, 2));
                $scope.preSiteBar.push(list[i].present);
                $scope.absSiteBar.push(list[i].absent);
                $scope.allocatedSiteBar.push(list[i].allocated);
            }


            $scope.dataSiteBar = [$scope.allocatedSiteBar, $scope.preSiteBar, $scope.absSiteBar];

        }, function errorCallback(response) {

            console.log(response);

        });

        $scope.export = function () {

            $window.location.href = '/itouch/index.php/report/SiteBarChartDownload';
    
        };

}]);


