<?php

/**
 * This is the model class for table "active_employee_count".
 *
 * The followings are the available columns in table 'active_employee_count':
 * @property integer $id
 * @property string $date
 * @property integer $site_id
 * @property integer $count_of_begin
 * @property integer $count_of_end
 * @property string $created_on
 */
class ActiveEmployeeCount extends CActiveRecord
{
	/**
	 * Returns the static model of the specified AR class.
	 * @param string $className active record class name.
	 * @return ActiveEmployeeCount the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'active_employee_count';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('date, site_id, count_of_begin, count_of_end', 'required'),
			array('site_id, count_of_begin, count_of_end', 'numerical', 'integerOnly'=>true),
			array('date', 'length', 'max'=>12),
			array('created_on', 'safe'),
			// The following rule is used by search().
			// Please remove those attributes that should not be searched.
			array('id, date, site_id, count_of_begin, count_of_end, created_on', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'date' => 'Date',
			'site_id' => 'Site',
			'count_of_begin' => 'Count Of Begin',
			'count_of_end' => 'Count Of End',
			'created_on' => 'Created On',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 * @return CActiveDataProvider the data provider that can return the models based on the search/filter conditions.
	 */
	public function search()
	{
		// Warning: Please modify the following code to remove attributes that
		// should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);
		$criteria->compare('date',$this->date,true);
		$criteria->compare('site_id',$this->site_id);
		$criteria->compare('count_of_begin',$this->count_of_begin);
		$criteria->compare('count_of_end',$this->count_of_end);
		$criteria->compare('created_on',$this->created_on,true);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}
}