<?php

/**
 * This is the model class for table "deleted_payroll_items".
 *
 * The followings are the available columns in table 'deleted_payroll_items':
 * @property integer $id
 * @property string $EmployeeName
 * @property string $NIC
 * @property string $JobTitle
 * @property integer $Designationid
 * @property string $RateType
 * @property string $MPSuplier
 * @property string $Site
 * @property string $Account
 * @property string $WorkDay
 * @property string $NoPayDays
 * @property string $BasicWage
 * @property string $PoyadayPayment
 * @property string $MercantilePayment
 * @property string $SundayPayment
 * @property string $DayOfSundayP
 * @property string $NOT
 * @property string $DOT
 * @property string $TOT
 * @property string $Bonus
 * @property string $Allowance
 * @property string $Insentive
 * @property string $EPF
 * @property string $PAllowance
 * @property string $VAllowance
 * @property string $TotalGross
 * @property string $Deduction
 * @property string $Deduction2
 * @property string $Deduction3
 * @property string $TotalNet
 * @property string $EPFByCompany
 * @property string $ETFByCompany
 * @property string $ContractorFee
 * @property string $CostOfCompany
 * @property integer $Payroll_id
 * @property string $LateDeductTime
 * @property string $LateDeductAmount
 * @property string $Arrears
 * @property string $NOTHour
 * @property string $DOTHour
 * @property string $TOTHour
 * @property string $TotalForEPF
 * @property string $TotalAddition
 * @property string $TotalDeduction
 * @property string $EarlyOutDeductTime
 * @property string $EarlyOutDeductAmount
 * @property string $SiteHolidayAmount
 * @property integer $Accountid
 * @property integer $MPSupplierid
 * @property integer $Departmentid
 * @property string $DepartmentName
 * @property string $full_Basic_Salary
 * @property string $Sub_Basic_salary
 * @property string $BRA1
 * @property string $BRA2
 * @property string $BRA3
 * @property string $Perday_incentive
 * @property string $Lunch_incentive
 * @property string $NightShift_incentive
 * @property string $TotalForEPFPoyaday
 * @property integer $number_of_pieces
 */
class DeletedPayrollItems extends CActiveRecord
{
	/**
	 * Returns the static model of the specified AR class.
	 * @param string $className active record class name.
	 * @return DeletedPayrollItems the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'deleted_payroll_items';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('EmployeeName, NIC, JobTitle, RateType, MPSuplier, Site, Account, WorkDay, NoPayDays, BasicWage, TotalGross, TotalNet, CostOfCompany, Payroll_id', 'required'),
			array('Designationid, Payroll_id, Accountid, MPSupplierid, Departmentid, number_of_pieces', 'numerical', 'integerOnly'=>true),
			array('EmployeeName, MPSuplier, Site, Account', 'length', 'max'=>200),
			array('NIC', 'length', 'max'=>50),
			array('JobTitle, RateType', 'length', 'max'=>100),
			array('WorkDay, NoPayDays, BasicWage, PoyadayPayment, MercantilePayment, SundayPayment, DayOfSundayP, NOT, DOT, TOT, Bonus, Allowance, Insentive, EPF, PAllowance, VAllowance, TotalGross, Deduction, Deduction2, Deduction3, TotalNet, EPFByCompany, ETFByCompany, ContractorFee, CostOfCompany, LateDeductTime, LateDeductAmount, Arrears, NOTHour, DOTHour, TOTHour, TotalForEPF, TotalAddition, TotalDeduction, EarlyOutDeductTime, EarlyOutDeductAmount, SiteHolidayAmount, full_Basic_Salary, Sub_Basic_salary, BRA1, BRA2, BRA3, Perday_incentive, Lunch_incentive, NightShift_incentive, TotalForEPFPoyaday,performance_incentive', 'length', 'max'=>9),
			array('DepartmentName', 'length', 'max'=>250),
			// The following rule is used by search().
			// Please remove those attributes that should not be searched.
			array('id, EmployeeName, NIC, JobTitle, Designationid, RateType, MPSuplier, Site, Account, WorkDay, NoPayDays, BasicWage, PoyadayPayment, MercantilePayment, SundayPayment, DayOfSundayP, NOT, DOT, TOT, Bonus, Allowance, Insentive, EPF, PAllowance, VAllowance, TotalGross, Deduction, Deduction2, Deduction3, TotalNet, EPFByCompany, ETFByCompany, ContractorFee, CostOfCompany, Payroll_id, LateDeductTime, LateDeductAmount, Arrears, NOTHour, DOTHour, TOTHour, TotalForEPF, TotalAddition, TotalDeduction, EarlyOutDeductTime, EarlyOutDeductAmount, SiteHolidayAmount, Accountid, MPSupplierid, Departmentid, DepartmentName, full_Basic_Salary, Sub_Basic_salary, BRA1, BRA2, BRA3, Perday_incentive, Lunch_incentive, NightShift_incentive, TotalForEPFPoyaday, number_of_pieces', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'EmployeeName' => 'Employee Name',
			'NIC' => 'Nic',
			'JobTitle' => 'Job Title',
			'Designationid' => 'Designationid',
			'RateType' => 'Rate Type',
			'MPSuplier' => 'Mpsuplier',
			'Site' => 'Site',
			'Account' => 'Account',
			'WorkDay' => 'Work Day',
			'NoPayDays' => 'No Pay Days',
			'BasicWage' => 'Basic Wage',
			'PoyadayPayment' => 'Poyaday Payment',
			'MercantilePayment' => 'Mercantile Payment',
			'SundayPayment' => 'Sunday Payment',
			'DayOfSundayP' => 'Day Of Sunday P',
			'NOT' => 'Not',
			'DOT' => 'Dot',
			'TOT' => 'Tot',
			'Bonus' => 'Bonus',
			'Allowance' => 'Allowance',
			'Insentive' => 'Insentive',
			'EPF' => 'Epf',
			'PAllowance' => 'Pallowance',
			'VAllowance' => 'Vallowance',
			'TotalGross' => 'Total Gross',
			'Deduction' => 'Deduction',
			'Deduction2' => 'Deduction2',
			'Deduction3' => 'Deduction3',
			'TotalNet' => 'Total Net',
			'EPFByCompany' => 'Epfby Company',
			'ETFByCompany' => 'Etfby Company',
			'ContractorFee' => 'Contractor Fee',
			'CostOfCompany' => 'Cost Of Company',
			'Payroll_id' => 'Payroll',
			'LateDeductTime' => 'Late Deduct Time',
			'LateDeductAmount' => 'Late Deduct Amount',
			'Arrears' => 'Arrears',
			'NOTHour' => 'Nothour',
			'DOTHour' => 'Dothour',
			'TOTHour' => 'Tothour',
			'TotalForEPF' => 'Total For Epf',
			'TotalAddition' => 'Total Addition',
			'TotalDeduction' => 'Total Deduction',
			'EarlyOutDeductTime' => 'Early Out Deduct Time',
			'EarlyOutDeductAmount' => 'Early Out Deduct Amount',
			'SiteHolidayAmount' => 'Site Holiday Amount',
			'Accountid' => 'Accountid',
			'MPSupplierid' => 'Mpsupplierid',
			'Departmentid' => 'Departmentid',
			'DepartmentName' => 'Department Name',
			'full_Basic_Salary' => 'Full Basic Salary',
			'Sub_Basic_salary' => 'Sub Basic Salary',
			'BRA1' => 'Bra1',
			'BRA2' => 'Bra2',
			'BRA3' => 'Bra3',
			'Perday_incentive' => 'Perday Incentive',
			'Lunch_incentive' => 'Lunch Incentive',
			'NightShift_incentive' => 'Night Shift Incentive',
			'TotalForEPFPoyaday' => 'Total For Epfpoyaday',
			'number_of_pieces' => 'Number Of Pieces',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 * @return CActiveDataProvider the data provider that can return the models based on the search/filter conditions.
	 */
	public function search()
	{
		// Warning: Please modify the following code to remove attributes that
		// should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);
		$criteria->compare('EmployeeName',$this->EmployeeName,true);
		$criteria->compare('NIC',$this->NIC,true);
		$criteria->compare('JobTitle',$this->JobTitle,true);
		$criteria->compare('Designationid',$this->Designationid);
		$criteria->compare('RateType',$this->RateType,true);
		$criteria->compare('MPSuplier',$this->MPSuplier,true);
		$criteria->compare('Site',$this->Site,true);
		$criteria->compare('Account',$this->Account,true);
		$criteria->compare('WorkDay',$this->WorkDay,true);
		$criteria->compare('NoPayDays',$this->NoPayDays,true);
		$criteria->compare('BasicWage',$this->BasicWage,true);
		$criteria->compare('PoyadayPayment',$this->PoyadayPayment,true);
		$criteria->compare('MercantilePayment',$this->MercantilePayment,true);
		$criteria->compare('SundayPayment',$this->SundayPayment,true);
		$criteria->compare('DayOfSundayP',$this->DayOfSundayP,true);
		$criteria->compare('NOT',$this->NOT,true);
		$criteria->compare('DOT',$this->DOT,true);
		$criteria->compare('TOT',$this->TOT,true);
		$criteria->compare('Bonus',$this->Bonus,true);
		$criteria->compare('Allowance',$this->Allowance,true);
		$criteria->compare('Insentive',$this->Insentive,true);
		$criteria->compare('EPF',$this->EPF,true);
		$criteria->compare('PAllowance',$this->PAllowance,true);
		$criteria->compare('VAllowance',$this->VAllowance,true);
		$criteria->compare('TotalGross',$this->TotalGross,true);
		$criteria->compare('Deduction',$this->Deduction,true);
		$criteria->compare('Deduction2',$this->Deduction2,true);
		$criteria->compare('Deduction3',$this->Deduction3,true);
		$criteria->compare('TotalNet',$this->TotalNet,true);
		$criteria->compare('EPFByCompany',$this->EPFByCompany,true);
		$criteria->compare('ETFByCompany',$this->ETFByCompany,true);
		$criteria->compare('ContractorFee',$this->ContractorFee,true);
		$criteria->compare('CostOfCompany',$this->CostOfCompany,true);
		$criteria->compare('Payroll_id',$this->Payroll_id);
		$criteria->compare('LateDeductTime',$this->LateDeductTime,true);
		$criteria->compare('LateDeductAmount',$this->LateDeductAmount,true);
		$criteria->compare('Arrears',$this->Arrears,true);
		$criteria->compare('NOTHour',$this->NOTHour,true);
		$criteria->compare('DOTHour',$this->DOTHour,true);
		$criteria->compare('TOTHour',$this->TOTHour,true);
		$criteria->compare('TotalForEPF',$this->TotalForEPF,true);
		$criteria->compare('TotalAddition',$this->TotalAddition,true);
		$criteria->compare('TotalDeduction',$this->TotalDeduction,true);
		$criteria->compare('EarlyOutDeductTime',$this->EarlyOutDeductTime,true);
		$criteria->compare('EarlyOutDeductAmount',$this->EarlyOutDeductAmount,true);
		$criteria->compare('SiteHolidayAmount',$this->SiteHolidayAmount,true);
		$criteria->compare('Accountid',$this->Accountid);
		$criteria->compare('MPSupplierid',$this->MPSupplierid);
		$criteria->compare('Departmentid',$this->Departmentid);
		$criteria->compare('DepartmentName',$this->DepartmentName,true);
		$criteria->compare('full_Basic_Salary',$this->full_Basic_Salary,true);
		$criteria->compare('Sub_Basic_salary',$this->Sub_Basic_salary,true);
		$criteria->compare('BRA1',$this->BRA1,true);
		$criteria->compare('BRA2',$this->BRA2,true);
		$criteria->compare('BRA3',$this->BRA3,true);
		$criteria->compare('Perday_incentive',$this->Perday_incentive,true);
		$criteria->compare('Lunch_incentive',$this->Lunch_incentive,true);
		$criteria->compare('NightShift_incentive',$this->NightShift_incentive,true);
		$criteria->compare('TotalForEPFPoyaday',$this->TotalForEPFPoyaday,true);
		$criteria->compare('number_of_pieces',$this->number_of_pieces);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}
}