<?php

/**
 * This is the model class for table "designation_change".
 *
 * The followings are the available columns in table 'designation_change':
 * @property integer $id
 * @property integer $emp_id
 * @property integer $designation_id
 * @property string $effective_date
 * @property integer $changed_by
 * @property string $changed_on
 * @property integer $status
 */
class DesignationChange extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'designation_change';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('emp_id, designation_id, effective_date, changed_by, changed_on, status', 'required'),
			array('emp_id, designation_id, changed_by, status', 'numerical', 'integerOnly'=>true),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('id, emp_id, designation_id, effective_date, changed_by, changed_on, status', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'emp_id' => 'Emp',
			'designation_id' => 'Designation',
			'effective_date' => 'Effective Date',
			'changed_by' => 'Changed By',
			'changed_on' => 'Changed On',
			'status' => 'Status',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);
		$criteria->compare('emp_id',$this->emp_id);
		$criteria->compare('designation_id',$this->designation_id);
		$criteria->compare('effective_date',$this->effective_date,true);
		$criteria->compare('changed_by',$this->changed_by);
		$criteria->compare('changed_on',$this->changed_on,true);
		$criteria->compare('status',$this->status);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return DesignationChange the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
