<?php

/**
 * This is the model class for table "designation_incentive_changes".
 *
 * The followings are the available columns in table 'designation_incentive_changes':
 * @property integer $id
 * @property integer $incentive_id
 * @property integer $designation_id
 * @property integer $designation_salary_changes_id
 * @property string $incentive_amount_monthly
 * @property string $incentive_amount_daily
 * @property integer $site_id
 * @property integer $CreatedBy
 * @property string $createdOn
 * @property integer $status
 */
class DesignationIncentiveChanges extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'designation_incentive_changes';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('incentive_id, designation_id, designation_salary_changes_id, incentive_amount_monthly, incentive_amount_daily, site_id, CreatedBy, createdOn, status', 'required'),
			array('incentive_id, designation_id, designation_salary_changes_id, site_id, CreatedBy, status', 'numerical', 'integerOnly'=>true),
			array('incentive_amount_monthly, incentive_amount_daily', 'length', 'max'=>9),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('id, incentive_id, designation_id, designation_salary_changes_id, incentive_amount_monthly, incentive_amount_daily, site_id, CreatedBy, createdOn, status', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'incentive_id' => 'Incentive',
			'designation_id' => 'Designation',
			'designation_salary_changes_id' => 'Designation Salary Changes',
			'incentive_amount_monthly' => 'Incentive Amount Monthly',
			'incentive_amount_daily' => 'Incentive Amount Daily',
			'site_id' => 'Site',
			'CreatedBy' => 'Created By',
			'createdOn' => 'Created On',
			'status' => 'Status',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);
		$criteria->compare('incentive_id',$this->incentive_id);
		$criteria->compare('designation_id',$this->designation_id);
		$criteria->compare('designation_salary_changes_id',$this->designation_salary_changes_id);
		$criteria->compare('incentive_amount_monthly',$this->incentive_amount_monthly,true);
		$criteria->compare('incentive_amount_daily',$this->incentive_amount_daily,true);
		$criteria->compare('site_id',$this->site_id);
		$criteria->compare('CreatedBy',$this->CreatedBy);
		$criteria->compare('createdOn',$this->createdOn,true);
		$criteria->compare('status',$this->status);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return DesignationIncentiveChanges the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
