<?php

/**
 * This is the model class for table "designation_salary_changes".
 *
 * The followings are the available columns in table 'designation_salary_changes':
 * @property integer $id
 * @property string $MonthlySalary
 * @property string $DailySalary
 * @property string $MonthlyBasicSalary
 * @property string $MonthlyBRA1
 * @property string $MonthlyBRA2
 * @property string $MonthlyBRA3
 * @property string $DailyBasicSalary
 * @property string $DailyBRA1
 * @property string $DailyBRA2
 * @property string $DailyBRA3
 * @property integer $CreatedBy
 * @property string $CreatedOn
 * @property integer $Status
 * @property integer $DesignationId
 * @property integer $Siteid
 */
class DesignationSalaryChanges extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'designation_salary_changes';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array(' MonthlyBasicSalary, MonthlyBRA1, MonthlyBRA2, MonthlyBRA3, DailyBasicSalary, DailyBRA1, DailyBRA2, DailyBRA3, CreatedBy, CreatedOn, Status, DesignationId, Siteid', 'required'),
			array('CreatedBy, Status, DesignationId, Siteid', 'numerical', 'integerOnly'=>true),
			array('MonthlySalary, DailySalary, MonthlyBasicSalary, MonthlyBRA1, MonthlyBRA2, MonthlyBRA3, DailyBasicSalary, DailyBRA1, DailyBRA2, DailyBRA3', 'length', 'max'=>20),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('id, MonthlySalary, DailySalary, MonthlyBasicSalary, MonthlyBRA1, MonthlyBRA2, MonthlyBRA3, DailyBasicSalary, DailyBRA1, DailyBRA2, DailyBRA3, CreatedBy, CreatedOn, Status, DesignationId, Siteid', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'MonthlySalary' => 'Monthly Salary',
			'DailySalary' => 'Daily Salary',
			'MonthlyBasicSalary' => 'Monthly Basic Salary',
			'MonthlyBRA1' => 'Monthly Bra1',
			'MonthlyBRA2' => 'Monthly Bra2',
			'MonthlyBRA3' => 'Monthly Bra3',
			'DailyBasicSalary' => 'Daily Basic Salary',
			'DailyBRA1' => 'Daily Bra1',
			'DailyBRA2' => 'Daily Bra2',
			'DailyBRA3' => 'Daily Bra3',
			'CreatedBy' => 'Created By',
			'CreatedOn' => 'Created On',
			'Status' => 'Status',
			'DesignationId' => 'Designation',
			'Siteid' => 'Siteid',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);
		$criteria->compare('MonthlySalary',$this->MonthlySalary,true);
		$criteria->compare('DailySalary',$this->DailySalary,true);
		$criteria->compare('MonthlyBasicSalary',$this->MonthlyBasicSalary,true);
		$criteria->compare('MonthlyBRA1',$this->MonthlyBRA1,true);
		$criteria->compare('MonthlyBRA2',$this->MonthlyBRA2,true);
		$criteria->compare('MonthlyBRA3',$this->MonthlyBRA3,true);
		$criteria->compare('DailyBasicSalary',$this->DailyBasicSalary,true);
		$criteria->compare('DailyBRA1',$this->DailyBRA1,true);
		$criteria->compare('DailyBRA2',$this->DailyBRA2,true);
		$criteria->compare('DailyBRA3',$this->DailyBRA3,true);
		$criteria->compare('CreatedBy',$this->CreatedBy);
		$criteria->compare('CreatedOn',$this->CreatedOn,true);
		$criteria->compare('Status',$this->Status);
		$criteria->compare('DesignationId',$this->DesignationId);
		$criteria->compare('Siteid',$this->Siteid);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return DesignationSalaryChanges the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
