<?php

/**
 * This is the model class for table "employee_bulck_upload_fails".
 *
 * The followings are the available columns in table 'employee_bulck_upload_fails':
 * @property integer $id
 * @property string $NameWithInitial
 * @property string $FullName
 * @property string $NIC
 */
class EmployeeBulckUploadFails extends CActiveRecord
{
	/**
	 * Returns the static model of the specified AR class.
	 * @param string $className active record class name.
	 * @return EmployeeBulckUploadFails the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'Employee_bulck_upload_fails';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('NameWithInitial, FullName, NIC', 'required'),
			array('NameWithInitial', 'length', 'max'=>200),
			array('FullName', 'length', 'max'=>500),
			array('NIC', 'length', 'max'=>100),
			array('Description', 'length', 'max'=>1000),
			// The following rule is used by search().
			// Please remove those attributes that should not be searched.
			array('id, NameWithInitial, FullName, NIC', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'NameWithInitial' => 'Name With Initial',
			'FullName' => 'Full Name',
			'NIC' => 'Nic',
			'Description' => 'Description',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 * @return CActiveDataProvider the data provider that can return the models based on the search/filter conditions.
	 */
	public function search()
	{
		// Warning: Please modify the following code to remove attributes that
		// should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);
		$criteria->compare('NameWithInitial',$this->NameWithInitial,true);
		$criteria->compare('FullName',$this->FullName,true);
		$criteria->compare('NIC',$this->NIC,true);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}
}