<?php

/**
 * This is the model class for table "employee_incentive".
 *
 * The followings are the available columns in table 'employee_incentive':
 * @property integer $id
 * @property integer $employee_id
 * @property integer $incentive_id
 * @property string $incentive_amount
 * @property integer $createdBy
 * @property integer $status
 * @property integer $site_id
 */
class EmployeeIncentive extends CActiveRecord
{
	/**
	 * Returns the static model of the specified AR class.
	 * @param string $className active record class name.
	 * @return EmployeeIncentive the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'employee_incentive';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(

			array('employee_id, incentive_id, incentive_amount, createdBy, status,site_id', 'required'),
			array('employee_id, incentive_id, createdBy, status', 'numerical', 'integerOnly'=>true),
			array('incentive_amount', 'length', 'max'=>9),
			// The following rule is used by search().
			// Please remove those attributes that should not be searched.
			array('id, employee_id, incentive_id, incentive_amount, createdBy, status', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'employee_id' => 'Employee',
			'incentive_id' => 'Incentive',
			'incentive_amount' => 'Incentive Amount',
			'createdBy' => 'Created By',
			'status' => 'Status',
			'site_id'=>'Site'
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 * @return CActiveDataProvider the data provider that can return the models based on the search/filter conditions.
	 */
	public function search()
	{
		// Warning: Please modify the following code to remove attributes that
		// should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);
		$criteria->compare('employee_id',$this->employee_id);
		$criteria->compare('incentive_id',$this->incentive_id);
		$criteria->compare('incentive_amount',$this->incentive_amount,true);
		$criteria->compare('createdBy',$this->createdBy);
		$criteria->compare('status',$this->status);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}
}