<?php

/**
 * This is the model class for table "employeeteamhistory".
 *
 * The followings are the available columns in table 'employeeteamhistory':
 * @property integer $id
 * @property integer $Employeeid
 * @property integer $RemoveOn
 * @property string $RemoveBy
 * @property integer $ShiftId
 * @property integer $TeamId
 *
 * The followings are the available model relations:
 * @property Employee $employee
 * @property Shift $shift
 * @property Team $team
 */
class Employeeteamhistory extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'employeeteamhistory';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('Employeeid, RemoveOn, ShiftId, TeamId', 'numerical', 'integerOnly'=>true),
			array('RemoveBy', 'safe'),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('id, Employeeid, RemoveOn, RemoveBy, ShiftId, TeamId', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
			'employee' => array(self::BELONGS_TO, 'Employee', 'Employeeid'),
			'shift' => array(self::BELONGS_TO, 'Shift', 'ShiftId'),
			'team' => array(self::BELONGS_TO, 'Team', 'TeamId'),
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'Employeeid' => 'Employeeid',
			'RemoveOn' => 'Remove On',
			'RemoveBy' => 'Remove By',
			'ShiftId' => 'Shift',
			'TeamId' => 'Team',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);
		$criteria->compare('Employeeid',$this->Employeeid);
		$criteria->compare('RemoveOn',$this->RemoveOn);
		$criteria->compare('RemoveBy',$this->RemoveBy,true);
		$criteria->compare('ShiftId',$this->ShiftId);
		$criteria->compare('TeamId',$this->TeamId);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return Employeeteamhistory the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
