<?php

/**
 * This is the model class for table "leavedays".
 *
 * The followings are the available columns in table 'leavedays':
 * @property integer $id
 * @property integer $EmpId
 * @property string $leaveDays
 * @property double $Hours
 * @property string $CreatedOn
 * @property string $CreatedBy
 * @property integer $leaveId
 */
class Leavedays extends CActiveRecord
{
	/**
	 * Returns the static model of the specified AR class.
	 * @param string $className active record class name.
	 * @return Leavedays the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'leavedays';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('EmpId, leaveDays, CreatedOn, CreatedBy, leaveId,leaveType', 'required'),
			array('EmpId, leaveId,leave_type_status', 'numerical', 'integerOnly'=>true),
			array('Hours', 'numerical'),
			array('CreatedBy', 'length', 'max'=>50),
			// The following rule is used by search().
			// Please remove those attributes that should not be searched.
			array('id, EmpId, leaveDays, Hours, CreatedOn, CreatedBy, leaveId,leaveType', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'EmpId' => 'Emp',
			'leaveDays' => 'Leave Days',
			'Hours' => 'Hours',
			'CreatedOn' => 'Created On',
			'CreatedBy' => 'Created By',
			'leaveId' => 'Leave',
			'leaveType' => 'Leave Type',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 * @return CActiveDataProvider the data provider that can return the models based on the search/filter conditions.
	 */
	public function search()
	{
		// Warning: Please modify the following code to remove attributes that
		// should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);
		$criteria->compare('EmpId',$this->EmpId);
		$criteria->compare('leaveDays',$this->leaveDays,true);
		$criteria->compare('Hours',$this->Hours);
		$criteria->compare('CreatedOn',$this->CreatedOn,true);
		$criteria->compare('CreatedBy',$this->CreatedBy,true);
		$criteria->compare('leaveId',$this->leaveId);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}
        
        public function searchByLeaveId($leave_id) {


        $criteria = new CDbCriteria;

        $criteria->compare('leaveId', $leave_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }
}