<?php

/**
 * This is the model class for table "leavetype".
 *
 * The followings are the available columns in table 'leavetype':
 * @property integer $id
 * @property string $Type
 * @property string $Description
 */
class Leavetype extends CActiveRecord {

    /**
     * @return string the associated database table name
     */
    public function tableName() {
        return 'leavetype';
    }

    /**
     * @return array validation rules for model attributes.
     */
    public function rules() {
        // NOTE: you should only define rules for those attributes that
        // will receive user inputs.
        return array(
            array('Type', 'required'),
            array('Type,status', 'length', 'max' => 200),
            array('Description', 'length', 'max' => 250),
            // The following rule is used by search().
            // @todo Please remove those attributes that should not be searched.
            array('id, Type, Description', 'safe', 'on' => 'search'),
        );
    }

    /**
     * @return array relational rules.
     */
    public function relations() {
        // NOTE: you may need to adjust the relation name and the related
        // class name for the relations automatically generated below.
        return array(
        );
    }

    public static function getList() {
        return array('' => '') + CHtml::listData(self::model()->findAll(), 'id', 'Type');
    }

    public static function getListByStatus() {
        return array('' => '') + CHtml::listData(self::model()->findAllByAttributes(array('status' => 1)), 'id', 'Type');
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels() {
        return array(
            'id' => 'ID',
            'Type' => 'Type',
            'Description' => 'Description',
        );
    }

    /**
     * Retrieves a list of models based on the current search/filter conditions.
     *
     * Typical usecase:
     * - Initialize the model fields with values from filter form.
     * - Execute this method to get CActiveDataProvider instance which will filter
     * models according to data in model fields.
     * - Pass data provider to CGridView, CListView or any similar widget.
     *
     * @return CActiveDataProvider the data provider that can return the models
     * based on the search/filter conditions.
     */
    public function search() {
        // @todo Please modify the following code to remove attributes that should not be searched.

        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('Type', $this->Type, true);
        $criteria->compare('Description', $this->Description, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

    /**
     * Returns the static model of the specified AR class.
     * Please note that you should have this exact method in all your CActiveRecord descendants!
     * @param string $className active record class name.
     * @return Leavetype the static model class
     */
    public static function model($className = __CLASS__) {
        return parent::model($className);
    }

}
