<?php

/**
 * This is the model class for table "payroll_items".
 *
 * The followings are the available columns in table 'payroll_items':
 * @property integer $id
 * @property string $EmployeeName
 * @property string $NIC
 * @property string $JobTitle
 * @property string $RateType
 * @property string $MPSuplier
 * @property string $Site
 * @property string $Account
 * @property integer $WorkDay
 * @property string $BasicWage
 * @property string $PoyadayPayment
 * @property string $MercantilePayment
 * @property string $SundayPayment
 * @property string $DayOfSundayP
 * @property string $NOT
 * @property string $DOT
 * @property string $Bonus
 * @property string $Allowance
 * @property string $Insentive
 * @property string $EPF
 * @property string $PAllowance
 * @property string $VAllowance
 * @property string $TotalGross
 * @property string $Deduction
 * @property string $TotalNet
 * @property string $EPFByCompany
 * @property string $ETFByCompany
 * @property string $ContractorFee
 * @property string $CostOfCompany
 * @property integer $Payroll_id
 */
class PayrollItems extends CActiveRecord {

    /**
     * @return string the associated database table name
     */
    public function tableName() {
        return 'payroll_items';
    }

    /**
     * @return array validation rules for model attributes.
     */
    public function rules() {
        // NOTE: you should only define rules for those attributes that
        // will receive user inputs.
        return array(
            array('EmployeeName, NIC, JobTitle, RateType, MPSuplier, Site, Account, WorkDay, BasicWage, TotalGross, TotalNet, CostOfCompany, Payroll_id', 'required'),
            array('Accountid,Designationid,Payroll_id,MPSupplierid,Departmentid', 'numerical', 'integerOnly' => true),
            array('EmployeeName, MPSuplier, Site, Account,DepartmentName', 'length', 'max' => 200),
            array('NIC', 'length', 'max' => 50),
            array('JobTitle, RateType', 'length', 'max' => 100),
            array('BasicWage,ActualNOTHour,ActualDOTHour,ActualTOTHour,TotalAddition,SiteHolidayAmount,TotalDeduction,TotalForEPF,DOTHour,TOTHour,TOT,LateDeductTime,LateDeductAmount,Arrears, PoyadayPayment, MercantilePayment, SundayPayment, DayOfSundayP, NOT, DOT, Bonus, Allowance, Insentive, EPF, PAllowance, VAllowance, TotalGross, Deduction,Deduction2,Deduction3, TotalNet, EPFByCompany, ETFByCompany, ContractorFee, CostOfCompany,TotalForEPFPoyaday, number_of_pieces,Actual_WorkedDay,Special_Incentive,Trip_Commission_Incentive,Rural_incentive,BioPass_incentive,Incentive1,Incentive2,Incentive3,Incentive4,MonthIncentive,daysalary,contractorfee_rate,PreOTHour,PreOTAmount', 'length', 'max' => 50),
            // The following rule is used by search().
            // @todo Please remove those attributes that should not be searched.
            array('id,Deduction2,TotalAddition,SiteHolidayAmount,TotalDeduction,TotalForEPF,Deduction3, EmployeeName,TOT, NIC, JobTitle, RateType, MPSuplier, Site, Account, WorkDay, BasicWage, PoyadayPayment, MercantilePayment, SundayPayment, DayOfSundayP, NOT, DOT, Bonus, Allowance, Insentive, EPF, PAllowance, VAllowance, TotalGross, Deduction, TotalNet, EPFByCompany, ETFByCompany, ContractorFee, CostOfCompany, Payroll_id, full_Basic_Salary, Sub_Basic_salary, BRA1, BRA2, BRA3,Perday_incentive,Lunch_incentive,NightShift_incentive,travaling_incentive,accomondation_incentive,performance_incentive,TotalForEPFPoyaday', 'safe', 'on' => 'search'),
        );
    }

    /**
     * @return array relational rules.
     */
    public function relations() {
        // NOTE: you may need to adjust the relation name and the related
        // class name for the relations automatically generated below.
        return array(
        );
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels() {
        return array(
            'id' => 'ID',
            'EmployeeName' => 'Employee Name',
            'NIC' => 'Nic',
            'JobTitle' => 'Job Title',
            'RateType' => 'Rate Type',
            'MPSuplier' => 'Mpsuplier',
            'Site' => 'Site',
            'Account' => 'Account',
            'WorkDay' => 'Work Day',
            'BasicWage' => 'Basic Wage',
            'PoyadayPayment' => 'Poyaday Payment',
            'MercantilePayment' => 'Mercantile Payment',
            'SundayPayment' => 'Sunday Payment',
            'DayOfSundayP' => 'Day Of Sunday P',
            'NOT' => 'Not',
            'DOT' => 'Dot',
            'TOT' => 'Tot',
            'Bonus' => 'Bonus',
            'Allowance' => 'Allowance',
            'Insentive' => 'Insentive',
            'EPF' => 'Epf',
            'PAllowance' => 'Pallowance',
            'VAllowance' => 'Vallowance',
            'TotalGross' => 'Total Gross',
            'Deduction' => 'Deduction',
            'TotalNet' => 'Total Net',
            'EPFByCompany' => 'Epfby Company',
            'ETFByCompany' => 'Etfby Company',
            'ContractorFee' => 'Contractor Fee',
            'CostOfCompany' => 'Cost Of Company',
            'Payroll_id' => 'Payroll',
             'NOTHour' => 'NOTHour',
             'DOTHour' => 'DOTHour',
             'TOTHour' => 'TOTHour',
            'TotalForEPF'=>'TotalForEPF',
            'MPSupplierid'=>'MP Suplier',
            'Departmentid'=>'Department',
            'DepartmentName'=>'DepartmentName',
            
        );
    }

    /**
     * Retrieves a list of models based on the current search/filter conditions.
     *
     * Typical usecase:
     * - Initialize the model fields with values from filter form.
     * - Execute this method to get CActiveDataProvider instance which will filter
     * models according to data in model fields.
     * - Pass data provider to CGridView, CListView or any similar widget.
     *
     * @return CActiveDataProvider the data provider that can return the models
     * based on the search/filter conditions.
     */
    public function search() {
        // @todo Please modify the following code to remove attributes that should not be searched.

        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('EmployeeName', $this->EmployeeName, true);
        $criteria->compare('NIC', $this->NIC, true);
        $criteria->compare('JobTitle', $this->JobTitle, true);
        $criteria->compare('RateType', $this->RateType, true);
        $criteria->compare('MPSuplier', $this->MPSuplier, true);
        $criteria->compare('Site', $this->Site, true);
        $criteria->compare('Account', $this->Account, true);
        $criteria->compare('WorkDay', $this->WorkDay);
        $criteria->compare('BasicWage', $this->BasicWage, true);
        $criteria->compare('PoyadayPayment', $this->PoyadayPayment, true);
        $criteria->compare('MercantilePayment', $this->MercantilePayment, true);
        $criteria->compare('SundayPayment', $this->SundayPayment, true);
        $criteria->compare('DayOfSundayP', $this->DayOfSundayP, true);
        $criteria->compare('NOT', $this->NOT, true);
        $criteria->compare('DOT', $this->DOT, true);
        $criteria->compare('Bonus', $this->Bonus, true);
        $criteria->compare('Allowance', $this->Allowance, true);
        $criteria->compare('Insentive', $this->Insentive, true);
        $criteria->compare('EPF', $this->EPF, true);
        $criteria->compare('PAllowance', $this->PAllowance, true);
        $criteria->compare('VAllowance', $this->VAllowance, true);
        $criteria->compare('TotalGross', $this->TotalGross, true);
        $criteria->compare('Deduction', $this->Deduction, true);
        $criteria->compare('Deduction2', $this->Deduction2, true);
        $criteria->compare('Deduction3', $this->Deduction3, true);
        $criteria->compare('TotalNet', $this->TotalNet, true);
        $criteria->compare('EPFByCompany', $this->EPFByCompany, true);
        $criteria->compare('ETFByCompany', $this->ETFByCompany, true);
        $criteria->compare('ContractorFee', $this->ContractorFee, true);
        $criteria->compare('CostOfCompany', $this->CostOfCompany, true);
        $criteria->compare('Payroll_id', $this->Payroll_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

    /**
     * Returns the static model of the specified AR class.
     * Please note that you should have this exact method in all your CActiveRecord descendants!
     * @param string $className active record class name.
     * @return PayrollItems the static model class
     */
    public static function model($className = __CLASS__) {
        return parent::model($className);
    }

}
