<?php

/**
 * This is the model class for table "sitewise_absentdays_and_worlkingdays".
 *
 * The followings are the available columns in table 'sitewise_absentdays_and_worlkingdays':
 * @property integer $id
 * @property string $date
 * @property integer $site
 * @property integer $absent_days
 * @property integer $available_working_days
 * @property string $absenteeism_rate
 */
class SitewiseAbsentdaysAndWorlkingdays extends CActiveRecord
{
	/**
	 * Returns the static model of the specified AR class.
	 * @param string $className active record class name.
	 * @return SitewiseAbsentdaysAndWorlkingdays the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'sitewise_absentdays_and_worlkingdays';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('date, site', 'required'),
			array('site, absent_days, available_working_days', 'numerical', 'integerOnly'=>true),
			array('date, absenteeism_rate', 'length', 'max'=>10),
			// The following rule is used by search().
			// Please remove those attributes that should not be searched.
			array('id, date, site, absent_days, available_working_days, absenteeism_rate', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'date' => 'Date',
			'site' => 'Site',
			'absent_days' => 'Absent Days',
			'available_working_days' => 'Available Working Days',
			'absenteeism_rate' => 'Absenteeism Rate',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 * @return CActiveDataProvider the data provider that can return the models based on the search/filter conditions.
	 */
	public function search()
	{
		// Warning: Please modify the following code to remove attributes that
		// should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);
		$criteria->compare('date',$this->date,true);
		$criteria->compare('site',$this->site);
		$criteria->compare('absent_days',$this->absent_days);
		$criteria->compare('available_working_days',$this->available_working_days);
		$criteria->compare('absenteeism_rate',$this->absenteeism_rate,true);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}
}