<?php

/**
 * This is the model class for table "user_activity_master".
 *
 * The followings are the available columns in table 'user_activity_master':
 * @property integer $id
 * @property string $date
 * @property string $activity
 * @property string $supervisor
 * @property string $gatepass
 * @property string $start_time
 * @property string $end_time
 * @property integer $created_by
 */
class UserActivityMaster extends CActiveRecord
{
	/**
	 * Returns the static model of the specified AR class.
	 * @param string $className active record class name.
	 * @return UserActivityMaster the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'user_activity_master';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('date, activity, start_time, end_time, created_by', 'required'),
			array('created_by', 'numerical', 'integerOnly'=>true),
			array('activity, supervisor, gatepass', 'length', 'max'=>200),
			// The following rule is used by search().
			// Please remove those attributes that should not be searched.
			array('id, date, activity, supervisor, gatepass, start_time, end_time, created_by', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'date' => 'Date',
			'activity' => 'Activity',
			'supervisor' => 'Supervisor',
			'gatepass' => 'Gatepass',
			'start_time' => 'Start Time',
			'end_time' => 'End Time',
			'created_by' => 'Created By',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 * @return CActiveDataProvider the data provider that can return the models based on the search/filter conditions.
	 */
	public function search()
	{
		// Warning: Please modify the following code to remove attributes that
		// should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);
		$criteria->compare('date',$this->date,true);
		$criteria->compare('activity',$this->activity,true);
		$criteria->compare('supervisor',$this->supervisor,true);
		$criteria->compare('gatepass',$this->gatepass,true);
		$criteria->compare('start_time',$this->start_time,true);
		$criteria->compare('end_time',$this->end_time,true);
		$criteria->compare('created_by',$this->created_by);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}
}