<?php
$this->breadcrumbs = array(
    'Eligible Leaves' => array('admin'),
    'Manage',
);

echo $this->renderPartial('application.views.layouts._actions', array('model' => $model));

Yii::app()->clientScript->registerScript('search', "
$('.search-button').click(function(){
$('.search-form').toggle();
return false;
});
$('.search-form form').submit(function(){
$.fn.yiiGridView.update('eligible-leaves-grid', {
data: $(this).serialize()
});
return false;
});
");
?>

<h3>Manage Eligible Leaves</h3>

<!-- search-form -->
<div class="search-form" style="display:none">
    <p>You may optionally enter a comparison operator (<b>&lt;</b>, <b>&lt;=</b>, <b>&gt;</b>, <b>&gt;=</b>, <b>&lt;&gt;</b> or <b>=</b>) at the beginning of each of your search values to specify how the comparison should be done.</p>
    <?php
    $this->renderPartial('_search', array(
        'model' => $model,
    ));
    ?>
</div>
<!-- search-form -->

<?php
$this->widget('bootstrap.widgets.TbGridView', array(
    'id' => 'eligible-leaves-grid',
    'dataProvider' => $model->search(),
    'filter' => $model,
    'columns' => array(
        'id',
        array(
            'name' => 'designationId',
            'value' => '$data->designation !=null ? $data->designation->type:""',
            'filter' => Designation::getList()),
        array(
            'name' => 'leaveTypeId',
            'value' => '$data->leaveType !=null ? $data->leaveType->Type : ""',
            'filter' => Leavetype::getList()),
        'eligibleLeaves',
        'Time',
        'createdOn',
        array(
            'class' => 'bootstrap.widgets.TbButtonColumn',
        ),
    ),
));
?>
