<?php
$this->breadcrumbs = array(
    'Payrolls' => array('index'),
    'Manage',
);

echo $this->renderPartial('application.views.layouts._actions', array('model' => $model));

Yii::app()->clientScript->registerScript('search', "
$('.search-button').click(function(){
$('.search-form').toggle();
return false;
});
$('.search-form form').submit(function(){
$.fn.yiiGridView.update('payroll-grid', {
data: $(this).serialize()
});
return false;
});
");
?>

<h3>Manage Payrolls</h3>

<!-- search-form -->
<div class="search-form" style="display:none">
    <?php
    $this->renderPartial('_search', array(
        'model' => $model,
    ));
    ?>
</div>
<!-- search-form -->
<style>

    .tr_isadmin { 
        color: red; 
    }

</style>

<?php
$this->widget('bootstrap.widgets.TbGridView', array(
    'id' => 'payroll-grid',
    'dataProvider' => $model->search(),
    'filter' => $model,
    'rowCssClassExpression' => '$data->Status == 3 ? "tr_isadmin":""',
    'columns' => array(
        'id',
        'StartDate',
        'EndDate',
        'PayrollMethod',
        array(
            'name' => 'SiteId',
            'value' => function($data) {
                echo $data->site->name;
            }
        ),
        array(
            'name' => 'CreatedBy',
            'value' => '$data->CreatedUser->username',
        ),
        'CreatedTime',
        array(
            'name' => 'ApprovedBy',
            'value' => '$data->ApprovedUser != null ? $data->ApprovedUser->username : ""',
        ),
        'ApprovedTime',
        array(
            'name' => 'Status',
            'value' => 'Payroll::itemAlias("Status",$data->Status)',
            'filter' => Payroll::itemAlias("Status"),
        ),
        array(
            'class' => 'bootstrap.widgets.TbButtonColumn',
            'template' => '{view}  {delete}',
            'buttons' => array(
                'delete' => array(
                    'visible' => '$data->Status != 2',
                ),
            ),
        //'template' => '$data->Status == 0 ? {delete}  {view} : {view}'  //removed {delete}    
        ),
    ),
));
?>
