<?php if(!empty($absents)): ?>

<?php
$this->breadcrumbs=array(
	'Report'=>array('findAbsenteeismDetails'),
	'Daily Absent Report',
);
echo $this->renderPartial('application.views.layouts._actions', array('model'=>$model));
?>
<script type="text/javascript">
function sendData() {
    var model = <?php echo CJSON::encode($model) ;?>;
    var absents = <?php echo CJSON::encode($absents) ;?>;
    var url = '<?php echo Yii::app()->createUrl('report/createAbsentPDF'); ?>';
    gotoUrl(url, {
        'absents': absents,
        'model': model
    });
}

function sendDataExcel() {
    var model = <?php echo CJSON::encode($model) ;?>;
    var absents = <?php echo CJSON::encode($absents) ;?>;
    var url = '<?php echo Yii::app()->createUrl('report/CreateAbsentExcel'); ?>';
    gotoUrl(url, {
        'absents': absents,
        'model': model
    });
}

function gotoUrl(path, params, method) {
    //Null check
    method = method || "post"; // Set method to post by default if not specified.

    var form = document.createElement("form");
    form.setAttribute("method", method);
    form.setAttribute("action", path);

    //Fill the hidden form
    if (typeof params === 'string') {
        var hiddenField = document.createElement("input");
        hiddenField.setAttribute("type", "hidden");
        hiddenField.setAttribute("name", 'data');
        hiddenField.setAttribute("value", params);
        form.appendChild(hiddenField);
    } else {
        for (var key in params) {
            if (params.hasOwnProperty(key)) {
                var hiddenField = document.createElement("input");
                hiddenField.setAttribute("type", "hidden");
                hiddenField.setAttribute("name", key);
                if (typeof params[key] === 'object') {
                    hiddenField.setAttribute("value", JSON.stringify(params[key]));
                } else {
                    hiddenField.setAttribute("value", params[key]);
                }
                form.appendChild(hiddenField);
            }
        }
    }
    form.target = '_blank';
    document.body.appendChild(form);
    form.submit();
    return false;
}
</script>

<div>

    <div class="container">

        <h2 style="color:#575757;"><i class="fa fa-user-times" aria-hidden="true"></i> Absent Report
            <?php echo " ".$model->startDate."  to  ".$model->endDate; ?></h2>

        <div><button style="float:right;" type="button" class="btn btn-warning"
                onclick="location.href ='<?php echo Yii::app()->getBaseUrl(true); ?>/index.php/report/findAbsenteeismDetails'"><i
                    class="glyphicon glyphicon-search"></i> Search</button></div>
        <div class="dropdown" style="float:right;margin-left:10px;margin-right:10px;">
            <button class="btn btn-warning dropdown-toggle" type="button" data-toggle="dropdown"><i
                    class="glyphicon glyphicon-download-alt"></i> Export
                <span class="caret"></span></button>
            <ul class="dropdown-menu">
                <li><a onclick="sendData()"><b><i class="glyphicon glyphicon-file"></i> PDF</b></a></li>
                <li><a onclick="sendDataExcel()"><b><i class="glyphicon glyphicon-list-alt"></i> Excel</b></a></li>
            </ul>
        </div>

        <br /><br /><br /><br />

        <div class="portlet-body yellow">
            <div style="overflow-x: auto;height: 500px;">
                <table style=" margin-left: 15px;"
                    class="table tableCompany_View-striped table-bordered table-advance table-hover">
                    <thead class="thead-inverse">
                        <tr>
                            <th>DATE</th>
                            <th>NIC</th>
                            <th>ID</th>
                            <th>NAME</th>
                            <th>SHIFT</th>
                            <th>DESIGNATION</th>
                            <th>LEAVE TYPE</th>
                            <th>SITE</th>
                            <th>DEPARTMENT</th>
                            <th>CLIENT CODE</th>
                            <th>CLIENT NAME</th>
                            <th>MP</th>
                        </tr>

                    </thead>
                    <tbody>

                        <?php  
                                            foreach($absents as $record): ?>
                        <tr>
                            <td id="date">
                                <?php 
                                            $day = new DateTime($record['StartTime']) ;

                                                echo $day->format('Y-m-d');
                                                ?>
                            </td>

                            <td id="nic">
                                <?php 
                                            $employee = Employee::model()->findByPk($record['EmployeeId']);                                                        
                                                echo $employee->nic;
                                                ?>
                            </td>

                            <td id="empid">
                                <?php 
                                                echo $employee->id;

                                                ?>
                            </td>

                            <td id="name">
                                <?php 
                                                echo $employee->Namewithini ;

                                                ?>
                            </td>

                            <td id="shift">
                                <?php echo  $record['Shift'];

                                                ?>
                            </td>

                            <td id="designation">
                                <?php 
                                                    $designation = Designation::model()->findByPk($employee->designationid); 
                                                    echo  $designation->type;

                                                ?>
                            </td>

                            <td id="leave Type">
                                <?php 
                                                   echo $record['PaidType'];

                                                ?>
                            </td>

                            <td id="site">
                                <?php $site = Sites::model()->findByPk($record['Site']); 
                                                    echo $site->name ;

                                                ?>
                            </td>
                            <td id="depart">
                                <?php $dept= Department::model()->findByPk($employee->departmentid); 
                                                    echo  $dept->name;

                                                ?>
                            </td>
                            <td id="accountId">
                                <?php 
                                                    $account = Accounts::model()->findByPk($record['Account']);
                                                    echo $account->AccountOracleCode;

                                                ?>
                            </td>
                            <td id="account">
                                <?php 
                                                    $account = Accounts::model()->findByPk($record['Account']);
                                                    echo $account->name;

                                                ?>
                            </td>

                            <td id="manpower">
                                <?php 
                                                if($employee->supplierid!=NULL){
                                                    $supplier = Supplier::model()->findByPk($employee->supplierid);
                                                    echo  $supplier->name; 

                                                }
                                                else{
                                                    echo  "------";
                                                }
                                                    
                                                    ?>
                            </td>


                        </tr>
                        <?php endforeach; ?>



                    </tbody>
                </table>
            </div>
        </div>
    </div>
</div>

<?php else: ?>
<div class="box-body">

    <div class="alert alert-info alert-dismissible">
        <h3><i class="glyphicon glyphicon-exclamation-sign"></i> Alert!</h3>
        No Absent Data is Found.
        <button style="float: right;border: 1px solid black;background-color: Transparent;" type="button"
            data-dismiss="alert" aria-hidden="true"
            onclick="location.href='<?php echo Yii::app()->getBaseUrl(true); ?>/index.php/report/findAbsenteeismDetails';"><i
                class="glyphicon glyphicon-arrow-left"></i> Back</button>
    </div>

</div>
<?php endif ?>