<?php if(!empty($teamEmployees)): ?>
<?php
$this->breadcrumbs=array(
	'Report'=>array('findRosterDetails'),
	'Roster Report',
);
echo $this->renderPartial('application.views.layouts._actions', array('model'=>$model));
?>

<style>
button:hover {
    opacity: 0.7;
}
</style>
<script type="text/javascript">
function sendData() {
    var rosterSchedule = <?php echo CJSON::encode($rosterSchedule); ?>;
    var rosterShift = <?php echo CJSON::encode($rosterShift); ?>;
    var teamEmployees = <?php echo CJSON::encode($teamEmployees) ;?>;
    var url = '<?php echo Yii::app()->createUrl('report/createRosterPDF'); ?>';
    gotoUrl(url, {
        'rosterSchedule': rosterSchedule,
        'rosterShift': rosterShift,
        'teamEmployees': teamEmployees
    });
}

function sendDataExcel() {
    var rosterSchedule = <?php echo CJSON::encode($rosterSchedule); ?>;
    var rosterShift = <?php echo CJSON::encode($rosterShift); ?>;
    var teamEmployees = <?php echo CJSON::encode($teamEmployees) ;?>;
    var url = '<?php echo Yii::app()->createUrl('report/createRosterExcel'); ?>';
    gotoUrl(url, {
        'rosterSchedule': rosterSchedule,
        'rosterShift': rosterShift,
        'teamEmployees': teamEmployees
    });
}

function gotoUrl(path, params, method) {
    //Null check
    method = method || "post"; // Set method to post by default if not specified.

    var form = document.createElement("form");
    form.setAttribute("method", method);
    form.setAttribute("action", path);

    //Fill the hidden form
    if (typeof params === 'string') {
        var hiddenField = document.createElement("input");
        hiddenField.setAttribute("type", "hidden");
        hiddenField.setAttribute("name", 'data');
        hiddenField.setAttribute("value", params);
        form.appendChild(hiddenField);
    } else {
        for (var key in params) {
            if (params.hasOwnProperty(key)) {
                var hiddenField = document.createElement("input");
                hiddenField.setAttribute("type", "hidden");
                hiddenField.setAttribute("name", key);
                if (typeof params[key] === 'object') {
                    hiddenField.setAttribute("value", JSON.stringify(params[key]));
                } else {
                    hiddenField.setAttribute("value", params[key]);
                }
                form.appendChild(hiddenField);
            }
        }
    }

    form.target = '_blank';
    document.body.appendChild(form);
    form.submit();
    return false;
}
</script>
<div>

    <div class="container">

        <h3>Roster Report on<?php echo " ".$rosterSchedule->Date; ?></h3>
        <h4><?php echo "Shift  :".$rosterShift->name; ?></h4>

        <?php
    $sDateTime = new DateTime($rosterShift->StartTime);
    $eDateTime = new DateTime($rosterShift->EndTime);                                                                                                          
    
        ?>
        <h4><?php echo 'Shift Time : '.$sDateTime->format('h:i a')."  -  ".$eDateTime->format('h:i a'); ?></h4>

        <div><button style="float:right;" type="button" class="btn btn-warning"
                onclick="location.href ='<?php echo Yii::app()->getBaseUrl(true); ?>/index.php/report/findRosterDetails'"><i
                    class="glyphicon glyphicon-search"></i> Search</button></div>

        <div class="dropdown" style="float:right;margin-left:10px;margin-right:10px;">
            <button class="btn btn-warning dropdown-toggle" type="button" data-toggle="dropdown"><i
                    class="glyphicon glyphicon-download-alt"></i> Export
                <span class="caret"></span></button>
            <ul class="dropdown-menu">
                <li><a onclick="sendData()"><b><i class="glyphicon glyphicon-file"></i> PDF</b></a></li>
                <li><a onclick="sendDataExcel()"><b><i class="glyphicon glyphicon-list-alt"></i> Excel</b></a></li>
            </ul>
        </div>

        <br /><br /><br /><br />
        <div class="panel panel-warning">

            <div class="panel-heading">
                <i class="glyphicon glyphicon-user"></i>
                Roster Employee Details

            </div>

            <div class="panel-body ">

                <div class="portlet-body" style="overflow-x: auto;height: 500px;">

                    <table class="table table-striped">
                        <thead class="thead-inverse">
                            <tr>
                                <th>TEAM</th>
                                <th>NIC</th>
                                <th>EMPLOYEE ID</th>
                                <th>NAME</th>
                                <th>SITE</th>
                                <th>CLIENT CODE</th>
                                <th>CLIENT NAME</th>
                            </tr>

                        </thead>
                        <tbody>

                            <?php  foreach ($teamEmployees as $key=> $employees):
                                            foreach ($employees as $employee): ?>
                            <tr>
                                <td id="team">
                                    <?php
                                            $teamData = Team::model()->findByPk($key);                                                         
                                            echo $teamData->name;
                                            ?>

                                </td>
                                <?php 

                                        ?>

                                <td id="nic">
                                    <?php                                                         
                                                echo $employee->nic;
                                            ?>
                                </td>

                                <td id="empid">
                                    <?php 
                                        echo $employee->id;
                                        //echo $employee->contact;

                                            ?>
                                </td>

                                <td id="name">
                                    <?php 
                                        
                                                echo $employee->Namewithini;

                                            ?>
                                </td>

                                <td id="site">
                                    <?php 
                                        $site = Sites::model()->findByPk($employee->siteid);
                                                echo $site->name;

                                            ?>
                                </td>
                                <td id="accountId">
                                    <?php 
                                        $account = Accounts::model()->findByPk($employee->Accountid);
                                                echo $account->AccountOracleCode;

                                            ?>
                                </td>

                                <td id="account">
                                    <?php 
                                        $account = Accounts::model()->findByPk($employee->Accountid);
                                                echo $account->name;

                                            ?>
                                </td>


                            </tr>
                            <?php endforeach; ?>
                            <?php endforeach; ?>

                        </tbody>
                    </table>
                </div>
            </div>

        </div>
    </div>
</div>

<?php else: ?>
<div class="box-body">

    <div class="alert alert-info alert-dismissible">
        <h3><i class="glyphicon glyphicon-exclamation-sign"></i> Alert!</h3>
        No Roster Data is Found.
        <button style="float: right;border: 1px solid black;background-color: Transparent;" type="button"
            data-dismiss="alert" aria-hidden="true"
            onclick="location.href='<?php echo Yii::app()->getBaseUrl(true); ?>/index.php/report/findAbsenteeismDetails';"><i
                class="glyphicon glyphicon-arrow-left"></i> Back</button>
    </div>

</div>
<?php endif ?>
<style>
.panel-warning>.panel-heading {
    color: #ffffff;
    background-color: #f79727;
}
</style>