<?php $form=$this->beginWidget('bootstrap.widgets.TbActiveForm',array(
	'id'=>'sku-salary-form',
	'enableAjaxValidation'=>false,
)); ?>

<p class="help-block">Fields with <span class="required">*</span> are required.</p>
<div class="portlet box yellow">
    <?php echo $form->errorSummary($model); ?>
    <div class="portlet-title">
        <div class="caption">
            <i class="icon-reorder"></i>
        </div>
        <div class="tools">
            <a href="#" class="collapse"></a>
            <a href="#portlet-config" data-toggle="modal" class="config"></a>
            <a href="#" class="reload"></a>
            <a href="#" class="remove"></a>
        </div>
    </div>
    <div class="portlet-body form">
        <form role="form">
            <div class="form-body">
                <div class="row">
                    <div class="form-group col-md-6">
                        <label class="control-label">SKU Type</label>
                        <div class="input-group">
                            <span class="input-group-addon">
                                <i class="glyphicon glyphicon-tags"></i>
                            </span>
                            <select name="SkuSalary[sku_id]" class="form-control select2me"
                                id="Timelog_Employeeid" data-placeholder="Select..." onchange="loadData(this.value)">
                                <option value="-1"></option>
                                <?php foreach ($Sku as $sk): ?>
                                <option value="<?php echo $sk->id; ?>">
                                    <?php echo $sk->name; ?>(<?php echo $sk->description; ?>)</option>
                                <?php endforeach; ?>
                            </select>
                        </div>
                        
                    </div>
                    <div class="form-group col-md-6">
                        <?php echo $form->textFieldRow($model,'basic_plus_bra',array('class'=>'form-control','maxlength'=>20,'disabled'=>'true')); ?>
                    </div>
                </div>
                <div class="row">


                    <div class="form-group col-md-2">
                        <?php echo $form->textFieldRow($model,'basic',array('autocomplete' => 'off','class' => 'form-control','onkeyup'=>"setTotalSalary('Monthly')")); ?>
                    </div>

                    <div class="form-group col-md-2">
                        <?php echo $form->textFieldRow($model,'BRA1',array('autocomplete' => 'off','class' => 'form-control','onkeyup'=>"setTotalSalary('Monthly')")); ?>
                    </div>

                    <div class="form-group col-md-2">
                        <?php echo $form->textFieldRow($model,'BRA2',array('autocomplete' => 'off','class' => 'form-control','onkeyup'=>"setTotalSalary('Monthly')")); ?>
                    </div>

                    <div class="form-group col-md-2">
                        <?php echo $form->textFieldRow($model,'BRA3',array('autocomplete' => 'off','class' => 'form-control','onkeyup'=>"setTotalSalary('Monthly')")); ?>
                    </div>
                    <div class="form-group col-md-2">
                        <?php echo $form->textFieldRow($model,'contract_fee',array('autocomplete' => 'off','class' => 'form-control')); ?>
                    </div>
                    <div class="form-group col-md-2">
                        <?php echo $form->textFieldRow($model,'mp_agent_rate',array('autocomplete' => 'off','class' => 'form-control')); ?>
                    </div>

                </div>




                <div class="form-group" style="display:none;">
                    <?php echo $form->textFieldRow($model,'CreatedBy',array('class'=>'form-control')); ?>
                </div>

                <div class="form-group" style="display:none;">
                    <?php echo $form->textFieldRow($model,'CreatedOn',array('class'=>'form-control')); ?>
                </div>

                <div class="form-group" style="display:none;">
                    <?php echo $form->textFieldRow($model,'Status',array('class'=>'form-control')); ?>
                </div>



                <div class="form-group" style="display:none;">
                    <?php echo $form->textFieldRow($model,'site_id',array('class'=>'form-control')); ?>
                </div>

            </div>
            <div class="form-actions">
                <?php $this->widget('bootstrap.widgets.TbButton', array(
			'buttonType'=>'submit',
			'type'=>'primary',
			'label'=>$model->isNewRecord ? 'Create' : 'Save',
                        'htmlOptions'   => array('class'=>'btn yellow'),
		)); ?>
            </div>
        </form>
    </div>
</div>

<?php $this->endWidget(); ?>
<script>
function loadData(skuId) {
    $.ajax({
        type: 'POST',
        url: '<?php echo Yii::app()->createUrl('SkuSalary/GetSalary'); ?>',
        data: {
            skuId: skuId
        },
        dataType: 'json',
        success: function(result) {

            $('#SkuSalary_basic_plus_bra').val(result.basic_plus_bra);
            $('#SkuSalary_basic').val(result.basic);
            $('#SkuSalary_BRA1').val(result.BRA1);
            $('#SkuSalary_BRA2').val(result.BRA2);
            $('#SkuSalary_BRA3').val(result.BRA3);
            $('#SkuSalary_contract_fee').val(result.contract_fee);
            $('#SkuSalary_mp_agent_rate').val(result.mp_agent_rate);

        },
        error: function(data) {

        }
    });
    $.ajax({
        type: 'POST',
        url: '<?php echo Yii::app()->createUrl('SkuSalary/GetSiteId'); ?>',
        data: {
            skuId: skuId
        },
        dataType: 'json',
        success: function(result) {
            $('#SkuSalary_site_id').val(result.siteId);
        },
        error: function(data) {

        }
    });

}

function setTotalSalary(type) {
    if (type == 'Monthly') {
        var basic = parseFloat(document.getElementById('SkuSalary_basic').value)
        var BRA1 = parseFloat(document.getElementById('SkuSalary_BRA1').value)
        var BRA2 = parseFloat(document.getElementById('SkuSalary_BRA2').value)
        var BRA3 = parseFloat(document.getElementById('SkuSalary_BRA3').value)

        var basic = isNaN(basic) ? 0 : basic
        var BRA1 = isNaN(BRA1) ? 0 : BRA1
        var BRA2 = isNaN(BRA2) ? 0 : BRA2
        var BRA3 = isNaN(BRA3) ? 0 : BRA3


        let ttl = basic + BRA1 + BRA2 + BRA3

        $('#SkuSalary_basic_plus_bra').val(ttl.toFixed(5));
    }

}
</script>