<?php
$this->breadcrumbs=array(
	'Report'=>array('CreateDailyWorkingHoursReport'),
	'Daily Working Hours Report',
);
?>

<style>
#td_1 {
    border: 1px solid #ddd;
    text-align: left;
    padding: 15px;
}

#table_1 {
    border: 1px solid #ddd;
    text-align: left;
    border-collapse: collapse;
    width: 100%;
}
</style>
<script type="text/javascript">
function sendData() {

    var list = <?php echo CJSON::encode($list);?>;
    var model = <?php echo CJSON::encode($model);?>;
    var url = '<?php echo Yii::app()->createUrl('report/DailyWorkingHoursReportPdf'); ?>';
    gotoUrl(url, {
        'list': list,
        'model': model
    });

}

function sendExcel() {

    var list = <?php echo CJSON::encode($list);?>;
    var model = <?php echo CJSON::encode($model);?>;
    var url = '<?php echo Yii::app()->createUrl('report/DailyWorkingHoursReportExcel'); ?>';
    gotoUrl(url, {
        'list': list,
        'model': model
    });

}

function gotoUrl(path, params, method) {
    //Null check
    method = method || "post"; // Set method to post by default if not specified.

    var form = document.createElement("form");
    form.setAttribute("method", method);
    form.setAttribute("action", path);

    //Fill the hidden form
    if (typeof params === 'string') {
        var hiddenField = document.createElement("input");
        hiddenField.setAttribute("type", "hidden");
        hiddenField.setAttribute("name", 'data');
        hiddenField.setAttribute("value", params);
        form.appendChild(hiddenField);
    } else {
        for (var key in params) {
            if (params.hasOwnProperty(key)) {
                var hiddenField = document.createElement("input");
                hiddenField.setAttribute("type", "hidden");
                hiddenField.setAttribute("name", key);
                if (typeof params[key] === 'object') {
                    hiddenField.setAttribute("value", JSON.stringify(params[key]));
                } else {
                    hiddenField.setAttribute("value", params[key]);
                }
                form.appendChild(hiddenField);
            }
        }
    }
    form.target = '_blank';
    document.body.appendChild(form);
    form.submit();
    return false;
}
</script>

<?php if(!empty($list)): ?>

<?php if($model['tag']==1): ?>
<h3>Daily Working Hours Report </h3>
<?php else: ?>
<h3>Working Hours Report </h3>
<?php endif ?>

<div class="row">

    <?php if($model['tag']==1): ?>
    <button style="float: right;margin: 15px;" class="btn btn-warning" type="button"
        onclick="location.href='<?php echo Yii::app()->getBaseUrl(true); ?>/index.php/report/createDailyWorkingHoursReport';">
        <i class="glyphicon glyphicon-search"></i> Search
    </button>
    <?php else: ?>
    <button style="float: right;margin: 15px;" class="btn btn-warning" type="button"
        onclick="location.href='<?php echo Yii::app()->getBaseUrl(true); ?>/index.php/report/createWorkingHoursReport';">
        <i class="glyphicon glyphicon-search"></i> Search
    </button>
    <?php endif ?>

    <div class="dropdown" style="float: right;margin: 15px;">
        <button class="btn btn-warning dropdown-toggle" type="button" data-toggle="dropdown"><i
                class="glyphicon glyphicon-download-alt"></i> Export
            <span class="caret"></span></button>
        <ul class="dropdown-menu">
            <li><a onclick=sendData()><i class="glyphicon glyphicon-file"></i><strong> PDF </strong></a></li>
            <li><a onclick=sendExcel()><i class="glyphicon glyphicon-list-alt"></i><strong> Excel </strong></a></li>
        </ul>
    </div>
</div>

<h5><strong>From :- <?php echo $model['startDate'] .'  To :-'. $model['endDate'];?></strong></h5>

<div class="portlet box yellow">
    <div class="portlet-title">
        <?php if($model['tag']==1): ?>
        <div class="caption"><i class="fa fa-id-card" aria-hidden="true"></i>Daily working hours details</div>
        <?php else: ?>
        <div class="caption"><i class="fa fa-id-card" aria-hidden="true"></i>Working hours details</div>
        <?php endif ?>

        <div class="tools">
            <a href="javascript:;" class="reload"></a>
            <a href="javascript:;" class="remove"></a>
        </div>
    </div>
    <div class="portlet-body" style="overflow-x: auto;height: 500px;">
        <table class="table table-striped table-bordered table-hover" id="table_1">
            <thead>
                <tr>
                    <th>NAME</th>
                    <th>NIC</th>
                    <th>DESIGNATION</th>
                    <th>CLIENT CODE</th>
                    <th>CLINET NAME</th>
                    <th>DEPARTMENT</th>
                    <th>IN TIME</th>
                    <th>OUT TIME</th>
                    <th>HOURS(HRS)</th>


                </tr>
            </thead>
            <tbody>
                <?php foreach ($list as $list): ?>

                <tr>
                    <td><?php echo $list['Name']; ?></td>
                    <td><?php echo $list['NIC']; ?></td>
                    <td><?php echo $list['Designation']; ?></td>
                    <td><?php echo $list['accountId']; ?></td>
                    <td><?php echo $list['Account']; ?></td>
                    <td><?php echo $list['department']; ?></td>
                    <td><?php echo $list['StartTime']; ?></td>
                    <td><?php echo $list['EndTime']; ?></td>
                    <td><?php echo Yii::app()->commonUtil->convertToHoursMins($list['Hours']); ?></td>
                </tr>
                <?php endforeach; ?>

            </tbody>
        </table>
    </div>
</div>
<?php else: ?>
<div class="box-body">

    <div class="alert alert-info alert-dismissible">
        <h3><i class="glyphicon glyphicon-exclamation-sign"></i> Alert!</h3>
        No Attendance Report Found.

        <?php if($model['tag']==1): ?>
        <button style="float: right;border: 1px solid black;background-color: Transparent;" type="button"
            data-dismiss="alert" aria-hidden="true"
            onclick="location.href='<?php echo Yii::app()->getBaseUrl(true); ?>/index.php/report/createDailyWorkingHoursReport';"><i
                class="glyphicon glyphicon-arrow-left"></i> Back
        </button>
        <?php else: ?>
        <button style="float: right;border: 1px solid black;background-color: Transparent;" type="button"
            data-dismiss="alert" aria-hidden="true"
            onclick="location.href='<?php echo Yii::app()->getBaseUrl(true); ?>/index.php/report/createWorkingHoursReport';"><i
                class="glyphicon glyphicon-arrow-left"></i> Back
        </button>
        <?php endif ?>

    </div>

</div>
<?php endif ?>