<?php
$this->breadcrumbs = array(
    'Report' => array('WorkingHoursTrackingReport'),
    'Working Hours Tracking Report',
);
?>

<style>
    #td_1 {    
        border: 1px solid #ddd;
        text-align: left;
        padding: 15px;
    }

    #table_1 {
        border: 1px solid #ddd;
        text-align: left;
        border-collapse: collapse;

    }
    .supplierTd{
        text-align: center;
        text-transform: uppercase;
        color: #bf0441;
        font-size: 16px;
        font-weight: bold;
    }

</style>
<script>
    function sendExcel() {

        var list = <?php echo CJSON::encode($list); ?>;
        var rangeOfDates = <?php echo CJSON::encode($rangeOfDates); ?>;
        var url = '<?php echo Yii::app()->createUrl('report/WorkingHoursTrackingReportExcel'); ?>';
        gotoUrl(url, {'list': list, 'rangeOfDates': rangeOfDates});

    }

    function gotoUrl(path, params, method) {
        //Null check
        method = method || "post"; // Set method to post by default if not specified.

        var form = document.createElement("form");
        form.setAttribute("method", method);
        form.setAttribute("action", path);

        //Fill the hidden form
        if (typeof params === 'string') {
            var hiddenField = document.createElement("input");
            hiddenField.setAttribute("type", "hidden");
            hiddenField.setAttribute("name", 'data');
            hiddenField.setAttribute("value", params);
            form.appendChild(hiddenField);
        } else {
            for (var key in params) {
                if (params.hasOwnProperty(key)) {
                    var hiddenField = document.createElement("input");
                    hiddenField.setAttribute("type", "hidden");
                    hiddenField.setAttribute("name", key);
                    if (typeof params[key] === 'object') {
                        hiddenField.setAttribute("value", JSON.stringify(params[key]));
                    } else {
                        hiddenField.setAttribute("value", params[key]);
                    }
                    form.appendChild(hiddenField);
                }
            }
        }
        form.target = '_blank';
        document.body.appendChild(form);
        form.submit();
        return false;
    }
</script>

<?php if (!empty($list)): ?>


    <h3>WorkingHoursTrackingReport</h3>


    <div class = "row">


        <button  style="float: right;margin: 15px;" class="btn btn-warning" type="button"  onclick="location.href = '<?php echo Yii::app()->getBaseUrl(true); ?>/index.php/report/CreateWorkingHoursTrackingReport';">
            <i class="glyphicon glyphicon-search"></i>  Search
        </button>


        <div class="dropdown" style="float: right;margin: 15px;">
            <button  class="btn btn-warning dropdown-toggle" type="button" data-toggle="dropdown"><i class="glyphicon glyphicon-download-alt"></i>  Export
                <span class="caret"></span></button>
            <ul class="dropdown-menu">
                <li><a onclick=sendExcel()><i class="glyphicon glyphicon-list-alt"></i><strong>  Excel  </strong></a></li>
            </ul>
        </div>
    </div>


    <div  style="max-height: 500px;overflow: scroll;">
        
        <div class="portlet-body">
            <table class="table table-striped table-bordered table-hover" id="table_1">
                <thead>
                    <tr>
                        <th>EMPID</th>
                        <th>NAME</th>
                        <th>NIC</th>
                        <th>CLIENT CODE</th>
                        <th>CLIENT NAME</th>
                        <? foreach($rangeOfDates as $range):?>
                            <th><?= $range ?></th>
                        <? endforeach; ?>
                        <th>TOTAL</th>  
                    </tr>
                </thead>

                <!-- ===if change the column in the report change the colspan count also=== -->
                <?$clospan = count($rangeOfDates)+4 ?>
                <tbody>
                    <?php for ($i = 0; $i < count($list); $i++): ?>
                        <?php if ($i == 0): ?>
                            <? $supplier = $list[$i]['Supplier']; ?>
                            <tr> <td colspan= <?= $clospan ?> ><span class="supplierTd"><?= $supplier ?></span></td> </tr>
                        <?php endif; ?>

                        <?php if ($supplier == $list[$i]['Supplier']): ?>
                            <tr>
                                <td><?php echo $list[$i]['Id']; ?></td>
                                <td><?php echo $list[$i]['Name']; ?></td>
                                <td><?php echo $list[$i]['NIC']; ?></td>
                                <td><?php echo $list[$i]['accountId']; ?></td>
                                <td><?php echo $list[$i]['Account']; ?></td>
                                <? foreach($rangeOfDates as $range):?>
                                    <?if(array_key_exists($range, $list[$i])):?>
                                        <td><?php echo $list[$i][$range]; ?></td>
                                    <? else:?>
                                        <td></td>
                                    <? endif ?>
                                <? endforeach; ?>
                                <td><?php echo $list[$i]['total']; ?></td>
                            </tr>
                        <?php else: ?>
                            <? $supplier = $list[$i]['Supplier']; ?>
                            <tr> <td colspan= <?= $clospan ?> ><span class="supplierTd"><?= $supplier ?></span></td> </tr>


                            <tr>
                                <td><?php echo $list[$i]['Id']; ?></td>
                                <td><?php echo $list[$i]['Name']; ?></td>
                                <td><?php echo $list[$i]['NIC']; ?></td>
                                <td><?php echo $list[$i]['accountId']; ?></td>
                                <td><?php echo $list[$i]['Account']; ?></td>
                                <? foreach($rangeOfDates as $range):?>
                                    <?if(array_key_exists($range, $list[$i])):?>
                                        <td><?php echo $list[$i][$range]; ?></td>
                                    <? else:?>
                                        <td></td>
                                    <? endif ?>
                                <? endforeach; ?>
                                <td><?php echo $list[$i]['total']; ?></td>
                            </tr>
                        <?php endif; ?>

                    <?php endfor; ?>

                </tbody>
            </table>
        </div>
    </div>
<?php else: ?>
    <div class="box-body">

        <div class="alert alert-info alert-dismissible">
            <h3><i class="glyphicon glyphicon-exclamation-sign"></i>  Alert!</h3>
            No  Report Found.


            <button style="float: right;border: 1px solid black;background-color: Transparent;" type="button" data-dismiss="alert" aria-hidden="true" 
                    onclick="location.href = '<?php echo Yii::app()->getBaseUrl(true); ?>/index.php/report/CreateWorkingHoursTrackingReport';"><i class = "glyphicon glyphicon-arrow-left"></i> Back
            </button>


        </div>

    </div>
<?php endif ?>


