<?php if(!empty($finalResult)) :?>

<?php
$this->breadcrumbs=array(
	'Reports'=>array('findAttendanceSummaryDetails'),
	'Attendance Summary',
);
echo $this->renderPartial('application.views.layouts._actions', array('model'=>$model));
?>
<script type="text/javascript">
function sendData() {
    var finalResult = <?php echo CJSON::encode($finalResult); ?>;
    var model = <?php echo CJSON::encode($model); ?>;
    var url = '<?php echo Yii::app()->createUrl('report/createAttendanceSummaryPDF'); ?>';
    gotoUrl(url, {
        'finalResult': finalResult,
        'model': model
    });
}

function sendDataExcel() {
    var finalResult = <?php echo CJSON::encode($finalResult); ?>;
    var model = <?php echo CJSON::encode($model); ?>;
    var url = '<?php echo Yii::app()->createUrl('report/createAttendanceSummaryExcel'); ?>';
    gotoUrl(url, {
        'finalResult': finalResult,
        'model': model
    });
}

function gotoUrl(path, params, method) {
    //Null check
    method = method || "post"; // Set method to post by default if not specified.

    var form = document.createElement("form");
    form.setAttribute("method", method);
    form.setAttribute("action", path);

    //Fill the hidden form
    if (typeof params === 'string') {
        var hiddenField = document.createElement("input");
        hiddenField.setAttribute("type", "hidden");
        hiddenField.setAttribute("name", 'data');
        hiddenField.setAttribute("value", params);
        form.appendChild(hiddenField);
    } else {
        for (var key in params) {
            if (params.hasOwnProperty(key)) {
                var hiddenField = document.createElement("input");
                hiddenField.setAttribute("type", "hidden");
                hiddenField.setAttribute("name", key);
                if (typeof params[key] === 'object') {
                    hiddenField.setAttribute("value", JSON.stringify(params[key]));
                } else {
                    hiddenField.setAttribute("value", params[key]);
                }
                form.appendChild(hiddenField);
            }
        }
    }

    form.target = '_blank';
    document.body.appendChild(form);
    form.submit();
    return false;
}
</script>

<div>

    <div class="container">

        <h2 style="color:#575757;"><i class="fa fa-calendar" aria-hidden="true"></i> Attendance Summary Report from <?php 
   
    echo $model['startDate']." - ".$model['endDate']; ?></h2>
        <h3 style="color:#575757;"> Site : <?php 
            $site = Sites::model()->findByPk($model['site']);
            echo $site->name; ?> </h3>
        <hr>
        <div><button style="float:right;" type="button" class="btn btn-warning"
                onclick="location.href ='<?php echo Yii::app()->getBaseUrl(true); ?>/index.php/report/findAttendanceSummaryDetails'"><i
                    class="glyphicon glyphicon-search"></i> Search</button></div>
        <div class="dropdown" style="float:right;margin-left:10px;margin-right:10px;">
            <button class="btn btn-warning dropdown-toggle" type="button" data-toggle="dropdown"><i
                    class="glyphicon glyphicon-download-alt"></i> Export
                <span class="caret"></span></button>
            <ul class="dropdown-menu">
                <li><a onclick="sendData()"><b><i class="glyphicon glyphicon-file"></i> PDF</b></a></li>
                <li><a onclick="sendDataExcel()"><b><i class="glyphicon glyphicon-list-alt"></i> Excel</b></a></li>
            </ul>
        </div>

        <br /><br /><br /><br />

        <div class="portlet-body" style="overflow-x: auto; height:500px;">
            <div>
                <table style=" margin-left: 15px;"
                    class="table tableCompany_View-striped table-bordered table-advance table-hover">
                    <thead class="thead-inverse">
                        <tr>
                            <th>NIC</th>
                            <th>ID</th>
                            <th>NAME</th>
                            <th>DESIGNATION</th>
                            <th>PRESENT DAYS</th>
                            <th>ABSENT DAYS</th>
                            <th>WORKED HOUR</th>
                            <th>IN LATE DEDUCT(HRS.)</th>
                            <th>EARLY OUT DEDUCT(HRS.)</th>
                            <th>NORMAL OT (HRS.)</th>
                            <th>DOUBLE OT (HRS.)</th>
                            <th>TRIPLE OT (HRS.)</th>
                            <th>TOTAL OT (HRS.)</th>
                            <th>NO-PAY DAYS</th>
                            <th>WORKED SUNDAYs</th>
                            <th>CLIENT CODE</th>
                            <th>CLIENT NAME</th>
                            <th>DEPARTMENT</th>
                            <th>PAYMENT METHOD</th>

                        </tr>

                    </thead>
                    <tbody>

                        <?php  
                                    foreach($finalResult as $final): ?>
                        <tr>
                            <td><?php $employee = Employee::model()->findByPk($final['EmployeeId']);                                                        
                                            echo $employee->nic;
                                        ?>
                            </td>
                            <td><?php echo $employee->id;?></td>
                            <td><?php echo $employee->Namewithini;?></td>
                            <td><?php echo $final['designation'];?></td>
                            <td><?php echo $final['PresentDays']  ; ?></td>
                            <td><?php echo $final['AbsentDays']  ;?></td>
                            <td>
                                <?php
                                        if($final['WorkedHour']==NULL) 
                                            echo "-";
                                        else                                           
                                            echo Yii::app()->commonUtil->convertToHoursMins($final['WorkedHour']) ;    
                                        ?>
                            </td>
                            <td><?php echo Yii::app()->commonUtil->convertToHoursMins($final['Hourgap'])  ;?></td>
                            <td><?php echo Yii::app()->commonUtil->convertToHoursMins($final['OutLateHrs']) ;?></td>
                            
                            <td>
                                <?php
                                        if($final['NOTHrs']==NULL) 
                                            echo "-";
                                        else                                           
                                            echo Yii::app()->commonUtil->convertToHoursMins($final['NOTHrs']) ;    
                                        ?>
                            </td>
                            <td>
                                <?php  
                                        if($final['DOTHrs']==NULL) 
                                                echo "-";
                                            else                                            
                                            echo Yii::app()->commonUtil->convertToHoursMins($final['DOTHrs'])  ;    
                                        ?>
                            </td>
                            <td>
                                <?php  
                                        if($final['TOTHrs']==NULL) 
                                                echo "-";
                                            else                                            
                                            echo Yii::app()->commonUtil->convertToHoursMins($final['TOTHrs'] ) ;    
                                        ?>
                            </td>
                            <td>
                                <?php 
                                        if($final['TotOTHrs']==NULL) 
                                            echo "-";
                                        else                                             
                                            echo Yii::app()->commonUtil->convertToHoursMins($final['TotOTHrs'])  ;    
                                        ?>
                            </td>
                            <td> <?php echo Yii::app()->commonUtil->convertToHoursMins($final['NoPayCount'])  ; ?></td>
                            <td><?php echo Yii::app()->commonUtil->convertToHoursMins($final['SundaysWork'] ) ;?></td>
                            <td><?php $account = Accounts::model()->findByPk($employee->Accountid);                                            
                echo $account->AccountOracleCode;    
                ?>
                            </td>
                            <td><?php $account = Accounts::model()->findByPk($employee->Accountid);                                            
                                        echo $account->name;    
                                        ?>
                            </td>
                            <td><?php $dept= Department::model()->findByPk($employee->departmentid); 
                                        echo  $dept->name;

                                        ?>
                            </td>
                            <td><?php $patmentMethod = Paymentmethod::model()->findByPk($employee->paymentmethodid);                                      
                                        echo $patmentMethod->type;    
                                        ?>
                            </td>

                        </tr>
                        <?php endforeach; ?>


                    </tbody>
                </table>
            </div>
        </div>

    </div>
</div>

<?php else: ?>
<div class="box-body">

    <div class="alert alert-info alert-dismissible">
        <h3><i class="glyphicon glyphicon-exclamation-sign"></i> Alert!</h3>
        No Data is Found.
        <button style="float: right;border: 1px solid black;background-color: Transparent;" type="button"
            data-dismiss="alert" aria-hidden="true"
            onclick="location.href='<?php echo Yii::app()->getBaseUrl(true); ?>/index.php/report/findAttendanceSummaryDetails';"><i
                class="glyphicon glyphicon-arrow-left"></i> Back</button>
    </div>

</div>
<?php endif ?>