<?php if(!empty($invalidEmployees)): ?>

<?php
$this->breadcrumbs=array(
	'Report'=>array('findInvalidAttendanceDetails'),
	'Invalid Attendance Report',
);
echo $this->renderPartial('application.views.layouts._actions', array('model'=>$model));
?>
<script type="text/javascript">
function sendData() {
    var model = <?php echo CJSON::encode($model); ?>;
    var invalidEmployees = <?php echo CJSON::encode($invalidEmployees) ;?>;
    var url = '<?php echo Yii::app()->createUrl('report/CreateInvalidAttendancePdf'); ?>';
    gotoUrl(url, {
        'model': model,
        'invalidEmployees': invalidEmployees
    });
}

function sendDataExcel() {
    var model = <?php echo CJSON::encode($model); ?>;
    var invalidEmployees = <?php echo CJSON::encode($invalidEmployees) ;?>;
    var url = '<?php echo Yii::app()->createUrl('report/createInvalidAttendanceExcel'); ?>';
    gotoUrl(url, {
        'model': model,
        'invalidEmployees': invalidEmployees
    });
}

function gotoUrl(path, params, method) {
    //Null check
    method = method || "post"; // Set method to post by default if not specified.

    var form = document.createElement("form");
    form.setAttribute("method", method);
    form.setAttribute("action", path);

    //Fill the hidden form
    if (typeof params === 'string') {
        var hiddenField = document.createElement("input");
        hiddenField.setAttribute("type", "hidden");
        hiddenField.setAttribute("name", 'data');
        hiddenField.setAttribute("value", params);
        form.appendChild(hiddenField);
    } else {
        for (var key in params) {
            if (params.hasOwnProperty(key)) {
                var hiddenField = document.createElement("input");
                hiddenField.setAttribute("type", "hidden");
                hiddenField.setAttribute("name", key);
                if (typeof params[key] === 'object') {
                    hiddenField.setAttribute("value", JSON.stringify(params[key]));
                } else {
                    hiddenField.setAttribute("value", params[key]);
                }
                form.appendChild(hiddenField);
            }
        }
    }

    form.target = '_blank';
    document.body.appendChild(form);
    form.submit();
    return false;
}
</script>


<style>
td {
    max-width: 170px;
}
</style>


<div>
    <div class="container">

        <h2 style="color:#575757;"><i class="fa fa-exclamation-triangle" aria-hidden="true"></i> Invalid Attendance
            Report From : <?php echo $model->startDate." "; ?> To : <?php echo " ".$model->endDate; ?> </h2>

        <hr>
        <div><button style="float:right;" type="button" class="btn btn-warning"
                onclick="location.href ='<?php echo Yii::app()->getBaseUrl(true); ?>/index.php/report/findInvalidAttendanceDetails'"><i
                    class="glyphicon glyphicon-search"></i> Search</button></div>
        <div class="dropdown" style="float:right;margin-left:10px;margin-right:10px;">
            <button class="btn btn-warning dropdown-toggle" type="button" data-toggle="dropdown"><i
                    class="glyphicon glyphicon-download-alt"></i> Export
                <span class="caret"></span></button>
            <ul class="dropdown-menu">
                <li><a onclick="sendData()"><b><i class="glyphicon glyphicon-file"></i> PDF</b></a></li>
                <li><a onclick="sendDataExcel()"><b><i class="glyphicon glyphicon-list-alt"></i> Excel</b></a></li>
            </ul>
        </div>

        <br /><br /><br /><br />

        <div class="portlet-body">
            <div style="overflow-x: auto;height: 500px;">
                <table style=" margin-left: 15px;"
                    class="table tableCompany_View-striped table-bordered table-advance table-hover">
                    <thead class="thead-inverse">
                        <tr>
                            <th>DATE</th>
                            <th>NIC</th>
                            <th>ID</th>
                            <th>NAME</th>
                            <th>IN PUNCH TIME</th>
                            <th>OUT PUNCH TIME</th>
                            <th>SITE</th>
                            <th>CLIENT CODE</th>
                            <th>CLIENT NAME</th>
                            <th>DEPT.</th>
                            <th>MP</th>
                        </tr>

                    </thead>
                    <tbody>

                        <?php  
                            foreach($invalidEmployees as $invalidEmployee): ?>

                        <tr>

                            <td id="date">
                                <?php 
                                    echo $invalidEmployee['date'] ;

                                    ?>
                            </td>

                            <td id="nic">
                                <?php 
                            $employee = Employee::model()->findByPk($invalidEmployee['EmployeeId']);                                                        
                                    echo $employee->nic;
                                ?>
                            </td>

                            <td id="empid">
                                <?php 
                                echo $employee->id;
                            ?>
                            </td>

                            <td id="name">
                                <?php 
                                echo $employee->FirstName;

                                ?>
                            </td>

                            <td style="text-align:center" id="INpunchtime" style="overflow-x:auto;">
                                <?php 
                                    if($invalidEmployee['Intime']!='0000-00-00 00:00:00')
                                        echo $invalidEmployee['Intime'];                                                    
                                    else
                                        echo '-----';
                                    
                                

                                ?>

                            </td>

                            <td style="text-align:center" id="Outpunchtime" style="overflow-x:auto;">

                                <?php
                                    if($invalidEmployee['OuteTime']!='0000-00-00 00:00:00') 
                                        echo $invalidEmployee['OuteTime']; 
                                    else
                                        echo '-----';

                                ?>
                            </td>
                            <td id="site">
                                <?php 
                                    $site = Sites::model()->findByPk($employee->siteid);
                                    echo  $site->name; 

                                    ?>
                            </td>

                            <td id="accountId">
                                <?php 
                                    $account = Accounts::model()->findByPk($employee->Accountid);
                                    echo  $account->AccountOracleCode; 

                                    ?>
                            </td>

                            <td id="account">
                                <?php 
                                    $account = Accounts::model()->findByPk($employee->Accountid);
                                    echo  $account->name; 

                                    ?>
                            </td>
                            <td id="depart">
                                <?php $dept= Department::model()->findByPk($employee->departmentid); 
                                        echo  $dept->name;

                                    ?>
                            </td>

                            <td id="manpower">
                                <?php 
                                    $mp = Supplier::model()->findByPk($employee->supplierid);
                                    echo  $mp['name']; 

                                ?>
                            </td>
                        </tr>
                        <?php endforeach; ?>
                    </tbody>
                </table>
            </div>

        </div>
    </div>
</div>

<?php else: ?>
<div class="box-body">
    <div class="alert alert-info alert-dismissible">
        <h3><i class="glyphicon glyphicon-exclamation-sign"></i> Alert!</h3>
        No Invalid Attendance Data is Found.
        <button style="float: right;border: 1px solid black;background-color: Transparent;" type="button"
            data-dismiss="alert" aria-hidden="true"
            onclick="location.href='<?php echo Yii::app()->getBaseUrl(true); ?>/index.php/report/findInvalidAttendanceDetails';"><i
                class="glyphicon glyphicon-arrow-left"></i> Back</button>
    </div>
</div>
<?php endif ?>