<?php
$this->breadcrumbs=array(
	'Report'=>array('AttendanceRange'),
	'View Range',
);
?>

<style>
#td_1 {
    border: 1px solid #ddd;
    text-align: left;
    padding: 15px;
}

#table_1 {
    border: 1px solid #ddd;
    text-align: left;
    border-collapse: collapse;
    width: 100%;
}
</style>
<script type="text/javascript">

function sendExcel() {

    var lists = <?php echo CJSON::encode($lists);?>;
    var model = <?php echo CJSON::encode($model);?>;
    var url = '<?php echo Yii::app()->createUrl('report/AllAttendanceWithAbsentExcel'); ?>';
    gotoUrl(url, {
        'lists': lists,
        'model': model
    });

}

function gotoUrl(path, params, method) {
    //Null check
    method = method || "post"; // Set method to post by default if not specified.

    var form = document.createElement("form");
    form.setAttribute("method", method);
    form.setAttribute("action", path);

    //Fill the hidden form
    if (typeof params === 'string') {
        var hiddenField = document.createElement("input");
        hiddenField.setAttribute("type", "hidden");
        hiddenField.setAttribute("name", 'data');
        hiddenField.setAttribute("value", params);
        form.appendChild(hiddenField);
    } else {
        for (var key in params) {
            if (params.hasOwnProperty(key)) {
                var hiddenField = document.createElement("input");
                hiddenField.setAttribute("type", "hidden");
                hiddenField.setAttribute("name", key);
                if (typeof params[key] === 'object') {
                    hiddenField.setAttribute("value", JSON.stringify(params[key]));
                } else {
                    hiddenField.setAttribute("value", params[key]);
                }
                form.appendChild(hiddenField);
            }
        }
    }
    form.target = '_blank';
    document.body.appendChild(form);
    form.submit();
    return false;
}
</script>

<?php if(!empty($lists)): ?>
<h3>Attendance Report</h3>
<h5><strong>Date From:- <?php echo $model['startDate'].'&nbspTo:-'.$model['endDate']?></strong></h5>
<div class="row">
    <button style="float: right;margin: 15px;" class="btn btn-warning" type="button"
        onclick="location.href='<?php echo Yii::app()->getBaseUrl(true); ?>/index.php/report/AllAttendanceWithAbsent';">
        <i class="glyphicon glyphicon-search"></i> Search
    </button>
    <div class="dropdown" style="float: right;margin: 15px;">
        <button class="btn btn-warning dropdown-toggle" type="button" data-toggle="dropdown"><i
                class="glyphicon glyphicon-download-alt"></i> Export
            <span class="caret"></span></button>
        <ul class="dropdown-menu">
            <li><a onclick=sendExcel()><i class="glyphicon glyphicon-list-alt"></i><strong> Excel </strong></a></li>
        </ul>
    </div>
</div>
<div class="portlet box yellow">
    <div class="portlet-title">
        <div class="caption"><i class="icon-globe"></i>Attendance details</div>
        <div class="tools">
            <a href="javascript:;" class="reload"></a>
            <a href="javascript:;" class="remove"></a>
        </div>
    </div>
    <div class="portlet-body" style="overflow:auto; height:450px">
        <table class="table table-striped table-bordered table-hover" id="table_1">
            <thead>
                <tr>
                    <th>NAME</th>
                    <th>NIC</th>
                    <td>DATE</td>
                    <td>IMAGE</td>
                </tr>
            </thead>
            <tbody>
                <?php foreach ($lists as $list): ?>


                <tr>
                    <td><?php echo $list['name']; ?></td>
                    <td><?php echo $list['nic']; ?></td>
                    <td><?php echo $list['date']; ?></td>
                    <td><?php echo '<img style="height: 100px;width: 100px;" src="data:image/png;base64,'.$list['image'].'"/>'; ?></td>
                    

                </tr>
                <?php endforeach; ?>
            </tbody>
        </table>
    </div>
</div>
<?php else: ?>
<div class="box-body">

    <div class="alert alert-info alert-dismissible">
        <h3><i class="glyphicon glyphicon-exclamation-sign"></i> Alert!</h3>
        No Attendance Report Found.
        <button style="float: right;border: 1px solid black;background-color: Transparent;" type="button"
            data-dismiss="alert" aria-hidden="true"
            onclick="location.href='<?php echo Yii::app()->getBaseUrl(true); ?>/index.php/report/AllAttendanceWithAbsent';"><i
                class="glyphicon glyphicon-arrow-left"></i> Back</button>
    </div>

</div>
<?php endif ?>