

var app = angular.module('ItouchApp', ['chart.js', 'nvd3']);
app.controller('dashboardCtrl', ['$http', '$scope', '$location', '$window', function ($http, $scope, $location, $window) {
    $scope.colorsBar = [{
        backgroundColor: '#E5BA3A',
        borderColor: '#E5BA3A',
        hoverBackgroundColor: '#E5BA3A',
        hoverBorderColor: '#E5BA3A'
    },
    {
        backgroundColor: '#EF820D',
        borderColor: '#EF820D',
        hoverBackgroundColor: '#EF820D',
        hoverBorderColor: '#EF820D'
    }];
    $scope.datasetOverrideBar = [
        {
            fill: true,
            backgroundColor: [
                "#2ACAFF",
                "#2ACAFF",

            ]
        },
        {
            fill: true,
            backgroundColor: [
                "#0099CC",
                "#0099CC",

            ]
        }];
    $scope.labelsBar = [];
    $scope.seriesBar = ['Present', 'Absent'];
    $scope.preBar = [];
    $scope.absBar = [];
    $scope.dataBar = [];
    $scope.optionsBar = {
        scales: {
            xAxes: [{
                gridLines: {
                    display: false
                },
                barPercentage: 1,
                categoryPercentage: 1,
                scaleLabel: {
                    display: true,
                    labelString: 'Sites'
                }



            }],
            yAxes: [{
                gridLines: {
                    display: true
                },
                scaleLabel: {
                    display: true,
                    labelString: 'Head Count'
                }

            }]
        }
    };


    $scope.dateBar;

    $http.get("http://localhost/WFM_EFL/index.php/DashboardApi/PresenceAbsenceChart")
        .then(function (response) {
            var list = response.data.list;
            $scope.dateBar = response.data.date + ' (Today)';
            for (var i = 0; i < list.length; i++) {
                $scope.labelsBar.push(list[i].name.substring(0, 2));
                $scope.preBar.push(list[i].PRE);
                $scope.absBar.push(list[i].ABS);
            }


            $scope.dataBar = [$scope.preBar, $scope.absBar];

        }, function errorCallback(response) {

            console.log(response);

        });

    $scope.export = function () {

        $window.location.href = '/WFM_EFL/index.php/report/BarChartDownload';

    };

}]);


app.controller('stackChart', ['$http', '$scope', '$location','$window', function ($http, $scope, $location,$window) {

    $scope.labelsStack = [];
    $scope.typeStack = "StackedBar";
    $scope.seriesStack = ['Basic', 'OT', 'Allownce'];
    $scope.optionsStack = {
        scales: {
            xAxes: [{
                stacked: true,
                ticks: {
                    beginAtZero: true
                },
                gridLines: {
                    display: false
                },
                scaleLabel: {
                    display: true,
                    labelString: 'Sites'
                },

            }],
            yAxes: [{
                stacked: true,
                gridLines: {
                    display: true
                },
                scaleLabel: {
                    display: true,
                    labelString: 'Cost(%)'
                },
                ticks: {
                    callback: function (tick) {
                        return tick.toString() + '%';
                    }
                }
            }]
        }
    };
    $scope.bscStack = [];
    $scope.otStack = [];
    $scope.allwncStack = [];
    $scope.dateStack;


    $http.get("http://localhost/WFM_EFL/index.php/DashboardApi/PayrollChart")

        .then(function (response) {
            var list = response.data.list;
            $scope.dateStack = response.data.date;
            for (var i = 0; i < list.length; i++) {
                $scope.labelsStack.push(list[i].name.substring(0, 2));
                $scope.bscStack.push(list[i].basic);
                $scope.otStack.push(list[i].ot);
                $scope.allwncStack.push(list[i].allownce);
            }





        }, function errorCallback(response) {

            console.log(response);

        });

    $scope.export = function () {

        $window.location.href = '/WFM_EFL/index.php/report/StackChartDownload';

    };
    
    $scope.dataStack = [
        $scope.bscStack,
        $scope.otStack,
        $scope.allwncStack
    ];
     $scope.colorsStack = [{
        backgroundColor: '#ffa500',
        borderColor: '#ffa500',
        hoverBackgroundColor: '#ffa500',
        hoverBorderColor: '#ffa500'
    },
    {
        backgroundColor: '#ffb732',
        borderColor: '#ffb732',
        hoverBackgroundColor: '#ffb732',
        hoverBorderColor: '#ffb732'
    },
    {
        backgroundColor: '#ffc966',
        borderColor: '#ffc966',
        hoverBackgroundColor: '#ffc966',
        hoverBorderColor: '#ffc966'
    }];

    $scope.datasetOverrideStack = [
        {
            label: "My First dataset",
            //backgroundColor: "#2ed573",
            data: $scope.bscStack,
            stack: 1
        }, {
            label: "My Second dataset",
            //backgroundColor: "#ff6b81",
            data: $scope.otStack,
            stack: 2
        }, {
            label: "My Third dataset",
            //backgroundColor: "#eccc68",
            data: $scope.allwncStack,
            stack: 2
        }
    ];
   
}]);

app.controller("LineCtrl", function ($http, $scope, $window) {
    $scope.labelsLine = [];
    $scope.colorsLine = ['#00B2EE', '#4DD2FF', '#D9F5FF'];
    $scope.seriesLine = ['Present', 'Absent', 'Total Allocated'];
    $scope.dataLine = [];
    $scope.preLine = [];
    $scope.absLine = [];
    $scope.ttlLine = [];
    $scope.dateLine;
    var month;


    $http.get("http://localhost/WFM_EFL/index.php/DashboardApi/AreaChart")
        .then(function (response) {
            var list = response.data.list;
            $scope.exprt = list;
            $scope.dateLine = response.data.date;
            for (var i = 0; i < list.length; i++) {
                $scope.labelsLine.push(list[i].date.slice(-2));
                $scope.preLine.push(list[i].present);
                $scope.absLine.push(list[i].absent);
                $scope.ttlLine.push(list[i].total);
            }


            $scope.dataLine = [$scope.preLine, $scope.absLine, $scope.ttlLine];

        }, function errorCallback(response) {

            console.log(response);

        });

    $scope.export = function () {

        $window.location.href = '/WFM_EFL/index.php/report/LineChartDownload';

    };


    $scope.onClick = function (points, evt) {
        console.log(points, evt);
    };
    $scope.datasetOverrideLine = [{ yAxisID: 'y-axis-1' }];

    $scope.optionsLine = {
        scales: {
            xAxes: [{
                stacked: true,
                ticks: {
                    beginAtZero: true
                },
                gridLines: {
                    display: false
                },
                scaleLabel: {
                    display: true,
                    labelString: 'Dates Of Month'
                }
            }],
            yAxes: [
                {
                    id: 'y-axis-1',
                    type: 'linear',
                    display: true,
                    position: 'left',
                    scaleLabel: {
                        display: true,
                        labelString: 'Head Count'
                    }
                }]
        }
    };
});


app.controller("PieCtrl", function ($http, $scope, $location, $window) {


    $scope.labelsPie = [];
    $scope.dataPie = [];
    $scope.datePie;
    $scope.colorsPie = ['#ffc04c', '#ffe4b2', '#ffdb99', '#ffd27f', '#ffc966',
        '#ffc04c', '#ffb732', '#ffae19', '#ffa500'];
    $scope.showHeader = false;
    $scope.msg = 'No Data Found';
    $scope.optionsPie = {
        legend: {
            display: false,
            position: 'left',

        }
    }


    $http.get("http://40.71.221.154/WFM_EFL/index.php/DashboardApi/PieChart")

        .then(function (response) {
            var list = response.data.list;
            if (list.length == 0) {
                $scope.showHeader = true;
            }
            $scope.datePie = response.data.date + ' (Today)';
            for (var i = 0; i < list.length; i++) {
                $scope.labelsPie.push(list[i].name);
                $scope.dataPie.push(list[i].count);

            }




        }, function errorCallback(response) {

            console.log(response);

        });

    $scope.export = function () {

        $window.location.href = '/WFM_EFL/index.php/report/PieChartDownload';

    };

    $scope.onClick = function (points, evt) {
        var index = points[0]._index;
        var siteName = $scope.labelsPie[index];
        var items = {
            site: siteName
        };
        //console.log(siteName);

        $http.post('http://40.71.221.154/WFM_EFL/index.php/DashboardApi/GetSiteId', items).success(function (res) {

            $window.location.href = '/WFM_EFL/index.php/report/NonAllocatedEmployees/' + res;

        });
        // var a = JSON.parse(points[0]);
        // console.log(a.ChartElement );
        //$window.location.href = '/itouch/index.php/report/NonAllocatedEmployees/' + siteName;
    };



});

app.controller("BaseCtrl",
    function ($scope, $http, $window) {
        $scope.labelsB = [];
        $scope.dataB = [];
        $scope.typeB = 'pie';
        $scope.date;
        $scope.colorsPie = ['#fff6e5', '#ffe4b2', '#ffdb99', '#ffd27f', '#ffc966',
        '#ffc04c', '#ffb732', '#ffae19', '#ffa500','#e59400','#cc8400','#b27300','#996300','#7f5200'];
        $scope.date;
        $scope.showHeader = false;
        $scope.msg = 'No Data Found';


        $http.get("http://40.71.221.154/WFM_EFL/index.php/DashboardApi/GetAccountViceAttendance")

            .then(function (response) {
                var list = response.data.list;
                if (list.length == 0) {
                    $scope.showHeader = true;
                }
                $scope.date = response.data.date
                for (var i = 0; i < list.length; i++) {
                    $scope.labelsB.push(list[i].name);
                    $scope.dataB.push(list[i].count);
                }
            }, function errorCallback(response) {

                console.log(response);

            });

        
        
    $scope.export = function () {

        $window.location.href = '/WFM_EFL/index.php/report/SitePieChartDownload';

    };

        $scope.toggle = function () {

            $scope.typeB = $scope.typeB === 'polarArea' ?
                'pie' : 'polarArea';
        };
    });

app.controller('siteBarChart', ['$http', '$scope', '$location','$window', function ($http, $scope, $location,$window) {
$scope.colorsSiteBar = [{
        backgroundColor: '#ffa500',
        borderColor: '#ffa500',
        hoverBackgroundColor: '#ffa500',
        hoverBorderColor: '#ffa500'
    },
    {
        backgroundColor: '#ffb732',
        borderColor: '#ffb732',
        hoverBackgroundColor: '#ffb732',
        hoverBorderColor: '#ffb732'
    }, {
        backgroundColor: '#ffc966',
        borderColor: '#ffc966',
        hoverBackgroundColor: '#ffc966',
        hoverBorderColor: '#ffc966'
    }];
    $scope.datasetOverrideSiteBar = [
        {
            fill: true,
            backgroundColor: [
                "#4a69bd",
                "#4a69bd",

            ]
        },
        {
            fill: true,
            backgroundColor: [
                "#eb2f06",
                "#eb2f06",

            ]
        }];
    $scope.labelsSiteBar = [];
    $scope.seriesSiteBar = ['Total Allocated', 'Present', 'Absent'];
    $scope.allocatedSiteBar = [];
    $scope.preSiteBar = [];
    $scope.absSiteBar = [];
    $scope.dataSiteBar = [];
    $scope.optionsSiteBar = {
        scales: {
            xAxes: [{
                gridLines: {
                    display: false
                },
                BarPercentage: 1,
                categoryPercentage: 1,
                scaleLabel: {
                    display: true,
                    labelString: 'Accounts'
                }



            }],
            yAxes: [{
                gridLines: {
                    display: true
                },
                scaleLabel: {
                    display: true,
                    labelString: 'Head Count'
                }

            }]
        }
    };


    $scope.dateSiteBar;
    $scope.date;
    $scope.showHeader = false;
    $scope.msg = 'There Is No Allocated Employees';


    $http.get("http://40.71.221.154/WFM_EFL/index.php/DashboardApi/GetAccountVicePresentAbsent")

        .then(function (response) {
            var list = response.data.list;
            if (list.length == 0) {
                $scope.showHeader = true;
            }
            $scope.date = response.data.date
            for (var i = 0; i < list.length; i++) {
                $scope.labelsSiteBar.push(list[i].name.substring(0, 2));
                $scope.preSiteBar.push(list[i].present);
                $scope.absSiteBar.push(list[i].absent);
                $scope.allocatedSiteBar.push(list[i].allocated);
            }


            $scope.dataSiteBar = [$scope.allocatedSiteBar, $scope.preSiteBar, $scope.absSiteBar];

        }, function errorCallback(response) {

            console.log(response);

        });

        $scope.export = function () {

            $window.location.href = '/WFM_EFL/index.php/report/SiteBarChartDownload';
    
        };
        
        

}]);
app.factory('socket', function($rootScope) {
    var socket = io.connect("http://40.71.221.154:8883"); 
    return {
        on: function(eventName, callback) {
            socket.on(eventName, function() {
                var args = arguments;
                $rootScope.$apply(function() {
                    callback.apply(socket, args);
                });
            });
        },
        emit: function(eventName, data, callback) {
            socket.emit(eventName, data, function() {
                var args = arguments;
                $rootScope.$apply(function() {
                    if (callback) {
                        callback.apply(socket, args);
                    }
                });
            });
        }
    };
});


// Battery level
app.controller("BatteryCtrl", function ($http, $scope, $location, $window,socket) {
socket.on("sensor_data",function(data){
  //  console.log(data);
    
    
});
 $scope.Clickbutt = function() {
     alert();
      //  $window.battery.Update(60);
           
    
        };

});


