<?php

class ReportController extends Controller
{
/**
* @var string the default layout for the views. Defaults to '//layouts/column2', meaning
* using two-column layout. See 'protected/views/layouts/column2.php'.
*/
public $layout='//layouts/column1';

/**
* @return array action filters
*/
public function filters()
{
return array(
'accessControl', // perform access control for CRUD operations
);
}

/**
* Specifies the access control rules.
* This method is used by the 'accessControl' filter.
* @return array access control rules
*/
public function accessRules()
{
    return array(

    array('allow', // allow only the owner to perform 'PersonalReport','PersonalReportPDF'  actions
        'actions' => array('PersonalReport','PersonalReportPDF','ShoeAndTshirt','ShoeAndTshirtPDF','ShoeAndTshirtExcel'),
        'expression' => 'Yii::app()->user->can("Personal_report")',
    ),
    array('allow', // allow only the owner to perform 'PersonalReport','PersonalReportPDF'  actions
        'actions' => array('NewEmployeesList','NewEmployeesListPDF','NewEmployeesListExcel'),
        'expression' => 'Yii::app()->user->can("NewEmployeesList_report")',
    ),
    array('allow', // allow only the owner to perform   actions
        'actions' => array('FindLeaveDetails','CreateLeaveReportPDF','CreateLeaveReportExcel'),
        'expression' => 'Yii::app()->user->can("CreateLeave1_report")',
    ),
    array('allow', // allow only the owner to perform   actions
        'actions' => array('findRosterDetails','createRosterPDF','createRosterExcel'),
        'expression' => 'Yii::app()->user->can("createRoster1_report")',
    ),
    array('allow', // allow only the owner to perform   actions
        'actions' => array('findPresenceDetails','createPresencePDF','createPresenceExcel'),
        'expression' => 'Yii::app()->user->can("createPresence_report")',
    ),
    array('allow', // allow only the owner to perform   actions
        'actions' => array('findAbsenteeismDetails','createAbsentPDF','createAbsentExcel'),
        'expression' => 'Yii::app()->user->can("createAbsent_report")',
    ),
    array('allow', // allow only the owner to perform   actions
        'actions' => array('HeadCountReport','HeadCountReportPDF','HeadCountReportExcel'),
        'expression' => 'Yii::app()->user->can("HeadCount_report")',
    ),
    array('allow', // allow only the owner to perform   actions
        'actions' => array('MercantileHolidayWorkingReport','MercantileHolidayWorkingReportPDF','PoyadayWorkingReportExcel'),
        'expression' => 'Yii::app()->user->can("MercantileHolidayWorking_report")',
    ),
    array('allow', // allow only the owner to perform   actions
        'actions' => array('PoyadayWorkingReport','PoyadayWorkingReportPDF','PoyadayWorkingReportExcel'),
        'expression' => 'Yii::app()->user->can("PoyadayDayWorking_report")',
    ),
    array('allow', // allow only the owner to perform   actions
        'actions' => array('ManualTimeAdjustmentReport','ManualTimeAdjustmentReportPDF','ManualTimeAdjustmentReportExcel'),
        'expression' => 'Yii::app()->user->can("ManualTimeAdjustment_report")',
    ),
     array('allow', // allow only the owner to perform   actions
        'actions' => array('OTSummaryReport','OTSummaryReportPDF','OTSummaryReportExcel'),
        'expression' => 'Yii::app()->user->can("OTSummary_report")',
    ),
     array('allow', // allow only the owner to perform   actions
        'actions' => array('DailyAbnormalOT','DailyAbnormalOTPDF','DailyAbnormalOTExcel'),
        'expression' => 'Yii::app()->user->can("DailyAbnormalOT_report")',
    ),
     array('allow', // allow only the owner to perform   actions
        'actions' => array('DailyOvertimeReport','DailyOvertimeReportPDF','DailyOvertimeReportExcel'),
        'expression' => 'Yii::app()->user->can("DailyOvertime_report")',
    ),
     array('allow', // allow only the owner to perform   actions
        'actions' => array('ResignEmployeesListExcel','ResignEmployeesListPDF','ResignEmployeesListReport'),
        'expression' => 'Yii::app()->user->can("ResignEmployeesList_report")',
    ),
     array('allow', // allow only the owner to perform   actions
        'actions' => array('SundayWorkingReportExcel','SundayWorkingReportPDF','SundayWorkingReport'),
        'expression' => 'Yii::app()->user->can("SundayWorkingReport1_report")',
    ),
     array('allow', // allow only the owner to perform   actions
        'actions' => array('SearchByDesignation','DesignationPdf','DesignationExcel'),
        'expression' => 'Yii::app()->user->can("Designation1_report")',
    ),
     array('allow', // allow only the owner to perform   actions
        'actions' => array('findAttendanceSummaryDetails','createAttendanceSummaryPDF','createAttendanceSummaryExcel'),
        'expression' => 'Yii::app()->user->can("createAttendanceSummary_report")',
    ),
     array('allow', // allow only the owner to perform   actions
        'actions' => array('findEarlyOutsDetails','createEarlyOutPDF','createEarlyOutExcel'),
        'expression' => 'Yii::app()->user->can("createEarlyOut_report")',
    ),
     array('allow', // allow only the owner to perform   actions
        'actions' => array('findConsecutiveAbsenceDetails','createContinuousAbsencePDF','createContinuousAbsenceExcel'),
        'expression' => 'Yii::app()->user->can("createContinuousAbsence_report")',
    ),
     array('allow', // allow only the owner to perform   actions
        'actions' => array('DailyWorkingHoursReportExcel', 'DailyWorkingHoursReportPdf','CreateDailyWorkingHoursReport'),
        'expression' => 'Yii::app()->user->can("DailyWorkingHours_report")',
    ),
     array('allow', // allow only the owner to perform   actions
        'actions' => array('findInvalidAttendanceDetails','CreateInvalidAttendancePdf','createInvalidAttendanceExcel'),
        'expression' => 'Yii::app()->user->can("InvalidAttendance_report")',
    ),
    array('allow', // allow only the owner to perform   actions
        'actions' => array('findLateAttendanceDetails','createLateAttendancePDF','CreateLateAttendanceExcel'),
        'expression' => 'Yii::app()->user->can("LateAttendance_report")',
    ),
    array('allow', // allow only the owner to perform   actions
        'actions' => array('Attendance','Pdf','AttendanceExcel'),
        'expression' => 'Yii::app()->user->can("EmployeeAttendance_report")',
    ),
    array('allow', // allow only the owner to perform   actions
        'actions' => array('AttendanceRange','AttendanceRangePdf','AttendanceRangeExcel'),
        'expression' => 'Yii::app()->user->can("AttendanceRange_report")',
    ),
    array('allow', // allow only the owner to perform   actions
        'actions' => array('HighOvertimeReport'),
        'expression' => 'Yii::app()->user->can("HighOvertime_report")',
    ),
     array('allow', // allow only the owner to perform   actions
        'actions' => array('CreateWorkingHoursReport'),
        'expression' => 'Yii::app()->user->can("CreateWorkingHours_report")',
    ),
     array('allow', // allow only the owner to perform   actions
        'actions' => array('Timesheetexcel','PayrollExcel'),
        'expression' => 'Yii::app()->user->can("Timesheet1_report")',
    ),
     array('allow', // allow only the owner to perform   actions
        'actions' => array('findAuditLogs','createAuditLogPDF','createAuditLogExcel'),
        'expression' => 'Yii::app()->user->can("AuditLog1_report")',
    ),
     array('allow', // allow only the owner to perform   actions
        'actions' => array('auditLogEmployee','createAuditLogEmployeePDF','createAuditLogEmployeeExcel'),
        'expression' => 'Yii::app()->user->can("Employee1_AuditLog1_report")',
    ),
    array('allow', // allow only the owner to perform   actions
        'actions' => array('EmployeeAllAttendance','EmployeeAllAttendancePDF','EmployeeAllAttendanceExcel'),
        'expression' => 'Yii::app()->user->can("EmployeeAllAttendance_report")',
),
    array('allow', // allow only the owner to perform   actions
        'actions' => array('findTeamEmployees','teamEmployeesPDF','teamEmployeesExcel'),
        'expression' => 'Yii::app()->user->can("Team_Employee1_report")',
    ),

    array('allow', // allow only the owner to perform   actions
        'actions' => array('ActiveEmployeeList','ActiveEmployeeListPDF','ActiveEmployeeListExcel','DeactiveEmployeeList','DeactiveEmployeeListExcel'),
        'expression' => 'Yii::app()->user->can("ActiveEmployeeList_report")',
    ),
    array('allow', // allow only the owner to perform   actions
        'actions' => array('DesignationWiseDailyCostReportExcel','AssetsReport','MPWiseDailyCostReportExcel','DesignationWiseDailyCostingReport','MPDailyCostingReport','PresentReport','PresentReportPDF','PresentReportExcel','NonAllocatedEmployees',
        'NonAllocatedEmployeestPDF','NonAllocatedEmployeestExcel','LineChartDownload','PieChartDownload','BarChartDownload',
        'StackChartDownload','SiteBarChartDownload','SitePieChartDownload','TestReport','WorkingHoursTrackingReportExcel','CreateWorkingHoursTrackingReport',
        'ManpowerWiseCost','ManpowerWiseCostExcel','ManpowerWiseCostPDF','missingdocument','MissingEmpDoc','Suppliermissingdocument','SupplierMissingEmpDoc','EmployeeLeaveHistory',
        'EmployeeLeaveHistoryPDF','EmployeeLeaveHistoryExcel','SupplierWiseAttendanceSummery','SupplierWiseAttendanceSummeryPDF',
        'SupplierWiseAttendanceSummeryExcel','AdhocTimelog','AdhocTimelogExcel','AdhocTimelogPDF','NonAllocatedEmployeesReport','NonAllocatedEmployeesReportPDF'
        ,'NonAllocatedEmployeesReportExcel','PieceDetails','PieceDetailsExcel','AllAttendanceWithAbsent','AllAttendanceWithAbsentExcel','EmployeeAssetsExcel',
        'TimelogWithPin'),
        'expression' => 'Yii::app()->user->can("Present_report")',
    ),
     array('deny', // deny all users
        'users' => array('*'),
    ),
    array('allow',  // allow all users to perform 'index' and 'view' actions
     'actions'=>array('ConvertToHoursMins'),
     'users'=>array('*'),
     ),    
    );
}

/**
* Displ     ays a particular model.
* @param integer $id the ID of the model to be displayed
*/
    public function convertToHoursMins($Decimalvalue, $format = '%02d:%02d') {
        $time = round($Decimalvalue *60);
          if ($time < 1) {
             $hours = 0;
             $minutes = 0;
             return sprintf($format, $hours, $minutes);
            }
          $hours = floor($time / 60);
          $minutes = ($time % 60);
         return sprintf($format, $hours, $minutes);
             
 } 
 public function actionPersonalReport(){
        $model = new PersonalReport;
        if(isset($_POST['PersonalReport'])){
            $model->attributes = $_POST['PersonalReport'];


            if($model->validate()){
                $list= Yii::app()->db->createCommand("SELECT E.*,S.name SName,A.name AName,D.type DName,ES.monthsalary monthSalary,ES.DalySalary dailySalary
                FROM employee E
                INNER JOIN sites S ON S.id = E.siteid
                INNER JOIN accounts A ON A.id = E.Accountid
                INNER JOIN designation D ON D.id = E.designationid
                INNER JOIN employeesalary ES ON ES.employeeid = E.id
                WHERE E.id = $model->employee AND ES.status = 1")->queryAll();
                $paymantmethod = Paymentmethod::model()->findByPk($list[0]['paymentmethodid']);
                // print_r($model->employee);
                //  print_r($paymantmethod->type);
                //  die;
                $this->render('//employee/ViewPersonalReport',array('list'=>$list,'model'=>$model,'paymantmethod'=>$paymantmethod->type));
            }

        }else{
            return $this->render('//employee/CreatePersonalReport',array('model'=>$model));
        }
}
//============================================================================================
public function actionPersonalReportPDF()
{

    $list = CJSON::decode($_POST['list']);
    $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
    $mPDF1->setAutoBottomMargin = 'stretch';
    $mPDF1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
    $mPDF1->WriteHTML($this->renderPartial('//employee/PersonalReportPDF',array('list'=>$list),true));
    $file_name= 'Personal Report.'.'pdf';


    ob_end_clean();
    $mPDF1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );
}
//=========================================================================
public function actionNewEmployeesList(){
        $model = new NewEmployeesList;
        if(isset($_POST['NewEmployeesList'])){
            $model-> attributes = $_POST['NewEmployeesList'];
         //   $model->account = $_POST['NewEmployeesList']['account'];
            if($model->validate()){
                if(isset($_POST['accounts'])){
                    $list= Yii::app()->db->createCommand("SELECT A.AccountOracleCode accountId,E.id Id,E.Namewithini Name,E.nic NIC,E.joindate Date,S.name Site,A.name Account,D.type Designation ,DP.name department
                        FROM employee E
                        INNER JOIN sites S ON S.id = E.siteid
                        INNER JOIN accounts A ON A.id = E.Accountid
                        INNER JOIN designation D ON D.id = E.designationid
                        INNER JOIN department DP ON DP.id = E.departmentid
                        WHERE E.joindate >= DATE('$model->startDate') AND E.joindate <= DATE('$model->endDate') AND E.statusId = 1 AND E.accountId IN (".implode(',',$_POST['accounts']).")
                        ORDER BY Account")->queryAll();
                }else{
                    if(Yii::app()->user->isAdmin()){

                        $list= Yii::app()->db->createCommand("SELECT A.AccountOracleCode accountId,E.id Id,E.Namewithini Name,E.nic NIC,E.joindate Date,S.name Site,A.name Account,D.type Designation ,DP.name department
                        FROM employee E
                        INNER JOIN sites S ON S.id = E.siteid
                        INNER JOIN accounts A ON A.id = E.Accountid
                        INNER JOIN designation D ON D.id = E.designationid
                        INNER JOIN department DP ON DP.id = E.departmentid
                        WHERE E.joindate >= DATE('$model->startDate') AND E.joindate <= DATE('$model->endDate') AND E.statusId = 1
                        ORDER BY Account")->queryAll();

                    }

                    else{
                        $sitid = Yii::app()->user->data()->SiteId;
                        $list= Yii::app()->db->createCommand("SELECT A.AccountOracleCode accountId,E.id Id,E.Namewithini Name,E.nic NIC,E.joindate Date,S.name Site,A.name Account,D.type Designation ,DP.name department
                        FROM employee E
                        INNER JOIN sites S ON S.id = E.siteid
                        INNER JOIN accounts A ON A.id = E.Accountid
                        INNER JOIN designation D ON D.id = E.designationid
                        INNER JOIN department DP ON DP.id = E.departmentid
                        WHERE E.joindate >= DATE('$model->startDate') AND E.joindate <= DATE('$model->endDate') AND E.statusId = 1 AND E.siteid = $sitid
                        ORDER BY Account")->queryAll();

                    }
                }

          //      if($model->account == ''){


/*                 }

                else{

                    if(Yii::app()->user->isAdmin()){

                        $list= Yii::app()->db->createCommand("SELECT E.id Id,E.Namewithini Name,E.nic NIC,E.Confirmationdate Date,S.name Site,A.name Account,D.type Designation
                        FROM employee E
                        INNER JOIN sites S ON S.id = E.siteid
                        INNER JOIN accounts A ON A.id = E.Accountid
                        INNER JOIN designation D ON D.id = E.designationid
                        WHERE E.joindate >= DATE('$model->startDate') AND E.joindate <= DATE('$model->endDate') AND E.statusId = 1 AND E.Accountid = $model->account
                        ")->queryAll();

                    }

                    else{
                        $sitid = Yii::app()->user->data()->SiteId;
                        $list= Yii::app()->db->createCommand("SELECT E.id Id,E.Namewithini Name,E.nic NIC,E.Confirmationdate Date,S.name Site,A.name Account,D.type Designation
                        FROM employee E
                        INNER JOIN sites S ON S.id = E.siteid
                        INNER JOIN accounts A ON A.id = E.Accountid
                        INNER JOIN designation D ON D.id = E.designationid
                        WHERE E.joindate >= DATE('$model->startDate') AND E.joindate <= DATE('$model->endDate') AND E.statusId = 1 AND E.siteid = $sitid AND E.Accountid = $model->account
                        ")->queryAll();

                    }

                } */





                // print_r($list);
                // die;
                $this->render('//employee/ViewNewEmployeesList',array('list'=>$list,'model'=>$model));
            }

        }else{
            return $this->render('//employee/CreateNewEmployeesList',array('model'=>$model));
        }
    }

    //===========================================================
    public function actionNewEmployeesListPDF()
    {

        $list = CJSON::decode($_POST['list']);
        $model = CJSON::decode($_POST['model']);
        $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
        $mPDF1->setAutoBottomMargin = 'stretch';
        $mPDF1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
        $mPDF1->WriteHTML($this->renderPartial('//employee/NewEmployeesListPDF',array('list'=>$list,'model'=>$model),true));
        $file_name= $model['startDate'].'-'.$model['endDate'].'.pdf';


        ob_end_clean();
        $mPDF1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );
    }
    //=========================================================================
    public function actionNewEmployeesListExcel(){
        $objPHPExcel = new PHPExcel();
        $list = CJSON::decode($_POST['list']);
        $model = CJSON::decode($_POST['model']);

        // print_r($list);
        // die;

        $objPHPExcel->setActiveSheetIndex(0)
        ->setCellValue('A1', 'New Employee List')
        ->setCellValue('E1', 'Generated On')
        ->setCellValue('F1', date("Y-m-d - h:i:sa"))
        ->setCellValue('A2', 'Id')
        ->setCellValue('B2', 'Name')
        ->setCellValue('C2', 'NIC')
        ->setCellValue('D2', 'Designation')
        ->setCellValue('E2', 'Site')
        ->setCellValue('F2', 'Client Code')
        ->setCellValue('G2', 'Client Name')
        ->setCellValue('H2', 'Date')
        ->setCellValue('I2', 'Department');
        $col = 3;


        for($i = 0;$i < count($list);$i++){

            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0,$col,$list[$i]['Id']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1,$col,$list[$i]['Name']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2,$col,$list[$i]['NIC']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(3,$col,$list[$i]['Designation']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(4,$col,$list[$i]['Site']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(5,$col,$list[$i]['accountId']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(6,$col,$list[$i]['Account']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(7,$col,$list[$i]['Date']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(8,$col,$list[$i]['department']);
            $col++;

        }
        $styleArray = array(
            'font'  => array(
                'bold'  => true,
                'color' => array('rgb' => '#f79727'),
                'size'  => 10
            ));
        $objPHPExcel->getActiveSheet()->getStyle('A1:I2')->applyFromArray($styleArray);

        //$objPHPExcel->getActiveSheet()->setTitle('sffd');

        $objPHPExcel->setActiveSheetIndex(0);

        ob_end_clean();
        ob_start();

        header('Content-Type: application/vnd.ms-excel');
        header('Content-Disposition: attachment;filename='.$model['startDate'].' to '.$model['endDate'].'.xls');
        header('Cache-Control: max-age=0');
        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
        $objWriter->save('php://output');
      }

    //============================================================================================
public function actionFindLeaveDetails(){
        $model = new LeaveDetailsForm;
        if(isset($_POST['LeaveDetailsForm'])){

                $model->attributes=$_POST['LeaveDetailsForm'];
                $requiredYear=$model->year;;
                $requiredMonth=$model->month;
                $paidType=$model->paidType;
                // print_r($requiredYear." ".$requiredMonth);die;
                if(!Yii::app()->user->isAdmin()){
                    $sitid = Yii::app()->user->data()->SiteId;
                    $leaves=Yii::app()->db->createCommand(
                        "SELECT * FROM `leave` AS L
                         INNER JOIN employee ON employee.id = L.EmoloyeeId
                         WHERE EXTRACT(YEAR FROM L.StartDate)='$requiredYear' AND
                         EXTRACT(MONTH FROM L.StartDate) = '$requiredMonth' AND
                         L.PaidType ='$paidType' AND  employee.siteid = $sitid")->queryAll();

                        //  print_r($leaves);
                        //  die;
                }
                else{
                    $leaves=Yii::app()->db->createCommand(
                        "SELECT * FROM `leave` AS L
                         INNER JOIN employee ON employee.id = L.EmoloyeeId
                         WHERE EXTRACT(YEAR FROM L.StartDate)='$requiredYear' AND
                         EXTRACT(MONTH FROM L.StartDate) = '$requiredMonth' AND
                         L.PaidType ='$paidType' ORDER BY employee.siteid")->queryAll();

                }

                // $invalidRange can be configured by the Admin.

                $this->render('//leave/leaveReport', array('model'=>$model,'requiredYear'=> $requiredYear,'requiredMonth'=>$requiredMonth,'leaves'=> $leaves));

    }
        else{
            $this->render('//leave/getLeaveDetailsForm', array('model'=>$model));
            }


    }
//======================================================Monthly Leave report PDF=================================================

    public function actionCreateLeaveReportPDF(){
        $requiredYear = CJSON::decode($_POST['requiredYear']);
        $requiredMonth = CJSON::decode($_POST['requiredMonth']);
        $leaves = CJSON::decode($_POST['leaves']);
        $mpdf1 = Yii::app()->ePdf->mpdf();
        $mpdf1->setAutoBottomMargin = 'stretch';
        $mpdf1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
        $mpdf1->WriteHTML($this->renderPartial('//leave/leavesReportPDF', array('model'=>$model,'leaves'=> $leaves, 'requiredYear'=> $requiredYear,'requiredMonth'=>$requiredMonth),true));

        $file_name= "Leave Report on:".$requiredYear." ".$requiredMonth.".pdf";

        ob_end_clean();

        $mpdf1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );

    }

    //===============================================Monthly Leave Excel========================================================
    public function actionCreateLeaveReportExcel(){


        $objPHPExcel = new PHPExcel();
        $requiredYear = CJSON::decode($_POST['requiredYear']);
        $requiredMonth = CJSON::decode($_POST['requiredMonth']);
        $dateObj   = DateTime::createFromFormat('!m', $requiredMonth);
        $monthName = $dateObj->format('F');

        $leaves = CJSON::decode($_POST['leaves']);
                // Set document properties
                $objPHPExcel->getProperties()->setCreator("K'iin Balam")
                     ->setLastModifiedBy("K'iin Balam")
                     ->setTitle("YiiExcel Test Document")
                     ->setSubject("YiiExcel Test Document")
                     ->setDescription("Test document for YiiExcel, generated using PHP classes.")
                     ->setKeywords("office PHPExcel php YiiExcel UPNFM")
                     ->setCategory("Test result file");

                // Add some data
                $objPHPExcel->setActiveSheetIndex(0)
                    ->setCellValue('A1', 'Leave Report :')
                    ->setCellValue('E1', 'Generated On')
                    ->setCellValue('F1', date("Y-m-d - h:i:sa"))
                    ->setCellValue('C1', $requiredYear." ".$monthName)
                    ->setCellValue('A4', 'NIC')
                    ->setCellValue('B4', 'Employee ID')
                    ->setCellValue('C4', 'Name')
                    ->setCellValue('D4', 'Department')
                    ->setCellValue('E4', 'Site')
                    ->setCellValue('F4', 'Designation')
                    ->setCellValue('G4', 'Start Date')
                    ->setCellValue('H4', 'Number of Days')
                    ->setCellValue('I4', 'Number of Hours')
                    ->setCellValue('J4', 'Leave type')
                    ->setCellValue('K4', 'Client Code')
                    ->setCellValue('L4', 'Client Name')
                    ;
                    $styleArray = array(
                        'font'  => array(
                            'bold'  => true,
                            'color' => array('rgb' => '#f79727'),
                            'size'  => 10
                        ));
                    $objPHPExcel->getActiveSheet()->getStyle('A1:L4')->applyFromArray($styleArray);

                    $row =5;
                      foreach($leaves as $leave) {
                            $col =1;
                            $employee = Employee::model()->findByPk($leave['EmoloyeeId']);    //  should be corrected to employee in db and here
                            $designation = Designation::model()->findByPk($employee->designationid);
                            $site = Sites::model()->findByPk($employee->siteid);
                            $dept = Department::model()->findByPk($employee->departmentid);
                            $start=$leave['StartDate'];
                            $days=$leave['No_of_Day'];
                            $hours=$leave['No_Of_Hour'];
                            $type=$leave['LeaveType'];
                            $account = Accounts::model()->findByPk($leave['Accountid']);  

                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0,$row,$employee->nic);
                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col,$row,$employee->id);
                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$employee->FirstName." ".$employee->LastName);
                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$dept->name);
                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$site->name);
                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$designation->type);
                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$start);
                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$days);
                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$hours);
                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$type);
                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$account->AccountOracleCode);
                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$account->name);

                            $row++;
                        }



                $objPHPExcel->getActiveSheet()->setTitle('YiiExcel');
                $filename = "Leave Report on: ".$requiredYear."-".$requiredMonth;
                header('Content-Type: application/vnd.ms-excel');
                header('Content-Disposition: attachment;filename="'.$filename.'.xls"');
                header('Cache-Control: max-age=0');

                $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');

                $objWriter->save('php://output');
                unset($this->objWriter);
                unset($this->objWorksheet);
                unset($this->objReader);
                unset($this->objPHPExcel);
                exit();
            }
//=================================================================Roster Details===================================================================
public function actionFindRosterDetails(){
    $model = new RosterDetailsForm;
    if(isset($_POST['RosterDetailsForm'])){

            $model->attributes=$_POST['RosterDetailsForm'];  // only schedule is setted.
            $model->shift=$_POST['shift'];
            $model->teams = $_POST['teams'];
            $teamsArray = $model->teams;
            $rosterSchedule = Schedule::model()->findByPk($model->schedule);
            $rosterShift = Shift::model()->findByPk($model->shift);

            $teamEmployees=array();
            foreach($teamsArray as $element){
                $teamEmployees[$element] =Employee::model()->findAllBySql("select * from employee where statusid= 1 AND id in(select employeeid from employee_team where employee_team.teamid=$element AND employee_team.status=1) order by id");

            }

            $this->render('//roster/rosterReport', array('model'=>$model,'rosterSchedule'=> $rosterSchedule,'rosterShift'=> $rosterShift,'teamEmployees'=>$teamEmployees));

}
    else{

        $this->render('//roster/getRosterDetailsForm', array('model'=>$model));
     }



}




public function actionCreateRosterPDF(){

     $rosterSchedule = CJSON::decode($_POST['rosterSchedule']);
     $rosterShift = CJSON::decode( $_POST['rosterShift']);
     $teamEmployees = CJSON::decode($_POST['teamEmployees']);
     $mpdf1 = Yii::app()->ePdf->mpdf();
     $mpdf1->setAutoBottomMargin = 'stretch';
     $mpdf1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
    $mpdf1->WriteHTML($this->renderPartial('//roster/rosterPDF', array('model'=>$model,'teamEmployees'=> $teamEmployees, 'rosterSchedule'=> $rosterSchedule,'rosterShift'=> $rosterShift),true));


    $file_name= $rosterSchedule['Date'].'.pdf';

    ob_end_clean();

    $mpdf1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );

 }

 public function actionCreateRosterExcel(){

    $objPHPExcel = new PHPExcel();
    $rosterSchedule = CJSON::decode($_POST['rosterSchedule']);
    $rosterShift = CJSON::decode( $_POST['rosterShift']);
    $teamEmployees = CJSON::decode($_POST['teamEmployees']);
            // Set document properties
            $objPHPExcel->getProperties()->setCreator("K'iin Balam")
                 ->setLastModifiedBy("K'iin Balam")
                 ->setTitle("YiiExcel Test Document")
                 ->setSubject("YiiExcel Test Document")
                 ->setDescription("Test document for YiiExcel, generated using PHP classes.")
                 ->setKeywords("office PHPExcel php YiiExcel UPNFM")
                 ->setCategory("Test result file");

            // Add some data
            $objPHPExcel->setActiveSheetIndex(0)
                ->setCellValue('A1', 'Roster Report')
                ->setCellValue('E1', 'Generated On')
                ->setCellValue('F1', date("Y-m-d - h:i:sa"))
                ->setCellValue('A2', 'Schedule :')
                ->setCellValue('A3', 'Shift :')
                ->setCellValue('C2', $rosterSchedule['Date'])
                ->setCellValue('C3', $rosterShift['name'])
                ->setCellValue('A4', 'Team')
                ->setCellValue('B4', 'NIC')
                ->setCellValue('C4', 'Employee ID')
                ->setCellValue('D4', 'Name')
                ->setCellValue('E4', 'Client Code')
                ->setCellValue('F4', 'Client Name')
                ;

                $styleArray = array(
                    'font'  => array(
                        'bold'  => true,
                        'color' => array('rgb' => '#f79727'),
                        'size'  => 10
                    ));
                $objPHPExcel->getActiveSheet()->getStyle('A1:J4')->applyFromArray($styleArray);


                $row = 5;
                foreach($teamEmployees as $key=>$employees) {
                    $teamData = Team::model()->findByPk($key);

                    foreach($employees as $employee) {
                        $account = Accounts::model()->findByPk($employee['Accountid']);
                        $col =1;
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, $row,$teamData->name);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col,$row,$employee['nic']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$employee['id']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$employee['Namewithini']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$account->AccountOracleCode);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$account->name);
                        $row++;
                    }

                }


            $objPHPExcel->getActiveSheet()->setTitle('YiiExcel');
            $filename = $rosterSchedule['Date']." ".$rosterShift['name'];
            header('Content-Type: application/vnd.ms-excel');
            header('Content-Disposition: attachment;filename="'.$filename.'.xls"');
            header('Cache-Control: max-age=0');

            $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');

            $objWriter->save('php://output');
            unset($this->objWriter);
            unset($this->objWorksheet);
            unset($this->objReader);
            unset($this->objPHPExcel);
            exit();
        }

//===================================================================Find Presence details==============================================================

        public function actionFindPresenceDetails(){
            $model = new DailyPresenceForm;
            if(isset($_POST['DailyPresenceForm'])){

                    $model->attributes=$_POST['DailyPresenceForm'];
                    $model->shift=$_POST['shift'];
                    $schedule = Schedule::model()->findByPk($model->schedule);
                    $shift = Shift::model()->findByPk($model->shift);
                    $shiftEndTime = $shift->EndTime;
                    //$presentEmployees = Timesheet::model()->findBySql("SELECT * FROM timesheet WHERE date = '$schedule->Date' AND Intime <='$shiftEndTime'");
                    $presentEmployees=Yii::app()->db->createCommand("SELECT t.* FROM timesheet as t
                    LEFT JOIN employee_shift as es on t.EmployeeShiftid = es.id
                    LEFT JOIN employee as e on es.EmployeeId = e.id
                    WHERE date = '$schedule->Date' AND es.Shiftid = $model->shift AND Intime <='$shiftEndTime' ORDER BY e.siteid,e.Accountid,t.EmployeeId")->queryAll();
                    //print_r($presentEmployees); die;
                     $this->render('//roster/presenceReport', array('model'=>$model,'schedule'=> $schedule,'shift'=> $shift,'presentEmployees'=>$presentEmployees));

        }
            else{

                $this->render('//roster/getPresenceDetails', array('model'=>$model));
            }



        }

//==========================================Find Absent details=================================================================
public function actionFindAbsenteeismDetails(){
    $model = new DailyAbsenteesmForm;
    if(isset($_POST['DailyAbsenteesmForm'])){

            $model->attributes=$_POST['DailyAbsenteesmForm'];
            if(isset($_POST['accounts']))
            $selectedAccounts = $_POST['accounts'];
            else
            $selectedAccounts = [];
//======================================================================================================================================================

    if(!empty($selectedAccounts)){

        $absentsPaid = Yii::app()->db->createCommand(
            "SELECT employee_shift.EmployeeId as EmployeeId,shift.name as Shift,shift.StartTime as StartTime,'Paid' as PaidType,employee.siteid as Site,employee.Accountid as Account
            FROM  employee_shift
            LEFT JOIN timesheet ON employee_shift.id = timesheet.EmployeeShiftid
            LEFT JOIN employee ON employee_shift.EmployeeId = employee.id
            INNER JOIN shift ON shift.id = employee_shift.shiftid
            WHERE employee.statusId = 1 AND Intime IS NULL AND OuteTime IS NULL AND
            DATE( shift.StartTime ) >= '$model->startDate' AND DATE( shift.StartTime ) <= '$model->endDate' AND employee_shift.EmployeeId  IN (SELECT EmoloyeeId
            FROM  `leave` AS L
            WHERE L.StartDate >='$model->startDate'
            AND DATE_ADD( L.StartDate, INTERVAL L.No_of_Day
            DAY ) <=  '$model->endDate' AND PaidType = 'Pay')
            ORDER BY employee.siteid,employee.Accountid,StartTime,employee.id")->queryAll(); // EmployeeId ->EmoloyeeId


        $absentsNoPay = Yii::app()->db->createCommand(
            "SELECT * FROM
            (SELECT employee_shift.EmployeeId as EmployeeId,shift.name as Shift,shift.StartTime as StartTime,'No Pay' as PaidType,employee.siteid as Site,employee.Accountid as Account
            FROM  employee_shift
            LEFT JOIN timesheet ON employee_shift.id = timesheet.EmployeeShiftid
            LEFT JOIN employee ON employee_shift.EmployeeId = employee.id
            INNER JOIN shift ON shift.id = employee_shift.shiftid
            WHERE employee.statusId = 1 AND Intime IS NULL AND OuteTime IS NULL AND
            DATE( shift.StartTime ) >= '$model->startDate' AND DATE( shift.StartTime ) <='$model->endDate' AND employee_shift.EmployeeId NOT IN (SELECT EmoloyeeId
            FROM  `leave` AS L
            WHERE L.StartDate >='$model->startDate'
            AND DATE_ADD( L.StartDate, INTERVAL L.No_of_Day DAY) <= '$model->endDate')


            UNION


            SELECT employee_shift.EmployeeId as EmployeeId,shift.name as Shift,shift.StartTime as StartTime,'No Pay' as PaidType,employee.siteid as Site,employee.Accountid as Account
            FROM  employee_shift
            LEFT JOIN timesheet ON employee_shift.id = timesheet.EmployeeShiftid
            LEFT JOIN employee ON employee_shift.EmployeeId = employee.id
            INNER JOIN shift ON shift.id = employee_shift.shiftid
            WHERE employee.statusId = 1 AND Intime IS NULL AND OuteTime IS NULL AND
            DATE( shift.StartTime ) >= '$model->startDate' AND DATE( shift.StartTime ) <= '$model->endDate' AND employee_shift.EmployeeId IN (SELECT EmoloyeeId
            FROM  `leave` AS L
            WHERE L.StartDate >='$model->startDate'
            AND DATE_ADD( L.StartDate, INTERVAL L.No_of_Day DAY) <=  '$model->endDate' AND PaidType = 'NO Pay')
            ) as newTable

            ORDER BY newTable.Site,newTable.Account,newTable.EmployeeId")->queryAll();

        $data = array_merge($absentsPaid,$absentsNoPay);

        $relevantAbsents= array();



        if(!empty($data)){
            foreach($data as $record){
                if(in_array($record['Account'],$selectedAccounts))
                $relevantAbsents[]= $record;

            }

        }

    }

    else{
        if(Yii::app()->user->isAdmin()){
            $absentsPaid = Yii::app()->db->createCommand(
                "SELECT employee_shift.EmployeeId as EmployeeId,shift.name as Shift,shift.StartTime as StartTime,'Paid' as PaidType,employee.siteid as Site,employee.Accountid as Account
                FROM  employee_shift
                LEFT JOIN timesheet ON employee_shift.id = timesheet.EmployeeShiftid
                LEFT JOIN employee ON employee_shift.EmployeeId = employee.id
                INNER JOIN shift ON shift.id = employee_shift.shiftid
                WHERE employee.statusId = 1 AND Intime IS NULL AND OuteTime IS NULL AND
                DATE( shift.StartTime ) >= '$model->startDate' AND DATE( shift.StartTime ) <= '$model->endDate' AND employee_shift.EmployeeId  IN (SELECT EmoloyeeId
                FROM  `leave` AS L
                WHERE L.StartDate >='$model->startDate'
                AND DATE_ADD( L.StartDate, INTERVAL L.No_of_Day
                DAY ) <=  '$model->endDate' AND PaidType = 'Pay')
                ORDER BY employee.siteid,employee.Accountid,StartTime,employee.id")->queryAll(); // EmployeeId ->EmoloyeeId


        $absentsNoPay = Yii::app()->db->createCommand(
                "SELECT * FROM
                (SELECT employee_shift.EmployeeId as EmployeeId,shift.name as Shift,shift.StartTime as StartTime,'No Pay' as PaidType,employee.siteid as Site,employee.Accountid as Account
                FROM  employee_shift
                LEFT JOIN timesheet ON employee_shift.id = timesheet.EmployeeShiftid
                LEFT JOIN employee ON employee_shift.EmployeeId = employee.id
                INNER JOIN shift ON shift.id = employee_shift.shiftid
                WHERE employee.statusId = 1 AND Intime IS NULL AND OuteTime IS NULL AND
                DATE( shift.StartTime ) >= '$model->startDate' AND DATE( shift.StartTime ) <='$model->endDate' AND employee_shift.EmployeeId NOT IN (SELECT EmoloyeeId
                FROM  `leave` AS L
                WHERE L.StartDate >='$model->startDate'
                AND DATE_ADD( L.StartDate, INTERVAL L.No_of_Day DAY) <= '$model->endDate')


                UNION


                SELECT employee_shift.EmployeeId as EmployeeId,shift.name as Shift,shift.StartTime as StartTime,'No Pay' as PaidType,employee.siteid as Site,employee.Accountid as Account
                FROM  employee_shift
                LEFT JOIN timesheet ON employee_shift.id = timesheet.EmployeeShiftid
                LEFT JOIN employee ON employee_shift.EmployeeId = employee.id
                INNER JOIN shift ON shift.id = employee_shift.shiftid
                WHERE employee.statusId = 1 AND Intime IS NULL AND OuteTime IS NULL AND
                DATE( shift.StartTime ) >= '$model->startDate' AND DATE( shift.StartTime ) <= '$model->endDate' AND employee_shift.EmployeeId IN (SELECT EmoloyeeId
                FROM  `leave` AS L
                WHERE L.StartDate >='$model->startDate'
                AND DATE_ADD( L.StartDate, INTERVAL L.No_of_Day DAY) <=  '$model->endDate' AND PaidType = 'NO Pay')
                ) as newTable

                ORDER BY newTable.Site,newTable.Account,newTable.EmployeeId")->queryAll();

            $relevantAbsents = array_merge($absentsPaid,$absentsNoPay);

        }
        else{
            $site = Yii::app()->user->data()->SiteId;
            $absentsPaid = Yii::app()->db->createCommand(
                "SELECT employee_shift.EmployeeId as EmployeeId,shift.name as Shift,shift.StartTime as StartTime,'Paid' as PaidType,employee.siteid as Site,employee.Accountid as Account
                FROM  employee_shift
                LEFT JOIN timesheet ON employee_shift.id = timesheet.EmployeeShiftid
                LEFT JOIN employee ON employee_shift.EmployeeId = employee.id
                INNER JOIN shift ON shift.id = employee_shift.shiftid
                WHERE employee.statusId = 1 AND Intime IS NULL AND OuteTime IS NULL AND
                DATE( shift.StartTime ) >= '$model->startDate' AND DATE( shift.StartTime ) <= '$model->endDate' AND employee_shift.EmployeeId  IN (SELECT EmoloyeeId
                FROM  `leave` AS L
                WHERE L.StartDate >='$model->startDate'
                AND DATE_ADD( L.StartDate, INTERVAL L.No_of_Day
                DAY ) <=  '$model->endDate' AND PaidType = 'Pay')
                AND employee.siteid = $site
                ORDER BY employee.Accountid,StartTime,employee.id")->queryAll(); // EmployeeId ->EmoloyeeId


        $absentsNoPay = Yii::app()->db->createCommand(
                "SELECT * FROM
                (SELECT employee_shift.EmployeeId as EmployeeId,shift.name as Shift,shift.StartTime as StartTime,'No Pay' as PaidType,employee.siteid as Site,employee.Accountid as Account
                FROM  employee_shift
                LEFT JOIN timesheet ON employee_shift.id = timesheet.EmployeeShiftid
                LEFT JOIN employee ON employee_shift.EmployeeId = employee.id
                INNER JOIN shift ON shift.id = employee_shift.shiftid
                WHERE employee.statusId = 1 AND Intime IS NULL AND OuteTime IS NULL AND
                DATE( shift.StartTime ) >= '$model->startDate' AND DATE( shift.StartTime ) <='$model->endDate' AND employee_shift.EmployeeId NOT IN (SELECT EmoloyeeId
                FROM  `leave` AS L
                WHERE L.StartDate >='$model->startDate'
                AND DATE_ADD( L.StartDate, INTERVAL L.No_of_Day DAY) <= '$model->endDate')


                UNION


                SELECT employee_shift.EmployeeId as EmployeeId,shift.name as Shift,shift.StartTime as StartTime,'No Pay' as PaidType,employee.siteid as Site,employee.Accountid as Account
                FROM  employee_shift
                LEFT JOIN timesheet ON employee_shift.id = timesheet.EmployeeShiftid
                LEFT JOIN employee ON employee_shift.EmployeeId = employee.id
                INNER JOIN shift ON shift.id = employee_shift.shiftid
                WHERE employee.statusId = 1 AND Intime IS NULL AND OuteTime IS NULL AND
                DATE( shift.StartTime ) >= '$model->startDate' AND DATE( shift.StartTime ) <= '$model->endDate' AND employee_shift.EmployeeId IN (SELECT EmoloyeeId
                FROM  `leave` AS L
                WHERE L.StartDate >='$model->startDate'
                AND DATE_ADD( L.StartDate, INTERVAL L.No_of_Day DAY) <=  '$model->endDate' AND PaidType = 'NO Pay')
                ) as newTable
                WHERE newTable.Site = $site
                ORDER BY newTable.Account,newTable.EmployeeId")->queryAll();

            $relevantAbsents = array_merge($absentsPaid,$absentsNoPay);

        }


    }

//=======================================================================================================================================================



            $this->render('//roster/absentReport', array('model'=>$model,'absents'=>$relevantAbsents));

}
    else{

        $this->render('//roster/getAbsentDetails', array('model'=>$model));
    }



}

//=============================================Presence PDF======================================================


public function actionCreatePresencePDF(){

    $schedule = CJSON::decode($_POST['schedule']);
    $shift = CJSON::decode( $_POST['shift']);
    $presentEmployees = CJSON::decode($_POST['presentEmployees']);
    $mpdf1 = Yii::app()->ePdf->mpdf();
    $mpdf1->setAutoBottomMargin = 'stretch';
    $mpdf1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
    $mpdf1->WriteHTML($this->renderPartial('//roster/presencePDF', array('model'=>$model,'presentEmployees'=> $presentEmployees, 'schedule'=> $schedule,'shift'=> $shift),true));


    $file_name= "Presence Report on:".$schedule['Date'].'.pdf';

    ob_end_clean();

    $mpdf1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );

 }

 //=============================================Absent PDF======================================================

 public function actionCreateAbsentPDF(){

     $model = CJSON::decode($_POST['model']);
     $absentEmployees = CJSON::decode($_POST['absents']);
     $mpdf1 = Yii::app()->ePdf->mpdf();
     $mpdf1->setAutoBottomMargin = 'stretch';
     $mpdf1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
    $mpdf1->WriteHTML($this->renderPartial('//roster/absenteesmPDF', array('model'=>$model,'absentEmployees'=> $absentEmployees),true));


    $file_name= "Absenteeism Report on:".$model['startDate'].'  to  '.$model['endDate'].'.pdf';

    ob_end_clean();

    $mpdf1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );

 }

 //=========================================Create Excel for Present details====================================================================
 public function actionCreatePresenceExcel(){

    $objPHPExcel = new PHPExcel();
    $schedule = CJSON::decode($_POST['schedule']);
    $shift = CJSON::decode( $_POST['shift']);
    $presentEmployees = CJSON::decode($_POST['presentEmployees']);
            // Set document properties
            $objPHPExcel->getProperties()->setCreator("K'iin Balam")
                 ->setLastModifiedBy("K'iin Balam")
                 ->setTitle("YiiExcel Test Document")
                 ->setSubject("YiiExcel Test Document")
                 ->setDescription("Test document for YiiExcel, generated using PHP classes.")
                 ->setKeywords("office PHPExcel php YiiExcel UPNFM")
                 ->setCategory("Test result file");

            // Add some data
            $objPHPExcel->setActiveSheetIndex(0)
                ->setCellValue('A1', 'Presence Report')
                ->setCellValue('E1', 'Generated On')
                ->setCellValue('F1', date("Y-m-d - h:i:sa"))
                ->setCellValue('A2', 'Schedule :')
                ->setCellValue('A3', 'Shift :')
                ->setCellValue('C2', $schedule['Date'])
                ->setCellValue('C3', $shift['name'])
                ->setCellValue('A4', 'NIC')
                ->setCellValue('B4', 'ID')
                ->setCellValue('C4', 'Name')
                ->setCellValue('D4', 'Designation')
                ->setCellValue('E4', 'Site')
                ->setCellValue('F4', 'Client Code')
                ->setCellValue('G4', 'Client Name')
                ->setCellValue('H4', 'Department');

                $styleArray = array(
                    'font'  => array(
                        'bold'  => true,
                        'color' => array('rgb' => '#f79727'),
                        'size'  => 10
                    ));
                $objPHPExcel->getActiveSheet()->getStyle('A1:G4')->applyFromArray($styleArray);


                $row = 5;
                  foreach($presentEmployees as $presentEmployee) {
                        $employee = Employee::model()->findByPk($presentEmployee['EmployeeId']);
                        $col =1;
                        $designation = Designation::model()->findByPk($employee->designationid);
                        $site = Sites::model()->findByPk($employee->siteid);
                        $account = Accounts::model()->findByPk($employee->Accountid);
                        $dept= Department::model()->findByPk($employee->departmentid);

                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0,$row,$employee->nic);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col,$row,$employee->id);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$employee->Namewithini);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$designation->type);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$site->name);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$employee->Accountid);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$account->name);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$dept->name);

                        $row++;
                    }




            $objPHPExcel->getActiveSheet()->setTitle('YiiExcel');
            $filename = "Presence Details on : ".$schedule['Date']." ".$shift['name'];
            header('Content-Type: application/vnd.ms-excel');
            header('Content-Disposition: attachment;filename="'.$filename.'.xls"');
            header('Cache-Control: max-age=0');

            $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');

            $objWriter->save('php://output');
            unset($this->objWriter);
            unset($this->objWorksheet);
            unset($this->objReader);
            unset($this->objPHPExcel);
            exit();
        }

 //=========================================Create Excel for Absent details====================================================================
 public function actionCreateAbsentExcel(){


    $objPHPExcel = new PHPExcel();
    $model = CJSON::decode($_POST['model']);
    $absentEmployees = CJSON::decode($_POST['absents']);
            // Set document properties
            $objPHPExcel->getProperties()->setCreator("K'iin Balam")
                 ->setLastModifiedBy("K'iin Balam")
                 ->setTitle("YiiExcel Test Document")
                 ->setSubject("YiiExcel Test Document")
                 ->setDescription("Test document for YiiExcel, generated using PHP classes.")
                 ->setKeywords("office PHPExcel php YiiExcel UPNFM")
                 ->setCategory("Test result file");

            // Add some data
            $objPHPExcel->setActiveSheetIndex(0)
                ->setCellValue('A1', 'Absent Report')
                ->setCellValue('E1', 'Generated On')
                ->setCellValue('F1', date("Y-m-d - h:i:sa"))
                ->setCellValue('A2', $model['startDate']."  to  ".$model['endDate'])
                ->setCellValue('A4', 'NIC')
                ->setCellValue('B4', 'Employee ID')
                ->setCellValue('C4', 'Name')
                ->setCellValue('D4', 'Shift')
                ->setCellValue('E4', 'Designation')
                ->setCellValue('F4', 'Leave Type')
                ->setCellValue('G4', 'Site')
                ->setCellValue('H4', 'Client Code')
                ->setCellValue('I4', 'Client Name')
                ->setCellValue('J4', 'Department')
                ->setCellValue('K4', 'MP');


                $styleArray = array(
                    'font'  => array(
                        'bold'  => true,
                        'color' => array('rgb' => '#f79727'),
                        'size'  => 10
                    ));
                $objPHPExcel->getActiveSheet()->getStyle('A1:J4')->applyFromArray($styleArray);

                $row = 5;
                  foreach($absentEmployees as $absentEmployee) {
                        $col =1;
                        $employee = Employee::model()->findByPk($absentEmployee['EmployeeId']);
                        $designation = Designation::model()->findByPk($employee->designationid);
                        $site = Sites::model()->findByPk($employee->siteid);
                        $payMethod = Paymentmethod::model()->findByPk($employee->paymentmethodid);
                        $category = Category::model()->findByPk($employee->categoryid);
                        $labourCat = Labourcategory::model()->findByPk($employee->LabourCategory);
                        $account = Accounts::model()->findByPk($employee->Accountid);
                        $dept= Department::model()->findByPk($employee->departmentid);


                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0,$row,$employee->nic);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col,$row,$employee->id);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$employee->Namewithini);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$absentEmployee['Shift']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$designation->type);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$absentEmployee['PaidType']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$site->name);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$account->AccountOracleCode);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$account->name);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$dept->name);
                        if($employee->supplierid != NULL){
                            $supplier = Supplier::model()->findByPk($employee->supplierid);
                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,substr($supplier['name'],0,5).".");

                        }
                        else{
                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,"-Not Found-");

                        }


                        $row++;
                    }



            $objPHPExcel->getActiveSheet()->setTitle('YiiExcel');
            $filename = "Absenteeism Details: ".$model['startDate']." to ".$model['endDate'];
            header('Content-Type: application/vnd.ms-excel');
            header('Content-Disposition: attachment;filename="'.$filename.'.xls"');
            header('Cache-Control: max-age=0');

            $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');

            $objWriter->save('php://output');
            unset($this->objWriter);
            unset($this->objWorksheet);
            unset($this->objReader);
            unset($this->objPHPExcel);
            exit();
        }
//===============================================================================
public function actionHeadCountReport(){

    $model = new HeadCountReport;
    if(isset($_POST['HeadCountReport'])){
        $model-> attributes = $_POST['HeadCountReport'];
        if($model->validate()){

        if(Yii::app()->user->isAdmin()){
            $list= Yii::app()->db->createCommand("SELECT SC.Date Date,S.id Id,S.name Name,count(ES.EmployeeId) HCount,S.StartTime StartTime, S.EndTime EndTime
            FROM schedule SC
            INNER JOIN shift S ON S.schedulid = SC.id
            INNER JOIN employee_shift ES ON ES.ShiftId = S.id
            WHERE SC.Date >= DATE('$model->startDate') AND SC.Date <= DATE('$model->endDate')
            group by S.id
            ORDER BY SC.Date")->queryAll();

        }
        else{

            $site = Yii::app()->user->data()->SiteId;
            $list= Yii::app()->db->createCommand("SELECT SC.Date Date,S.id Id,S.name Name,count(ES.EmployeeId) HCount,S.StartTime StartTime, S.EndTime EndTime
            FROM schedule SC
            INNER JOIN shift S ON S.schedulid = SC.id
            INNER JOIN employee_shift ES ON ES.ShiftId = S.id
            WHERE SC.Date >= DATE('$model->startDate') AND SC.Date <= DATE('$model->endDate') AND S.SiteId = $site
            group by S.id
            ORDER BY SC.Date")->queryAll();

        }

            //  print_r($list);
            //  die;

            $this->render('//schedule/ViewHeadCountReport',array('list'=>$list,'model'=>$model));
        }

    }else{
        return $this->render('//schedule/CreateHeadCountReport',array('model'=>$model));
    }


}


//============================================================================================
public function actionHeadCountReportPDF()
{

    $list = CJSON::decode($_POST['list']);
    $model = CJSON::decode($_POST['model']);
    $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
    $mPDF1->setAutoBottomMargin = 'stretch';
    $mPDF1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
    $mPDF1->WriteHTML($this->renderPartial('//schedule/HeadCountReportPDF',array('list'=>$list,'model'=>$model),true));
    $file_name= $model['startDate'].'-'.$model['endDate'].'HeadCount.pdf';


    ob_end_clean();
    $mPDF1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );
}
//=========================================================================
public function actionHeadCountReportExcel(){
    $objPHPExcel = new PHPExcel();
    $list = CJSON::decode($_POST['list']);
    $model = CJSON::decode($_POST['model']);

    // print_r($list);
    // die;

    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue('A1', 'Head Count Report')
    ->setCellValue('E1', 'Generated On')
    ->setCellValue('F1', date("Y-m-d - h:i:sa"))
    ->setCellValue('A2', 'Shift Id')
    ->setCellValue('B2', 'Date')
    ->setCellValue('C2', 'Shift Name')
    ->setCellValue('D2', 'Shift(Start)')
    ->setCellValue('E2', 'Shift(End)')
    ->setCellValue('F2', 'Head Count');
    $col = 3;


    for($i = 0;$i < count($list);$i++){

        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0,$col,$list[$i]['Id']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1,$col,$list[$i]['Date']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2,$col,$list[$i]['Name']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(3,$col,$list[$i]['StartTime']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(4,$col,$list[$i]['EndTime']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(5,$col,$list[$i]['HCount']);

        $col++;

    }
    $styleArray = array(
        'font'  => array(
            'bold'  => true,
            'color' => array('rgb' => '#f79727'),
            'size'  => 10
        ));
    $objPHPExcel->getActiveSheet()->getStyle('A1:F2')->applyFromArray($styleArray);

    $objPHPExcel->setActiveSheetIndex(0);

    ob_end_clean();
    ob_start();

    header('Content-Type: application/vnd.ms-excel');
    header('Content-Disposition: attachment;filename='.$model['startDate'].'-'.$model['endDate'].'-HeadCount.xls');
    header('Cache-Control: max-age=0');
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
    $objWriter->save('php://output');
  }


//   missing employee documt

public function actionMissingEmpDoc(){
    $objPHPExcel = new PHPExcel();
    $list = CJSON::decode("s");
    $model = CJSON::decode("ss");
     if(Yii::app()->user->isAdmin()){

        $allemployee = Yii::app()->db->createCommand("SELECT * FROM employee")->queryAll();
        $employeArray= array();
    
        
        
        foreach($allemployee as $value) {
            $emp_id=$value['id'];
            $siteid=$value['siteid'];
            $accountid=$value['Accountid'];
            $missing_doc = array();
    
        $employee_doc = Yii::app()->db->createCommand("SELECT * FROM employee_document_type")->queryAll();
    
        foreach($employee_doc as $value2) {
    
           
    
         
            $emp_doc_id=$value2['id'];
    
    
            $employeedocuments=EmployeeDocuments::model()->find(" status='1' AND emp_id='$emp_id' AND document_id='$emp_doc_id'");
    

            if(!$employeedocuments){

                $missing_doc[]=array("emp_doc_id"=> $emp_doc_id , "doc"=>0);
                    
                // $missing_doc[] = array("emp_id"=>$emp_id,"emp_doc_id"=> $emp_doc_id);
    
             
                
                  }else{
                    $missing_doc[]=array("emp_doc_id"=> $emp_doc_id , "doc"=>1 );
        
                      }
             }  
                             
             $employeArray[] = array("emp_id"=>$emp_id,"empdoc"=> $missing_doc);
        } 
    
    
        // print_r($employeArray);
        // die;
    
      
    
}else{
    $sitid = Yii::app()->user->data()->SiteId;

    $allemployee = Yii::app()->db->createCommand("SELECT * FROM employee WHERE siteid='$sitid'")->queryAll();
    $employeArray= array();

    

    foreach($allemployee as $value) {
        $emp_id=$value['id'];
        $siteid=$value['siteid'];
        $accountid=$value['Accountid'];
        $missing_doc = array();

    $employee_doc = Yii::app()->db->createCommand("SELECT * FROM employee_document_type")->queryAll();

    foreach($employee_doc as $value2) {

       

     
        $emp_doc_id=$value2['id'];


        $employeedocuments=EmployeeDocuments::model()->find(" status='1' AND emp_id='$emp_id' AND document_id='$emp_doc_id'");


        if(!$employeedocuments){

            $missing_doc[]=array("emp_doc_id"=> $emp_doc_id , "doc"=>0);
                
            // $missing_doc[] = array("emp_id"=>$emp_id,"emp_doc_id"=> $emp_doc_id);

         
            
              }else{
                $missing_doc[]=array("emp_doc_id"=> $emp_doc_id , "doc"=>1 );
    
                  }
         }  
         
         
         $employeArray[] = array("emp_id"=>$emp_id,"empdoc"=> $missing_doc);
    }

}

    // print_r($list);
    // die;

    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue('A1', 'Missing Employee Documnet List')
    ->setCellValue('D1', 'Generated On')
    ->setCellValue('E1', date("Y-m-d - h:i:sa"))
    ->setCellValue('A2', 'Emp Id')
  
    
    ->setCellValue('B2', 'Employee Name')
    ->setCellValue('C2', 'Employee NIC')
    ->setCellValue('D2', 'Joined Date')
    ->setCellValue('E2', 'Copies of Certificates Including')
    ->setCellValue('F2', 'Appointment letter')
    ->setCellValue('G2', 'CV')
    ->setCellValue('H2', 'NIC')
    ->setCellValue('I2', 'Two Passport Size Colored Photos')
    ->setCellValue('J2', 'Birth Certificate')
    ->setCellValue('K2', 'Educational Certificates')
    ->setCellValue('L2', 'Work Experience')
    ->setCellValue('M2', 'Police Clearance')
    ->setCellValue('N2', 'Police Clearance Expire Date')
    ->setCellValue('O2', 'Grama Sevaka Certificate') 
    ->setCellValue('P2', 'Grama Sevaka Certificate Expire Date')
    ->setCellValue('Q2', 'B Card')
    ->setCellValue('R2', 'Driving Licen')        
    ->setCellValue('S2', 'Employee Status')
    ->setCellValue('T2', 'Supplier Name')
    ->setCellValue('U2', 'Site Name')
    ->setCellValue('V2', 'Client Code')
    ->setCellValue('W2', 'Client Name')
    ;
   
    $col = 3;

   


    for($i = 0;$i < count($employeArray);$i++){

        $empids=$employeArray[$i]['emp_id'];
     
        $emp= Employee::model()->find("id=$empids");
        $emp_nic= Employee::model()->find("id=$empids")->nic ;
        $siteid= Employee::model()->find("id=$empids")->siteid ;
        $acountid= Employee::model()->find("id=$empids")->Accountid ;
        $sitename=Sites::model()->find("id=$siteid")->name;
        $accountname=Accounts::model()->find("id=$acountid")->name;
        $supplier=Supplier::model()->find("id=$emp->supplierid")->name;


        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0,$col, $empids);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1,$col,$emp->Namewithini);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2,$col,$emp_nic);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(3,$col,$emp->joindate);
        
                    
           $colomn =4;         
           for($j= 0;$j < count($employeArray[$i]["empdoc"]);$j++){
              
        if($j == 9){
           
           $employeedocuments=EmployeeDocuments::model()->find(" status='1' AND emp_id='$empids' AND document_id='9'");
           $InactiveDate = !empty($employeedocuments)? $employeedocuments->inactive_date :"";
           $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($colomn,$col,$InactiveDate);
           $colomn++;
           
        }
        if($j == 10){
            
            $employeedocument =EmployeeDocuments::model()->find(" status='1' AND emp_id='$empids' AND document_id='10'");
            $Inactive_Date = !empty($employeedocument)? $employeedocument->inactive_date :"";
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($colomn,$col,$Inactive_Date);
             $colomn++;
           }  

             $docstatus=$employeArray[$i]["empdoc"][$j]['doc'];
                       
             if($docstatus==0){
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($colomn,$col,"Not Received");

             }else{
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($colomn,$col,"Completed");

             }
        
             $colomn++;
        }
                   
        if($emp->statusId ==1){
           $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(18,$col,"Active");

        }else{
           $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(18,$col,"Deactive");
        }
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(19,$col,$supplier);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(20,$col,$sitename);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(21,$col,$acountid);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(22,$col,$accountname);



        $col++;

    }
    $styleArray = array(
        'font'  => array(
            'bold'  => true,
            'color' => array('rgb' => '#f79727'),
            'size'  => 10
        ));
        $objPHPExcel->getActiveSheet()->getColumnDimension('B')->setWidth("30");
        $objPHPExcel->getActiveSheet()->getColumnDimension('C')->setWidth("20");
        $objPHPExcel->getActiveSheet()->getColumnDimension('E')->setWidth("12");
        $objPHPExcel->getActiveSheet()->getColumnDimension('D')->setWidth("15");
        $objPHPExcel->getActiveSheet()->getColumnDimension('N')->setWidth("12");
        $objPHPExcel->getActiveSheet()->getColumnDimension('P')->setWidth("12");
    $objPHPExcel->getActiveSheet()->getStyle('A1:V2')->applyFromArray($styleArray);

    $objPHPExcel->setActiveSheetIndex(0);

    ob_end_clean();
    ob_start();

    header('Content-Type: application/vnd.ms-excel');
    header('Content-Disposition: attachment;filename=Missing Employee Document.xls');
    header('Cache-Control: max-age=0');
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
    $objWriter->save('php://output');
  }



//   missing employee documt end

//============================================================================================
public function actionPoyadayWorkingReport(){
    $model = new PoyadayWorkingReport;
    if(isset($_POST['PoyadayWorkingReport'])){
        $model-> attributes = $_POST['PoyadayWorkingReport'];

        if($model->validate()){
            if(isset($_POST['accounts'])){
                $list= Yii::app()->db->createCommand("SELECT A.AccountOracleCode accountId,T.date PoyaDate,E.id Id,E.Namewithini Name,E.nic NIC,D.type Designation,A.name Account,S.StartTime ShiftStartTime,S.EndTime ShiftEndTime,T.Intime Intime,T.OuteTime OutTime,DP.name department
                    FROM timesheet T
                    INNER JOIN employee E ON E.id = T.EmployeeId
                    INNER JOIN designation D ON D.id = T.DesignaId
                    INNER JOIN accounts A ON A.id = E.Accountid
                    INNER JOIN department DP ON DP.id = E.departmentid
                    INNER JOIN employee_shift ES ON ES.id = T.EmployeeShiftid
                    INNER JOIN shift S ON S.id = ES.ShiftId
                    WHERE E.accountId IN (".implode(',',$_POST['accounts']).") AND T.date IN (
                                    SELECT H.Date
                                    FROM holydays H
                                    WHERE H.Date >= Date('$model->startDate') AND H.Date <= Date('$model->endDate') AND H.Is_Poyaday ='POYADAY') ORDER BY Account")->queryAll();
            }else{
                if(Yii::app()->user->isAdmin()){
                    $list= Yii::app()->db->createCommand("SELECT A.AccountOracleCode accountId,T.date PoyaDate,E.id Id,E.Namewithini Name,E.nic NIC,D.type Designation,A.name Account,S.StartTime ShiftStartTime,S.EndTime ShiftEndTime,T.Intime Intime,T.OuteTime OutTime,DP.name department
                    FROM timesheet T
                    INNER JOIN employee E ON E.id = T.EmployeeId
                    INNER JOIN designation D ON D.id = T.DesignaId
                    INNER JOIN accounts A ON A.id = E.Accountid
                    INNER JOIN department DP ON DP.id = E.departmentid
                    INNER JOIN employee_shift ES ON ES.id = T.EmployeeShiftid
                    INNER JOIN shift S ON S.id = ES.ShiftId
                    WHERE T.date IN (
                                    SELECT H.Date
                                    FROM holydays H
                                    WHERE H.Date >= Date('$model->startDate') AND H.Date <= Date('$model->endDate') AND H.Is_Poyaday ='POYADAY') ORDER BY Account")->queryAll();

                }else{
                    $sitid = Yii::app()->user->data()->SiteId;
                    $list= Yii::app()->db->createCommand("SELECT A.AccountOracleCode accountId,T.date PoyaDate,E.id Id,E.Namewithini Name,E.nic NIC,D.type Designation,A.name Account,S.StartTime ShiftStartTime,S.EndTime ShiftEndTime,T.Intime Intime,T.OuteTime OutTime,DP.name department
                    FROM timesheet T
                    INNER JOIN employee E ON E.id = T.EmployeeId
                    INNER JOIN designation D ON D.id = T.DesignaId
                    INNER JOIN accounts A ON A.id = E.Accountid
                    INNER JOIN department DP ON DP.id = E.departmentid
                    INNER JOIN employee_shift ES ON ES.id = T.EmployeeShiftid
                    INNER JOIN shift S ON S.id = ES.ShiftId
                    WHERE E.siteid = $sitid AND T.date IN (
                                    SELECT H.Date
                                    FROM holydays H
                                    WHERE H.Date >= Date('$model->startDate') AND H.Date <= Date('$model->endDate') AND H.Is_Poyaday ='POYADAY') ORDER BY Account")->queryAll();
                }
            }


            // print_r($list);
            // die;
            $this->render('//holydays/ViewPoyadayWorkingReport',array('list'=>$list,'model'=>$model));
        }

    }else{
        return $this->render('//holydays/CreatePoyadayWorkingReport',array('model'=>$model));
    }
}
//========================================================================================
public function actionPoyadayWorkingReportPDF()
{

    $list = CJSON::decode($_POST['list']);
    $model = CJSON::decode($_POST['model']);
    $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
    $mPDF1->setAutoBottomMargin = 'stretch';
    $mPDF1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
    $mPDF1->WriteHTML($this->renderPartial('//holydays/PoyadayWorkingReportPDF',array('list'=>$list,'model'=>$model),true));
    $file_name= $model['startDate'].'-'.$model['endDate'].' poyadays.pdf';


    ob_end_clean();
    $mPDF1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );
}
//=========================================================================
public function actionPoyadayWorkingReportExcel(){
    $objPHPExcel = new PHPExcel();
    $list = CJSON::decode($_POST['list']);
    $model = CJSON::decode($_POST['model']);

    // print_r($list);
    // die;

    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue('A1', 'Holiday Working Report')
    ->setCellValue('E1', 'Generated On')
    ->setCellValue('F1', date("Y-m-d - h:i:sa"))
    ->setCellValue('A2', 'Holiday')
    ->setCellValue('B2', 'Id')
    ->setCellValue('C2', 'Name')
    ->setCellValue('D2', 'NIC')
    ->setCellValue('E2', 'Designation')
    ->setCellValue('F2', 'Client Code')
    ->setCellValue('G2', 'Client Name')
    ->setCellValue('H2', 'Department')
    ->setCellValue('I2', 'Shift Start Time')
    ->setCellValue('J2', 'Shift End Time')
    ->setCellValue('K2', 'In Time')
    ->setCellValue('L2', 'Out Time')
    ;
    $col = 3;


    for($i = 0;$i < count($list);$i++){

        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0,$col,$list[$i]['PoyaDate']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1,$col,$list[$i]['Id']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2,$col,$list[$i]['Name']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(3,$col,$list[$i]['NIC']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(4,$col,$list[$i]['Designation']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(5,$col,$list[$i]['accountId']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(6,$col,$list[$i]['Account']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(7,$col,$list[$i]['department']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(8,$col,$list[$i]['ShiftStartTime']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(9,$col,$list[$i]['ShiftEndTime']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(10,$col,$list[$i]['Intime']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(11,$col,$list[$i]['OutTime']);
        $col++;

    }
    $styleArray = array(
        'font'  => array(
            'bold'  => true,
            'color' => array('rgb' => '#f79727'),
            'size'  => 10
        ));
    $objPHPExcel->getActiveSheet()->getStyle('A1:L2')->applyFromArray($styleArray);

    //$objPHPExcel->getActiveSheet()->setTitle('sffd');

    $objPHPExcel->setActiveSheetIndex(0);

    ob_end_clean();
    ob_start();

    header('Content-Type: application/vnd.ms-excel');
    header('Content-Disposition: attachment;filename='.$model['startDate'].' to '.$model['endDate'].'.xls');
    header('Cache-Control: max-age=0');
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
    $objWriter->save('php://output');
  }

//============================================================================================
public function actionMercantileHolidayWorkingReport(){
    $model = new MercantileHolidayWorkingReport;
    if(isset($_POST['MercantileHolidayWorkingReport'])){
        $model-> attributes = $_POST['MercantileHolidayWorkingReport'];

        if($model->validate()){
            if(isset($_POST['accounts'])){
                $list= Yii::app()->db->createCommand("SELECT A.AccountOracleCode accountId,T.date PoyaDate,E.id Id,E.Namewithini Name,E.nic NIC,D.type Designation,A.name Account,S.StartTime ShiftStartTime,S.EndTime ShiftEndTime,T.Intime Intime,T.OuteTime OutTime,DP.name department
                    FROM timesheet T
                    INNER JOIN employee E ON E.id = T.EmployeeId
                    INNER JOIN designation D ON D.id = T.DesignaId
                    INNER JOIN accounts A ON A.id = E.Accountid
                    INNER JOIN department DP ON DP.id = E.departmentid
                    INNER JOIN employee_shift ES ON ES.id = T.EmployeeShiftid
                    INNER JOIN shift S ON S.id = ES.ShiftId
                    WHERE E.accountId IN (".implode(',',$_POST['accounts']).") AND T.date IN (
                                    SELECT H.Date
                                    FROM holydays H
                                    WHERE H.Date >= Date('$model->startDate') AND H.Date <= Date('$model->endDate') AND H.Is_Mercantile ='MERCANTILE') ORDER BY Account")->queryAll();
            }else{
                if(Yii::app()->user->isAdmin()){
                    $list= Yii::app()->db->createCommand("SELECT A.AccountOracleCode accountId,T.date PoyaDate,E.id Id,E.Namewithini Name,E.nic NIC,D.type Designation,A.name Account,S.StartTime ShiftStartTime,S.EndTime ShiftEndTime,T.Intime Intime,T.OuteTime OutTime,DP.name department
                    FROM timesheet T
                    INNER JOIN employee E ON E.id = T.EmployeeId
                    INNER JOIN designation D ON D.id = T.DesignaId
                    INNER JOIN accounts A ON A.id = E.Accountid
                    INNER JOIN department DP ON DP.id = E.departmentid
                    INNER JOIN employee_shift ES ON ES.id = T.EmployeeShiftid
                    INNER JOIN shift S ON S.id = ES.ShiftId
                    WHERE T.date IN (
                                    SELECT H.Date
                                    FROM holydays H
                                    WHERE H.Date >= Date('$model->startDate') AND H.Date <= Date('$model->endDate') AND H.Is_Mercantile ='MERCANTILE') ORDER BY Account")->queryAll();
                }else{
                    $sitid = Yii::app()->user->data()->SiteId;
                    $list= Yii::app()->db->createCommand("SELECT A.AccountOracleCode accountId,T.date PoyaDate,E.id Id,E.Namewithini Name,E.nic NIC,D.type Designation,A.name Account,S.StartTime ShiftStartTime,S.EndTime ShiftEndTime,T.Intime Intime,T.OuteTime OutTime,DP.name department
                    FROM timesheet T
                    INNER JOIN employee E ON E.id = T.EmployeeId
                    INNER JOIN designation D ON D.id = T.DesignaId
                    INNER JOIN accounts A ON A.id = E.Accountid
                    INNER JOIN department DP ON DP.id = E.departmentid
                    INNER JOIN employee_shift ES ON ES.id = T.EmployeeShiftid
                    INNER JOIN shift S ON S.id = ES.ShiftId
                    WHERE E.siteid = $sitid AND T.date IN (
                                    SELECT H.Date
                                    FROM holydays H
                                    WHERE H.Date >= Date('$model->startDate') AND H.Date <= Date('$model->endDate') AND H.Is_Mercantile ='MERCANTILE') ORDER BY Account")->queryAll();
                }
            }


            // print_r($list);
            // die;
            $this->render('//holydays/ViewMercantileHolidayWorkingReport',array('list'=>$list,'model'=>$model));
        }

    }else{
        return $this->render('//holydays/CreateMercantileHolidayWorkingReport',array('model'=>$model));
    }
}
//========================================================================================
public function actionMercantileHolidayWorkingReportPDF()
{

    $list = CJSON::decode($_POST['list']);
    $model = CJSON::decode($_POST['model']);
    $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
    $mPDF1->setAutoBottomMargin = 'stretch';
    $mPDF1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
    $mPDF1->WriteHTML($this->renderPartial('//holydays/MercantileHolidayWorkingReportPDF',array('list'=>$list,'model'=>$model),true));
    $file_name= $model['startDate'].'-'.$model['endDate'].'Created On'.date("Y-m-d  -  h:i:sa").'Mercantile.pdf';


    ob_end_clean();
    $mPDF1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );
}
//=========================================================================

public function actionManualTimeAdjustmentReport(){
    $model = new ManualTimeAdjustmentReport;
    if(isset($_POST['ManualTimeAdjustmentReport'])){
        $model-> attributes = $_POST['ManualTimeAdjustmentReport'];

        if($model->validate()){
            $list= Yii::app()->db->createCommand("SELECT E.id Id,E.Namewithini Name,E.nic NIC,TC.CreatedON CreatedDate,U.username CreatedBy,TC.OldInTime OldInTime,TC.NewIntime NewInTime,TC.OldOutTime OldOutTime,TC.NewOutTime NewOutTime
            FROM timsheetchange TC
            INNER JOIN timesheet T ON T.id = TC.TimeSheetId
            INNER JOIN employee E ON E.id = T.EmployeeId
            INNER JOIN user U ON U.id = TC.CreatedBy
            WHERE TC.CreatedON >= DATE('$model->startDate') AND TC.CreatedON <= DATE('$model->endDate')")->queryAll();
            // print_r($list);
            // die;
            $this->render('//timsheetchange/ViewManualTimeAdjustmentReport',array('list'=>$list,'model'=>$model));
        }

    }else{
        return $this->render('//timsheetchange/CreateManualTimeAdjustmentReport',array('model'=>$model));
    }
}
//========================================================================================
public function actionManualTimeAdjustmentReportPDF()
{

    $list = CJSON::decode($_POST['list']);
    $model = CJSON::decode($_POST['model']);
    $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
    $mPDF1->setAutoBottomMargin = 'stretch';
    $mPDF1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
    $mPDF1->WriteHTML($this->renderPartial('//timsheetchange/ManualTimeAdjustmentReportPDF',array('list'=>$list,'model'=>$model),true));
    $file_name= $model['startDate'].'-'.$model['endDate'].' TimeAdjustment.pdf';


    ob_end_clean();
    $mPDF1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );
}
//=========================================================================
public function actionManualTimeAdjustmentReportExcel(){
    $objPHPExcel = new PHPExcel();
    $list = CJSON::decode($_POST['list']);
    $model = CJSON::decode($_POST['model']);

    // print_r($list);
    // die;

    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue('A1', 'Manual Time Adjustment Report')
    ->setCellValue('E1', 'Generated On')
    ->setCellValue('F1', date("Y-m-d - h:i:sa"))
    ->setCellValue('A2', 'Id')
    ->setCellValue('B2', 'Name')
    ->setCellValue('C2', 'NIC')
    ->setCellValue('D2', 'Modified On')
    ->setCellValue('E2', 'Modified By')
    ->setCellValue('F2', 'InTime(Old)')
    ->setCellValue('G2', 'InTime(New)')
    ->setCellValue('H2', 'Out Time(Old)')
    ->setCellValue('I2', 'Out Time(New)');
    $col = 3;


    for($i = 0;$i < count($list);$i++){

        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0,$col,$list[$i]['Id']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1,$col,$list[$i]['Name']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2,$col,$list[$i]['NIC']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(3,$col,$list[$i]['CreatedDate']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(4,$col,$list[$i]['CreatedBy']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(5,$col,$list[$i]['OldInTime']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(6,$col,$list[$i]['NewInTime']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(7,$col,$list[$i]['OldOutTime']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(8,$col,$list[$i]['NewOutTime']);
        $col++;

    }
    $styleArray = array(
        'font'  => array(
            'bold'  => true,
            'color' => array('rgb' => '#f79727'),
            'size'  => 10
        ));
    $objPHPExcel->getActiveSheet()->getStyle('A1:I2')->applyFromArray($styleArray);

    //$objPHPExcel->getActiveSheet()->setTitle('sffd');

    $objPHPExcel->setActiveSheetIndex(0);

    ob_end_clean();
    ob_start();

    header('Content-Type: application/vnd.ms-excel');
    header('Content-Disposition: attachment;filename='.$model['startDate'].' to '.$model['endDate'].'.xls');
    header('Cache-Control: max-age=0');
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
    $objWriter->save('php://output');
  }

//============================================================================================
//============================================================================================
public function actionCreateDailyWorkingHoursReport(){
    $model = new DailyWorkingHoursReport;
    if(isset($_POST['DailyWorkingHoursReport'])){
        $model-> attributes = $_POST['DailyWorkingHoursReport'];

        if($model->validate()){
            if(isset($_POST['accounts'])){
                $list= Yii::app()->db->createCommand("SELECT A.AccountOracleCode accountId,E.Namewithini Name,A.name Account,T.Intime StartTime, T.OuteTime EndTime ,E.nic NIC,D.type Designation,(T.WorkedHour + T.TotalOTHour) Hours,DP.name department
                    FROM timesheet T
                    INNER JOIN employee E ON E.id = T.EmployeeId
                    INNER JOIN department DP ON DP.id = E.departmentid
                    INNER JOIN designation D ON D.id = T.DesignaId
                    INNER JOIN employee_shift ES ON ES.id = T.EmployeeShiftid
                    INNER JOIN shift S ON S.id = ES.ShiftId
                    INNER JOIN accounts A ON A.id = E.Accountid
                    WHERE E.accountId IN (".implode(',',$_POST['accounts']).") AND T.date >= DATE('$model->startDate') AND T.date <= DATE('$model->endDate') ORDER BY Account,Name,StartTime")->queryAll();
            }else{
                if(Yii::app()->user->isAdmin()){
                    $list= Yii::app()->db->createCommand("SELECT A.AccountOracleCode accountId,E.Namewithini Name,A.name Account,T.Intime StartTime, T.OuteTime EndTime ,E.nic NIC,D.type Designation,(T.WorkedHour + T.TotalOTHour) Hours ,DP.name department
                    FROM timesheet T
                    INNER JOIN employee E ON E.id = T.EmployeeId
                    INNER JOIN department DP ON DP.id = E.departmentid
                    INNER JOIN designation D ON D.id = T.DesignaId
                    INNER JOIN employee_shift ES ON ES.id = T.EmployeeShiftid
                    INNER JOIN shift S ON S.id = ES.ShiftId
                    INNER JOIN accounts A ON A.id = E.Accountid
                    WHERE T.date >= DATE('$model->startDate') AND T.date <= DATE('$model->endDate') ORDER BY Account,Name,StartTime")->queryAll();

                }else{
                    $sitid = Yii::app()->user->data()->SiteId;
                    $list= Yii::app()->db->createCommand("SELECT A.AccountOracleCode accountId,E.Namewithini Name,A.name Account,T.Intime StartTime, T.OuteTime EndTime ,E.nic NIC,D.type Designation,(T.WorkedHour + T.TotalOTHour) Hours ,DP.name department
                    FROM timesheet T
                    INNER JOIN employee E ON E.id = T.EmployeeId
                    INNER JOIN department DP ON DP.id = E.departmentid
                    INNER JOIN designation D ON D.id = T.DesignaId
                    INNER JOIN employee_shift ES ON ES.id = T.EmployeeShiftid
                    INNER JOIN shift S ON S.id = ES.ShiftId
                    INNER JOIN accounts A ON A.id = E.Accountid
                    WHERE E.siteid = $sitid AND T.date >= DATE('$model->startDate') AND T.date <= DATE('$model->endDate') ORDER BY Account,Name,StartTime")->queryAll();
                }
            }


            // print_r($list);
            // die;
            $this->render('//timeSheet/ViewDailyWorkingHoursReport',array('list'=>$list,'model'=>$model));
        }

    }else{
        return $this->render('//timeSheet/CreateDailyWorkingHoursReport',array('model'=>$model));
    }
}
//============================================================================================
public function actionCreateWorkingHoursReport()
{
    $model = new WorkingHoursReport;
    if(isset($_POST['WorkingHoursReport'])){
        $model-> attributes = $_POST['WorkingHoursReport'];

        if($model->validate()){
            if(isset($_POST['accounts'])){
                $list= Yii::app()->db->createCommand("SELECT A.AccountOracleCode accountId,E.Namewithini Name,A.name Account,T.Intime StartTime, T.OuteTime EndTime ,E.nic NIC,D.type Designation,(T.WorkedHour + T.TotalOTHour) Hours ,DP.name department
                    FROM timesheet T
                    INNER JOIN employee E ON E.id = T.EmployeeId
                    INNER JOIN department DP ON DP.id = E.departmentid
                    INNER JOIN designation D ON D.id = T.DesignaId
                    INNER JOIN employee_shift ES ON ES.id = T.EmployeeShiftid
                    INNER JOIN shift S ON S.id = ES.ShiftId
                    INNER JOIN accounts A ON A.id = E.Accountid
                    WHERE E.accountId IN (".implode(',',$_POST['accounts']).") AND T.date >= DATE('$model->startDate') AND T.date <= DATE('$model->endDate') AND (T.WorkedHour + T.TotalOTHour) > $model->hours ORDER BY Account,Name,StartTime")->queryAll();
            }else{
                if(Yii::app()->user->isAdmin()){
                    $list= Yii::app()->db->createCommand("SELECT A.AccountOracleCode accountId,E.Namewithini Name,A.name Account,T.Intime StartTime, T.OuteTime EndTime ,E.nic NIC,D.type Designation,(T.WorkedHour + T.TotalOTHour) Hours ,DP.name department
                    FROM timesheet T
                    INNER JOIN employee E ON E.id = T.EmployeeId
                    INNER JOIN department DP ON DP.id = E.departmentid
                    INNER JOIN designation D ON D.id = T.DesignaId
                    INNER JOIN employee_shift ES ON ES.id = T.EmployeeShiftid
                    INNER JOIN shift S ON S.id = ES.ShiftId
                    INNER JOIN accounts A ON A.id = E.Accountid
                    WHERE T.date >= DATE('$model->startDate') AND T.date <= DATE('$model->endDate') AND (T.WorkedHour + T.TotalOTHour) > $model->hours ORDER BY Account,Name,StartTime")->queryAll();
                }else{
                    $sitid = Yii::app()->user->data()->SiteId;
                    $list= Yii::app()->db->createCommand("SELECT A.AccountOracleCode accountId,E.Namewithini Name,A.name Account,T.Intime StartTime, T.OuteTime EndTime ,E.nic NIC,D.type Designation,(T.WorkedHour + T.TotalOTHour) Hours ,DP.name department
                    FROM timesheet T
                    INNER JOIN employee E ON E.id = T.EmployeeId
                    INNER JOIN department DP ON DP.id = E.departmentid
                    INNER JOIN designation D ON D.id = T.DesignaId
                    INNER JOIN employee_shift ES ON ES.id = T.EmployeeShiftid
                    INNER JOIN shift S ON S.id = ES.ShiftId
                    INNER JOIN accounts A ON A.id = E.Accountid
                    WHERE E.siteid = $sitid AND T.date >= DATE('$model->startDate') AND T.date <= DATE('$model->endDate') AND (T.WorkedHour + T.TotalOTHour) > $model->hours ORDER BY Account,Name,StartTime")->queryAll();
                }
            }

            $this->render('//timeSheet/ViewDailyWorkingHoursReport',array('list'=>$list,'model'=>$model));
        }

    }else{
        return $this->render('//timeSheet/CreateWorkingHoursReport',array('model'=>$model));
    }
}
//============================================================================================
public function actionResignEmployeesListReport(){
    $model = new ResignEmployeesListReport;
    if(isset($_POST['ResignEmployeesListReport'])){
        $model-> attributes = $_POST['ResignEmployeesListReport'];

        if($model->validate()){
            if(isset($_POST['accounts'])){
                $list= Yii::app()->db->createCommand("SELECT A.AccountOracleCode accountId,E.Namewithini Name,E.nic NIC,E.id Id,A.name Account,m1.affective_date Date,S.name Site,D.type Designation,DP.name department
                    FROM employee_status_history m1
                    LEFT JOIN employee_status_history m2 ON (m1.emp_id = m2.emp_id AND m1.id < m2.id)
                    INNER JOIN employee E ON E.id = m1.emp_id
                    INNER JOIN sites S ON S.id = E.siteid
                    INNER JOIN accounts A ON A.id = E.Accountid
                    INNER JOIN department DP ON DP.id = E.departmentid
                    INNER JOIN designation D ON D.id = E.designationid
                    WHERE E.accountId IN (".implode(',',$_POST['accounts']).") AND m2.id IS NULL AND m1.status_id = 2 AND m1.affective_date >= DATE('$model->startDate') AND m1.affective_date <= DATE('$model->endDate') ORDER BY Account")->queryAll();
            }else{
                if(Yii::app()->user->isAdmin()){
                    $list= Yii::app()->db->createCommand("SELECT A.AccountOracleCode accountId,E.Namewithini Name,E.nic NIC,E.id Id,A.name Account,m1.affective_date Date,S.name Site,D.type Designation,DP.name department
                    FROM employee_status_history m1
                    LEFT JOIN employee_status_history m2 ON (m1.emp_id = m2.emp_id AND m1.id < m2.id)
                    INNER JOIN employee E ON E.id = m1.emp_id
                    INNER JOIN sites S ON S.id = E.siteid
                    INNER JOIN accounts A ON A.id = E.Accountid
                    INNER JOIN department DP ON DP.id = E.departmentid
                    INNER JOIN designation D ON D.id = E.designationid
                    WHERE m2.id IS NULL AND m1.status_id = 2 AND m1.affective_date >= DATE('$model->startDate') AND m1.affective_date <= DATE('$model->endDate') ORDER BY Account")->queryAll();
                }else{
                    $sitid = Yii::app()->user->data()->SiteId;
                    $list= Yii::app()->db->createCommand("SELECT A.AccountOracleCode accountId,E.Namewithini Name,E.nic NIC,E.id Id,A.name Account,m1.affective_date Date,S.name Site,D.type Designation,DP.name department
                    FROM employee_status_history m1
                    LEFT JOIN employee_status_history m2 ON (m1.emp_id = m2.emp_id AND m1.id < m2.id)
                    INNER JOIN employee E ON E.id = m1.emp_id
                    INNER JOIN sites S ON S.id = E.siteid
                    INNER JOIN accounts A ON A.id = E.Accountid
                    INNER JOIN department DP ON DP.id = E.departmentid
                    INNER JOIN designation D ON D.id = E.designationid
                    WHERE E.siteid = $sitid AND m2.id IS NULL AND m1.status_id = 2 AND m1.affective_date >= DATE('$model->startDate') AND m1.affective_date <= DATE('$model->endDate') ORDER BY Account")->queryAll();
                }
            }


            // print_r($list);
            // die;
            $this->render('//timeSheet/ViewResignEmployeesListReport',array('list'=>$list,'model'=>$model));
        }

    }else{
        return $this->render('//timeSheet/CreateResignEmployeesListReport',array('model'=>$model));
    }
}
//============================================================================================
public function actionResignEmployeesListPDF()
{

    $list = CJSON::decode($_POST['list']);
    $model = CJSON::decode($_POST['model']);
    $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
    $mPDF1->setAutoBottomMargin = 'stretch';
    $mPDF1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
    $mPDF1->WriteHTML($this->renderPartial('//timeSheet/ResignEmployeesListPDF',array('list'=>$list,'model'=>$model),true));
    $file_name= $model['startDate'].'.pdf';


    ob_end_clean();
    $mPDF1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );
}
//=========================================================================
public function actionResignEmployeesListExcel(){
    $objPHPExcel = new PHPExcel();
    $list = CJSON::decode($_POST['list']);
    $model = CJSON::decode($_POST['model']);

    // print_r($list);
    // die;

    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue('A1', 'Resign Employees List')
    ->setCellValue('E1', 'Generated On')
    ->setCellValue('F1', date("Y-m-d - h:i:sa"))
    ->setCellValue('A2', 'Id')
    ->setCellValue('B2', 'Name')
    ->setCellValue('C2', 'NIC')
    ->setCellValue('D2', 'Designation')
    ->setCellValue('E2', 'Site')
    ->setCellValue('F2', 'Client Code')
    ->setCellValue('G2', 'Client Name')
    ->setCellValue('H2', 'Date')
    ->setCellValue('I2', 'Department');
    $col = 3;


    for($i = 0;$i < count($list);$i++){

        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0,$col,$list[$i]['Id']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1,$col,$list[$i]['Name']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2,$col,$list[$i]['NIC']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(3,$col,$list[$i]['Designation']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(4,$col,$list[$i]['Site']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(5,$col,$list[$i]['accountId']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(6,$col,$list[$i]['Account']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(7,$col,$list[$i]['Date']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(8,$col,$list[$i]['department']);
        $col++;

    }
    $styleArray = array(
        'font'  => array(
            'bold'  => true,
            'color' => array('rgb' => '#f79727'),
            'size'  => 10
        ));
    $objPHPExcel->getActiveSheet()->getStyle('A1:I2')->applyFromArray($styleArray);

    //$objPHPExcel->getActiveSheet()->setTitle('sffd');

    $objPHPExcel->setActiveSheetIndex(0);

    ob_end_clean();
    ob_start();

    header('Content-Type: application/vnd.ms-excel');
    header('Content-Disposition: attachment;filename='.$model['startDate'].' to '.$model['endDate'].'.xls');
    header('Cache-Control: max-age=0');
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
    $objWriter->save('php://output');
  }

//============================================================================================
public function actionDailyWorkingHoursReportPdf()
{
    $list = CJSON::decode($_POST['list']);
    $model = CJSON::decode($_POST['model']);
    $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
    $mPDF1->setAutoBottomMargin = 'stretch';
    $mPDF1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
    $mPDF1->WriteHTML($this->renderPartial('//timeSheet/DailyWorkingHoursReportPDF',array('list'=>$list,'model'=>$model),true));
    $file_name= $model['startDate'].'-'.$model['endDate'].'.pdf';


    ob_end_clean();
    $mPDF1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );
}
//=========================================================================

public function actionDailyWorkingHoursReportExcel(){
    $objPHPExcel = new PHPExcel();
    $list = CJSON::decode($_POST['list']);
    $model = CJSON::decode($_POST['model']);

    // print_r($model);
    // die;

    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue('A1', 'Working Hours Report')
    ->setCellValue('E1', 'Generated On')
    ->setCellValue('F1', date("Y-m-d - h:i:sa"))
    ->setCellValue('A2', 'Name')
    ->setCellValue('B2', 'Nic')
    ->setCellValue('C2', 'Designation')
    ->setCellValue('D2', 'Client Code')
    ->setCellValue('E2', 'Client Name')
    ->setCellValue('F2', 'Department')
    ->setCellValue('G2', 'In time')
    ->setCellValue('H2', 'Out time')
    ->setCellValue('I2', 'Hours');
    $col = 3;


    for($i = 0;$i < count($list);$i++){

        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0,$col,$list[$i]['Name']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1,$col,$list[$i]['NIC']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2,$col,$list[$i]['Designation']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(3,$col,$list[$i]['accountId']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(4,$col,$list[$i]['Account']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(5,$col,$list[$i]['department']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(6,$col,$list[$i]['StartTime']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(7,$col,$list[$i]['EndTime']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(8,$col,$list[$i]['Hours']);
        $col++;

    }
    $styleArray = array(
        'font'  => array(
            'bold'  => true,
            'color' => array('rgb' => '#f79727'),
            'size'  => 10
        ));
    $objPHPExcel->getActiveSheet()->getStyle('A1:i2')->applyFromArray($styleArray);

    $objPHPExcel->getActiveSheet()->setTitle($model['startDate']);

    $objPHPExcel->setActiveSheetIndex(0);

    ob_end_clean();
    ob_start();

    header('Content-Type: application/vnd.ms-excel');
    header('Content-Disposition: attachment;filename='.$model['startDate'].'.xls');
    header('Cache-Control: max-age=0');
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
    $objWriter->save('php://output');
  }

//============================================================================================
public function actiontimesheetExcel(){
    $objPHPExcel = new PHPExcel();
    $timesheet = CJSON::decode($_POST['timesheet']);
    $checkedlist = CJSON::decode($_POST['checkedlist']);
    $employeeId = CJSON::decode($_POST['employeeId']);
    //  print_r($checkedlist);
    // die;



    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue('A1', 'Time Sheet')
    ->setCellValue('E1', 'Generated On')
    ->setCellValue('F1', date("Y-m-d - h:i:sa"))
    ->setCellValue('A3', 'In Time ')
    ->setCellValue('B3', 'Out Time')
    ->setCellValue('C3', 'Worked Hour')
    ->setCellValue('D3', 'In Late Deduct')
    ->setCellValue('E3', 'Out Late Deduct')        
    ->setCellValue('F3', 'N-OT Hour')
    ->setCellValue('G3', 'D-OT Hour')
    ->setCellValue('H3', 'T-OT Hour')
    ->setCellValue('I3', 'PreOT Hour')         
    ->setCellValue('J3', 'Total OT Hour');
$col = 4;
$WorkrdHour =0;
$LateDeductTime = 0;
$OutDeductTime =0;
$NOTHour =0;
$DOTHour = 0;
$TOTHour =0;
$PreOT = 0;
$TotalOT =0;
        
foreach($timesheet as $value){
    
    $row = 0;
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$col,$value['Intime']);
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['OuteTime']);
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,Yii::app()->commonUtil->convertToHoursMins($value['WorkedHour']));
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,Yii::app()->commonUtil->convertToHoursMins($value['LatedeductTime']));
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,Yii::app()->commonUtil->convertToHoursMins($value['OutLateDeductTime']));
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,Yii::app()->commonUtil->convertToHoursMins($value['NOvertimeHours']));
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,Yii::app()->commonUtil->convertToHoursMins($value['DOverTimeHour']));
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,Yii::app()->commonUtil->convertToHoursMins($value['TOverTimeHour']));
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,Yii::app()->commonUtil->convertToHoursMins($value['PreOTHour']));
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,Yii::app()->commonUtil->convertToHoursMins($value['TotalOTHour']));
    
    $WorkrdHour += $value['WorkedHour'];
    $LateDeductTime += $value['LatedeductTime'];
    $OutDeductTime += $value['OutLateDeductTime'];
    $NOTHour += $value['NOvertimeHours'];
    $DOTHour += $value['DOverTimeHour'];
    $TOTHour += $value['TOverTimeHour'];
    $PreOT += $value['PreOTHour'];
    $TotalOT += $value['TotalOTHour'];
    $col++;
   
}
$row =1;
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(0, $col)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(1, $col)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(2, $col)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(3, $col)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(4, $col)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(5, $col)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(6, $col)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(7, $col)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(8, $col)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(9, $col)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));

        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, $col, "TOTAL");
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$row, $col, Yii::app()->commonUtil->convertToHoursMins($WorkrdHour));
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$row, $col, Yii::app()->commonUtil->convertToHoursMins($LateDeductTime));
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$row, $col, Yii::app()->commonUtil->convertToHoursMins($OutDeductTime));
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$row, $col, Yii::app()->commonUtil->convertToHoursMins($NOTHour));
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$row, $col, Yii::app()->commonUtil->convertToHoursMins($DOTHour));
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$row, $col, Yii::app()->commonUtil->convertToHoursMins($TOTHour));
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$row, $col, Yii::app()->commonUtil->convertToHoursMins($PreOT));
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$row, $col, Yii::app()->commonUtil->convertToHoursMins($TotalOT));

        $styleArray = array(
    'font'  => array(
        'bold'  => true,
        'color' => array('rgb' => '#f79727'),
        'size'  => 10
    ));
$objPHPExcel->getActiveSheet()->getStyle('A1:Y3')->applyFromArray($styleArray);



    $objPHPExcel->getActiveSheet()->setTitle($timesheet[0]['Namewithini']);

    $objPHPExcel->setActiveSheetIndex(0);

    ob_end_clean();
    ob_start();

    header('Content-Type: application/vnd.ms-excel');
    header('Content-Disposition: attachment;filename='.$timesheet[0]['Namewithini'].'.xls');
    header('Cache-Control: max-age=0');
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
    $objWriter->save('php://output');
  }
//============================================================================================
public function actionSundayWorkingReport(){

    $model = new SundayWorkingReport;
    if(isset($_POST['SundayWorkingReport'])){
        $model-> attributes = $_POST['SundayWorkingReport'];
        if($model->validate()){
            $sunDaysArr = $this->getDateForSpecificDayBetweenDates(DATE($model->startDate), DATE($model->endDate), 0);
            $comma_separated = implode("','", $sunDaysArr);
            $comma_separated = "'".$comma_separated."'";
            if($comma_separated != "''"){
                if(isset($_POST['accounts'])){
                    $list= Yii::app()->db->createCommand("SELECT A.AccountOracleCode accountId,T.date Sundays,E.id Id,E.Namewithini Name,E.nic NIC,D.type Designation,A.name Account,S.StartTime StartTime, S.EndTime EndTime,T.Intime InTime,T.OuteTime OutTime,DP.name department
                        FROM timesheet T
                        INNER JOIN employee E ON E.id = T.EmployeeId
                        INNER JOIN accounts A ON A.id = E.Accountid
                        INNER JOIN department DP ON DP.id = E.departmentid
                        LEFT JOIN employee_shift ES ON ES.id = T.EmployeeShiftid
                        LEFT JOIN shift S ON S.id = ES.ShiftId
                        INNER JOIN designation D ON D.id = E.designationid
                        WHERE E.accountId IN (".implode(',',$_POST['accounts']).") AND T.date in ($comma_separated) AND E.statusId = 1 ORDER BY Sundays")->queryAll();
                }else{
                    if(Yii::app()->user->isAdmin()){
                        $list= Yii::app()->db->createCommand("SELECT A.AccountOracleCode accountId,T.date Sundays,E.id Id,E.Namewithini Name,E.nic NIC,D.type Designation,A.name Account,S.StartTime StartTime, S.EndTime EndTime,T.Intime InTime,T.OuteTime OutTime,DP.name department
                        FROM timesheet T
                        INNER JOIN employee E ON E.id = T.EmployeeId
                        INNER JOIN accounts A ON A.id = E.Accountid
                        INNER JOIN department DP ON DP.id = E.departmentid
                        LEFT JOIN employee_shift ES ON ES.id = T.EmployeeShiftid
                        LEFT JOIN shift S ON S.id = ES.ShiftId
                        INNER JOIN designation D ON D.id = E.designationid
                        WHERE T.date in ($comma_separated) AND E.statusId = 1 ORDER BY Sundays")->queryAll();
                    }else{
                        $sitid = Yii::app()->user->data()->SiteId;
                        $list= Yii::app()->db->createCommand("SELECT A.AccountOracleCode accountId,T.date Sundays,E.id Id,E.Namewithini Name,E.nic NIC,D.type Designation,A.name Account,S.StartTime StartTime, S.EndTime EndTime,T.Intime InTime,T.OuteTime OutTime,DP.name department
                        FROM timesheet T
                        INNER JOIN employee E ON E.id = T.EmployeeId
                        INNER JOIN accounts A ON A.id = E.Accountid
                        INNER JOIN department DP ON DP.id = E.departmentid
                        LEFT JOIN employee_shift ES ON ES.id = T.EmployeeShiftid
                        LEFT JOIN shift S ON S.id = ES.ShiftId
                        INNER JOIN designation D ON D.id = E.designationid
                        WHERE E.siteid = $sitid AND T.date in ($comma_separated) AND E.statusId = 1 ORDER BY Sundays")->queryAll();
                    }
                }


            }else{
                $list = [];
            }
            $this->render('//timeSheet/ViewSundayWorkingReport',array('list'=>$list,'model'=>$model));
        }

    }else{
        return $this->render('//timeSheet/CreateSundayWorkingReport',array('model'=>$model));
    }
        // function for find sunday

}

function getDateForSpecificDayBetweenDates($startDate, $endDate, $weekdayNumber)
{
    $startDate = strtotime($startDate);
    $endDate = strtotime($endDate);

    $dateArr = array();

    do
    {
        if(date("w", $startDate) != $weekdayNumber)
        {
            $startDate += (24 * 3600); // add 1 day
        }
    } while(date("w", $startDate) != $weekdayNumber);


    while($startDate <= $endDate)
    {
        $dateArr[] = date('Y-m-d', $startDate);
        $startDate += (7 * 24 * 3600); // add 7 days
    }

    return($dateArr);
}
//============================================================================================
public function actionSundayWorkingReportPDF()
{

    $list = CJSON::decode($_POST['list']);
    $model = CJSON::decode($_POST['model']);
    $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
    $mPDF1->setAutoBottomMargin = 'stretch';
    $mPDF1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
    $mPDF1->WriteHTML($this->renderPartial('//timeSheet/SundayWorkingReportPDF',array('list'=>$list,'model'=>$model),true));
    $file_name= $model['startDate'].'-'.$model['endDate'].' Sundays.pdf';


    ob_end_clean();
    $mPDF1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );
}
//=========================================================================
public function actionSundayWorkingReportExcel(){
    $objPHPExcel = new PHPExcel();
    $list = CJSON::decode($_POST['list']);
    $model = CJSON::decode($_POST['model']);

    // print_r($list);
    // die;

    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue('A1','Sunday Working Report')
    ->setCellValue('E1', 'Generated On')
    ->setCellValue('F1', date("Y-m-d - h:i:sa"))
    ->setCellValue('A2', 'Sunday')
    ->setCellValue('B2', 'Id')
    ->setCellValue('C2', 'Name')
    ->setCellValue('D2', 'NIC')
    ->setCellValue('E2', 'Designation')
    ->setCellValue('F2', 'Client Code')
    ->setCellValue('G2', 'Client Name')
    ->setCellValue('H2', 'Department')
    ->setCellValue('I2', 'Shift Start Time')
    ->setCellValue('J2', 'Shift End Time')
    ->setCellValue('K2', 'In Time')
    ->setCellValue('L2', 'Out Time');
    $col = 3;


    for($i = 0;$i < count($list);$i++){

        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0,$col,$list[$i]['Sundays']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1,$col,$list[$i]['Id']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2,$col,$list[$i]['Name']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(3,$col,$list[$i]['NIC']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(4,$col,$list[$i]['Designation']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(5,$col,$list[$i]['accountId']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(6,$col,$list[$i]['Account']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(7,$col,$list[$i]['department']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(8,$col,$list[$i]['StartTime']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(9,$col,$list[$i]['EndTime']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(10,$col,$list[$i]['InTime']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(11,$col,$list[$i]['OutTime']);
        $col++;

    }
    $styleArray = array(
        'font'  => array(
            'bold'  => true,
            'color' => array('rgb' => '#f79727'),
            'size'  => 10
        ));
    $objPHPExcel->getActiveSheet()->getStyle('A1:L2')->applyFromArray($styleArray);

    //$objPHPExcel->getActiveSheet()->setTitle('sffd');

    $objPHPExcel->setActiveSheetIndex(0);

    ob_end_clean();
    ob_start();

    header('Content-Type: application/vnd.ms-excel');
    header('Content-Disposition: attachment;filename='.$model['startDate'].' to '.$model['endDate'].'.xls');
    header('Cache-Control: max-age=0');
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
    $objWriter->save('php://output');
  }

//============================================================================================
public function actionDailyOvertimeReport(){

    $model = new DailyOvertimeReport;
    if(isset($_POST['DailyOvertimeReport'])){
        $model-> attributes = $_POST['DailyOvertimeReport'];
        if($model->validate()){
            if(isset($_POST['accounts'])){
                $list= Yii::app()->db->createCommand("SELECT D.type designation,A.AccountOracleCode accountId,E.id Id,E.Namewithini Name,A.name Account,T.date,E.nic NIC,(T.NOvertimeHours+T.DOverTimeHour+T.TOverTimeHour) Overtime,DP.name department
                    FROM timesheet T
                    INNER JOIN employee E ON E.id = T.EmployeeId
                    INNER JOIN department DP ON DP.id = E.departmentid
                    INNER JOIN accounts A ON A.id = E.Accountid
                    INNER JOIN designation D ON D.id = E.designationid
                    WHERE E.accountId IN (".implode(',',$_POST['accounts']).") AND T.date >= DATE('$model->startDate') AND T.date <= DATE('$model->endDate') AND (T.NOvertimeHours+T.DOverTimeHour+T.TOverTimeHour) > 0.00  ORDER BY Account")->queryAll();
            }else{
                if(Yii::app()->user->isAdmin()){
                    $list= Yii::app()->db->createCommand("SELECT D.type designation,A.AccountOracleCode accountId,E.id Id,E.Namewithini Name,A.name Account,T.date,E.nic NIC,(T.NOvertimeHours+T.DOverTimeHour+T.TOverTimeHour) Overtime,DP.name department
                    FROM timesheet T
                    INNER JOIN employee E ON E.id = T.EmployeeId
                    INNER JOIN department DP ON DP.id = E.departmentid
                    INNER JOIN accounts A ON A.id = E.Accountid
                    INNER JOIN designation D ON D.id = E.designationid
                    WHERE T.date >= DATE('$model->startDate') AND T.date <= DATE('$model->endDate') AND (T.NOvertimeHours+T.DOverTimeHour+T.TOverTimeHour) > 0.00 ORDER BY Account")->queryAll();
                }else{
                    $sitid = Yii::app()->user->data()->SiteId;
                    $list= Yii::app()->db->createCommand("SELECT D.type designation,A.AccountOracleCode accountId,E.id Id,E.Namewithini Name,A.name Account,T.date,E.nic NIC,(T.NOvertimeHours+T.DOverTimeHour+T.TOverTimeHour) Overtime,DP.name department
                    FROM timesheet T
                    INNER JOIN employee E ON E.id = T.EmployeeId
                    INNER JOIN department DP ON DP.id = E.departmentid
                    INNER JOIN accounts A ON A.id = E.Accountid
                    INNER JOIN designation D ON D.id = E.designationid
                    WHERE E.siteid = $sitid AND T.date >= DATE('$model->startDate') AND T.date <= DATE('$model->endDate') AND (T.NOvertimeHours+T.DOverTimeHour+T.TOverTimeHour) > 0.00  ORDER BY Account")->queryAll();
                }
            }


            //  print_r($list);
            //  die;

            $this->render('//timeSheet/ViewDailyOvertimeReport',array('list'=>$list,'model'=>$model));

        }

    }else{
        return $this->render('//timeSheet/CreateDailyOvertimeReport',array('model'=>$model));
    }


}


//============================================================================================
public function actionDailyOvertimeReportPDF()
{

    $list = CJSON::decode($_POST['list']);
    $model = CJSON::decode($_POST['model']);
    $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
    $mPDF1->setAutoBottomMargin = 'stretch';
    $mPDF1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
    $mPDF1->WriteHTML($this->renderPartial('//timeSheet/DailyOvertimeReportPDF',array('list'=>$list,'model'=>$model),true));
    $file_name= 'OT Report Create On'.date("Y-m-d  -  h:i:sa").'.pdf';


    ob_end_clean();
    $mPDF1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );
}
//=========================================================================
public function actionDailyOvertimeReportExcel(){
    $objPHPExcel = new PHPExcel();
    $list = CJSON::decode($_POST['list']);
    $model = CJSON::decode($_POST['model']);

    // print_r($list);
    // die;

    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue('A1', 'Overtime Report')
    ->setCellValue('E1', 'Generated On')
    ->setCellValue('F1', date("Y-m-d - h:i:sa"))
    ->setCellValue('A2', 'Date')
    ->setCellValue('B2', 'Id')
    ->setCellValue('C2', 'Name')
    ->setCellValue('D2', 'Designation')
    ->setCellValue('E2', 'NIC')
    ->setCellValue('F2', 'Overtime Hours')
    ->setCellValue('G2', 'Client Code')
    ->setCellValue('H2', 'Client Name')
    ->setCellValue('I2', 'Department');
    $col = 3;


    for($i = 0;$i < count($list);$i++){

        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0,$col,$list[$i]['date']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1,$col,$list[$i]['Id']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2,$col,$list[$i]['Name']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(3,$col,$list[$i]['designation']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(4,$col,$list[$i]['NIC']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(5,$col,Yii::app()->commonUtil->convertToHoursMins($list[$i]['Overtime']));
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(6,$col,$list[$i]['accountId']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(7,$col,$list[$i]['Account']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(8,$col,$list[$i]['department']);
        $col++;

    }
    $styleArray = array(
        'font'  => array(
            'bold'  => true,
            'color' => array('rgb' => '#f79727'),
            'size'  => 10
        ));
    $objPHPExcel->getActiveSheet()->getStyle('A1:I2')->applyFromArray($styleArray);

    //$objPHPExcel->getActiveSheet()->setTitle('sffd');

    $objPHPExcel->setActiveSheetIndex(0);

    ob_end_clean();
    ob_start();

    header('Content-Type: application/vnd.ms-excel');
    if($model['tag']==1){
    header('Content-Disposition: attachment;filename='.$model['startDate'].'-'.$model['endDate'].'-High OT.xls');
    }else{
        header('Content-Disposition: attachment;filename='.$model['StartDate'].'-'.$model['EndDate'].'-High OT.xls');
    }
    header('Cache-Control: max-age=0');
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
    $objWriter->save('php://output');
  }

//============================================================================================
public function actionHighOvertimeReport(){

    $model = new HighOvertimeReport;
    if(isset($_POST['HighOvertimeReport'])){
        $model-> attributes = $_POST['HighOvertimeReport'];
        if($model->validate()){
            if(isset($_POST['accounts'])){
                $hours = (int)$model->hours;
                    $list= Yii::app()->db->createCommand("SELECT D.type designation,A.AccountOracleCode accountId,E.id Id,T.date,E.Namewithini Name ,A.name Account,E.nic NIC,(T.NOvertimeHours+T.DOverTimeHour+T.TOverTimeHour) Overtime,DP.name department
                    FROM timesheet T
                    INNER JOIN employee E ON E.id = T.EmployeeId
                    INNER JOIN accounts A ON A.id = E.Accountid
                    INNER JOIN designation D ON D.id = E.designationid
                    INNER JOIN department DP ON DP.id = E.departmentid
                    WHERE E.accountId IN (".implode(',',$_POST['accounts']).") AND T.date >= DATE('$model->StartDate') AND T.date <= DATE('$model->EndDate') AND (T.NOvertimeHours+T.DOverTimeHour+T.TOverTimeHour) > $hours  ORDER BY Account,T.date ASC")->queryAll();
            }else{
                if(Yii::app()->user->isAdmin()){
                    $hours = (int)$model->hours;
                    $list= Yii::app()->db->createCommand("SELECT D.type designation,A.AccountOracleCode accountId,E.id Id,T.date,E.Namewithini Name ,A.name Account,E.nic NIC,(T.NOvertimeHours+T.DOverTimeHour+T.TOverTimeHour) Overtime,DP.name department
                    FROM timesheet T
                    INNER JOIN employee E ON E.id = T.EmployeeId
                    INNER JOIN accounts A ON A.id = E.Accountid
                    INNER JOIN designation D ON D.id = E.designationid
                    INNER JOIN department DP ON DP.id = E.departmentid
                    WHERE T.date >= DATE('$model->StartDate') AND T.date <= DATE('$model->EndDate') AND (T.NOvertimeHours+T.DOverTimeHour+T.TOverTimeHour) > $hours  ORDER BY Account,T.date ASC")->queryAll();
                }else{
                    $sitid = Yii::app()->user->data()->SiteId;
                    $hours = (int)$model->hours;
                    $list= Yii::app()->db->createCommand("SELECT D.type designation,A.AccountOracleCode accountId,E.id Id,T.date,E.Namewithini Name ,A.name Account,E.nic NIC,(T.NOvertimeHours+T.DOverTimeHour+T.TOverTimeHour) Overtime,DP.name department
                    FROM timesheet T
                    INNER JOIN employee E ON E.id = T.EmployeeId
                    INNER JOIN accounts A ON A.id = E.Accountid
                    INNER JOIN designation D ON D.id = E.designationid
                    INNER JOIN department DP ON DP.id = E.departmentid
                    WHERE E.siteid = $sitid AND T.date >= DATE('$model->StartDate') AND T.date <= DATE('$model->EndDate') AND (T.NOvertimeHours+T.DOverTimeHour+T.TOverTimeHour) > $hours  ORDER BY Account,T.date ASC")->queryAll();
                }
            }


            // print_r($list);
            // die;
            $this->render('//timeSheet/ViewDailyOvertimeReport',array('list'=>$list,'model'=>$model));
        }

    }else{
        return $this->render('//timeSheet/CreateHighOvertimeReport',array('model'=>$model));
    }


}


//============================================================================================
public function actionDailyAbnormalOT(){

    $model = new DailyAbnormalOT;
    if(isset($_POST['DailyAbnormalOT'])){
        $model-> attributes = $_POST['DailyAbnormalOT'];
        if($model->validate()){
            if(isset($_POST['accounts'])){
                $list= Yii::app()->db->createCommand("SELECT D.type designation,A.AccountOracleCode accountId,T.id Id,E.Namewithini Name,A.name Account,E.nic NIC,T.date Date,S.StartTime StartTime,S.EndTime EndTime,T.NOvertimeHours NrmlOT,T.DOverTimeHour DblOT,T.TOverTimeHour Tot,(T.NOvertimeHours+T.DOverTimeHour+T.TOverTimeHour) Total,(S.FirstOTTimeRang+S.SecondOTRange) Maxx,DP.name department
                    FROM timesheet T
                    INNER JOIN employee_shift ES ON ES.id = T.EmployeeShiftid
                    INNER JOIN shift S ON S.id = ES.ShiftId
                    INNER JOIN employee E ON E.id = T.EmployeeId
                    INNER JOIN accounts A ON A.id = E.Accountid
                    INNER JOIN designation D ON D.id = E.designationid
                    INNER JOIN department DP ON DP.id = E.departmentid
                    WHERE E.accountId IN (".implode(',',$_POST['accounts']).") AND T.date = DATE('$model->certainDate') AND 0 < (T.NOvertimeHours+T.DOverTimeHour+T.TOverTimeHour) ORDER BY Account")->queryAll();
            }else{
                if(Yii::app()->user->isAdmin()){
                    $list= Yii::app()->db->createCommand("SELECT D.type designation,A.AccountOracleCode accountId,T.id Id,E.Namewithini Name,A.name Account,E.nic NIC,T.date Date,S.StartTime StartTime,S.EndTime EndTime,T.NOvertimeHours NrmlOT,T.DOverTimeHour DblOT,T.TOverTimeHour Tot,(T.NOvertimeHours+T.DOverTimeHour+T.TOverTimeHour) Total,(S.FirstOTTimeRang+S.SecondOTRange) Maxx,DP.name department
                    FROM timesheet T
                    INNER JOIN employee_shift ES ON ES.id = T.EmployeeShiftid
                    INNER JOIN shift S ON S.id = ES.ShiftId
                    INNER JOIN employee E ON E.id = T.EmployeeId
                    INNER JOIN accounts A ON A.id = E.Accountid
                    INNER JOIN designation D ON D.id = E.designationid
                    INNER JOIN department DP ON DP.id = E.departmentid
                    WHERE T.date = DATE('$model->certainDate') AND 0 < (T.NOvertimeHours+T.DOverTimeHour+T.TOverTimeHour) ORDER BY Account")->queryAll();
                }else{
                    $sitid = Yii::app()->user->data()->SiteId;
                    $list= Yii::app()->db->createCommand("SELECT D.type designation,A.AccountOracleCode accountId,T.id Id,E.Namewithini Name,A.name Account,E.nic NIC,T.date Date,S.StartTime StartTime,S.EndTime EndTime,T.NOvertimeHours NrmlOT,T.DOverTimeHour DblOT,T.TOverTimeHour Tot,(T.NOvertimeHours+T.DOverTimeHour+T.TOverTimeHour) Total,(S.FirstOTTimeRang+S.SecondOTRange) Maxx,DP.name department
                    FROM timesheet T
                    INNER JOIN employee_shift ES ON ES.id = T.EmployeeShiftid
                    INNER JOIN shift S ON S.id = ES.ShiftId
                    INNER JOIN employee E ON E.id = T.EmployeeId
                    INNER JOIN accounts A ON A.id = E.Accountid
                    INNER JOIN designation D ON D.id = E.designationid
                    INNER JOIN department DP ON DP.id = E.departmentid
                    WHERE E.siteid = $sitid AND T.date = DATE('$model->certainDate') AND 0 < (T.NOvertimeHours+T.DOverTimeHour+T.TOverTimeHour) ORDER BY Account")->queryAll();
                }
            }


            //  print_r($list);
            //  die;

            $this->render('//timeSheet/ViewDailyAbnormalOT',array('list'=>$list,'model'=>$model));
        }

    }else{
        return $this->render('//timeSheet/CreateDailyAbnormalOT',array('model'=>$model));
    }


}


//============================================================================================
public function actionDailyAbnormalOTPDF()
{

    $list = CJSON::decode($_POST['list']);
    $model = CJSON::decode($_POST['model']);
    $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
    $mPDF1->setAutoBottomMargin = 'stretch';
    $mPDF1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
    $mPDF1->WriteHTML($this->renderPartial('//timeSheet/DailyAbnormalOTPDF',array('list'=>$list,'model'=>$model),true));
    $file_name= $model['certainDate'].'Abnormal OT.pdf';


    ob_end_clean();
    $mPDF1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );
}
//=========================================================================
public function actionDailyAbnormalOTExcel(){
    $objPHPExcel = new PHPExcel();
    $list = CJSON::decode($_POST['list']);
    $model = CJSON::decode($_POST['model']);

    // print_r($list);
    // die;

    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue('A1', 'Abnormal OT report')
    ->setCellValue('E1', 'Generated On')
    ->setCellValue('F1', date("Y-m-d - h:i:sa"))
    ->setCellValue('A2', 'Id')
    ->setCellValue('B2', 'Name')
    ->setCellValue('C2', 'NIC')
    ->setCellValue('D2', 'Designation')
    ->setCellValue('E2', 'Date')
    ->setCellValue('F2', 'Shift(Start)')
    ->setCellValue('G2', 'Shift(End)')
    ->setCellValue('H2', 'Nrml OT')
    ->setCellValue('I2', 'Dbl OT')
    ->setCellValue('J2', 'Total OT')
    ->setCellValue('K2', 'Ttl Allocated OT')
    ->setCellValue('L2', 'Client Code')
    ->setCellValue('M2', 'Client Name')
    ->setCellValue('N2', 'Department');
    $col = 3;


    for($i = 0;$i < count($list);$i++){

        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0,$col,$list[$i]['Id']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1,$col,$list[$i]['Name']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2,$col,$list[$i]['NIC']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(3,$col,$list[$i]['designation']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(4,$col,$list[$i]['Date']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(5,$col,$list[$i]['StartTime']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(6,$col,$list[$i]['EndTime']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(7,$col,Yii::app()->commonUtil->convertToHoursMins($list[$i]['NrmlOT']));
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(8,$col,Yii::app()->commonUtil->convertToHoursMins($list[$i]['DblOT']));
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(9,$col,Yii::app()->commonUtil->convertToHoursMins($list[$i]['Total']));
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(10,$col,$list[$i]['Maxx']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(11,$col,$list[$i]['accountId']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(12,$col,$list[$i]['Account']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(13,$col,$list[$i]['department']);

        $col++;

    }
    $styleArray = array(
        'font'  => array(
            'bold'  => true,
            'color' => array('rgb' => '#f79727'),
            'size'  => 10
        ));
    $objPHPExcel->getActiveSheet()->getStyle('A1:M2')->applyFromArray($styleArray);

    //$objPHPExcel->getActiveSheet()->setTitle('sffd');

    $objPHPExcel->setActiveSheetIndex(0);

    ob_end_clean();
    ob_start();

    header('Content-Type: application/vnd.ms-excel');
    header('Content-Disposition: attachment;filename='.$model['certainDate'].'-Abnormal OT.xls');
    header('Cache-Control: max-age=0');
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
    $objWriter->save('php://output');
  }

//============================================================================================

public function actionOTSummaryReport(){

    $model = new OTSummaryReport;
    if(isset($_POST['OTSummaryReport'])){
        $model-> attributes = $_POST['OTSummaryReport'];
        if($model->validate()){
            if(isset($_POST['accounts'])){
                $list= Yii::app()->db->createCommand("SELECT D.type designation,A.AccountOracleCode accountId,E.id Id,E.Namewithini Name,A.name Account,E.nic NIC,(T.NOvertimeHours+T.DOverTimeHour+T.TOverTimeHour) TtlHours,T.NOvertimeHours NOtHours,T.DOverTimeHour DOtHours,T.TOverTimeHour Tot,DP.name department,T.ActualNOT,T.ActualDOT,T.ActualTOT
                    FROM timesheet T
                    INNER JOIN employee E ON E.id = T.EmployeeId
                    INNER JOIN accounts A ON A.id = E.Accountid
                    INNER JOIN designation D ON D.id = E.designationid
                    INNER JOIN department DP ON DP.id = E.departmentid
                    WHERE E.accountId IN (".implode(',',$_POST['accounts']).") AND T.date >= DATE('$model->startDate') AND T.date <= DATE('$model->endDate') AND (T.NOvertimeHours+T.DOverTimeHour+T.TOverTimeHour) > 0 ORDER BY Account,E.id")->queryAll();
            }else{
                if(Yii::app()->user->isAdmin()){
                    $list= Yii::app()->db->createCommand("SELECT D.type designation,A.AccountOracleCode accountId,E.id Id,E.Namewithini Name,A.name Account,E.nic NIC,(T.NOvertimeHours+T.DOverTimeHour+T.TOverTimeHour) TtlHours,T.NOvertimeHours NOtHours,T.DOverTimeHour DOtHours,T.TOverTimeHour Tot,DP.name department,T.ActualNOT,T.ActualDOT,T.ActualTOT
                    FROM timesheet T
                    INNER JOIN employee E ON E.id = T.EmployeeId
                    INNER JOIN accounts A ON A.id = E.Accountid
                    INNER JOIN designation D ON D.id = E.designationid
                    INNER JOIN department DP ON DP.id = E.departmentid
                    WHERE T.date >= DATE('$model->startDate') AND T.date <= DATE('$model->endDate') AND (T.NOvertimeHours+T.DOverTimeHour+T.TOverTimeHour) > 0 ORDER BY Account,E.id")->queryAll();
                }else{
                    $sitid = Yii::app()->user->data()->SiteId;
                    $list= Yii::app()->db->createCommand("SELECT D.type designation,A.AccountOracleCode accountId,E.id Id,E.Namewithini Name,A.name Account,E.nic NIC,(T.NOvertimeHours+T.DOverTimeHour+T.TOverTimeHour) TtlHours,T.NOvertimeHours NOtHours,T.DOverTimeHour DOtHours,T.TOverTimeHour Tot,DP.name department,T.ActualNOT,T.ActualDOT,T.ActualTOT
                    FROM timesheet T
                    INNER JOIN employee E ON E.id = T.EmployeeId
                    INNER JOIN accounts A ON A.id = E.Accountid
                    INNER JOIN designation D ON D.id = E.designationid
                    INNER JOIN department DP ON DP.id = E.departmentid
                    WHERE E.siteid = $sitid AND T.date >= DATE('$model->startDate') AND T.date <= DATE('$model->endDate') AND (T.NOvertimeHours+T.DOverTimeHour+T.TOverTimeHour) > 0 ORDER BY Account,E.id")->queryAll();
                }
            }


           $out1 = array();
           foreach ($list as $key => $value){
               if (array_key_exists($value['NIC'], $out1)){
                   $out1[$value['NIC']]['TtlHours'] += (float)$value['TtlHours'];
                   $out1[$value['NIC']]['NOtHours'] += (float)$value['NOtHours'];
                   $out1[$value['NIC']]['DOtHours'] += (float)$value['DOtHours'];
                   $out1[$value['NIC']]['Tot'] += (float)$value['Tot'];
                   $out1[$value['NIC']]['ActualNOT'] += (float)$value['ActualNOT'];
                   $out1[$value['NIC']]['ActualDOT'] += (float)$value['ActualDOT'];
                   $out1[$value['NIC']]['ActualTOT'] += (float)$value['ActualTOT'];
                    //print_r($out1);
                    //die;
               } else {
                   $out1[$value['NIC']] = array('NIC' => $value['NIC'],'Name' => $value['Name'],'Account'=>$value['Account'],'Department'=>$value['department'],'Id' => $value['Id'], 'TtlHours' => (float)$value['TtlHours'], 'NOtHours'=>  (float)$value['NOtHours'], 'DOtHours' => (float)$value['DOtHours'],'Tot'=> (float)$value['Tot'],'ActualNOT'=> (float)$value['ActualNOT'],'ActualDOT'=> (float)$value['ActualDOT'],'ActualTOT'=> (float)$value['ActualTOT'],'accountId' => $value['accountId'],'designation' => $value['designation']);
                   // $out1 = array_values($out1);
                   // print_r($out1);
                   // die;
               }
           }
           $out1 = array_values($out1);
        //    print_r($out1);
        //    die;

            $this->render('//timeSheet/ViewOTSummaryReport',array('list'=>$out1,'model'=>$model));
        }

    }else{
        return $this->render('//timeSheet/CreateOTSummaryReport',array('model'=>$model));
    }


}


//============================================================================================
public function actionOTSummaryReportPDF()
{

    $list = CJSON::decode($_POST['list']);
    $model = CJSON::decode($_POST['model']);
    $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
    $mPDF1->setAutoBottomMargin = 'stretch';
    $mPDF1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
    $mPDF1->WriteHTML($this->renderPartial('//timeSheet/OTSummaryReportPDF',array('list'=>$list,'model'=>$model),true));
    $file_name= $model['startDate'].'-'.$model['endDate'].'OT Summary.pdf';


    ob_end_clean();
    $mPDF1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );
}
//=========================================================================
public function actionOTSummaryReportExcel(){
    $objPHPExcel = new PHPExcel();
    $list = CJSON::decode($_POST['list']);
    $model = CJSON::decode($_POST['model']);

    // print_r($list);
    // die;

    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue('A1', 'OT Summary Report')
    ->setCellValue('E1', 'Generated On')
    ->setCellValue('F1', date("Y-m-d - h:i:sa"))
    ->setCellValue('A2', 'Id')
    ->setCellValue('B2', 'Name')
    ->setCellValue('C2', 'NIC')
    ->setCellValue('D2', 'Designation')
    ->setCellValue('E2', 'Client Code')
    ->setCellValue('F2', 'Client Name')
    ->setCellValue('G2', 'Department')
    ->setCellValue('H2', 'Actual Worked NOverTime(Hrs)')
    ->setCellValue('I2', 'Actual Worked DOverTime(Hrs)')         
    ->setCellValue('J2', 'Ttl NOverTime(Hrs)')
    ->setCellValue('K2', 'Ttl DOverTime(Hrs)')
    ->setCellValue('L2', 'Total OT Hours(Hrs)');
    $col = 3;


    for($i = 0;$i < count($list);$i++){
        $row = 0;
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$col,$list[$i]['Id']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['Name']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['NIC']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['designation']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['accountId']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['Account']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['Department']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,Yii::app()->commonUtil->convertToHoursMins($list[$i]['ActualNOT']));
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,Yii::app()->commonUtil->convertToHoursMins($list[$i]['ActualDOT']));
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,Yii::app()->commonUtil->convertToHoursMins($list[$i]['NOtHours']));
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,Yii::app()->commonUtil->convertToHoursMins($list[$i]['DOtHours']));
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,Yii::app()->commonUtil->convertToHoursMins($list[$i]['TtlHours']));


        $col++;

    }
    $styleArray = array(
        'font'  => array(
            'bold'  => true,
            'color' => array('rgb' => '#f79727'),
            'size'  => 10
        ));
    $objPHPExcel->getActiveSheet()->getStyle('A1:L2')->applyFromArray($styleArray);

    //$objPHPExcel->getActiveSheet()->setTitle('sffd');

    $objPHPExcel->setActiveSheetIndex(0);

    ob_end_clean();
    ob_start();

    header('Content-Type: application/vnd.ms-excel');
    header('Content-Disposition: attachment;filename='.$model['startDate'].'-'.$model['endDate'].'-OT Summary.xls');
    header('Cache-Control: max-age=0');
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
    $objWriter->save('php://output');
  }

//============================================================================================
public function actionAttendance() {
    $model = new AttendanceForm;

    if((isset($_POST['AttendanceForm']))){
        $model-> attributes = $_POST['AttendanceForm'];
        //validate Attendance Form
        if($model->validate()){
            //bind data
            $model->setData();
            //die($model->employee);
            //get data from timelog model
             $logs = Timelog::model()->findAllBySql("select * from timelog where Employeeid = ".$model->employee." AND DATE(PunchTime) >='$model->startDate' AND DATE(PunchTime) <= '$model->endDate' ORDER BY PunchTime ASC");
            //get employee data from Employee model
             $employeeDetails = Employee::model()->findByPk($model->employee);

            //send data to view form
            $this->render('//timelog/viewAttendance',array('model'=>$model,'logs'=>$logs,'employeeDetails'=>$employeeDetails));


            }

    }else{
        //load CreateAttendance Form
        return $this->render('//timelog/attendanceRecorde',array('model'=>$model));
    }




}
//=========================================================================
public function actionPdf()
{
        $logs = CJSON::decode($_POST['logs']);
        $model = CJSON::decode($_POST['model']);
        $employeeDetails = CJSON::decode($_POST['employee']);
        $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
        $mPDF1->setAutoBottomMargin = 'stretch';
        $mPDF1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
        $mPDF1->WriteHTML($this->renderPartial('//timelog/testHtml',array('logs'=>$logs,'employeeDetails'=>$employeeDetails,'model'=>$model),true));
        $file_name= $employeeDetails['nic'].'Created On'.date("Y-m-d - h:i:sa").'.pdf';
        ob_end_clean();
        $mPDF1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );

}

//=========================================================================
    public function actionAttendanceRange(){
        $model = new AttendaceRange;
        $sitid = Yii::app()->user->data()->SiteId;
        $EmpList =array();

        if(isset($_POST['AttendaceRange'])){
            
            $model->attributes = $_POST['AttendaceRange'];


            if($model->validate()){
                if(isset($_POST['accounts'])){
                    $list= Yii::app()->db->createCommand("SELECT sites.name as siteName,A.id accountId,E.id,E.Namewithini,E.nic,E.EmployeeNumber,D.type,T.date,T.Intime as Intime,T.OuteTime as OuteTime,T.WorkedHour,T.TotalOTHour,A.name,A.AccountOracleCode,DP.name department,supplier.name as supname,E.PresentAddress,E.ResidentType,E.GNDivision,E.PoliceDivision,E.GNDLockdown,E.PDLockdown,company.name AS CompanyName
                    FROM timesheet T
                        INNER JOIN employee E ON E.id = T.EmployeeId
                        INNER JOIN designation D ON D.id = E.designationid
                        INNER JOIN supplier ON E.supplierid = supplier.id
                        INNER JOIN accounts A ON A.id = E.Accountid
                        INNER JOIN department DP ON DP.id = E.departmentid
                        INNER JOIN sites ON sites.id = E.siteid
                        INNER JOIN company ON sites.clusterid = company.id
                        WHERE T.date >= DATE('$model->startDate') AND T.date <= DATE('$model->endDate') AND E.accountId IN (".implode(',',$_POST['accounts']).") ORDER BY A.name, E.nic,T.Intime ")->queryAll();
                }else{
                    if(Yii::app()->user->isAdmin()){
                        $list= Yii::app()->db->createCommand("SELECT sites.name as siteName,A.id accountId,E.id,E.Namewithini,E.nic,E.EmployeeNumber,D.type,T.date as date,T.Intime as Intime,T.OuteTime as OuteTime,T.WorkedHour,T.TotalOTHour,A.name,A.AccountOracleCode,DP.name department,supplier.name as supname,E.PresentAddress,E.ResidentType,E.GNDivision,E.PoliceDivision,E.GNDLockdown,E.PDLockdown,company.name AS CompanyName
                        FROM timesheet T
                        INNER JOIN employee E ON E.id = T.EmployeeId
                        INNER JOIN designation D ON D.id = E.designationid
                        INNER JOIN supplier ON E.supplierid = supplier.id
                        INNER JOIN accounts A ON A.id = E.Accountid
                        INNER JOIN department DP ON DP.id = E.departmentid
                        INNER JOIN sites ON sites.id = E.siteid
                        INNER JOIN company ON sites.clusterid = company.id
                        WHERE T.date >= DATE('$model->startDate') AND T.date <= DATE('$model->endDate') ORDER BY A.name, E.nic,T.Intime")->queryAll();
                    }else{

                        $list= Yii::app()->db->createCommand("SELECT sites.name as siteName,A.id accountId,E.id,E.Namewithini,E.nic,E.EmployeeNumber,D.type,T.date,T.Intime as Intime,T.OuteTime as OuteTime,T.WorkedHour,T.TotalOTHour,A.name,A.AccountOracleCode,DP.name department,supplier.name as supname,E.PresentAddress,E.ResidentType,E.GNDivision,E.PoliceDivision,E.GNDLockdown,E.PDLockdown,company.name AS CompanyName
                        FROM timesheet T
                        INNER JOIN employee E ON E.id = T.EmployeeId
                        INNER JOIN designation D ON D.id = E.designationid
                        INNER JOIN supplier ON E.supplierid = supplier.id
                        INNER JOIN accounts A ON A.id = E.Accountid
                        INNER JOIN department DP ON DP.id = E.departmentid
                        INNER JOIN sites ON sites.id = E.siteid
                        INNER JOIN company ON sites.clusterid = company.id
                        WHERE T.date >= DATE('$model->startDate') AND T.date <= DATE('$model->endDate') AND E.siteid = $sitid ORDER BY A.name, E.nic,T.Intime ")->queryAll();
                    }
                }

                if (Yii::app()->user->isAdmin()) {
                    $EmpList= Yii::app()->db->createCommand("SELECT distinct E.nic
                        FROM timesheet T
                        INNER JOIN employee E ON E.id = T.EmployeeId
                        INNER JOIN designation D ON D.id = E.designationid
                         INNER JOIN supplier ON E.supplierid = supplier.id
                        INNER JOIN accounts A ON A.id = E.Accountid
                        INNER JOIN department DP ON DP.id = E.departmentid
                        WHERE T.date >= DATE('$model->startDate') AND T.date <= DATE('$model->endDate') ORDER BY E.nic")->queryAll();
                }else{
                    $EmpList= Yii::app()->db->createCommand("SELECT distinct E.nic
                    FROM timesheet T
                    INNER JOIN employee E ON E.id = T.EmployeeId
                    INNER JOIN designation D ON D.id = E.designationid
                     INNER JOIN supplier ON E.supplierid = supplier.id
                    INNER JOIN accounts A ON A.id = E.Accountid
                    INNER JOIN department DP ON DP.id = E.departmentid
                    WHERE T.date >= DATE('$model->startDate') AND T.date <= DATE('$model->endDate') AND E.siteid = $sitid ORDER BY E.nic")->queryAll();
                }

                // print_r($list);die;
                $this->render('//timelog/viewAttendanceRange',array('attendanceRanges'=>$list,'model'=>$model,'EmpList'=>$EmpList));
            }

        }else{
            return $this->render('//timelog/createAttendaceRange',array('model'=>$model));
        }
    }



//=========================================================================
public function actionAttendanceRangePdf()
{

    $attendanceRanges = CJSON::decode($_POST['attendanceRanges']);
    $model = CJSON::decode($_POST['model']);
    $empList = CJSON::decode($_POST['empList']);
    //print_r($_POST['empList']);
    //die;
    $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
    $mPDF1->setAutoBottomMargin = 'stretch';
    $mPDF1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
    $mPDF1->WriteHTML($this->renderPartial('//timelog/attendanceRangePdf',array('attendanceRanges'=>$attendanceRanges,'model'=>$model,'empList'=>$empList),true));
    $file_name= $model['startDate'].'-'.$model['endDate'].'Created On'.date("Y-m-d  -  h:i:sa").'.pdf';


    ob_end_clean();
    $mPDF1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );
}

//=========================================================================        
public function actionAttendanceRangeExcel(){
    $objPHPExcel = new PHPExcel();
    $list = CJSON::decode($_POST['list']);
    $model = CJSON::decode($_POST['model']);

    // print_r($list);
    // die;

    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue('A1','All Attendance')
    ->setCellValue('E1', 'Generated On')
    ->setCellValue('F1', date("Y-m-d - h:i:sa"))
    ->setCellValue('A2', 'Id')
    ->setCellValue('B2', 'Name')
    ->setCellValue('C2', 'NIC')
    ->setCellValue('D2', 'Emp Number') 
    ->setCellValue('E2', 'Present Address')
    ->setCellValue('F2', 'Resident Type')  
    ->setCellValue('G2', 'GN Division')   
    ->setCellValue('H2', 'GN Division Lockdown')   
    ->setCellValue('I2', 'Police Division')   
    ->setCellValue('J2', 'Police Division Lockdown')   
    ->setCellValue('K2', 'Designation')
    ->setCellValue('L2', 'Account Oracle Code ')
    ->setCellValue('M2', 'Client Id')
    ->setCellValue('N2', 'Client Name')
    ->setCellValue('O2', 'Departmanet')
    ->setCellValue('P2', 'Site')
    ->setCellValue('Q2', 'Company')        
    ->setCellValue('R2', 'MP Supplier')
    ->setCellValue('S2', 'Date')
    ->setCellValue('T2', 'In Time')
    ->setCellValue('U2', 'Out Time')
    ->setCellValue('V2', 'Working Hours')
    ->setCellValue('W2', 'OT Hours')
    ->setCellValue('X2', 'Normal Working Hours');

    $col = 3;


    for($i = 0;$i < count($list);$i++){
        $workingHr1 = $list[$i]['WorkedHour'] + $list[$i]['TotalOTHour'];
        $workingHr = $this->ConvertToHoursMins($workingHr1, '%02d:%02d');
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0,$col,$list[$i]['id']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1,$col,$list[$i]['Namewithini']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2,$col,$list[$i]['nic']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(3,$col,$list[$i]['EmployeeNumber']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(4,$col,$list[$i]['PresentAddress']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(5,$col,$list[$i]['ResidentType']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(6,$col,$list[$i]['GNDivision']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(7,$col,$list[$i]['GNDLockdown']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(8,$col,$list[$i]['PoliceDivision']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(9,$col,$list[$i]['PDLockdown']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(10,$col,$list[$i]['type']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(11,$col,$list[$i]['AccountOracleCode']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(12,$col,$list[$i]['accountId']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(13,$col,$list[$i]['name']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(14,$col,$list[$i]['department']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(15,$col,$list[$i]['siteName']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(16,$col,$list[$i]['CompanyName']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(17,$col,$list[$i]['supname']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(18,$col,$list[$i]['date']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(19,$col,$list[$i]['Intime']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(20,$col,$list[$i]['OuteTime']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(21,$col,$workingHr);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(22,$col,$this->ConvertToHoursMins($list[$i]['TotalOTHour']));
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(23,$col,$this->ConvertToHoursMins($list[$i]['WorkedHour'], '%02d:%02d'));
       
        $col++;

    }
    $styleArray = array(
        'font'  => array(
            'bold'  => true,
            'color' => array('rgb' => '#f79727'),
            'size'  => 10
        ));
    $objPHPExcel->getActiveSheet()->getStyle('A1:X2')->applyFromArray($styleArray);

    //$objPHPExcel->getActiveSheet()->setTitle('sffd');

    $objPHPExcel->setActiveSheetIndex(0);

    ob_end_clean();
    ob_start();

    header('Content-Type: application/vnd.ms-excel');
    header('Content-Disposition: attachment;filename='.$model['startDate'].' to '.$model['endDate'].'.xls');
    header('Cache-Control: max-age=0');
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
    $objWriter->save('php://output');
  }

//============================================================================================
public function actionAttendanceExcel(){
    $objPHPExcel = new PHPExcel();
    $logs = CJSON::decode($_POST['logs']);
    $model = CJSON::decode($_POST['model']);
    $employeeDetails = CJSON::decode($_POST['employee']);

    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue('B1', 'Employee Timelog For'.$model['startDate'].'---------'.$model['endDate'])
    ->setCellValue('E1', 'Generated On')
    ->setCellValue('F1', date("Y-m-d - h:i:sa"))
    ->setCellValue('B2', 'Name ')
    ->setCellValue('C2', $employeeDetails['title'] . ' ' . $employeeDetails['Namewithini'])
    ->setCellValue('D2', 'Customer Id' )
    ->setCellValue('E2', $employeeDetails['Accountid'])
    ->setCellValue('A3', 'Date')
    ->setCellValue('B3', 'Time')
    ->setCellValue('C3', 'Type');
    $y = 4;
    $styleArray = array(
        'font'  => array(
            'bold'  => true,
            'color' => array('rgb' => '#f79727'),
            'size'  => 10
        ));
    $objPHPExcel->getActiveSheet()->getStyle('A1:G3')->applyFromArray($styleArray);

    for($i = 0;$i < count($logs);$i++){

        $dateTime = new DateTime($logs[$i]['PunchTime']);
        $date = $dateTime->format('Y-m-d');
        //'h' time in 12hr
        //'H' time in 24hr
        //'a' am or pm
        $time = $dateTime->format('H:i:s');
        $objPHPExcel->setActiveSheetIndex(0)
        ->setCellValue('A'.$y, $date)
        ->setCellValue('B'.$y, $time)
        ->setCellValue('C'.$y, $logs[$i]['Type']);
        $y++;


    }

    $objPHPExcel->getActiveSheet()->setTitle($employeeDetails['nic']);

    $objPHPExcel->setActiveSheetIndex(0);

    ob_end_clean();
    ob_start();

    header('Content-Type: application/vnd.ms-excel');
    header('Content-Disposition: attachment;filename= Employee Timelog '.$employeeDetails['nic'].'Created On'.date("Y-m-d - h:i:sa").'.xls');
    header('Cache-Control: max-age=0');
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
    $objWriter->save('php://output');
  }
//============================Invalid Attendance Report=======================================================

public function actionFindInvalidAttendanceDetails(){
    $model = new InvalidAttendanceDetailsForm;
    if(isset($_POST['InvalidAttendanceDetailsForm'])){

            $model->attributes=$_POST['InvalidAttendanceDetailsForm'];

//===========================================================Newly Added One========16-02-2018================================================================
           if(isset($_POST['accounts']))
            $selectedAccounts = $_POST['accounts'];
            else
            $selectedAccounts = [];


            if(!empty($selectedAccounts)){
                $logs= Yii::app()->db->createcommand("SELECT t.*,employee.Accountid as Accountid FROM `timesheet`as t
                    INNER JOIN employee on t.Employeeid = employee.id
                    WHERE t.date>= '$model->startDate' AND t.date<= '$model->endDate' AND
                    (Intime is NULL OR OuteTime is NULL ) Order By employee.Accountid,date,t.Employeeid")->queryAll();

            $data = array();

            if(!empty($logs)){
                foreach($logs as $record){
                    if(in_array($record['Accountid'],$selectedAccounts))
                    $data[]= $record;

                }


            }


            }

            else{

                if(Yii::app()->user->isAdmin()){

                    $data= Yii::app()->db->createcommand("SELECT t.* FROM `timesheet`as t
                    INNER JOIN employee on t.Employeeid = employee.id
                    WHERE t.date>= '$model->startDate' AND t.date<= '$model->endDate' AND employee.paymentmethodid != 4 AND
                    (Intime is NULL OR OuteTime is NULL ) Order By employee.siteid,employee.Accountid,date,t.Employeeid")->queryAll();

                }
                else{
                    $sitid = Yii::app()->user->data()->SiteId;

                    $data= Yii::app()->db->createcommand("SELECT t.* FROM `timesheet`as t
                    INNER JOIN employee on t.Employeeid = employee.id
                    WHERE t.date>= '$model->startDate' AND t.date<= '$model->endDate' AND t.SiteId = $sitid  AND employee.paymentmethodid != 4 AND
                    (Intime is NULL OR OuteTime is NULL ) Order By employee.Accountid,date,t.Employeeid")->queryAll();

                }



            }




//=======================================================================================================================================================



/*             $invalidEmployees = array();
            $data= Yii::app()->db->createcommand("SELECT t.* FROM `timesheet`as t
            INNER JOIN employee on t.Employeeid = employee.id
            WHERE date>= '$model->startDate' AND date<= '$model->endDate' AND
            (Intime is NULL OR OuteTime is NULL ) Order By employee.Accountid,date,t.Employeeid")->queryAll();

                    if(Yii::app()->user->isAdmin()){
                        foreach($data as $record){
                            if($record['SiteId'] == $model->site){
                                $invalidEmployees[] = $record;

                            }
                        }
                    }

                    else{
                        $sitid = Yii::app()->user->data()->SiteId;
                        $model->site = $sitid;
                        foreach($data as $record){
                            if($record['SiteId'] == $sitid){
                                $invalidEmployees[] = $record;

                            }
                        }

                    } */
            //===========================================Newly added============================================
           // $this->render('//timelog/invalidAttendanceReport', array('model'=>$model,'invalidEmployees'=> $data));
           $this->render('//timelog/invalidAttendanceReport', array('model'=>$model,'invalidEmployees'=> $data));

    }
    else{

        $this->render('//timelog/getInvalidAttendanceDetailsForm', array('model'=>$model));
     }


}
//================================================Invalid attendance PDF ================================================================================

public function actionCreateInvalidAttendancePdf()
{

    $invalidEmployees = CJSON::decode($_POST['invalidEmployees']);
    $model = CJSON::decode($_POST['model']);
    // print_r($model);
    // die;
    $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
    $mPDF1->setFooter('{PAGENO}');
    $mPDF1->WriteHTML($this->renderPartial('//timelog/invalidAttendancePDF',array('model'=>$model,'invalidEmployees'=>$invalidEmployees),true));
    $file_name= "Invalid Attendance ".$model['startDate'].' to '.$model['endDate'].'.pdf';
    $time = date("Y-m-d  -  h:i:sa");
    $mPDF1->SetFooter('Report generated by '.Yii::app()->user->name.' on ' .$time.  '<br> powered by Eimsky Business Solutions Pvt Ltd');


    ob_end_clean();
    $mPDF1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );
}

 //================================================Create Invalid Attendance Report Excel=================================================================



public function actionCreateInvalidAttendanceExcel(){


$objPHPExcel = new PHPExcel();
$model = CJSON::decode($_POST['model']);
$invalidEmployees = CJSON::decode($_POST['invalidEmployees']);

        // Set document properties
        $objPHPExcel->getProperties()->setCreator("K'iin Balam")
             ->setLastModifiedBy("K'iin Balam")
             ->setTitle("YiiExcel Test Document")
             ->setSubject("YiiExcel Test Document")
             ->setDescription("Test document for YiiExcel, generated using PHP classes.")
             ->setKeywords("office PHPExcel php YiiExcel UPNFM")
             ->setCategory("Test result file");

        // Add some data
        $objPHPExcel->setActiveSheetIndex(0)
            ->setCellValue('A1', 'Invalid Attendance Report')
            ->setCellValue('F1', "Generated On : ".date("Y-m-d - h:i:sa"))
            ->setCellValue('C1', "Start : ".$model['startDate'])
            ->setCellValue('E1', "End   : ".$model['endDate'])

            ->setCellValue('A4','Date')
            ->setCellValue('B4','NIC')
            ->setCellValue('C4','Employee ID')
            ->setCellValue('D4','Name')
            ->setCellValue('E4','IN Punch Time')
            ->setCellValue('F4','OUT Punch Time')
            ->setCellValue('G4','Site')
            ->setCellValue('H4','Client Code')
            ->setCellValue('I4','Client Name')
            ->setCellValue('J4','Department')
            ->setCellValue('K4','MP');
        $styleArray = array(
            'font'  => array(
                'bold'  => true,
                'color' => array('rgb' => '#f79727'),
                'size'  => 10
            ));
        $objPHPExcel->getActiveSheet()->getStyle('A1:K4')->applyFromArray($styleArray);

            $row = 5;
              foreach($invalidEmployees as $invalidEmployee) {
                    $col =1;
                    $employee = Employee::model()->findByPk($invalidEmployee['EmployeeId']);
                    $account = Accounts::model()->findByPk($employee->Accountid);
                    $site = Sites::model()->findByPk($employee->siteid);
                    $supplier = Supplier::model()->findByPk($employee->supplierid);
                    $dept = Department::model()->findByPk($employee->departmentid);

                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0,$row,$invalidEmployee['date']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col,$row,$employee->nic);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$employee->id);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$employee->FirstName);

                    if($invalidEmployee['Intime'] != '0000-00-00 00:00:00')
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row, $invalidEmployee['Intime']);
                    else
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,'---');

                    if($invalidEmployee['OuteTime'] != '0000-00-00 00:00:00')
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row, $invalidEmployee['OuteTime']);
                    else
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,'---');

                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$site->name);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$account->AccountOracleCode);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$account->name);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$dept->name);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,substr($supplier['name'],0,5).".");

                    $row++;
                }

        $objPHPExcel->getActiveSheet()->setTitle('YiiExcel');
        $filename = "Invalid Attendance Report from: ".$model['startDate']." to ".$model['endDate'];
        header('Content-Type: application/vnd.ms-excel');
        header('Content-Disposition: attachment;filename="'.$filename.'.xls"');
        header('Cache-Control: max-age=0');

        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');

        $objWriter->save('php://output');
        unset($this->objWriter);
        unset($this->objWorksheet);
        unset($this->objReader);
        unset($this->objPHPExcel);
        exit();
    }



//==========================Find Late Attendance==============================================================

public function actionfindLateAttendanceDetails(){
    $model = new LateAttendanceDetailsForm;
    if(isset($_POST['LateAttendanceDetailsForm'])){

            $model->attributes=$_POST['LateAttendanceDetailsForm'];
            $requiredYear=$model->year;
            $requiredMonth=$model->month;

            if(isset($_POST['accounts']))
            $selectedAccounts = $_POST['accounts'];

            else
            $selectedAccounts = [];

            if(!empty($selectedAccounts)){



                $data=Yii::app()->db->createCommand(
                    "SELECT S.id, TS.EmployeeId ,TS.Intime,TS.OuteTime,E.siteid,E.Accountid
                    FROM shift AS S
                    LEFT JOIN employee_shift as ES ON  S.id = ES.ShiftID
                    LEFT JOIN timesheet as TS ON ES.id = TS.EmployeeShiftid
                    LEFT JOIN employee as E ON TS.EmployeeId = E.id
                    WHERE  EXTRACT( YEAR
                    FROM S.StartTime ) = '$requiredYear'
                    AND EXTRACT(
                    MONTH FROM S.StartTime ) = '$requiredMonth'
                    AND S.id = ES.ShiftID
                    AND ES.id = TS.EmployeeShiftid
                    AND TS.Intime>S.StartTime AND E.Accountid
                     ORDER by E.siteid,E.Accountid
                    ")->queryAll();
                $lateEmployees= array();


            if(!empty($data)){
                foreach($data as $record){
                    if(in_array($record['Accountid'],$selectedAccounts))
                    $lateEmployees[]= $record;
                }

            }




            }
            else{

            if(!Yii::app()->user->isAdmin()){
                $sitid = Yii::app()->user->data()->SiteId;
                $lateEmployees=Yii::app()->db->createCommand(
                    "SELECT S.id, TS.EmployeeId ,TS.Intime,TS.OuteTime,E.siteid
                    FROM shift AS S
                    LEFT JOIN employee_shift as ES ON  S.id = ES.ShiftID
                    LEFT JOIN timesheet as TS ON ES.id = TS.EmployeeShiftid
                    LEFT JOIN employee as E ON TS.EmployeeId = E.id
                    WHERE EXTRACT( YEAR
                    FROM S.StartTime ) = '$requiredYear'
                    AND EXTRACT(
                    MONTH FROM S.StartTime ) = '$requiredMonth'
                    AND S.id = ES.ShiftID
                    AND ES.id = TS.EmployeeShiftid
                    AND TS.Intime>S.StartTime AND E.siteid = $sitid ORDER by E.Accountid
                    ")->queryAll();
            }

            else{
                $lateEmployees=Yii::app()->db->createCommand(
                    "SELECT S.id, TS.EmployeeId ,TS.Intime,TS.OuteTime,E.siteid
                    FROM shift AS S
                    LEFT JOIN employee_shift as ES ON  S.id = ES.ShiftID
                    LEFT JOIN timesheet as TS ON ES.id = TS.EmployeeShiftid
                    LEFT JOIN employee as E ON TS.EmployeeId = E.id
                    WHERE EXTRACT( YEAR
                    FROM S.StartTime ) = '$requiredYear'
                    AND EXTRACT(
                    MONTH FROM S.StartTime ) = '$requiredMonth'
                    AND S.id = ES.ShiftID
                    AND ES.id = TS.EmployeeShiftid
                    AND TS.Intime>S.StartTime  ORDER by E.siteid,E.Accountid
                    ")->queryAll();
            }

            }



            $this->render('//timelog/lateAttendanceReport', array('model'=>$model,'requiredYear'=> $requiredYear,'requiredMonth'=>$requiredMonth,'lateEmployees'=> $lateEmployees));

        }
        else{

            $this->render('//timelog/getLateAttendanceDetailsForm', array('model'=>$model));

        }
    }

public function actionCreateLateAttendancePDF(){

    $requiredYear = CJSON::decode($_POST['requiredYear']);
    $requiredMonth = CJSON::decode($_POST['requiredMonth']);
    $lateEmployees = CJSON::decode($_POST['lateEmployees']);
    $mpdf1 = Yii::app()->ePdf->mpdf();
    $mpdf1->setAutoBottomMargin = 'stretch';
    $mpdf1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
    $mpdf1->WriteHTML($this->renderPartial('//timelog/lateAttendancePDF', array('model'=>$model,'lateEmployees'=> $lateEmployees, 'requiredYear'=> $requiredYear,'requiredMonth'=>$requiredMonth),true));

    $file_name= "Late Attendance Report on:".$requiredYear." ".$requiredMonth.".pdf";

    ob_end_clean();

    $mpdf1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );

}

//=======================================================Late Attendance Excel==========================================================
public function actionCreateLateAttendanceExcel(){

    $objPHPExcel = new PHPExcel();
    $requiredYear = CJSON::decode($_POST['requiredYear']);
    $requiredMonth = CJSON::decode($_POST['requiredMonth']);
    $lateEmployees = CJSON::decode($_POST['lateEmployees']);
    $dateObj   = DateTime::createFromFormat('!m', $requiredMonth);
    $monthName = $dateObj->format('F');
            // Set document properties
            $objPHPExcel->getProperties()->setCreator("K'iin Balam")
                ->setLastModifiedBy("K'iin Balam")
                ->setTitle("YiiExcel Test Document")
                ->setSubject("YiiExcel Test Document")
                ->setDescription("Test document for YiiExcel, generated using PHP classes.")
                ->setKeywords("office PHPExcel php YiiExcel UPNFM")
                ->setCategory("Test result file");

            // Add some data
            $objPHPExcel->setActiveSheetIndex(0)
            ->setCellValue('A1', 'Late Attendance Report :')
            ->setCellValue('E1', 'Generated On')
            ->setCellValue('F1', date("Y-m-d - h:i:sa"))
            ->setCellValue('C1', $requiredYear."  ".$monthName)
            ->setCellValue('A4', 'Date')
            ->setCellValue('B4', 'NIC')
            ->setCellValue('C4', 'Employee ID')
            ->setCellValue('D4', 'Name')
            ->setCellValue('E4', 'Site')
            ->setCellValue('F4', 'Client Code')
            ->setCellValue('G4', 'Client Name')
            ->setCellValue('H4', 'Department')
            ->setCellValue('I4', 'Shift')
            ->setCellValue('J4', 'Shift Start')
            ->setCellValue('K4', 'Shift End')
            ->setCellValue('L4', 'In Time')
            ->setCellValue('M4', 'Out Time');
            $styleArray = array(
                'font'  => array(
                    'bold'  => true,
                    'color' => array('rgb' => '#f79727'),
                    'size'  => 10
                ));
            $objPHPExcel->getActiveSheet()->getStyle('A1:M4')->applyFromArray($styleArray);
            $row = 5;
            foreach($lateEmployees as $lateEmployee) {
                    $col =1;
                    $employee = Employee::model()->findByPk($lateEmployee['EmployeeId']);
                    $site = Sites::model()->findByPk($employee->siteid);
                    $account = Accounts::model()->findByPk($employee->Accountid);
                    $shift = Shift::model()->findByPk($lateEmployee['id']);
                    $dept = Department::model()->findByPk($employee->departmentid);

                    $day = new DateTime($shift->StartTime);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0,$row,$day->format('Y-m-d'));
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col,$row,$employee->nic);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$employee->id);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$employee->Namewithini);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$site->name);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$account->AccountOracleCode);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$account->name);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$dept->name);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$shift->name);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$shift->StartTime);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$shift->EndTime);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$lateEmployee['Intime']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$lateEmployee['OuteTime']);

                    $row++;
                }


            $objPHPExcel->getActiveSheet()->setTitle('YiiExcel');
            $filename = "Late Attendance Report on: ".$requiredYear."-".$requiredMonth;
            header('Content-Type: application/vnd.ms-excel');
            header('Content-Disposition: attachment;filename="'.$filename.'.xls"');
            header('Cache-Control: max-age=0');

            $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');

            $objWriter->save('php://output');
            unset($this->objWriter);
            unset($this->objWorksheet);
            unset($this->objReader);
            unset($this->objPHPExcel);
            exit();
    }

    //==============================================Early outs Find=====================================================

    public function actionFindEarlyOutsDetails(){
        $model = new EarlyOutsDetailsForm;
        if(isset($_POST['EarlyOutsDetailsForm'])){

                $model->attributes=$_POST['EarlyOutsDetailsForm'];

                $requiredYear=$model->year;;
                $requiredMonth=$model->month;

                if(isset($_POST['accounts']))
                $selectedAccounts = $_POST['accounts'];

                else
                $selectedAccounts = [];

                if(!empty($selectedAccounts)){
                    $data=Yii::app()->db->createCommand(
                        "SELECT S.id, TS.EmployeeId ,TS.Intime,TS.OuteTime,E.siteid,E.Accountid
                            FROM shift AS S
                            LEFT JOIN employee_shift as ES ON  S.id = ES.ShiftID
                            LEFT JOIN timesheet as TS ON ES.id = TS.EmployeeShiftid
                            LEFT JOIN employee as E ON TS.EmployeeId = E.id
                            WHERE EXTRACT( YEAR
                            FROM S.StartTime ) = '$requiredYear'
                            AND EXTRACT(
                            MONTH FROM S.StartTime ) = '$requiredMonth'
                            AND S.id = ES.ShiftID
                            AND ES.id = TS.EmployeeShiftid
                            AND TS.OuteTime<S.EndTime ORDER by  E.Accountid
                            ")->queryAll();

                    $earlyOutEmployees = array();

                    if(!empty($data)){
                        foreach($data as $record){
                            if(in_array($record['Accountid'],$selectedAccounts))
                            $earlyOutEmployees[]= $record;

                        }
                    }


                }
                else{

                    if(!Yii::app()->user->isAdmin()){
                        $sitid = Yii::app()->user->data()->SiteId;
                        $earlyOutEmployees=Yii::app()->db->createCommand(
                            "SELECT S.id, TS.EmployeeId ,TS.Intime,TS.OuteTime,E.siteid
                             FROM shift AS S
                             LEFT JOIN employee_shift as ES ON  S.id = ES.ShiftID
                             LEFT JOIN timesheet as TS ON ES.id = TS.EmployeeShiftid
                             LEFT JOIN employee as E ON TS.EmployeeId = E.id
                             WHERE EXTRACT( YEAR
                             FROM S.StartTime ) = '$requiredYear'
                             AND EXTRACT(
                             MONTH FROM S.StartTime ) = '$requiredMonth'
                             AND S.id = ES.ShiftID
                             AND ES.id = TS.EmployeeShiftid
                             AND TS.OuteTime<S.EndTime AND E.siteid = $sitid 
                             ORDER By E.Accountid
                             ")->queryAll();
                        }

                else{

                    $earlyOutEmployees=Yii::app()->db->createCommand(
                        "SELECT S.id, TS.EmployeeId ,TS.Intime,TS.OuteTime,E.siteid
                            FROM shift AS S
                            LEFT JOIN employee_shift as ES ON  S.id = ES.ShiftID
                            LEFT JOIN timesheet as TS ON ES.id = TS.EmployeeShiftid
                            LEFT JOIN employee as E ON TS.EmployeeId = E.id
                            WHERE EXTRACT( YEAR
                            FROM S.StartTime ) = '$requiredYear'
                            AND EXTRACT(
                            MONTH FROM S.StartTime ) = '$requiredMonth'
                            AND S.id = ES.ShiftID
                            AND ES.id = TS.EmployeeShiftid
                            AND TS.OuteTime<S.EndTime ORDER by E.siteid,E.Accountid
                            ")->queryAll();

                }

                }




                $this->render('//timelog/earlyOutsReport', array('model'=>$model,'requiredYear'=> $requiredYear,'requiredMonth'=>$requiredMonth,'earlyOutEmployees'=> $earlyOutEmployees));

    }
        else{

            $this->render('//timelog/getEarlyOutsDetailsForm', array('model'=>$model));
         }


    }

    //===========================================Early outs PDF==============================================================
    public function actionCreateEarlyOutPDF(){

        $requiredYear = CJSON::decode($_POST['requiredYear']);
        $requiredMonth = CJSON::decode($_POST['requiredMonth']);
        $earlyOutEmployees = CJSON::decode($_POST['earlyOutEmployees']);
        $mpdf1 = Yii::app()->ePdf->mpdf();
        $mpdf1->setAutoBottomMargin = 'stretch';
        $mpdf1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
        $mpdf1->WriteHTML($this->renderPartial('//timelog/earlyOutsPDF', array('model'=>$model,'earlyOutEmployees'=> $earlyOutEmployees, 'requiredYear'=> $requiredYear,'requiredMonth'=>$requiredMonth),true));


        $file_name= "Early Out Report on:".$requiredYear." ".$requiredMonth.".pdf";

        ob_end_clean();

        $mpdf1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );

     }

    //===========================================Early Outs Excel============================================================

    public function actionCreateEarlyOutExcel(){


        $objPHPExcel = new PHPExcel();
        $requiredYear = CJSON::decode($_POST['requiredYear']);
        $requiredMonth = CJSON::decode($_POST['requiredMonth']);
        $dateObj   = DateTime::createFromFormat('!m', $requiredMonth);
        $monthName = $dateObj->format('F');

        $earlyOutEmployees = CJSON::decode($_POST['earlyOutEmployees']);
                // Set document properties
                $objPHPExcel->getProperties()->setCreator("K'iin Balam")
                     ->setLastModifiedBy("K'iin Balam")
                     ->setTitle("YiiExcel Test Document")
                     ->setSubject("YiiExcel Test Document")
                     ->setDescription("Test document for YiiExcel, generated using PHP classes.")
                     ->setKeywords("office PHPExcel php YiiExcel UPNFM")
                     ->setCategory("Test result file");



                // Add some data
                $objPHPExcel->setActiveSheetIndex(0)
                    ->setCellValue('A1', 'Early outs Report')
                    ->setCellValue('E1', 'Generated On')
                    ->setCellValue('F1', date("Y-m-d - h:i:sa"))
                    ->setCellValue('C1', $requiredYear."  ".$monthName)
                    ->setCellValue('A4', 'Date')
                    ->setCellValue('B4', 'NIC')
                    ->setCellValue('C4', 'Employee ID')
                    ->setCellValue('D4', 'Name')
                    ->setCellValue('E4', 'Site')
                    ->setCellValue('F4', 'Client Code')
                    ->setCellValue('G4', 'Client Name')
                    ->setCellValue('H4','Department')
                    ->setCellValue('I4', 'Shift')
                    ->setCellValue('J4', 'Shift Start')
                    ->setCellValue('K4', 'Shift End')
                    ->setCellValue('L4', 'In Time')
                    ->setCellValue('M4', 'Out Time');

                    $styleArray = array(
                        'font'  => array(
                            'bold'  => true,
                            'color' => array('rgb' => '#f79727'),
                            'size'  => 10
                        ));
                    $objPHPExcel->getActiveSheet()->getStyle('A1:M4')->applyFromArray($styleArray);
                    $row = 5;
                      foreach($earlyOutEmployees as $earlyOutEmployee) {
                            $col =1;
                            $employee = Employee::model()->findByPk($earlyOutEmployee['EmployeeId']);
                            $site = Sites::model()->findByPk($employee->siteid);
                            $account = Accounts::model()->findByPk($employee->Accountid);
                            $shift = Shift::model()->findByPk($earlyOutEmployee['id']);
                            $dept = Department::model()->findByPk($employee->departmentid);
                            $day = new DateTime($shift->StartTime);

                            $shift = Shift::model()->findByPk($earlyOutEmployee['id']);
                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0,$row,$day->format('Y-m-d'));
                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col,$row,$employee->nic);
                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$employee->id);
                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$employee->Namewithini);
                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$site->name);
                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$account->AccountOracleCode);
                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$account->name);
                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$dept->name);
                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$shift->name);
                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$shift->StartTime);
                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$shift->EndTime);
                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$earlyOutEmployee['Intime']);
                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$earlyOutEmployee['OuteTime']);

                            $row++;
                        }



                $objPHPExcel->getActiveSheet()->setTitle('YiiExcel');
                $filename = "Early Outs Report on: ".$requiredYear."-".$requiredMonth;
                header('Content-Type: application/vnd.ms-excel');
                header('Content-Disposition: attachment;filename="'.$filename.'.xls"');
                header('Cache-Control: max-age=0');

                $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');

                $objWriter->save('php://output');
                unset($this->objWriter);
                unset($this->objWorksheet);
                unset($this->objReader);
                unset($this->objPHPExcel);
                exit();
            }

    public function actionFindConsecutiveAbsenceDetails(){
        $model = new ConsecutiveAbsenceDetailsForm;
        if(isset($_POST['ConsecutiveAbsenceDetailsForm'])){

                $model->attributes=$_POST['ConsecutiveAbsenceDetailsForm'];

                $requiredYear=$model->year;
                $requiredMonth=$model->month;

                $effectedEmployees =Yii::app()->db->createCommand(
                    "SELECT employee_shift.EmployeeId
                    FROM  `employee_shift`
                    LEFT JOIN shift ON employee_shift.Shiftid = shift.id
                    WHERE EXTRACT( YEAR FROM shift.StartTime ) ='$requiredYear' AND EXTRACT(MONTH FROM shift.StartTime ) ='$requiredMonth'
                    Group by EmployeeId")->queryAll();

                $continuousAbsents = array();

                foreach($effectedEmployees as $index=>  $effectedEmployee){
                    $id = $effectedEmployee['EmployeeId'];
                    $count=Yii::app()->db->createCommand(
                    "SELECT DISTINCT o2.id
                    FROM (
                    SELECT employee_shift.id AS id, employee_shift.Status AS
                    STATUS , employee_shift.EmployeeId AS EmployeeId, employee_shift.ShiftId AS ShiftId, timesheet.Intime AS Intime
                    FROM  `employee_shift`
                    LEFT JOIN timesheet ON employee_shift.id = timesheet.EmployeeShiftid
                    WHERE employee_shift.EmployeeId = $id
                    ) AS o1, (

                    SELECT employee_shift.id AS id,
                    employee_shift.Status AS STATUS , employee_shift.EmployeeId AS EmployeeId, employee_shift.ShiftId AS ShiftId, timesheet.Intime AS Intime
                    FROM  `employee_shift`
                    LEFT JOIN timesheet ON employee_shift.id = timesheet.EmployeeShiftid
                    WHERE employee_shift.EmployeeId = $id
                    ) AS o2
                    WHERE (
                    o1.ShiftId = o2.ShiftId -1
                    OR o1.ShiftId = o2.ShiftId +1
                    )
                    AND o2.STATUS = 1
                    AND o1.Intime IS NULL
                    AND o2.Intime IS NULL
                    AND o1.ShiftId
                    IN (

                    SELECT shift.id
                    FROM shift
                    WHERE EXTRACT( YEAR
                    FROM StartTime ) ='$requiredYear'
                    AND EXTRACT(
                    MONTH FROM StartTime ) ='$requiredMonth'
                    ) "
                )->queryAll();

                    if(count($count)!=0){
                        $employee = Employee::model()->findByPk($id);


                        if(Yii::app()->user->isAdmin()){
                            $continuousAbsents[$index] = array('EmployeeId'=>$id,'Count'=>count($count),'site'=>$employee->siteid);
                            }

                            else{
                                $sitid = Yii::app()->user->data()->SiteId;
                                if($employee->siteid == $sitid){
                                    $continuousAbsents[$index] = array('EmployeeId'=>$id,'Count'=>count($count),'site'=>$employee->siteid);
                                }
                                else{
                                    continue;
                                }
                            }
                    }


                    }

                    $requirement = array();
                    foreach ($continuousAbsents as $key => $row)
                    {
                        $requirement[$key] = $row['site'];
                    }
                    array_multisort($requirement, SORT_DESC, $continuousAbsents);



                $this->render('//timelog/consecutiveAbsenceReport', array('model'=>$model,'requiredYear'=> $requiredYear,'requiredMonth'=>$requiredMonth,'continuousAbsents'=> $continuousAbsents));




    }
        else{

            $this->render('//timelog/getConsecutiveAbsenceDetailsForm', array('model'=>$model));
            }


    }
//====================================================Continuous Absence PDF=================================================================

public function actionCreateContinuousAbsencePDF(){

$requiredYear = CJSON::decode($_POST['requiredYear']);
$requiredMonth = CJSON::decode($_POST['requiredMonth']);
$continuousAbsents = CJSON::decode($_POST['continuousAbsents']);
$mpdf1 = Yii::app()->ePdf->mpdf();
$mpdf1->setAutoBottomMargin = 'stretch';
$mpdf1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
$mpdf1->WriteHTML($this->renderPartial('//timelog/continuousAbsencePDF', array('model'=>$model,'continuousAbsents'=> $continuousAbsents, 'requiredYear'=> $requiredYear,'requiredMonth'=>$requiredMonth),true));


$file_name= "Continuous Absenteeism Report on:".$requiredYear." ".$requiredMonth.".pdf";

ob_end_clean();


$mpdf1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );

}

//=============================Continuous Absence Excel=============================================================================================
    public function actionCreateContinuousAbsenceExcel(){


        $objPHPExcel = new PHPExcel();
        $requiredYear = CJSON::decode($_POST['requiredYear']);
        $requiredMonth = CJSON::decode($_POST['requiredMonth']);
        $dateObj   = DateTime::createFromFormat('!m', $requiredMonth);
        $monthName = $dateObj->format('F');

        $continuousAbsents = CJSON::decode($_POST['continuousAbsents']);
            // Set document properties
            $objPHPExcel->getProperties()->setCreator("K'iin Balam")
                ->setLastModifiedBy("K'iin Balam")
                ->setTitle("YiiExcel Test Document")
                ->setSubject("YiiExcel Test Document")
                ->setDescription("Test document for YiiExcel, generated using PHP classes.")
                ->setKeywords("office PHPExcel php YiiExcel UPNFM")
                ->setCategory("Test result file");

            // Add some data
            $objPHPExcel->setActiveSheetIndex(0)
                ->setCellValue('A1', 'Continuous Absenteeism Report')
                ->setCellValue('E1', 'Generated On')
                ->setCellValue('F1', date("Y-m-d - h:i:sa"))
                ->setCellValue('C1', $requiredYear."  ".$monthName)
                ->setCellValue('A4', 'NIC')
                ->setCellValue('B4', 'Employee ID')
                ->setCellValue('C4', 'Name')
                ->setCellValue('D4', 'Designation')
                ->setCellValue('E4', 'Department')
                ->setCellValue('F4', 'Site')
                ->setCellValue('G4', 'Client Code')
                ->setCellValue('H4', 'Client Name')
                ->setCellValue('I4', 'Continuosly Absent Days');


            $styleArray = array(
                'font'  => array(
                    'bold'  => true,
                    'color' => array('rgb' => '#f79727'),
                    'size'  => 10
                ));
            $objPHPExcel->getActiveSheet()->getStyle('A1:I4')->applyFromArray($styleArray);
                $row = 5;
                foreach($continuousAbsents as $continuousAbsent) {
                        $col =1;
                        $employee = Employee::model()->findByPk($continuousAbsent['EmployeeId']);
                        $designation = Designation::model()->findByPk($employee->designationid);
                        $site = Sites::model()->findByPk($continuousAbsent['site']);
                        $dept = Department::model()->findByPk($employee->departmentid);
                        $account = Accounts::model()->findByPk($employee->Accountid);

                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0,$row,$employee->nic);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col,$row,$employee->id);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$employee->Namewithini);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$designation->type);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$dept->name);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$site->name);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$account->AccountOracleCode);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$account->name);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$continuousAbsent['Count']);

                        $row++;
                    }



            $objPHPExcel->getActiveSheet()->setTitle('YiiExcel');
            $filename = "Continuos Absenteeism Report on: ".$requiredYear."-".$requiredMonth;
            header('Content-Type: application/vnd.ms-excel');
            header('Content-Disposition: attachment;filename="'.$filename.'.xls"');
            header('Cache-Control: max-age=0');

            $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');

            $objWriter->save('php://output');
            unset($this->objWriter);
            unset($this->objWorksheet);
            unset($this->objReader);
            unset($this->objPHPExcel);
            exit();
        }

//==================================================================================================================================================
public function actionfindAttendanceSummaryDetails(){
    $model = new MonthlySummaryAttendanceForm;
    if(isset($_POST['MonthlySummaryAttendanceForm'])){
            $model->attributes=$_POST['MonthlySummaryAttendanceForm'];
            if($model->validate()){
              if(!Yii::app()->user->isAdmin()){
                $model->site = Yii::app()->user->data()->SiteId;
            }

        $finalResult  = Yii::app()->db->createCommand("CALL GetSummary('$model->startDate','$model->endDate','$model->site')")->queryAll();
        $listHolidays = CHtml::listData(Holydays::model()->findAllBySql("SELECT * FROM holydays WHERE Date >= '$model->startDate' AND Date <= '$model->endDate'"), 'id', 'Date');
        $holidays= array_values($listHolidays); // change the index of the array
        $sunDaysArr = $this->getDateForSpecificDayBetweenDates(DATE($model->startDate), DATE($model->endDate), 0);
        $comma_separated = implode("','", $sunDaysArr);
        $comma_separated = "'".$comma_separated."'";

        foreach($finalResult as $index => $log){
            $id =$log['EmployeeId'];
                $leaves =Yii::app()->db->createCommand("SELECT count(leaveDays) as leaveCount FROM `leavedays` WHERE EmpId = $id AND leaveType ='NO Pay'
                AND  DATE(`leavedays`.leaveDays) >= '$model->startDate' AND DATE(`leavedays`.leaveDays) <= '$model->endDate'")->queryAll();


           $finalResult[$index]['NoPayCount']= $leaves[0]['leaveCount'];

           if($comma_separated != "''"){
            $sundayWorks= Yii::app()->db->createCommand("SELECT COUNT(T.date) Sundays
                FROM timesheet T
                INNER JOIN employee E ON E.id = T.EmployeeId
                WHERE E.id = $id  AND  T.date in ($comma_separated)")->queryAll();
            
            $finalResult[$index]['SundaysWork']= $sundayWorks[0]['Sundays']; 
            
    }

        }
       
        $this->render('//timelog/attendanceSummaryReport', array('model'=>$model,'finalResult'=> $finalResult));
    }
    else{
        $this->render('//timelog/attendanceSummaryReport', array('model'=>$model,'finalResult'=> array()));

    }
}


    else{

        $this->render('//timelog/getAttendanceSummaryDetailsForm', array('model'=>$model));
     }


}

//===========================================Create Attendance Summary PDF==============================================================
    public function actionCreateAttendanceSummaryPDF(){

        $finalResult = CJSON::decode($_POST['finalResult']);
        $model = CJSON::decode($_POST['model']);
        $mpdf1 = Yii::app()->ePdf->mpdf();
        $mpdf1->setFooter('{PAGENO}');

        $mpdf1->WriteHTML($this->renderPartial('//timelog/attendanceSummaryPDF', array('model'=>$model,'finalResult'=> $finalResult),true));
        $mpdf1->SetFooter("Report generated by ".Yii::app()->user->name." on ".date('Y-m-d H:i:s')."<br />powered by eIMSky Business Solutions Pvt Ltd.");

        $file_name= "Attendance Summary Report For: ".$model['startDate']." - ".$model['endDate']. " Created On".date('Y-m-d H:i:s').".pdf";

        ob_end_clean();

        $mpdf1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );

    }

//==========================================create Attendance Summary Excel===========================================================


        public function actionCreateAttendanceSummaryExcel(){


            $objPHPExcel = new PHPExcel();
            $finalResult = CJSON::decode($_POST['finalResult']);
            $model = CJSON::decode($_POST['model']);
            $site = Sites::model()->findByPk($model['site']);
            // Set document properties
            $objPHPExcel->getProperties()->setCreator("K'iin Balam")
                ->setLastModifiedBy("K'iin Balam")
                ->setTitle("YiiExcel Test Document")
                ->setSubject("YiiExcel Test Document")
                ->setDescription("Test document for YiiExcel, generated using PHP classes.")
                ->setKeywords("office PHPExcel php YiiExcel UPNFM")
                ->setCategory("Test result file");

            // Add some data
            $objPHPExcel->setActiveSheetIndex(0)
                ->setCellValue('A1', "Attendance Summary Report from : ".$model['startDate']." - ".$model['endDate'])
                ->setCellValue('D1', 'Site :')
                ->setCellValue('E1',$site->name)
                ->setCellValue('F1', 'Generated On')
                ->setCellValue('G1', date("Y-m-d - h:i:sa"))
                ->setCellValue('A2', 'NIC')
                ->setCellValue('B2', 'Employee ID')
                ->setCellValue('C2', 'Name')
                ->setCellValue('D2', 'Designation')
                ->setCellValue('E2', 'Present Days')
                ->setCellValue('F2', 'Absent Days')
                ->setCellValue('G2', 'Worked Hours')
                ->setCellValue('H2', 'In Late Deduct (Hrs.)')
                ->setCellValue('I2', 'early out Deduct(Hrs.)')   
                ->setCellValue('J2', 'Actual N-OT (Hrs.) ')  
                ->setCellValue('K2', 'Actual D-OT (Hrs.)')
                ->setCellValue('L2', 'Actual T-OT (Hrs.)')
                ->setCellValue('M2', 'Approved N-OT (Hrs.) ')
                ->setCellValue('N2', 'Approved D-OT (Hrs.)')
                ->setCellValue('O2', 'Approved T-OT (Hrs.)')
                ->setCellValue('P2', 'Total Overtime (Hrs.)')
                ->setCellValue('Q2', 'No Pay Days')
                ->setCellValue('R2', 'Worked-Sundays')
                ->setCellValue('S2', 'Client Code')
                ->setCellValue('T2', 'Client Name')
                ->setCellValue('U2', 'Department')
                ->setCellValue('V2', 'Payment Method');


            $styleArray = array(
                'font'  => array(
                    'bold'  => true,
                    'color' => array('rgb' => '#f79727'),
                    'size'  => 10
                ));
            $objPHPExcel->getActiveSheet()->getStyle('A1:W2')->applyFromArray($styleArray);
                $row = 3;
                foreach($finalResult as $final) {
                    $col =1;
                    $employee = Employee::model()->findByPk($final['EmployeeId']);
                    $account = Accounts::model()->findByPk($employee->Accountid);
                    $patmentMethod = Paymentmethod::model()->findByPk($employee->paymentmethodid);
                    $dept = Department::model()->findByPk($employee->departmentid);

                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0,$row,$employee->nic);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col,$row,$employee->id);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$employee->Namewithini);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$final['designation']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$final['PresentDays']);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$final['AbsentDays']);

                    if($final['WorkedHour']!=NULL)
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,Yii::app()->commonUtil->convertToHoursMins($final['WorkedHour']));
                    else
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,'-');

                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,Yii::app()->commonUtil->convertToHoursMins($final['Hourgap']));
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,Yii::app()->commonUtil->convertToHoursMins($final['OutLateHrs']));
                   
                    if($final['ActualNOT']!=NULL)
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,Yii::app()->commonUtil->convertToHoursMins($final['ActualNOT']));
                    else
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,'-');

                    if($final['ActualDOT']!=NULL)
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,Yii::app()->commonUtil->convertToHoursMins($final['ActualDOT']));
                    else
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,'-');

                    if($final['ActualTOT']!=NULL)
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,Yii::app()->commonUtil->convertToHoursMins($final['ActualTOT']));
                    else
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,'-');

                    if($final['NOTHrs']!=NULL)
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,Yii::app()->commonUtil->convertToHoursMins($final['NOTHrs']));
                    else
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,'-');

                    if($final['DOTHrs']!=NULL)
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,Yii::app()->commonUtil->convertToHoursMins($final['DOTHrs']));
                    else
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,'-');

                    if($final['TOTHrs']!=NULL)
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,Yii::app()->commonUtil->convertToHoursMins($final['TOTHrs']));
                    else
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,'-');

                    if($final['TotOTHrs']!=NULL)
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,Yii::app()->commonUtil->convertToHoursMins($final['TotOTHrs']));
                    else
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,'-');

                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,Yii::app()->commonUtil->convertToHoursMins($final['NoPayCount']));
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,Yii::app()->commonUtil->convertToHoursMins($final['SundaysWork']));
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$account->AccountOracleCode);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$account->name);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$dept->name);
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$patmentMethod->type);
                    $row++;
                    
                }



            $objPHPExcel->getActiveSheet()->setTitle('YiiExcel');
            $filename = "Attendance Summary Report Form: " .$model['startDate']." - ".$model['endDate']." Created On ".date("Y-m-d - h:i:sa");
            header('Content-Type: application/vnd.ms-excel');
            header('Content-Disposition: attachment;filename="'.$filename.'.xls"');
            header('Cache-Control: max-age=0');

            $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');

            $objWriter->save('php://output');
            unset($this->objWriter);
            unset($this->objWorksheet);
            unset($this->objReader);
            unset($this->objPHPExcel);
            exit();
        }
//==================================================================
public function actionSearchByDesignation(){
    $model = new SearchDesignation;

    if(isset($_POST['SearchDesignation'])){
        // print_r($_POST['accounts']);
        // die;
        $model-> attributes = $_POST['SearchDesignation'];
        if($model->validate()){
                if(isset($_POST['accounts'])){
                    $logs = Yii::app()->db->createCommand("SELECT  A.AccountOracleCode accountId,DS.MonthlySalary salary,D.type type,E.nic nic,E.id id,E.Namewithini name,S.name site,A.name account
                                    FROM employee E
                                    INNER JOIN designation D ON D.id = E.designationid
                                    INNER JOIN sites S ON S.id = E.siteid
                                    INNER JOIN accounts A ON A.id = E.Accountid
                                    INNER JOIN designation_salary DS ON DS.DesignationId = D.id
                                    WHERE E.designationid = $model->designationId AND E.statusId = 1 AND DS.Status = 1 AND E.siteid = DS.Siteid AND E.accountId  IN (".implode(',',$_POST['accounts']).")
                                    ORDER BY site,account")->queryAll();
                }else{
                    if(Yii::app()->user->isAdmin()){
                        $logs = Yii::app()->db->createCommand("SELECT  A.AccountOracleCode accountId,DS.MonthlySalary salary,D.type type,E.nic nic,E.id id,E.Namewithini name,S.name site,A.name account
                                    FROM employee E
                                    INNER JOIN designation D ON D.id = E.designationid
                                    INNER JOIN sites S ON S.id = E.siteid
                                    INNER JOIN accounts A ON A.id = E.Accountid
                                    INNER JOIN designation_salary DS ON DS.DesignationId = D.id
                                    WHERE E.designationid = $model->designationId AND E.statusId = 1 AND E.siteid = DS.Siteid AND DS.Status = 1
                                    ORDER BY site,account")->queryAll();
                    }

                    else{
                        $sitid = Yii::app()->user->data()->SiteId;
                        

                        $logs = Yii::app()->db->createCommand("SELECT A.AccountOracleCode accountId,DS.MonthlySalary salary,D.type type,E.nic nic,E.id id,E.Namewithini name,S.name site,A.name account
                                    FROM employee E
                                    INNER JOIN designation D ON D.id = E.designationid
                                    INNER JOIN sites S ON S.id = E.siteid
                                    INNER JOIN accounts A ON A.id = E.Accountid
                                    INNER JOIN designation_salary DS ON DS.DesignationId = D.id
                                    WHERE E.designationid = $model->designationId AND E.statusId = 1 AND DS.Status = 1 AND DS.Siteid =$sitid AND E.siteid = $sitid 
                                    ORDER BY site,account")->queryAll();
                    }
                }






            $this->render('//designation/viewDesignation',array('logs'=>$logs,'model'=>$model));

        }

    }else{
        $this->render('//designation/searchDesignationForm',array('model'=>$model,));
    }



}
//==================================================================
public function actionDesignationPdf(){
    $logs = CJSON::decode($_POST['logs']);
    $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
    $mPDF1->setAutoBottomMargin = 'stretch';
    $mPDF1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
    $mPDF1->WriteHTML($this->renderPartial('//designation/viewDesignationPDF',array('logs'=>$logs),true));
    $file_name= $logs[0]['type'].'--'.date("Y-m-d  -  h:i:sa").'.pdf';


    ob_end_clean();
    $mPDF1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );
}

//==================================================================
public function actionDesignationExcel(){
    $objPHPExcel = new PHPExcel();
    $logs = CJSON::decode($_POST['logs']);



    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue('A1','Designation Report')
    ->setCellValue('E1', 'Generated On')
    ->setCellValue('F1', date("Y-m-d - h:i:sa"))
    ->setCellValue('A2', 'ID')
    ->setCellValue('B2', 'NIC')
    ->setCellValue('C2', 'NAME')
    ->setCellValue('D2', 'SITE')
    ->setCellValue('E2', 'Client Code')
    ->setCellValue('F2', 'Client Name');
    $y = 3;

    $styleArray = array(
        'font'  => array(
            'bold'  => true,
            'color' => array('rgb' => '#f79727'),
            'size'  => 10
        ));
    $objPHPExcel->getActiveSheet()->getStyle('A1:F2')->applyFromArray($styleArray);

    foreach($logs as $logs){


        $objPHPExcel->setActiveSheetIndex(0)
        ->setCellValue('A'.$y, $logs['id'])
        ->setCellValue('B'.$y, $logs['nic'])
        ->setCellValue('C'.$y, $logs['name'])
        ->setCellValue('D'.$y, $logs['site'])
        ->setCellValue('E'.$y, $logs['accountId'])
        ->setCellValue('F'.$y, $logs['account']);
        $y++;


    }
   // $objPHPExcel->getActiveSheet()->setTitle($logs['type']);

    $objPHPExcel->setActiveSheetIndex(0);

    ob_end_clean();
    ob_start();

    header('Content-Type: application/vnd.ms-excel');
    header('Content-Disposition: attachment;filename='.$logs['type'].'.xls');
    header('Cache-Control: max-age=0');
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
    $objWriter->save('php://output');
  }



//====================================Audit logs related Reports===========================================

public function actionFindAuditLogs(){

            $model = new ModelAuditLogForm;
            if(isset($_POST['ModelAuditLogForm'])){

                $model->attributes=$_POST['ModelAuditLogForm'];  // only schedule is setted.
                if($model->validate()){

                    $auditModel = AuditModel::model()->findByPk($model->neededModel);
                    $logs =Yii::app()->db->createCommand("SELECT * FROM trackrecordlog WHERE model = '$auditModel->model_name'
                            AND DATE(creationdate) >= '$model->startDate' AND DATE(creationdate) <= '$model->endDate' ORDER BY action,creationdate ")->queryAll();


                    $this->render('//auditLog/viewModelAuditLog',array('model'=>$model,'logs'=>$logs));

                    }

            }

            else{

                $this->render('//auditLog/getModelAuditLogs', array('model'=>$model));
             }

        }

        public function actionCreateAuditLogPDF(){

            $model = CJSON::decode($_POST['auditmodel']);
            $logs = CJSON::decode($_POST['logs']);
            $mpdf1 = Yii::app()->ePdf->mpdf();

            $auditingModel = AuditModel::model()->findByPk($model['neededModel']);
            $mpdf1->setFooter('{PAGENO}');
            $mpdf1->WriteHTML($this->renderPartial('//auditLog/viewModelAuditLogPDF', array('model'=>$model,'logs'=> $logs),true));
            $mpdf1->SetFooter($auditingModel->model_name." Audit Log Report created by : ".Yii::app()->user->name." on ".date('Y-m-d H:i:s')."<br />powered by eIMSky Business Solutions Pvt Ltd.");

            $file_name= $auditingModel->model_name." : Audit Log Report From :".$startDate." To :  ".$endDate.".pdf";

            ob_end_clean();

            $mpdf1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );

        }

        public function actionCreateAuditLogExcel(){


            $objPHPExcel = new PHPExcel();
            $model = CJSON::decode($_POST['auditmodel']);
            $logs = CJSON::decode($_POST['logs']);
                    // Set document properties
                    $objPHPExcel->getProperties()->setCreator("K'iin Balam")
                         ->setLastModifiedBy("K'iin Balam")
                         ->setTitle("YiiExcel Test Document")
                         ->setSubject("YiiExcel Test Document")
                         ->setDescription("Test document for YiiExcel, generated using PHP classes.")
                         ->setKeywords("office PHPExcel php YiiExcel UPNFM")
                         ->setCategory("Test result file");

                    $auditingModel = AuditModel::model()->findByPk($model['neededModel']);
                    // Add some data
                    $objPHPExcel->setActiveSheetIndex(0)
                        ->setCellValue('A1', $auditingModel->model_name.' Audit log Report')
                        ->setCellValue('E1', 'Generated On')
                        ->setCellValue('F1', date("Y-m-d - h:i:sa"))
                        ->setCellValue('A2', 'Start Date :')
                        ->setCellValue('A3', 'End Date   :')
                        ->setCellValue('C2',$model['startDate'])
                        ->setCellValue('C3',$model['endDate'])
                        ->setCellValue('A4', 'ID')
                        ->setCellValue('B4', 'Action')
                        ->setCellValue('C4', 'Field')
                        ->setCellValue('D4', 'Old Value')
                        ->setCellValue('E4', 'New Value')
                        ->setCellValue('F4', 'Date')
                        ->setCellValue('G4', 'Changed User');

                        $styleArray = array(
                            'font'  => array(
                                'bold'  => true,
                                'color' => array('rgb' => '#f79727'),
                                'size'  => 10
                            ));
                        $objPHPExcel->getActiveSheet()->getStyle('A1:G4')->applyFromArray($styleArray);
                        $row = 5;
                          foreach($logs as $log) {
                                $col =1;

                                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0,$row,$log['idModel']);
                                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col,$row,$log['action']);
                                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$log['field']);
                                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$log['old_value']);
                                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$log['new_value']);
                                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$log['creationdate']);
                                $user=User::model()->findByPk($log['userid']);
                                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$user->username);

                                $row++;

                            }



                    $objPHPExcel->getActiveSheet()->setTitle('YiiExcel');
                    $filename = $auditingModel->model_name." Audit Report on: ".$model['startDate']."  -  ".$model['endDate'];
                    header('Content-Type: application/vnd.ms-excel');
                    header('Content-Disposition: attachment;filename="'.$filename.'.xls"');
                    header('Cache-Control: max-age=0');

                    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');

                    $objWriter->save('php://output');
                    unset($this->objWriter);
                    unset($this->objWorksheet);
                    unset($this->objReader);
                    unset($this->objPHPExcel);
                    exit();
                }
//==========================================================================================================



//========================================Employee Model Audit logs=========================================
public function actionAuditLogEmployee(){

    $model = new EmployeeModelAuditForm;
    if(isset($_POST['EmployeeModelAuditForm'])){

        $model->attributes=$_POST['EmployeeModelAuditForm'];  // only schedule is setted.
        if($model->validate()){

            $logs =Yii::app()->db->createCommand("SELECT * FROM trackrecordlog WHERE model = 'Employee' AND DATE(creationdate) >= '$model->startDate' AND DATE(creationdate) <= '$model->endDate' ORDER BY action,creationdate")->queryAll();

              //send data to view form
           $this->render('//employee/viewEmployeeAuditLogs',array('model'=>$model,'logs'=>$logs));

           }

    }

    else{

        $this->render('//employee/getEmployeeAuditLogs', array('model'=>$model));
     }


 }



public function actionCreateAuditLogEmployeePDF(){

    $model = CJSON::decode($_POST['auditmodel']);
    $logs = CJSON::decode($_POST['logs']);
    $mpdf1 = Yii::app()->ePdf->mpdf();

    $mpdf1->setFooter('{PAGENO}');
    $mpdf1->WriteHTML($this->renderPartial('//employee/employeeAuditLogPDF', array('model'=>$model,'logs'=> $logs),true));
    $mpdf1->SetFooter("Employee Audit Log Report created by : ".Yii::app()->user->name." on ".date('Y-m-d H:i:s')."<br />powered by eIMSky Business Solutions Pvt Ltd.");

    $file_name= "Employee Audit Log Report From :".$startDate." To :  ".$endDate.".pdf";
    ob_end_clean();
    $mpdf1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );

}

public function actionCreateAuditLogEmployeeExcel(){


    $objPHPExcel = new PHPExcel();
    $model = CJSON::decode($_POST['auditmodel']);
    $logs = CJSON::decode($_POST['logs']);
            // Set document properties
            $objPHPExcel->getProperties()->setCreator("K'iin Balam")
                 ->setLastModifiedBy("K'iin Balam")
                 ->setTitle("YiiExcel Test Document")
                 ->setSubject("YiiExcel Test Document")
                 ->setDescription("Test document for YiiExcel, generated using PHP classes.")
                 ->setKeywords("office PHPExcel php YiiExcel UPNFM")
                 ->setCategory("Test result file");

            // Add some data
            $objPHPExcel->setActiveSheetIndex(0)
                ->setCellValue('A1', 'Employee Audit Log Report')
                ->setCellValue('E1', 'Generated On')
                ->setCellValue('F1', date("Y-m-d - h:i:sa"))
                ->setCellValue('A2','Start Date : ')
                ->setCellValue('A3','End Date   :')
                ->setCellValue('C2', $model['startDate'])
                ->setCellValue('C3', $model['endDate'])
                ->setCellValue('A4', 'Action')
                ->setCellValue('B4', 'Employee ID')
                ->setCellValue('C4', 'Employee NIC')
                ->setCellValue('D4', 'Field')
                ->setCellValue('E4', 'Old Value')
                ->setCellValue('F4', 'New Value')
                ->setCellValue('G4', 'Date')
                ->setCellValue('H4', 'Changed User');

                $styleArray = array(
                    'font'  => array(
                        'bold'  => true,
                        'color' => array('rgb' => '#f79727'),
                        'size'  => 10
                    ));
                $objPHPExcel->getActiveSheet()->getStyle('A1:H4')->applyFromArray($styleArray);
                $row = 5;
                  foreach($logs as $log) {
                        $col =1;
                        $employee = Employee::model()->findByPk($log['idModel']);


                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0,$row,$log['action']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col,$row,$employee->id);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$employee->nic);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$log['field']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$log['old_value']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$log['new_value']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$log['creationdate']);
                        $user=User::model()->findByPk($log['userid']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$user->username);

                        $row++;

                    }



            $objPHPExcel->getActiveSheet()->setTitle('YiiExcel');
            $filename = "Employee Audit Report on: ".$model['startDate']."  -  ".$model['endDate'];
            header('Content-Type: application/vnd.ms-excel');
            header('Content-Disposition: attachment;filename="'.$filename.'.xls"');
            header('Cache-Control: max-age=0');

            $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');

            $objWriter->save('php://output');
            unset($this->objWriter);
            unset($this->objWorksheet);
            unset($this->objReader);
            unset($this->objPHPExcel);
            exit();
        }
//==========================================================================================================
public function actionEmployeeAllAttendance(){
    $model = new EmployeeAllAttendance;
    if(isset($_POST['EmployeeAllAttendance'])){
        $model->attributes = $_POST['EmployeeAllAttendance'];//$model->startDate  $model->endDate  $model->employee

        if($model->validate()){

            function toDate($x){
                return date('Y-m-d', $x);
            }
            $dates = range(strtotime($model->startDate), strtotime($model->endDate),86400);
            $range_of_dates = array_map('toDate',$dates);
            //print_r($range_of_dates);
            //die;
            if(Yii::app()->user->isAdmin()){
                $list= Yii::app()->db->createCommand("SELECT D.selected_date,IFNULL(T.Intime,'------') Intime,IFNULL(T.OuteTime,'------') OuteTime,IFNULL(T.date,'------') date,IFNULL(T.WorkedHour,'------') Hours,IFNULL(T.NOvertimeHours,'------') NOTH, IFNULL(T.DOverTimeHour,'------') DOTH,IFNULL(T.TOverTimeHour,'------') TOTH,IFNULL(T.TotalOTHour,'------') ttlOT,LD.leaveType Lid,LT.Type leaveType,sites.name siteName
                FROM (select * from
                (select adddate('1970-01-01',t4.i*10000 + t3.i*1000 + t2.i*100 + t1.i*10 + t0.i) selected_date from
                (select 0 i union select 1 union select 2 union select 3 union select 4 union select 5 union select 6 union select 7 union select 8 union select 9) t0,
                (select 0 i union select 1 union select 2 union select 3 union select 4 union select 5 union select 6 union select 7 union select 8 union select 9) t1,
                (select 0 i union select 1 union select 2 union select 3 union select 4 union select 5 union select 6 union select 7 union select 8 union select 9) t2,
                (select 0 i union select 1 union select 2 union select 3 union select 4 union select 5 union select 6 union select 7 union select 8 union select 9) t3,
                (select 0 i union select 1 union select 2 union select 3 union select 4 union select 5 union select 6 union select 7 union select 8 union select 9) t4) v
                where selected_date between DATE('$model->startDate') and DATE('$model->endDate') ) as D
                LEFT JOIN (SELECT * FROM  timesheet WHERE timesheet.date >= DATE('$model->startDate') AND timesheet.date <= DATE('$model->endDate') AND timesheet.EmployeeId = $model->employee) T on D.selected_date = T.date
                LEFT JOIN sites ON sites.id = T.SiteId
                LEFT JOIN (SELECT * FROM leavedays WHERE EmpId = $model->employee AND leaveDays >= DATE('$model->startDate') AND leaveDays <= DATE('$model->endDate')  ) LD ON LD.leaveDays=D.selected_date
                LEFT JOIN `leave` L ON L.id = LD.leaveId
                LEFT JOIN leavetype LT ON LT.id = L.LeaveType
                ORDER BY D.selected_date ASC")->queryAll();
            }else{
                $sitid = Yii::app()->user->data()->SiteId;
                $list= Yii::app()->db->createCommand("SELECT D.selected_date,IFNULL(T.Intime,'------') Intime,IFNULL(T.OuteTime,'------') OuteTime,IFNULL(T.date,'------') date,IFNULL(T.WorkedHour,'------') Hours,IFNULL(T.NOvertimeHours,'------') NOTH, IFNULL(T.DOverTimeHour,'------') DOTH,IFNULL(T.TOverTimeHour,'------') TOTH,IFNULL(T.TotalOTHour,'------') ttlOT,LD.leaveType Lid,LT.Type leaveType,sites.name siteName
                FROM (select * from
                (select adddate('1970-01-01',t4.i*10000 + t3.i*1000 + t2.i*100 + t1.i*10 + t0.i) selected_date from
                (select 0 i union select 1 union select 2 union select 3 union select 4 union select 5 union select 6 union select 7 union select 8 union select 9) t0,
                (select 0 i union select 1 union select 2 union select 3 union select 4 union select 5 union select 6 union select 7 union select 8 union select 9) t1,
                (select 0 i union select 1 union select 2 union select 3 union select 4 union select 5 union select 6 union select 7 union select 8 union select 9) t2,
                (select 0 i union select 1 union select 2 union select 3 union select 4 union select 5 union select 6 union select 7 union select 8 union select 9) t3,
                (select 0 i union select 1 union select 2 union select 3 union select 4 union select 5 union select 6 union select 7 union select 8 union select 9) t4) v
                where selected_date between DATE('$model->startDate') and DATE('$model->endDate') ) as D
                LEFT JOIN (SELECT * FROM  timesheet WHERE timesheet.date >= DATE('$model->startDate') AND timesheet.date <= DATE('$model->endDate') AND timesheet.EmployeeId = $model->employee AND timesheet.SiteId = $sitid) T on D.selected_date = T.date
                LEFT JOIN sites ON sites.id = T.SiteId
                LEFT JOIN (SELECT * FROM leavedays WHERE EmpId = $model->employee AND leaveDays >= DATE('$model->startDate') AND leaveDays <= DATE('$model->endDate')  ) LD ON LD.leaveDays=D.selected_date
                LEFT JOIN `leave` L ON L.id = LD.leaveId
                LEFT JOIN leavetype LT ON LT.id = L.LeaveType
                ORDER BY D.selected_date ASC")->queryAll();
            }
            $holidays = Yii::app()->db->createCommand("SELECT H.Date,IFNULL(concat(H.Is_Mercantile,' ',H.Is_Poyaday,' ',H.Is_Public,' ',H.Is_Bank),'HOLIDAY') discription
            FROM holydays H
            WHERE H.Date >= '".$model->startDate."' AND H.Date <= '".$model->endDate."' ")->queryAll();
            
            $newHolidays = [];
            foreach($holidays as $holiday){
                $newHolidays[$holiday['Date']] = $holiday['discription'];
            }
            
            $employeeDetails = Employee::model()->findByPk($model->employee);
            $MpSupplier = Supplier::model()->findByPk($employeeDetails->supplierid);
            $designation = Designation::model()->findByPk($employeeDetails->designationid);
            // print_r($newHolidays);
            // die;
            $this->render('//timeSheet/ViewEmployeeAllAttendence',array('range_of_dates'=>$range_of_dates,'list'=>$list,'model'=>$model,'employeeDetails'=>$employeeDetails,'designation'=>$designation,'MpSupplier'=>$MpSupplier,'holidays'=>$newHolidays));
        }

    }else{
        return $this->render('//timeSheet/CreateEmployeeAllAttendance',array('model'=>$model));
    }


}



//=========================================================================
public function actionEmployeeAllAttendancePDF()
{

$list = CJSON::decode($_POST['list']);
$range_of_dates = CJSON::decode($_POST['range_of_dates']);
$model = CJSON::decode($_POST['model']);
$employeeDetails = CJSON::decode($_POST['employeeDetails']);
$designation = CJSON::decode($_POST['designation']);
$MPSupplier = CJSON::decode($_POST['MpSupplier']);
$holidays = CJSON::decode($_POST['holidays']);
// print_r($MPSupplier);
// die;
$mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
$mPDF1->setAutoBottomMargin = 'stretch';
$mPDF1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
$mPDF1->WriteHTML($this->renderPartial('//timeSheet/EmployeeAllAttendencePDF',array('employeeDetails'=>$employeeDetails,'list'=>$list,'model'=>$model,'designation'=>$designation,'range_of_dates'=>$range_of_dates,'holidays'=>$holidays),true));
$file_name='Emp Attendance'.$employeeDetails['nic'].'-'. $model['startDate'].'-'.$model['endDate'].'Created On'.date("Y-m-d  -  h:i:sa").'.pdf';


ob_end_clean();
$mPDF1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );
}

//=========================================================================
public function actionEmployeeAllAttendanceExcel(){
$objPHPExcel = new PHPExcel();
$list = CJSON::decode($_POST['list']);
$range_of_dates = CJSON::decode($_POST['range_of_dates']);
$model = CJSON::decode($_POST['model']);
$employeeDetails = CJSON::decode($_POST['employeeDetails']);
$designation = CJSON::decode($_POST['designation']);
$MPSupplier = CJSON::decode($_POST['MpSupplier']);
$holidays = CJSON::decode($_POST['holidays']);

// print_r($list);
// die;

$objPHPExcel->setActiveSheetIndex(0)
->setCellValue('A1', 'Employee All Attendance')
->setCellValue('E1', 'Generated On')
->setCellValue('F1', date("Y-m-d - h:i:sa"))
->setCellValue('A2', 'Id')
->setCellValue('B2', $employeeDetails['id'])
->setCellValue('A3', 'Name')
->setCellValue('B3', $employeeDetails['Namewithini'])
->setCellValue('A4', 'NIC')
->setCellValue('B4', $employeeDetails['nic'])
->setCellValue('A5', 'Designation')
->setCellValue('B5', $designation['type'])
->setCellValue('A6', 'MP Supplier')
->setCellValue('B6', $MPSupplier['name'])
->setCellValue('C6', 'Customer Id')
->setCellValue('D6', $employeeDetails['Accountid'])
->setCellValue('A8', 'Date')
->setCellValue('B8', 'Day')
->setCellValue('C8', 'IN Date')
->setCellValue('D8', 'IN Time')
->setCellValue('E8', 'OUT Date ')
->setCellValue('F8', 'OUT Time')
->setCellValue('G8', 'WorkingHrs')
->setCellValue('H8', 'N OT')
->setCellValue('I8', 'D OT')
->setCellValue('J8', 'T OT')
->setCellValue('K8', 'Ttl OT')
->setCellValue('L8', 'Leave Type')
;
$col = 9;
foreach($list as $value){
    $row = 0;
    $isHoliday = false;
            if (array_key_exists($value['selected_date'],$holidays)){
                $day = $holidays[$value['selected_date']];
                $isHoliday = true;
            }else{
                $day = date('D',strtotime($value['selected_date']));
            }
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$col,$value['selected_date']);
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$day);
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['Intime'] == '------' ? $value['Intime'] : date('Y-d-m',strtotime($value['Intime'])));
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['Intime'] == '------' ? $value['Intime'] :date('H:i:m',strtotime($value['Intime'])));
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['OuteTime'] == '------' ? $value['OuteTime'] : date('Y-d-m',strtotime($value['OuteTime'])));
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['OuteTime'] == '------' ? $value['OuteTime'] :date('H:i:m',strtotime($value['OuteTime'])));
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,Yii::app()->commonUtil->convertTime($value['Hours']));
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,Yii::app()->commonUtil->convertTime($value['NOTH']));
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,Yii::app()->commonUtil->convertTime($value['DOTH']));
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,Yii::app()->commonUtil->convertTime($value['TOTH']));
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,Yii::app()->commonUtil->convertTime($value['ttlOT']));
    if($isHoliday){
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,'Holiday');
    }else{
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$day == 'Sun' ? 'N/A' : ($value['Intime'] == '------' ? ( $value['Lid'] == null ? 'NO PAY' : 'LEAVE('.$value['leaveType'].'/'.strtoupper($value['Lid']).')') : ( $value['Lid'] != null ? 'LEAVE('.$value['leaveType'].'/'.strtoupper($value['Lid']).')' : '-----')));
    }
    $col++;

    }




$styleArray = array(
    'font'  => array(
        'bold'  => true,
        'color' => array('rgb' => '#f79727'),
        'size'  => 10
    ));
$objPHPExcel->getActiveSheet()->getStyle('A1:J7')->applyFromArray($styleArray);

//$objPHPExcel->getActiveSheet()->setTitle('sffd');

$objPHPExcel->setActiveSheetIndex(0);

ob_end_clean();
ob_start();

header('Content-Type: application/vnd.ms-excel');
header('Content-Disposition: attachment;filename='.$model['startDate'].' to '.$model['endDate'].'.xls');
header('Cache-Control: max-age=0');
$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
$objWriter->save('php://output');
}

//============================================================================================
public function actionPayrollExcel() {
        $objPHPExcel = new PHPExcel();
        $list = CJSON::decode($_POST['list']);
        $model = CJSON::decode($_POST['model']);

        $objPHPExcel->setActiveSheetIndex(0)
                ->setCellValue('A1', 'Invoice Reconciliation Report')
                ->setCellValue('F1', 'Generated On')
                ->setCellValue('G1', date("Y-m-d - h:i:sa"))
                ->setCellValue('A2', 'From:-')
                ->setCellValue('B2', $model['StartDate'])
                ->setCellValue('C2', 'To:-')
                ->setCellValue('D2', $model['EndDate']);

        if ($model['PayrollMethod'] == 'MONTHLY') {
            $headdings = ['Employee Name', 'NIC', 'Job Title', 'Rate type', 'Man Power Supplier', 'Site', 'Department', 'Account', 'Actual Worked Days', 'Pay Days', 'Num Of Week Days', 'Basic Salary', 'Salary', 'BRA1', 'BRA2', 'BRA3', 'Net Wage', 'In Late Hours', 'In Late Deduct', 'Out Late Hours', 'Out Late Deduct', 'Total For EPF', 'Poya Amount For EPF', 'Poyaday payment', 'Mercantileday Payment', 'Sunday payment', 'Site Holiday payment', 'N-OT Amount', 'D-OT Amount', 'T-OT Amount', 'Pre-OT Amount', 'N-OT Hour', 'D-OT Hour', 'T-OT Hour', 'Pre-OT Hour', 'Attendance Incentive', 'Lunch Incentive', 'Night Shift Incentive', 'Traveling Incentive', 'Accomondation Incentive', 'Performance Incentive', 'Special Incentive', 'Trip Commission Incentive', 'Rural Incentive', 'BOI Pass Incentive', 'Incentive1', 'Incentive2', 'Incentive3', 'Per Month Incentive', 'Attendance Incentive 2', 'Total Incentive', 'Att Bonus', 'Allowance', 'Perform Allowance', 'Variable Allowance', 'Arrears', 'Total Allowance', 'Total Gross', 'Deduction1', 'Deduction2', 'Deduction3', 'Total Deduction', 'Total Net', 'EPF 12 %', 'ETF 03%', 'Contractor Fee Rate', 'Contractor Fee', 'Cost to Company'];
            $values = ['EmployeeName', 'NIC', 'JobTitle', 'RateType', 'MPSuplier', 'Site', 'DepartmentName', 'Account', 'WorkDay', 'NoPayDays', 'Actual_WorkedDay', 'full_Basic_Salary', 'Sub_Basic_salary', 'BRA1', 'BRA2', 'BRA3', 'BasicWage', 'LateDeductTime', 'LateDeductAmount', 'EarlyOutDeductTime', 'EarlyOutDeductAmount', 'TotalForEPF', 'TotalForEPFPoyaday', 'PoyadayPayment', 'MercantilePayment', 'SundayPayment', 'SiteHolidayAmount', 'NOT', 'DOT', 'TOT', 'PreOTAmount', 'NOTHour', 'DOTHour', 'TOTHour', 'PreOTHour', 'Perday_incentive', 'Lunch_incentive', 'NightShift_incentive', 'travaling_incentive', 'accomondation_incentive', 'performance_incentive', 'Special_Incentive', 'Trip_Commission_Incentive', 'Rural_incentive', 'BioPass_incentive', 'Incentive1', 'Incentive2', 'Incentive4', 'MonthIncentive', 'Incentive3', 'Insentive', 'Bonus', 'Allowance', 'PAllowance', 'VAllowance', 'Arrears', 'TotalAddition', 'TotalGross', 'Deduction', 'Deduction2', 'Deduction3', 'TotalDeduction', 'TotalNet', 'EPFByCompany', 'ETFByCompany', 'contractorfee_rate', 'ContractorFee', 'CostOfCompany'];
            $summery = ['EmployeeName' => 0, 'NIC' => 0, 'JobTitle' => 0, 'RateType' => 0, 'MPSuplier' => 0, 'Site' => 0, 'DepartmentName' => 0, 'Account' => 0, 'WorkDay' => 0, 'NoPayDays' => 0, 'Actual_WorkedDay' => 0, 'full_Basic_Salary' => 0, 'Sub_Basic_salary' => 0, 'BRA1' => 0, 'BRA2' => 0, 'BRA3' => 0, 'BasicWage' => 0, 'LateDeductTime' => 0, 'LateDeductAmount' => 0, 'EarlyOutDeductTime' => 0, 'EarlyOutDeductAmount' => 0, 'TotalForEPF' => 0, 'TotalForEPFPoyaday' => 0, 'PoyadayPayment' => 0, 'MercantilePayment' => 0, 'SundayPayment' => 0, 'SiteHolidayAmount' => 0, 'NOT' => 0, 'DOT' => 0, 'TOT' => 0, 'PreOTAmount' => 0, 'NOTHour' => 0, 'DOTHour' => 0, 'TOTHour' => 0, 'PreOTHour' => 0, 'Perday_incentive' => 0, 'Lunch_incentive' => 0, 'NightShift_incentive' => 0, 'travaling_incentive' => 0, 'accomondation_incentive' => 0, 'performance_incentive' => 0, 'Special_Incentive' => 0, 'Trip_Commission_Incentive' => 0, 'Rural_incentive' => 0, 'BioPass_incentive' => 0, 'Incentive1' => 0, 'Incentive2' => 0, 'Incentive4' => 0, 'MonthIncentive' => 0, 'Incentive3' => 0, 'Insentive' => 0, 'Bonus' => 0, 'Allowance' => 0, 'PAllowance' => 0, 'VAllowance' => 0, 'Arrears' => 0, 'TotalAddition' => 0, 'TotalGross' => 0, 'Deduction' => 0, 'Deduction2' => 0, 'Deduction3' => 0, 'TotalDeduction' => 0, 'TotalNet' => 0, 'EPFByCompany' => 0, 'ETFByCompany' => 0, 'contractorfee_rate' => 0, 'ContractorFee' => 0, 'CostOfCompany' => 0];
        } else {
            $headdings = ['Employee Name', 'NIC', 'Job Title', 'Rate type', 'Man Power Supplier', 'Site', 'Department', 'Account', 'Actual Worked Days', 'Num Of Week Days', 'Day Salary', 'Basic Salary', 'Salary', 'BRA1', 'BRA2', 'BRA3', 'Net Wage', 'In Late Hours', 'In Late Deduct', 'Out Late Hours', 'Out Late Deduct', 'Total For EPF', 'Poyaday payment', 'Poya Amount For EPF', 'Mercantileday Payment', 'Sunday payment', 'Site Holiday payment', 'N-OT Amount', 'D-OT Amount', 'T-OT Amount', 'Pre-OT Amount', 'N-OT Hour', 'D-OT Hour', 'T-OT Hour', 'Pre-OT Hour', 'Attendance Incentive', 'Lunch Incentive', 'Night Shift Incentive', 'Traveling Incentive', 'Accomondation Incentive', 'Performance Incentive', 'Special Incentive', 'Trip Commission Incentive', 'Rural Incentive', 'BOI Pass Incentive', 'Incentive1', 'Incentive2', 'Incentive3', 'Per Month Incentive', 'Attendance Incentive 2', 'Total Incentive', 'Att Bonus', 'Allowance', 'Perform Allowance', 'Variable Allowance', 'Arrears', 'Total Allowance', 'Total Gross', 'Deduction1', 'Deduction2', 'Deduction3', 'Total Deduction', 'Total Net', 'EPF 12 %', 'ETF 03%', 'Contractor Fee Rate', 'Contractor Fee', 'Cost to Company'];
            $values = ['EmployeeName', 'NIC', 'JobTitle', 'RateType', 'MPSuplier', 'Site', 'DepartmentName', 'Account', 'WorkDay', 'Actual_WorkedDay', 'daysalary', 'full_Basic_Salary', 'Sub_Basic_salary', 'BRA1', 'BRA2', 'BRA3', 'BasicWage', 'LateDeductTime', 'LateDeductAmount', 'EarlyOutDeductTime', 'EarlyOutDeductAmount', 'TotalForEPF', 'TotalForEPFPoyaday', 'PoyadayPayment', 'MercantilePayment', 'SundayPayment', 'SiteHolidayAmount', 'NOT', 'DOT', 'TOT', 'PreOTAmount', 'NOTHour', 'DOTHour', 'TOTHour', 'PreOTHour', 'Perday_incentive', 'Lunch_incentive', 'NightShift_incentive', 'travaling_incentive', 'accomondation_incentive', 'performance_incentive', 'Special_Incentive', 'Trip_Commission_Incentive', 'Rural_incentive', 'BioPass_incentive', 'Incentive1', 'Incentive2', 'Incentive4', 'MonthIncentive', 'Incentive3', 'Insentive', 'Bonus', 'Allowance', 'PAllowance', 'VAllowance', 'Arrears', 'TotalAddition', 'TotalGross', 'Deduction', 'Deduction2', 'Deduction3', 'TotalDeduction', 'TotalNet', 'EPFByCompany', 'ETFByCompany', 'contractorfee_rate', 'ContractorFee', 'CostOfCompany'];
            $summery = ['EmployeeName' => 0, 'NIC' => 0, 'JobTitle' => 0, 'RateType' => 0, 'MPSuplier' => 0, 'Site' => 0, 'DepartmentName' => 0, 'Account' => 0, 'WorkDay' => 0, 'Actual_WorkedDay' => 0, 'daysalary' => 0, 'full_Basic_Salary' => 0, 'Sub_Basic_salary' => 0, 'BRA1' => 0, 'BRA2' => 0, 'BRA3' => 0, 'BasicWage' => 0, 'LateDeductTime' => 0, 'LateDeductAmount' => 0, 'EarlyOutDeductTime' => 0, 'EarlyOutDeductAmount' => 0, 'TotalForEPF' => 0, 'TotalForEPFPoyaday' => 0, 'PoyadayPayment' => 0, 'MercantilePayment' => 0, 'SundayPayment' => 0, 'SiteHolidayAmount' => 0, 'NOT' => 0, 'DOT' => 0, 'TOT' => 0, 'PreOTAmount' => 0, 'NOTHour' => 0, 'DOTHour' => 0, 'TOTHour' => 0, 'PreOTHour' => 0, 'Perday_incentive' => 0, 'Lunch_incentive' => 0, 'NightShift_incentive' => 0, 'travaling_incentive' => 0, 'accomondation_incentive' => 0, 'performance_incentive' => 0, 'Special_Incentive' => 0, 'Trip_Commission_Incentive' => 0, 'Rural_incentive' => 0, 'BioPass_incentive' => 0, 'Incentive1' => 0, 'Incentive2' => 0, 'Incentive4' => 0, 'MonthIncentive' => 0, 'Incentive3' => 0, 'Incentive3' => 0, 'Insentive' => 0, 'Bonus' => 0, 'Allowance' => 0, 'PAllowance' => 0, 'VAllowance' => 0, 'Arrears' => 0, 'TotalAddition' => 0, 'TotalGross' => 0, 'Deduction' => 0, 'Deduction2' => 0, 'Deduction3' => 0, 'TotalDeduction' => 0, 'TotalNet' => 0, 'EPFByCompany' => 0, 'ETFByCompany' => 0, 'contractorfee_rate' => 0, 'ContractorFee' => 0, 'CostOfCompany' => 0];
        }

        $headCol = 4;
        $headRow = 0;
        foreach ($headdings as $headdings) {
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($headRow, $headCol, $headdings);
            $headRow++;
        }

        $col = 5;
        for ($i = 0; $i < count($list); $i++) {
            $valueRow = 0;
            foreach ($values as $value) {

                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($valueRow, $col, $value != 'NOTHour' ? ( $value != 'DOTHour' ? ($value != 'TOTHour' ? ($value != 'LateDeductTime' ? ($value != 'EarlyOutDeductTime' ? $list[$i][$value] : Yii::app()->commonUtil->convertToHoursMins($list[$i][$value])) : Yii::app()->commonUtil->convertToHoursMins($list[$i][$value])) : Yii::app()->commonUtil->convertToHoursMins($list[$i][$value])) : Yii::app()->commonUtil->convertToHoursMins($list[$i][$value])) : Yii::app()->commonUtil->convertToHoursMins($list[$i][$value]));

                if ($value == 'NOTHour' || $value == 'DOTHour' || $value == 'TOTHour' || $value == 'LateDeductTime' || $value == 'EarlyOutDeductTime' || $value == 'PreOTHour') {
                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($valueRow, $col, Yii::app()->commonUtil->convertToHoursMins($list[$i][$value]));
                }
                
                if ($model['PayrollMethod'] == 'MONTHLY' && $value == 'NoPayDays') {

                    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($valueRow, $col, (string) (30 - $list[$i][$value]));
                    $summery[$value] += 30 - $list[$i][$value];
                } else {
                    $summery[$value] += is_numeric($list[$i][$value]) ? $list[$i][$value] : 0;
                }

                $valueRow++;
            }
            $col++;
        }
        $summery = array_values($summery);

        $roww = 7;
        $col++;
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($roww, $col, 'Total');
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($roww, $col)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
        $roww++;
        for ($i = 8; $i < count($summery); $i++) {
            if ($i == 17 || $i == 19 || $i == 31 || $i == 32 || $i == 33 || $i == 34) {
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($roww, $col, Yii::app()->commonUtil->convertToHoursMins($summery[$i]));
                $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($roww, $col)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
                $roww++;
            } else {
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($roww,$col,(string)$summery[$i]);
                $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($roww, $col)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));         
                $roww++;
            }
        }
        // print_r(CJSON::encode($summery));
        // die;
        $styleArray = array(
            'font' => array(
                'bold' => true,
                'color' => array('rgb' => '#f79727'),
                'size' => 10
        ));

        $objPHPExcel->getActiveSheet()->getStyle('A1:BQ4')->applyFromArray($styleArray);

        $objPHPExcel->setActiveSheetIndex(0);

        ob_end_clean();
        ob_start();

        header('Content-Type: application/vnd.ms-excel');
        header('Content-Disposition: attachment;filename= Invoice Reconciliation Report.xls');
        header('Cache-Control: max-age=0');
        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
        $objWriter->save('php://output');
    }
//=============================================Employee Team Report=============================================================
public function actionfindTeamEmployees(){
    $model = new TeamEmployeeForm;
    if(isset($_POST['TeamEmployeeForm'])){

            $model->attributes=$_POST['TeamEmployeeForm'];  // only schedule is setted.
            $teamEmployees=array();

            if(Yii::app()->user->isAdmin()){
                $teamEmployees= Employee::model()->findAllBySql("select * from employee where id in(select employeeid from employee_team where employee_team.teamid= $model->team AND employee_team.Status = 1)");

            }

            else{
                $sitid = Yii::app()->user->data()->SiteId;
                $teamEmployees= Employee::model()->findAllBySql("select * from employee where id in (select employeeid from employee_team where employee_team.teamid= $model->team AND employee_team.Status = 1) AND employee.siteid = $sitid");

            }



            $this->render('//employeeTeam/viewTeamEmployees', array('model'=>$model,'team'=> $model->team,'teamEmployees'=>$teamEmployees));

}
    else{

        $this->render('//employeeTeam/getTeamEmployee', array('model'=>$model));
     }



}




public function actionTeamEmployeesPDF(){

    $team = CJSON::decode( $_POST['team']);
    $teamEmployees = CJSON::decode($_POST['teamEmployees']);
    $mpdf1 = Yii::app()->ePdf->mpdf();
    $mpdf1->setAutoBottomMargin = 'stretch';
    //$mPDF1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
    $mpdf1->WriteHTML($this->renderPartial('//employeeTeam/viewTeamEmployeePDF', array('model'=>$model,'teamEmployees'=> $teamEmployees, 'team'=> $team),true));

    $file_name= $teamModel->name.' Team Employees'.'.pdf';
    ob_end_clean();
    $mpdf1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );

 }

 public function actionTeamEmployeesExcel(){

    $objPHPExcel = new PHPExcel();
    $team = CJSON::decode( $_POST['team']);
    $teamModel= Team::model()->findByPk($team);
    $teamEmployees = CJSON::decode($_POST['teamEmployees']);
            // Set document properties
            $objPHPExcel->getProperties()->setCreator("K'iin Balam")
                 ->setLastModifiedBy("K'iin Balam")
                 ->setTitle("YiiExcel Test Document")
                 ->setSubject("YiiExcel Test Document")
                 ->setDescription("Test document for YiiExcel, generated using PHP classes.")
                 ->setKeywords("office PHPExcel php YiiExcel UPNFM")
                 ->setCategory("Test result file");

            // Add some data
            $objPHPExcel->setActiveSheetIndex(0)
                ->setCellValue('A1', 'Team '.$teamModel->name.' Employee Report')
                ->setCellValue('E1', 'Generated On')
                ->setCellValue('F1', date("Y-m-d - h:i:sa"))
                ->setCellValue('A2', 'NIC')
                ->setCellValue('B2', 'Employee ID')
                ->setCellValue('C2', 'Name')
                ->setCellValue('D2', 'Designation')
                ->setCellValue('E2', 'Client Code')
                ->setCellValue('F2', 'Client Name');

                $styleArray = array(
                    'font'  => array(
                        'bold'  => true,
                        'color' => array('rgb' => '#f79727'),
                        'size'  => 10
                    ));
                $objPHPExcel->getActiveSheet()->getStyle('A1:F2')->applyFromArray($styleArray);
                $row = 3;
                foreach($teamEmployees as $employee) {
                    $designation = Designation::model()->findByPk($employee['designationid']);
                    $account = Accounts::model()->findByPk($employee['Accountid']);

                        $col =1;
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0,$row,$employee['nic']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col,$row,$employee['id']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$employee['Namewithini']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$designation->type);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$account->AccountOracleCode);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$account->name);

                        $row++;


                }


            $objPHPExcel->getActiveSheet()->setTitle('YiiExcel');
            $filename = $teamModel->name;
            header('Content-Type: application/vnd.ms-excel');
            header('Content-Disposition: attachment;filename="'.$filename.'.xls"');
            header('Cache-Control: max-age=0');

            $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');

            $objWriter->save('php://output');
            unset($this->objWriter);
            unset($this->objWorksheet);
            unset($this->objReader);
            unset($this->objPHPExcel);
            exit();
        }


public function actionActiveEmployeeList(){
    if(Yii::app()->user->isAdmin()){
        $list = Yii::app()->db->createCommand("SELECT A.AccountOracleCode,E.* ,CF.contractfee,D.type designation,S.name site,DP.name department,A.name as account,P.type payment,C.name category,LC.name lcategory,T.type Tsize,SH.type shoes,SP.name supplier,ES.monthsalary monthSal,ES.DalySalary daySal
         FROM employee E
         INNER JOIN designation D ON D.id = E.designationid
         INNER JOIN sites S ON S.id = E.siteid
         INNER JOIN department DP ON DP.id = E.departmentid
         INNER JOIN accounts A ON A.id = E.Accountid
         INNER JOIN paymentmethod P ON P.id = E.paymentmethodid
         INNER JOIN category C ON C.id = E.categoryid
         INNER JOIN labourcategory LC ON LC.id = E.LabourCategory
         LEFT JOIN employeesalary ES ON ES.employeeid = E.id AND ES.Status = 1 AND ES.site_id = E.siteid
         LEFT JOIN employeecontractfee CF ON CF.employeeid = E.id AND CF.status = 1 AND CF.site_id = E.siteid
         LEFT JOIN tshirt T ON E.tshirtsize = T.id
         LEFT JOIN shoes SH ON E.shoesize = SH.id
         LEFT JOIN supplier SP ON E.supplierid = SP.id
         WHERE E.statusId = 1 
         ORDER BY E.siteid,E.Accountid,E.id")->queryAll();

        // print_r(CJSON::encode($list));die;
    }else{
        $sitid = Yii::app()->user->data()->SiteId;
        $list = Yii::app()->db->createCommand("SELECT A.AccountOracleCode,E.* ,CF.contractfee,D.type designation,S.name site,DP.name department,A.name account,P.type payment,C.name category,LC.name lcategory,T.type Tsize,SH.type shoes,SP.name supplier,ES.monthsalary monthSal,ES.DalySalary daySal
        FROM employee E
        INNER JOIN designation D ON D.id = E.designationid
        INNER JOIN sites S ON S.id = E.siteid
        INNER JOIN department DP ON DP.id = E.departmentid
        INNER JOIN accounts A ON A.id = E.Accountid
        INNER JOIN paymentmethod P ON P.id = E.paymentmethodid
        INNER JOIN category C ON C.id = E.categoryid
        INNER JOIN labourcategory LC ON LC.id = E.LabourCategory
        LEFT JOIN employeesalary ES ON ES.employeeid = E.id AND ES.Status = 1 AND ES.site_id = E.siteid
        LEFT JOIN employeecontractfee CF ON CF.employeeid = E.id AND CF.status = 1 AND CF.site_id = E.siteid
        LEFT JOIN tshirt T ON E.tshirtsize = T.id
        LEFT JOIN shoes SH ON E.shoesize = SH.id
        LEFT JOIN supplier SP ON E.supplierid = SP.id
        WHERE E.statusId = 1 AND E.siteid = $sitid;
        ORDER BY E.siteid,E.Accountid,E.id")->queryAll();
    }
    $this->render('//employee/viewActiveEmployeeList', array('list'=>$list));
}
public function actionActiveEmployeeListExcel(){
    $objPHPExcel = new PHPExcel();
    $list = CJSON::decode($_POST['list']);

    // print_r(count($list));
    // die;
    $EmpCount = 10;

    $objPHPExcel->setActiveSheetIndex(0)
        ->setCellValue('A1', 'Active Employees List')
        ->setCellValue('E1', 'Generated On')
        ->setCellValue('F1', date("Y-m-d - h:i:sa"))
        ->setCellValue('A2','There Are '.count($list).' Active Employees')
        ->setCellValue('A3', 'Id')
        ->setCellValue('B3', 'Gender')
        ->setCellValue('C3', 'NIC')
        ->setCellValue('D3', 'DOB')
        ->setCellValue('E3', 'First Name')
        ->setCellValue('F3', 'Last Name')
        ->setCellValue('G3', 'Sur Name')
        ->setCellValue('H3', 'Name with initilas')
        ->setCellValue('I3', 'Full Name')
        ->setCellValue('J3', 'Address')
        ->setCellValue('K3', 'Designation')
        ->setCellValue('L3', 'Appointment Date')
        ->setCellValue('M3', 'Department')
        ->setCellValue('N3', 'Confirmation date')
        ->setCellValue('O3', 'Account')
        ->setCellValue('P3', 'Category')
        ->setCellValue('Q3', 'Labour Category')
        ->setCellValue('R3', 'OT Entitle')
        ->setCellValue('S3', 'Tshirt size')
        ->setCellValue('T3', 'Shoe size')
        ->setCellValue('U3', 'EPF No')
        ->setCellValue('V3', 'Supplier')
        ->setCellValue('W3', 'Civil Status')
        ->setCellValue('X3', 'Site')
        ->setCellValue('Y3', 'Join Date')
        ->setCellValue('Z3', 'Employee Number')
        ->setCellValue('AA3', 'Shift Mode')    
        ->setCellValue('AB3', 'Payment Method')
        ->setCellValue('AC3', 'Contractor Fee')
        ->setCellValue('AD3', 'Salary(Rs)')
        ->setCellValue('AE3', 'Contact Number');
    $col = 4;

    foreach($list as $value){
        $EntitleOT;
        if($value['EntitleOT'] == 0){
            $EntitleOT = 'OT Entitle';
        }else{
            $EntitleOT = 'NOT OT Entitle';
        }

        $row = 0;
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$col,$value['id']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['gender']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['nic']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['date_of_birth']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['FirstName']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['LastName']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['SurName']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['Namewithini']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['FullName']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['address']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['designation']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['Appointment']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['department']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['Confirmationdate']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['account']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['category']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['lcategory']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$EntitleOT);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['Tsize']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['shoes']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['EPFNo']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['supplier']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['CivilStatus']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['site']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['joindate']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['EmployeeNumber']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['Shift_mode']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['payment']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,isset($value['contractfee'])? $value['contractfee']: '');
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['payment']=='MONTHLY'? $value['monthSal'] : $value['daySal'] );
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['contact_number']);
        $col++;

    }
    $styleArray = array(
        'font'  => array(
            'bold'  => true,
            'color' => array('rgb' => '#f79727'),
            'size'  => 10
        ));
    $objPHPExcel->getActiveSheet()->getStyle('A1:AE3')->applyFromArray($styleArray);

    //$objPHPExcel->getActiveSheet()->setTitle('sffd');

    $objPHPExcel->setActiveSheetIndex(0);

    ob_end_clean();
    ob_start();

    header('Content-Type: application/vnd.ms-excel');
    header('Content-Disposition: attachment;filename= ActiveEmployeeList.xls');
    header('Cache-Control: max-age=0');
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
    $objWriter->save('php://output');
  }
//***************************************************************************************************** */
public function actionPresentReport(){
    // print_r($_POST['PresentEmployee']);
    // die;
    $model = new PresentEmployee;
    if(isset($_POST['PresentEmployee'])){
        $model->attributes = $_POST['PresentEmployee'];

        if($model->validate()){
            if(isset($_POST['accounts'])){
                $list= Yii::app()->db->createCommand("SELECT DISTINCT E.id,E.Namewithini name,E.nic ,D.type designation ,A.name account,A.AccountOracleCode accountId,TIME(T.PunchTime) time,DP.name department
                    FROM timelog T
                    INNER JOIN employee E ON T.Employeeid = E.id
                    INNER JOIN accounts A ON A.id = E.Accountid
                    INNER JOIN department DP ON DP.id = E.departmentid
                    INNER JOIN designation D ON D.id = E.designationid
                    WHERE DATE(T.PunchTime) = '".$model->certainDate."' AND T.Type ='IN' And E.accountId  IN (".implode(',',$_POST['accounts']).") AND E.statusId = 1
                    ORDER BY account,time")->queryAll();
            }else{
                if(Yii::app()->user->isAdmin()){
                    $list= Yii::app()->db->createCommand("SELECT DISTINCT E.id,E.Namewithini name,E.nic ,D.type designation ,A.name account,A.AccountOracleCode accountId,TIME(T.PunchTime) time,DP.name department
                    FROM timelog T
                    INNER JOIN employee E ON T.Employeeid = E.id
                    INNER JOIN accounts A ON A.id = E.Accountid
                    INNER JOIN department DP ON DP.id = E.departmentid
                    INNER JOIN designation D ON D.id = E.designationid
                    WHERE DATE(T.PunchTime) = '".$model->certainDate."' AND T.Type ='IN' AND E.statusId = 1
                    -- GROUP BY E.id
                    ORDER BY account,time")->queryAll();
                }else{
                    $sitid = Yii::app()->user->data()->SiteId;
                    $list= Yii::app()->db->createCommand("SELECT DISTINCT E.id,E.Namewithini name,E.nic ,D.type designation ,A.name account,A.AccountOracleCode accountId,TIME(T.PunchTime) time,DP.name department
                    FROM timelog T
                    INNER JOIN employee E ON T.Employeeid = E.id
                    INNER JOIN accounts A ON A.id = E.Accountid
                    INNER JOIN department DP ON DP.id = E.departmentid
                    INNER JOIN designation D ON D.id = E.designationid
                    WHERE DATE(T.PunchTime) = '".$model->certainDate."' AND T.Type ='IN' And E.siteid = $sitid AND E.statusId = 1
                    -- GROUP BY E.id
                    ORDER BY account,time")->queryAll();

                }
            }





            $count = count($list);
            $this->render('//timelog/ViewPresentReport',array('list'=>$list,'model'=>$model,'count'=>$count));

        }

    }else{
        return $this->render('//timelog/CreatePresentReport',array('model'=>$model));
    }


}
//==========================================================================================
public function actionPresentReportPDF()
{
    $list = CJSON::decode($_POST['list']);
    $model = CJSON::decode($_POST['model']);
    $count = CJSON::decode($_POST['count']);
    // print_r( $site);
    // die;

    $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
    $mPDF1->setAutoBottomMargin = 'stretch';
    $mPDF1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
    $mPDF1->WriteHTML($this->renderPartial('//timelog/presentReportPDF',array('list'=>$list,'model'=>$model,'site'=>$site,'count'=>$count),true));
    $file_name= $model['certainDate'].'present report.pdf';


    ob_end_clean();
    $mPDF1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );
}
//=========================================================================
public function actionPresentReportExcel(){
    $objPHPExcel = new PHPExcel();
    $list = CJSON::decode($_POST['list']);
    $model = CJSON::decode($_POST['model']);
    $count = CJSON::decode($_POST['count']);

    // print_r($list);
    // die;

    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue('A1', 'Present report')
    ->setCellValue('E1', 'Generated On')
    ->setCellValue('F1', date("Y-m-d - h:i:sa"))

    ->setCellValue('B2', 'count = '.$count)
    ->setCellValue('A3', 'Id')
    ->setCellValue('B3', 'Name')
    ->setCellValue('C3', 'NIC')
    ->setCellValue('D3', 'Designation')
    ->setCellValue('E3', 'Client Code')
    ->setCellValue('F3', 'Client Name')
    ->setCellValue('G3', 'Time')
    ->setCellValue('H3', 'Department') ;
    $col = 4;


    for($i = 0;$i < count($list);$i++){

        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0,$col,$list[$i]['id']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1,$col,$list[$i]['name']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2,$col,$list[$i]['nic']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(3,$col,$list[$i]['designation']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(4,$col,$list[$i]['accountId']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(5,$col,$list[$i]['account']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(6,$col,$list[$i]['time']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(7,$col,$list[$i]['department']);


        $col++;

    }
    $styleArray = array(
        'font'  => array(
            'bold'  => true,
            'color' => array('rgb' => '#f79727'),
            'size'  => 10
        ));
    $objPHPExcel->getActiveSheet()->getStyle('A1:G3')->applyFromArray($styleArray);

    //$objPHPExcel->getActiveSheet()->setTitle('sffd');

    $objPHPExcel->setActiveSheetIndex(0);

    ob_end_clean();
    ob_start();

    header('Content-Type: application/vnd.ms-excel');
    header('Content-Disposition: attachment;filename='.$model['certainDate'].'-present report.xls');
    header('Cache-Control: max-age=0');
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
    $objWriter->save('php://output');
  }

  public function actionNonAllocatedEmployees($id){

    $siteName = Sites::model()->findByPk($id);



    $yesterday = date('Y-m-d');
    $details = array($yesterday,$siteName['name']);
    $list= Yii::app()->db->createCommand("SELECT E.id Id,E.nic NIC ,E.Namewithini Name,D.type Designation,A.name Account
    FROM employee E
    INNER JOIN sites S on S.id = E.siteid
    INNER JOIN designation D on D.id = E.designationid
    INNER JOIN accounts A on A.id = E.Accountid
    WHERE S.id = $id AND E.statusId = 1 AND E.id IN (SELECT A.Employeeid
            from (SELECT DISTINCT T.Employeeid
                    FROM timelog T
                    WHERE DATE(T.PunchTime) = '$yesterday' AND T.Type = 'IN') A
            WHERE A.Employeeid NOT IN (SELECT ET.employeeid FROM employee_team ET WHERE ET.Status = 1 AND ET.teamid IN (SELECT TS.teamid
                                            FROM team_shift TS
                                                                    WHERE TS.shiftid IN (SELECT SF.id
                                                                                                            FROM shift SF INNER JOIN schedule SCH ON SF.schedulid = SCH.id
                                                                                                            WHERE SCH.Date = '$yesterday'))))")->queryAll();
      //print_r($list);
      $this->render('//timesheet/ViewNonAllocatedEmployees',array('list'=>$list,'date'=>$yesterday,'site'=>$siteName['name'],'details'=>$details));

  }
//===========================================================================================================

  public function actionNonAllocatedEmployeestPDF()
{
    $list = CJSON::decode($_POST['list']);
    $details = CJSON::decode($_POST['details']);
    // print_r($details);
    // die;

    $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
    $mPDF1->setAutoBottomMargin = 'stretch';
    $mPDF1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
    $mPDF1->WriteHTML($this->renderPartial('//timeSheet/NonAllocatedEmployeesPDF',array('list'=>$list,'details'=>$details),true));
    $file_name= $details[0].'Non Allocated report.pdf';


    ob_end_clean();
    $mPDF1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );
}

public function actionNonAllocatedEmployeestExcel(){
    $objPHPExcel = new PHPExcel();
    $list = CJSON::decode($_POST['list']);
    $details = CJSON::decode($_POST['details']);

    // print_r($list);
    // die;

    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue('A1', 'Non Allocated Employees Report')
    ->setCellValue('E1', 'Generated On')
    ->setCellValue('F1', date("Y-m-d - h:i:sa"))
    ->setCellValue('A2', 'Id')
    ->setCellValue('B2', 'Name')
    ->setCellValue('C2', 'NIC')
    ->setCellValue('D2', 'Designation')
    ->setCellValue('E2', 'Account');

    $col = 3;


    for($i = 0;$i < count($list);$i++){
        $row = 0;
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$col,$list[$i]['Id']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['Name']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['NIC']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['Designation']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['Account']);


        $col++;

    }
    $styleArray = array(
        'font'  => array(
            'bold'  => true,
            'color' => array('rgb' => '#f79727'),
            'size'  => 10
        ));
    $objPHPExcel->getActiveSheet()->getStyle('A1:F2')->applyFromArray($styleArray);

    //$objPHPExcel->getActiveSheet()->setTitle('sffd');

    $objPHPExcel->setActiveSheetIndex(0);

    ob_end_clean();
    ob_start();

    header('Content-Type: application/vnd.ms-excel');
    header('Content-Disposition: attachment;filename='.$details[0].'-Non Allocated Report.xls');
    header('Cache-Control: max-age=0');
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
    $objWriter->save('php://output');
  }

//========================================================================================
  public function actionLineChartDownload(){
    $objPHPExcel = new PHPExcel();
    $lists = Yii::app()->db->createCommand("SELECT DISTINCT(T.date) date,T.total,T.present,T.absent FROM tblResults T")->queryAll();




    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue('A1', 'Monthly Attendance')
    ->setCellValue('E1', 'Generated On')
    ->setCellValue('F1', date("Y-m-d - h:i:sa"))
    ->setCellValue('A3', 'Date ')
    ->setCellValue('B3', 'Total Allocated')
    ->setCellValue('C3', 'Present ')
    ->setCellValue('D3', 'Absent ');
$col = 4;

foreach($lists as $list){


    $row = 0;
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$col,$list['date']);
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list['total']);
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list['present']);
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list['absent']);
    $col++;

}
$styleArray = array(
    'font'  => array(
        'bold'  => true,
        'color' => array('rgb' => '#f79727'),
        'size'  => 10
    ));
$objPHPExcel->getActiveSheet()->getStyle('A1:Y3')->applyFromArray($styleArray);



    $objPHPExcel->getActiveSheet()->setTitle("Monthly Attendance");

    $objPHPExcel->setActiveSheetIndex(0);

    ob_end_clean();
    ob_start();

    header('Content-Type: application/vnd.ms-excel');
    header('Content-Disposition: attachment;filename= MonthlyAttendance.xls');
    header('Cache-Control: max-age=0');
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
    $objWriter->save('php://output');
  }


  //========================================================================================
  public function actionPieChartDownload(){
    $objPHPExcel = new PHPExcel();
    $yesterday = date('Y-m-d');
    $lists = Yii::app()->db->createCommand("SELECT S.name,COUNT(E.id) count
    FROM employee E
    INNER JOIN sites S on S.id = E.siteid
    WHERE E.statusId = 1 AND E.id IN (SELECT A.Employeeid
            from (SELECT DISTINCT T.Employeeid
                    FROM timelog T
                    WHERE DATE(T.PunchTime) = '$yesterday' AND T.Type = 'IN') A
            WHERE A.Employeeid NOT IN (SELECT ET.employeeid FROM employee_team ET WHERE ET.Status = 1 AND ET.teamid IN (SELECT TS.teamid
                                                                                                                            FROM team_shift TS
                                                                                                                            WHERE TS.shiftid IN (SELECT SF.id
                                                                                                                                                    FROM shift SF
                                                                                                                                                    INNER JOIN schedule SCH ON SF.schedulid = SCH.id
                                                                                                                                                    WHERE SCH.Date = '$yesterday'))))
    GROUP BY E.siteid")->queryAll();


    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue('A1', 'Non Allocated Employees')
    ->setCellValue('E1', 'Generated On')
    ->setCellValue('F1', date("Y-m-d - h:i:sa"))
    ->setCellValue('A3', 'Site ')
    ->setCellValue('B3', 'Employee Count');
$col = 4;

foreach($lists as $list){


    $row = 0;
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$col,$list['name']);
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list['count']);

    $col++;

}
$styleArray = array(
    'font'  => array(
        'bold'  => true,
        'color' => array('rgb' => '#f79727'),
        'size'  => 10
    ));
$objPHPExcel->getActiveSheet()->getStyle('A1:Y3')->applyFromArray($styleArray);



    $objPHPExcel->getActiveSheet()->setTitle("Non Allocated Employees");

    $objPHPExcel->setActiveSheetIndex(0);

    ob_end_clean();
    ob_start();

    header('Content-Type: application/vnd.ms-excel');
    header('Content-Disposition: attachment;filename= NonAllocatedEmployees.xls');
    header('Cache-Control: max-age=0');
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
    $objWriter->save('php://output');
  }

  //========================================================================================
  public function actionBarChartDownload(){
    $objPHPExcel = new PHPExcel();
    $yesterday = date('Y-m-d');
    $lists = Yii::app()->db->createCommand("SELECT S.name,IFNULL(chart.ttl,0) TTL,IFNULL(chart.pre,0) PRE,IFNULL(chart.abs,0) ABS
        FROM sites S
        LEFT JOIN (SELECT A.siteid, A.ttl,B.pre,(A.ttl - B.pre) abs
                    FROM (SELECT E.siteid, COUNT(ET.employeeid) ttl
                            FROM employee_team ET
                            INNER JOIN employee E ON E.id = ET.employeeid
                            WHERE ET.Status = 1 AND ET.teamid IN (SELECT TS.teamid
                                                                    FROM team_shift TS
                                                                    WHERE TS.shiftid IN (SELECT SF.id
                                                                                    FROM shift SF
                                                                                    INNER JOIN schedule SCH ON SF.schedulid = SCH.id
                                                                                    WHERE SCH.Date = '$yesterday'))
                                                                    GROUP BY E.siteid) A
        INNER JOIN (SELECT E.siteid,COUNT(DISTINCT(TL.Employeeid)) pre
                FROM timelog TL
                INNER JOIN employee E ON E.id = TL.Employeeid
                WHERE DATE(TL.PunchTime) = '$yesterday'  AND TL.Type = 'IN' AND TL.Employeeid IN (SELECT ET.employeeid
                FROM employee_team ET
                            WHERE ET.Status = 1 AND ET.teamid IN (SELECT TS.teamid
                            FROM team_shift TS
                            WHERE TS.shiftid IN (SELECT SF.id
                            FROM shift SF
                            INNER JOIN schedule SCH ON SF.schedulid = SCH.id
                            WHERE SCH.Date = '$yesterday')))

                GROUP BY E.siteid) B ON A.siteid = B.siteid) chart ON chart.siteid = S.id")->queryAll();


    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue('A1', 'Daily Attendance Chart')
    ->setCellValue('E1', 'Generated On')
    ->setCellValue('F1', date("Y-m-d - h:i:sa"))
    ->setCellValue('A3', 'Site ')
    ->setCellValue('B3', 'Present')
    ->setCellValue('C3', 'Absent');
$col = 4;

foreach($lists as $list){


    $row = 0;
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$col,$list['name']);
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list['PRE']);
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list['ABS']);

    $col++;

}
$styleArray = array(
    'font'  => array(
        'bold'  => true,
        'color' => array('rgb' => '#f79727'),
        'size'  => 10
    ));
$objPHPExcel->getActiveSheet()->getStyle('A1:Y3')->applyFromArray($styleArray);



    $objPHPExcel->getActiveSheet()->setTitle("Daily Attendance Chart");

    $objPHPExcel->setActiveSheetIndex(0);

    ob_end_clean();
    ob_start();

    header('Content-Type: application/vnd.ms-excel');
    header('Content-Disposition: attachment;filename= DailyAttendanceChart.xls');
    header('Cache-Control: max-age=0');
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
    $objWriter->save('php://output');
  }


  //========================================================================================
  public function actionStackChartDownload(){
    $objPHPExcel = new PHPExcel();
    $current_month=date('m');
	$current_year=date('Y');
	$lastmonth=$current_month-1;
        $lastYearMonth = $current_year.'-'.$lastmonth;
        $newDate = date("Y-m", strtotime($lastYearMonth));
        $newDate1 = date("M-Y", strtotime($lastYearMonth));

    $lists = Yii::app()->db->createCommand("SELECT S.name,IFNULL(CAST(((ccc.bcs * 100)/(ccc.bcs + ccc.ot + ccc.allwnc)) as int),0) basic,IFNULL(CAST(((ccc.ot * 100)/(ccc.bcs + ccc.ot + ccc.allwnc)) as int),0) ot,IFNULL(CAST(((ccc.allwnc * 100)/(ccc.bcs + ccc.ot + ccc.allwnc)) as int),0) allownce
    FROM sites S
    LEFT JOIN (SELECT P.SiteId,SUM(bbb.basic) bcs,SUM(bbb.OT) ot,SUM(bbb.allowance) allwnc
            FROM payroll P
            INNER JOIN (SELECT PI.Payroll_id,sum(PI.BasicWage) basic,SUM(PI.NOT),SUM(PI.DOT),SUM(PI.TOT),(SUM(PI.NOT) + SUM(PI.DOT) + SUM(PI.TOT)) OT,SUM(PI.Allowance) allowance
                    FROM payroll_items PI
                    WHERE PI.Payroll_id IN (SELECT P.id
                            FROM payroll P
                            WHERE P.EndDate LIKE '%{$newDate}%')

                    GROUP by PI.Payroll_id) bbb ON bbb.Payroll_id = P.id

            GROUP BY P.SiteId) ccc ON ccc.siteId = S.id")->queryAll();

    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue('A1', 'Monthly Payroll')
    ->setCellValue('E1', 'Generated On')
    ->setCellValue('F1', date("Y-m-d - h:i:sa"))
    ->setCellValue('A3', 'Site ')
    ->setCellValue('B3', 'Basic')
    ->setCellValue('C3', 'OT')
    ->setCellValue('D3', 'Allownce');
$col = 4;

foreach($lists as $list){


    $row = 0;
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$col,$list['name']);
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list['basic'].'%');
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list['ot'].'%');
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list['allownce'].'%');

    $col++;

}
$styleArray = array(
    'font'  => array(
        'bold'  => true,
        'color' => array('rgb' => '#f79727'),
        'size'  => 10
    ));
$objPHPExcel->getActiveSheet()->getStyle('A1:Y3')->applyFromArray($styleArray);



    $objPHPExcel->getActiveSheet()->setTitle("Monthly Payroll");

    $objPHPExcel->setActiveSheetIndex(0);

    ob_end_clean();
    ob_start();

    header('Content-Type: application/vnd.ms-excel');
    header('Content-Disposition: attachment;filename= MonthlyPayroll.xls');
    header('Cache-Control: max-age=0');
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
    $objWriter->save('php://output');
  }

//========================================================================================
public function actionSiteBarChartDownload(){
    $objPHPExcel = new PHPExcel();
    $sitid = Yii::app()->user->data()->SiteId;
    // print_r($sitid);
    //  die;
    $lists = Yii::app()->db->createCommand("SELECT allo.name,allo.allocated,pre.present,(allo.allocated - pre.present) absent
            FROM (SELECT A.name, COUNT(E.id) allocated
            FROM employee_shift ES
            INNER JOIN employee E ON E.id = ES.EmployeeId
            INNER JOIN accounts A ON A.id = E.Accountid
            WHERE E.statusId = 1 AND ES.ShiftId IN (SELECT SF.id
                                    FROM schedule SCH
                                    INNER JOIN shift SF ON SF.schedulid = SCH.id
                                    WHERE SCH.Date = CURDATE() AND SF.SiteId = $sitid)
            GROUP BY A.name) allo
            LEFT JOIN (SELECT A.name, count(DISTINCT(T.Employeeid)) present
            FROM timelog T
            INNER JOIN employee E ON E.id = T.Employeeid
            INNER JOIN accounts A ON A.id = E.Accountid
            WHERE DATE(T.PunchTime) = CURDATE() AND T.Type = 'IN' AND T.Employeeid IN (SELECT E.id
                    FROM employee_shift ES
                    INNER JOIN employee E ON E.id = ES.EmployeeId
                    INNER JOIN accounts A ON A.id = E.Accountid
                    WHERE ES.ShiftId IN (SELECT SF.id
                                            FROM schedule SCH
                                            INNER JOIN shift SF ON SF.schedulid = SCH.id
                                            WHERE SCH.Date = CURDATE() AND SF.SiteId = $sitid))
            GROUP BY A.name) pre ON allo.name = pre.name")->queryAll();
    // print_r($lists);
    // die;
    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue('A1', 'Daily Attendance')
    ->setCellValue('E1', 'Generated On')
    ->setCellValue('F1', date("Y-m-d - h:i:sa"))
    ->setCellValue('A3', 'Site ')
    ->setCellValue('B3', 'Allocated')
    ->setCellValue('C3', 'present')
    ->setCellValue('D3', 'Absent');
$col = 4;

foreach($lists as $list){


    $row = 0;
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$col,$list['name']);
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list['allocated']);
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list['present']);
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list['absent']);

    $col++;

}
$styleArray = array(
    'font'  => array(
        'bold'  => true,
        'color' => array('rgb' => '#f79727'),
        'size'  => 10
    ));
$objPHPExcel->getActiveSheet()->getStyle('A1:Y3')->applyFromArray($styleArray);



    $objPHPExcel->getActiveSheet()->setTitle("Daily Attendance");

    $objPHPExcel->setActiveSheetIndex(0);

    ob_end_clean();
    ob_start();

    header('Content-Type: application/vnd.ms-excel');
    header('Content-Disposition: attachment;filename= DETAILS_ATTENDANCE.xls');
    header('Cache-Control: max-age=0');
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
    $objWriter->save('php://output');
  }

//========================================================================================
public function actionSitePieChartDownload(){
    $objPHPExcel = new PHPExcel();
    $sitid = Yii::app()->user->data()->SiteId;
    $lists = Yii::app()->db->createCommand("SELECT A.name, COUNT(DISTINCT T.Employeeid) AS count
        FROM timelog T
        INNER JOIN employee E ON E.id = T.Employeeid
        INNER JOIN accounts A ON A.id = E.Accountid
        WHERE DATE(T.PunchTime) = CURDATE() AND E.siteid = $sitid AND E.statusId = 1 AND T.Type = 'IN'
        GROUP BY A.name")->queryAll();
    // print_r($lists);
    // die;
    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue('A1', 'Account-Wise Attendance')
    ->setCellValue('E1', 'Generated On')
    ->setCellValue('F1', date("Y-m-d - h:i:sa"))
    ->setCellValue('A3', 'Account ')
    ->setCellValue('B3', 'Employee Count');
$col = 4;

foreach($lists as $list){


    $row = 0;
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$col,$list['name']);
    $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list['count']);


    $col++;

}
$styleArray = array(
    'font'  => array(
        'bold'  => true,
        'color' => array('rgb' => '#f79727'),
        'size'  => 10
    ));
$objPHPExcel->getActiveSheet()->getStyle('A1:Y3')->applyFromArray($styleArray);



    $objPHPExcel->getActiveSheet()->setTitle("Account-Wise Attendance");

    $objPHPExcel->setActiveSheetIndex(0);

    ob_end_clean();
    ob_start();

    header('Content-Type: application/vnd.ms-excel');
    header('Content-Disposition: attachment;filename= Account-WiseAttendance.xls');
    header('Cache-Control: max-age=0');
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
    $objWriter->save('php://output');
  }



  public function actionTestReport(){
    $lists = Yii::app()->db->createCommand("SELECT E.Namewithini Name,T.Intime StartTime, T.OuteTime EndTime ,E.nic NIC,D.type Designation,(T.WorkedHour + T.TotalOTHour) Hours ,DP.name department,A.name Account,SP.name supplier
            FROM timesheet T
            INNER JOIN employee E ON E.id = T.EmployeeId
            INNER JOIN supplier SP ON SP.id = E.supplierid
            INNER JOIN department DP ON DP.id = E.departmentid
            INNER JOIN designation D ON D.id = T.DesignaId
            INNER JOIN employee_shift ES ON ES.id = T.EmployeeShiftid
            INNER JOIN shift S ON S.id = ES.ShiftId
            INNER JOIN accounts A ON A.id = E.Accountid
            WHERE T.date >= DATE('2018-04-02') AND T.date <= DATE('2018-04-03') AND E.statusId = 1 ORDER BY Account,supplier")->queryAll();

        return $this->render('//timesheet/testreport',array('lists'=>$lists));
    }

    public function actionCreateWorkingHoursTrackingReport()
    {
            if (Yii::app()->user->data()->superuser == 1) {
                $Departments = Department::model()->findAll();
            } else {
                $SiteId = Yii::app()->user->data()->SiteId;
                $Departments = Department::model()->findAllByAttributes(array('siteid' => $SiteId));
                
            }
            
        $model = new WorkingHoursTrackingReport;
             
        if(isset($_POST['WorkingHoursTrackingReport']) and isset($_POST['department'])){
            $model-> attributes = $_POST['WorkingHoursTrackingReport'];

          //  if($model->validate()){
                $list= Yii::app()->db->createCommand("SELECT A.AccountOracleCode accountId,E.EmployeeNumber As id,E.gender, E.Namewithini Name,A.name Account,E.nic NIC,FLOOR(T.WorkedHour + T.TotalOTHour) Hours ,DP.name department,T.date,S.name Supplier
                    FROM timesheet T
                    INNER JOIN employee E ON E.id = T.EmployeeId
                    INNER JOIN department DP ON DP.id = E.departmentid
                    INNER JOIN designation D ON D.id = T.DesignaId
                    INNER JOIN accounts A ON A.id = E.Accountid
                    INNER JOIN supplier S ON S.id = E.supplierid
                    WHERE T.date >= DATE('$model->startDate') AND T.date <= DATE('$model->endDate') AND DP.id IN(".implode(',',$_POST['department']).") ORDER BY Supplier,Account")->queryAll();
                    
//             echo CJSON::encode($list);
//             die;
                $out1 = array();
                foreach ($list as $key => $value){
                    if (array_key_exists($value['NIC'], $out1)){
                        
                        $out1[$value['NIC']]['total'] += $value['Hours'];

                        if(array_key_exists($value['date'],$out1[$value['NIC']])){
                            $out1[$value['NIC']][$value['date']] += $value['Hours']; 
                        }else{
                            $out1[$value['NIC']][$value['date']] = $value['Hours'];
                            
                        }
                        
                    } else {
                        $out1[$value['NIC']] = array('NIC' => $value['NIC'],'Name' => $value['Name'], $value['date'] => $value['Hours'],'total' => $value['Hours'],'Account' =>$value['Account'],'Supplier' =>$value['Supplier'],'Gender' =>$value['gender'],'Id' =>$value['id'],'Department' =>$value['department'],'accountId' =>$value['accountId'] );
                        
                    }
                }
                $out1 = array_values($out1);
                // print_r(CJSON::encode($out1));
                // die;

                function toDate($x){
                    return date('Y-m-d', $x);
                }
                $dates = range(strtotime($model->startDate), strtotime($model->endDate),86400);
                $range_of_dates = array_map('toDate',$dates);
//                 print_r($out1);
//                 die;


                $this->render('//timeSheet/ViewWorkingHoursTrackingReport',array('model'=>$model,'list'=>$out1,'rangeOfDates'=>$range_of_dates));
          //  }
    
        }else{
            return $this->render('//timeSheet/WorkingHoursTrackingReport',array('model'=>$model,'Departments'=>$Departments));
        }
    }


    public function actionWorkingHoursTrackingReportExcel(){
        
        $list = CJSON::decode($_POST['list']);
        $rangeOfDates = CJSON::decode($_POST['rangeOfDates']);
        
        $objPHPExcel = new PHPExcel();
        $headingColumn = 0;
        $headingRow = 2;
        
            
        //=================================Report Name==============
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1,1,'Working Hours Tracking Report');
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(1, 1)->applyFromArray(array('borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40'))),'font' => array('size' => 13,'name'=>'Algerian','bold' => true, 'color' => array('rgb' => '312692'))));
        //=================================== end ====================

        //===================================table heading================
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($headingColumn,$headingRow,'EmpId');
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($headingColumn, $headingRow)->applyFromArray(array('alignment' => array(
            'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER),'fill' => array(
            'type' => PHPExcel_Style_Fill::FILL_SOLID,'color' => array('rgb' => '2f75b5')),'borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40'))),'font' => array('size' => 11 ,'bold' => true, 'color' => array('rgb' => 'ffffff'))));

        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$headingColumn,$headingRow,'NIC');
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($headingColumn, $headingRow)->applyFromArray(array('alignment' => array(
            'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER),'fill' => array(
            'type' => PHPExcel_Style_Fill::FILL_SOLID,'color' => array('rgb' => '2f75b5')),'borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40'))),'font' => array('size' => 11 ,'bold' => true, 'color' => array('rgb' => 'ffffff'))));

        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$headingColumn,$headingRow,'Name');
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($headingColumn, $headingRow)->applyFromArray(array('alignment' => array(
            'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER),'fill' => array(
            'type' => PHPExcel_Style_Fill::FILL_SOLID,'color' => array('rgb' => '2f75b5')),'borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40'))),'font' => array('size' => 11 ,'bold' => true, 'color' => array('rgb' => 'ffffff'))));

        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$headingColumn,$headingRow,'Gender');
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($headingColumn, $headingRow)->applyFromArray(array('alignment' => array(
            'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER),'fill' => array(
            'type' => PHPExcel_Style_Fill::FILL_SOLID,'color' => array('rgb' => '2f75b5')),'borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40'))),'font' => array('size' => 11 ,'bold' => true, 'color' => array('rgb' => 'ffffff'))));
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$headingColumn,$headingRow,'Client Code');
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($headingColumn, $headingRow)->applyFromArray(array('alignment' => array(
            'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER),'fill' => array(
            'type' => PHPExcel_Style_Fill::FILL_SOLID,'color' => array('rgb' => '2f75b5')),'borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40'))),'font' => array('size' => 11 ,'bold' => true, 'color' => array('rgb' => 'ffffff'))));
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$headingColumn,$headingRow,'Client Name');
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($headingColumn, $headingRow)->applyFromArray(array('alignment' => array(
            'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER),'fill' => array(
            'type' => PHPExcel_Style_Fill::FILL_SOLID,'color' => array('rgb' => '2f75b5')),'borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40'))),'font' => array('size' => 11 ,'bold' => true, 'color' => array('rgb' => 'ffffff'))));
        foreach($rangeOfDates as $range){
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$headingColumn,$headingRow,$range);
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($headingColumn, $headingRow)->applyFromArray(array('alignment' => array(
                'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER),'fill' => array(
                'type' => PHPExcel_Style_Fill::FILL_SOLID,'color' => array('rgb' => '2f75b5')),'borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40'))),'font' => array('size' => 11 ,'bold' => true, 'color' => array('rgb' => 'ffffff'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($headingColumn, $headingRow)->getAlignment()->setTextRotation(90);
        }
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$headingColumn,$headingRow,'Total');
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($headingColumn, $headingRow)->applyFromArray(array('alignment' => array(
            'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER),'fill' => array(
            'type' => PHPExcel_Style_Fill::FILL_SOLID,'color' => array('rgb' => '2f75b5')),'borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40'))),'font' => array('size' => 11 ,'bold' => true, 'color' => array('rgb' => 'ffffff'))));

        //===================================end table heading================
        
        $dataRow = 3;
        //==============create new array for daily total hrs==============
        $dailyTotalHours = array();
        $dailyTotalHours['total'] = 0;
        //========================================
        //====================add data to table ================
        for($i = 0;$i < count($list);$i++){
            $dataColumn = 0;
            if($i == 0){
                $supplier = $list[$i]['Supplier'];
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1,$dataRow,$supplier);
                $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(1, $dataRow)->applyFromArray(array('font' => array('size' => 13 ,'bold' => true, 'color' => array('rgb' => 'bf0441'))));
                ++$dataRow;
            }

            if($supplier == $list[$i]['Supplier']){
                
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($dataColumn,$dataRow,$list[$i]['Id']);
                $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($dataColumn, $dataRow)->applyFromArray(array('borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40')))));
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$dataColumn,$dataRow,$list[$i]['NIC']);
                $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($dataColumn, $dataRow)->applyFromArray(array('borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40')))));
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$dataColumn,$dataRow,$list[$i]['Name']);
                $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($dataColumn, $dataRow)->applyFromArray(array('borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40')))));
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$dataColumn,$dataRow,$list[$i]['Gender']);
                $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($dataColumn, $dataRow)->applyFromArray(array('borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40')))));
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$dataColumn,$dataRow,$list[$i]['accountId']);
                $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($dataColumn, $dataRow)->applyFromArray(array('borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40')))));
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$dataColumn,$dataRow,$list[$i]['Account']);
                $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($dataColumn, $dataRow)->applyFromArray(array('borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40')))));


                foreach($rangeOfDates as $range){
                    if (array_key_exists($range, $list[$i])){
                        //==============add data to dailytotalHrs Array==============
                        if(array_key_exists($range,$dailyTotalHours)){
                            $dailyTotalHours[$range] += $list[$i][$range];
                            $dailyTotalHours['total'] += $list[$i][$range];
                        }else{
                            $dailyTotalHours[$range] = $list[$i][$range];
                            $dailyTotalHours['total'] += $list[$i][$range];
                        }
                        //======================================================
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$dataColumn,$dataRow,$list[$i][$range]);
                        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($dataColumn, $dataRow)->applyFromArray(array('borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40')))));
                    }else{
                        ++$dataColumn;
                        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($dataColumn, $dataRow)->applyFromArray(array('borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40'))),'fill' => array(
                            'type' => PHPExcel_Style_Fill::FILL_SOLID,'color' => array('rgb' => '2f75b5'))));
                        
                    }
        
                }
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$dataColumn,$dataRow,$list[$i]['total']);
                $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($dataColumn, $dataRow)->applyFromArray(array('font' => array('bold' => true),'borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40')))));
                ++$dataRow;
            }else{
                $supplier = $list[$i]['Supplier'];
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1,$dataRow,$supplier);
                $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(1, $dataRow)->applyFromArray(array('font' => array('size' => 13 ,'bold' => true, 'color' => array('rgb' => 'bf0441'))));
                ++$dataRow;

                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($dataColumn,$dataRow,$list[$i]['Id']);
                $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($dataColumn, $dataRow)->applyFromArray(array('borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40')))));
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$dataColumn,$dataRow,$list[$i]['NIC']);
                $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($dataColumn, $dataRow)->applyFromArray(array('borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40')))));
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$dataColumn,$dataRow,$list[$i]['Name']);
                $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($dataColumn, $dataRow)->applyFromArray(array('borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40')))));
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$dataColumn,$dataRow,$list[$i]['Gender']);
                $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($dataColumn, $dataRow)->applyFromArray(array('borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40')))));
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$dataColumn,$dataRow,$list[$i]['accountId']);
                $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($dataColumn, $dataRow)->applyFromArray(array('borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40')))));
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$dataColumn,$dataRow,$list[$i]['Account']);
                $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($dataColumn, $dataRow)->applyFromArray(array('borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40')))));


                foreach($rangeOfDates as $range){
                    if (array_key_exists($range, $list[$i])){
                        //==============add data to dailytotalHrs Array==============
                        if(array_key_exists($range,$dailyTotalHours)){
                            $dailyTotalHours[$range] += $list[$i][$range];
                            $dailyTotalHours['total'] += $list[$i][$range];
                        }else{
                            $dailyTotalHours[$range] = $list[$i][$range];
                            $dailyTotalHours['total'] += $list[$i][$range];
                        }
                        //======================================================
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$dataColumn,$dataRow,$list[$i][$range]);
                        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($dataColumn, $dataRow)->applyFromArray(array('borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40')))));

                    }else{
                        ++$dataColumn;
                        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($dataColumn, $dataRow)->applyFromArray(array('borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40'))),'fill' => array(
                            'type' => PHPExcel_Style_Fill::FILL_SOLID,'color' => array('rgb' => '2f75b5'))));
                        
                    }
        
                }
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$dataColumn,$dataRow,$list[$i]['total']);
                $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($dataColumn, $dataRow)->applyFromArray(array('font' => array('bold' => true),'borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40')))));
                ++$dataRow;
            }

            
        }
        //====================End data adding ================

        //==========if add or remove fields in the report change the value of totalColumn==============
        $totalColumn = 5;
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($totalColumn,$dataRow,'Total');
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($totalColumn, $dataRow)->applyFromArray(array('font' => array('bold' => true),'borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40')))));
        foreach($rangeOfDates as $range){
            if (array_key_exists($range, $dailyTotalHours)){
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$totalColumn,$dataRow,$dailyTotalHours[$range]);
                $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($totalColumn, $dataRow)->applyFromArray(array('font' => array('bold' => true),'borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40'))),'fill' => array(
                    'type' => PHPExcel_Style_Fill::FILL_SOLID,'color' => array('rgb' => '92d050'))));

            }else{
                ++$totalColumn;
                $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($totalColumn, $dataRow)->applyFromArray(array('borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40'))),'fill' => array(
                    'type' => PHPExcel_Style_Fill::FILL_SOLID,'color' => array('rgb' => '92d050'))));
                
               
            }
        }
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$totalColumn,$dataRow,$dailyTotalHours['total']);
                $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($totalColumn, $dataRow)->applyFromArray(array('font' => array('bold' => true),'borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40'))),'fill' => array(
                    'type' => PHPExcel_Style_Fill::FILL_SOLID,'color' => array('rgb' => 'de69e0'))));       
       
        $objPHPExcel->setActiveSheetIndex(0);

        ob_end_clean();
        ob_start();

        header('Content-Type: application/vnd.ms-excel');
        header('Content-Disposition: attachment;filename=WorkingHoursTrackingReport.xls');
        header('Cache-Control: max-age=0');
        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
        $objWriter->save('php://output');
    }

//===============================================added by thilina 2019-01-23============================
    public function actionManpowerWiseCost(){
        
        $model = new Manpower_wise_cost_report;
        if(isset($_POST['Manpower_wise_cost_report'])){
            $model-> attributes = $_POST['Manpower_wise_cost_report'];
            // print_r($model->startDate);die;
            $siteid = Yii::app()->user->data()->SiteId;
    
            if($model->validate()){
                $list= Yii::app()->db->createCommand("SELECT TS.* ,E.supplierid,ES.monthsalary,S.name
                FROM timesheet TS
                INNER JOIN employee E ON E.id = TS.EmployeeId
                INNER JOIN employeesalary ES ON ES.employeeid = E.id
                INNER JOIN supplier S ON S.id = E.supplierid
                WHERE TS.date >= '".$model->startDate."' AND TS.date <= '".$model->endDate."' AND TS.WorkedHour NOT IN ('0.00') AND ES.Status = 1 AND E.siteid = $siteid")->queryAll();
                
                $out1 = array();
                foreach ($list as $key => $value){
                    $basic = 0;
                    if($value['PaymentMethod'] =='MONTHLY'){
                        $basic = ($value['monthsalary']/26)-($value['LatedeductAmount']+$value['OutLateDeductAmount'])+($value['Tovertimesalary']);
                    }else if($value['PaymentMethod'] =='DAILY'){
                        $basic = ($value['SallaryRate'])-($value['LatedeductAmount']+$value['OutLateDeductAmount'])+($value['Tovertimesalary']);
                    }


                    if (array_key_exists($value['name'], $out1)){
                        $out1[$value['name']]['empCount'] += 1;
                        $out1[$value['name']]['cost'] += $basic;
                        
                    } else {
                        $out1[$value['name']] = array('supplier' => $value['name'],'empCount' => 1,'cost' => $basic, );
                        
                    }
                }
                $out1 = array_values($out1);
                
                $this->render('//timeSheet/view_manpower_wise_cost',array('lists'=>$out1,'model'=>$model));
    
            }
    
        }else{
            return $this->render('//timeSheet/create_manpower_wise_cost_report',array('model'=>$model));
        }
    
    
    }

    public function actionManpowerWiseCostExcel(){
        $objPHPExcel = new PHPExcel();
        $list = CJSON::decode($_POST['lists']);
        $model = CJSON::decode($_POST['model']);
    
        // print_r($model);
        // die;
    
        $objPHPExcel->setActiveSheetIndex(0)
        ->setCellValue('A1', 'Man Power Wise Cost Report')
        ->setCellValue('E1', 'Generated On')
        ->setCellValue('F1', date("Y-m-d - h:i:sa"))
        ->setCellValue('A2', 'Man Power')
        ->setCellValue('B2', 'Employee Count')
        ->setCellValue('C2', 'Cost');
        
    
        $col = 3;
    
    
        for($i = 0;$i < count($list);$i++){
            $row = 0;
            // print_r($list[$i]);
            // die;
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$col,$list[$i]['supplier']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['empCount']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['cost']);
            
    
    
            $col++;
    
        }
        $styleArray = array(
            'font'  => array(
                'bold'  => true,
                'color' => array('rgb' => '#f79727'),
                'size'  => 10
            ));
        $objPHPExcel->getActiveSheet()->getStyle('A1:F2')->applyFromArray($styleArray);
    
        //$objPHPExcel->getActiveSheet()->setTitle('sffd');
    
        $objPHPExcel->setActiveSheetIndex(0);
    
        if (ob_get_length()) ob_end_clean();
        ob_start();
    
        header('Content-Type: application/vnd.ms-excel');
        header('Content-Disposition: attachment;filename='.$model['startDate'].'-'.$model['startDate'].'-manpower wise cost.xls');
        header('Cache-Control: max-age=0');
        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
        $objWriter->save('php://output');
      }

      public function actionManpowerWiseCostPDF()
{

    $list = CJSON::decode($_POST['lists']);
    $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
    $mPDF1->setAutoBottomMargin = 'stretch';
    $mPDF1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
    $mPDF1->WriteHTML($this->renderPartial('//timesheet/manpower_wise_cost_PDF',array('list'=>$list),true));
    $file_name= 'manpowerWiseCost.'.'pdf';


    ob_end_clean();
    $mPDF1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );
}

public function actionShoeAndTshirt() {
    $model = new ShoeAndTshirt;

    if((isset($_POST['ShoeAndTshirt']))){
        $model->attributes = $_POST['ShoeAndTshirt'];

        if($_POST['ShoeAndTshirt']['emp_id'] == ""){
            $shoes = Yii::app()->db->createCommand("SELECT ES.* ,E.Namewithini,E.nic,A.AccountOracleCode accountId,A.name account
                FROM employee_shoe ES 
                INNER JOIN employee E ON E.id = ES.empID
                INNER JOIN accounts A ON A.id = E.Accountid
                WHERE ES.issuedDate >= '".$model->startDate."' AND ES.issuedDate <= '".$model->endDate."'")->queryAll();

            $tShirts = Yii::app()->db->createCommand("SELECT ET.*,E.Namewithini,E.nic,A.AccountOracleCode accountId,A.name account
                FROM employee_tshirt ET
                INNER JOIN employee E ON E.id = ET.empID
                INNER JOIN accounts A ON A.id = E.Accountid
                WHERE ET.issuedDate >= '".$model->startDate."' AND ET.issuedDate <= '".$model->endDate."'")->queryAll();
            
            $this->render('//shoes/viewShoeAndTshirt',array('model'=>$model,'shoes'=>$shoes,'tShirts'=>$tShirts));
            
        }else{
            $model->emp_id = $_POST['ShoeAndTshirt']['emp_id'];

            $shoes = Yii::app()->db->createCommand("SELECT ES.* ,E.Namewithini,E.nic,A.AccountOracleCode accountId,A.name account
                FROM employee_shoe ES 
                INNER JOIN employee E ON E.id = ES.empID
                INNER JOIN accounts A ON A.id = E.Accountid
                WHERE ES.empID =$model->emp_id AND ES.issuedDate >= '".$model->startDate."' AND ES.issuedDate <= '".$model->endDate."'")->queryAll();

            $tShirts = Yii::app()->db->createCommand("SELECT ET.*,E.Namewithini,E.nic,A.AccountOracleCode accountId,A.name account
                FROM employee_tshirt ET
                INNER JOIN employee E ON E.id = ET.empID
                INNER JOIN accounts A ON A.id = E.Accountid
                WHERE ET.empID = $model->emp_id AND ET.issuedDate >= '".$model->startDate."' AND ET.issuedDate <= '".$model->endDate."'")->queryAll();
            
            $this->render('//shoes/viewShoeAndTshirt',array('model'=>$model,'shoes'=>$shoes,'tShirts'=>$tShirts));
            
        }
        
    }else{
        return $this->render('//shoes/createShoeAndTshirt',array('model'=>$model));
    }




}

public function actionAssetsReport() {
    $model = new ShoeAndTshirt;

    if((isset($_POST['ShoeAndTshirt']))){
        $model->attributes = $_POST['ShoeAndTshirt'];

        if($_POST['ShoeAndTshirt']['emp_id'] == ""){
            
        if (Yii::app()->user->isAdmin()) {
        $assets = Yii::app()->db->createCommand("SELECT ES.* ,E.Namewithini,E.nic,A.AccountOracleCode accountId,A.name account,asset.name as asset,ast.type as assetType
                FROM employee_assets ES 
                INNER JOIN employee E ON E.id = ES.empId
                INNER JOIN asset ON ES.asset_id =asset.id
                INNER JOIN asset_types ast ON ES.assetType_id = ast.id
                INNER JOIN accounts A ON A.id = E.Accountid
                WHERE ES.issuedDate >= '".$model->startDate."' AND ES.issuedDate <= '".$model->endDate."'
                ORDER BY ES.empId,ES.asset_id,ES.issuedDate ASC")->queryAll();

        } else {
         $assets = Yii::app()->db->createCommand("SELECT ES.* ,E.Namewithini,E.nic,A.AccountOracleCode accountId,A.name account,asset.name as asset,ast.type as assetType
                FROM employee_assets ES 
                INNER JOIN employee E ON E.id = ES.empId
                INNER JOIN asset ON ES.asset_id =asset.id
                INNER JOIN asset_types ast ON ES.assetType_id = ast.id
                INNER JOIN accounts A ON A.id = E.Accountid
                WHERE E.siteid ='".Yii::app()->user->data()->SiteId."' AND ES.issuedDate >= '".$model->startDate."' AND ES.issuedDate <= '".$model->endDate."'
                ORDER BY ES.empId,ES.asset_id,ES.issuedDate ASC")->queryAll();

        }
         
            $this->render('//asset/viewAssets',array('model'=>$model,'assets'=>$assets));
            
        }else{
            $model->emp_id = $_POST['ShoeAndTshirt']['emp_id'];

            $assets = Yii::app()->db->createCommand("SELECT ES.* ,E.Namewithini,E.nic,A.AccountOracleCode accountId,A.name account,asset.name as asset,ast.type as assetType
                FROM employee_assets ES 
                INNER JOIN employee E ON E.id = ES.empId
                INNER JOIN asset ON ES.asset_id =asset.id
                INNER JOIN asset_types ast ON ES.assetType_id = ast.id
                INNER JOIN accounts A ON A.id = E.Accountid
                WHERE ES.empID =$model->emp_id AND ES.issuedDate >= '".$model->startDate."' AND ES.issuedDate <= '".$model->endDate."'
                ORDER BY ES.empId,ES.asset_id,ES.issuedDate ASC")->queryAll();

            $this->render('//asset/viewAssets',array('model'=>$model,'assets'=>$assets));
            
        }
        
    }else{
        return $this->render('//asset/AssetsForm',array('model'=>$model));
    }




}
public function actionEmployeeAssetsExcel(){
    $objPHPExcel = new PHPExcel();
    $assets = CJSON::decode($_POST['assets']);
    $model = CJSON::decode($_POST['model']);

    // print_r($model);
    // die;

    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue('A1', 'Employee Assets History Report')
    ->setCellValue('E1', 'Generated On')
    ->setCellValue('F1', date("Y-m-d - h:i:sa"))
    ->setCellValue('A2', 'Assets Details')
    ->setCellValue('A3', 'Asset')
    ->setCellValue('B3', 'Asset Type')         
    ->setCellValue('C3', 'Employee')
    ->setCellValue('D3', 'NIC')
    ->setCellValue('E3', 'Account')
    ->setCellValue('F3', 'Account')         
    ->setCellValue('G3', 'Issued Date')
    ->setCellValue('H3', 'Returned Date')
    ->setCellValue('I3', 'Status');
    

    $ShoesCol = 4;
    
    for($i = 0;$i < count($assets);$i++){
        $row = 0;
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$ShoesCol,$assets[$i]['asset']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$ShoesCol,$assets[$i]['assetType']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$ShoesCol,$assets[$i]['Namewithini']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$ShoesCol,$assets[$i]['nic']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$ShoesCol,$assets[$i]['accountId']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$ShoesCol,$assets[$i]['account']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$ShoesCol,$assets[$i]['issuedDate']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$ShoesCol,$assets[$i]['returnedDate']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$ShoesCol,$assets[$i]['Status']);
        
        $ShoesCol++;

    }
        
    $styleArray = array(
        'font'  => array(
            'bold'  => true,
            'color' => array('rgb' => '#f79727'),
            'size'  => 10
        ));
    $objPHPExcel->getActiveSheet()->getStyle('A1:P2')->applyFromArray($styleArray);

    $styleArray2 = [
        'font'=> [
            'bold'=> true,
            'color'=>['rgb'=>'#6c5ce7'],
        ],
        'size'=>10
    ];
    $objPHPExcel->getActiveSheet()->getStyle('A3:P3')->applyFromArray($styleArray2);

    //$objPHPExcel->getActiveSheet()->setTitle('sffd');

    $objPHPExcel->setActiveSheetIndex(0);

    if (ob_get_length()) ob_end_clean();
    ob_start();

    header('Content-Type: application/vnd.ms-excel');
    header('Content-Disposition: attachment;filename='.$model['startDate'].'-'.$model['startDate'].'-Assets History.xls');
    header('Cache-Control: max-age=0');
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
    $objWriter->save('php://output');
  }
//=========================================================================
// missing Dcumnet Report


public function actionMissingdocument(){

    if(Yii::app()->user->isAdmin()){

    $allemployee = Yii::app()->db->createCommand("SELECT * FROM employee")->queryAll();
    $employeArray= array();

    

    foreach($allemployee as $value) {
        $emp_id=$value['id'];
        $missing_doc = array();

    $employee_doc = Yii::app()->db->createCommand("SELECT * FROM employee_document_type")->queryAll();

    foreach($employee_doc as $value2) {

       

     
        $emp_doc_id=$value2['id'];


        $employeedocuments=EmployeeDocuments::model()->find(" status='1' AND emp_id='$emp_id' AND document_id='$emp_doc_id'");


        if(!$employeedocuments){

            $missing_doc[]=array("emp_doc_id"=> $emp_doc_id , "doc"=>0 );
                
            // $missing_doc[] = array("emp_id"=>$emp_id,"emp_doc_id"=> $emp_doc_id);

         
            
              }else{
            $missing_doc[]=array("emp_doc_id"=> $emp_doc_id , "doc"=>1 );

              }

         }  
         
         
         $employeArray[] = array("emp_id"=>$emp_id,"empdoc"=> $missing_doc);
    } 


    // print_r($employeArray);
    // die;

  


  }else{

    $sitid = Yii::app()->user->data()->SiteId;

    $allemployee = Yii::app()->db->createCommand("SELECT * FROM employee WHERE siteid='$sitid'")->queryAll();
    $employeArray= array();

    

    foreach($allemployee as $value) {
        $emp_id=$value['id'];
        $missing_doc = array();

    $employee_doc = Yii::app()->db->createCommand("SELECT * FROM employee_document_type")->queryAll();

    foreach($employee_doc as $value2) {

       

     
        $emp_doc_id=$value2['id'];


        $employeedocuments=EmployeeDocuments::model()->find(" status='1' AND emp_id='$emp_id' AND document_id='$emp_doc_id'");


        if(!$employeedocuments){

            $missing_doc[]=array("emp_doc_id"=> $emp_doc_id , "doc"=>0);
                
            // $missing_doc[] = array("emp_id"=>$emp_id,"emp_doc_id"=> $emp_doc_id);

         
            
              }else{
                $missing_doc[]=array("emp_doc_id"=> $emp_doc_id , "doc"=>1 );
    
                  }
         }  
         
         
         $employeArray[] = array("emp_id"=>$emp_id,"empdoc"=> $missing_doc);
    }


  }




    $this->render('//employeeDocuments/missingdocument',array('missing_doc'=>$employeArray));

}



// missing Dcumnet Report End
//Supplier  missing Dcumnet Report start
public function actionSuppliermissingdocument(){

    $supplierall=Supplier::model()->findAll();
    $Sup_missing_doc = array();
    foreach($supplierall as $value) {

        $supplierdocumenttype=SupplierDocumentType::model()->findAll("site_status='0'");

        foreach($supplierdocumenttype as $value2) {

 
                   $supplierdocuments=SupplierDocuments::model()->find(" status='1' AND supplier_id='$value->id' AND documents_type_id='$value2->id'");
 
                   if(!$supplierdocuments){
                    $Sup_missing_doc[] = array("sup_id"=>$value->name,"sup_doc_id"=> $value2->name,"site_id"=>"GENERAL");

                   }
        }

        $supplierdocumenttype_sitevise=SupplierDocumentType::model()->findAll("site_status='1'");

        foreach($supplierdocumenttype_sitevise as $value3) {

            $sitesall =Sites::model()->findAll();

            foreach($sitesall as $value4) {
              $suppliercontractocument = SupplierContractDocument::model()->find(" status='1' AND supplier_id='$value->id' AND documents_type_id='$value3->id' AND site_id='$value4->id'");

              if(!$suppliercontractocument ){
                $Sup_missing_doc[] = array("sup_id"=>$value->name,"sup_doc_id"=> $value3->name,"site_id"=>$value4->name);

              }

            
               

            }


        }
      

    }

  
    $this->render('//supplier/suppliermissingdoc',array('Sup_missing_doc'=>$Sup_missing_doc));

}
//Supplier missing Dcumnet Report End


//Supplier   missing employee documt EXLE

public function actionSupplierMissingEmpDoc(){


    $objPHPExcel = new PHPExcel();
    $list = CJSON::decode("s");
    $model = CJSON::decode("ss");
     if(Yii::app()->user->isAdmin()){

        $supplierall=Supplier::model()->findAll();
        $Sup_missing_doc = array();
        foreach($supplierall as $value) {
    
            $supplierdocumenttype=SupplierDocumentType::model()->findAll("site_status='0'");
    
            foreach($supplierdocumenttype as $value2) {
    
     
                       $supplierdocuments=SupplierDocuments::model()->find(" status='1' AND supplier_id='$value->id' AND documents_type_id='$value2->id'");
     
                       if(!$supplierdocuments){
                        $Sup_missing_doc[] = array("sup_id"=>$value->name,"sup_doc_id"=> $value2->name,"site_id"=>"GENERAL");
    
                       }
            }
    
            $supplierdocumenttype_sitevise=SupplierDocumentType::model()->findAll("site_status='1'");
    
            foreach($supplierdocumenttype_sitevise as $value3) {
    
                $sitesall =Sites::model()->findAll();
    
                foreach($sitesall as $value4) {
                  $suppliercontractocument = SupplierContractDocument::model()->find(" status='1' AND supplier_id='$value->id' AND documents_type_id='$value3->id' AND site_id='$value4->id'");
    
                  if(!$suppliercontractocument ){
                    $Sup_missing_doc[] = array("sup_id"=>$value->name,"sup_doc_id"=> $value3->name,"site_id"=>$value4->name);
    
                  }
    
                
                   
    
                }
    
    
            }
          
    
        }
}else{
    $sitid = Yii::app()->user->data()->SiteId;
    
    $supplierall=Supplier::model()->findAll();
    $Sup_missing_doc = array();
    foreach($supplierall as $value) {

        $supplierdocumenttype=SupplierDocumentType::model()->findAll("site_status='0'");

        foreach($supplierdocumenttype as $value2) {

 
                   $supplierdocuments=SupplierDocuments::model()->find(" status='1' AND supplier_id='$value->id' AND documents_type_id='$value2->id'");
 
                   if(!$supplierdocuments){
                    $Sup_missing_doc[] = array("sup_id"=>$value->name,"sup_doc_id"=> $value2->name,"site_id"=>"GENERAL");

                   }
        }

        $supplierdocumenttype_sitevise=SupplierDocumentType::model()->findAll("site_status='1'");

        foreach($supplierdocumenttype_sitevise as $value3) {

            $sitesall =Sites::model()->findAll();

            foreach($sitesall as $value4) {
              $suppliercontractocument = SupplierContractDocument::model()->find(" status='1' AND supplier_id='$value->id' AND documents_type_id='$value3->id' AND site_id='$value4->id'");

              if(!$suppliercontractocument ){
                $Sup_missing_doc[] = array("sup_id"=>$value->name,"sup_doc_id"=> $value3->name,"site_id"=>$value4->name);

              }

            
               

            }


        }
      

    }
  

}

    // print_r($list);
    // die;

    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue('A1', 'Missing Supplier Documnet List')
    ->setCellValue('C1', 'Generated On')
    ->setCellValue('D1', date("Y-m-d - h:i:sa"))
    ->setCellValue('A2', 'Supplier Name')
  
    
    ->setCellValue('B2', 'Missing Document')
    ->setCellValue('C2', '	Site');

   
    $col = 3;

   


    for($i = 0;$i < count($Sup_missing_doc);$i++){

        $sup_name=$Sup_missing_doc[$i]['sup_id'];
      $sup_mis_documet=$Sup_missing_doc[$i]['sup_doc_id'];
      $site_name=$Sup_missing_doc[$i]['site_id'];

  



        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0,$col, $sup_name);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1,$col, $sup_mis_documet);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2,$col,$site_name);
  
        // $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2,$col,$list[$i]['Name']);
        // $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(3,$col,$list[$i]['StartTime']);
        // $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(4,$col,$list[$i]['EndTime']);
        // $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(5,$col,$list[$i]['HCount']);

        $col++;

    }
    $styleArray = array(
        'font'  => array(
            'bold'  => true,
            'color' => array('rgb' => '#f79727'),
            'size'  => 10
        ));
        $objPHPExcel->getActiveSheet()->getColumnDimension('A')->setWidth("15");

        $objPHPExcel->getActiveSheet()->getColumnDimension('B')->setWidth("30");
        $objPHPExcel->getActiveSheet()->getColumnDimension('C')->setWidth("20");
        $objPHPExcel->getActiveSheet()->getColumnDimension('D')->setWidth("30");
    $objPHPExcel->getActiveSheet()->getStyle('A1:D2')->applyFromArray($styleArray);

    $objPHPExcel->setActiveSheetIndex(0);

    ob_end_clean();
    ob_start();

    header('Content-Type: application/vnd.ms-excel');
    header('Content-Disposition: attachment;filename='.$model['startDate'].'-'.$model['endDate'].'-Missing Employee Document.xls');
    header('Cache-Control: max-age=0');
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
    $objWriter->save('php://output');
  }


//   missing employee documt end

public function actionShoeAndTshirtPDF(){
        $tShirts = CJSON::decode($_POST['tShirts']);
        $model = CJSON::decode($_POST['model']);
        $shoes = CJSON::decode($_POST['shoes']);
        $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
        $mPDF1->setAutoBottomMargin = 'stretch';
        $mPDF1->SetFooter('Report generated by <br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
        $mPDF1->WriteHTML($this->renderPartial('//shoes/shoesAndTshirtsPDF',array('tShirts'=>$tShirts,'shoes'=>$shoes,'model'=>$model),true));
        $file_name= 'Shoes And Tshirt Report Created On.pdf';
        ob_end_clean();
        $mPDF1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );

}   
public function actionShoeAndTshirtExcel(){
    $objPHPExcel = new PHPExcel();
    $tShirts = CJSON::decode($_POST['tShirts']);
    $model = CJSON::decode($_POST['model']);
    $shoes = CJSON::decode($_POST['shoes']);

    // print_r($model);
    // die;

    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue('A1', 'Shoes And T-Shirt History Report')
    ->setCellValue('E1', 'Generated On')
    ->setCellValue('F1', date("Y-m-d - h:i:sa"))
    ->setCellValue('A2', 'Shoes Details')
    ->setCellValue('A3', 'Employee')
    ->setCellValue('B3', 'NIC')
    ->setCellValue('C3', 'Account')
    ->setCellValue('D3', 'Account')
    ->setCellValue('E3', 'Issued Date')
    ->setCellValue('F3', 'Returned Date')
    ->setCellValue('G3', 'Status')
    ->setCellValue('J2', 'T-Shirts Details')
    ->setCellValue('J3', 'Employee')
    ->setCellValue('K3', 'NIC')
    ->setCellValue('L3', 'Account')
    ->setCellValue('M3', 'Account')
    ->setCellValue('N3', 'Issued Date')
    ->setCellValue('O3', 'Returned Date')
    ->setCellValue('P3', 'Status')
    ;
    

    $ShoesCol = 4;
    $tShirtCol = 4;


    for($i = 0;$i < count($shoes);$i++){
        $row = 0;
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$ShoesCol,$shoes[$i]['Namewithini']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$ShoesCol,$shoes[$i]['nic']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$ShoesCol,$shoes[$i]['accountId']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$ShoesCol,$shoes[$i]['account']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$ShoesCol,$shoes[$i]['issuedDate']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$ShoesCol,$shoes[$i]['returnedDate']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$ShoesCol,$shoes[$i]['Status']);
        
        $ShoesCol++;

    }
    for($i = 0;$i < count($tShirts);$i++){
        $row = 9;
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$tShirtCol,$tShirts[$i]['Namewithini']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$tShirtCol,$tShirts[$i]['nic']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$tShirtCol,$tShirts[$i]['accountId']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$tShirtCol,$tShirts[$i]['account']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$tShirtCol,$tShirts[$i]['issuedDate']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$tShirtCol,$tShirts[$i]['returnedDate']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$tShirtCol,$tShirts[$i]['Status']);
        
        $tShirtCol++;

    }
    
    $styleArray = array(
        'font'  => array(
            'bold'  => true,
            'color' => array('rgb' => '#f79727'),
            'size'  => 10
        ));
    $objPHPExcel->getActiveSheet()->getStyle('A1:P2')->applyFromArray($styleArray);

    $styleArray2 = [
        'font'=> [
            'bold'=> true,
            'color'=>['rgb'=>'#6c5ce7'],
        ],
        'size'=>10
    ];
    $objPHPExcel->getActiveSheet()->getStyle('A3:P3')->applyFromArray($styleArray2);

    //$objPHPExcel->getActiveSheet()->setTitle('sffd');

    $objPHPExcel->setActiveSheetIndex(0);

    if (ob_get_length()) ob_end_clean();
    ob_start();

    header('Content-Type: application/vnd.ms-excel');
    header('Content-Disposition: attachment;filename='.$model['startDate'].'-'.$model['startDate'].'-Shoes And T-shirt History.xls');
    header('Cache-Control: max-age=0');
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
    $objWriter->save('php://output');
  }

public function actionEmployeeLeaveHistory(){
    $model = new AttendanceForm;

    if((isset($_POST['AttendanceForm']))){
        $model->attributes = $_POST['AttendanceForm'];
        //validate Attendance Form
        if($model->validate()){

            //fetch data
            $logs = Yii::app()->db->createCommand("SELECT E.Namewithini,E.nic,S.name supplier, LT.Type,LD.leaveDays,L.PaidType
            FROM leavedays LD
            INNER JOIN `leave` L ON L.id = LD.leaveId
            INNER JOIN employee E ON E.id = LD.EmpId
            INNER JOIN supplier S ON S.id = E.supplierid
            INNER JOIN leavetype LT ON LT.id = L.LeaveType
            WHERE LD.leaveDays >= '".$model->startDate."' AND LD.leaveDays <= '".$model->endDate."' AND LD.EmpId = '".$model->employee."'")->queryAll();
        
            //get employee data from Employee model
             $employeeDetails = Employee::model()->findByPk($model->employee);

            //send data to view form
            $this->render('//leave/viewEmployeeLeaveHistory',array('model'=>$model,'logs'=>$logs,'employeeDetails'=>$employeeDetails));


            }

    }else{
        //load CreateAttendance Form
        return $this->render('//leave/createEmployeeLeaveHistory',array('model'=>$model));
    } 
}
public function actionEmployeeLeaveHistoryPDF()
{
        $logs = CJSON::decode($_POST['logs']);
        $model = CJSON::decode($_POST['model']);
        $employeeDetails = CJSON::decode($_POST['employee']);
        $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
        $mPDF1->setAutoBottomMargin = 'stretch';
        $mPDF1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
        $mPDF1->WriteHTML($this->renderPartial('//leave/employeeLeaveHistoryPDF',array('logs'=>$logs,'employeeDetails'=>$employeeDetails,'model'=>$model),true));
        $file_name= $employeeDetails['nic'].'Created On'.date("Y-m-d - h:i:sa").'.pdf';
        ob_end_clean();
        $mPDF1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );

}
public function actionEmployeeLeaveHistoryExcel(){
    $objPHPExcel = new PHPExcel();
    $logs = CJSON::decode($_POST['logs']);
    $model = CJSON::decode($_POST['model']);
    $employeeDetails = CJSON::decode($_POST['employee']);

    $account = Accounts::model()->findByPk($employeeDetails['Accountid']);
    $supplier = Supplier::model()->findByPk($employeeDetails['supplierid']);

    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue('B1', 'Employee Leave History For'.$model['startDate'].'---------'.$model['endDate'])
    ->setCellValue('E1', 'Generated On')
    ->setCellValue('F1', date("Y-m-d - h:i:sa"))
    ->setCellValue('B2', 'Name ')
    ->setCellValue('C2', $employeeDetails['title'] . ' ' . $employeeDetails['Namewithini'])
    ->setCellValue('D2', 'Customer Name')
    ->setCellValue('E2', $account->name)
    ->setCellValue('F2', 'MPSupplier ')
    ->setCellValue('G2', $supplier->name)
    ->setCellValue('H2', 'Customer Code')
    ->setCellValue('I2', $employeeDetails['Accountid'])
    ->setCellValue('A3', 'Leave Date')
    ->setCellValue('B3', 'Leave Type')
    ->setCellValue('C3', 'Paid Type');
    $y = 4;
    $styleArray = array(
        'font'  => array(
            'bold'  => true,
            'color' => array('rgb' => '#f79727'),
            'size'  => 10
        ));
    $objPHPExcel->getActiveSheet()->getStyle('A1:I3')->applyFromArray($styleArray);

    for($i = 0;$i < count($logs);$i++){

        $objPHPExcel->setActiveSheetIndex(0)
        ->setCellValue('A'.$y, $logs[$i]['leaveDays'])
        ->setCellValue('B'.$y, $logs[$i]['Type'])
        ->setCellValue('C'.$y, $logs[$i]['PaidType']);
        $y++;


    }

    $objPHPExcel->getActiveSheet()->setTitle($employeeDetails['nic']);

    $objPHPExcel->setActiveSheetIndex(0);

    ob_end_clean();
    ob_start();

    header('Content-Type: application/vnd.ms-excel');
    header('Content-Disposition: attachment;filename= Employee Timelog '.$employeeDetails['nic'].'Created On'.date("Y-m-d - h:i:sa").'.xls');
    header('Cache-Control: max-age=0');
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
    $objWriter->save('php://output');
  }

  public function actionSupplierWiseAttendanceSummery(){
    $previous_date = date('Y-m-d',strtotime('-1 day'));
    // $previous_date = '2019-02-18';
    if(Yii::app()->user->isAdmin()){
        $data = Yii::app()->db->createCommand("SELECT K.name,K.allocated,K2.present,(K.allocated - K2.present) absent
        FROM (SELECT SP.name,COUNT(ES.EmployeeId) allocated
            FROM schedule S
            INNER JOIN employee_shift ES ON ES.schedulid = S.id
            INNER JOIN employee E ON E.id = ES.EmployeeId
            INNER JOIN supplier SP ON SP.id = E.supplierid
            WHERE S.Date = '".$previous_date."'
            GROUP by SP.name) K
        LEFT JOIN (SELECT S.name,COUNT(T.EmployeeId) present
            FROM timesheet T 
            INNER JOIN employee E ON E.id = T.EmployeeId
            INNER JOIN supplier S ON S.id = E.supplierid
            WHERE T.date = '".$previous_date."'
            GROUP BY S.name) K2 ON K2.name = K.name")->queryAll();
    }else{
        $sitid = Yii::app()->user->data()->SiteId;
        $data = Yii::app()->db->createCommand("SELECT K.name,K.allocated,K2.present,(K.allocated - K2.present) absent
        FROM (SELECT SP.name,COUNT(ES.EmployeeId) allocated
            FROM schedule S
            INNER JOIN employee_shift ES ON ES.schedulid = S.id
            INNER JOIN employee E ON E.id = ES.EmployeeId
            INNER JOIN supplier SP ON SP.id = E.supplierid
            WHERE S.Date = '".$previous_date."' AND E.siteid = '".$sitid."'
            GROUP by SP.name) K
        LEFT JOIN (SELECT S.name,COUNT(T.EmployeeId) present
            FROM timesheet T 
            INNER JOIN employee E ON E.id = T.EmployeeId
            INNER JOIN supplier S ON S.id = E.supplierid
            WHERE T.date = '".$previous_date."' AND E.siteid = '".$sitid."'
            GROUP BY S.name) K2 ON K2.name = K.name")->queryAll();
    }
    $this->render('//timeSheet/supplierWiseAttendanceSummery',array('lists'=>$data,'date'=>$previous_date));
  }
  public function actionSupplierWiseAttendanceSummeryPDF()
  {
  
      $list = CJSON::decode($_POST['list']);
      $date = $_POST['date'];
      $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
      $mPDF1->setAutoBottomMargin = 'stretch';
      $mPDF1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
      $mPDF1->WriteHTML($this->renderPartial('//timeSheet/supplierWiseAttendanceSummeryPDF',array('lists'=>$list,'previous_date'=>$date),true));
      $file_name= $model['certainDate'].'supplierWiseAttendanceSummery.pdf';
  
  
      ob_end_clean();
      $mPDF1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );
  }

  public function actionSupplierWiseAttendanceSummeryExcel(){
    $objPHPExcel = new PHPExcel();
    $list = CJSON::decode($_POST['list']);
    $date = CJSON::decode($_POST['date']);

    // print_r($list);
    // die;

    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue('A1', 'Supplier Wise Attendance Summery Report')
    ->setCellValue('E1', 'Generated On')
    ->setCellValue('F1', date("Y-m-d - h:i:sa"))
    ->setCellValue('A2', 'MPSupplier')
    ->setCellValue('B2', 'Allocated Employees')
    ->setCellValue('C2', 'Present Employees')
    ->setCellValue('D2', 'Absent Employees');
    $col = 3;


    for($i = 0;$i < count($list);$i++){

        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0,$col,$list[$i]['name']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1,$col,$list[$i]['allocated']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2,$col,$list[$i]['present']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(3,$col,$list[$i]['absent']);

        $col++;

    }
    $styleArray = array(
        'font'  => array(
            'bold'  => true,
            'color' => array('rgb' => '#f79727'),
            'size'  => 10
        ));
    $objPHPExcel->getActiveSheet()->getStyle('A1:L2')->applyFromArray($styleArray);

    //$objPHPExcel->getActiveSheet()->setTitle('sffd');

    $objPHPExcel->setActiveSheetIndex(0);

    ob_end_clean();
    ob_start();

    header('Content-Type: application/vnd.ms-excel');
    header('Content-Disposition: attachment;filename=SupplierWiseAttendanceSummeryReport.xls');
    header('Cache-Control: max-age=0');
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
    $objWriter->save('php://output');
  }
  
  
  
   public function actionMPDailyCostingReport() {

        $Sites = Sites::model()->findAll();

        if (isset($_POST['MPDailySCostReport'])) {


            $Date = $_POST['MPDailySCostReport']['Date'];
            if (Yii::app()->user->data()->superuser == 1) {
                $SiteId = $_POST['MPDailySCostReport']['Site'];
                $Site = Sites::model()->findByAttributes(array('id' => $SiteId));
            } else {
                $SiteId = Yii::app()->user->data()->SiteId;
                $Site = Sites::model()->findByAttributes(array('id' => $SiteId));
            }

            $sql0 = "SELECT COUNT(timesheet.id) AS numberof_count,timesheet.MP_suplier_id , supplier.name,SUM(timesheet.SallaryRate) As daywage,SUM(timesheet.LatedeductTime) AS LatedeductTime,SUM(timesheet.OutLateDeductTime) AS OutLateDeductTime,SUM(timesheet.NOvertimeHours) AS NOvertimeHours ,SUM(timesheet.DOverTimeHour) AS DOverTimeHour, SUM(timesheet.PreOTHour) AS PreOTHour,SUM(timesheet.PreOTAmount) AS PreOTAmount,SUM(timesheet.LatedeductAmount) AS LatedeductAmount,SUM(timesheet.OutLateDeductAmount) AS OutLatedeductAmount,SUM(timesheet.NOvertimeSalary) as NOTAmount,SUM(timesheet.Dovertimesalary)AS DOTAmount,
                        SUM(timesheet.Tovertimesalary) AS TOTAmount
                        FROM timesheet
                        INNER JOIN supplier ON timesheet.MP_suplier_id = supplier.id
                        WHERE timesheet.date ='" . $Date . "' AND timesheet.SiteId ='" . $SiteId . "'
                        GROUP BY timesheet.SiteId";

            $AllAmount = Yii::app()->db->createCommand($sql0)->queryAll();

            $sql = "SELECT COUNT(timesheet.id) AS numberof_count,timesheet.MP_suplier_id , supplier.name,SUM(timesheet.SallaryRate) As daywage,SUM(timesheet.LatedeductTime) AS LatedeductTime,SUM(timesheet.OutLateDeductTime) AS OutLateDeductTime,SUM(timesheet.NOvertimeHours) AS NOvertimeHours ,SUM(timesheet.DOverTimeHour) AS DOverTimeHour, SUM(timesheet.PreOTHour) AS PreOTHour,SUM(timesheet.PreOTAmount) AS PreOTAmount,SUM(timesheet.LatedeductAmount) AS LatedeductAmount,SUM(timesheet.OutLateDeductAmount) AS OutLatedeductAmount,SUM(timesheet.NOvertimeSalary) as NOTAmount,SUM(timesheet.Dovertimesalary)AS DOTAmount,
                        SUM(timesheet.Tovertimesalary) AS TOTAmount
                        FROM timesheet
                        INNER JOIN supplier ON timesheet.MP_suplier_id = supplier.id
                        WHERE timesheet.date ='" . $Date . "' AND timesheet.SiteId ='" . $SiteId . "'
                        GROUP BY timesheet.MP_suplier_id";

            $MPWiseList = Yii::app()->db->createCommand($sql)->queryAll();
            $Alllist = array();
            $index = 0;

            if (!empty($MPWiseList)) {
                foreach ($MPWiseList as $mplist) {

                    $Alllist[] = $mplist;

                    $sql1 = "SELECT employee.id, employee.Namewithini,employee.nic,designation.type,department.name AS DepartmentName,accounts.name AS AccountName,timesheet.DayName,timesheet.SiteId,timesheet.PaymentMethod,timesheet.EmployeeShiftid,timesheet.SallaryRate,timesheet.LatedeductTime,timesheet.OutLateDeductTime,timesheet.LatedeductAmount,timesheet.OutLateDeductAmount,timesheet.PreOTHour,timesheet.PreOTAmount,timesheet.NOvertimeHours,timesheet.DOverTimeHour,timesheet.NOvertimeSalary,timesheet.Dovertimesalary,
                            timesheet.Tovertimesalary
                            FROM timesheet
                            INNER JOIN employee ON timesheet.EmployeeId = employee.id
                            INNER JOIN designation ON timesheet.DesignaId =designation.id
                            INNER JOIN department ON timesheet.department_id = department.id
                            LEFT OUTER JOIN accounts ON timesheet.account_id = accounts.id
                            WHERE timesheet.date ='" . $Date . "' AND timesheet.SiteId ='" . $SiteId . "' AND timesheet.MP_suplier_id ='" . $mplist['MP_suplier_id'] . "'";

                    $PO_List = Yii::app()->db->createCommand($sql1)->queryAll();
                    array_push($Alllist[$index], $PO_List);

                    $index++;
                }
                $this->render('//payroll/MPDailyCostingReportView', array('Alllist' => $Alllist, 'AllAmount' => $AllAmount, 'Sites' => $Sites, 'Site' => $Site, 'Date' => $Date));
            } else {

                $this->render('//payroll/MPDilyCostingAllert', array('Alllist' => $Alllist, 'AllAmount' => $AllAmount, 'Sites' => $Sites, 'Site' => $Site, 'Date' => $Date));
            }
        } else {
            $this->render('//payroll/MPDailyCostingReport', array('Sites' => $Sites));
        }
    }

    public function actionDesignationWiseDailyCostingReport() {

        $Sites = Sites::model()->findAll();

        if (isset($_POST['DesignationDailySCostReport'])) {

            $Date = $_POST['DesignationDailySCostReport']['Date'];
            if (Yii::app()->user->data()->superuser == 1) {
                $SiteId = $_POST['DesignationDailySCostReport']['Site'];
                $Site = Sites::model()->findByAttributes(array('id' => $SiteId));
            } else {
                $SiteId = Yii::app()->user->data()->SiteId;
                $Site = Sites::model()->findByAttributes(array('id' => $SiteId));
            }
            $sql0 = "SELECT COUNT(timesheet.id) AS numberof_count,timesheet.DesignaId , designation.type,SUM(timesheet.SallaryRate) As daywage,SUM(timesheet.LatedeductTime) AS LatedeductTime,SUM(timesheet.OutLateDeductTime) AS OutLateDeductTime,SUM(timesheet.NOvertimeHours) AS NOvertimeHours ,SUM(timesheet.DOverTimeHour) AS DOverTimeHour, SUM(timesheet.PreOTHour) AS PreOTHour,SUM(timesheet.PreOTAmount) AS PreOTAmount,SUM(timesheet.LatedeductAmount) AS LatedeductAmount,SUM(timesheet.OutLateDeductAmount) AS OutLatedeductAmount,SUM(timesheet.NOvertimeSalary) as NOTAmount,SUM(timesheet.Dovertimesalary)AS DOTAmount,
                        SUM(timesheet.Tovertimesalary) AS TOTAmount
                        FROM timesheet
                        INNER JOIN designation ON timesheet.DesignaId =designation.id
                        WHERE timesheet.date ='" . $Date . "' AND timesheet.SiteId ='" . $SiteId . "'
                        GROUP BY timesheet.SiteId";

            $AllAmount = Yii::app()->db->createCommand($sql0)->queryAll();

            $sql = "SELECT COUNT(timesheet.id) AS numberof_count,timesheet.DesignaId , designation.type,SUM(timesheet.SallaryRate) As daywage,SUM(timesheet.LatedeductTime) AS LatedeductTime,SUM(timesheet.OutLateDeductTime) AS OutLateDeductTime,SUM(timesheet.NOvertimeHours) AS NOvertimeHours ,SUM(timesheet.DOverTimeHour) AS DOverTimeHour, SUM(timesheet.PreOTHour) AS PreOTHour,SUM(timesheet.PreOTAmount) AS PreOTAmount,SUM(timesheet.LatedeductAmount) AS LatedeductAmount,SUM(timesheet.OutLateDeductAmount) AS OutLatedeductAmount,SUM(timesheet.NOvertimeSalary) as NOTAmount,SUM(timesheet.Dovertimesalary)AS DOTAmount,
                        SUM(timesheet.Tovertimesalary) AS TOTAmount
                        FROM timesheet
                        INNER JOIN designation ON timesheet.DesignaId = designation.id
                        WHERE timesheet.date ='" . $Date . "' AND timesheet.SiteId ='" . $SiteId . "'
                        GROUP BY timesheet.DesignaId";

            $DesignationWiseList = Yii::app()->db->createCommand($sql)->queryAll();
            $Alllist = array();
            $index = 0;

            if (!empty($DesignationWiseList)) {
                foreach ($DesignationWiseList as $mplist) {

                    $Alllist[] = $mplist;

                    $sql1 = " SELECT employee.id,employee.Namewithini,employee.nic,designation.type,department.name AS DepartmentName,accounts.name AS AccountName,timesheet.SiteId,timesheet.PaymentMethod,timesheet.EmployeeShiftid,timesheet.SallaryRate,timesheet.LatedeductTime,timesheet.OutLateDeductTime,timesheet.LatedeductAmount,timesheet.OutLateDeductAmount,timesheet.PreOTHour,timesheet.PreOTAmount,timesheet.NOvertimeHours,timesheet.DOverTimeHour,timesheet.NOvertimeSalary,timesheet.Dovertimesalary,
                            timesheet.Tovertimesalary
                            FROM timesheet
                            INNER JOIN employee ON timesheet.EmployeeId = employee.id
                            INNER JOIN designation ON timesheet.DesignaId =designation.id
                            INNER JOIN department ON timesheet.department_id = department.id
                            LEFT OUTER JOIN accounts ON timesheet.account_id = accounts.id
                            WHERE timesheet.date ='" . $Date . "' AND timesheet.SiteId ='" . $SiteId . "' AND timesheet.DesignaId ='" . $mplist['DesignaId'] . "'";

                    $PO_List = Yii::app()->db->createCommand($sql1)->queryAll();
                    array_push($Alllist[$index], $PO_List);

                    $index++;
                }
                $this->render('//payroll/DesignationWiseDailyCostingReportView', array('Alllist' => $Alllist, 'AllAmount' => $AllAmount, 'Sites' => $Sites, 'Site' => $Site, 'Date' => $Date));
            } else {
                $this->render('//payroll/MPDilyCostingAllert', array('Alllist' => $Alllist, 'AllAmount' => $AllAmount, 'Sites' => $Sites, 'Site' => $Site, 'Date' => $Date));
            }
        } else {
            $this->render('//payroll/DesignationWiseDailyCostingReport', array('Sites' => $Sites));
        }
    }

    public function actionMPWiseDailyCostReportExcel() {


        $objPHPExcel = new PHPExcel();
        $Account_List = CJSON::decode($_POST['AllList']);
        $AllAmount = CJSON::decode($_POST['AllAmount']);
        $Site = CJSON::decode($_POST['Site']);
        $Date = $_POST['Date'];
//         print_r($Account_List);
//          die;
//        if (!empty($Payroll)) {
//            $Site = Sites::model()->findByAttributes(array('id' => $Payroll['SiteId']));
//        }
        // Set document properties
        $objPHPExcel->getProperties()->setCreator("K'iin Balam")
                ->setLastModifiedBy("K'iin Balam")
                ->setTitle("YiiExcel Test Document")
                ->setSubject("YiiExcel Test Document")
                ->setDescription("Test document for YiiExcel, generated using PHP classes.")
                ->setKeywords("office PHPExcel php YiiExcel UPNFM")
                ->setCategory("Test result file");

        // Add some data
        $styleArray = array(
            'font' => array(
                'bold' => true,
                'color' => array('rgb' => '#f79727'),
                'size' => 10
        ));

        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, 1, 'MP SUPPLIER WISE DAILY COST REPORT ');
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, 2, 'DATE :');
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1, 2, $Date);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, 3, 'SITE :');
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1, 3, $Site['name']);

        $PerDayIncentiveS = 0;
        $LunchIncentiveS = 0;
        $NightShiftIncentiveS = 0;
        $TravelingIncentiveS = 0;
        $AccomodationIncentiveS = 0;
        $PerformanceIncentiveS = 0;
        $SpecialIncentiveS = 0;
        $TripCommissionIncentiveS = 0;
        $BOIPassIncentiveS = 0;
        $ContrctorFeeValueS = 0;
        $TotalForEpfS = 0;
        $TotalDayWageS = 0;


        $row = 6;
        
        foreach ($Account_List as $list1) {
            $col2 = 1;

            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, ++$row, 'MP SUPPLIER :');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col2, $row, $list1['name']);
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(0, $row)->applyFromArray(array('font' => array('size' => 11, 'bold' => true, 'color' => array('rgb' => '000000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(1, $row)->applyFromArray(array('font' => array('size' => 11, 'bold' => true, 'color' => array('rgb' => '0000ff'))));
            $row++;
            $col1 = 1;
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, $row, 'Employee Name');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col1, $row, 'NIC');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Job Title');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Department');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Account');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'net wage');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'In Late Hour');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'In Late Deduct');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Out Late Hour');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Out Late Deduct');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Total For EPF');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'N-OT Hour');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'N-OT Amount');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'D-OT Hour');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'D-OT Amount');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'pre-OT Hour');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Pre-OT Amount');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Attendance Incentive');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Lunch Incentive');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Night Shift Incentive');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Traveling Incentive');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Accomondation Incentive');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Performance Incentive');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Special Incentive');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Trip Commission Incentive');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'BOI Pass Incentive');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Total Incentive');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Total Net');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'EPF\ETF');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Contract Fee');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Cost To Company');

            $PerformanceIncentiveMP = 0;
            $SpecialIncentiveMP = 0;
            $TripCommissionIncentiveMP = 0;
            $BOIPassIncentiveMP = 0;
            $NightShiftIncentiveMP = 0;
            $PerDayIncentiveMP = 0;
            $LunchIncentiveMP = 0;
            $TravelingIncentiveMP = 0;
            $AccomodationIncentiveMp = 0;
            $ContrctorFeeValueMP = 0;
            $TotalForEpfMP = 0;
            $TotalDayWageMP = 0;


            $row++;

            foreach ($list1[0] as $list2) {

                $col = 1;

                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, $row, $list2['Namewithini']);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col, $row, $list2['nic']);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $list2['type']);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $list2['DepartmentName']);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $list2['AccountName']);
                
                $Shift = Yii::app()->db->createCommand("SELECT shift.id,shift.StartTime,shift.EndTime,employee_shift.id AS employeeshift
                        FROM employee_shift
                        INNER JOIN shift ON employee_shift.ShiftId = shift.id
                        WHERE employee_shift.id = '" . $list2['EmployeeShiftid'] . "'")->queryAll();


                $employeesalary = Employeesalary::model()->findByAttributes(array('employeeid' => $list2['id'], 'Status' => 1));
                if (empty($employeesalary)) {
                    $employeesalary = new Employeesalary;
                    $employeesalary->monthsalary = 0;
                    $employeesalary->DalySalary = 0;
                    $employeesalary->HourlyRate = 0;
                    $employeesalary->OTRate = 0;
                    $employeesalary->DoubleOTRate = 0;
                    $employeesalary->BasicSalary = 0;
                    $employeesalary->BRA1 = 0;
                    $employeesalary->BRA2 = 0;
                    $employeesalary->BRA3 = 0;
                }

                if (!empty($Shift) and ($Shift[0]['StartTime'] == $Shift[0]['EndTime'])) {
                    $Poyaday = Holydays::model()->findByAttributes(array('Date' => $Date, 'Is_Poyaday' => "POYADAY"));
                    $Amountforepf = !empty($Poyaday) ? $employeesalary->DalySalary * 1.5 : $employeesalary->DalySalary;
                    $ConTractFee = $employeesalary->DalySalary;
                } else {
                    $Amount = $list2['SallaryRate'] - ($list2['LatedeductAmount'] + $list2['OutLateDeductAmount']);
                    $Amountforepf = $Amount > 0 ? $Amount : 0;
                    $ConTractFee = $employeesalary->DalySalary;
                }
                $Holiday = Yii::app()->db->createCommand("SELECT DISTINCT holydays.Date 
                FROM holydays
                WHERE holydays.Date ='" . $Date . "' AND( holydays.type ='GENERAL' OR holydays.siteId ='" . $list2['SiteId'] . "')")->queryAll();
                          
                if(!empty($Holiday)){
                    
                  $DayWge = $list2['PaymentMethod'] == "MONTHLY" ? $employeesalary->DalySalary :$list2['SallaryRate'];
                }
                else {  
                    
                    $DayWge = $list2['SallaryRate'];
                }
     
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $DayWge);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, Yii::app()->commonUtil->convertToHoursMins($list2['LatedeductTime']));
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $list2['LatedeductAmount']);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, Yii::app()->commonUtil->convertToHoursMins($list2['OutLateDeductTime']) );
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $list2['OutLateDeductAmount']);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $Amountforepf);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, Yii::app()->commonUtil->convertToHoursMins($list2['NOvertimeHours']));
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $list2['NOvertimeSalary']);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, Yii::app()->commonUtil->convertToHoursMins($list2['DOverTimeHour']));
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $list2['Dovertimesalary']);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, Yii::app()->commonUtil->convertToHoursMins($list2['PreOTHour']));
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $list2['PreOTAmount']);


                $Perday_Attendance = EmployeeIncentive::model()->findByAttributes(array('employee_id' => $list2['id'],'site_id'=>$list2['SiteId'], 'incentive_id' => 1, 'status' => 1));
                $PerDayIncentive = !empty($Perday_Attendance) ? $Perday_Attendance->incentive_amount : 0;
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $PerDayIncentive);

                $Perday_Lunch = EmployeeIncentive::model()->findByAttributes(array('employee_id' => $list2['id'],'site_id'=>$list2['SiteId'], 'incentive_id' => 2, 'status' => 1));
                $LunchIncentive = !empty($Perday_Lunch) ? $Perday_Lunch->incentive_amount : 0;
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $LunchIncentive);

                $NightShiftIncentive = 0;
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $NightShiftIncentive);

                $Employee = Employee::model()->findByAttributes(array('id' => $list2['id']));
                $travaling = EmployeeIncentive::model()->findByAttributes(array('employee_id' => $Employee->id,'site_id'=>$Employee->siteid, 'incentive_id' => 4, 'status' => 1));
                $JoinedDate = date_create($Employee->joindate);
                $StartDate = date_create($Date);
                $DateDiff = date_diff($JoinedDate, $StartDate);
                $NumberOfDay = $DateDiff->format("%R%a");
                $TravelingIncentive = 0;
                if (!empty($travaling) && $NumberOfDay > 365) {
                    $TravelingIncentive = $travaling->incentive_amount;
                }
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $TravelingIncentive);

                $accomondation = EmployeeIncentive::model()->findByAttributes(array('employee_id' => $list2['id'],'site_id'=>$list2['SiteId'], 'incentive_id' => 5, 'status' => 1));
                $AccomodationIncentive = !empty($accomondation) ? $accomondation->incentive_amount : 0;
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $AccomodationIncentive);

                $PerformanceIncentive = 0;
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $PerformanceIncentive);
                
                $Special_Incentive = EmployeeIncentive::model()->findByAttributes(array('employee_id' => $Employee->id,'site_id'=>$list2['SiteId'],'incentive_id' => 7, 'status' => 1));
                $SpecialIncentive = !empty($Special_Incentive) ? $Special_Incentive->incentive_amount : 0;
                
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $SpecialIncentive);
                $TripCommissionIncentive = 0;
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $TripCommissionIncentive);
                $BOIPassIncentive = 0;
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $BOIPassIncentive);

                $TotalIncentive = $PerDayIncentive + $LunchIncentive + $TravelingIncentive + $AccomodationIncentive;
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $TotalIncentive);

                $NetWge = ($list2['SallaryRate'] + $list2['NOvertimeSalary'] + $list2['Dovertimesalary'] + $list2['PreOTAmount'] + $TotalIncentive) - ( $list2['LatedeductAmount'] + $list2['OutLateDeductAmount']);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $NetWge);

                $EPf = 15 / 100 * $Amountforepf;

                $Contractfee = Employeecontractfee::model()->findByAttributes(array('employeeid' => $list2['id'],'site_id'=>$list2['SiteId'], 'status' => 1));
                $contractfeevalue = $Contractfee != null ? $Contractfee->contractfee : 0;
                $ContrctorFeeValue = ($contractfeevalue / 100) * $ConTractFee;

                $costtocompany = $NetWge + $EPf + $ContrctorFeeValue;

                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $EPf);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $ContrctorFeeValue);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $costtocompany);

                $PerformanceIncentiveMP += $PerformanceIncentive;
                $SpecialIncentiveMP += $SpecialIncentive;
                $TripCommissionIncentiveMP += $TripCommissionIncentive;
                $BOIPassIncentiveMP += $BOIPassIncentive;
                $NightShiftIncentiveMP += $NightShiftIncentive;
                $PerDayIncentiveMP += $PerDayIncentive;
                $LunchIncentiveMP += $LunchIncentive;
                $TravelingIncentiveMP += $TravelingIncentive;
                $AccomodationIncentiveMp += $AccomodationIncentive;
                $ContrctorFeeValueMP += $ContrctorFeeValue;
                $TotalForEpfMP += $Amountforepf;
                $TotalDayWageMP = $DayWge;

                $PerformanceIncentiveS += $PerformanceIncentive;
                $SpecialIncentiveS += $SpecialIncentive;
                $TripCommissionIncentiveS += $TripCommissionIncentive;
                $BOIPassIncentiveS += $BOIPassIncentive;
                $NightShiftIncentiveS += $NightShiftIncentive;
                $PerDayIncentiveS += $PerDayIncentive;
                $LunchIncentiveS += $LunchIncentive;
                $TravelingIncentiveS += $TravelingIncentive;
                $AccomodationIncentiveS += $AccomodationIncentive;
                $ContrctorFeeValueS += $ContrctorFeeValue;
                $TotalForEpfS += $Amountforepf;
                $TotalDayWageS += $DayWge;

                $row++;
            }
    
            $col4 = 5;
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(1, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(3, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(4, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(5, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(6, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(7, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(8, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(9, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(10, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(11, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(12, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(13, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(14, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(15, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(16, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(17, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(18, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(19, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(20, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(21, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(22, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(23, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(24, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(25, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(26, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(27, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(28, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(29, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(30, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));


            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1, $row, 'TOTAL OF MP SUPPLIER');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col4, $row, $TotalDayWageMP);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, Yii::app()->commonUtil->convertToHoursMins($list1['LatedeductTime']));
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $list1['LatedeductAmount']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, Yii::app()->commonUtil->convertToHoursMins($list1['OutLateDeductTime']));
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $list1['OutLatedeductAmount']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $TotalForEpfMP);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, Yii::app()->commonUtil->convertToHoursMins($list1['NOvertimeHours']));
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $list1['NOTAmount']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, Yii::app()->commonUtil->convertToHoursMins($list1['DOverTimeHour']));
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $list1['DOTAmount']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, Yii::app()->commonUtil->convertToHoursMins($list1['PreOTHour']));
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $list1['PreOTAmount']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $PerDayIncentiveMP);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $LunchIncentiveMP);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $NightShiftIncentiveMP);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $TravelingIncentiveMP);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $AccomodationIncentiveMp);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $PerformanceIncentiveMP);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $SpecialIncentiveMP);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $TripCommissionIncentiveMP);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $BOIPassIncentiveMP);

            $MPTotalIncentive = $PerDayIncentiveMP + $LunchIncentiveMP + $NightShiftIncentiveMP + $TravelingIncentiveMP + $AccomodationIncentiveMp + $PerformanceIncentiveMP + $SpecialIncentiveMP + $TripCommissionIncentiveMP + $BOIPassIncentiveMP;
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $MPTotalIncentive);


            $NetWge = ($list1['daywage'] + $list1['NOTAmount'] + $list1['DOTAmount'] + $list1['PreOTAmount'] + $MPTotalIncentive) - ( $list1['LatedeductAmount'] + $list1['OutLatedeductAmount']);

            $EPf = 15 / 100 * $TotalForEpfMP;
            $costtocompany = $NetWge + $EPf + $ContrctorFeeValueMP;

            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $NetWge);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $EPf);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $ContrctorFeeValueMP);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $costtocompany);

            $row++;
        }
        $col5 = 5;
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(1, $row)->applyFromArray(array('font' => array('size' => 11, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(3, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(4, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(5, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(6, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(7, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(8, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(9, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(10, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(11, $row)->applyFromArray(array('font' => array('size' => 11, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(12, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(13, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(14, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(15, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(16, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(17, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(18, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(19, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(20, $row)->applyFromArray(array('font' => array('size' => 11, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(21, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(22, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(23, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(24, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(25, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(26, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(27, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(28, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(29, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(30, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));



        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1, $row, 'TOTAL OF SITE');
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col5, $row, $TotalDayWageS);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, Yii::app()->commonUtil->convertToHoursMins($AllAmount[0]['LatedeductTime']));
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $AllAmount[0]['LatedeductAmount']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, Yii::app()->commonUtil->convertToHoursMins($AllAmount[0]['OutLateDeductTime']));
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $AllAmount[0]['OutLatedeductAmount']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $TotalForEpfS);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, Yii::app()->commonUtil->convertToHoursMins($AllAmount[0]['NOvertimeHours']));
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $AllAmount[0]['NOTAmount']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, Yii::app()->commonUtil->convertToHoursMins($AllAmount[0]['DOverTimeHour']));
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $AllAmount[0]['DOTAmount']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, Yii::app()->commonUtil->convertToHoursMins($AllAmount[0]['PreOTHour']));
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $AllAmount[0]['PreOTAmount']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $PerDayIncentiveS);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $LunchIncentiveS);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $NightShiftIncentiveS);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $TravelingIncentiveS);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $AccomodationIncentiveS);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $PerformanceIncentiveS);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $SpecialIncentiveS);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $TripCommissionIncentiveS);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $BOIPassIncentiveS);

        $SiteTotalIncentive = $PerDayIncentiveS + $LunchIncentiveS + $NightShiftIncentiveS + $TravelingIncentiveS + $AccomodationIncentiveS + $PerformanceIncentiveS + $SpecialIncentiveS + $TripCommissionIncentiveS + $BOIPassIncentiveS;
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $SiteTotalIncentive);

        $NetWge2 = ($AllAmount[0]['daywage'] + $AllAmount[0]['NOTAmount'] + $AllAmount[0]['DOTAmount'] + $AllAmount[0]['PreOTAmount'] + $SiteTotalIncentive) - ( $AllAmount[0]['LatedeductAmount'] + $AllAmount[0]['OutLatedeductAmount']);

        $EPf2 = 15 / 100 * $TotalForEpfS;

        $costtocompany2 = $NetWge2 + $EPf2 + $ContrctorFeeValueS;

        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $NetWge2);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $EPf2);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $ContrctorFeeValueS);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $costtocompany2);



        $row++;


        $objPHPExcel->getActiveSheet()->setTitle('YiiExcel');
        $filename = "Payroll Account Wise Report";
        header('Content-Type: application/vnd.ms-excel');
        header('Content-Disposition: attachment;filename="' . $filename . '.xls"');
        header('Cache-Control: max-age=0');

        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');

        $objWriter->save('php://output');
        unset($this->objWriter);
        unset($this->objWorksheet);
        unset($this->objReader);
        unset($this->objPHPExcel);
        exit();
    }

    public function actionDesignationWiseDailyCostReportExcel() {


        $objPHPExcel = new PHPExcel();
        $Account_List = CJSON::decode($_POST['AllList']);
        $AllAmount = CJSON::decode($_POST['AllAmount']);
        $Site = CJSON::decode($_POST['Site']);
        $Date = $_POST['Date'];
//         print_r($Account_List);
//          die;
//        if (!empty($Payroll)) {
//            $Site = Sites::model()->findByAttributes(array('id' => $Payroll['SiteId']));
//        }
        // Set document properties
//        print_r($Site['name']);
//        die;
        $objPHPExcel->getProperties()->setCreator("K'iin Balam")
                ->setLastModifiedBy("K'iin Balam")
                ->setTitle("YiiExcel Test Document")
                ->setSubject("YiiExcel Test Document")
                ->setDescription("Test document for YiiExcel, generated using PHP classes.")
                ->setKeywords("office PHPExcel php YiiExcel UPNFM")
                ->setCategory("Test result file");

        // Add some data
        $styleArray = array(
            'font' => array(
                'bold' => true,
                'color' => array('rgb' => '#f79727'),
                'size' => 10
        ));

        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, 1, 'DESIGNATION WISE DAILY COST REPORT ');
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, 2, 'DATE :');
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1, 2, $Date);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, 3, 'SITE :');
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1, 3, $Site['name']);

        $PerDayIncentiveS = 0;
        $LunchIncentiveS = 0;
        $NightShiftIncentiveS = 0;
        $TravelingIncentiveS = 0;
        $AccomodationIncentiveS = 0;
        $PerformanceIncentiveS = 0;
        $SpecialIncentiveS = 0;
        $TripCommissionIncentiveS = 0;
        $BOIPassIncentiveS = 0;
        $ContrctorFeeValueS = 0;
        $TotalForEpfS = 0;
        $TotalDayWageS = 0;


        $row = 6;

        foreach ($Account_List as $list1) {
            $col2 = 1;

            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, ++$row, 'DESIGNATION :');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col2, $row, $list1['type']);
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(0, $row)->applyFromArray(array('font' => array('size' => 11, 'bold' => true, 'color' => array('rgb' => '000000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(1, $row)->applyFromArray(array('font' => array('size' => 11, 'bold' => true, 'color' => array('rgb' => '0000ff'))));
            $row++;
            $col1 = 1;

            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, $row, 'Employee Name');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col1, $row, 'NIC');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Department');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Account');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'net wage');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'In Late Hour');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'In Late Deduct');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Out Late Hour');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Out Late Deduct');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Total For EPF');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'N-OT Hour');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'N-OT Amount');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'D-OT Hour');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'D-OT Amount');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'pre-OT Hour');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Pre-OT Amount');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Attendance Incentive');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Lunch Incentive');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Night Shift Incentive');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Traveling Incentive');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Accomondation Incentive');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Performance Incentive');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Special Incentive');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Trip Commission Incentive');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'BOI Pass Incentive');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Total Incentive');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Total Net');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'EPF\ETF');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Contract Fee');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow( ++$col1, $row, 'Cost To Company');

            $PerformanceIncentiveMP = 0;
            $SpecialIncentiveMP = 0;
            $TripCommissionIncentiveMP = 0;
            $BOIPassIncentiveMP = 0;
            $NightShiftIncentiveMP = 0;
            $PerDayIncentiveMP = 0;
            $LunchIncentiveMP = 0;
            $TravelingIncentiveMP = 0;
            $AccomodationIncentiveMp = 0;
            $ContrctorFeeValueMP = 0;
            $TotalForEpfMP = 0;
            $TotalDayWageMP = 0;


            $row++;

            foreach ($list1[0] as $list2) {

                $col = 1;

                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, $row, $list2['Namewithini']);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col, $row, $list2['nic']);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $list2['DepartmentName']);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $list2['AccountName']);
                                $Shift = Yii::app()->db->createCommand("SELECT shift.id,shift.StartTime,shift.EndTime,employee_shift.id AS employeeshift
                        FROM employee_shift
                        INNER JOIN shift ON employee_shift.ShiftId = shift.id
                        WHERE employee_shift.id = '" . $list2['EmployeeShiftid'] . "'")->queryAll();


                $employeesalary = Employeesalary::model()->findByAttributes(array('employeeid' => $list2['id'], 'Status' => 1));
                if (empty($employeesalary)) {
                    $employeesalary = new Employeesalary;
                    $employeesalary->monthsalary = 0;
                    $employeesalary->DalySalary = 0;
                    $employeesalary->HourlyRate = 0;
                    $employeesalary->OTRate = 0;
                    $employeesalary->DoubleOTRate = 0;
                    $employeesalary->BasicSalary = 0;
                    $employeesalary->BRA1 = 0;
                    $employeesalary->BRA2 = 0;
                    $employeesalary->BRA3 = 0;
                }

                if (!empty($Shift) and ($Shift[0]['StartTime'] == $Shift[0]['EndTime'])) {
                    $Poyaday = Holydays::model()->findByAttributes(array('Date' => $Date, 'Is_Poyaday' => "POYADAY"));
                    $Amountforepf = !empty($Poyaday) ? $employeesalary->DalySalary * 1.5 : $employeesalary->DalySalary;
                    $ConTractFee = $employeesalary->DalySalary;
                } else {
                    $Amount = $list2['SallaryRate'] - ($list2['LatedeductAmount'] + $list2['OutLateDeductAmount']);
                    $Amountforepf = $Amount > 0 ? $Amount : 0;
                    $ConTractFee = $employeesalary->DalySalary;
                }
                $Holiday = Yii::app()->db->createCommand("SELECT DISTINCT holydays.Date 
                FROM holydays
                WHERE holydays.Date ='" . $Date . "' AND( holydays.type ='GENERAL' OR holydays.siteId ='" . $list2['SiteId'] . "')")->queryAll();
                          
                if(!empty($Holiday)){
                    
                  $DayWge = $list2['PaymentMethod'] == "MONTHLY" ? $employeesalary->DalySalary :$list2['SallaryRate'];
                }
                else {  
                    
                    $DayWge = $list2['SallaryRate'];
                }
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $DayWge);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, Yii::app()->commonUtil->convertToHoursMins($list2['LatedeductTime']));
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $list2['LatedeductAmount']);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, Yii::app()->commonUtil->convertToHoursMins($list2['OutLateDeductTime']));
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $list2['OutLateDeductAmount']);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $Amountforepf);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, Yii::app()->commonUtil->convertToHoursMins($list2['NOvertimeHours']));
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $list2['NOvertimeSalary']);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, Yii::app()->commonUtil->convertToHoursMins($list2['DOverTimeHour']));
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $list2['Dovertimesalary']);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, Yii::app()->commonUtil->convertToHoursMins($list2['PreOTHour']));
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $list2['PreOTAmount']);


                $Perday_Attendance = EmployeeIncentive::model()->findByAttributes(array('employee_id' => $list2['id'], 'incentive_id' => 1, 'status' => 1));
                $PerDayIncentive = !empty($Perday_Attendance) ? $Perday_Attendance->incentive_amount : 0;
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $PerDayIncentive);

                $Perday_Lunch = EmployeeIncentive::model()->findByAttributes(array('employee_id' => $list2['id'], 'incentive_id' => 2, 'status' => 1));
                $LunchIncentive = !empty($Perday_Lunch) ? $Perday_Lunch->incentive_amount : 0;
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $LunchIncentive);

                $NightShiftIncentive = 0;
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $NightShiftIncentive);

                $Employee = Employee::model()->findByAttributes(array('id' => $list2['id']));
                $travaling = EmployeeIncentive::model()->findByAttributes(array('employee_id' => $Employee->id, 'incentive_id' => 4, 'status' => 1));
                $JoinedDate = date_create($Employee->joindate);
                $StartDate = date_create($Date);
                $DateDiff = date_diff($JoinedDate, $StartDate);
                $NumberOfDay = $DateDiff->format("%R%a");
                $TravelingIncentive = 0;
                if (!empty($travaling) && $NumberOfDay > 365) {
                    $TravelingIncentive = $travaling->incentive_amount;
                }
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $TravelingIncentive);

                $accomondation = EmployeeIncentive::model()->findByAttributes(array('employee_id' => $list2['id'], 'incentive_id' => 5, 'status' => 1));
                $AccomodationIncentive = !empty($accomondation) ? $accomondation->incentive_amount : 0;
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $AccomodationIncentive);

                $PerformanceIncentive = 0;
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $PerformanceIncentive);
                
                $Special_Incentive = EmployeeIncentive::model()->findByAttributes(array('employee_id' => $Employee->id,'incentive_id' => 7, 'status' => 1));
                $SpecialIncentive = !empty($Special_Incentive) ? $Special_Incentive->incentive_amount : 0;
                
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $SpecialIncentive);
                $TripCommissionIncentive = 0;
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $TripCommissionIncentive);
                $BOIPassIncentive = 0;
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $BOIPassIncentive);

                $TotalIncentive = $PerDayIncentive + $LunchIncentive + $TravelingIncentive + $AccomodationIncentive;
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $TotalIncentive);

                $NetWge = ($list2['SallaryRate'] + $list2['NOvertimeSalary'] + $list2['Dovertimesalary'] + $list2['PreOTAmount'] + $TotalIncentive) - ( $list2['LatedeductAmount'] + $list2['OutLateDeductAmount']);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $NetWge);

                $EPf = 15 / 100 * $Amountforepf;

                $Contractfee = Employeecontractfee::model()->findByAttributes(array('employeeid' => $list2['id'], 'status' => 1));
                $contractfeevalue = $Contractfee != null ? $Contractfee->contractfee : 0;
                $ContrctorFeeValue = ($contractfeevalue / 100) * $list2['SallaryRate'];

                $costtocompany = $NetWge + $EPf + $ContrctorFeeValue;

                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $EPf);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $ContrctorFeeValue);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col, $row, $costtocompany);

                $PerformanceIncentiveMP += $PerformanceIncentive;
                $SpecialIncentiveMP += $SpecialIncentive;
                $TripCommissionIncentiveMP += $TripCommissionIncentive;
                $BOIPassIncentiveMP += $BOIPassIncentive;
                $NightShiftIncentiveMP += $NightShiftIncentive;
                $PerDayIncentiveMP += $PerDayIncentive;
                $LunchIncentiveMP += $LunchIncentive;
                $TravelingIncentiveMP += $TravelingIncentive;
                $AccomodationIncentiveMp += $AccomodationIncentive;
                $ContrctorFeeValueMP += $ContrctorFeeValue;
                $TotalForEpfMP += $Amountforepf;
                $TotalDayWageMP += $DayWge;

                $PerformanceIncentiveS += $PerformanceIncentive;
                $SpecialIncentiveS += $SpecialIncentive;
                $TripCommissionIncentiveS += $TripCommissionIncentive;
                $BOIPassIncentiveS += $BOIPassIncentive;
                $NightShiftIncentiveS += $NightShiftIncentive;
                $PerDayIncentiveS += $PerDayIncentive;
                $LunchIncentiveS += $LunchIncentive;
                $TravelingIncentiveS += $TravelingIncentive;
                $AccomodationIncentiveS += $AccomodationIncentive;
                $ContrctorFeeValueS += $ContrctorFeeValue;
                $TotalForEpfS += $Amountforepf;
                $TotalDayWageS += $DayWge;


                $row++;
            }
            $col4 = 4;
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(0, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(2, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(3, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(4, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(5, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(6, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(7, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(8, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(9, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(10, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(11, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(12, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(13, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(14, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(15, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(16, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(17, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(18, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(19, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(20, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(21, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(22, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(23, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(24, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(25, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(26, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(27, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(28, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(29, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => 'ff0000'))));

            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, $row, 'TOTAL OF DESIGNATION');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col4, $row,$TotalDayWageMP);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, Yii::app()->commonUtil->convertToHoursMins($list1['LatedeductTime']));
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $list1['LatedeductAmount']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, Yii::app()->commonUtil->convertToHoursMins($list1['OutLateDeductTime']));
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $list1['OutLatedeductAmount']);

            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $TotalForEpfMP);

            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, Yii::app()->commonUtil->convertToHoursMins($list1['NOvertimeHours']));
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $list1['NOTAmount']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, Yii::app()->commonUtil->convertToHoursMins($list1['DOverTimeHour']));
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $list1['DOTAmount']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, Yii::app()->commonUtil->convertToHoursMins($list1['PreOTHour']));
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $list1['PreOTAmount']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $PerDayIncentiveMP);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $LunchIncentiveMP);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $NightShiftIncentiveMP);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $TravelingIncentiveMP);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $AccomodationIncentiveMp);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $PerformanceIncentiveMP);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $SpecialIncentiveMP);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $TripCommissionIncentiveMP);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $BOIPassIncentiveMP);

            $MPTotalIncentive = $PerDayIncentiveMP + $LunchIncentiveMP + $NightShiftIncentiveMP + $TravelingIncentiveMP + $AccomodationIncentiveMp + $PerformanceIncentiveMP + $SpecialIncentiveMP + $TripCommissionIncentiveMP + $BOIPassIncentiveMP;
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $MPTotalIncentive);

            $NetWge = ($list1['daywage'] + $list1['NOTAmount'] + $list1['DOTAmount'] + $list1['PreOTAmount'] + $MPTotalIncentive) - ( $list1['LatedeductAmount'] + $list1['OutLatedeductAmount']);

            $EPf = 15 / 100 * $TotalForEpfMP;
            $costtocompany = $NetWge + $EPf + $ContrctorFeeValueMP;

            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $NetWge);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $EPf);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $ContrctorFeeValueMP);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col4, $row, $costtocompany);

            $row++;
        }
        $col5 = 4;
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(0, $row)->applyFromArray(array('font' => array('size' => 11, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(2, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(3, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(4, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(5, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(6, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(7, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(8, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(9, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(10, $row)->applyFromArray(array('font' => array('size' => 11, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(11, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(12, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(13, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(14, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(15, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(16, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(17, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(18, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(19, $row)->applyFromArray(array('font' => array('size' => 11, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(20, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(21, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(22, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(23, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(24, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(25, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(26, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(27, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(28, $row)->applyFromArray(array('font' => array('size' => 11, 'bold' => true, 'color' => array('rgb' => '990000'))));
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(29, $row)->applyFromArray(array('font' => array('size' => 10, 'bold' => true, 'color' => array('rgb' => '990000'))));


        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1, $row, 'TOTAL OF SITE');
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col5, $row, $TotalDayWageS);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, Yii::app()->commonUtil->convertToHoursMins($AllAmount[0]['LatedeductTime']));
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $AllAmount[0]['LatedeductAmount']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, Yii::app()->commonUtil->convertToHoursMins($AllAmount[0]['OutLateDeductTime']));
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $AllAmount[0]['OutLatedeductAmount']);

        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $TotalForEpfS);

        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, Yii::app()->commonUtil->convertToHoursMins($AllAmount[0]['NOvertimeHours']));
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $AllAmount[0]['NOTAmount']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, Yii::app()->commonUtil->convertToHoursMins($AllAmount[0]['DOverTimeHour']));
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $AllAmount[0]['DOTAmount']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, Yii::app()->commonUtil->convertToHoursMins($AllAmount[0]['PreOTHour']));
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $AllAmount[0]['PreOTAmount']);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $PerDayIncentiveS);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $LunchIncentiveS);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $NightShiftIncentiveS);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $TravelingIncentiveS);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $AccomodationIncentiveS);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $PerformanceIncentiveS);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $SpecialIncentiveS);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $TripCommissionIncentiveS);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $BOIPassIncentiveS);

        $SiteTotalIncentive = $PerDayIncentiveS + $LunchIncentiveS + $NightShiftIncentiveS + $TravelingIncentiveS + $AccomodationIncentiveS + $PerformanceIncentiveS + $SpecialIncentiveS + $TripCommissionIncentiveS + $BOIPassIncentiveS;
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $SiteTotalIncentive);


        $NetWge2 = ($AllAmount[0]['daywage'] + $AllAmount[0]['NOTAmount'] + $AllAmount[0]['DOTAmount'] + $AllAmount[0]['PreOTAmount'] + $SiteTotalIncentive) - ( $AllAmount[0]['LatedeductAmount'] + $AllAmount[0]['OutLatedeductAmount']);

        $EPf2 = 15 / 100 * $TotalForEpfMP;

        $costtocompany2 = $NetWge2 + $EPf2 + $ContrctorFeeValueS;

        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $NetWge2);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $EPf2);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $ContrctorFeeValueS);
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col5, $row, $costtocompany2);


        $row++;


        $objPHPExcel->getActiveSheet()->setTitle('YiiExcel');
        $filename = "Payroll Account Wise Report";
        header('Content-Type: application/vnd.ms-excel');
        header('Content-Disposition: attachment;filename="' . $filename . '.xls"');
        header('Cache-Control: max-age=0');

        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');

        $objWriter->save('php://output');
        unset($this->objWriter);
        unset($this->objWorksheet);
        unset($this->objReader);
        unset($this->objPHPExcel);
        exit();
    }

    public function actionAdhocTimelog(){
        $model = new AttendaceRange;
        
        if(isset($_POST['AttendaceRange'])){
            $model->attributes = $_POST['AttendaceRange'];


            if($model->validate()){
                if(Yii::app()->user->isAdmin()){
                    $list= Yii::app()->db->createCommand("SELECT AE.*,AT.*
                    FROM adhoc_cadre_timelog as AT
                    INNER JOIN adhoc_cadre_employees AE ON AE.id = AT.adhoc_employee_id
                    WHERE date(AT.in_time) >= '".$model->startDate."' AND date(AT.in_time) <= '".$model->endDate."'")->queryAll();
                }else{
                    $siteId = Yii::app()->user->data()->SiteId;
                    $list= Yii::app()->db->createCommand("SELECT AE.*,AT.*
                    FROM adhoc_cadre_timelog as AT
                    INNER JOIN adhoc_cadre_employees AE ON AE.id = AT.adhoc_employee_id
                    WHERE AE.site_id = $siteId AND date(AT.in_time) >= '".$model->startDate."' AND date(AT.in_time) <= '".$model->endDate."'")->queryAll();
                }

                // print_r($list);die;
                $this->render('//adhocCadreTimelog/viewTimelogReport',array('attendanceRanges'=>$list,'model'=>$model));
            }

        }else{
            return $this->render('//adhocCadreTimelog/createTimelogReport',array('model'=>$model));
        }
    }
    public function actionAdhocTimelogPDF()
{

    $attendanceRanges = CJSON::decode($_POST['attendanceRanges']);
    $model = CJSON::decode($_POST['model']);
    
    $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
    $mPDF1->setAutoBottomMargin = 'stretch';
    $mPDF1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
    $mPDF1->WriteHTML($this->renderPartial('//adhocCadreTimelog/timelogPDF',array('attendanceRanges'=>$attendanceRanges,'model'=>$model),true));
    $file_name= $model['startDate'].'-'.$model['endDate'].'Created On'.date("Y-m-d  -  h:i:sa").'.pdf';


    ob_end_clean();
    $mPDF1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );
}

//=========================================================================        
    public function actionAdhocTimelogExcel(){
        $objPHPExcel = new PHPExcel();
        $list = CJSON::decode($_POST['list']);
        $model = CJSON::decode($_POST['model']);

        // print_r($list);
        // die;

        $objPHPExcel->setActiveSheetIndex(0)
        ->setCellValue('A1','Adhoc Employees Timelog')
        ->setCellValue('E1', 'Generated On')
        ->setCellValue('F1', date("Y-m-d - h:i:sa"))
        ->setCellValue('A2', 'NAME')
        ->setCellValue('B2', 'NIC')
        ->setCellValue('C2', 'CURRENT ADDRESS')
        ->setCellValue('D2', 'PERMANENT ADDRESS')        
        ->setCellValue('E2', 'DEPARTMENT')
        ->setCellValue('F2', 'MP SUPPLIER')
        ->setCellValue('G2', 'IN TIME')
        ->setCellValue('H2', 'OUT TIME')
        ->setCellValue('I2', 'IN LATE HRS')
        ->setCellValue('J2', 'IN LATE DEDUCTION')
        ->setCellValue('K2', 'OUT LATE HRS')
        ->setCellValue('L2', 'OUT LATE DEDUCTION')
        ->setCellValue('M2', 'N OT HRS')
        ->setCellValue('N2', 'N OT COST')
        ->setCellValue('O2', 'D OT HRS')
        ->setCellValue('P2', 'D OT COST')
        ->setCellValue('Q2', 'BASIC DAY WAGE')
        ->setCellValue('R2', 'BRA1')
        ->setCellValue('S2', 'BRA2')
        ->setCellValue('T2', 'BRA3')
        ->setCellValue('U2', 'TRANSPORT')
        ->setCellValue('V2', 'PER DAY INCENTIVE')
        ->setCellValue('W2', 'NIGHT SHIFT INCENTIVE')
        ->setCellValue('X2', 'MEAL')
        ->setCellValue('Y2', 'CONT FEE')
        ->setCellValue('Z2', 'EPF')
        ->setCellValue('AA2', 'ETF')
        ->setCellValue('AB2', 'COST TO COMPANY')
        ;

        $col = 3;


        for($i = 0;$i < count($list);$i++){
            $row = 0;
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$col,$list[$i]['full_name']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['nic']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['current_address']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['permanent_address']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['department']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['supplier']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['in_time']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['out_time']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['in_late_hrs']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['in_late_deduction']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['out_late_hrs']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['out_late_deduction']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['N_OT_hrs']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['N_OT_cost']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['D_OT_hrs']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['D_OT_cost']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['basic_day_wage']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['BRA1']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['BRA2']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['BRA3']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['transport']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['per_day_incentive']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['night_shift_incentive']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['meal']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['cont_Fee']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['EPF']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['ETF']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['cost_to_company']);
        
            $col++;

        }
        $styleArray = array(
            'font'  => array(
                'bold'  => true,
                'color' => array('rgb' => '#f79727'),
                'size'  => 10
            ));
        $objPHPExcel->getActiveSheet()->getStyle('A1:AB2')->applyFromArray($styleArray);

        //$objPHPExcel->getActiveSheet()->setTitle('sffd');

        $objPHPExcel->setActiveSheetIndex(0);

        ob_end_clean();
        ob_start();

        header('Content-Type: application/vnd.ms-excel');
        header('Content-Disposition: attachment;filename='.$model['startDate'].' to '.$model['endDate'].'.xls');
        header('Cache-Control: max-age=0');
        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
        $objWriter->save('php://output');
    }

    public function actionNonAllocatedEmployeesReport(){
        
        $model = new PresentEmployee;
        if(isset($_POST['PresentEmployee'])){
        $model->attributes = $_POST['PresentEmployee'];//'".$model->certainDate."'

        if($model->validate()){ 
            if(isset($_POST['accounts'])){
                $list = Yii::app()->db->createCommand("SELECT E.Namewithini,E.nic,D.type designation,A.id clientId,A.name accountname,A.AccountOracleCode,DP.name department,S.name site,SP.name supplier,I.PunchTime AS  punchIn,IFNULL(O.PunchTime,'0000-00-00 00:00:00') as punchOut
                    FROM (SELECT T.Employeeid,MIN(T.PunchTime) as PunchTime from timelog T WHERE date(T.PunchTime) = '".$model->certainDate."' AND T.Type = 'IN' GROUP BY T.Employeeid) as I
                    LEFT JOIN (SELECT T.Employeeid,MAX(T.PunchTime) as PunchTime from timelog T WHERE date(T.PunchTime) = '".$model->certainDate."' AND T.Type = 'OUT' GROUP BY T.Employeeid) as O ON I.Employeeid = O.Employeeid
                    INNER JOIN employee E ON E.id = I.Employeeid
                    INNER JOIN accounts A ON A.id = E.Accountid
                    INNER JOIN designation D ON D.id = E.designationid
                    INNER JOIN sites S ON S.id = E.siteid
                    INNER JOIN supplier SP ON SP.id = E.supplierid
                    INNER JOIN department DP ON DP.id = E.departmentid
                    WHERE E.statusId = 1 And E.accountId  IN (".implode(',',$_POST['accounts']).") AND I.Employeeid NOT IN (SELECT E.id
                                                FROM employee_shift ES 
                                                INNER JOIN employee E ON E.id = ES.EmployeeId
                                                WHERE E.statusId = 1 AND ES.ShiftId IN (SELECT SF.id 
                                                        FROM schedule SCH
                                                        INNER JOIN shift SF ON SF.schedulid = SCH.id
                                                        WHERE SCH.Date = '".$model->certainDate."'))")->queryAll();
            }else{
                if(Yii::app()->user->isAdmin()){
                    $list = Yii::app()->db->createCommand("SELECT E.Namewithini,E.nic,D.type designation,A.id clientId,A.name accountname,A.AccountOracleCode,DP.name department,S.name site,SP.name supplier,I.PunchTime AS  punchIn,IFNULL(O.PunchTime,'0000-00-00 00:00:00') as punchOut
                        FROM (SELECT T.Employeeid,MIN(T.PunchTime) as PunchTime from timelog T WHERE date(T.PunchTime) = '".$model->certainDate."' AND T.Type = 'IN' GROUP BY T.Employeeid) as I
                        LEFT JOIN (SELECT T.Employeeid,MAX(T.PunchTime) as PunchTime from timelog T WHERE date(T.PunchTime) = '".$model->certainDate."' AND T.Type = 'OUT' GROUP BY T.Employeeid) as O ON I.Employeeid = O.Employeeid
                        INNER JOIN employee E ON E.id = I.Employeeid
                        INNER JOIN accounts A ON A.id = E.Accountid
                        INNER JOIN designation D ON D.id = E.designationid
                        INNER JOIN sites S ON S.id = E.siteid
                        INNER JOIN supplier SP ON SP.id = E.supplierid
                        INNER JOIN department DP ON DP.id = E.departmentid
                        WHERE E.statusId = 1 AND I.Employeeid NOT IN (SELECT E.id
                                                    FROM employee_shift ES 
                                                    INNER JOIN employee E ON E.id = ES.EmployeeId
                                                    WHERE E.statusId = 1 AND ES.ShiftId IN (SELECT SF.id 
                                                            FROM schedule SCH
                                                            INNER JOIN shift SF ON SF.schedulid = SCH.id
                                                            WHERE SCH.Date = '".$model->certainDate."'))")->queryAll();
                }else{
                    $sitid = Yii::app()->user->data()->SiteId;
                    $list = Yii::app()->db->createCommand("SELECT E.Namewithini,E.nic,D.type designation,A.id clientId,A.name accountname,A.AccountOracleCode,DP.name department,S.name site,SP.name supplier,I.PunchTime AS  punchIn,IFNULL(O.PunchTime,'0000-00-00 00:00:00') as punchOut
                        FROM (SELECT T.Employeeid,MIN(T.PunchTime) as PunchTime from timelog T WHERE date(T.PunchTime) = '".$model->certainDate."' AND T.Type = 'IN' GROUP BY T.Employeeid) as I
                        LEFT JOIN (SELECT T.Employeeid,MAX(T.PunchTime) as PunchTime from timelog T WHERE date(T.PunchTime) = '".$model->certainDate."' AND T.Type = 'OUT' GROUP BY T.Employeeid) as O ON I.Employeeid = O.Employeeid
                        INNER JOIN employee E ON E.id = I.Employeeid
                        INNER JOIN accounts A ON A.id = E.Accountid
                        INNER JOIN designation D ON D.id = E.designationid
                        INNER JOIN sites S ON S.id = E.siteid
                        INNER JOIN supplier SP ON SP.id = E.supplierid
                        INNER JOIN department DP ON DP.id = E.departmentid
                        WHERE E.statusId = 1 AND E.siteid = $sitid AND I.Employeeid NOT IN (SELECT E.id
                                                    FROM employee_shift ES 
                                                    INNER JOIN employee E ON E.id = ES.EmployeeId
                                                    WHERE E.statusId = 1 AND ES.ShiftId IN (SELECT SF.id 
                                                            FROM schedule SCH
                                                            INNER JOIN shift SF ON SF.schedulid = SCH.id
                                                            WHERE SCH.Date = '".$model->certainDate."'))")->queryAll();

                }
            }
            // print_r($list);die;

            $this->render('//timelog/viewNonAllocatedEmployeeReport',array('list'=>$list,'model'=>$model));

        }

        }else{
            return $this->render('//timelog/createNonAllocatedEmployeeReport',array('model'=>$model));
        }
    }
    public function actionNonAllocatedEmployeesReportPDF(){
        $list = CJSON::decode($_POST['list']);
        $model = CJSON::decode($_POST['model']);
        
        $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
        $mPDF1->setAutoBottomMargin = 'stretch';
        $mPDF1->SetFooter('Report generated by '.Yii::app()->user->name.'<br> Powered By Eimsky Business Solutions Pvt Ltd <br> Page {PAGENO} of {nb}');
        $mPDF1->WriteHTML($this->renderPartial('//timelog/nonAllocatedEmployeeReportPDF',array('list'=>$list,'model'=>$model,'site'=>$site),true));
        $file_name= $model['certainDate'].'non-allocated report.pdf';

        ob_end_clean();
        $mPDF1->Output($file_name,EYiiPdf::OUTPUT_TO_DOWNLOAD );
    }
    public function actionNonAllocatedEmployeesReportExcel(){
        $objPHPExcel = new PHPExcel();
        $list = CJSON::decode($_POST['list']);
        $model = CJSON::decode($_POST['model']);
    
        // print_r($list);
        // die;
    
        $objPHPExcel->setActiveSheetIndex(0)
        ->setCellValue('A1', 'Non-Allocated Employees Report')
        ->setCellValue('E1', 'Generated On')
        ->setCellValue('F1', date("Y-m-d - h:i:sa"))
    
        ->setCellValue('A3', 'Name')
        ->setCellValue('B3', 'NIC')
        ->setCellValue('C3', 'Designation')
        ->setCellValue('D3', 'Client Code')
        ->setCellValue('E3', 'Client Name')
        ->setCellValue('F3', 'Acnt Oracle Code')
        ->setCellValue('G3', 'Department')
        ->setCellValue('H3', 'Site')
        ->setCellValue('I3', 'MP Supplier') 
        ->setCellValue('J3', 'Date') 
        ->setCellValue('K3', 'In Time') 
        ->setCellValue('L3', 'Out Time') ;
        $col = 4;
    
    
        for($i = 0;$i < count($list);$i++){

            $row = 0;

            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$col,$list[$i]['Namewithini']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['nic']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['designation']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['clientId']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['accountname']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['AccountOracleCode']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['department']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['site']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$list[$i]['supplier']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col, date('Y-m-d',strtotime($list[$i]['punchIn'])));
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,date('H:i:m',strtotime($list[$i]['punchIn'])));
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,date('H:i:m',strtotime($list[$i]['punchOut'])));
    
    
            $col++;
    
        }
        $styleArray = array(
            'font'  => array(
                'bold'  => true,
                'color' => array('rgb' => '#f79727'),
                'size'  => 10
            ));
        $objPHPExcel->getActiveSheet()->getStyle('A1:L3')->applyFromArray($styleArray);
    
        //$objPHPExcel->getActiveSheet()->setTitle('sffd');
    
        $objPHPExcel->setActiveSheetIndex(0);
    
        ob_end_clean();
        ob_start();
    
        header('Content-Type: application/vnd.ms-excel');
        header('Content-Disposition: attachment;filename='.$model['certainDate'].'-Non-allocated report.xls');
        header('Cache-Control: max-age=0');
        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
        $objWriter->save('php://output');
    }

    public function actionPieceDetails(){
        $model = new EmployeeAllAttendance;
        if(isset($_POST['EmployeeAllAttendance'])){
            $model->attributes = $_POST['EmployeeAllAttendance'];
            // print_r(CJSON::encode($model));die;
            if($model->employee == 'All'){
                $sitid = Yii::app()->user->data()->SiteId;
                $list= Yii::app()->db->createCommand("SELECT D.selected_date,P.pieceType sku,P.Employee,sku.id as sku_name,sku.name as sku_code,sku.description,P.numberofpices
                FROM (select * from
                (select adddate('1970-01-01',t4.i*10000 + t3.i*1000 + t2.i*100 + t1.i*10 + t0.i) selected_date from
                (select 0 i union select 1 union select 2 union select 3 union select 4 union select 5 union select 6 union select 7 union select 8 union select 9) t0,
                (select 0 i union select 1 union select 2 union select 3 union select 4 union select 5 union select 6 union select 7 union select 8 union select 9) t1,
                (select 0 i union select 1 union select 2 union select 3 union select 4 union select 5 union select 6 union select 7 union select 8 union select 9) t2,
                (select 0 i union select 1 union select 2 union select 3 union select 4 union select 5 union select 6 union select 7 union select 8 union select 9) t3,
                (select 0 i union select 1 union select 2 union select 3 union select 4 union select 5 union select 6 union select 7 union select 8 union select 9) t4) v
                where selected_date between DATE('$model->startDate') and DATE('$model->endDate') ) as D
                LEFT JOIN (SELECT * FROM  pieces_datails WHERE pieces_datails.Date >= DATE('$model->startDate') AND pieces_datails.Date <= DATE('$model->endDate') AND pieces_datails.Employee IN(SELECT id FROM employee WHERE siteId = $sitid AND statusId = 1) ) P on D.selected_date = P.Date
                LEFT JOIN sku ON sku.id = P.pieceType
                HAVING Employee IS NOT NULL")->queryAll();
            }else{
                $list= Yii::app()->db->createCommand("SELECT D.selected_date,P.pieceType sku,P.Employee,sku.id as sku_name,sku.name as sku_code,sku.description,P.numberofpices
                FROM (select * from
                (select adddate('1970-01-01',t4.i*10000 + t3.i*1000 + t2.i*100 + t1.i*10 + t0.i) selected_date from
                (select 0 i union select 1 union select 2 union select 3 union select 4 union select 5 union select 6 union select 7 union select 8 union select 9) t0,
                (select 0 i union select 1 union select 2 union select 3 union select 4 union select 5 union select 6 union select 7 union select 8 union select 9) t1,
                (select 0 i union select 1 union select 2 union select 3 union select 4 union select 5 union select 6 union select 7 union select 8 union select 9) t2,
                (select 0 i union select 1 union select 2 union select 3 union select 4 union select 5 union select 6 union select 7 union select 8 union select 9) t3,
                (select 0 i union select 1 union select 2 union select 3 union select 4 union select 5 union select 6 union select 7 union select 8 union select 9) t4) v
                where selected_date between DATE('$model->startDate') and DATE('$model->endDate') ) as D
                LEFT JOIN (SELECT * FROM  pieces_datails WHERE pieces_datails.Date >= DATE('$model->startDate') AND pieces_datails.Date <= DATE('$model->endDate') AND pieces_datails.Employee = $model->employee ) P on D.selected_date = P.Date
                LEFT JOIN sku ON sku.id = P.pieceType
                HAVING Employee IS NOT NULL")->queryAll();

            }

            $out1 = array();
            foreach ($list as $key => $value){
                if (array_key_exists($value['Employee'], $out1)){

                    if (array_key_exists($value['sku_name'], $out1[$value['Employee']]['sku'])){
                    
                        $out1[$value['Employee']]['sku'][$value['sku_name']]['totalq'] += $value['numberofpices'];

                        if(array_key_exists($value['selected_date'],$out1[$value['Employee']]['sku'][$value['sku_name']])){
                            $out1[$value['Employee']]['sku'][$value['sku_name']][$value['selected_date']] += $value['numberofpices']; 
                        }else{
                            $out1[$value['Employee']]['sku'][$value['sku_name']][$value['selected_date']] = $value['numberofpices'];
                            
                        }
                    }else{
                        $out1[$value['Employee']]['sku'][$value['sku_name']] = [$value['selected_date'] => $value['numberofpices'],'totalq' => $value['numberofpices']];
                    }
                    
                } else {
                    $out1[$value['Employee']] = array('Employee' => $value['Employee'], 'sku'=>[$value['sku_name'] => [$value['selected_date'] => $value['numberofpices'],'totalq' => $value['numberofpices']]]);
                    
                }
            }
            $out1 = array_values($out1);
            // print_r(CJSON::encode($out1));
            // die;

            function toDate($x){
                return date('Y-m-d', $x);
            }
            $dates = range(strtotime($model->startDate), strtotime($model->endDate),86400);
            $range_of_dates = array_map('toDate',$dates);

            $this->render('//piecesDatails/viewPieceDetailsReport',array('model'=>$model,'rangeOfDates'=>$range_of_dates,'list'=>$out1));

        }else{
            $this->render('//piecesDatails/createPieceDetailsReport',array('model'=>$model));
        }
    }

    public function actionPieceDetailsExcel(){
        $list = CJSON::decode($_POST['list']);
        $rangeOfDates = CJSON::decode($_POST['rangeOfDates']);

        $objPHPExcel = new PHPExcel();
        $headingColumn = 0;
        $headingRow = 2;
        
            
        //=================================Report Name==============
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1,1,'PIECE DETAILS TRACKING REPORT');

        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($headingColumn,$headingRow,'NIC');
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($headingColumn, $headingRow)->applyFromArray(array('alignment' => array(
            'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER),'fill' => array(
            'type' => PHPExcel_Style_Fill::FILL_SOLID,'color' => array('rgb' => '2f75b5')),'borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40'))),'font' => array('size' => 11 ,'bold' => true, 'color' => array('rgb' => 'ffffff'))));
        
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$headingColumn,$headingRow,'NAME');
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($headingColumn, $headingRow)->applyFromArray(array('alignment' => array(
            'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER),'fill' => array(
            'type' => PHPExcel_Style_Fill::FILL_SOLID,'color' => array('rgb' => '2f75b5')),'borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40'))),'font' => array('size' => 11 ,'bold' => true, 'color' => array('rgb' => 'ffffff'))));
        
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$headingColumn,$headingRow,'MP');
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($headingColumn, $headingRow)->applyFromArray(array('alignment' => array(
            'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER),'fill' => array(
            'type' => PHPExcel_Style_Fill::FILL_SOLID,'color' => array('rgb' => '2f75b5')),'borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40'))),'font' => array('size' => 11 ,'bold' => true, 'color' => array('rgb' => 'ffffff'))));
        
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$headingColumn,$headingRow,'SKU CODE');
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($headingColumn, $headingRow)->applyFromArray(array('alignment' => array(
            'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER),'fill' => array(
            'type' => PHPExcel_Style_Fill::FILL_SOLID,'color' => array('rgb' => '2f75b5')),'borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40'))),'font' => array('size' => 11 ,'bold' => true, 'color' => array('rgb' => 'ffffff'))));
       
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$headingColumn,$headingRow,'DEISCRIPTION');
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($headingColumn, $headingRow)->applyFromArray(array('alignment' => array(
            'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER),'fill' => array(
            'type' => PHPExcel_Style_Fill::FILL_SOLID,'color' => array('rgb' => '2f75b5')),'borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40'))),'font' => array('size' => 11 ,'bold' => true, 'color' => array('rgb' => 'ffffff'))));
        foreach($rangeOfDates as $range){
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$headingColumn,$headingRow,$range);
            $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($headingColumn, $headingRow)->applyFromArray(array('alignment' => array(
            'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER),'fill' => array(
            'type' => PHPExcel_Style_Fill::FILL_SOLID,'color' => array('rgb' => '2f75b5')),'borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40'))),'font' => array('size' => 11 ,'bold' => true, 'color' => array('rgb' => 'ffffff'))));
        }
        
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$headingColumn,$headingRow,'TOTAL QUANTITY');
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($headingColumn, $headingRow)->applyFromArray(array('alignment' => array(
            'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER),'fill' => array(
            'type' => PHPExcel_Style_Fill::FILL_SOLID,'color' => array('rgb' => '2f75b5')),'borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40'))),'font' => array('size' => 11 ,'bold' => true, 'color' => array('rgb' => 'ffffff'))));
        
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$headingColumn,$headingRow,'UNIT RATE');
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($headingColumn, $headingRow)->applyFromArray(array('alignment' => array(
            'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER),'fill' => array(
            'type' => PHPExcel_Style_Fill::FILL_SOLID,'color' => array('rgb' => '2f75b5')),'borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40'))),'font' => array('size' => 11 ,'bold' => true, 'color' => array('rgb' => 'ffffff'))));
        
        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$headingColumn,$headingRow,'TQ * UR');
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($headingColumn, $headingRow)->applyFromArray(array('alignment' => array(
            'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER),'fill' => array(
            'type' => PHPExcel_Style_Fill::FILL_SOLID,'color' => array('rgb' => '2f75b5')),'borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40'))),'font' => array('size' => 11 ,'bold' => true, 'color' => array('rgb' => 'ffffff'))));
            
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$headingColumn,$headingRow,'MP RATE');
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($headingColumn, $headingRow)->applyFromArray(array('alignment' => array(
            'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER),'fill' => array(
            'type' => PHPExcel_Style_Fill::FILL_SOLID,'color' => array('rgb' => '2f75b5')),'borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40'))),'font' => array('size' => 11 ,'bold' => true, 'color' => array('rgb' => 'ffffff'))));
            
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$headingColumn,$headingRow,'TQ * MPR');
        $objPHPExcel->getActiveSheet()->getStyleByColumnAndRow($headingColumn, $headingRow)->applyFromArray(array('alignment' => array(
            'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,'vertical' => PHPExcel_Style_Alignment::VERTICAL_CENTER),'fill' => array(
            'type' => PHPExcel_Style_Fill::FILL_SOLID,'color' => array('rgb' => '2f75b5')),'borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN,'color' => array('rgb' => '130f40'))),'font' => array('size' => 11 ,'bold' => true, 'color' => array('rgb' => 'ffffff'))));

        $dataRow = 3;
        
    
        for($i = 0;$i < count($list);$i++){
            $dataColumn = 2;
            $employee = Employee::model()->findByPk($list[$i]['Employee']);

            

            foreach($list[$i]['sku'] as $key => $value){
                $sku = Sku::model()->findByAttributes(['id'=>$key]);
                $skuSalary = SkuSalary::model()->findByAttributes(['sku_id'=>$sku->id,'Status'=>1]);
                
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0,$dataRow,$employee->nic);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1,$dataRow,$employee->Namewithini);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2,$dataRow,$employee->supplier->name);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$dataColumn,$dataRow,$sku->name);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$dataColumn,$dataRow,$sku->description);

                foreach($rangeOfDates as $range){
                    if(array_key_exists($range, $value)){
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$dataColumn,$dataRow,$value[$range]);
                    }else{
                        ++$dataColumn;
                    }
                }
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$dataColumn,$dataRow,$value['totalq']);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$dataColumn,$dataRow,$skuSalary->basic_plus_bra);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$dataColumn,$dataRow,$value['totalq']*($skuSalary->basic_plus_bra));
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$dataColumn,$dataRow,$skuSalary->mp_agent_rate);
                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$dataColumn,$dataRow,$value['totalq']*($skuSalary->mp_agent_rate));

                ++$dataRow;
                $dataColumn = 2;

                // $dataColumn = 0;
                // $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($dataColumn,$dataRow,$employee->nic);
                // $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$dataColumn,$dataRow,$employee->Namewithini);
                // $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$dataColumn,$dataRow,$employee->supplier->name);

            }
            
    
        }
        
    
        $objPHPExcel->setActiveSheetIndex(0);
    
        ob_end_clean();
        ob_start();
    
        header('Content-Type: application/vnd.ms-excel');
        header('Content-Disposition: attachment;filename=PIECE DETAILS TRACKING REPORT.xls');
        header('Cache-Control: max-age=0');
        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
        $objWriter->save('php://output');
    }

    public function actionAllAttendanceWithAbsent(){
        $model = new AttendaceRange;
        if(isset($_POST['AttendaceRange'])){
            $model->attributes = $_POST['AttendaceRange'];
            $siteId = Yii::app()->user->data()->SiteId;
            Yii::app()->db->createCommand("call AllAttendanceReport('$model->startDate','$model->endDate','$siteId')")->query();
            $lists = Yii::app()->db->createCommand("select * from allAttendance")->queryAll();

            return $this->render('//timeSheet/viewAllAttendance',array('model'=>$model,'lists'=>$lists));
        }else{
            return $this->render('//timeSheet/createAllAttendance',array('model'=>$model));
        }
    }
    public function actionAllAttendanceWithAbsentExcel(){
        $objPHPExcel = new PHPExcel();
        $lists = CJSON::decode($_POST['lists']);
        $model = CJSON::decode($_POST['model']);
            // Set document properties
            $objPHPExcel->getProperties()->setCreator("K'iin Balam")
                ->setLastModifiedBy("K'iin Balam")
                ->setTitle("YiiExcel Test Document")
                ->setSubject("YiiExcel Test Document")
                ->setDescription("Test document for YiiExcel, generated using PHP classes.")
                ->setKeywords("office PHPExcel php YiiExcel UPNFM")
                ->setCategory("Test result file");

            // Add some data
            $objPHPExcel->setActiveSheetIndex(0)
                ->setCellValue('A1', 'All Attendance With Absent')
                ->setCellValue('E1', 'Generated On')
                ->setCellValue('F1', date("Y-m-d - h:i:sa"))
                ->setCellValue('A4', 'NAME')
                ->setCellValue('B4', 'NIC')
                ->setCellValue('C4', 'DESIGNATION')
                ->setCellValue('D4', 'ACCOUNT ORACLE CODE')
                ->setCellValue('E4', 'CLIENT ID')
                ->setCellValue('F4', 'CLIENT NAME')
                ->setCellValue('G4', 'DEPARTMENT')
                ->setCellValue('H4', 'SITE')
                ->setCellValue('I4', 'MP SUPPLIER')
                ->setCellValue('J4', 'DATE')
                ->setCellValue('K4', 'DAY')
                ->setCellValue('L4', 'IN TIME')
                ->setCellValue('M4', 'OUT TIME')
                ->setCellValue('N4', 'LATE HOURS')
                ->setCellValue('O4', 'EARLY OUT HOURS')
                ->setCellValue('P4', 'NORMAL HR')
                ->setCellValue('Q4', 'DOUBLE HR')
                ->setCellValue('R4', 'TRIPLE HR')
                ->setCellValue('S4', 'PRE HR')
                ->setCellValue('T4', 'TOTAL OT HOURS')
                ->setCellValue('U4', 'NORMAL WORKING HOURS')
                ->setCellValue('V4', 'TOTAL WORKING HOURS')
                ->setCellValue('W4', 'LEAVE TYPE')
                ->setCellValue('X4', 'HOLIDAYS');


            $styleArray = array(
                'font'  => array(
                    'bold'  => true,
                    'color' => array('rgb' => '#f79727'),
                    'size'  => 10
                ));
            $objPHPExcel->getActiveSheet()->getStyle('A1:X4')->applyFromArray($styleArray);
                $row = 5;
                foreach($lists as $list) {
                        $col =0;
                        

                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($col,$row,$list['name']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$list['nic']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$list['designation']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$list['account_oracle_code']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$list['client_id']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$list['client_name']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$list['departmanet']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$list['site']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$list['MP_supplier']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$list['date']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$list['day']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$list['in_time']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$list['out_time']);
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,Yii::app()->commonUtil->convertToHoursMins($list['late_hours']));
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,Yii::app()->commonUtil->convertToHoursMins($list['early_out_hours']));
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,Yii::app()->commonUtil->convertToHoursMins($list['normal_OT']));
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,Yii::app()->commonUtil->convertToHoursMins($list['double_OT']));
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,Yii::app()->commonUtil->convertToHoursMins($list['triple_OT']));
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,Yii::app()->commonUtil->convertToHoursMins($list['pre_OT']));
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,Yii::app()->commonUtil->convertToHoursMins($list['Total_OT_hours']));
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,Yii::app()->commonUtil->convertToHoursMins($list['normal_working_hours']));
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,Yii::app()->commonUtil->convertToHoursMins($list['Total_working_hours']));
                        if(is_null($list['leave_type'])){

                            if($list['in_time'] == '------' && $list['out_time'] == '------' && $list['day'] != 'Sunday' && $list['holyday'] == '------'){
                                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,'NO PAY');
                            }else if($list['in_time'] == '0000-00-00 00:00:00' || $list['out_time'] == '0000-00-00 00:00:00'){
                                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,'NO PAY');
                            }else{
                                $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,'------');
                            }

                        }else{
                            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$list['leave_type']);
                        }
                        
                        $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$col,$row,$list['holyday']);

                        $row++;
                    }



            $objPHPExcel->getActiveSheet()->setTitle('YiiExcel');
            $filename = "All Attendance With Absent ";
            header('Content-Type: application/vnd.ms-excel');
            header('Content-Disposition: attachment;filename="'.$filename.'.xls"');
            header('Cache-Control: max-age=0');

            $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');

            $objWriter->save('php://output');
            unset($this->objWriter);
            unset($this->objWorksheet);
            unset($this->objReader);
            unset($this->objPHPExcel);
            exit();
    }

    public function actionDeactiveEmployeeList(){
        if(Yii::app()->user->isAdmin()){
            $list = Yii::app()->db->createCommand("SELECT A.AccountOracleCode,E.* ,CF.contractfee,D.type designation,S.name site,DP.name department,A.name as account,P.type payment,C.name category,LC.name lcategory,T.type Tsize,SH.type shoes,SP.name supplier,ES.monthsalary monthSal,ES.DalySalary daySal,ER.resign_date
             FROM employee E
             INNER JOIN designation D ON D.id = E.designationid
             INNER JOIN sites S ON S.id = E.siteid
             INNER JOIN department DP ON DP.id = E.departmentid
             INNER JOIN accounts A ON A.id = E.Accountid
             INNER JOIN paymentmethod P ON P.id = E.paymentmethodid
             INNER JOIN category C ON C.id = E.categoryid
             INNER JOIN labourcategory LC ON LC.id = E.LabourCategory
             LEFT JOIN employeesalary ES ON ES.employeeid = E.id AND ES.Status = 1 AND ES.site_id = E.siteid
             LEFT JOIN employeecontractfee CF ON CF.employeeid = E.id AND CF.status = 1 AND CF.site_id = E.siteid
             LEFT JOIN employee_resign_details ER ON ER.employee_id = E.id AND ER.status=1 AND ER.site_id = E.siteid
             LEFT JOIN tshirt T ON E.tshirtsize = T.id
             LEFT JOIN shoes SH ON E.shoesize = SH.id
             LEFT JOIN supplier SP ON E.supplierid = SP.id
             WHERE E.statusId = 2 
             ORDER BY E.siteid,E.Accountid,E.id")->queryAll();
    
            // print_r(CJSON::encode($list));die;
        }else{
            $sitid = Yii::app()->user->data()->SiteId;
            $list = Yii::app()->db->createCommand("SELECT A.AccountOracleCode,E.* ,CF.contractfee,D.type designation,S.name site,DP.name department,A.name account,P.type payment,C.name category,LC.name lcategory,T.type Tsize,SH.type shoes,SP.name supplier,ES.monthsalary monthSal,ES.DalySalary daySal,ER.resign_date
            FROM employee E
            INNER JOIN designation D ON D.id = E.designationid
            INNER JOIN sites S ON S.id = E.siteid
            INNER JOIN department DP ON DP.id = E.departmentid
            INNER JOIN accounts A ON A.id = E.Accountid
            INNER JOIN paymentmethod P ON P.id = E.paymentmethodid
            INNER JOIN category C ON C.id = E.categoryid
            INNER JOIN labourcategory LC ON LC.id = E.LabourCategory
            LEFT JOIN employeesalary ES ON ES.employeeid = E.id AND ES.Status = 1 AND ES.site_id = E.siteid
            LEFT JOIN employeecontractfee CF ON CF.employeeid = E.id AND CF.status = 1 AND CF.site_id = E.siteid
            LEFT JOIN employee_resign_details ER ON ER.employee_id = E.id AND ER.status=1 AND ER.site_id = E.siteid
            LEFT JOIN tshirt T ON E.tshirtsize = T.id
            LEFT JOIN shoes SH ON E.shoesize = SH.id
            LEFT JOIN supplier SP ON E.supplierid = SP.id
            WHERE E.statusId = 2 AND E.siteid = $sitid;
            ORDER BY E.siteid,E.Accountid,E.id")->queryAll();
        }
        $this->render('//employee/viewDeactiveEmployeeList', array('list'=>$list));
    }
    public function actionDeactiveEmployeeListExcel(){
        $objPHPExcel = new PHPExcel();
        $list = CJSON::decode($_POST['list']);
    
        // print_r(count($list));
        // die;
        $EmpCount = 10;
    
        $objPHPExcel->setActiveSheetIndex(0)
            ->setCellValue('A1', 'Deactive Employees List')
            ->setCellValue('E1', 'Generated On')
            ->setCellValue('F1', date("Y-m-d - h:i:sa"))
            ->setCellValue('A2','There Are '.count($list).' Deactive Employees')
            ->setCellValue('A3', 'Id')
            ->setCellValue('B3', 'Gender')
            ->setCellValue('C3', 'NIC')
            ->setCellValue('D3', 'DOB')
            ->setCellValue('E3', 'First Name')
            ->setCellValue('F3', 'Last Name')
            ->setCellValue('G3', 'Sur Name')
            ->setCellValue('H3', 'Name with initilas')
            ->setCellValue('I3', 'Full Name')
            ->setCellValue('J3', 'Address')
            ->setCellValue('K3', 'Designation')
            ->setCellValue('L3', 'Appointment Date')
            ->setCellValue('M3', 'Department')
            ->setCellValue('N3', 'Confirmation date')
            ->setCellValue('O3', 'Account')
            ->setCellValue('P3', 'Category')
            ->setCellValue('Q3', 'Labour Category')
            ->setCellValue('R3', 'OT Entitle')
            ->setCellValue('S3', 'Tshirt size')
            ->setCellValue('T3', 'Shoe size')
            ->setCellValue('U3', 'EPF No')
            ->setCellValue('V3', 'Supplier')
            ->setCellValue('W3', 'Civil Status')
            ->setCellValue('X3', 'Site')
            ->setCellValue('Y3', 'Join Date')
            ->setCellValue('Z3', 'Employee Number')
            ->setCellValue('AA3', 'Shift Mode')    
            ->setCellValue('AB3', 'Payment Method')
            ->setCellValue('AC3', 'Contractor Fee')
            ->setCellValue('AD3', 'Salary(Rs)')
            ->setCellValue('AE3', 'Resigned Date');
        $col = 4;
    
        foreach($list as $value){
            $EntitleOT;
            if($value['EntitleOT'] == 0){
                $EntitleOT = 'OT Entitle';
            }else{
                $EntitleOT = 'NOT OT Entitle';
            }
    
            $row = 0;
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($row,$col,$value['id']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['gender']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['nic']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['date_of_birth']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['FirstName']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['LastName']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['SurName']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['Namewithini']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['FullName']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['address']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['designation']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['Appointment']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['department']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['Confirmationdate']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['account']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['category']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['lcategory']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$EntitleOT);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['Tsize']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['shoes']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['EPFNo']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['supplier']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['CivilStatus']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['site']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['joindate']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['EmployeeNumber']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['Shift_mode']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['payment']);
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,isset($value['contractfee'])? $value['contractfee']: '');
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,$value['payment']=='MONTHLY'? $value['monthSal'] : $value['daySal'] );
            $objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(++$row,$col,isset($value['resign_date'])? $value['resign_date']: '0000-00-00');
            $col++;
    
        }
        $styleArray = array(
            'font'  => array(
                'bold'  => true,
                'color' => array('rgb' => '#f79727'),
                'size'  => 10
            ));
        $objPHPExcel->getActiveSheet()->getStyle('A1:AE3')->applyFromArray($styleArray);
    
        //$objPHPExcel->getActiveSheet()->setTitle('sffd');
    
        $objPHPExcel->setActiveSheetIndex(0);
    
        ob_end_clean();
        ob_start();
    
        header('Content-Type: application/vnd.ms-excel');
        header('Content-Disposition: attachment;filename= DeactiveEmployeeList.xls');
        header('Cache-Control: max-age=0');
        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
        $objWriter->save('php://output');
      }
    //***************************************************************************************************** */

    public function actionTimelogWithPin(){
        $model = new AttendaceRange;
        if(isset($_POST['AttendaceRange'])){
            $model->attributes = $_POST['AttendaceRange'];

            if(Yii::app()->user->isAdmin()){
                $list = Yii::app()->db->createCommand("SELECT K.Namewithini as name,K.nic,K.siteid,ES.date,ES.image 
                FROM employees_snapshots ES
                INNER JOIN (select e.Namewithini,e.nic,e.siteid, e.id  from employee e union select en.Namewithini,en.nic,en.siteid, en.id from nonpayroll_employee en) K ON ES.emp_id = K.id 
                WHERE date(ES.date) >= '$model->startDate' AND date(ES.date) <= '$model->endDate'
                ORDER BY ES.emp_id,ES.date DESC")->queryAll();
            }else{

                $sitid = Yii::app()->user->data()->SiteId;
                $list = Yii::app()->db->createCommand("SELECT K.Namewithini as name,K.nic,K.siteid,ES.date,ES.image 
                FROM employees_snapshots ES
                INNER JOIN (select e.Namewithini,e.nic,e.siteid, e.id  from employee e union select en.Namewithini,en.nic,en.siteid, en.id from nonpayroll_employee en) K ON ES.emp_id = K.id 
                WHERE date(ES.date) >= '$model->startDate' AND date(ES.date) <= '$model->endDate' AND K.siteid ='$sitid'
                ORDER BY ES.emp_id,ES.date DESC")->queryAll();

            }

            // print_r($list);die;

            return $this->render('//timelog/viewTimelogWithPin',array('model'=>$model,'lists'=>$list));
        }else{
            return $this->render('//timelog/createTimelogWithPin',array('model'=>$model));
        }
    }


}